(* ::Package:: *)

(* Theorema
    Copyright (C) 2017 The Theorema Group

    This file is part of Theorema 2.0
    
    Theorema 2.0 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Theorema 2.0 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*)

(* The sole purpose of this package is to register all useful non-critical public functions in context "Theorema`Core`Tools`".
	It is not loaded by default, but only when 'enterCore' from "/Provers/CoreInit.m" is evaluated. *)

BeginPackage[ "Theorema`Core`Tools`"]

If[ Theorema`Common`$privateSymbolsLoaded =!= True, Get[ FileNameJoin[ {Theorema`$TheoremaDirectory, "Theorema", "System", "Common.m"}]]]	(* TODO: Change when publish. *)

With[ {Theorema`lang = "English"},
	(* General *)
	MessageName[ enterCore, "usage", Theorema`lang] = "";
	MessageName[ leaveCore, "usage", Theorema`lang] = "";
	
	(* IO *)
	MessageName[ exportImage, "usage", Theorema`lang] = "";
	MessageName[ importImage, "usage", Theorema`lang] = "";
	MessageName[ initIO, "usage", Theorema`lang] = "";
	MessageName[ makeFileName, "usage", Theorema`lang] = "";
	MessageName[ makeTheoryFileName, "usage", Theorema`lang] = "";
	MessageName[ shortenFileName, "usage", Theorema`lang] = "";
	
	(* Messages *)
	MessageName[ coreNotification, "usage", Theorema`lang] = "";
	MessageName[ dialogYesNo, "usage", Theorema`lang] = "";
	MessageName[ printDisplayStruct, "usage", Theorema`lang] = "";
	MessageName[ printMessage, "usage", Theorema`lang] = "";
	
	(* Types *)
	MessageName[ applyTypeGenSpecRepl, "usage", Theorema`lang] = "";
	MessageName[ getAllConstDecls, "usage", Theorema`lang] = "";
	MessageName[ getHeadAtom, "usage", Theorema`lang] = "";
	MessageName[ getObjectTruthType, "usage", Theorema`lang] = "";
	MessageName[ getType, "usage", Theorema`lang] = "";
	MessageName[ inferTypes, "usage", Theorema`lang] = "";
	MessageName[ makeFunctionType, "usage", Theorema`lang] = "";
	MessageName[ mergeSorts, "usage", Theorema`lang] = "";
	MessageName[ resultType, "usage", Theorema`lang] = "";
	MessageName[ stripArgumentTypes, "usage", Theorema`lang] = "";
	MessageName[ tvpToSorts, "usage", Theorema`lang] = "";
	MessageName[ unifyTypeListsIt, "usage", Theorema`lang] = "";
	MessageName[ unifyTypeListsRec, "usage", Theorema`lang] = "";
	
	(* HORewriting *)
	MessageName[ applyEqRewriteRule, "usage", Theorema`lang] = "";
	MessageName[ applyReductionRule, "usage", Theorema`lang] = "";
	MessageName[ generateEqRewriteRule, "usage", Theorema`lang] = "";
	MessageName[ generateReductionRule, "usage", Theorema`lang] = "";
	MessageName[ generateSimpleRewriteRule, "usage", Theorema`lang] = "";
	MessageName[ makeAlphaEquivFun, "usage", Theorema`lang] = "";
	MessageName[ patternMatchQ, "usage", Theorema`lang] = "";
	
	(* Toplevel *)
	MessageName[ abbrevTerm, "usage", Theorema`lang] = "";
	MessageName[ abbrevType, "usage", Theorema`lang] = "";
	MessageName[ addAxmToTheory, "usage", Theorema`lang] = "";
	MessageName[ addCoreTypedefCasesThms, "usage", Theorema`lang] = "";
	MessageName[ addCoreTypedefInductThms, "usage", Theorema`lang] = "";
	MessageName[ addCoreTypedefInjectThms, "usage", Theorema`lang] = "";
	MessageName[ addFactsToTheory, "usage", Theorema`lang] = "";
	MessageName[ addFactsToTheoryDirect, "usage", Theorema`lang] = "";
	MessageName[ addFmlToTheory, "usage", Theorema`lang] = "";
	MessageName[ addGlobalFactList, "usage", Theorema`lang] = "";
	MessageName[ addRulesToTheory, "usage", Theorema`lang] = "";
	MessageName[ addTheoryDeps, "usage", Theorema`lang] = "";
	MessageName[ addThmToTheory, "usage", Theorema`lang] = "";
	MessageName[ copyType, "usage", Theorema`lang] = "";
	MessageName[ declareConstants, "usage", Theorema`lang] = "";
	MessageName[ declareConstantsDirect, "usage", Theorema`lang] = "";
	MessageName[ declareTypes, "usage", Theorema`lang] = "";
	MessageName[ declareTypesDirect, "usage", Theorema`lang] = "";
	MessageName[ defineType, "usage", Theorema`lang] = "";
	MessageName[ extractFreshConstant, "usage", Theorema`lang] = "";
	MessageName[ formulaToAssumption, "usage", Theorema`lang] = "";
	MessageName[ getCoreVar, "usage", Theorema`lang] = "";
	MessageName[ getCoreVarAssoc, "usage", Theorema`lang] = "";
	MessageName[ getFactListKeys, "usage", Theorema`lang] = "";
	MessageName[ getFormulas, "usage", Theorema`lang] = "";
	MessageName[ getTheory, "usage", Theorema`lang] = "";
	MessageName[ getProofOfFormula, "usage", Theorema`lang] = "";
	MessageName[ getRuleFormulas, "usage", Theorema`lang] = "";
	MessageName[ getThmData, "usage", Theorema`lang] = "";
	MessageName[ getThmInst, "usage", Theorema`lang] = "";
	MessageName[ getThmLabel, "usage", Theorema`lang] = "";
	MessageName[ getTheorems, "usage", Theorema`lang] = "";
	MessageName[ importTheories, "usage", Theorema`lang] = "";
	MessageName[ increaseTheoremIndex, "usage", Theorema`lang] = "";
	MessageName[ inScopeQ, "usage", Theorema`lang] = "";
	MessageName[ inScopeTSQ, "usage", Theorema`lang] = "";
	MessageName[ inTheoryScopeQ, "usage", Theorema`lang] = "";
	MessageName[ lockConstants, "usage", Theorema`lang] = "";
	MessageName[ lookupCurrentValue, "usage", Theorema`lang] = "";
	MessageName[ overloadingOnOff, "usage", Theorema`lang] = "";
	MessageName[ printTypes, "usage", Theorema`lang] = "";
	MessageName[ printTerms, "usage", Theorema`lang] = "";
	MessageName[ printForms, "usage", Theorema`lang] = "";
	MessageName[ remFormsFromTheory, "usage", Theorema`lang] = "";
	MessageName[ remTheoryDeps, "usage", Theorema`lang] = "";
	MessageName[ remThmSchemasFromTheory, "usage", Theorema`lang] = "";
	MessageName[ remTypesFromTheory, "usage", Theorema`lang] = "";
	MessageName[ setCoreVar, "usage", Theorema`lang] = "";
	MessageName[ setDefaultSort, "usage", Theorema`lang] = "";
	MessageName[ setTheory, "usage", Theorema`lang] = "";
	MessageName[ setTruthJudgment, "usage", Theorema`lang] = "";
	MessageName[ simplifyTerms, "usage", Theorema`lang] = "";
	MessageName[ termNotation, "usage", Theorema`lang] = "";
	MessageName[ termSyntax, "usage", Theorema`lang] = "";
	MessageName[ typedefOnOff, "usage", Theorema`lang] = "";
	MessageName[ typeNotation, "usage", Theorema`lang] = "";
	MessageName[ typeSyntax, "usage", Theorema`lang] = "";
	MessageName[ undeclareConstantsDirect, "usage", Theorema`lang] = "";
	MessageName[ unsetCoreVar, "usage", Theorema`lang] = "";
	
	(* Reasoning *)
	MessageName[ aaCount, "usage", Theorema`lang] = "";
	MessageName[ abstractionCount, "usage", Theorema`lang] = "";
	MessageName[ addRulesToAssociation, "usage", Theorema`lang] = "";
	MessageName[ addRulesToRULEC$, "usage", Theorema`lang] = "";
	MessageName[ allCount, "usage", Theorema`lang] = "";
	MessageName[ alphaEquivOffset, "usage", Theorema`lang] = "";
	MessageName[ applyCurried, "usage", Theorema`lang] = "";
	MessageName[ assmCountSkipAll, "usage", Theorema`lang] = "";
	MessageName[ associationFromRULEC$, "usage", Theorema`lang] = "";
	MessageName[ betaExpand, "usage", Theorema`lang] = "";
	MessageName[ betaReduceRestricted, "usage", Theorema`lang] = "";
	MessageName[ containsVar, "usage", Theorema`lang] = "";
	MessageName[ dropAssms, "usage", Theorema`lang] = "";
	MessageName[ etaExpand, "usage", Theorema`lang] = "";
	MessageName[ etaReduceRestricted, "usage", Theorema`lang] = "";
	MessageName[ extendRULEC$, "usage", Theorema`lang] = "";
	MessageName[ extractAtomicGoal, "usage", Theorema`lang] = "";
	MessageName[ extractFormulas, "usage", Theorema`lang] = "";
	MessageName[ extractRelevantRules, "usage", Theorema`lang] = "";
	MessageName[ fastKeyFromLabel, "usage", Theorema`lang] = "fastKeyFromLabel is a function that maps labels to keys of formulas.";
	MessageName[ fastThmFromLabel, "usage", Theorema`lang] = "fastThmFromLabel is a function that maps theorems specified by labels to theorems specified by keys.";
	MessageName[ findAtomPositions, "usage", Theorema`lang] = "";
	MessageName[ findPositions, "usage", Theorema`lang] = "";
	MessageName[ fromAssmsGoal, "usage", Theorema`lang] = "";
	MessageName[ getArgs, "usage", Theorema`lang] = "";
	MessageName[ getProofSitData, "usage", Theorema`lang] = "";
	MessageName[ getRuleConsts, "usage", Theorema`lang] = "";
	MessageName[ getTermAbbrevList, "usage", Theorema`lang] = "";
	MessageName[ groupRulesByRuleConsts, "usage", Theorema`lang] = "";
	MessageName[ incrementRuleIterator, "usage", Theorema`lang] = "";
	MessageName[ introFixCommandList, "usage", Theorema`lang] = "";
	MessageName[ iterateRULEC$, "usage", Theorema`lang] = "";
	MessageName[ makeCoreExpr, "usage", Theorema`lang] = "";
	MessageName[ makeCoreExprPatt, "usage", Theorema`lang] = "";
	MessageName[ makeCoreForms, "usage", Theorema`lang] = "";
	MessageName[ makeCorePattern, "usage", Theorema`lang] = "";
	MessageName[ makeFactsExplicitInline, "usage", Theorema`lang] = "";
	MessageName[ makeInstantiation, "usage", Theorema`lang] = "";
	MessageName[ makeRULEC$, "usage", Theorema`lang] = "";
	MessageName[ makeSingleSTERM, "usage", Theorema`lang] = "";
	MessageName[ makeSTERM, "usage", Theorema`lang] = "";
	MessageName[ mapAllInline, "usage", Theorema`lang] = "";
	MessageName[ mapFreeVars, "usage", Theorema`lang] = "";
	MessageName[ mapVars, "usage", Theorema`lang] = "";
	MessageName[ parseAddRemOnlySpec, "usage", Theorema`lang] = "";
	MessageName[ remRulesByPattFromRULEC$, "usage", Theorema`lang] = "";
	MessageName[ remRulesFromAssociation, "usage", Theorema`lang] = "";
	MessageName[ remRulesFromRULEC$, "usage", Theorema`lang] = "";
	MessageName[ replaceSyntacticByMeta, "usage", Theorema`lang] = "";
	MessageName[ restrictRULEC$, "usage", Theorema`lang] = "";
	MessageName[ scanFactSpec, "usage", Theorema`lang] = "";
	MessageName[ setProofSitData, "usage", Theorema`lang] = "";
	MessageName[ simpleMatchQ, "usage", Theorema`lang] = "";
	MessageName[ splitHeadArgs, "usage", Theorema`lang] = "";
	MessageName[ stripAbstractions, "usage", Theorema`lang] = "";
	MessageName[ stripAll, "usage", Theorema`lang] = "";
	MessageName[ substFree, "usage", Theorema`lang] = "";
	MessageName[ takeAssms, "usage", Theorema`lang] = "";
	MessageName[ termToTermPatt, "usage", Theorema`lang] = "";
	MessageName[ tryTerminalProofSteps, "usage", Theorema`lang] = "";
	MessageName[ unfoldTermAbbrevs, "usage", Theorema`lang] = "";
	MessageName[ unfoldTriangularSubst, "usage", Theorema`lang] = "";
	MessageName[ unifierToAbbrevs, "usage", Theorema`lang] = "";
	
	(* Syntax *)
	MessageName[ addScopeCondition, "usage", Theorema`lang] = "";
	MessageName[ addToConditionalRules, "usage", Theorema`lang] = "";
	MessageName[ addToConstPattern, "usage", Theorema`lang] = "";
	MessageName[ addToMapping, "usage", Theorema`lang] = "";
	MessageName[ addToRuleBlocks, "usage", Theorema`lang] = "";
	MessageName[ applyRuleBlocks, "usage", Theorema`lang] = "";
	MessageName[ binaryApply, "usage", Theorema`lang] = "";
	MessageName[ chooseRangeVar, "usage", Theorema`lang] = "";
	MessageName[ defaultBinderParser, "usage", Theorema`lang] = "";
	MessageName[ defaultReconstructRange, "usage", Theorema`lang] = "";
	MessageName[ dropTypesFromPrintingRule, "usage", Theorema`lang] = "";
	MessageName[ getFullTypeForDisplay, "usage", Theorema`lang] = "";
	MessageName[ makeTypeBoxes, "usage", Theorema`lang] = "";
	MessageName[ mapVarsSlow, "usage", Theorema`lang] = "";
	MessageName[ mapFreeVarsSlow, "usage", Theorema`lang] = "";
	MessageName[ normalizeRange, "usage", Theorema`lang] = "";
	MessageName[ parseCoreTermPost, "usage", Theorema`lang] = "";
	MessageName[ parseCoreTermPre, "usage", Theorema`lang] = "";
	MessageName[ parseType, "usage", Theorema`lang] = "";
	MessageName[ printCoreBinder, "usage", Theorema`lang] = "";
	MessageName[ printCoreTerm, "usage", Theorema`lang] = "";
	MessageName[ printType, "usage", Theorema`lang] = "";
	MessageName[ recursiveApply, "usage", Theorema`lang] = "";
	MessageName[ remFromConditionalRules, "usage", Theorema`lang] = "";
	MessageName[ remFromConstPattern, "usage", Theorema`lang] = "";
	MessageName[ theoremaInputDisplay, "usage", Theorema`lang] = "";
	MessageName[ translatePrettyPrintingRulesToInputPrintingRules, "usage", Theorema`lang] = "";
	MessageName[ varToSymbol, "usage", Theorema`lang] = "";
	
	(* Interactive *)
	MessageName[ addCriticalTheoryCommands, "usage", Theorema`lang] = "";
	MessageName[ addCustomProofInterpretationRules, "usage", Theorema`lang] = "";
	MessageName[ addCustomTheoryInterpretationRules, "usage", Theorema`lang] = "";
	MessageName[ addFormulaVariantRules, "usage", Theorema`lang] = "";
	MessageName[ addFullTypeDisplayRules, "usage", Theorema`lang] = "";
	MessageName[ addProofMethodRules, "usage", Theorema`lang] = "";
	MessageName[ buildTheory, "usage", Theorema`lang] = "";
	MessageName[ defaultPLT, "usage", Theorema`lang] = "";
	MessageName[ defaultTLT, "usage", Theorema`lang] = "";
	MessageName[ displayCoreKnowledge, "usage", Theorema`lang] = "";
	MessageName[ displayCoreProofState, "usage", Theorema`lang] = "";
	MessageName[ enterCoreCellEvaluation, "usage", Theorema`lang] = "";
	MessageName[ evaluateNotebook, "usage", Theorema`lang] = "";
	MessageName[ executeCoreProofCommands, "usage", Theorema`lang] = "";
	MessageName[ exitCoreCellEvaluation, "usage", Theorema`lang] = "";
	MessageName[ exportCoreProof, "usage", Theorema`lang] = "";
	MessageName[ getCurrentScope, "usage", Theorema`lang] = "";
	MessageName[ getEvaluationPosition, "usage", Theorema`lang] = "";
	MessageName[ getNotationSpec, "usage", Theorema`lang] = "";
	MessageName[ increaseEvaluationPosition, "usage", Theorema`lang] = "";
	MessageName[ initInteractiveCoreProof, "usage", Theorema`lang] = "";
	MessageName[ isNotebookEvaluation, "usage", Theorema`lang] = "";
	MessageName[ makeFmlList, "usage", Theorema`lang] = "";
	MessageName[ makeProofCommand, "usage", Theorema`lang] = "";
	MessageName[ parseOptsAsAssociation, "usage", Theorema`lang] = "";
	MessageName[ parseTheoremaCodeCell, "usage", Theorema`lang] = "";
	MessageName[ printCoreProofSituation, "usage", Theorema`lang] = "";
	MessageName[ processTheoremaCell, "usage", Theorema`lang] = "";
	MessageName[ registerCustomProofInterpretationRules, "usage", Theorema`lang] = "";
	MessageName[ registerCustomTheoryInterpretationRules, "usage", Theorema`lang] = "";
	MessageName[ registerFormulaVariantRules, "usage", Theorema`lang] = "";
	MessageName[ registerFullTypeDisplayRules, "usage", Theorema`lang] = "";
	MessageName[ registerProofMethodRules, "usage", Theorema`lang] = "";
	
	(* Variables *)
	MessageName[ $abbrevConstDecls, "usage", Theorema`lang] = "$abbrevConstDecls is the analogue of constDecls in /Trusted/Consistency.m, containing the declarations
																of constants serving as abbreviations. $abbrevConstDecls is an association mapping constants to
																'COREVAR$'-structures, which themselves store for each theory a pair consisting of a key and a type
																(this is the same as the information in 'constDecls' without the value of the theory counter).";
	MessageName[ $abbrevTypeDecls, "usage", Theorema`lang] = "$abbrevTypeDecls is the analogue of typeDefs in /Trusted/Consistency.m, containing type abbreviations
																(or synonyms). $abbrevTypeDecls is an association mapping type constructors to lists of rules of the
																form 'typ /; inTheoryScopeQ[ ...] -> key'.";
	
	MessageName[ $coreFmlPre, "usage", Theorema`lang] = "$coreFmlPre is similar to $tmaFmlPre in that it is called before a formula enters the global theory context.
												In contrast to $tmaFmlPre it is not parametrized over 'nb' and 'cell', does not get argument 'simp', and is supposed
												to return either '$Failed' or a 5-tuple '{newForm, newLbl, newTags, kind, post}'. Note that it gets fully
												type-annotated formulas as input (i.e. after parseCoreTermPost has been applied).
												'kind' may be
												- \"def\": add as definition,
												- \"axiom\": add as axiom,
												- \"thm\": add as theorem if proof exists (regardless of theory mode); do not check proof,
												- 'prf_Hold': add as theorem with proof 'prf'; check proof,
												- Automatic: add as theorem if proof exists and theory mode is strict.";
	MessageName[ $defaultInputSort, "usage", Theorema`lang] = "";
	MessageName[ $globalFactLists, "usage", Theorema`lang] = "$globalFactLists is an association mapping pairs of strings and position specifications
																to lists of pairs of the form '{spec, pos}'. 'spec' is a fact-specifier (key, THM$), and 'pos' is again
																a position specification corresponding to the cell where the respective fact was added to the collection.
																A position specification is a pair of a key and a position-list.";
	MessageName[ $ignoreScope, "usage", Theorema`lang] = "";
	MessageName[ $inCore, "usage", Theorema`lang] = "$inCore is a global variable that specifies whether the current Theorem session is in Core or not.";
	MessageName[ $objectValidity, "usage", Theorema`lang] = "Some provable term of object-logic truth type. Needed in 'copyType'.";
	MessageName[ $objectValidityProof, "usage", Theorema`lang] = "The proof of $objectValidity.";
	MessageName[ $theoremIndex, "usage", Theorema`lang] = "";
	MessageName[ $typedefFormulaConstructor, "usage", Theorema`lang] = "";
	MessageName[ $typedefProofTransformer, "usage", Theorema`lang] = "";
	MessageName[ $typedefThmGenerator, "usage", Theorema`lang] = "";
	
	MessageName[ $autoredRules, "usage", Theorema`lang] = "";
	MessageName[ $compRules, "usage", Theorema`lang] = "";
	MessageName[ $congRules, "usage", Theorema`lang] = "";
	MessageName[ $elimRules, "usage", Theorema`lang] = "";
	MessageName[ $introRules, "usage", Theorema`lang] = "";
	MessageName[ $simpRules, "usage", Theorema`lang] = "";
	MessageName[ $symRules, "usage", Theorema`lang] = "";
	MessageName[ $transRules, "usage", Theorema`lang] = "";
	
	MessageName[ $autoredRuleVariant, "usage", Theorema`lang] = "";
	MessageName[ $elimRuleVariant, "usage", Theorema`lang] = "";
	MessageName[ $introRuleVariant, "usage", Theorema`lang] = "";
	MessageName[ $simpRuleVariant, "usage", Theorema`lang] = "";
	MessageName[ $symRuleVariant, "usage", Theorema`lang] = "";
	MessageName[ $transRuleVariant, "usage", Theorema`lang] = "";
	
	MessageName[ $generalizeFix, "usage", Theorema`lang] = "$generalizeFix is a global variable specifying whether a.b.f. constants introduced in proof methods
													such as 'coreRule' etc. shall be generalized again afterward. Typically, top-level proof commands
													\"proof\" and \"apply\" set it to 'True', whereas \"qed\" and \"by\" set it to 'False'.";
	MessageName[ $initialProofSteps, "usage", Theorema`lang] = "$initialProofSteps is a sequence of proof commands that are always applied at the beginning of a
																proof of a formula in a notebook.";
	MessageName[ $proofGoal, "usage", Theorema`lang] = "$proofGoal is a global variable holding the FML$-structure of the formula that is being proved at the moment.
												This variable is set in 'initiateProof', but it may be overwritten randomly during the proof search by
												external functions: it is *not at all* relevant for the correctness or consistency of Core!";
	MessageName[ $proofMode, "usage", Theorema`lang] = "";
	MessageName[ $terminalProofSteps, "usage", Theorema`lang] = "$terminalProofSteps is a global variable containing all registered terminal proof steps.
									A terminal proof step is a function that takes 7 arguments, 'G', 'hyps', 'idx', fix', meta', tfix', 'tvar', and basically
									decides whether the subgoal 'G' is provable from 'hyps' by \"trivial\" means; if so, it shall return a functon that, when
									applied to some non-negative integer 'a', returns a sequence of proof methods that actually do the job; 'a' is the
									number of additional explicit assumptions.
									In case of success, the sequence of proof methods returned by the function must satisfy certain criteria in order for
									reasoners to function correctly:
									- It must close the first subgoal; in particular, it must be applicable.
									- It must do so without instantiating type variables or meta variables that appear in other subgoals.
									- It must leave all other subgoals unchanged.
									- It may increase the type variable index, and introduce new a.b.f. type/term constants and meta variables.";
	
	MessageName[ $abbrevTermFoldingRules, "usage", Theorema`lang] = "";
	MessageName[ $abbrevTermUnfoldingRules, "usage", Theorema`lang] = "";
	MessageName[ $abbrevTypeFoldingRules, "usage", Theorema`lang] = "";
	MessageName[ $abbrevTypeUnfoldingRules, "usage", Theorema`lang] = "";
	MessageName[ $binaryTermParsingRules, "usage", Theorema`lang] = "";
	MessageName[ $binaryTypeParsingRules, "usage", Theorema`lang] = "";
	MessageName[ $binaryTermInputPrintingRules, "usage", Theorema`lang] = "";
	MessageName[ $binaryTermPrintingRules, "usage", Theorema`lang] = "";
	MessageName[ $binaryTypePrintingRules, "usage", Theorema`lang] = "";
	MessageName[ $binderParser, "usage", Theorema`lang] = "";
	MessageName[ $condDefaultBinderInputPrinting, "usage", Theorema`lang] = "$condDefaultBinderInputPrinting is like '$condDefaultBinderPrinting', but
																			for input format.";
	MessageName[ $condDefaultBinderPrinting, "usage", Theorema`lang] = "$condDefaultBinderPrinting is an alternatives-pattern of binders that shall be
																		pretty-printed as conditional default binders. More precisely, the individual elements
																		of the pattern are either plain unconditional constants or patterns of the form
																		'b1|b2|b3|...|bn /; inTheoryScopeQ[ thy]', where the 'bi' are the binders and 'thy'
																		is the theory in which these binders were added to the list. The unconditional constants
																		originate from Core itself, i.e. they are always in scope. There are no negative scope
																		conditions.
																		This seemingly strange representation is chosen for the sake of efficiency.";
	MessageName[ $curriedDBParsingRules, "usage", Theorema`lang] = "$curriedDBParsingRules is a list of custom term parsing rules that are applied to curried
																	terms with de Bruijn indices, and where Lambda is the only binder.";
	MessageName[ $curriedDBInputPrintingRules, "usage", Theorema`lang] = "$curriedDBInputPrintingRules is like '$curriedDBPrintingRules', but for input format.";
	MessageName[ $curriedDBPrintingRules, "usage", Theorema`lang] = "$curriedDBPrintingRules is a list of custom term printing rules that are applied to curried
																	terms with de Bruijn indices.";
	MessageName[ $curriedHeads, "usage", Theorema`lang] = "$curriedHeads is a pattern of symbols that are supposed to be kept curried when applied to arguments,
															when printing terms. Same representation as '$condDefaultBinderPrinting'.";
	MessageName[ $curriedNominalInputPrintingRules, "usage", Theorema`lang] = "$curriedNominalInputPrintingRules is like '$curriedNominalPrintingRules', but for
																				input format.";
	MessageName[ $curriedNominalPrintingRules, "usage", Theorema`lang] = "$curriedNominalPrintingRules is a list of custom term printing rules that are applied
																		to curried terms with named variables.";
	MessageName[ $fullTypeDisplayMapping, "usage", Theorema`lang] = "$fullTypeDisplayMapping has the same format as '$proofMethodMapping'";
	MessageName[ $parsingCtxt, "usage", Theorema`lang] = "$parsingCtxt is an auxiliary variable for making simple parsing rules context-aware.";
	MessageName[ $postParsingRules, "usage", Theorema`lang] = "$postParsingRules is a list of custom term parsing rules that are applied after types have been
																inferred, but before abbreviations are unfolded. Note that these rules operate on the output
																of inferTypes, i.e. a structure of the form '{{_, _, _, _, _}, _}'. ";
	MessageName[ $printingCtxt, "usage", Theorema`lang] = "$printingCtxt is an auxiliary variable for making simple printing rules context-aware.";
	MessageName[ $rangeReconstructionF, "usage", Theorema`lang] = "";
	MessageName[ $termSortConstructor, "usage", Theorema`lang] = "";
	MessageName[ $typeHeads, "usage", Theorema`lang] = "Pattern of symbols that indicate types. Same representation as '$condDefaultBinderPrinting'.";
	MessageName[ $typeParsingRules, "usage", Theorema`lang] = "";
	MessageName[ $typePrintingRules, "usage", Theorema`lang] = "";
	MessageName[ $uncondDefaultBinderInputPrinting, "usage", Theorema`lang] = "$uncondDefaultBinderInputPrinting is like '$uncondDefaultBinderPrinting', but
																				for input format.";
	MessageName[ $uncondDefaultBinderPrinting, "usage", Theorema`lang] = "$uncondDefaultBinderPrinting is a pattern of binders that shall, in addition to CoreAll,
																			be pretty-printed as unconditional default binders. Same representation as
																			'$condDefaultBinderPrinting'.";
	MessageName[ $uncurriedNominalParsingRules, "usage", Theorema`lang] = "$uncurriedNominalParsingRules is a list of custom term parsing rules that are applied
																			to uncurried terms with named variables and arbitrary binders.";
	MessageName[ $uncurriedNominalInputPrintingRules, "usage", Theorema`lang] = "$uncurriedNominalInputPrintingRules is like '$uncurriedNominalPrintingRules', but
																				for input format.";
	MessageName[ $uncurriedNominalPrintingRules, "usage", Theorema`lang] = "$uncurriedNominalPrintingRules is a list of custom term printing rules that are applied
																			to uncurried terms with named variables.";
	
	MessageName[ $criticalTheoryCommands, "usage", Theorema`lang] = "$criticalTheoryCommands is a list of rules of the form 'sym /; inTheoryScopeQ[ thy] -> cmd'.
																	There are only positive scope conditions. The symbols 'sym' are the heads of theory commands
																	that should only be the first commands in cells.";
	MessageName[ $currentScope, "usage", Theorema`lang] = "$currentScope is the source-position specification of the current scope. It typically corresponds to the
															currently evaluating cell, but in some situations could also be something else (e.g. when the proof
															of a formula is triggered from a different cell). Note, however, that the theory of '$currentScope'
															must always be the same as the theory of the currently evaluating cell, for otherwise 'getTheoryScope[]'
															is wrong.
															$currentScope is made public, because in contrast to $evaluationPosition it has to be set explicitly
															by functions outside of \"Interactive.m\".";
	MessageName[ $defaultTheoryImage, "usage", Theorema`lang] = "";
	MessageName[ $evaluationCell, "usage", Theorema`lang] = "";
	MessageName[ $evaluationNotebook, "usage", Theorema`lang] = "";
	MessageName[ $formulaVariantMapping, "usage", Theorema`lang] = "$formulaVariantMapping has the same format as '$proofMethodMapping'.";
	MessageName[ $labelKeyMapping, "usage", Theorema`lang] = "$labelKeyMapping is an association mapping source-label pairs to formula-keys.";
	MessageName[ $labelThmMapping, "usage", Theorema`lang] = "$labelThmMapping is an association mapping plain labels (no source!) to keys of theorem schemas";
	MessageName[ $proofCommandInterpretationRules1, "usage", Theorema`lang] = "";
	MessageName[ $proofCommandInterpretationRules2, "usage", Theorema`lang] = "";
	MessageName[ $proofCommandSeparators, "usage", Theorema`lang] = "";
	MessageName[ $proofLanguageTranslator, "usage", Theorema`lang] = "";
	MessageName[ $proofMethodMapping, "usage", Theorema`lang] = "$proofMethodMapping is an association mapping keys to pairs consisting of a list of rules of the
																form 'thy -> val' and a default value. These lists of rules have the same meaning as the associations
																in 'COREVAR$'-structures; they are lists rather than associations because 'lookupCurrentValue' is
																more efficient when called directly on lists. Of course, one could replace the pairs by
																'COREVAR$'-structures and compute the current values whenever entering a theory.";
	MessageName[ $theoryCommandInterpretationRules1, "usage", Theorema`lang] = "";
	MessageName[ $theoryCommandInterpretationRules2, "usage", Theorema`lang] = "";
	MessageName[ $theoryCommandSeparators, "usage", Theorema`lang] = "";
	MessageName[ $theoryDirs, "usage", Theorema`lang] = "";
	MessageName[ $theoryLanguageTranslator, "usage", Theorema`lang] = "";
	MessageName[ $theoryMapping, "usage", Theorema`lang] = "$theoryMapping is an association mapping short names of theories (e.g. \"HOL\") to
															proper theory names (including the \"Source:\"-prefix). It is mainly used by proof methods that
															need to refer to facts originating from certain theories.";
	MessageName[ $thmLabelData, "usage", Theorema`lang] = "$thmLabelData is an association mapping keys of theorem schemas to pairs of labels and data. The data
															is itself an association mapping keys (e.g. \"tags\") to values.";
	
	(* Data Structures *)
	MessageName[ COREVAR$, "usage", Theorema`lang] = "COREVAR$ is a data structure for storing variables whose values may be set in different theories.";
	MessageName[ POS$, "usage", Theorema`lang] = "POS$ is a data structure containing position-information, most notably positions of subterms of a term that is
													being rewritten.";
	MessageName[ RULEC$, "usage", Theorema`lang] = "RULEC$ is a data structure for storing collections of formula-rules, e.g. for rewriting, backchaining, etc."
];

EndPackage[]

Get[ "Theorema`Core`Tools`IO`"]
Get[ "Theorema`Core`Tools`Messages`"]
Get[ "Theorema`Core`Tools`Types`"]
Get[ "Theorema`Core`Tools`HORewriting`"]
Get[ "Theorema`Core`Tools`Toplevel`"]
Get[ "Theorema`Core`Tools`Reasoning`"]
Get[ "Theorema`Core`Tools`Syntax`"]
Get[ "Theorema`Core`Tools`Interactive`"]
