(* ::Package:: *)

(* Theorema
    Copyright (C) 2017 The Theorema Group

    This file is part of Theorema 2.0
    
    Theorema 2.0 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Theorema 2.0 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*)

(* The sole purpose of this package is to register all critical public functions in context "Theorema`Core`Trusted`". *)

BeginPackage[ "Theorema`Core`Trusted`"]

If[ Theorema`Common`$privateSymbolsLoaded =!= True, Get[ FileNameJoin[ {Theorema`$TheoremaDirectory, "Theorema", "System", "Common.m"}]]]	(* TODO: Change when publish. *)
(* for "Reasoning.m" and "Consistency.m" (and "Types.m"?) *)

With[ {Theorema`lang = "English"},
	(* General *)
	MessageName[ coreMessageToList, "usage", Theorema`lang] = "";
	MessageName[ sowMessage, "usage", Theorema`lang] = "";
	
	(* Consistency *)
	MessageName[ accumulateTheories, "usage", Theorema`lang] = "";
	MessageName[ checkProof, "usage", Theorema`lang] = "";
	MessageName[ checkTheoremInsts, "usage", Theorema`lang] = "";
	MessageName[ constOverloadedQ, "usage", Theorema`lang] = "";
	MessageName[ constOverloadingEnabledQ, "usage", Theorema`lang] = "";
	MessageName[ exportTheoryImage, "usage", Theorema`lang] = "";
	MessageName[ getConstDecls, "usage", Theorema`lang] = "";
	MessageName[ getConstDefs, "usage", Theorema`lang] = "";
	MessageName[ getDefaultSort, "usage", Theorema`lang] = "";
	MessageName[ getFmlEnv, "usage", Theorema`lang] = "";
	MessageName[ getImageFile, "usage", Theorema`lang] = "";
	MessageName[ getImportedTheories, "usage", Theorema`lang] = "";
	MessageName[ getLockedConsts, "usage", Theorema`lang] = "";
	MessageName[ getPositions, "usage", Theorema`lang] = "";
	MessageName[ getProtectedConsts, "usage", Theorema`lang] = "";
	MessageName[ getThmEnv, "usage", Theorema`lang] = "";
	MessageName[ getTheoryCounter, "usage", Theorema`lang] = "";
	MessageName[ getTheoryDeps, "usage", Theorema`lang] = "";
	MessageName[ getTheoryMode, "usage", Theorema`lang] = "";
	MessageName[ getTheoryRootDist, "usage", Theorema`lang] = "";
	MessageName[ getTheoryScope, "usage", Theorema`lang] = "";
	MessageName[ getTypeDefs, "usage", Theorema`lang] = "";
	MessageName[ importTheoryImage, "usage", Theorema`lang] = "";
	MessageName[ makeTypeVarPositions, "usage", Theorema`lang] = "";
	MessageName[ manipulateContext, "usage", Theorema`lang] = "";
	MessageName[ obtainFactsFromProof, "usage", Theorema`lang] = "";
	MessageName[ restartSession, "usage", Theorema`lang] = "";
	MessageName[ typeDefsEnabledQ, "usage", Theorema`lang] = "";
	MessageName[ typeOverloadingEnabledQ, "usage", Theorema`lang] = "";
	
	(* Types *)
	MessageName[ checkType, "usage", Theorema`lang] = "";
	MessageName[ compareTypes, "usage", Theorema`lang] = "";
	MessageName[ eliminateAnonymousVars, "usage", Theorema`lang] = "";
	MessageName[ flattenTypes, "usage", Theorema`lang] = "";
	MessageName[ generalizeTypes, "usage", Theorema`lang] = "";
	MessageName[ getDeclaredType, "usage", Theorema`lang] = "";
	MessageName[ getFullType, "usage", Theorema`lang] = "";
	MessageName[ getFullTypeNoSorts, "usage", Theorema`lang] = "";
	MessageName[ getMaxTVar, "usage", Theorema`lang] = "";
	MessageName[ getTypeInstance, "usage", Theorema`lang] = "";
	MessageName[ hasSort, "usage", Theorema`lang] = "";
	MessageName[ hasSortList, "usage", Theorema`lang] = "";
	MessageName[ hasSortTFix, "usage", Theorema`lang] = "";
	MessageName[ intersectSorts, "usage", Theorema`lang] = "";
	MessageName[ isLegalType, "usage", Theorema`lang] = "";
	MessageName[ isLegalTypeList, "usage", Theorema`lang] = "";
	MessageName[ isSubsort, "usage", Theorema`lang] = "";
	MessageName[ isWellFormedAtom, "usage", Theorema`lang] = "";
	MessageName[ isWellFormedType, "usage", Theorema`lang] = "";
	MessageName[ liftTypeVars, "usage", Theorema`lang] = "";
	MessageName[ matchType, "usage", Theorema`lang] = "";
	MessageName[ replaceTypes, "usage", Theorema`lang] = "";
	MessageName[ shiftTypeVars, "usage", Theorema`lang] = "";
	MessageName[ specializeTypes, "usage", Theorema`lang] = "";
	MessageName[ swapSortAssociations, "usage", Theorema`lang] = "";
	MessageName[ typeGeneralizationReplacement, "usage", Theorema`lang] = "";
	MessageName[ typeSpecializationReplacement, "usage", Theorema`lang] = "";
	MessageName[ unifyTypes, "usage", Theorema`lang] = "";
	
	(* Reasoning *)
	MessageName[ alphaEquiv, "usage", Theorema`lang] = "";
	MessageName[ applyFunction, "usage", Theorema`lang] = "";
	MessageName[ assmCount, "usage", Theorema`lang] = "";
	MessageName[ assmPosition, "usage", Theorema`lang] = "";
	MessageName[ betaReduce, "usage", Theorema`lang] = "";
	MessageName[ basicInference, "usage", Theorema`lang] = "";
	MessageName[ checkTheorems, "usage", Theorema`lang] = "";
	MessageName[ compareThmIndices, "usage", Theorema`lang] = "";
	MessageName[ countAbstractionsFromPos, "usage", Theorema`lang] = "";
	MessageName[ etaReduce, "usage", Theorema`lang] = "";
	MessageName[ executeProofCommands, "usage", Theorema`lang] = "";
	MessageName[ extractFormula, "usage", Theorema`lang] = "";
	MessageName[ getMaxConversionContext, "usage", Theorema`lang] = "";
	MessageName[ initiateProof, "usage", Theorema`lang] = "";
	MessageName[ makeFormulaKey, "usage", Theorema`lang] = "";
	MessageName[ normalize, "usage", Theorema`lang] = "";
	MessageName[ reap, "usage", Theorema`lang] = "";
	MessageName[ scanVars, "usage", Theorema`lang] = "";
	MessageName[ stripAssms, "usage", Theorema`lang] = "";
	MessageName[ toAssmsGoal, "usage", Theorema`lang] = "";
	MessageName[ validExtract, "usage", Theorema`lang] = "";
	
	(* Variables *)
	MessageName[ $autoNormalize, "usage", Theorema`lang] = "$autoNormalize specifies whether expressions that enter Core shall automatically be beta-eta-reduced.";
	MessageName[ $branchCombinator, "usage", Theorema`lang] = "$branchCombinator specifies which function to use for combining two lazy lists of branches in proofs.
													Possible values are '1' (default), in which case 'lJoin' is used, '2', in which case 'lInterleave' is used,
													and arbitrary binary relations 'rel', in which case 'lMerge[ rel]' is used.";
	MessageName[ $instantiateTypes, "usage", Theorema`lang] = "$instantiateTypes specifies whether type variables shall automatically be instantiated if necessary
														(e.g. when checking alpha-equivalence of expressions).";
	MessageName[ $msgID, "usage", Theorema`lang] = "$msgID is either 'None' or an arbitrary identifier that is added to messages sown by 'sowMessage'.";
	MessageName[ $preProof, "usage", Theorema`lang] = "$preProof is a function applied to the proof goal before a proof is started. Its main purpose is to set some
												global variables.";
	MessageName[ $reportUndeclaredConsts, "usage", Theorema`lang] = "$reportUndeclaredConsts specifies whether function 'getDeclaredType' shall sow undeclared constants
																	with tag \"undeclared\".";
	MessageName[ $strictTypeChecking, "usage", Theorema`lang] = "$strictTypeChecking specifies whether constants that enter Core shall be required to be declared and
																type-instances of their declared types. Even if the variable is set to 'False' the soundness of the
																kernel is not affected.";
	
	(* Data Structures *)
	MessageName[ FKEYDISP$, "usage", Theorema`lang] = "FKEYDISP$ is a data structure for expressions that shall be displayed as formula-keys and -labels.";
	MessageName[ INF$, "usage", Theorema`lang] = "";
	MessageName[ KEYDISP$, "usage", Theorema`lang] = "KEYDISP$ is a data structure for expressions that shall be displayed as keys.";
	MessageName[ MSG$, "usage", Theorema`lang] = "MSG$ is a data structure for messages.";
	MessageName[ PRFSTAT$, "usage", Theorema`lang] = "";
	MessageName[ STERM$, "usage", Theorema`lang] = "STERM$ is a dat structure for terms with sort constraints, which are of the form 'STERM$[ term, termTFix, termTVar]'.";
	MessageName[ SYMDISP$, "usage", Theorema`lang] = "SYMDISP$ is a data structure for expressions that shall be displayed as plain symbols (i.e. without suffix \"$TM\" etc.).";
	MessageName[ TERMDISP$, "usage", Theorema`lang] = "TERMDISP$ is a data structure for expressions that shall be displayed as terms.";
	MessageName[ THM$, "usage", Theorema`lang] = "";
	MessageName[ TTDISP$, "usage", Theorema`lang] = "TTDISP$ is a data structure for expressions that shall be displayed as terms with an outermost type annotation.";
	MessageName[ TYPEDISP$, "usage", Theorema`lang] = "TYPEDISP$ is a data structure for expressions that shall be displayed as types.";
];

Begin[ "`Private`"]

Scan[
	With[ {$$name = #[[1]], $$desc = #[[2]]},
	With[ {$$sym1 = Symbol[ "Theorema`Language`" <> $$name], $$sym2 = Symbol[ "Theorema`Computation`Language`" <> $$name]},
		MessageName[ $$sym1, "usage", "English"] = $$desc;
		MessageName[ $$sym2, "usage", "English"] = $$desc;
	]]&,
	{
		{"CoreAll$TM", ""},
		{"CoreImplies$TM", ""},
		{"CoreEqual$TM", ""},
		{"FORM$TM", ""},
		{"FUN$TM", ""},
		{"TFIX$", ""},
		{"TVAR$", ""},
		{"TYPED$", ""},
		{"TYPRNG$", ""},
		{"STRING$TM", ""},
		{"SVAR$", ""}
	}
]

Clear[ coreMessageToList];
Map[ Get, FileNames[ "*.m", FileNameJoin[ {Theorema`$TheoremaDirectory, "Theorema", "Core", "LanguageData"}]]];

sowMessage[ msg_MSG$] :=
	Sow[ If[ $msgID === None, msg, {$msgID, msg}], "Message"]
sowMessage[ text_String] :=
	sowMessage[ MSG$[ text]]
sowMessage[ text_String, header_String] :=
	sowMessage[ MSG$[ text, header]]
sowMessage[ args__] :=
	sowMessage[ MSG$[ coreMessageToList, args]]

Get[ "Theorema`Core`Trusted`Consistency`"]
Get[ "Theorema`Core`Trusted`Reasoning`"]
Get[ "Theorema`Core`Trusted`Types`"]

(*
Scan[
	With[ {sym = Symbol[ #]},
		If[ !MemberQ[ Attributes[ sym], Locked], SetAttributes[ sym, {Protected, Locked}]]
	]&,
	DeleteCases[ Names[ "Theorema`Core`Trusted`*"], _String?(StringMatchQ[ #, "$" ~~ __]&)]
]
*)

(* TODO: One could clear and lock 'Names', such that it cannot be used anymore. *)

End[]

EndPackage[]
