(* Indirect Rewriting. *)

indirectRewriteAll[ STERM$[ A0_, _, tvar0_Association], hyps_, idx0_, fix0_, meta0_, tfix_, usedEnvKeys0_, {hypIndices_, glob_, microstrat_}] :=
	Module[ {A = A0, idx = idx0, fix = fix0, meta = meta0, tvar = tvar0,
				down = True, cat = 2, subpos = {{}, 0}, except = initExcept[], loose = {}, usedEnvKeys = usedEnvKeys0},
	With[ {hypNum = Length[ hyps] + 1,
			succ = indirectRewriteAllNextSuccess[ {cat, down, subpos, except}, microstrat],
			fail = Hold[ indirectRewriteAllNextFailure[ {A, loose, cat, down, subpos, except}, microstrat]]},
	With[ {out =
			Last[
				Reap[
					While[ down =!= $Failed,
						{subpos, except, loose} = adjustSubposition[ A, subpos, except, microstrat[[2]]];
						With[ {excur = Part @@ except, subcur = Take @@ subpos, jj = If[ TrueQ[ down], 1, 2]},
						With[ {expr = extractSingle[ A, subcur]},
						Switch[ cat,
							(* we skip '0' and '1' to be consistent with direct rewriting *)
							2,	(* hypotheses *)
							Catch[
								Scan[
									If[ !MemberQ[ First[ excur], #],
										With[ {fml = hyps[[#]]},
											Replace[ applyEqRewriteRule[ expr, fml, loose, {idx, fix, meta, tfix, tvar}],
												{inst10_List, inst20_List, {tv_Association, tinst_List}, bren_List, _, test_} :>
													Replace[ adjustInstantiations[ inst10, inst20, expr, loose],
														{inst1_, inst2_} :>
															Replace[
																indirectRewriteSingle[
																	{A, idx},
																	fml,
																	subcur,
																	DeleteCases[ bren, x_ -> x_],
																	inst1,
																	inst2,
																	tinst,
																	test,
																	{hyps, fix, meta, tfix, tv}
																],
																prf_List :>
																	(
																		succ[ {If[ MemberQ[ getOptionalComponent[ fml, "tags"], "cong"], {#}, {}], {}}];
																		fix = fix /. tinst;
																		meta = meta /. tinst;
																		tvar = tv;
																		Sow[ {# - hypNum, inst1, inst2, tinst, prf, subcur}, True];
																		Throw[ Null]
																	)
															]
													]
											]
										]
									]&,
									hypIndices[[jj]]
								];
								cat = 3
							],
						(*else*)
							3,	(* environment and theorem instances *)
							Catch[
								Scan[
									If[ !MemberQ[ Last[ excur], #],
										If[ ListQ[ #],
											With[ {fml = getFormulas[ True][ #]},
												Replace[ applyEqRewriteRule[ expr, fml, loose, {idx, fix, meta, tfix, tvar}],
													{inst10_List, inst20_List, {tv_Association, tinst_List}, bren_List, _, test_} :>
														Replace[ adjustInstantiations[ inst10, inst20, expr, loose],
															{inst1_, inst2_} :>
																Replace[
																	indirectRewriteSingle[
																		{A, idx},
																		fml,
																		subcur,
																		DeleteCases[ bren, x_ -> x_],
																		inst1,
																		inst2,
																		tinst,
																		test,
																		{hyps, fix, meta, tfix, tv}
																	],
																	prf_List :>
																		(
																			succ[ {{}, If[ MemberQ[ getOptionalComponent[ fml, "tags"], "cong"], {#}, {}]}];
																			fix = fix /. tinst;
																			meta = meta /. tinst;
																			tvar = tv;
																			Sow[
																				{
																					With[ {i = First[ FirstPosition[ usedEnvKeys, #, {$Failed}, {1}, Heads -> False]]},
																						If[ IntegerQ[ i],
																							{1 - (hypNum + i)},
																						(*else*)
																							AppendTo[ usedEnvKeys, #];
																							{1 - (hypNum + Length[ usedEnvKeys])}
																						]
																					],
																					inst1, inst2, tinst, prf, subcur
																				},
																				True
																			];
																			Throw[ Null]
																		)
																]
														]
												]
											],
										(*else*)
											Replace[ getThmInst[ True, idx][ #],
												{thm_, newIdx_} :>
													Replace[ applyEqRewriteRule[ expr, thm, Lookup[ getThmData[ #], "rwData", $Failed], loose, {idx, fix, meta, tfix, tvar}],
														{inst10_List, inst20_List, {tv_Association, tinst_List}, bren_List, _, test_} :>
															Replace[ adjustInstantiations[ inst10, inst20, expr, loose],
																{inst1_, inst2_} :>
																	Replace[
																		indirectRewriteSingle[
																			{A, idx},
																			{thm, newIdx},
																			subcur,
																			DeleteCases[ bren, x_ -> x_],
																			inst1,
																			inst2,
																			tinst,
																			test,
																			{hyps, fix, meta, tfix, tv}
																		],
																		prf_List :>
																			(
																				succ[ {{}, If[ MemberQ[ Lookup[ getThmData[ #], "tags", {}], "cong"], {#}, {}]}];
																				fix = fix /. tinst;
																				meta = meta /. tinst;
																				tvar = tv;
																				Sow[ {# - hypNum, inst1, inst2, tinst, prf, subcur}, True];
																				Throw[ Null]
																			)
																	]
															]
													]
											]
										]
									]&,
									List @@ extractRelevantRules[ glob[[jj]], getRuleConsts[ expr, Head, False]]	(* we need the atomic head, even if it is 'TrueQ' *)
								];
								ReleaseHold[ fail]
							],
						(*else*)
							_,
							ReleaseHold[ fail]
						]]]
					],
					True
				]
			]},
		{usedEnvKeys, A, tvar, Join @@ out}
	]]]

SetAttributes[ indirectRewriteAllNextSuccess, HoldFirst];
indirectRewriteAllNextSuccess[ {cat_, down_, subpos_, except_}, microstrat_][ exnew_] :=
	Replace[ microstrat[[3]][ NFORMS, down, subpos, except, exnew],
		{
			{newSub_, newExcept_, newDown_} :>
				(
					subpos = newSub;
					except = newExcept;
					down = newDown;
					cat = 2
				),
			_ :> (subpos = except = down = cat = $Failed)
		}
	]

SetAttributes[ indirectRewriteAllNextFailure, HoldFirst];
indirectRewriteAllNextFailure[ {A_, loose_, cat_, down_, subpos_, except_}, microstrat_] :=
	Replace[ getNextIndirectRWPos[ down, A, loose, subpos, except, microstrat[[4]]],
		{
			{newLoose_, newSub_, newExcept_, newDown_} :>
				(
					loose = newLoose;
					subpos = newSub;
					except = newExcept;
					down = newDown;
					cat = 2
				),
			_ :> (subpos = except = down = cat = $Failed)
		}
	]

SetAttributes[ indirectRewriteSingle, HoldFirst];
indirectRewriteSingle[ {A_, idx_}, fml_FML$, subcur_, bren_, inst1_, inst2_, tinst_, test_, ctxt_] :=
	indirectRewriteSingle[ {A, idx}, extractFormula[ fml, idx], subcur, bren, inst1, inst2, tinst, test, ctxt]
indirectRewriteSingle[ {A_, idx_}, {STERM$[ f0_, _, _], newIdx_}, subcur_, bren0_, inst1_, inst2_, tinst_, test_, {hyps_, fix_, meta_, tfix_, tvar_}] :=
	If[ MemberQ[ inst1, Automatic] || MemberQ[ inst2, Automatic],
		$Failed,
	(*else*)
		With[ {f1 = toAssmsGoal[ stripAll[ f0], {}, Infinity]},
		With[ {conds0 = Most[ f1], concl = Last[ f1]},
			Replace[ concl,
				{
					eq:(TYPED$[ CoreEqual$TM, {_}][ _][ b0_]) :>
						With[ {bren = Cases[ bren0, (x_Symbol -> y_Symbol) :> (RNG$[ TYPRNG$[ x, typ_]] :> RNG$[ TYPRNG$[ y, typ]])]},
						With[ {b1 = Fold[ applyFunction, instantiateLoose[ replaceTypes[ b0, tinst] /. bren, inst1], inst2]},
						With[ {n = abstractionCount[ b1, 0, LengthWhile[ Reverse[ subcur], (# === 0)&]]},
						With[ {pos = Drop[ subcur, -n]},
						With[ {A0 = extractSingle[ A, pos]},
						With[ {b = normalize[ Fold[ applyFunction, b1, getArgs[ A0, n]]]},
							If[ test === True || TrueQ[ test[ A0, b]],
								With[ {subprf = tryTerminalProofSteps[ instantiateLoose[ replaceTypes[ conds0, tinst], inst1], hyps, newIdx, fix, meta, tfix, tvar]},
									If[ ListQ[ subprf],
										A =
											With[ {aux = ReplacePart[ replaceTypes[ A, tinst], {pos} -> b]},
											With[ {conv = getMaxConversionContext[ pos, MatchQ[ b, _Lambda$TM]]},
												If[ conv === 0,
													aux,
												(*else*)
													MapAt[ normalize, aux, {Drop[ pos, -conv]}]
												]
											]];
										idx = newIdx;
										#[ 0]& /@ subprf,
									(*else*)
										$Failed
									]
								],
							(*else*)
								$Failed
							]
						]]]]]],
					_ -> $Failed
				}
			]
		]]
	]
indirectRewriteSingle[ _, _, _, _, _, _, _, _] :=
	$Failed


(* ::Subsubsection:: *)
(*Proof Methods*)

(* 'simplifiedVariant[ args, factID, keyHandler, lbl]' is an auxiliary proof method used for obtaining the simplified
	variant of hypotheses of the current proof situation, making use of indirect rewriting. 'args' must be in the same
	format as in direct rewriting. *)
simplifiedVariant[ args_List, factID_, keyHandler_, lbl_, add_, rem_][ ps_, __] :=
	Replace[ parseRWSpec[ args, ps, "indirectRewriteAll"],
		{_List, hypsDown_List, hypsUp_List, globDown_Association, globUp_Association, variants_List,
				_, _, microstrat_, _, _, _} :>
			With[ {id = getFreshFactID[]},
				Hold @@ {
					addKnowledgeAux[ variants, addKeysToList[ id, False], Hold[], Automatic, None],
					simplifiedVariant[ id, {{hypsDown, hypsUp}, {globDown, globUp}, microstrat}, factID, keyHandler, lbl, add, rem]
				}
			]
	]
simplifiedVariant[ argsID_, {{hypsDown_, hypsUp_}, glob_, microstrat_}, factID_, keyHandler_, lbl_, add_, rem_][ ps:PRFSIT$[ _, hyps_, __], __] :=
	With[ {factKeys = getProofSitData[ ps, factID, {}], argKeys0 = getProofSitData[ ps, argsID, {}]},
	With[ {tempArgs = Cases[ argKeys0, {k:{_, _}, False} :> k], argKeys = Replace[ argKeys0, {k:{_, _}, _} :> k, {1}],
			fun = If[ TrueQ[ microstrat[[1]]], If[ MemberQ[ #, "comp"], 2, 1]&, If[ MemberQ[ #, "cong"], 1, 2]&]},
		Replace[
			Last[
				Reap[
					Scan[
						Quiet[ Check[
							With[ {h = FirstCase[ hyps, FML$[ #, __, "rwData" -> _, ___], Null]},
								Sow[ #, fun[ getOptionalComponent[ h, "tags"]]]
							],
							Null
						]]&,
						argKeys
					],
					{1, 2}
				]
			],
			{newHypKeysDown_, newHypKeysUp_} :>
				Hold @@ Join[
					{
						updateAbbrevLists[ {}, {}, {}, {factID, argsID}],
						variantIterator[
							factKeys,
							(* we must work with keys, since 'variantIterator' might remove hypotheses *)
							simplifiedVariantFun[
								{Join[ hyps[[hypsDown, 1]], Join @@ newHypKeysDown], Join[ hyps[[hypsUp, 1]], Join @@ newHypKeysUp]},
								glob,
								microstrat
							],
							keyHandler,
							lbl,
							add,
							rem
						]
					},
					If[ tempArgs === {}, {}, {forgetHyps[ tempArgs]}]
				]
		]
	]]

simplifiedVariantFun[ {hypKeysDown_, hypKeysUp_}, glob_, microstrat_][ i_, PRFSIT$[ _, hyps_, idx_, fix_, meta_, tfix_, __]] :=
	With[ {hypsDown = Position[ hyps, FML$[ Alternatives @@ hypKeysDown, __], {1}, Heads -> False][[All, 1]],
			hypsUp = Position[ hyps, FML$[ Alternatives @@ hypKeysUp, __], {1}, Heads -> False][[All, 1]]},
	With[ {fml = extractFormula[ hyps[[i]], idx]},
		Replace[ indirectRewriteAll[ First[ fml], hyps, Last[ fml], fix, {}, tfix, {}, {{hypsDown, hypsUp}, glob, microstrat}],
			{
				{_, _, _, {}} -> Null,
				{usedEnvKeys_, A_, newTVar_Association, data_List} :> {{STERM$[ A, Association[], newTVar], simplifiedVariantProof[ i, usedEnvKeys, data]}},
				_ -> $Failed
			}
		]
	]]

simplifiedVariantProof[ i_Integer, usedEnvKeys_List, data_List][ n_Integer] :=
	Hold @@ Join[
		{INF$[ "makeExplicit", i + n]},
		Map[ INF$[ "insert", #]&, usedEnvKeys],
		{indirectRewriteProof[ Replace[ data, {{j_Integer?Negative}, rest__} :> {j - n, rest}, {1}]]}
	]

indirectRewriteProof[ {}][ PRFSIT$[ {TYPED$[ CoreImplies$TM, {}][ _][ G_]}, __], __] :=
	With[ {ac = assmCount[ G, 0, Infinity]},
		Hold[ INF$[ "impE", 1, ac], INF$[ "close"]]
	]
indirectRewriteProof[ {{rule_, inst1_List, inst2_List, tinst_List, prf_List, pos_List}, rest___}][ __] :=
	Hold @@ Join[
		{If[ IntegerQ[ rule], INF$[ "makeExplicit", rule], INF$[ "theorem", rule]]},
		If[ tinst === {}, {}, {INF$[ "instT", tinst]}],
		If[ inst1 === {}, {}, {instantiateCoreAll[ inst1, 1]}],
		{indirectRewriteProof[ inst2, prf, pos, {rest}]}
	]
indirectRewriteProof[ inst_List, {}, pos_List, rest_List][ ps:PRFSIT$[ _, _, idx_, __], args__] :=
	indirectRewriteProofAux[ inst, pos, idx, rest][ ps, args]
indirectRewriteProof[ inst_List, prf_List, pos_List, rest_List][ PRFSIT$[ {TYPED$[ CoreImplies$TM, {}][ f_][ _]}, _, idx_, __], __] :=
	With[ {f1 = stripAssms[ f]},
		Join[
			Hold[ setupSubgoalsMP[ f1, 1], INF$[ "impE", 1, 0]],
			Join @@ prf,
			Hold[ INF$[ "drop", 1], indirectRewriteProofAux[ inst, pos, idx, rest]]
		]
	]

indirectRewriteProofAux[ inst_List, pos_List, idx0_Integer, rest_List][
		PRFSIT$[ {TYPED$[ CoreImplies$TM, {}][ TYPED$[ CoreEqual$TM, {_}][ a_][ _]][ _]}, _, idx_, __], __] :=
	With[ {realpos = Join[ {1, 0, 1}, pos], diff = idx - idx0},
		Hold @@ Join[
			If[ inst === {}, {}, {INF$[ "alphabetaeta", realpos, Fold[ #1[ #2]&, a, inst], False, True]}],
			{
				INF$[ "replace", 1, Join[ realpos, Table[ 0, {Length[ inst]}]]],
				INF$[ "drop", 1],
				indirectRewriteProof[ If[ diff === 0, rest, rest /. TVAR$[ i_Integer?(# >= idx &), sym___] :> TVAR$[ i + diff, sym]]]
			}
		]
	]
indirectRewriteProofAux[ _List, _List, _Integer, _List][ __] :=
	$Failed


(* ::Subsubsection:: *)
(*Auxiliary Functions*)

getNextIndirectRWPos[ True, expr_, loose_, subpos:{sublist_, s_}, except:{exlist_, x_}, stratNextRWPos_] :=
	Which[
		s === Length[ sublist],
		stratNextRWPos[ NFORMS, True, expr, loose, subpos, except],
	(*else*)
		sublist[[s + 1]] === 2,
		{Prepend[ loose, extractSingle[ expr, Join[ Take[ sublist, s], {1, 1, 2}]]], {sublist, s + 1}, {exlist, x + 1}, True},
	(*else*)
		True,
		{loose, {sublist, s + 1}, {exlist, x + 1}, True}
	]
getNextIndirectRWPos[ False, expr_, {}, {{}, _}, _, _] :=
	$Failed
getNextIndirectRWPos[ False, expr_, loose_, subpos_, except_, stratNextRWPos_] :=
	stratNextRWPos[ NFORMS, False, expr, loose, subpos, except]

instantiateLoose[ expr_, inst_List] :=
	With[ {len = Length[ inst]},
		mapFreeVars[ expr, inst[[ len + #2 - #3]] &]
	]
