(* ::Package:: *)

(* ::Section:: *)
(* Public Declaration Part: executes in Theorema`CoreProvers` *)


With[ {lang = "English"},

(* Tacticals *)
MessageName[ andTac, "usage", lang] = "";
MessageName[ andNewTac, "usage", lang] = "";
MessageName[ blockTac, "usage", lang] = "";
MessageName[ evalTac, "usage", lang] = "";
MessageName[ failTac, "usage", lang] = "";
MessageName[ ifTac, "usage", lang] = "";
MessageName[ mapAllTac, "usage", lang] = "";
MessageName[ notNormalizeTac, "usage", lang] = "";
MessageName[ orElseTac, "usage", lang] = "";
MessageName[ orTac, "usage", lang] = "";
MessageName[ repeatNewTac, "usage", lang] = "";
MessageName[ repeatNTac, "usage", lang] = "";
MessageName[ repeatSTac, "usage", lang] = "";
MessageName[ repeatTac, "usage", lang] = "";
MessageName[ solveTac, "usage", lang] = "";
MessageName[ thenTac, "usage", lang] = "";
MessageName[ tryTac, "usage", lang] = "";
MessageName[ voidTac, "usage", lang] = "";

(* Proof Methods *)
MessageName[ accumulateCalculation, "usage", lang] = "";
MessageName[ addExplicitTermAbbrev, "usage", lang] = "";
MessageName[ addKnowledgeExplicit, "usage", lang] = "";
MessageName[ addKnowledgeImplicit, "usage", lang] = "";
MessageName[ addToHypData, "usage", lang] = "";
MessageName[ addTheoremImplicit, "usage", lang] = "";
MessageName[ atomizeTerm, "usage", lang] = "";
MessageName[ autoReduce, "usage", lang] = "";
MessageName[ backChain, "usage", lang] = "";
MessageName[ backChainSingle, "usage", lang] = "";
MessageName[ closeAllByRefl, "usage", lang] = "";
MessageName[ closeByAssm, "usage", lang] = "";
MessageName[ closeByFact, "usage", lang] = "";
MessageName[ closeByRefl, "usage", lang] = "";
MessageName[ closeByTerminal, "usage", lang] = "";
MessageName[ closeProofSit, "usage", lang] = "";
MessageName[ closeSubgoals, "usage", lang] = "";
MessageName[ combineCalculation, "usage", lang] = "";
MessageName[ convertBetaEta, "usage", lang] = "";
MessageName[ coreDest, "usage", lang] = "";
MessageName[ coreElim, "usage", lang] = "";
MessageName[ coreInitialProofStep, "usage", lang] = "";
MessageName[ coreIntro, "usage", lang] = "";
MessageName[ coreRule, "usage", lang] = "";
MessageName[ coreThis, "usage", lang] = "";
MessageName[ defineConst, "usage", lang] = "";
MessageName[ directRewriteAll, "usage", lang] = "";
MessageName[ duplicateAssms, "usage", lang] = "";
MessageName[ eliminateCoreImplies, "usage", lang] = "";
MessageName[ eliminateCoreImpliesMult, "usage", lang] = "";
MessageName[ forgetConsts, "usage", lang] = "";
MessageName[ forgetHyps, "usage", lang] = "";
MessageName[ generalizeFix, "usage", lang] = "";
MessageName[ generalizeTerms, "usage", lang] = "";
MessageName[ instantiateCoreAll, "usage", lang] = "";
MessageName[ instantiateCoreAllGoal, "usage", lang] = "";
MessageName[ instantiateCoreAllMult, "usage", lang] = "";
MessageName[ internalFactHandler, "usage", lang] = "";
MessageName[ introduceAssms, "usage", lang] = "";
MessageName[ introduceAssmsFix, "usage", lang] = "";
MessageName[ introduceFix, "usage", lang] = "";
MessageName[ makeExplicitAssms, "usage", lang] = "";
MessageName[ obtainConstants, "usage", lang] = "";
MessageName[ rearrangeAssms, "usage", lang] = "";
MessageName[ reflectTerm, "usage", lang] = "";
MessageName[ renameHyps, "usage", lang] = "";
MessageName[ reverseSubgoals, "usage", lang] = "";
MessageName[ rewriteAll, "usage", lang] = "";
MessageName[ selectSubgoal, "usage", lang] = "";
MessageName[ setupSubgoal, "usage", lang] = "";
MessageName[ setupSubgoals, "usage", lang] = "";
MessageName[ setupSubgoalsMP, "usage", lang] = "";
MessageName[ toCanonicalFormat, "usage", lang] = "";
MessageName[ toEliminationFormat, "usage", lang] = "";
MessageName[ toEquationalFormat, "usage", lang] = "";
MessageName[ updateAbbrevLists, "usage", lang] = "";

(* Rewriters *)
MessageName[ NOMATCH, "usage", lang] = "";

] (* With *)


(* ::Section::Closed:: *)
(* Private Implementation Part: executes in Theorema`CoreProvers`CoreProofMethods`Private` *)

Begin["`CoreProofMethods`Private`"]

Needs[ "Theorema`Core`Trusted`"]
Needs[ "Theorema`Common`"]

With[ {lang = "English"},

(* ::Subsection:: *)
(*Manipulating Explicit Assumptions*)

cpmMessageToList[ 1, {assm_}, _, lang] :=
	{"Cannot make assumption", STRING$[ assm], "explicit."};
cpmMessageToList[ 2, {i_, j_}, _, lang] :=
	{"Cannot move assumption", i, "to position", j, "."};
cpmMessageToList[ 3, {i_}, _, lang] :=
	{"Unable to duplicate assumption", i, "."};
	

(* ::Subsection:: *)
(*Knowledge Management*)

cpmMessageToList[ 11, {fact_}, _, lang] :=
	{"Fact not found:", fact};
cpmMessageToList[ 12, {fact_}, _, lang] :=
	{"Fact comes after proof goal:", fact};
cpmMessageToList[ 13, _, _, lang] = {"No pending calculation."};
cpmMessageToList[ 14, {ran_}, _, lang] :=
	{"Range", ran, "is invalid."};
cpmMessageToList[ 15, {thm_}, _, lang] :=
	Join[ {"Theorem", thm, "does not exist."}];
cpmMessageToList[ 16, {hyp_}, _, lang] :=
	{"Cannot rename hypothesis", hyp, "."};
cpmMessageToList[ 17, {hyp_}, _, lang] :=
	{"Cannot remove hypothesis", hyp, "."};
cpmMessageToList[ 18, _, _, lang] = {"Fact not found."};
cpmMessageToList[ 19, {fact_}, _, lang] :=
	{"Literal fact", fact, "is ill-typed."};


(* ::Subsection:: *)
(*Subgoals*)

cpmMessageToList[ 31, _, _, lang] = {"Cannot set up ill-typed subgoal."};
cpmMessageToList[ 32, {n_}, _, lang] :=
	{"Cannot use", n, "explicit assumptions for setting up subgoal."};
cpmMessageToList[ 33, _, _, lang] = {"No subgoal to select."};
cpmMessageToList[ 34, _, _, lang] = {"Goal-pattern is ill-typed."};
cpmMessageToList[ 35, {i_}, _, lang] :=
	{"Cannot select subgoal number", i};


(* ::Subsection:: *)
(*Obtaining Constants*)

cpmMessageToList[ 41, _, _, lang] = {"Cannot obtain existing constant."};
cpmMessageToList[ 42, _, _, lang] = {"Cannot obtain non-constant."};
cpmMessageToList[ 43, _, _, lang] = {"New constants are not distinct."};
cpmMessageToList[ 44, _, _, lang] = {"Goal-pattern is ill-typed."};


(* ::Subsection:: *)
(*Abbreviations and Definitions*)

cpmMessageToList[ 51, _, _, lang] = {"Term in pattern-matching is ill-typed or contains meta variables."};
(*UNUSED*)cpmMessageToList[ 52, _, _, lang] = {"Patterns do not match term."};
(*UNUSED*)cpmMessageToList[ 53, _, _, lang] = {"Patterns are ill-formed."};
(*UNUSED*)cpmMessageToList[ 54, uinst_, _, lang] :=
	Join[ {"Obtained matcher does not instantiate syntactic variables"}, Riffle[ Composition[ SYMDISP$, First] /@ uinst, ","]];
(*UNUSED*)cpmMessageToList[ 55, {META$[ x_, _]}, _, lang] :=
	{"Instance of syntactic variable", SYMDISP$[ x], "depends on other syntactic variables and/or meta variables."};
cpmMessageToList[ 56, _, _, lang] = {"Recursive definition."};
cpmMessageToList[ 57, _, _, lang] = {"Specialized type variables in a polymorphic definition."};
cpmMessageToList[ 58, _, _, lang] = {"Definition is ill-formed or ill-typed or contains meta variables."};


(* ::Subsection:: *)
(*Universal Quantifiers*)

cpmMessageToList[ 71, {i_}, _, lang] :=
	{"Cannot instantiate non-existing assumption", i, "."};
cpmMessageToList[ 72, _, _, lang] = {"Cannot instantiate by ill-typed term."};
cpmMessageToList[ 73, _, _, lang] = {"More instantiations than variables."};
cpmMessageToList[ 74, {i_}, _, lang] :=
	{"Cannot instantiate", i, "assumptions."};
cpmMessageToList[ 75, {a_, b_}, _, lang] :=
	{"Type", TYPEDISP$[ a], "of instantiation does not match type", TYPEDISP$[ b], "of bound variable."};
cpmMessageToList[ 76, _, _, lang] = {"Term to be generalized is ill-typed or contains illegal (new) a.b.f. constants or meta variables."};
cpmMessageToList[ 77, _, _, lang] = {"More constants than quantifiers."};
cpmMessageToList[ 78, {x_}, _, lang] :=
	{TERMDISP$[ x], "is no a.b.f. constant."};
cpmMessageToList[ 79, {}, _, lang] = {"Cannot instantiate universal quantifier: atomic goal is not of object truth type."};


(* ::Subsection:: *)
(*Implications*)

cpmMessageToList[ 91, {i_}, _, lang] :=
	{"Cannot eliminate assumption", i, "."};
cpmMessageToList[ 92, _, _, lang] = {"Cannot eliminate assumption by itself."};
cpmMessageToList[ 93, {i_}, _, lang] :=
	{"Cannot eliminate assumption by assumption", i, "."};
cpmMessageToList[ 94, {i_}, _, lang] :=
	{"Cannot eliminate", i, "implications."};
cpmMessageToList[ 95, _, _, lang] = {"Cannot drop one or more assumption(s)."};
cpmMessageToList[ 96, _, _, lang] = {"Cannot introduce one or more assumption(s)."};
cpmMessageToList[ 97, {i_}, _, lang] :=
	{"Cannot drop", i, "explicit assumptions."};
cpmMessageToList[ 98, _, _, lang] = {"Specialized types of polymorphic assumptions."};
cpmMessageToList[ 99, _, _, lang] = {"Cannot add explicit assumptions to hypotheses because of multiple subgoals."};
cpmMessageToList[ 100, _, _, lang] = {"Cannot prove premise of implication automatically."};
cpmMessageToList[ 101, {case_}, _, lang] :=
	{"Case", STRING$[ case], "does not exist."};
cpmMessageToList[ 102, {case_}, _, lang] :=
	{"Case", STRING$[ case], " does not match any subgoal."};


(* ::Subsection:: *)
(*Canonical/Equational Format*)

cpmMessageToList[ 111, {i_}, _, lang] :=
	{"Cannot construct canonical format of non-existing assumption", i, "."};
cpmMessageToList[ 112, {i_}, _, lang] :=
	{"Cannot construct equational format of non-existing assumption", i, "."};


(* ::Subsection:: *)
(*Beta/Eta Conversion*)

cpmMessageToList[ 121, {spec_}, _, lang] :=
	{"Unknown conversion mode", spec, "for \[Beta]\[Eta]-conversion."};
cpmMessageToList[ 122, pos_List, _, lang] :=
	{"Cannot \[Beta]\[Eta]-convert at valid position", pos};
cpmMessageToList[ 123, pos_List, _, lang] :=
	{"Cannot \[Beta]\[Eta]-convert at invalid position", pos};
cpmMessageToList[ 124, {major_, args_}, _, lang] :=
	{"Invalid arguments", args, "of", STRING$[ major], "."};


(* ::Subsection:: *)
(*Calculational Reasoning*)

cpmMessageToList[ 131, _, _, lang] = {"No suitable symmetry rule found."};
cpmMessageToList[ 132, _, _, lang] = {"No suitable symmetry rule given."};
cpmMessageToList[ 133, _, _, lang] = {"No suitable transitivity rule found."};
cpmMessageToList[ 134, _, _, lang] = {"No suitable transitivity rule given."};
cpmMessageToList[ 135, _, _, lang] = {"No pending calculation."};


(* ::Subsection:: *)
(*Backchaining*)

cpmMessageToList[ 141, _, _, lang] = {"Nothing to eliminate."};
cpmMessageToList[ 142, {e_}, _, lang] :=
	{"Cannot eliminate assumption", e, "."};
cpmMessageToList[ 143, _, _, lang] = {"Rule used for backchaining does not have enough premises."};


(* ::Subsection:: *)
(*Rewriting*)

cpmMessageToList[ 151, {}, _, lang] = {"Ignoring duplicate rewrite-rule(s)."};
cpmMessageToList[ 151, dups_List, _, lang] :=
	Join[ {"Ignoring duplicate rewrite-rule(s):"}, Riffle[ Replace[ dups, k_List :> FKEYDISP$[ k], {1}], ","]];
cpmMessageToList[ 152, {}, _, lang] = {"List of rewrite-rules does not contain rewrite-rule(s) to be removed."};
cpmMessageToList[ 152, missing_List, _, lang] :=
	Join[ {"List of rewrite-rules does not contain rewrite-rule(s) to be removed:"}, Riffle[ Replace[ missing, k_List :> FKEYDISP$[ k], {1}], ","]];
cpmMessageToList[ 153, _, _, lang] = {"Duplicate rewriters given."};
cpmMessageToList[ 154, _, _, lang] = {"List of rewriters does not contain rewriters to be removed."};
cpmMessageToList[ 155, {rule_}, _, lang] :=
	{"Rewrite-rule not found:", rule};
cpmMessageToList[ 156, {rule_}, _, lang] :=
	{"Rewrite-rule comes after proof goal:", rule};
cpmMessageToList[ 157, _, _, lang] = {"Cannot remove variants of formulas from list of rewrite-rules."};
cpmMessageToList[ 158, {k_}, _, lang] :=
	{"Internal error: Variant with key", k, "does not exist."};
cpmMessageToList[ 159, {k_}, _, lang] :=
	{"Cannot extract rewrite-rule from formula with key", k, "."};


(* ::Subsection:: *)
(*Auto Reduction*)

cpmMessageToList[ 171, {}, _, lang] = {"Ignoring duplicate reduction rule(s)."};
cpmMessageToList[ 171, dups_List, _, lang] :=
	Join[ {"Ignoring duplicate reduction rule(s):"}, Riffle[ Replace[ dups, k_List :> FKEYDISP$[ k], {1}], ","]];
cpmMessageToList[ 172, {}, _, lang] = {"List of reduction rules does not contain reduction rule(s) to be removed."};
cpmMessageToList[ 172, missing_List, _, lang] :=
	Join[ {"List of reduction rules does not contain reduction rule(s) to be removed:"}, Riffle[ Replace[ missing, k_List :> FKEYDISP$[ k], {1}], ","]];
cpmMessageToList[ 173, {rule_}, _, lang] :=
	{"Reduction rule not found:", rule};
cpmMessageToList[ 174, {rule_}, _, lang] :=
	{"Reduction rule comes after proof goal:", rule};
cpmMessageToList[ 175, _, _, lang] = {"Cannot remove variants of formulas from list of reduction rules."};


(* ::Subsection:: *)
(*Reflection and Atomization*)

cpmMessageToList[ 191, {term_}, _, lang] :=
	{"Term", TERMDISP$[ term], "cannot be reflected."};
cpmMessageToList[ 192, {term_}, _, lang] :=
	{"Term", TERMDISP$[ term], "cannot be atomized."};

(* ::Subsection:: *)
(*General*)

(* Here we put all messages where the message text alone does not indicate which proof method generated the message. *)

cpmMessageToList[ 1001, _, _, lang] = {"Type constants are not disjoint."};
cpmMessageToList[ 1002, _, _, lang] = {"Specialized types of polymorphic a.b.f. term constants."};
cpmMessageToList[ 1003, _, _, lang] = {"Term contains new or polymorphic a.b.f. term constants."};
cpmMessageToList[ 1004, _, _, lang] = {"Term contains meta variables."};
cpmMessageToList[ 1005, _, _, lang] = {"Ill-typed term."};
cpmMessageToList[ 1006, {n_}, _, lang] :=
	{"Less than", n, "assumptions."};
cpmMessageToList[ 1007, _, _, lang] = {"No rigid unifier."};
cpmMessageToList[ 1008, _, _, lang] = {"More arguments than premises."};
cpmMessageToList[ 1009, _, _, lang] = {"No facts available."};
cpmMessageToList[ 1010, _, _, lang] = {"Empty rule-set."};
cpmMessageToList[ 1011, {a_}, _, lang] :=
	{"Cannot atomize", a, "assumptions."};
cpmMessageToList[ 1012, _, _, lang] = {"Flex-flex equations do not identify goal and rule."};
cpmMessageToList[ 1013, _, _, lang] = {"Argument-list of proof method is invalid."};
cpmMessageToList[ 1014, {mod_}, _, lang] :=
	{"Modifier", mod, "is invalid."};
cpmMessageToList[ 1015, {mod_, alt_}, _, lang] :=
	{"Modifier", mod, "is invalid; did you mean", alt, "?"};
cpmMessageToList[ 1016, _, _, lang] = {"Redundant specifications before \"only:\" in argument-list."};
cpmMessageToList[ 1017, {pos_}, _, lang] :=
	{"Part specification", pos, "refers to a non-existing part of the first subgoal."};
cpmMessageToList[ 1018, {pos_}, _, lang] :=
	{"Position", pos, "refers to an invalid subterm of the first subgoal."};

] (* With *)

End[]
