(* Theorema
    Copyright (C) 2010 The Theorema Group

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*)

BeginPackage[ "Theorema`CoreProvers`"]

Needs[ "Theorema`Common`"]
Needs[ "Theorema`Language`"]

MessageName[ loadProvers, "usage", "English"] = "";

Begin[ "`Private`"]

loadProvers[ {}] := Null
loadProvers[ provers_List] :=
	With[ {langFolders = Select[ FileNames[ "*", {FileNameJoin[ {$TheoremaDirectory, "Theorema", "CoreProvers", "LanguageData"}]}], FileType[ #] === Directory &]},
		BeginPackage[ "Theorema`CoreProvers`"];
		Scan[
			Function[ l,
				Scan[
					Quiet[ Check[ Get[ FileNameJoin[ {l, # <> ".m"}]], Null]]&,
					provers
				]
			],
			langFolders
		];
		EndPackage[];
		Scan[
			Quiet[ Check[ Get[ FileNameJoin[ {$TheoremaDirectory, "Theorema", "CoreProvers", # <> ".m"}]], Null]]&,
			provers
		];
	]
loadProvers[ prover_String] :=
	loadProvers[ {prover}]

End[]

EndPackage[]
