(* ::Package:: *)

(* This package is loaded in context "Theorema`HOL`Private`". *)

With[ {lang = "English"},
	
(* ::Section:: *)
(*General*)

(* ::Subsection:: *)
(*Definitions*)

holMessageToList[ 1, _, _, lang] = "Ill-formed definition.";
holMessageToList[ 2, _, _, lang] = "Ill-formed definition: arguments on left-hand-side are not distinct.";
holMessageToList[ 3, _, _, lang] = "Ill-formed definition: non-variable argument on left-hand-side.";
holMessageToList[ 4, _, _, lang] = "Ill-formed definition: right-hand-side contains variable not appearing on left-hand-side.";

(* ::Subsection:: *)
(*General*)

holMessageToList[ 11, {fact_}, _, lang] :=
	{"Fact", fact, "not found."};


(* ::Section:: *)
(*Parsing*)

(*UNUSED*)holMessageToList[ 51, {assoc_}, _, lang] :=
	{"Associativity specification", assoc, "is unknown."};
holMessageToList[ 52, {r_}, _, lang] :=
	{"Multi-range", r, "of an abbreviation contains non-abbreviation variable ranges."};
holMessageToList[ 53, {e_}, _, lang] :=
	{"Clause", e, "of a rule function is ill-formed."};


(* ::Section:: *)
(*Inductive*)

holMessageToList[ 101, {c_}, _, lang] :=
	{"Declared constant", TERMDISP$[ c], "must have an explicit type annotation on the left-hand-side of the \"where\" construct."};
holMessageToList[ 102, {c_, t_}, _, lang] :=
	{"Annotated type", TYPEDISP$[ t], "cannot be unified with the declared type of constant", TERMDISP$[ c]};
holMessageToList[ 103, {c_, t_}, _, lang] :=
	{"Annotated type", TYPEDISP$[ t], "of constant", TERMDISP$[ c], "contains non-anonymous type variables."};
holMessageToList[ 104, consts_List, _, lang] :=
	Join[ {"Defining type instance(s)"}, Riffle[ TTDISP$ @@@ consts, ","], {"of declared constant(s)."}];
holMessageToList[ 105, _, _, lang] = {"The \"prefix\" option of inductive definitions must be a single string."};
holMessageToList[ 106, {k_String}, _, lang] :=
	{STRING$[ k], "is no valid option for inductive definitions."};
holMessageToList[ 107, _, _, lang] = {"Unable to parse the options of the inductive definition."};
holMessageToList[ 108, _, _, lang] = {"Mutually inductive definitions of more than one predicates are not supported."};
holMessageToList[ 109, _, _, lang] = {"Each occurrence of the inductive predicate must be applied to the same permutation of the parameters."};
holMessageToList[ 110, {{i_Integer}, consts___}, _, lang] :=
	{"Constant", TERMDISP$[ {consts}[[i]]], "is no predicate."};
holMessageToList[ 111, {i_List}, _, lang] :=
	Join[ {"Inductive predicate occurs in its arguments in introduction rule(s)"}, Riffle[ i, ","], {"."}];
holMessageToList[ 112, {i_List}, _, lang] :=
	Join[ {"Head of atomic consequent of introduction rule(s)"}, Riffle[ i, ","], {"is no inductive predicate."}];
holMessageToList[ 113, {i_List}, _, lang] :=
	Join[ {"Premise of introduction rule(s)"}, Riffle[ i, ","], {"is not of type", TYPEDISP$[ Theorema`Knowledge`BOOL$TM]}];


(* ::Section:: *)
(*HOLProofMethods*)

(* ::Subsection:: *)
(*Definitions*)

holMessageToList[ 1001, _, _, lang] = "Recursive definition.";
holMessageToList[ 1002, _, _, lang] = "Specialized type variables in a polymorphic definition.";
holMessageToList[ 1003, _, _, lang] = "Definition is ill-formed or ill-typed or contains meta variables.";
holMessageToList[ 1004, _, _, lang] = "Head of left-hand-side in definition is no fresh a.b.f. constant.";


(* ::Subsection:: *)
(*Existential Quantifiers*)

holMessageToList[ 1011, _, _, lang] = "Goal is not existentially quantified.";
holMessageToList[ 1012, {i_}, _, lang] :=
	{"Cannot eliminate non-existing assumption", i};
holMessageToList[ 1013, _, _, lang] := "List of constants contains invalid element.";
holMessageToList[ 1014, _, _, lang] := "Less existential quantifiers than constants.";
holMessageToList[ 1015, _, _, lang] := "Assumption is not existentially quantified.";

] (* With *)
