(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20022,        556]
NotebookOptionsPosition[     16297,        461]
NotebookOutlinePosition[     16906,        481]
CellTagsIndexPosition[     16863,        478]
WindowTitle->Proof of (\:21D4I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715053466513281*^9, 3.7150534731538258`*^9}},
 CellID->1829131314,ExpressionUUID->"e1f3747e-b40a-4892-ab9b-8677b782b1dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<PQ\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<QP\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715055405933757*^9, 3.715055432731945*^9}},
 CellID->717555881,ExpressionUUID->"689bc2b2-7045-402a-a610-e6e48ecc5afd"],

Cell[BoxData[{
 RowBox[{"from", " ", 
  RowBox[{"\"\<True \[Or] False\>\"", "[", 
   RowBox[{"of", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}]}], "]"}], " ", "show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   StyleBox[
    FormBox[
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}],
     TheoremaForm],
    Selectable->True], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.715053542155044*^9, 3.715053591593871*^9}, {
  3.7150536584812307`*^9, 3.715053686809311*^9}, {3.715055396327236*^9, 
  3.715055396487576*^9}, {3.715055443920035*^9, 3.715055450671845*^9}},
 CellID->148445618,ExpressionUUID->"e0e7fc35-833e-43a8-b3d4-e1983940e7b4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<P1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox["True",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[True, {}]]]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150554645584784`*^9, 3.715055478165313*^9}, {
  3.715055569309617*^9, 3.7150555733233643`*^9}},
 CellID->387009970,ExpressionUUID->"4991cfe7-ace7-415a-bba8-db647226e1ce"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]TrueD\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715055936532839*^9, 3.715055957430456*^9}},
 CellID->804629161,ExpressionUUID->"5be2702b-c191-4d18-a71b-028ff18c4e7a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"hence", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<PQ\>\""}], ")"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715055839631054*^9, 3.7150558541570673`*^9}, {
  3.715055974870294*^9, 3.715056009735169*^9}},
 CellID->1878465444,ExpressionUUID->"1a706d0e-a120-4e98-9825-0245e00587ce"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<P1\>\"", " ", "show", " ", "_"}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", 
      RowBox[{"\"\<\[Equal] subst'\>\"", "[", 
       RowBox[{"of", " ", 
        RowBox[{"\[OpenCurlyQuote]", 
         RowBox[{
          UnderscriptBox["\[Lambda]", "x"], 
          RowBox[{"(", 
           RowBox[{"x", "\[DoubleLeftRightArrow]", 
            FormBox[
             StyleBox["Q", "ExpressionABF"],
             TheoremaForm]}], ")"}]}], "\[CloseCurlyQuote]"}]}], "]"}]}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150556195831738`*^9, 3.715055727831581*^9}, {
  3.7150557703566217`*^9, 3.71505579383644*^9}, {3.7150558771186113`*^9, 
  3.715055881337229*^9}, {3.715055961310672*^9, 3.7150559658945827`*^9}},
 CellID->261554347,ExpressionUUID->"e50b69e9-37e0-499c-86af-5d2a65ace8d6"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"\"\<True \[Or] False\>\"", "[", 
     RowBox[{"of", " ", 
      RowBox[{"\[OpenCurlyQuote]", 
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "\[CloseCurlyQuote]"}]}], "]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"True", " ", "\[DoubleLeftRightArrow]", " ", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056067404373*^9, 3.71505610468799*^9}},
 CellID->995181439,ExpressionUUID->"cc8df925-da56-48e5-bfeb-d7cd9d0ad2ae"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<Q1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], " ", "\[DoubleLeftRightArrow]", " ", "True"}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056108074581*^9, 3.715056128664497*^9}},
 CellID->1973521585,ExpressionUUID->"548e2036-69c4-47d6-b589-f6d49462b1ac"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", 
      RowBox[{"\"\<\[Equal] subst'\>\"", "[", 
       RowBox[{"of", " ", 
        RowBox[{"\[OpenCurlyQuote]", 
         RowBox[{
          UnderscriptBox["\[Lambda]", "x"], 
          RowBox[{"(", 
           RowBox[{"True", "\[DoubleLeftRightArrow]", "x"}], ")"}]}], 
         "\[CloseCurlyQuote]"}]}], "]"}]}], ",", " ", "triv"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056131314736*^9, 3.715056226385056*^9}},
 CellID->1130862732,ExpressionUUID->"babe5446-d772-4b24-9285-4a528202bde1"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056238274581*^9, 3.715056242250134*^9}},
 CellID->83125937,ExpressionUUID->"87751fd8-272b-436b-84b9-65c3f676cbd2"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<Q2\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], " ", "\[DoubleLeftRightArrow]", " ", "False"}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056247908309*^9, 3.71505626897801*^9}},
 CellID->2111045935,ExpressionUUID->"f5b2849f-151a-416f-83c0-7cbfd5517636"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]D1 reverse\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056338708329*^9, 3.715056404196163*^9}},
 CellID->11460239,ExpressionUUID->"ea60d0bb-314b-4a2e-8450-67c04137dc17"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<FalseE\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71505641536401*^9, 3.715056426884369*^9}},
 CellID->548155484,ExpressionUUID->"8d86e26b-1043-40e1-b31b-b0fe66502a4d"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056432048744*^9, 3.715056437468421*^9}},
 CellID->451067047,ExpressionUUID->"e7fe1e4d-b346-44a8-8614-0a4aa3be14db"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<P2\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox["False",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[True, {}]]]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150554645584784`*^9, 3.715055478165313*^9}, {
  3.715055569309617*^9, 3.7150555733233643`*^9}, {3.715056464854788*^9, 
  3.7150564669093513`*^9}},
 CellID->50018511,ExpressionUUID->"6aa08a57-7d4b-4ad0-92a2-9ea412058f25"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", "_"}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", 
      RowBox[{"\"\<\[Equal] subst'\>\"", "[", 
       RowBox[{"of", " ", 
        RowBox[{"\[OpenCurlyQuote]", 
         RowBox[{
          UnderscriptBox["\[Lambda]", "x"], 
          RowBox[{"(", 
           RowBox[{"x", "\[DoubleLeftRightArrow]", 
            FormBox[
             StyleBox["Q", "ExpressionABF"],
             TheoremaForm]}], ")"}]}], "\[CloseCurlyQuote]"}]}], "]"}]}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150556195831738`*^9, 3.715055727831581*^9}, {
  3.7150557703566217`*^9, 3.71505579383644*^9}, {3.7150558771186113`*^9, 
  3.715055881337229*^9}, {3.715055961310672*^9, 3.7150559658945827`*^9}, {
  3.7150564842052402`*^9, 3.7150564856288013`*^9}},
 CellID->439110410,ExpressionUUID->"52118e94-65f8-4469-9693-b0b1411e6d1a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"\"\<True \[Or] False\>\"", "[", 
     RowBox[{"of", " ", 
      RowBox[{"\[OpenCurlyQuote]", 
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "\[CloseCurlyQuote]"}]}], "]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"False", " ", "\[DoubleLeftRightArrow]", " ", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056067404373*^9, 3.71505610468799*^9}, {
  3.7150564932454367`*^9, 3.715056493885269*^9}},
 CellID->69774696,ExpressionUUID->"01f2e0e3-534c-4019-ab77-597de4304eb2"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<Q1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], " ", "\[DoubleLeftRightArrow]", " ", "True"}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056108074581*^9, 3.715056128664497*^9}},
 CellID->855024134,ExpressionUUID->"a027697a-0914-4175-9d19-46f9b182bc83"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]TrueD\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056521422879*^9, 3.7150565436382017`*^9}},
 CellID->86360404,ExpressionUUID->"d1bc7e50-264d-4aea-aa46-8d0a620b4b83"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<QP\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150565466573067`*^9, 3.7150565641503553`*^9}},
 CellID->785312317,ExpressionUUID->"64f42f07-034d-4e11-a8f6-7ff9c259d3d3"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"with", " ", "\"\<P2\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]D1\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056576332828*^9, 3.7150566169505253`*^9}},
 CellID->1586279271,ExpressionUUID->"bf8ededf-13e3-412f-8b09-20cf9ffd83d7"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<FalseE\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056131314736*^9, 3.715056226385056*^9}, {
  3.715056625383387*^9, 3.7150566274472513`*^9}},
 CellID->1876719325,ExpressionUUID->"05f0584f-d820-47d2-979d-e33e8c20eb08"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056238274581*^9, 3.715056242250134*^9}},
 CellID->669537564,ExpressionUUID->"313448c6-a459-4947-a95c-798fc692b905"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<Q2\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], " ", "\[DoubleLeftRightArrow]", " ", "False"}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715056247908309*^9, 3.71505626897801*^9}},
 CellID->1516288170,ExpressionUUID->"4283f8fc-98f0-497f-a280-1526c5709ea3"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<\[Equal] subst'\>\""}], ",", " ", "triv"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.71505641536401*^9, 3.715056426884369*^9}, {
  3.7150566592401648`*^9, 3.715056668063694*^9}},
 CellID->1324724924,ExpressionUUID->"e1cbc448-7108-49ab-8023-1efde29ad140"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[DoubleLeftRightArrow]I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 373, 11, 20, "ProofText", "ExpressionUUID" -> \
"e1f3747e-b40a-4892-ab9b-8677b782b1dd",
 CellID->1829131314],
Cell[966, 34, 1436, 37, 20, "ProofText", "ExpressionUUID" -> \
"689bc2b2-7045-402a-a610-e6e48ecc5afd",
 CellID->717555881],
Cell[2405, 73, 1228, 31, 42, "ProofText", "ExpressionUUID" -> \
"e0e7fc35-833e-43a8-b3d4-e1983940e7b4",
 CellID->148445618],
Cell[3636, 106, 854, 22, 20, "ProofText", "ExpressionUUID" -> \
"4991cfe7-ace7-415a-bba8-db647226e1ce",
 CellID->387009970],
Cell[4493, 130, 473, 12, 18, "ProofText", "ExpressionUUID" -> \
"5be2702b-c191-4d18-a71b-028ff18c4e7a",
 CellID->804629161],
Cell[4969, 144, 519, 13, 20, "ProofText", "ExpressionUUID" -> \
"1a706d0e-a120-4e98-9825-0245e00587ce",
 CellID->1878465444],
Cell[5491, 159, 923, 22, 52, "ProofText", "ExpressionUUID" -> \
"e50b69e9-37e0-499c-86af-5d2a65ace8d6",
 CellID->261554347],
Cell[6417, 183, 707, 18, 42, "ProofText", "ExpressionUUID" -> \
"cc8df925-da56-48e5-bfeb-d7cd9d0ad2ae",
 CellID->995181439],
Cell[7127, 203, 496, 13, 20, "ProofText", "ExpressionUUID" -> \
"548e2036-69c4-47d6-b589-f6d49462b1ac",
 CellID->1973521585],
Cell[7626, 218, 661, 17, 31, "ProofText", "ExpressionUUID" -> \
"babe5446-d772-4b24-9285-4a528202bde1",
 CellID->1130862732],
Cell[8290, 237, 239, 5, 18, "ProofText", "ExpressionUUID" -> \
"87751fd8-272b-436b-84b9-65c3f676cbd2",
 CellID->83125937],
Cell[8532, 244, 496, 13, 20, "ProofText", "ExpressionUUID" -> \
"f5b2849f-151a-416f-83c0-7cbfd5517636",
 CellID->2111045935],
Cell[9031, 259, 568, 14, 18, "ProofText", "ExpressionUUID" -> \
"ea60d0bb-314b-4a2e-8450-67c04137dc17",
 CellID->11460239],
Cell[9602, 275, 325, 7, 18, "ProofText", "ExpressionUUID" -> \
"8d86e26b-1043-40e1-b31b-b0fe66502a4d",
 CellID->548155484],
Cell[9930, 284, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"e7fe1e4d-b346-44a8-8614-0a4aa3be14db",
 CellID->451067047],
Cell[10152, 290, 905, 23, 20, "ProofText", "ExpressionUUID" -> \
"6aa08a57-7d4b-4ad0-92a2-9ea412058f25",
 CellID->50018511],
Cell[11060, 315, 944, 23, 52, "ProofText", "ExpressionUUID" -> \
"52118e94-65f8-4469-9693-b0b1411e6d1a",
 CellID->439110410],
Cell[12007, 340, 758, 19, 42, "ProofText", "ExpressionUUID" -> \
"01f2e0e3-534c-4019-ab77-597de4304eb2",
 CellID->69774696],
Cell[12768, 361, 495, 13, 20, "ProofText", "ExpressionUUID" -> \
"a027697a-0914-4175-9d19-46f9b182bc83",
 CellID->855024134],
Cell[13266, 376, 478, 12, 18, "ProofText", "ExpressionUUID" -> \
"d1bc7e50-264d-4aea-aa46-8d0a620b4b83",
 CellID->86360404],
Cell[13747, 390, 450, 11, 18, "ProofText", "ExpressionUUID" -> \
"64f42f07-034d-4e11-a8f6-7ff9c259d3d3",
 CellID->785312317],
Cell[14200, 403, 450, 10, 18, "ProofText", "ExpressionUUID" -> \
"bf8ededf-13e3-412f-8b09-20cf9ffd83d7",
 CellID->1586279271],
Cell[14653, 415, 378, 8, 18, "ProofText", "ExpressionUUID" -> \
"05f0584f-d820-47d2-979d-e33e8c20eb08",
 CellID->1876719325],
Cell[15034, 425, 240, 5, 18, "ProofText", "ExpressionUUID" -> \
"313448c6-a459-4947-a95c-798fc692b905",
 CellID->669537564],
Cell[15277, 432, 496, 13, 20, "ProofText", "ExpressionUUID" -> \
"4283f8fc-98f0-497f-a280-1526c5709ea3",
 CellID->1516288170],
Cell[15776, 447, 517, 12, 20, "ProofText", "ExpressionUUID" -> \
"e1cbc448-7108-49ab-8023-1efde29ad140",
 CellID->1324724924]
}
]
*)

