(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16617,        486]
NotebookOptionsPosition[     13524,        406]
NotebookOutlinePosition[     14120,        426]
CellTagsIndexPosition[     14077,        423]
WindowTitle->Proof of (\254\:2228)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186244238479147`*^9, 3.718624429370267*^9}},
 CellID->1129249000,ExpressionUUID->"e8f498fa-42be-43ce-a5a5-f4d760c399c7"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71862443199257*^9, 3.7186244346209373`*^9}},
 CellID->1873657169,ExpressionUUID->"149ec13f-7dcc-4ab5-8629-4e8e77755e52"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Or]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
         SyntaxForm->"x\[Or]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186244369044743`*^9, 3.718624452300952*^9}},
 CellID->1323813622,ExpressionUUID->"f46b5981-3162-4344-9ab1-cdaa9d8baab3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"intro", " ", "\"\<\[And]I\>\"", " ", "\"\<\[Not]I\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71862445695562*^9, 3.718624499205625*^9}},
 CellID->1648872199,ExpressionUUID->"2fa77a70-99cd-400c-b2ed-6bebb8750e53"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624521013988*^9, 3.7186245259618998`*^9}},
 CellID->2116052227,ExpressionUUID->"f57dfec1-fa3b-46dd-a69b-9468275198c9"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], "\n", 
   "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186245357010202`*^9, 3.71862454923037*^9}},
 CellID->794028928,ExpressionUUID->"464201cc-4fef-478d-9a9e-2e9aa169c0b9"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Or]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
      SyntaxForm->"x\[Or]y"], 
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624560850803*^9, 3.7186245919907227`*^9}},
 CellID->1435757302,ExpressionUUID->"576237d6-f1e1-4879-bfa9-ae2146184ff2"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624594518385*^9, 3.718624608502226*^9}},
 CellID->1153529318,ExpressionUUID->"1dd4f0f3-7a20-4bcb-a678-2743b58c8782"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186246120192327`*^9, 3.718624616744787*^9}},
 CellID->257431678,ExpressionUUID->"f5d362f8-b95f-44d4-a781-3d260c616e0d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], "\n", 
   "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186245357010202`*^9, 3.71862454923037*^9}},
 CellID->1310859267,ExpressionUUID->"b5e9738d-d221-41b2-bb29-b2118aeee3bb"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Or]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
      SyntaxForm->"x\[Or]y"], 
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624560850803*^9, 3.7186245919907227`*^9}, {
  3.7186246315536957`*^9, 3.7186246339033318`*^9}},
 CellID->1386409047,ExpressionUUID->"6907b490-f5d6-487d-b69c-701c192bc1f6"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624594518385*^9, 3.7186246417358007`*^9}},
 CellID->1729770297,ExpressionUUID->"1b842f29-eb43-4a48-8c29-44fb7bb1b7cf"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624646744918*^9, 3.7186246670961723`*^9}, 
   3.7186247847554483`*^9},
 CellID->1238244303,ExpressionUUID->"94aca2dc-ab9b-4f0d-a660-7920ebd81c11"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Or]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
         SyntaxForm->"x\[Or]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624661317053*^9, 3.718624678359777*^9}, {
  3.7186247874015923`*^9, 3.7186247878492823`*^9}},
 CellID->1067998647,ExpressionUUID->"89a46c00-7dd5-4921-aa49-691456be80f2"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186247979247847`*^9, 3.71862481726962*^9}},
 CellID->2061645826,ExpressionUUID->"1a633b48-e785-4d8c-8deb-586677200e6e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", "_"}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", ",", " ", 
      RowBox[{"elim", " ", "\"\<\[Or]E\>\""}]}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186247484526854`*^9, 3.7186247585446653`*^9}, {
  3.7186248246655273`*^9, 3.718624826577799*^9}, {3.718624870674593*^9, 
  3.718624877034732*^9}},
 CellID->1240827648,ExpressionUUID->"e28da96c-1efb-48da-8151-62886cc9f28a"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718624830167369*^9, 3.718624840602162*^9}, {
  3.718624883867093*^9, 3.718624895976322*^9}},
 CellID->2012745306,ExpressionUUID->"f643f6ed-f7d6-48a1-a140-0222e7a7ff61"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186248994706297`*^9, 3.7186249158876677`*^9}},
 CellID->2132745037,ExpressionUUID->"30168a7b-19d5-468e-95ae-f8aeace2ea75"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186249191894503`*^9, 3.718624922579214*^9}},
 CellID->850721017,ExpressionUUID->"8f00e1c6-8ef8-4459-a60a-33cc301fe6dd"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7186249243634243`*^9, 3.71862493025909*^9}},
 CellID->1297133775,ExpressionUUID->"dfcf4054-b14b-4e48-8a6e-d348f9175b48"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7186248994706297`*^9, 3.718624937582448*^9}},
 CellID->228792368,ExpressionUUID->"f124e57b-892d-4fbc-83cc-04b536c2e383"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Not]\[Or])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 373, 11, 20, "ProofText", "ExpressionUUID" -> \
"e8f498fa-42be-43ce-a5a5-f4d760c399c7",
 CellID->1129249000],
Cell[969, 34, 236, 4, 39, "ProofText", "ExpressionUUID" -> \
"149ec13f-7dcc-4ab5-8629-4e8e77755e52",
 CellID->1873657169],
Cell[1208, 40, 1122, 32, 20, "ProofText", "ExpressionUUID" -> \
"f46b5981-3162-4344-9ab1-cdaa9d8baab3",
 CellID->1323813622],
Cell[2333, 74, 1509, 44, 39, "ProofText", "ExpressionUUID" -> \
"2fa77a70-99cd-400c-b2ed-6bebb8750e53",
 CellID->1648872199],
Cell[3845, 120, 326, 9, 20, "ProofText", "ExpressionUUID" -> \
"f57dfec1-fa3b-46dd-a69b-9468275198c9",
 CellID->2116052227],
Cell[4174, 131, 373, 8, 39, "ProofText", "ExpressionUUID" -> \
"464201cc-4fef-478d-9a9e-2e9aa169c0b9",
 CellID->794028928],
Cell[4550, 141, 923, 25, 18, "ProofText", "ExpressionUUID" -> \
"576237d6-f1e1-4879-bfa9-ae2146184ff2",
 CellID->1435757302],
Cell[5476, 168, 285, 6, 39, "ProofText", "ExpressionUUID" -> \
"1dd4f0f3-7a20-4bcb-a678-2743b58c8782",
 CellID->1153529318],
Cell[5764, 176, 325, 9, 20, "ProofText", "ExpressionUUID" -> \
"f5d362f8-b95f-44d4-a781-3d260c616e0d",
 CellID->257431678],
Cell[6092, 187, 374, 8, 39, "ProofText", "ExpressionUUID" -> \
"b5e9738d-d221-41b2-bb29-b2118aeee3bb",
 CellID->1310859267],
Cell[6469, 197, 976, 26, 18, "ProofText", "ExpressionUUID" -> \
"6907b490-f5d6-487d-b69c-701c192bc1f6",
 CellID->1386409047],
Cell[7448, 225, 325, 7, 59, "ProofText", "ExpressionUUID" -> \
"1b842f29-eb43-4a48-8c29-44fb7bb1b7cf",
 CellID->1729770297],
Cell[7776, 234, 1405, 42, 20, "ProofText", "ExpressionUUID" -> \
"94aca2dc-ab9b-4f0d-a660-7920ebd81c11",
 CellID->1238244303],
Cell[9184, 278, 1151, 32, 39, "ProofText", "ExpressionUUID" -> \
"89a46c00-7dd5-4921-aa49-691456be80f2",
 CellID->1067998647],
Cell[10338, 312, 595, 16, 20, "ProofText", "ExpressionUUID" -> \
"1a633b48-e785-4d8c-8deb-586677200e6e",
 CellID->2061645826],
Cell[10936, 330, 506, 12, 41, "ProofText", "ExpressionUUID" -> \
"e28da96c-1efb-48da-8151-62886cc9f28a",
 CellID->1240827648],
Cell[11445, 344, 375, 10, 20, "ProofText", "ExpressionUUID" -> \
"f643f6ed-f7d6-48a1-a140-0222e7a7ff61",
 CellID->2012745306],
Cell[11823, 356, 515, 13, 18, "ProofText", "ExpressionUUID" -> \
"30168a7b-19d5-468e-95ae-f8aeace2ea75",
 CellID->2132745037],
Cell[12341, 371, 242, 5, 18, "ProofText", "ExpressionUUID" -> \
"8f00e1c6-8ef8-4459-a60a-33cc301fe6dd",
 CellID->850721017],
Cell[12586, 378, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"dfcf4054-b14b-4e48-8a6e-d348f9175b48",
 CellID->1297133775],
Cell[12916, 389, 604, 15, 19, "ProofText", "ExpressionUUID" -> \
"f124e57b-892d-4fbc-83cc-04b536c2e383",
 CellID->228792368]
}
]
*)

