(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13809,        391]
NotebookOptionsPosition[     12355,        350]
NotebookOutlinePosition[     12951,        370]
CellTagsIndexPosition[     12908,        367]
WindowTitle->Proof of (\:2203!E)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[Exists]! def\>\""}], ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Exists]E\>\"", " ", "\"\<\[And]E\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153381963072443`*^9, 3.715338290033827*^9}},
 CellID->915965383,ExpressionUUID->"770e84b9-f536-406b-8a2c-902d1d945ffa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338304215048*^9, 3.7153383145912046`*^9}},
 CellID->916674552,ExpressionUUID->"a279c665-a85e-46b1-abb5-f5843418a485"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[And]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}], 
        TagBox["\[LongRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
         SyntaxForm->"x\[LongRightArrow]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           RowBox[{
            UnderscriptBox[
             TagBox["\[And]",
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
             TagBox[
              StyleBox["y", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
            RowBox[{
             RowBox[{
              TagBox[
               StyleBox["P", "ExpressionABF"],
               Theorema`Language`TAG$[
                Theorema`Language`TYPED$[
                 Theorema`Language`FUN$TM[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                  Theorema`Knowledge`BOOL$TM]]]], "[", 
              TagBox[
               StyleBox["y", "ExpressionVariable"],
               Theorema`Language`TAG$[
                Theorema`Language`TYPED$[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
             TagBox["\[LongRightArrow]",
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
               Theorema`Language`LongRightArrow$TM, {}]],
              SyntaxForm->"x\[LongRightArrow]y"], 
             RowBox[{
              TagBox["(",
               "AutoParentheses"], 
              RowBox[{
               TagBox[
                StyleBox["y", "ExpressionVariable"],
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
               TagBox["\[Equal]",
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[Theorema`Language`EqualTilde$TM, {
                   Theorema`Language`TFIX$[
                   Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
                SyntaxForm->"x\[EqualTilde]y"], 
               TagBox[
                StyleBox["x", "ExpressionVariable"],
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
              TagBox[")",
               "AutoParentheses"]}]}]}], 
           TagBox[")",
            "AutoParentheses"]}], 
          TagBox["\[LongRightArrow]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
           SyntaxForm->"x\[LongRightArrow]y"], 
          TagBox[
           StyleBox["R", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "and",
     " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<3\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["y", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
         TagBox["\[Equal]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[Equal]y"], 
         TagBox[
          StyleBox["t", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338364297616*^9, 3.715338428011204*^9}, {
  3.7183648766095333`*^9, 3.718364877185129*^9}},
 CellID->943354820,ExpressionUUID->"24cb3e0f-f699-4208-8491-cc858012d97e"],

Cell[BoxData[{
 RowBox[{"from", " ", "\"\<2\>\"", " ", "show", " ", 
  FormBox[
   StyleBox["R", "ExpressionABF"],
   TheoremaForm]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<1\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153384380066233`*^9, 3.715338536199168*^9}},
 CellID->729654930,ExpressionUUID->"bcabbd5a-4c65-4efc-9547-ebe04fd47802"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338461269415*^9, 3.715338474595491*^9}, {
  3.715338540492684*^9, 3.715338544470441*^9}},
 CellID->728629593,ExpressionUUID->"a069b413-75d6-4b33-b1d3-1310f6e516f4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338547094624*^9, 3.715338558137471*^9}},
 CellID->388192071,ExpressionUUID->"ebbdb02e-0926-42a5-b9cf-1e4129e4484b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<3\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm], "]"}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        FormBox[
         StyleBox["y", "ExpressionABF"],
         TheoremaForm], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338567094481*^9, 3.715338591933588*^9}},
 CellID->1393675077,ExpressionUUID->"c99c21d7-45ea-4f11-ae9c-c86597047b44"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715338596829564*^9, 3.715338629101534*^9}, {
  3.71836489356094*^9, 3.718364894009243*^9}},
 CellID->154210399,ExpressionUUID->"7efc924a-b94f-46de-951c-b85d85eb6e2d"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]!E)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 399, 9, 20, "ProofText", "ExpressionUUID" -> \
"770e84b9-f536-406b-8a2c-902d1d945ffa",
 CellID->915965383],
Cell[993, 32, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"a279c665-a85e-46b1-abb5-f5843418a485",
 CellID->916674552],
Cell[1441, 48, 7125, 185, 35, "ProofText", "ExpressionUUID" -> \
"24cb3e0f-f699-4208-8491-cc858012d97e",
 CellID->943354820],
Cell[8569, 235, 407, 10, 39, "ProofText", "ExpressionUUID" -> \
"bcabbd5a-4c65-4efc-9547-ebe04fd47802",
 CellID->729654930],
Cell[8979, 247, 369, 10, 20, "ProofText", "ExpressionUUID" -> \
"a069b413-75d6-4b33-b1d3-1310f6e516f4",
 CellID->728629593],
Cell[9351, 259, 490, 14, 20, "ProofText", "ExpressionUUID" -> \
"ebbdb02e-0926-42a5-b9cf-1e4129e4484b",
 CellID->388192071],
Cell[9844, 275, 1597, 45, 18, "ProofText", "ExpressionUUID" -> \
"c99c21d7-45ea-4f11-ae9c-c86597047b44",
 CellID->1393675077],
Cell[11444, 322, 907, 26, 19, "ProofText", "ExpressionUUID" -> \
"7efc924a-b94f-46de-951c-b85d85eb6e2d",
 CellID->154210399]
}
]
*)

