(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4600,        146]
NotebookOptionsPosition[      3518,        114]
NotebookOutlinePosition[      4121,        134]
CellTagsIndexPosition[      4078,        131]
WindowTitle->Proof of (\:03B5CI2)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363392809064*^9, 3.718363424354097*^9}},
 CellID->821800274,ExpressionUUID->"686af9d2-16ac-425c-a218-4939015ce24b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363427497052*^9, 3.718363444251728*^9}},
 CellID->578859065,ExpressionUUID->"c8550f3e-0d6d-494e-8926-56b4d23dc903"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["A", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", "x"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FormBox[
         StyleBox["Q", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}], "\[And]", 
       RowBox[{
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363447437272*^9, 3.7183634959513617`*^9}},
 CellID->291890141,ExpressionUUID->"b7e84fac-47d5-4629-973e-1ed7ad1f7e18"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<SomeI\>\""}], ",", " ", "rule", ",", " ", 
    SuperscriptBox["fact", "+"]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71836349928662*^9, 3.718363538576082*^9}},
 CellID->1575692852,ExpressionUUID->"a965f381-b03f-4026-af3f-c815c7d68691"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "thus", " ", "_", " ", "unfolding", " ", "\"\<\[CurlyEpsilon] def\>\""}], 
  " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718363553513378*^9, 3.7183635731841393`*^9}},
 CellID->943518774,ExpressionUUID->"009fba78-0973-45de-93f2-88832a1d51b0"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[CurlyEpsilon]CI2)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"686af9d2-16ac-425c-a218-4939015ce24b",
 CellID->821800274],
Cell[1038, 37, 709, 21, 20, "ProofText", "ExpressionUUID" -> \
"c8550f3e-0d6d-494e-8926-56b4d23dc903",
 CellID->578859065],
Cell[1750, 60, 721, 22, 28, "ProofText", "ExpressionUUID" -> \
"b7e84fac-47d5-4629-973e-1ed7ad1f7e18",
 CellID->291890141],
Cell[2474, 84, 642, 17, 22, "ProofText", "ExpressionUUID" -> \
"a965f381-b03f-4026-af3f-c815c7d68691",
 CellID->1575692852],
Cell[3119, 103, 395, 9, 19, "ProofText", "ExpressionUUID" -> \
"009fba78-0973-45de-93f2-88832a1d51b0",
 CellID->943518774]
}
]
*)

