(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4231,        132]
NotebookOptionsPosition[      3148,        100]
NotebookOutlinePosition[      3749,        120]
CellTagsIndexPosition[      3706,        117]
WindowTitle->Proof of (\:03B5I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363139078302*^9, 3.718363149698311*^9}, {
  3.718363195999001*^9, 3.718363203092044*^9}},
 CellID->1802491860,ExpressionUUID->"189102d1-369b-4ede-9e77-907281ce9df3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183632056086483`*^9, 3.71836321457099*^9}},
 CellID->1683919478,ExpressionUUID->"d01220a3-9429-4306-9afb-9b2ae8e82662"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["A", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", "x"], 
     RowBox[{"(", 
      RowBox[{"True", " ", "\[And]", " ", 
       RowBox[{
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363222597866*^9, 3.7183632547877827`*^9}},
 CellID->1159315994,ExpressionUUID->"cd69c822-4578-419e-a891-0f0cf2885f3e"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<SomeI\>\""}], ",", " ", "rule", ",", " ", 
    "rule", ",", " ", "fact"}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363267138813*^9, 3.718363345037739*^9}},
 CellID->1751882754,ExpressionUUID->"c6122a2a-c678-4260-82c3-98e88eb8f1e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "thus", " ", "_", " ", "unfolding", " ", "\"\<\[CurlyEpsilon] def\>\""}], 
  " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718363358207903*^9, 3.718363370989541*^9}},
 CellID->1067176506,ExpressionUUID->"a564ba78-b099-4778-b496-2e36680c253e"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[CurlyEpsilon]I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 420, 12, 20, "ProofText", "ExpressionUUID" -> \
"189102d1-369b-4ede-9e77-907281ce9df3",
 CellID->1802491860],
Cell[1013, 35, 464, 13, 20, "ProofText", "ExpressionUUID" -> \
"d01220a3-9429-4306-9afb-9b2ae8e82662",
 CellID->1683919478],
Cell[1480, 50, 624, 18, 28, "ProofText", "ExpressionUUID" -> \
"cd69c822-4578-419e-a891-0f0cf2885f3e",
 CellID->1159315994],
Cell[2107, 70, 640, 17, 20, "ProofText", "ExpressionUUID" -> \
"c6122a2a-c678-4260-82c3-98e88eb8f1e3",
 CellID->1751882754],
Cell[2750, 89, 394, 9, 19, "ProofText", "ExpressionUUID" -> \
"a564ba78-b099-4778-b496-2e36680c253e",
 CellID->1067176506]
}
]
*)

