(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     22384,        608]
NotebookOptionsPosition[     20049,        546]
NotebookOutlinePosition[     20640,        566]
CellTagsIndexPosition[     20597,        563]
WindowTitle->Proof of (choice)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030578864312*^9, 3.719030582291008*^9}},
 CellID->879512663,ExpressionUUID->"daef1325-b004-4e3c-96d3-ae3a1c1f72cd"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030591222987*^9, 3.7190305937970667`*^9}},
 CellID->1365655350,ExpressionUUID->"a5863650-9406-4d6b-a46e-bba83324b457"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       UnderscriptBox[
        TagBox["\[Exists]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030597009663*^9, 3.719030612815872*^9}},
 CellID->1994599187,ExpressionUUID->"f0dbdba7-ba48-45cb-bb6d-06bc3d3f1694"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]]], 
       TagBox[
        StyleBox["f", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030615762841*^9, 3.719030627973484*^9}},
 CellID->1799358379,ExpressionUUID->"1b7dc0db-d081-4d03-b514-b8c4561ee28c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        RowBox[{
         UnderscriptBox["\[CurlyEpsilon]", "y"], 
         RowBox[{
          FormBox[
           StyleBox["P", "ExpressionABF"],
           TheoremaForm], "[", 
          RowBox[{"x", ",", "y"}], "]"}]}]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030636851437*^9, 3.719030684646125*^9}},
 CellID->662141598,ExpressionUUID->"91a11a59-c8a0-43a4-9dee-deb3858b3eb6"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030687936692*^9, 3.71903069369851*^9}},
 CellID->1575820068,ExpressionUUID->"d2a585d5-b203-4c12-b843-2b8bcb12f213"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], ",", 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030698336796*^9, 3.7190307323342524`*^9}},
 CellID->1390111005,ExpressionUUID->"77c4b9b3-909e-4aae-90ee-8035633d3b64"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[CurlyEpsilon]I \[Exists]\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190307508069143`*^9, 3.719030776367118*^9}},
 CellID->1394671402,ExpressionUUID->"20bce552-ba93-4806-a2a9-74652032db36"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030780276926*^9, 3.719030791303513*^9}},
 CellID->1573277746,ExpressionUUID->"91e948b5-ac5c-43b1-a38d-2526d1863b4b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]]], 
       TagBox[
        StyleBox["f", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190307940208406`*^9, 3.719030804626834*^9}},
 CellID->115727459,ExpressionUUID->"2fb343b4-84bb-46a3-b6dc-abc4e93fe96e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030807613258*^9, 3.719030856544373*^9}},
 CellID->580285613,ExpressionUUID->"966f4382-20b3-4a52-9696-4fcf1d0645c5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       UnderscriptBox[
        TagBox["\[Exists]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030858640813*^9, 3.719030885736397*^9}},
 CellID->1501664841,ExpressionUUID->"811e214f-c6db-4f02-986a-bd3e9b46e940"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030888087075*^9, 3.719030892771764*^9}},
 CellID->70840569,ExpressionUUID->"a546b58e-ab20-40bf-a7b7-f016fce538d0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", 
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "]"}]}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030901168891*^9, 3.719030926504767*^9}},
 CellID->150008451,ExpressionUUID->"4fe57ff5-b6f5-43d5-8dc3-2518629e4899"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7190309305489473`*^9, 3.71903094986524*^9}},
 CellID->207193733,ExpressionUUID->"6689445f-2826-48e1-8fa2-7302f2cbc14e"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (choice)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 297, 8, 20, "ProofText", "ExpressionUUID" -> \
"daef1325-b004-4e3c-96d3-ae3a1c1f72cd",
 CellID->879512663],
Cell[889, 31, 237, 4, 39, "ProofText", "ExpressionUUID" -> \
"a5863650-9406-4d6b-a46e-bba83324b457",
 CellID->1365655350],
Cell[1129, 37, 2179, 56, 30, "ProofText", "ExpressionUUID" -> \
"f0dbdba7-ba48-45cb-bb6d-06bc3d3f1694",
 CellID->1994599187],
Cell[3311, 95, 2804, 69, 53, "ProofText", "ExpressionUUID" -> \
"1b7dc0db-d081-4d03-b514-b8c4561ee28c",
 CellID->1799358379],
Cell[6118, 166, 1675, 44, 55, "ProofText", "ExpressionUUID" -> \
"91a11a59-c8a0-43a4-9dee-deb3858b3eb6",
 CellID->662141598],
Cell[7796, 212, 324, 9, 20, "ProofText", "ExpressionUUID" -> \
"d2a585d5-b203-4c12-b843-2b8bcb12f213",
 CellID->1575820068],
Cell[8123, 223, 1549, 39, 30, "ProofText", "ExpressionUUID" -> \
"77c4b9b3-909e-4aae-90ee-8035633d3b64",
 CellID->1390111005],
Cell[9675, 264, 354, 8, 18, "ProofText", "ExpressionUUID" -> \
"20bce552-ba93-4806-a2a9-74652032db36",
 CellID->1394671402],
Cell[10032, 274, 323, 7, 59, "ProofText", "ExpressionUUID" -> \
"91e948b5-ac5c-43b1-a38d-2526d1863b4b",
 CellID->1573277746],
Cell[10358, 283, 2789, 69, 31, "ProofText", "ExpressionUUID" -> \
"2fb343b4-84bb-46a3-b6dc-abc4e93fe96e",
 CellID->115727459],
Cell[13150, 354, 1918, 51, 28, "ProofText", "ExpressionUUID" -> \
"966f4382-20b3-4a52-9696-4fcf1d0645c5",
 CellID->580285613],
Cell[15071, 407, 2157, 55, 52, "ProofText", "ExpressionUUID" -> \
"811e214f-c6db-4f02-986a-bd3e9b46e940",
 CellID->1501664841],
Cell[17231, 464, 321, 9, 20, "ProofText", "ExpressionUUID" -> \
"a546b58e-ab20-40bf-a7b7-f016fce538d0",
 CellID->70840569],
Cell[17555, 475, 750, 23, 20, "ProofText", "ExpressionUUID" -> \
"4fe57ff5-b6f5-43d5-8dc3-2518629e4899",
 CellID->150008451],
Cell[18308, 500, 1737, 44, 30, "ProofText", "ExpressionUUID" -> \
"6689445f-2826-48e1-8fa2-7302f2cbc14e",
 CellID->207193733]
}
]
*)

