(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7243,        209]
NotebookOptionsPosition[      6161,        177]
NotebookOutlinePosition[      6757,        197]
CellTagsIndexPosition[      6714,        194]
WindowTitle->Proof of (\:2203CI)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[Exists] def\>\""}], ",", " ", 
    RowBox[{
    "intro", " ", "\"\<\[ForAll]I\>\"", " ", "\"\<\[Implies]I\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335923510333*^9, 3.715335941628168*^9}},
 CellID->1633843134,ExpressionUUID->"7b840743-c7d4-4f3e-a1fa-545747bfb2ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335946253652*^9, 3.715335962474004*^9}},
 CellID->1477434148,ExpressionUUID->"c207f734-2cea-4124-94b5-439c64629af6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<3\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        StyleBox["x", "ExpressionVariable"], "]"}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153359661121273`*^9, 3.715336021236825*^9}},
 CellID->1064952645,ExpressionUUID->"ce76d53c-094d-4ceb-82c3-fd7a8089ec37"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<3\>\"", " ", "\"\<2\>\"", " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     FormBox[
      StyleBox["t", "ExpressionABF"],
      TheoremaForm], "]"}], 
    TagBox["\[Implies]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
     SyntaxForm->"x\[Implies]y"], 
    TagBox[
     StyleBox["R", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
   "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[ForAll]CD\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153360425906267`*^9, 3.7153361255900307`*^9}},
 CellID->1029323885,ExpressionUUID->"3c84bc16-a6de-4cc2-b34c-d8d1f67121cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "this", " ", "\"\<1\>\"", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["R", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715336166952368*^9, 3.715336178654799*^9}},
 CellID->539132979,ExpressionUUID->"e43e0832-2d30-4851-ae8c-de4f9b970a3c"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]CI)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 407, 10, 20, "ProofText", "ExpressionUUID" -> \
"7b840743-c7d4-4f3e-a1fa-545747bfb2ba",
 CellID->1633843134],
Cell[1001, 33, 517, 17, 20, "ProofText", "ExpressionUUID" -> \
"c207f734-2cea-4124-94b5-439c64629af6",
 CellID->1477434148],
Cell[1521, 52, 3041, 80, 30, "ProofText", "ExpressionUUID" -> \
"ce76d53c-094d-4ceb-82c3-fd7a8089ec37",
 CellID->1064952645],
Cell[4565, 134, 1089, 28, 21, "ProofText", "ExpressionUUID" -> \
"3c84bc16-a6de-4cc2-b34c-d8d1f67121cb",
 CellID->1029323885],
Cell[5657, 164, 500, 11, 19, "ProofText", "ExpressionUUID" -> \
"e43e0832-2d30-4851-ae8c-de4f9b970a3c",
 CellID->539132979]
}
]
*)

