(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10379,        293]
NotebookOptionsPosition[      8916,        252]
NotebookOutlinePosition[      9520,        272]
CellTagsIndexPosition[      9477,        269]
WindowTitle->Proof of (\:2203C\:F431')
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719217992581744*^9, 3.7192180157322283`*^9}, {
  3.7196498849034653`*^9, 3.719649885501301*^9}},
 CellID->1140812586,ExpressionUUID->"1259a6de-71fb-4527-a7b7-b91e817c82ac"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218020143626*^9, 3.719218023122508*^9}},
 CellID->873408468,ExpressionUUID->"490e0e59-82b7-4e7d-bd6e-6b0b32c8bd55"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218025255869*^9, 3.71921804812307*^9}, {
  3.719648238233879*^9, 3.719648238928919*^9}, {3.719648288826035*^9, 
  3.719648291793332*^9}, {3.7196498937774363`*^9, 3.71964989966418*^9}},
 CellID->1133448115,ExpressionUUID->"214dff5d-e1e7-4291-9b02-b42c76370b08"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719648365403067*^9, 3.719648415506542*^9}, {
  3.7196499043603783`*^9, 3.719649909108362*^9}},
 CellID->1875341679,ExpressionUUID->"adc9d223-0e40-40fa-8259-a94382a22dae"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     TagBox[
      StyleBox["t", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "\[Equal]", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218052042149*^9, 3.71921806438694*^9}, {
   3.719648296226829*^9, 3.7196482968255796`*^9}, {3.7196487173594713`*^9, 
   3.719648775024322*^9}, 3.719648973194459*^9, {3.7196496068840513`*^9, 
   3.719649607268939*^9}, {3.719649919607272*^9, 3.719649936446814*^9}},
 CellID->1508967815,ExpressionUUID->"29657117-4e08-42e9-b8b8-4464f3a43b3a"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218205741378*^9, 3.719218211781164*^9}, {
  3.719649623178658*^9, 3.719649624938047*^9}},
 CellID->683998968,ExpressionUUID->"c4a7353f-373d-4fbf-8f7c-172f4c9d02e8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218215896584*^9, 3.7192182264486732`*^9}, {
   3.71964824628963*^9, 3.719648246953409*^9}, {3.719649635347597*^9, 
   3.719649646707787*^9}, 3.719649942578714*^9},
 CellID->2139490176,ExpressionUUID->"5fbea6e4-adec-45c9-aa2a-f5be38b34b80"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       StyleBox["x", "ExpressionVariable"], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"intro", " ", "\"\<\[Exists]CI\>\""}], ",", " ", 
     RowBox[{"rule", " ", "\"\<\[Equal] refl\>\""}], ",", " ", "fact"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719218228920768*^9, 3.719218267829843*^9}, {
  3.719649680964329*^9, 3.7196497277162457`*^9}, {3.7196499491210423`*^9, 
  3.7196499616141*^9}},
 CellID->87837083,ExpressionUUID->"18b3be59-e02c-44f6-9726-aa82e292f73b"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]C\[Equal]')",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[597, 21, 424, 12, 20, "ProofText", "ExpressionUUID" -> \
"1259a6de-71fb-4527-a7b7-b91e817c82ac",
 CellID->1140812586],
Cell[1024, 35, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"490e0e59-82b7-4e7d-bd6e-6b0b32c8bd55",
 CellID->873408468],
Cell[1261, 41, 1917, 50, 30, "ProofText", "ExpressionUUID" -> \
"214dff5d-e1e7-4291-9b02-b42c76370b08",
 CellID->1133448115],
Cell[3181, 93, 910, 27, 18, "ProofText", "ExpressionUUID" -> \
"adc9d223-0e40-40fa-8259-a94382a22dae",
 CellID->1875341679],
Cell[4094, 122, 1566, 41, 21, "ProofText", "ExpressionUUID" -> \
"29657117-4e08-42e9-b8b8-4464f3a43b3a",
 CellID->1508967815],
Cell[5663, 165, 268, 5, 18, "ProofText", "ExpressionUUID" -> \
"c4a7353f-373d-4fbf-8f7c-172f4c9d02e8",
 CellID->683998968],
Cell[5934, 172, 933, 23, 21, "ProofText", "ExpressionUUID" -> \
"5fbea6e4-adec-45c9-aa2a-f5be38b34b80",
 CellID->2139490176],
Cell[6870, 197, 2042, 53, 30, "ProofText", "ExpressionUUID" -> \
"18b3be59-e02c-44f6-9726-aa82e292f73b",
 CellID->87837083]
}
]
*)

