(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6811,        193]
NotebookOptionsPosition[      5960,        167]
NotebookOutlinePosition[      6578,        187]
CellTagsIndexPosition[      6535,        184]
WindowTitle->Proof of (\:03B5I \:2203 weaker)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364054393783*^9, 3.7183640634445744`*^9}, 
   3.7183643269828053`*^9},
 CellID->769803610,ExpressionUUID->"7109dc2e-e328-4184-b500-d904136f45aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<rl\>\""}], ":", 
   " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364066211525*^9, 3.718364091429093*^9}, {
  3.7183643338727913`*^9, 3.718364342241776*^9}},
 CellID->918527219,ExpressionUUID->"354362d8-f0d5-48f5-8967-ea999465c931"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["R", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`FUN$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
        Theorema`Knowledge`BOOL$TM]]]], "[", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[CurlyEpsilon]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Such$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]}], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<rl\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<\[CurlyEpsilon]I \[Exists]\>\""}], ",", " ", 
    "fact"}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7183640983333063`*^9, 3.71836414807154*^9}, {
  3.718364348410306*^9, 3.718364348962089*^9}},
 CellID->390974505,ExpressionUUID->"f443dd0c-8721-40b8-bc5b-45d803c92244"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[CurlyEpsilon]I \[Exists] weaker)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 400, 12, 20, "ProofText", "ExpressionUUID" -> \
"7109dc2e-e328-4184-b500-d904136f45aa",
 CellID->769803610],
Cell[1007, 35, 3109, 81, 28, "ProofText", "ExpressionUUID" -> \
"354362d8-f0d5-48f5-8967-ea999465c931",
 CellID->918527219],
Cell[4119, 118, 1837, 47, 31, "ProofText", "ExpressionUUID" -> \
"f443dd0c-8721-40b8-bc5b-45d803c92244",
 CellID->390974505]
}
]
*)

