(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11689,        328]
NotebookOptionsPosition[     10350,        290]
NotebookOutlinePosition[     10956,        310]
CellTagsIndexPosition[     10913,        307]
WindowTitle->Proof of (\:2203CI classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", ":", " ", 
    RowBox[{"\"\<\[Not]\[Exists]C\>\"", "[", "symmetric", "]"}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718626279836213*^9, 3.718626293460642*^9}},
 CellID->64690712,ExpressionUUID->"eaa97593-cc20-4dca-9cae-8e2c76cdc4eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453983384103*^9, 3.718454012919444*^9}, {
  3.718626370197817*^9, 3.718626375016243*^9}},
 CellID->1413865072,ExpressionUUID->"410f3afd-3f3d-4291-a449-a94ab0f6c17f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[NotExists]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`NotExists$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        RowBox[{
         TagBox[
          StyleBox["C", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["a", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[And]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
        SyntaxForm->"x\[And]y"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["a", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718454016282143*^9, 3.718454027905257*^9}, 
   3.7186263093214293`*^9, 3.718626396378303*^9},
 CellID->34542899,ExpressionUUID->"a2ccaf91-10f1-41b4-96bf-875ec3207732"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox[
     TagBox["\[Exists]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     RowBox[{
      TagBox[
       StyleBox["C", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]], 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     TagBox[
      StyleBox["x", "ExpressionVariable"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<classical\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718625917335773*^9, 3.7186259365115747`*^9}, {
   3.7186260152520313`*^9, 3.718626015419438*^9}, 3.718626405196516*^9},
 CellID->65881967,ExpressionUUID->"9873ce77-d6ce-4b45-87c5-5ec1ddd23471"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<**\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[NotExists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`NotExists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718625951181589*^9, 3.718625962471099*^9}, 
   3.718626414749192*^9},
 CellID->1369716084,ExpressionUUID->"9f6edea6-262f-42fa-afc5-fba3bfc3df77"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["C", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["a", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], 
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
      SyntaxForm->"x\[And]y"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["a", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718626476771337*^9, 3.71862649019949*^9}},
 CellID->1429437677,ExpressionUUID->"3ecc4f9c-afd5-493e-9164-90e1ada400f2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", ",", " ", 
     RowBox[{"intro", " ", "\"\<\[Exists]CI\>\""}]}], ")"}]}]}]], "ProofText",\

 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7186260353233557`*^9, 3.718626054361841*^9}, {
  3.718626089258202*^9, 3.718626091034339*^9}, {3.718626323077156*^9, 
  3.7186263307573853`*^9}, {3.7186264233028603`*^9, 3.718626429942027*^9}, {
  3.718626501599196*^9, 3.7186265380962763`*^9}},
 CellID->1444003814,ExpressionUUID->"9b061db5-b0d8-402f-9d99-aa5b90d27d4c"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]CI classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 337, 8, 22, "ProofText", "ExpressionUUID" -> \
"eaa97593-cc20-4dca-9cae-8e2c76cdc4eb",
 CellID->64690712],
Cell[941, 31, 493, 15, 20, "ProofText", "ExpressionUUID" -> \
"410f3afd-3f3d-4291-a449-a94ab0f6c17f",
 CellID->1413865072],
Cell[1437, 48, 3360, 91, 39, "ProofText", "ExpressionUUID" -> \
"a2ccaf91-10f1-41b4-96bf-875ec3207732",
 CellID->34542899],
Cell[4800, 141, 1673, 43, 52, "ProofText", "ExpressionUUID" -> \
"9873ce77-d6ce-4b45-87c5-5ec1ddd23471",
 CellID->65881967],
Cell[6476, 186, 1675, 43, 32, "ProofText", "ExpressionUUID" -> \
"9f6edea6-262f-42fa-afc5-fba3bfc3df77",
 CellID->1369716084],
Cell[8154, 231, 1531, 41, 18, "ProofText", "ExpressionUUID" -> \
"3ecc4f9c-afd5-493e-9164-90e1ada400f2",
 CellID->1429437677],
Cell[9688, 274, 658, 14, 20, "ProofText", "ExpressionUUID" -> \
"9b061db5-b0d8-402f-9d99-aa5b90d27d4c",
 CellID->1444003814]
}
]
*)

