(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10889,        318]
NotebookOptionsPosition[      8679,        259]
NotebookOutlinePosition[      9281,        279]
CellTagsIndexPosition[      9238,        276]
WindowTitle->Proof of (\:2228E2 classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184533484142437`*^9, 3.718453356229343*^9}},
 CellID->317046539,ExpressionUUID->"3209579c-00e8-4310-b26a-95257a6c95b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<disj\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["R", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184533652058067`*^9, 3.718453401997809*^9}, {
  3.719122850661725*^9, 3.719122868356265*^9}, {3.7191230817382793`*^9, 
  3.719123084874413*^9}},
 CellID->1690460601,ExpressionUUID->"25850724-b05e-4282-a180-c21bcac3a556"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453412679021*^9, 3.718453433990211*^9}, {
  3.7191230876339073`*^9, 3.719123088747672*^9}},
 CellID->1382190333,ExpressionUUID->"296c1578-5fba-4dc8-b83c-ca3bd3d1882d"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  FormBox[
   StyleBox["R", "ExpressionABF"],
   TheoremaForm]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453437103424*^9, 3.718453442138064*^9}, {
  3.7191228940543413`*^9, 3.71912289735817*^9}},
 CellID->1695004691,ExpressionUUID->"68e0377e-e209-4b1c-ad19-938b59cfd4f2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453445495029*^9, 3.718453449616276*^9}, 
   3.7191230927804737`*^9},
 CellID->15891537,ExpressionUUID->"0ad7b81b-0303-47e7-a934-1fc446321c20"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453478803009*^9, 3.718453487239769*^9}, 
   3.71912295054261*^9},
 CellID->1886159545,ExpressionUUID->"552e514a-40ee-4d70-9353-f46ee46142c9"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845348944554*^9, 3.718453491432213*^9}},
 CellID->1582481557,ExpressionUUID->"6a43f3b9-9320-4071-8dcc-5a3bf0955ce5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453493289164*^9, 3.718453501731073*^9}, 
   3.719123099131061*^9},
 CellID->1881560526,ExpressionUUID->"24c343f0-c4b1-4290-b59b-46847234bdfd"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<disj\>\"", " ", "show", " ", "_"}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453503924453*^9, 3.718453509640131*^9}, {
  3.7191229735832653`*^9, 3.719122981910845*^9}},
 CellID->1496024001,ExpressionUUID->"053c6268-aef3-45e2-bb29-26b6e5dafefe"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122985339487*^9, 3.719122989593388*^9}},
 CellID->119755217,ExpressionUUID->"c87ab6fb-c371-4d12-b9c1-95d897f953c4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191229913775997`*^9, 3.7191230038737926`*^9}, {
  3.7191231122902193`*^9, 3.7191231174728107`*^9}},
 CellID->859263044,ExpressionUUID->"25e45ed7-a630-46d5-a80b-6f08abf03fee"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123006526626*^9, 3.7191230101358767`*^9}},
 CellID->1234582722,ExpressionUUID->"906ca561-cc2a-47aa-9ac1-4c0a2749b158"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123013614477*^9, 3.719123019423964*^9}},
 CellID->859080878,ExpressionUUID->"9c594e24-45c5-48a9-8dd7-7764fc04db93"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719123024193721*^9, 3.719123039313442*^9}, {
  3.719123123307418*^9, 3.719123125936944*^9}},
 CellID->1985209373,ExpressionUUID->"0852057d-b5bf-4866-8759-984869a2f493"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or]E2 classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"3209579c-00e8-4310-b26a-95257a6c95b2",
 CellID->317046539],
Cell[1049, 37, 2889, 78, 20, "ProofText", "ExpressionUUID" -> \
"25850724-b05e-4282-a180-c21bcac3a556",
 CellID->1690460601],
Cell[3941, 117, 618, 16, 18, "ProofText", "ExpressionUUID" -> \
"296c1578-5fba-4dc8-b83c-ca3bd3d1882d",
 CellID->1382190333],
Cell[4562, 135, 345, 8, 39, "ProofText", "ExpressionUUID" -> \
"68e0377e-e209-4b1c-ad19-938b59cfd4f2",
 CellID->1695004691],
Cell[4910, 145, 348, 10, 20, "ProofText", "ExpressionUUID" -> \
"0ad7b81b-0303-47e7-a934-1fc446321c20",
 CellID->15891537],
Cell[5261, 157, 343, 8, 18, "ProofText", "ExpressionUUID" -> \
"552e514a-40ee-4d70-9353-f46ee46142c9",
 CellID->1886159545],
Cell[5607, 167, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"6a43f3b9-9320-4071-8dcc-5a3bf0955ce5",
 CellID->1582481557],
Cell[5829, 173, 438, 12, 20, "ProofText", "ExpressionUUID" -> \
"24c343f0-c4b1-4290-b59b-46847234bdfd",
 CellID->1881560526],
Cell[6270, 187, 361, 8, 39, "ProofText", "ExpressionUUID" -> \
"053c6268-aef3-45e2-bb29-26b6e5dafefe",
 CellID->1496024001],
Cell[6634, 197, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"c87ab6fb-c371-4d12-b9c1-95d897f953c4",
 CellID->119755217],
Cell[6960, 208, 554, 14, 18, "ProofText", "ExpressionUUID" -> \
"25e45ed7-a630-46d5-a80b-6f08abf03fee",
 CellID->859263044],
Cell[7517, 224, 241, 5, 18, "ProofText", "ExpressionUUID" -> \
"906ca561-cc2a-47aa-9ac1-4c0a2749b158",
 CellID->1234582722],
Cell[7761, 231, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"9c594e24-45c5-48a9-8dd7-7764fc04db93",
 CellID->859080878],
Cell[8087, 242, 588, 15, 19, "ProofText", "ExpressionUUID" -> \
"0852057d-b5bf-4866-8759-984869a2f493",
 CellID->1985209373]
}
]
*)

