(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4330,        132]
NotebookOptionsPosition[      3251,        100]
NotebookOutlinePosition[      3854,        120]
CellTagsIndexPosition[      3811,        117]
WindowTitle->Proof of (contraposition pos)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[Not]I\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715061499178331*^9, 3.715061504693801*^9}},
 CellID->699935163,ExpressionUUID->"d1de1421-7b25-4308-89c7-8fa104caf436"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150615591260023`*^9, 3.7150615649472446`*^9}},
 CellID->289686825,ExpressionUUID->"bbd7a7e6-547d-4af6-ba12-fcf7abe48df7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150616013203583`*^9, 3.715061608549618*^9}},
 CellID->192179003,ExpressionUUID->"214d7045-2526-4358-b213-afd3a2b6696f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150615705695667`*^9, 3.715061595119205*^9}},
 CellID->875978289,ExpressionUUID->"f67b7f22-6ead-4209-81f0-af2524d12905"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", 
   RowBox[{"this", "[", 
    RowBox[{"OF", " ", 
     RowBox[{"\[OpenCurlyQuote]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "\[CloseCurlyQuote]"}]}], "]"}], " ", "show", " ", 
   "_"}], " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7150616171490297`*^9, 3.715061630119924*^9}},
 CellID->954243769,ExpressionUUID->"29f356a0-413d-4eb9-ab8a-edb876d7bf07"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (contraposition pos)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 282, 6, 18, "ProofText", "ExpressionUUID" -> \
"d1de1421-7b25-4308-89c7-8fa104caf436",
 CellID->699935163],
Cell[886, 29, 374, 11, 20, "ProofText", "ExpressionUUID" -> \
"bbd7a7e6-547d-4af6-ba12-fcf7abe48df7",
 CellID->289686825],
Cell[1263, 42, 362, 9, 20, "ProofText", "ExpressionUUID" -> \
"214d7045-2526-4358-b213-afd3a2b6696f",
 CellID->192179003],
Cell[1628, 53, 1065, 29, 20, "ProofText", "ExpressionUUID" -> \
"f67b7f22-6ead-4209-81f0-af2524d12905",
 CellID->875978289],
Cell[2696, 84, 551, 14, 21, "ProofText", "ExpressionUUID" -> \
"29f356a0-413d-4eb9-ab8a-edb876d7bf07",
 CellID->954243769]
}
]
*)

