(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4335,        132]
NotebookOptionsPosition[      3019,         94]
NotebookOutlinePosition[      3611,        114]
CellTagsIndexPosition[      3568,        111]
WindowTitle->Proof of (If same)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654564532497*^9, 3.719654569896084*^9}},
 CellID->1765053010,ExpressionUUID->"8df865e5-08b8-4684-b0f7-cf46e777752b"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196545732570047`*^9, 3.719654587288993*^9}},
 CellID->194363666,ExpressionUUID->"a1f69a85-1315-46cc-a488-eb750b35714e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654591022656*^9, 3.719654595373438*^9}},
 CellID->1323427938,ExpressionUUID->"cd2d877e-29de-445e-9882-e1bea9234cec"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654598029688*^9, 3.719654608105444*^9}},
 CellID->648514974,ExpressionUUID->"798f989e-3e10-4cd5-bdb8-dbb2711bdf0c"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654609860654*^9, 3.719654612584379*^9}},
 CellID->757770683,ExpressionUUID->"653d887d-47e7-4096-983e-3e8fc46b1c71"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654614121799*^9, 3.719654621446918*^9}},
 CellID->1331166262,ExpressionUUID->"7de6ebef-c1ff-4f51-8c43-936c4cea6bcb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719654623043146*^9, 3.719654633353394*^9}},
 CellID->348882948,ExpressionUUID->"3479bc3f-8dd9-45ea-8ee1-646464271448"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If same)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 371, 11, 20, "ProofText", "ExpressionUUID" -> \
"8df865e5-08b8-4684-b0f7-cf46e777752b",
 CellID->1765053010],
Cell[964, 34, 324, 7, 39, "ProofText", "ExpressionUUID" -> \
"a1f69a85-1315-46cc-a488-eb750b35714e",
 CellID->194363666],
Cell[1291, 43, 322, 9, 20, "ProofText", "ExpressionUUID" -> \
"cd2d877e-29de-445e-9882-e1bea9234cec",
 CellID->1323427938],
Cell[1616, 54, 328, 7, 18, "ProofText", "ExpressionUUID" -> \
"798f989e-3e10-4cd5-bdb8-dbb2711bdf0c",
 CellID->648514974],
Cell[1947, 63, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"653d887d-47e7-4096-983e-3e8fc46b1c71",
 CellID->757770683],
Cell[2169, 69, 412, 11, 20, "ProofText", "ExpressionUUID" -> \
"7de6ebef-c1ff-4f51-8c43-936c4cea6bcb",
 CellID->1331166262],
Cell[2584, 82, 431, 10, 19, "ProofText", "ExpressionUUID" -> \
"3479bc3f-8dd9-45ea-8ee1-646464271448",
 CellID->348882948]
}
]
*)

