(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5936,        174]
NotebookOptionsPosition[      5095,        148]
NotebookOutlinePosition[      5703,        168]
CellTagsIndexPosition[      5660,        165]
WindowTitle->Proof of (\:03B5I weaker)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364054393783*^9, 3.7183640634445744`*^9}},
 CellID->769803610,ExpressionUUID->"79d9d3b7-4b90-4f38-939d-310a55c102fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<rl\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364066211525*^9, 3.718364091429093*^9}},
 CellID->918527219,ExpressionUUID->"8f0228f0-8115-4470-b317-7faa8c086571"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["R", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`FUN$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
        Theorema`Knowledge`BOOL$TM]]]], "[", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[CurlyEpsilon]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Such$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]}], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<rl\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<\[CurlyEpsilon]I\>\""}], ",", " ", "fact"}], 
   ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7183640983333063`*^9, 3.71836414807154*^9}},
 CellID->390974505,ExpressionUUID->"2d741298-6b26-4d6b-b00d-5854b3636f3a"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[CurlyEpsilon]I weaker)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[597, 21, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"79d9d3b7-4b90-4f38-939d-310a55c102fe",
 CellID->769803610],
Cell[1045, 37, 2266, 61, 28, "ProofText", "ExpressionUUID" -> \
"8f0228f0-8115-4470-b317-7faa8c086571",
 CellID->918527219],
Cell[3314, 100, 1777, 46, 31, "ProofText", "ExpressionUUID" -> \
"2d741298-6b26-4d6b-b00d-5854b3636f3a",
 CellID->390974505]
}
]
*)

