(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4612,        140]
NotebookOptionsPosition[      3284,        102]
NotebookOutlinePosition[      3884,        122]
CellTagsIndexPosition[      3841,        119]
WindowTitle->Proof of (If\:F431 same)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196546859792423`*^9, 3.7196546911002283`*^9}},
 CellID->1130251456,ExpressionUUID->"0e075a4e-94b3-4d23-9033-b15e094b3169"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196546933022947`*^9, 3.719654703482498*^9}},
 CellID->1179282028,ExpressionUUID->"e5914bde-f5e0-4f9d-9c5b-cb77294dcb8f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654705704543*^9, 3.719654718266492*^9}},
 CellID->1020138835,ExpressionUUID->"3a4ab20f-377e-4d32-8f54-f4f3044474b1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196547210293083`*^9, 3.719654736818358*^9}},
 CellID->999853997,ExpressionUUID->"1e004de5-e51e-4d33-8b1d-eb2d074f59e2"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654742291643*^9, 3.71965474465854*^9}},
 CellID->1616850818,ExpressionUUID->"f537e2ac-673b-48dc-9e98-71f3e2e8a401"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654747071554*^9, 3.719654758609885*^9}},
 CellID->1671786076,ExpressionUUID->"a58d6ab3-d88f-45dd-be19-bd1b78317088"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719654761171186*^9, 3.719654769771061*^9}},
 CellID->2128586932,ExpressionUUID->"60891cea-b667-4a9b-bce2-5c7acea7b8ce"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If\[Equal] same)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 375, 11, 20, "ProofText", "ExpressionUUID" -> \
"0e075a4e-94b3-4d23-9033-b15e094b3169",
 CellID->1130251456],
Cell[974, 34, 325, 7, 39, "ProofText", "ExpressionUUID" -> \
"e5914bde-f5e0-4f9d-9c5b-cb77294dcb8f",
 CellID->1179282028],
Cell[1302, 43, 491, 14, 20, "ProofText", "ExpressionUUID" -> \
"3a4ab20f-377e-4d32-8f54-f4f3044474b1",
 CellID->1020138835],
Cell[1796, 59, 330, 7, 18, "ProofText", "ExpressionUUID" -> \
"1e004de5-e51e-4d33-8b1d-eb2d074f59e2",
 CellID->999853997],
Cell[2129, 68, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"f537e2ac-673b-48dc-9e98-71f3e2e8a401",
 CellID->1616850818],
Cell[2351, 74, 494, 14, 20, "ProofText", "ExpressionUUID" -> \
"a58d6ab3-d88f-45dd-be19-bd1b78317088",
 CellID->1671786076],
Cell[2848, 90, 432, 10, 19, "ProofText", "ExpressionUUID" -> \
"60891cea-b667-4a9b-bce2-5c7acea7b8ce",
 CellID->2128586932]
}
]
*)

