(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9846,        276]
NotebookOptionsPosition[      7375,        211]
NotebookOutlinePosition[      7989,        231]
CellTagsIndexPosition[      7946,        228]
WindowTitle->Proof of (\:21D4 assoc)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719043161022379*^9, 3.7190431700762777`*^9}},
 CellID->1891692562,ExpressionUUID->"110cafac-8914-4e35-86d2-786a82c88733"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"intro", " ", "\"\<\[DoubleLeftRightArrow]I\>\""}], ",", " ", 
    RowBox[{"elim", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], ",", 
    " ", "assumption", ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719043192604805*^9, 3.7190432072426367`*^9}, {
  3.719043307307876*^9, 3.719043373389049*^9}, {3.7190437032172823`*^9, 
  3.719043703761031*^9}},
 CellID->982937022,ExpressionUUID->"edd5d209-e93c-428c-9955-b3e3effb3256"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", 
     RowBox[{
     "\"\<\[Not]\[DoubleLeftRightArrow]\>\"", " ", 
      "\"\<\[DoubleLeftRightArrow]False\>\""}]}]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719043718702436*^9, 3.7190437660900803`*^9}},
 CellID->1623508161,ExpressionUUID->"5e01989e-a53d-4daf-af9e-f484c5237e6e"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], ",", 
    " ", "assumption", ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190437792906017`*^9, 3.719043813466586*^9}},
 CellID->501348122,ExpressionUUID->"60155198-08d7-48f2-bc39-59538fb32735"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", 
     RowBox[{
     "\"\<\[Not]\[DoubleLeftRightArrow]\>\"", " ", 
      "\"\<True\[DoubleLeftRightArrow]\>\""}]}]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719043819476182*^9, 3.719043869650782*^9}},
 CellID->554731125,ExpressionUUID->"ab756152-bc8b-4dbc-987c-118df60d7ffb"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], ",", 
    " ", "assumption", ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption", ",", 
    " ", "assumption"}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719043993581902*^9, 3.719044068943245*^9}, 
   3.719044104558742*^9},
 CellID->661091350,ExpressionUUID->"629e573b-fede-4155-8036-1c1027c72c92"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption", ",", 
    " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719044107057822*^9, 3.7190441204222403`*^9}},
 CellID->913167141,ExpressionUUID->"cc55480d-6b1b-4b98-b3bc-741b2984a2ea"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<\[Not]\[DoubleLeftRightArrow]\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190441361177998`*^9, 3.719044158502016*^9}},
 CellID->2067782934,ExpressionUUID->"e851f591-8017-451d-b94a-ce36ec06b4a3"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], ",", 
    " ", "assumption", ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption", ",", 
    " ", "assumption"}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719043993581902*^9, 3.719044068943245*^9}, 
   3.719044104558742*^9},
 CellID->1420299496,ExpressionUUID->"176280d4-bb17-41f2-931c-abf3581b8219"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption", ",", 
    " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719044107057822*^9, 3.7190441204222403`*^9}},
 CellID->1591919286,ExpressionUUID->"60342dc1-4e35-463e-87c7-44e6accf7bc2"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<\[Not]\[DoubleLeftRightArrow]\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190441361177998`*^9, 3.719044158502016*^9}},
 CellID->1854085167,ExpressionUUID->"362d55d5-eca4-41e9-ba9f-d64ce05b1a16"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], ",", 
    " ", "assumption", ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719044181150689*^9, 3.719044214703436*^9}},
 CellID->985336167,ExpressionUUID->"3f0e33ff-5113-42aa-ae65-cd2193af5e83"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<\[Not]\[DoubleLeftRightArrow]\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719044219789949*^9, 3.71904423489543*^9}},
 CellID->1971886021,ExpressionUUID->"d2df16cc-6fca-4a69-a331-eb79421fa3c6"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"elim", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], ",", 
    " ", "assumption", ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719044181150689*^9, 3.719044214703436*^9}},
 CellID->237304740,ExpressionUUID->"c003ae31-9eaf-4a0c-be58-f88ae543bc27"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", 
     RowBox[{
     "\"\<\[Not]\[DoubleLeftRightArrow]\>\"", " ", 
      "\"\<\[DoubleLeftRightArrow]False\>\""}]}]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719044219789949*^9, 3.7190442690565443`*^9}},
 CellID->1496551097,ExpressionUUID->"a302580a-0c26-4297-8c6c-f50322436cc3"],

Cell[BoxData["qed"], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719044272738665*^9, 3.719044273153426*^9}},
 CellID->1595001358,ExpressionUUID->"81afe9db-3df5-4374-b1af-ad213b003c08"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[DoubleLeftRightArrow] assoc)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 446, 14, 20, "ProofText", "ExpressionUUID" -> \
"110cafac-8914-4e35-86d2-786a82c88733",
 CellID->1891692562],
Cell[1044, 37, 615, 13, 20, "ProofText", "ExpressionUUID" -> \
"edd5d209-e93c-428c-9955-b3e3effb3256",
 CellID->982937022],
Cell[1662, 52, 413, 10, 18, "ProofText", "ExpressionUUID" -> \
"5e01989e-a53d-4daf-af9e-f484c5237e6e",
 CellID->1623508161],
Cell[2078, 64, 440, 10, 20, "ProofText", "ExpressionUUID" -> \
"60155198-08d7-48f2-bc39-59538fb32735",
 CellID->501348122],
Cell[2521, 76, 409, 10, 18, "ProofText", "ExpressionUUID" -> \
"ab756152-bc8b-4dbc-987c-118df60d7ffb",
 CellID->554731125],
Cell[2933, 88, 489, 11, 20, "ProofText", "ExpressionUUID" -> \
"629e573b-fede-4155-8036-1c1027c72c92",
 CellID->661091350],
Cell[3425, 101, 413, 10, 20, "ProofText", "ExpressionUUID" -> \
"cc55480d-6b1b-4b98-b3bc-741b2984a2ea",
 CellID->913167141],
Cell[3841, 113, 343, 8, 18, "ProofText", "ExpressionUUID" -> \
"e851f591-8017-451d-b94a-ce36ec06b4a3",
 CellID->2067782934],
Cell[4187, 123, 490, 11, 20, "ProofText", "ExpressionUUID" -> \
"176280d4-bb17-41f2-931c-abf3581b8219",
 CellID->1420299496],
Cell[4680, 136, 414, 10, 20, "ProofText", "ExpressionUUID" -> \
"60342dc1-4e35-463e-87c7-44e6accf7bc2",
 CellID->1591919286],
Cell[5097, 148, 343, 8, 18, "ProofText", "ExpressionUUID" -> \
"362d55d5-eca4-41e9-ba9f-d64ce05b1a16",
 CellID->1854085167],
Cell[5443, 158, 438, 10, 20, "ProofText", "ExpressionUUID" -> \
"3f0e33ff-5113-42aa-ae65-cd2193af5e83",
 CellID->985336167],
Cell[5884, 170, 340, 8, 18, "ProofText", "ExpressionUUID" -> \
"d2df16cc-6fca-4a69-a331-eb79421fa3c6",
 CellID->1971886021],
Cell[6227, 180, 438, 10, 20, "ProofText", "ExpressionUUID" -> \
"c003ae31-9eaf-4a0c-be58-f88ae543bc27",
 CellID->237304740],
Cell[6668, 192, 413, 10, 18, "ProofText", "ExpressionUUID" -> \
"a302580a-0c26-4297-8c6c-f50322436cc3",
 CellID->1496551097],
Cell[7084, 204, 287, 5, 19, "ProofText", "ExpressionUUID" -> \
"81afe9db-3df5-4374-b1af-ad213b003c08",
 CellID->1595001358]
}
]
*)

