(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4397,        132]
NotebookOptionsPosition[      3440,        103]
NotebookOutlinePosition[      4043,        123]
CellTagsIndexPosition[      4000,        120]
WindowTitle->Proof of (contraposition neg)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[Not]I\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150612436379967`*^9, 3.715061250443123*^9}},
 CellID->1976904222,ExpressionUUID->"02f0cff2-8b8d-4cff-a26f-49b75533dbbd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715061284152562*^9, 3.715061291261622*^9}},
 CellID->959911626,ExpressionUUID->"7add20ef-1324-4c53-aff7-81f49f869ab7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<QP\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}]}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715061293793695*^9, 3.715061330260624*^9}},
 CellID->235883779,ExpressionUUID->"f276ecf0-d68d-4254-b0ab-747a08316c9c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\"\<QP\>\"", "[", 
    RowBox[{"OF", " ", 
     RowBox[{"\[OpenCurlyQuote]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "\[CloseCurlyQuote]"}]}], "]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
  ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7150613415300827`*^9, 3.715061374836349*^9}},
 CellID->983569830,ExpressionUUID->"bdfde4a7-9de7-49eb-9619-03dc84f050c9"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (contraposition neg)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 285, 6, 18, "ProofText", "ExpressionUUID" -> \
"02f0cff2-8b8d-4cff-a26f-49b75533dbbd",
 CellID->1976904222],
Cell[889, 29, 370, 11, 20, "ProofText", "ExpressionUUID" -> \
"7add20ef-1324-4c53-aff7-81f49f869ab7",
 CellID->959911626],
Cell[1262, 42, 1393, 37, 20, "ProofText", "ExpressionUUID" -> \
"f276ecf0-d68d-4254-b0ab-747a08316c9c",
 CellID->235883779],
Cell[2658, 81, 778, 20, 21, "ProofText", "ExpressionUUID" -> \
"bdfde4a7-9de7-49eb-9619-03dc84f050c9",
 CellID->983569830]
}
]
*)

