(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12719,        368]
NotebookOptionsPosition[     10503,        309]
NotebookOutlinePosition[     11109,        329]
CellTagsIndexPosition[     11066,        326]
WindowTitle->Proof of (\:2200C\:2260)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218594581457*^9, 3.7192186001953297`*^9}},
 CellID->109006102,ExpressionUUID->"34b6a144-7c6b-4b9f-b0d3-5c98eaf25c49"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192186029626417`*^9, 3.7192186047856197`*^9}},
 CellID->214691186,ExpressionUUID->"6b4ecebc-deb8-4ee9-bd87-9c2f68253af0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       StyleBox["x", "ExpressionVariable"], 
       TagBox["\[NotEqual]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Unequal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[NotEqual]y"], 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192186072784357`*^9, 3.719218616984592*^9}},
 CellID->1738511181,ExpressionUUID->"9d9821e7-e1f2-4b7b-b257-ea9ea763109a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218620446783*^9, 3.719218641898232*^9}, {
  3.719218770157277*^9, 3.719218777491282*^9}},
 CellID->1823311505,ExpressionUUID->"e35b8455-c965-430e-bbeb-895c12feec1a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192186532687073`*^9, 3.719218664837502*^9}, 
   3.71921878406336*^9},
 CellID->859422088,ExpressionUUID->"6cb6bf5a-7cb4-4391-b7a9-d8c17a27872f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719218787467616*^9, 3.719218804476112*^9}},
 CellID->1425972050,ExpressionUUID->"a8b36b39-3a92-4b61-a170-86e295e7e5ee"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218824351375*^9, 3.719218832108698*^9}},
 CellID->2001633414,ExpressionUUID->"dcaba3c9-5ee5-4300-8666-3f26f2af1a6a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218835368281*^9, 3.7192188415888968`*^9}},
 CellID->2022853766,ExpressionUUID->"bfb61513-0f3a-491b-bbdd-2b78959526c1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218844590007*^9, 3.71921885292213*^9}},
 CellID->2044039303,ExpressionUUID->"b3891494-5166-4be7-a36c-1eb04e2e1407"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       StyleBox["x", "ExpressionVariable"], 
       TagBox["\[NotEqual]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Unequal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[NotEqual]y"], 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"intro", " ", "\"\<\[ForAll]CI\>\"", " ", "\"\<\[Not]I\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71921885627314*^9, 3.719218876565115*^9}},
 CellID->994962352,ExpressionUUID->"246996f1-c422-4d73-8f8f-37403f8ada96"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218879435998*^9, 3.719218883756531*^9}},
 CellID->748778587,ExpressionUUID->"2ea209ff-42f1-49ab-9695-1c1efd7c57a2"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218886349393*^9, 3.719218944038163*^9}},
 CellID->1030003771,ExpressionUUID->"8f8d0e3f-7b2a-4509-9f7f-13767fe650c5"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["t", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218950910198*^9, 3.719218962410432*^9}},
 CellID->1791481115,ExpressionUUID->"4120e793-85ed-4420-a7e7-70a2deae04e2"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719218965631166*^9, 3.7192189834218073`*^9}},
 CellID->1931615137,ExpressionUUID->"107df25a-55b2-408a-81d0-d0bf49ec4990"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[ForAll]C\[NotEqual])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 372, 11, 20, "ProofText", "ExpressionUUID" -> \
"34b6a144-7c6b-4b9f-b0d3-5c98eaf25c49",
 CellID->109006102],
Cell[971, 34, 238, 4, 39, "ProofText", "ExpressionUUID" -> \
"6b4ecebc-deb8-4ee9-bd87-9c2f68253af0",
 CellID->214691186],
Cell[1212, 40, 1647, 42, 30, "ProofText", "ExpressionUUID" -> \
"9d9821e7-e1f2-4b7b-b257-ea9ea763109a",
 CellID->1738511181],
Cell[2862, 84, 930, 25, 42, "ProofText", "ExpressionUUID" -> \
"e35b8455-c965-430e-bbeb-895c12feec1a",
 CellID->1823311505],
Cell[3795, 111, 519, 15, 21, "ProofText", "ExpressionUUID" -> \
"6cb6bf5a-7cb4-4391-b7a9-d8c17a27872f",
 CellID->859422088],
Cell[4317, 128, 535, 15, 18, "ProofText", "ExpressionUUID" -> \
"a8b36b39-3a92-4b61-a170-86e295e7e5ee",
 CellID->1425972050],
Cell[4855, 145, 328, 7, 18, "ProofText", "ExpressionUUID" -> \
"dcaba3c9-5ee5-4300-8666-3f26f2af1a6a",
 CellID->2001633414],
Cell[5186, 154, 279, 6, 39, "ProofText", "ExpressionUUID" -> \
"bfb61513-0f3a-491b-bbdd-2b78959526c1",
 CellID->2022853766],
Cell[5468, 162, 990, 26, 21, "ProofText", "ExpressionUUID" -> \
"b3891494-5166-4be7-a36c-1eb04e2e1407",
 CellID->2044039303],
Cell[6461, 190, 1748, 45, 52, "ProofText", "ExpressionUUID" -> \
"246996f1-c422-4d73-8f8f-37403f8ada96",
 CellID->994962352],
Cell[8212, 237, 322, 9, 20, "ProofText", "ExpressionUUID" -> \
"2ea209ff-42f1-49ab-9695-1c1efd7c57a2",
 CellID->748778587],
Cell[8537, 248, 750, 22, 20, "ProofText", "ExpressionUUID" -> \
"8f8d0e3f-7b2a-4509-9f7f-13767fe650c5",
 CellID->1030003771],
Cell[9290, 272, 493, 14, 21, "ProofText", "ExpressionUUID" -> \
"4120e793-85ed-4420-a7e7-70a2deae04e2",
 CellID->1791481115],
Cell[9786, 288, 713, 19, 21, "ProofText", "ExpressionUUID" -> \
"107df25a-55b2-408a-81d0-d0bf49ec4990",
 CellID->1931615137]
}
]
*)

