(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7942,        234]
NotebookOptionsPosition[      6739,        199]
NotebookOutlinePosition[      7332,        219]
CellTagsIndexPosition[      7289,        216]
WindowTitle->Proof of (\:2227D1)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", ":", " ", "\"\<\[And] def\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335011265348*^9, 3.715335019144208*^9}},
 CellID->1621663981,ExpressionUUID->"12065112-c2bf-454f-a9e4-58c05aa8f3b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71533505052392*^9, 3.715335056316585*^9}},
 CellID->2139168285,ExpressionUUID->"f2bb2ecf-35f5-43dd-ac6a-1acc99ac85f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
        Theorema`Language`Forall$TM, {Theorema`Knowledge`BOOL$TM}]]], 
      TagBox[
       StyleBox["R", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["Q", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
           TagBox["\[Implies]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
            SyntaxForm->"x\[Implies]y"], 
           TagBox[
            StyleBox["R", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
          TagBox[")",
           "AutoParentheses"]}]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["R", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153350630926647`*^9, 3.715335121729454*^9}},
 CellID->1730717471,ExpressionUUID->"b5f1b03f-b296-4078-8070-38ba0d089e6f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         FormBox[
          StyleBox["P", "ExpressionABF"],
          TheoremaForm]}], 
        TagBox[")",
         "AutoParentheses"]}]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153351281603203`*^9, 3.715335154881777*^9}},
 CellID->1422040216,ExpressionUUID->"f5950322-50a6-4a62-85bc-6393e579b73c"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335195306616*^9, 3.715335255437851*^9}},
 CellID->850330599,ExpressionUUID->"19e08f0f-fe1d-4341-8980-6d49e2846dc6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"intro", " ", "\"\<\[Implies]I\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715335259267177*^9, 3.7153352928834257`*^9}},
 CellID->1761109414,ExpressionUUID->"e35cd0b5-514c-4c6f-8a02-57148da8ba49"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[And]D1)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 291, 6, 18, "ProofText", "ExpressionUUID" -> \
"12065112-c2bf-454f-a9e4-58c05aa8f3b3",
 CellID->1621663981],
Cell[885, 29, 370, 11, 20, "ProofText", "ExpressionUUID" -> \
"f2bb2ecf-35f5-43dd-ac6a-1acc99ac85f5",
 CellID->2139168285],
Cell[1258, 42, 2169, 59, 29, "ProofText", "ExpressionUUID" -> \
"b5f1b03f-b296-4078-8070-38ba0d089e6f",
 CellID->1730717471],
Cell[3430, 103, 1552, 45, 18, "ProofText", "ExpressionUUID" -> \
"f5950322-50a6-4a62-85bc-6393e579b73c",
 CellID->1422040216],
Cell[4985, 150, 353, 8, 39, "ProofText", "ExpressionUUID" -> \
"19e08f0f-fe1d-4341-8980-6d49e2846dc6",
 CellID->850330599],
Cell[5341, 160, 1394, 37, 19, "ProofText", "ExpressionUUID" -> \
"e35cd0b5-514c-4c6f-8a02-57148da8ba49",
 CellID->1761109414]
}
]
*)

