(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18286,        544]
NotebookOptionsPosition[     15189,        464]
NotebookOutlinePosition[     15786,        484]
CellTagsIndexPosition[     15743,        481]
WindowTitle->Proof of (\254\:2227)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71894980882366*^9, 3.718949810989292*^9}, {
  3.71894985090145*^9, 3.718949856294767*^9}},
 CellID->940175454,ExpressionUUID->"638ce967-8bba-4323-840d-02768cd951f4"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718949866730814*^9, 3.718949875677771*^9}},
 CellID->1957638803,ExpressionUUID->"f8e44b6c-5972-4d37-9a5b-208c5582aee9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189498774672337`*^9, 3.718949889253025*^9}},
 CellID->1357400804,ExpressionUUID->"a2bcdfe7-e557-4552-9934-94072e726332"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]I1 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71894990464252*^9, 3.718949930654991*^9}},
 CellID->1172569382,ExpressionUUID->"caf3c226-6c3c-4e1b-98d6-dbab2129f3fb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718949934357733*^9, 3.718949948206643*^9}},
 CellID->693263889,ExpressionUUID->"4df96e89-81b8-400c-8a47-3f7066faf145"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Not]\[Not]D\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189499538924723`*^9, 3.718949968863433*^9}},
 CellID->2076588798,ExpressionUUID->"0c4ea44d-a96c-4b86-a1da-f85badeb9da0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189500011737843`*^9, 3.718950013367412*^9}},
 CellID->1942824532,ExpressionUUID->"695d00af-e5aa-4e8e-bad6-23688420f9df"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950015432755*^9, 3.7189500206799*^9}},
 CellID->671666463,ExpressionUUID->"456139c2-6689-4057-a0af-56738671661b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7189500303716993`*^9, 3.718950051272187*^9}},
 CellID->81982490,ExpressionUUID->"09f90c00-db66-42ea-a99f-f78ebaddeb28"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189500558701057`*^9, 3.7189500750004396`*^9}},
 CellID->2084439425,ExpressionUUID->"ca0b3543-4bae-4c71-aeaf-a8978d2e827d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950078796212*^9, 3.71895009168895*^9}},
 CellID->23502149,ExpressionUUID->"6e6dd65a-de10-47df-9563-87b935355289"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950094121554*^9, 3.718950107465003*^9}},
 CellID->939669203,ExpressionUUID->"885a0702-d6fa-4153-a159-049b4aa20521"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950116006365*^9, 3.718950129945059*^9}},
 CellID->620187094,ExpressionUUID->"3e98a737-f1de-414a-8b33-ace120ee804b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950135257913*^9, 3.718950148697556*^9}},
 CellID->1241695790,ExpressionUUID->"3490f639-4c39-4b32-94fb-d740467d691a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "and", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189501515659733`*^9, 3.718950166001473*^9}},
 CellID->1694140312,ExpressionUUID->"6ad4009c-0fac-4158-a582-bcef75a38036"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], "\n", 
   "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189501800700693`*^9, 3.7189501977458057`*^9}},
 CellID->1755242426,ExpressionUUID->"34d9e79d-8038-4d45-bf00-6b46665e235f"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950201126747*^9, 3.7189502121603127`*^9}},
 CellID->1705231323,ExpressionUUID->"fa45db5f-05c6-4fe9-a238-15b3915ba160"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "show", " ", "_"}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7189502151971703`*^9, 3.71895022641616*^9}},
 CellID->1497921155,ExpressionUUID->"61311367-e141-410f-b436-5b131eeebb17"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718950229636417*^9, 3.7189502328263474`*^9}},
 CellID->1966565412,ExpressionUUID->"800e3c39-e81b-4a6b-bc41-bc80128f851d"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71895023480754*^9, 3.718950243263515*^9}},
 CellID->1501970052,ExpressionUUID->"216a7b18-9346-43e8-99c1-00598d61c432"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], " ", "show", " ", "_"}], " ", ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718950246920076*^9, 3.718950256872819*^9}},
 CellID->1789318105,ExpressionUUID->"3aa85f8b-ceaa-47b3-ad10-a30b15ee567c"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Not]\[And])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 417, 12, 20, "ProofText", "ExpressionUUID" -> \
"638ce967-8bba-4323-840d-02768cd951f4",
 CellID->940175454],
Cell[1013, 35, 235, 4, 39, "ProofText", "ExpressionUUID" -> \
"f8e44b6c-5972-4d37-9a5b-208c5582aee9",
 CellID->1957638803],
Cell[1251, 41, 1087, 31, 20, "ProofText", "ExpressionUUID" -> \
"a2bcdfe7-e557-4552-9934-94072e726332",
 CellID->1357400804],
Cell[2341, 74, 1491, 44, 39, "ProofText", "ExpressionUUID" -> \
"caf3c226-6c3c-4e1b-98d6-dbab2129f3fb",
 CellID->1172569382],
Cell[3835, 120, 930, 27, 20, "ProofText", "ExpressionUUID" -> \
"4df96e89-81b8-400c-8a47-3f7066faf145",
 CellID->693263889],
Cell[4768, 149, 398, 10, 18, "ProofText", "ExpressionUUID" -> \
"0c4ea44d-a96c-4b86-a1da-f85badeb9da0",
 CellID->2076588798],
Cell[5169, 161, 438, 12, 39, "ProofText", "ExpressionUUID" -> \
"695d00af-e5aa-4e8e-bad6-23688420f9df",
 CellID->1942824532],
Cell[5610, 175, 325, 9, 20, "ProofText", "ExpressionUUID" -> \
"456139c2-6689-4057-a0af-56738671661b",
 CellID->671666463],
Cell[5938, 186, 600, 18, 18, "ProofText", "ExpressionUUID" -> \
"09f90c00-db66-42ea-a99f-f78ebaddeb28",
 CellID->81982490],
Cell[6541, 206, 1184, 32, 18, "ProofText", "ExpressionUUID" -> \
"ca0b3543-4bae-4c71-aeaf-a8978d2e827d",
 CellID->2084439425],
Cell[7728, 240, 320, 7, 59, "ProofText", "ExpressionUUID" -> \
"6e6dd65a-de10-47df-9563-87b935355289",
 CellID->23502149],
Cell[8051, 249, 1371, 41, 20, "ProofText", "ExpressionUUID" -> \
"885a0702-d6fa-4153-a159-049b4aa20521",
 CellID->939669203],
Cell[9425, 292, 1100, 31, 39, "ProofText", "ExpressionUUID" -> \
"3e98a737-f1de-414a-8b33-ace120ee804b",
 CellID->620187094],
Cell[10528, 325, 785, 21, 20, "ProofText", "ExpressionUUID" -> \
"3490f639-4c39-4b32-94fb-d740467d691a",
 CellID->1241695790],
Cell[11316, 348, 465, 13, 18, "ProofText", "ExpressionUUID" -> \
"6ad4009c-0fac-4158-a582-bcef75a38036",
 CellID->1694140312],
Cell[11784, 363, 1481, 42, 39, "ProofText", "ExpressionUUID" -> \
"34d9e79d-8038-4d45-bf00-6b46665e235f",
 CellID->1755242426],
Cell[13268, 407, 418, 11, 20, "ProofText", "ExpressionUUID" -> \
"fa45db5f-05c6-4fe9-a238-15b3915ba160",
 CellID->1705231323],
Cell[13689, 420, 369, 9, 18, "ProofText", "ExpressionUUID" -> \
"61311367-e141-410f-b436-5b131eeebb17",
 CellID->1497921155],
Cell[14061, 431, 243, 5, 18, "ProofText", "ExpressionUUID" -> \
"800e3c39-e81b-4a6b-bc41-bc80128f851d",
 CellID->1966565412],
Cell[14307, 438, 415, 11, 20, "ProofText", "ExpressionUUID" -> \
"216a7b18-9346-43e8-99c1-00598d61c432",
 CellID->1501970052],
Cell[14725, 451, 460, 11, 19, "ProofText", "ExpressionUUID" -> \
"3aa85f8b-ceaa-47b3-ad10-a30b15ee567c",
 CellID->1789318105]
}
]
*)

