(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     24926,        700]
NotebookOptionsPosition[     21954,        623]
NotebookOutlinePosition[     22553,        643]
CellTagsIndexPosition[     22510,        640]
WindowTitle->Proof of (\:2203\:2228)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651071225646*^9, 3.7196510789603243`*^9}},
 CellID->1895663448,ExpressionUUID->"96dd88d8-b41d-409e-84df-4ff9825c12bc"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651081327495*^9, 3.719651083141161*^9}},
 CellID->242150577,ExpressionUUID->"2263f48a-9ebb-45c1-939f-17866316c845"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}], 
        TagBox["\[Or]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
         SyntaxForm->"x\[Or]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196510866015472`*^9, 3.719651103572834*^9}},
 CellID->504450860,ExpressionUUID->"c2b7f373-e3f2-4579-b6a5-5b99020de01e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}], "\[Or]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651106310009*^9, 3.719651143625587*^9}},
 CellID->1802912091,ExpressionUUID->"fb70af2e-6ed7-4039-88f8-f1fd73ee5d14"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
    " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651151536847*^9, 3.719651167501876*^9}},
 CellID->236034022,ExpressionUUID->"c7e8e122-17ad-483d-a529-443e1ff535d0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651176979011*^9, 3.719651192296411*^9}},
 CellID->833876386,ExpressionUUID->"9f4f633a-eaf4-4bda-81bf-a64b097a5489"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ",", " ", "rule", ",", " ", 
     "fact", ",", " ", "fact"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651199540555*^9, 3.7196512285588284`*^9}},
 CellID->1541671372,ExpressionUUID->"640bfa2d-63ad-471e-873d-a13b6105fee4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196512333519163`*^9, 3.719651236638893*^9}},
 CellID->1309709161,ExpressionUUID->"21c8a2ba-2484-4b8b-9c4a-09eca90a9816"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196512383498363`*^9, 3.7196512485766172`*^9}},
 CellID->1071276430,ExpressionUUID->"c28409a0-4ff4-4c93-9b81-4c4204c374bb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ",", " ", "rule", ",", " ", 
     "fact", ",", " ", "fact"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651199540555*^9, 3.719651254639885*^9}},
 CellID->1131621130,ExpressionUUID->"c9cba258-764e-493c-ad07-59ed2b68dd39"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196512576813183`*^9, 3.719651263654992*^9}},
 CellID->1608488758,ExpressionUUID->"24a7ff10-cf8c-43fe-8d3f-4d6d60951b6e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651269908486*^9, 3.719651280727501*^9}},
 CellID->622350331,ExpressionUUID->"3f950f8d-1acc-43f8-a809-267f99eb621c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}], 
        TagBox["\[Or]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
         SyntaxForm->"x\[Or]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71965128398232*^9, 3.719651301734858*^9}},
 CellID->1536600223,ExpressionUUID->"edb61037-3722-42d4-9f43-2b9279798a0d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651305486298*^9, 3.719651315221753*^9}},
 CellID->453278478,ExpressionUUID->"0a17bdc0-1ca3-43e1-981c-2e60ebcb032f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196513176822853`*^9, 3.719651342912962*^9}},
 CellID->239080977,ExpressionUUID->"7df2baab-bbcf-414f-9b40-e4a119b65bff"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", ",", " ", 
     RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ",", " ", "fact", ",", " ", 
     "fact"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651348711524*^9, 3.719651374032476*^9}},
 CellID->694041208,ExpressionUUID->"574344a7-52e8-4194-bfed-37a3e408f497"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651381332818*^9, 3.7196513852488194`*^9}},
 CellID->1592200625,ExpressionUUID->"5e86e518-972b-4b7e-8350-80d1c81060c9"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651305486298*^9, 3.719651315221753*^9}, 
   3.7196513889690437`*^9},
 CellID->398151403,ExpressionUUID->"d65881bb-efa3-4d9f-94ff-e3dae7c9860c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196513176822853`*^9, 3.719651342912962*^9}, 
   3.719651391754105*^9},
 CellID->310667935,ExpressionUUID->"714dc38c-f1b8-45de-bdd8-38a425273f9b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", ",", " ", 
     RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ",", " ", "fact", ",", " ", 
     "fact"}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719651348711524*^9, 3.719651393672021*^9}},
 CellID->311497155,ExpressionUUID->"41c82f59-16f8-4338-9def-8986a9c233c9"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]\[Or])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 446, 14, 20, "ProofText", "ExpressionUUID" -> \
"96dd88d8-b41d-409e-84df-4ff9825c12bc",
 CellID->1895663448],
Cell[1044, 37, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"2263f48a-9ebb-45c1-939f-17866316c845",
 CellID->242150577],
Cell[1281, 43, 2031, 52, 30, "ProofText", "ExpressionUUID" -> \
"c2b7f373-e3f2-4579-b6a5-5b99020de01e",
 CellID->504450860],
Cell[3315, 97, 1078, 34, 18, "ProofText", "ExpressionUUID" -> \
"fb70af2e-6ed7-4039-88f8-f1fd73ee5d14",
 CellID->1802912091],
Cell[4396, 133, 3575, 95, 57, "ProofText", "ExpressionUUID" -> \
"c7e8e122-17ad-483d-a529-443e1ff535d0",
 CellID->236034022],
Cell[7974, 230, 490, 14, 20, "ProofText", "ExpressionUUID" -> \
"9f4f633a-eaf4-4bda-81bf-a64b097a5489",
 CellID->833876386],
Cell[8467, 246, 404, 9, 20, "ProofText", "ExpressionUUID" -> \
"640bfa2d-63ad-471e-873d-a13b6105fee4",
 CellID->1541671372],
Cell[8874, 257, 241, 5, 18, "ProofText", "ExpressionUUID" -> \
"21c8a2ba-2484-4b8b-9c4a-09eca90a9816",
 CellID->1309709161],
Cell[9118, 264, 495, 14, 20, "ProofText", "ExpressionUUID" -> \
"c28409a0-4ff4-4c93-9b81-4c4204c374bb",
 CellID->1071276430],
Cell[9616, 280, 402, 9, 20, "ProofText", "ExpressionUUID" -> \
"c9cba258-764e-493c-ad07-59ed2b68dd39",
 CellID->1131621130],
Cell[10021, 291, 279, 6, 39, "ProofText", "ExpressionUUID" -> \
"24a7ff10-cf8c-43fe-8d3f-4d6d60951b6e",
 CellID->1608488758],
Cell[10303, 299, 3461, 93, 35, "ProofText", "ExpressionUUID" -> \
"3f950f8d-1acc-43f8-a809-267f99eb621c",
 CellID->622350331],
Cell[13767, 394, 2043, 52, 52, "ProofText", "ExpressionUUID" -> \
"edb61037-3722-42d4-9f43-2b9279798a0d",
 CellID->1536600223],
Cell[15813, 448, 1603, 41, 30, "ProofText", "ExpressionUUID" -> \
"0a17bdc0-1ca3-43e1-981c-2e60ebcb032f",
 CellID->453278478],
Cell[17419, 491, 862, 26, 18, "ProofText", "ExpressionUUID" -> \
"7df2baab-bbcf-414f-9b40-e4a119b65bff",
 CellID->239080977],
Cell[18284, 519, 401, 9, 20, "ProofText", "ExpressionUUID" -> \
"574344a7-52e8-4194-bfed-37a3e408f497",
 CellID->694041208],
Cell[18688, 530, 241, 5, 18, "ProofText", "ExpressionUUID" -> \
"5e86e518-972b-4b7e-8350-80d1c81060c9",
 CellID->1592200625],
Cell[18932, 537, 1631, 42, 30, "ProofText", "ExpressionUUID" -> \
"d65881bb-efa3-4d9f-94ff-e3dae7c9860c",
 CellID->398151403],
Cell[20566, 581, 888, 27, 18, "ProofText", "ExpressionUUID" -> \
"714dc38c-f1b8-45de-bdd8-38a425273f9b",
 CellID->310667935],
Cell[21457, 610, 493, 11, 20, "ProofText", "ExpressionUUID" -> \
"41c82f59-16f8-4338-9def-8986a9c233c9",
 CellID->311497155]
}
]
*)

