(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6628,        200]
NotebookOptionsPosition[      5049,        156]
NotebookOutlinePosition[      5646,        176]
CellTagsIndexPosition[      5603,        173]
WindowTitle->Proof of (Peirce's Law)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452134618229*^9, 3.7184521397518253`*^9}},
 CellID->1583887241,ExpressionUUID->"bac8f9b2-d627-47c8-b47b-cd331977ae01"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184521452519484`*^9, 3.718452154540897*^9}},
 CellID->1640748656,ExpressionUUID->"89bafd33-6df3-40a2-ada2-dfe190be2cfa"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  FormBox[
   StyleBox["P", "ExpressionABF"],
   TheoremaForm]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<classical\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184521610352173`*^9, 3.718452173334931*^9}},
 CellID->1129834116,ExpressionUUID->"48e3fff6-590a-42a1-9c2b-314443ce409a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452185502487*^9, 3.718452196048985*^9}},
 CellID->1326899754,ExpressionUUID->"83f9fe45-111b-49ef-bf81-aa5804dd32ce"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[LongRightArrow]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", "-"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452200280553*^9, 3.718452242551991*^9}},
 CellID->1377958152,ExpressionUUID->"87524fa2-0495-4cf5-88fa-7f1b9819b517"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845224481207*^9, 3.71845225605886*^9}},
 CellID->472914584,ExpressionUUID->"56011f00-d34e-46f0-bd03-2f92f0f14c70"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452265524782*^9, 3.718452277341743*^9}},
 CellID->1559413825,ExpressionUUID->"eab6edda-7d02-49a6-947c-13a43ea02870"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452280621255*^9, 3.718452283591854*^9}},
 CellID->191154854,ExpressionUUID->"08792c93-b9dc-4068-b3f9-95499bb2fc5f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7184523374264107`*^9, 3.718452346281571*^9}},
 CellID->1566590020,ExpressionUUID->"9e6fb39a-4e1d-4719-8bc7-770e84566069"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (Peirce's Law)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 373, 11, 20, "ProofText", "ExpressionUUID" -> \
"bac8f9b2-d627-47c8-b47b-cd331977ae01",
 CellID->1583887241],
Cell[971, 34, 1295, 35, 20, "ProofText", "ExpressionUUID" -> \
"89bafd33-6df3-40a2-ada2-dfe190be2cfa",
 CellID->1640748656],
Cell[2269, 71, 385, 10, 39, "ProofText", "ExpressionUUID" -> \
"48e3fff6-590a-42a1-9c2b-314443ce409a",
 CellID->1129834116],
Cell[2657, 83, 414, 11, 20, "ProofText", "ExpressionUUID" -> \
"83f9fe45-111b-49ef-bf81-aa5804dd32ce",
 CellID->1326899754],
Cell[3074, 96, 540, 15, 39, "ProofText", "ExpressionUUID" -> \
"87524fa2-0495-4cf5-88fa-7f1b9819b517",
 CellID->1377958152],
Cell[3617, 113, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"56011f00-d34e-46f0-bd03-2f92f0f14c70",
 CellID->472914584],
Cell[3943, 124, 447, 12, 18, "ProofText", "ExpressionUUID" -> \
"eab6edda-7d02-49a6-947c-13a43ea02870",
 CellID->1559413825],
Cell[4393, 138, 237, 5, 18, "ProofText", "ExpressionUUID" -> \
"08792c93-b9dc-4068-b3f9-95499bb2fc5f",
 CellID->191154854],
Cell[4633, 145, 412, 9, 19, "ProofText", "ExpressionUUID" -> \
"9e6fb39a-4e1d-4719-8bc7-770e84566069",
 CellID->1566590020]
}
]
*)

