(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7061,        205]
NotebookOptionsPosition[      5967,        173]
NotebookOutlinePosition[      6575,        193]
CellTagsIndexPosition[      6532,        190]
WindowTitle->Proof of (\:21D4E)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.714991491803846*^9, 3.7149915010467777`*^9}},
 CellID->1367849273,ExpressionUUID->"7e91c508-8a8d-4aa5-ac0a-dedbf976b296"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[DoubleLeftRightArrow]", " ", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<**\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[LongRightArrow]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
          
          SyntaxForm->"x\[LongRightArrow]y"], 
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.7149915129484873`*^9, 3.71499155616936*^9}},
 CellID->1611375103,ExpressionUUID->"c4506474-0143-4493-87b0-4c7f65024973"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<**\>\""}], ")"}]}]}], "ProofText",
 CellChangeTimes->{{3.714991565167486*^9, 3.714991572473692*^9}},
 CellID->1824393359,ExpressionUUID->"ace82fe3-5c3c-4bdb-bbae-dfd54521b8b2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    StyleBox[
     FormBox[
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}],
      TheoremaForm],
     Selectable->True], "\[CloseCurlyQuote]"}], " ", "using", " ", 
   "\"\<*\>\"", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]D1\>\""}], 
    ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.714991612001472*^9, 3.714991636178382*^9}, {
  3.7149922962490177`*^9, 3.714992325011121*^9}, {3.7149923581155777`*^9, 
  3.714992367766667*^9}},
 CellID->320178186,ExpressionUUID->"dd6f6d6a-4cbf-482a-8698-ce81d9729cb6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "using", " ", "\"\<*\>\"", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]D2\>\""}], 
    ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.7149923763244457`*^9, 3.7149923904526052`*^9}, {
  3.714992438908525*^9, 3.714992445829423*^9}},
 CellID->1807868822,ExpressionUUID->"318a079a-73be-4e67-9fc0-f9070282a8e4"]
},
WindowSize->{808, 869},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Proof of (\[DoubleLeftRightArrow]E)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 426, 13, 20, "ProofText", "ExpressionUUID" -> \
"7e91c508-8a8d-4aa5-ac0a-dedbf976b296",
 CellID->1367849273],
Cell[1019, 36, 2583, 72, 20, "ProofText", "ExpressionUUID" -> \
"c4506474-0143-4493-87b0-4c7f65024973",
 CellID->1611375103],
Cell[3605, 110, 296, 6, 39, "ProofText", "ExpressionUUID" -> \
"ace82fe3-5c3c-4bdb-bbae-dfd54521b8b2",
 CellID->1824393359],
Cell[3904, 118, 1101, 28, 18, "ProofText", "ExpressionUUID" -> \
"dd6f6d6a-4cbf-482a-8698-ce81d9729cb6",
 CellID->320178186],
Cell[5008, 148, 955, 23, 18, "ProofText", "ExpressionUUID" -> \
"318a079a-73be-4e67-9fc0-f9070282a8e4",
 CellID->1807868822]
}
]
*)

(* End of internal cache information *)

