(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9396,        283]
NotebookOptionsPosition[      7823,        239]
NotebookOutlinePosition[      8414,        259]
CellTagsIndexPosition[      8371,        256]
WindowTitle->Proof of (\:2228E)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.714994632580976*^9, 3.714994642320842*^9}},
 CellID->242858091,ExpressionUUID->"02f245ee-606b-42a7-ad7a-05fc818ce89e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[Or]", " ", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[LongRightArrow]", " ", 
      FormBox[
       StyleBox["R", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], " ", "\[LongRightArrow]", " ", 
     FormBox[
      StyleBox["R", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.714994650917643*^9, 3.714994696205172*^9}, {
  3.715052562308419*^9, 3.7150525806526546`*^9}},
 CellID->577858107,ExpressionUUID->"7b5a03c2-cfd7-45af-bebd-4a4cd59f2ce8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "\"\<1\>\"", " ", "have", " ", "\"\<3\>\""}], ":", " ", 
  RowBox[{
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], " ", "\[Implies]", " ", 
     FormBox[
      StyleBox["R", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Implies]I\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715053074223255*^9, 3.71505312200211*^9}},
 CellID->56291845,ExpressionUUID->"cc8bf67c-8b46-4de6-8c8a-2b00e8962c2c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "\"\<2\>\"", " ", "have", " ", "\"\<4\>\""}], ":", " ", 
  RowBox[{
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], " ", "\[Implies]", " ", 
     FormBox[
      StyleBox["R", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Implies]I\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150531257296047`*^9, 3.715053149546686*^9}},
 CellID->1865426948,ExpressionUUID->"8325607a-50aa-42c7-9acb-8279a3ffe755"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox["\[ForAll]", "R"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm], "\[Implies]", "R"}], ")"}], "\[Implies]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FormBox[
          StyleBox["Q", "ExpressionABF"],
          TheoremaForm], "\[Implies]", "R"}], ")"}], "\[Implies]", "R"}]}], 
     ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"simp", ":", " ", "\"\<\[Or] def\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715052624426812*^9, 3.715052629571588*^9}, {
  3.715052664236453*^9, 3.715052711220899*^9}},
 CellID->389782733,ExpressionUUID->"71d02699-0913-4176-bd47-cb063a3a479d"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[Implies]", 
      FormBox[
       StyleBox["R", "ExpressionABF"],
       TheoremaForm]}], ")"}], "\[Implies]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "\[Implies]", 
       FormBox[
        StyleBox["R", "ExpressionABF"],
        TheoremaForm]}], ")"}], "\[Implies]", 
     FormBox[
      StyleBox["R", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[ForAll]D\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715052723439321*^9, 3.715052753109247*^9}},
 CellID->594684477,ExpressionUUID->"0aaa67c7-b6e8-44ed-8210-3736147997df"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[Implies]", 
      FormBox[
       StyleBox["R", "ExpressionABF"],
       TheoremaForm]}], ")"}], "\[LongRightArrow]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["Q", "ExpressionABF"],
         TheoremaForm], "\[Implies]", 
        FormBox[
         StyleBox["R", "ExpressionABF"],
         TheoremaForm]}], ")"}], "\[Implies]", 
      FormBox[
       StyleBox["R", "ExpressionABF"],
       TheoremaForm]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715052982058346*^9, 3.715053012992916*^9}, {
  3.715060891414206*^9, 3.7150608927800827`*^9}},
 CellID->1378941403,ExpressionUUID->"2c9a186b-f855-44aa-a95d-46f9e2dde5d5"],

Cell[BoxData[
 RowBox[{"from", " ", 
  RowBox[{"this", "[", 
   RowBox[{"OF", " ", "\"\<3\>\""}], "]"}], " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "\[Implies]", 
      FormBox[
       StyleBox["R", "ExpressionABF"],
       TheoremaForm]}], ")"}], "\[LongRightArrow]", 
    FormBox[
     StyleBox["R", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715053023324717*^9, 3.715053046017199*^9}, {
  3.715053173380211*^9, 3.715053191091308*^9}, {3.715053263955916*^9, 
  3.7150533083244457`*^9}, {3.715060894301408*^9, 3.715060896126664*^9}},
 CellID->55424492,ExpressionUUID->"ee6804de-5de7-408a-ad13-60ff9dd48c35"],

Cell[BoxData[
 RowBox[{"from", " ", 
  RowBox[{"this", "[", 
   RowBox[{"OF", " ", "\"\<4\>\""}], "]"}], " ", "show", " ", 
  RowBox[{
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["R", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715052919264927*^9, 3.715052967472056*^9}, {
  3.715053325556669*^9, 3.715053347089861*^9}},
 CellID->1034581215,ExpressionUUID->"008424d5-9ec4-49a4-b878-add23986c6b6"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or]E)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"02f245ee-606b-42a7-ad7a-05fc818ce89e",
 CellID->242858091],
Cell[1036, 37, 1195, 35, 20, "ProofText", "ExpressionUUID" -> \
"7b5a03c2-cfd7-45af-bebd-4a4cd59f2ce8",
 CellID->577858107],
Cell[2234, 74, 625, 16, 18, "ProofText", "ExpressionUUID" -> \
"cc8bf67c-8b46-4de6-8c8a-2b00e8962c2c",
 CellID->56291845],
Cell[2862, 92, 630, 16, 18, "ProofText", "ExpressionUUID" -> \
"8325607a-50aa-42c7-9acb-8279a3ffe755",
 CellID->1865426948],
Cell[3495, 110, 889, 24, 28, "ProofText", "ExpressionUUID" -> \
"71d02699-0913-4176-bd47-cb063a3a479d",
 CellID->389782733],
Cell[4387, 136, 914, 28, 18, "ProofText", "ExpressionUUID" -> \
"0aaa67c7-b6e8-44ed-8210-3736147997df",
 CellID->594684477],
Cell[5304, 166, 1012, 30, 18, "ProofText", "ExpressionUUID" -> \
"2c9a186b-f855-44aa-a95d-46f9e2dde5d5",
 CellID->1378941403],
Cell[6319, 198, 905, 23, 21, "ProofText", "ExpressionUUID" -> \
"ee6804de-5de7-408a-ad13-60ff9dd48c35",
 CellID->55424492],
Cell[7227, 223, 592, 14, 21, "ProofText", "ExpressionUUID" -> \
"008424d5-9ec4-49a4-b878-add23986c6b6",
 CellID->1034581215]
}
]
*)

