(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4829,        146]
NotebookOptionsPosition[      3619,        111]
NotebookOutlinePosition[      4227,        131]
CellTagsIndexPosition[      4184,        128]
WindowTitle->Proof of (classical contradiction)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451468761611*^9, 3.718451474742323*^9}, {
  3.7184515306229143`*^9, 3.718451562488625*^9}},
 CellID->139276541,ExpressionUUID->"78945d29-87ac-41bf-b6b9-4628403c97b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox["False",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[False, {}]]]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451567082869*^9, 3.718451577311161*^9}},
 CellID->211283587,ExpressionUUID->"9972edae-a262-46c0-abab-b98dc51b8aa7"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<classical\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451583522727*^9, 3.718451618279914*^9}},
 CellID->1908590827,ExpressionUUID->"e04a99ee-f09c-41e3-83cd-c6a23c854cee"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451621682797*^9, 3.718451632343637*^9}},
 CellID->1133384463,ExpressionUUID->"b63fee31-1451-4251-92f0-70a80d753b55"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845164591873*^9, 3.71845165804876*^9}},
 CellID->258975045,ExpressionUUID->"9599d685-1371-4813-b9e3-4bb1a1162839"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", "_"}], " ", ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718451661460965*^9, 3.718451671272558*^9}},
 CellID->763360360,ExpressionUUID->"77f190bd-ed05-4aad-9be4-00c22d77cced"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (classical contradiction)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 348, 9, 20, "ProofText", "ExpressionUUID" -> \
"78945d29-87ac-41bf-b6b9-4628403c97b1",
 CellID->139276541],
Cell[957, 32, 1056, 30, 20, "ProofText", "ExpressionUUID" -> \
"9972edae-a262-46c0-abab-b98dc51b8aa7",
 CellID->211283587],
Cell[2016, 64, 442, 11, 39, "ProofText", "ExpressionUUID" -> \
"e04a99ee-f09c-41e3-83cd-c6a23c854cee",
 CellID->1908590827],
Cell[2461, 77, 414, 11, 20, "ProofText", "ExpressionUUID" -> \
"b63fee31-1451-4251-92f0-70a80d753b55",
 CellID->1133384463],
Cell[2878, 90, 381, 9, 18, "ProofText", "ExpressionUUID" -> \
"9599d685-1371-4813-b9e3-4bb1a1162839",
 CellID->258975045],
Cell[3262, 101, 353, 8, 19, "ProofText", "ExpressionUUID" -> \
"77f190bd-ed05-4aad-9be4-00c22d77cced",
 CellID->763360360]
}
]
*)

