(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10843,        319]
NotebookOptionsPosition[      9242,        275]
NotebookOutlinePosition[      9862,        295]
CellTagsIndexPosition[      9819,        292]
WindowTitle->Proof of (\:03B5 \:F431 \:2203!)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"elim", " ", "\"\<\[Exists]!E\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364964388689*^9, 3.718364974594426*^9}, {
  3.7183650217629337`*^9, 3.718365036140945*^9}, {3.718365068979512*^9, 
  3.7183651207720737`*^9}},
 CellID->71490363,ExpressionUUID->"5f315eba-2cb1-4c23-8386-fabca8ada267"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365135977149*^9, 3.718365151263036*^9}},
 CellID->180181516,ExpressionUUID->"9a269d97-63d7-4c63-9b3f-2a4dc3c574e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<rl\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["y", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183651640827417`*^9, 3.7183651923347*^9}, {
  3.718365363814909*^9, 3.7183653650953417`*^9}},
 CellID->909900074,ExpressionUUID->"ade63b2f-e615-456b-8e39-2c1224ffbc2b"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox[
       TagBox["\[CurlyEpsilon]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Such$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[Equal]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[Equal]y"], 
    TagBox[
     StyleBox["a", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<\[CurlyEpsilon]I weaker\>\""}], ",", " ", 
    "fact"}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365224909864*^9, 3.718365294350103*^9}},
 CellID->650349429,ExpressionUUID->"9fb014fd-a9f1-4047-9d22-ed23a892ff8b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183652976247883`*^9, 3.718365317005211*^9}},
 CellID->472071657,ExpressionUUID->"966f4723-915f-4038-a65f-48bc3f559598"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183653448832493`*^9, 3.71836535577969*^9}},
 CellID->338109278,ExpressionUUID->"9eaa6aa7-1441-4f17-915e-5d061996aa0e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rl\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365383512864*^9, 3.718365401247723*^9}},
 CellID->1593868203,ExpressionUUID->"b4733872-c5ab-466a-98b4-30f13383a688"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rl\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718365405627522*^9, 3.718365437336791*^9}},
 CellID->1395642180,ExpressionUUID->"875e0319-f5bf-40d4-954b-3af8aa2ea391"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365441465547*^9, 3.718365464504283*^9}, {
   3.71836550040917*^9, 3.718365521041027*^9}, {3.7183655689449873`*^9, 
   3.718365573625759*^9}, 3.718365709947022*^9, {3.718425176126436*^9, 
   3.71842517712827*^9}},
 CellID->1979166561,ExpressionUUID->"d1c1dda2-1dc7-4853-aaf8-e6f12982fb12"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[CurlyEpsilon] \[Equal] \[Exists]!)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 387, 8, 18, "ProofText", "ExpressionUUID" -> \
"5f315eba-2cb1-4c23-8386-fabca8ada267",
 CellID->71490363],
Cell[994, 31, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"9a269d97-63d7-4c63-9b3f-2a4dc3c574e3",
 CellID->180181516],
Cell[1440, 47, 2875, 81, 30, "ProofText", "ExpressionUUID" -> \
"ade63b2f-e615-456b-8e39-2c1224ffbc2b",
 CellID->909900074],
Cell[4318, 130, 1929, 53, 53, "ProofText", "ExpressionUUID" -> \
"9fb014fd-a9f1-4047-9d22-ed23a892ff8b",
 CellID->650349429],
Cell[6250, 185, 322, 9, 20, "ProofText", "ExpressionUUID" -> \
"966f4723-915f-4038-a65f-48bc3f559598",
 CellID->472071657],
Cell[6575, 196, 491, 14, 20, "ProofText", "ExpressionUUID" -> \
"9eaa6aa7-1441-4f17-915e-5d061996aa0e",
 CellID->338109278],
Cell[7069, 212, 557, 15, 18, "ProofText", "ExpressionUUID" -> \
"b4733872-c5ab-466a-98b4-30f13383a688",
 CellID->1593868203],
Cell[7629, 229, 913, 25, 19, "ProofText", "ExpressionUUID" -> \
"875e0319-f5bf-40d4-954b-3af8aa2ea391",
 CellID->1395642180],
Cell[8545, 256, 693, 17, 18, "ProofText", "ExpressionUUID" -> \
"d1c1dda2-1dc7-4853-aaf8-e6f12982fb12",
 CellID->1979166561]
}
]
*)

