(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16817,        477]
NotebookOptionsPosition[     14721,        421]
NotebookOutlinePosition[     15323,        441]
CellTagsIndexPosition[     15280,        438]
WindowTitle->Proof of (\:2200C\:F431)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.719217992581744*^9, 3.7192180157322283`*^9}},
 CellID->1140812586,ExpressionUUID->"de141577-4ae2-431c-ba3a-665afd06ff2b"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellChangeTimes->{{3.719218020143626*^9, 3.719218023122508*^9}},
 CellID->873408468,ExpressionUUID->"7ce48e29-8c6b-43fe-a2d2-88b2316c0c7e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          StyleBox["x", "ExpressionVariable"], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["t", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.719218025255869*^9, 3.71921804812307*^9}, {
  3.719648238233879*^9, 3.719648238928919*^9}},
 CellID->1133448115,ExpressionUUID->"5a0bc3e2-33df-4091-846c-d646467f0a12"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.719218052042149*^9, 3.71921806438694*^9}},
 CellID->1508967815,ExpressionUUID->"a6917554-ef52-44fe-89d1-9665a8c611f6"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7192180667744417`*^9, 3.719218076750032*^9}},
 CellID->1463290120,ExpressionUUID->"2bbe20c2-1f5f-4268-9e19-429ab8895b51"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", "\"\<*\>\""}], ":", 
   " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        FormBox[
         StyleBox["t", "ExpressionABF"],
         TheoremaForm], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellChangeTimes->{{3.7192180850424747`*^9, 3.719218113899149*^9}, {
  3.7192181636833897`*^9, 3.719218164996581*^9}},
 CellID->446048847,ExpressionUUID->"60b8dc7b-b419-4cfe-a231-77fcef13fa22"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["t", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ",", " ", 
     RowBox[{"fact", " ", "\"\<*\>\""}], ",", " ", "rule"}], 
    ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.719218126858947*^9, 3.719218202748994*^9}},
 CellID->2027102322,ExpressionUUID->"1e0b5409-a12e-4fb1-8a7c-b649e9136cca"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.719218205741378*^9, 3.719218211781164*^9}},
 CellID->683998968,ExpressionUUID->"ac8791ee-9544-41e2-bb47-32396ff38871"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<2\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.719218215896584*^9, 3.7192182264486732`*^9}, {
  3.71964824628963*^9, 3.719648246953409*^9}},
 CellID->2139490176,ExpressionUUID->"724f143b-6462-4e0b-9ee5-0a48e0a2656b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          StyleBox["x", "ExpressionVariable"], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["t", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
     "intro", " ", "\"\<\[ForAll]CI\>\"", " ", "\"\<\[Implies]I\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellChangeTimes->{{3.719218228920768*^9, 3.719218267829843*^9}},
 CellID->87837083,ExpressionUUID->"936ce4fb-f22b-44c2-82f0-df104fc9e611"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7192182430959806`*^9, 3.719218247623189*^9}},
 CellID->2100780849,ExpressionUUID->"b422d4f2-9286-4b91-baa3-434db9616d57"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.719218249072136*^9, 3.71921829209656*^9}},
 CellID->1671901356,ExpressionUUID->"09f7bca2-8482-40d1-860b-39a0d0c64c79"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", "\"\<2\>\"", " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "\[Equal]", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.719218298334197*^9, 3.71921837194004*^9}},
 CellID->815470742,ExpressionUUID->"19f62930-294a-4392-85fa-904398d1afdd"]
},
WindowSize->{808, 869},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Proof of (\[ForAll]C\[Equal])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 426, 13, 20, "ProofText", "ExpressionUUID" -> \
"de141577-4ae2-431c-ba3a-665afd06ff2b",
 CellID->1140812586],
Cell[1025, 36, 214, 3, 39, "ProofText", "ExpressionUUID" -> \
"7ce48e29-8c6b-43fe-a2d2-88b2316c0c7e",
 CellID->873408468],
Cell[1242, 41, 2429, 63, 30, "ProofText", "ExpressionUUID" -> \
"5a0bc3e2-33df-4091-846c-d646467f0a12",
 CellID->1133448115],
Cell[3674, 106, 1514, 40, 42, "ProofText", "ExpressionUUID" -> \
"a6917554-ef52-44fe-89d1-9665a8c611f6",
 CellID->1508967815],
Cell[5191, 148, 794, 20, 21, "ProofText", "ExpressionUUID" -> \
"2bbe20c2-1f5f-4268-9e19-429ab8895b51",
 CellID->1463290120],
Cell[5988, 170, 1673, 47, 21, "ProofText", "ExpressionUUID" -> \
"60b8dc7b-b419-4cfe-a231-77fcef13fa22",
 CellID->446048847],
Cell[7664, 219, 627, 17, 21, "ProofText", "ExpressionUUID" -> \
"1e0b5409-a12e-4fb1-8a7c-b649e9136cca",
 CellID->2027102322],
Cell[8294, 238, 256, 5, 39, "ProofText", "ExpressionUUID" -> \
"ac8791ee-9544-41e2-bb47-32396ff38871",
 CellID->683998968],
Cell[8553, 245, 1585, 41, 21, "ProofText", "ExpressionUUID" -> \
"724f143b-6462-4e0b-9ee5-0a48e0a2656b",
 CellID->2139490176],
Cell[10141, 288, 2492, 66, 52, "ProofText", "ExpressionUUID" -> \
"936ce4fb-f22b-44c2-82f0-df104fc9e611",
 CellID->87837083],
Cell[12636, 356, 305, 8, 20, "ProofText", "ExpressionUUID" -> \
"b422d4f2-9286-4b91-baa3-434db9616d57",
 CellID->2100780849],
Cell[12944, 366, 729, 21, 20, "ProofText", "ExpressionUUID" -> \
"09f7bca2-8482-40d1-860b-39a0d0c64c79",
 CellID->1671901356],
Cell[13676, 389, 1041, 30, 18, "ProofText", "ExpressionUUID" -> \
"19f62930-294a-4392-85fa-904398d1afdd",
 CellID->815470742]
}
]
*)

(* End of internal cache information *)

