(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15377,        440]
NotebookOptionsPosition[     13660,        393]
NotebookOutlinePosition[     14263,        413]
CellTagsIndexPosition[     14220,        410]
WindowTitle->Proof of (\:2203C\:F431)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719217992581744*^9, 3.7192180157322283`*^9}},
 CellID->1140812586,ExpressionUUID->"67c2c49b-767c-42bb-9c8b-6ef96e1f3385"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218020143626*^9, 3.719218023122508*^9}},
 CellID->873408468,ExpressionUUID->"2d552060-5cf0-4007-9ad0-3d7088b65f59"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          StyleBox["x", "ExpressionVariable"], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["t", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218025255869*^9, 3.71921804812307*^9}, {
  3.719648238233879*^9, 3.719648238928919*^9}, {3.719648288826035*^9, 
  3.719648291793332*^9}},
 CellID->1133448115,ExpressionUUID->"0f0ef811-344d-4b3e-a975-748b480c870b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "\[Equal]", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm]}], " ", "\[And]", " ", 
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719648365403067*^9, 3.719648415506542*^9}},
 CellID->1875341679,ExpressionUUID->"de210a73-0d8a-4d66-9441-fc1c286feaa5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["t", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all", " ", "lazy"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719648426015576*^9, 3.719648469444594*^9}, {
  3.719648550637047*^9, 3.719648609125925*^9}, {3.7196486535042562`*^9, 
  3.7196486597906923`*^9}},
 CellID->768724367,ExpressionUUID->"2129c845-674a-47b8-9f75-7d0182a7d99c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719218052042149*^9, 3.71921806438694*^9}, {
   3.719648296226829*^9, 3.7196482968255796`*^9}, {3.7196487173594713`*^9, 
   3.719648775024322*^9}, 3.719648973194459*^9, {3.7196496068840513`*^9, 
   3.719649607268939*^9}},
 CellID->1508967815,ExpressionUUID->"762ca60f-17b1-4ec6-9ac0-20eb20a2284e"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218205741378*^9, 3.719218211781164*^9}, {
  3.719649623178658*^9, 3.719649624938047*^9}},
 CellID->683998968,ExpressionUUID->"4e39bea7-ae0f-4963-add4-ef07fb5e8531"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218215896584*^9, 3.7192182264486732`*^9}, {
  3.71964824628963*^9, 3.719648246953409*^9}, {3.719649635347597*^9, 
  3.719649646707787*^9}},
 CellID->2139490176,ExpressionUUID->"3cf8342e-1b23-4fec-a153-865bdd12bea4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["t", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["t", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719649650788322*^9, 3.719649673754736*^9}},
 CellID->625298973,ExpressionUUID->"db00354e-5b32-4156-a810-374181a9162f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         StyleBox["x", "ExpressionVariable"], 
         TagBox["\[Equal]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[Equal]y"], 
         TagBox[
          StyleBox["t", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[And]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"intro", " ", "\"\<\[Exists]CI\>\"", " ", "\"\<\[And]I\>\""}], 
     ",", " ", 
     RowBox[{"rule", " ", "\"\<\[Equal] refl\>\""}], ",", " ", "fact", ",", 
     " ", "fact"}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719218228920768*^9, 3.719218267829843*^9}, {
  3.719649680964329*^9, 3.7196497277162457`*^9}},
 CellID->87837083,ExpressionUUID->"c7601b09-6779-4d79-9582-1cc37df48db4"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]C\[Equal])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 446, 14, 20, "ProofText", "ExpressionUUID" -> \
"67c2c49b-767c-42bb-9c8b-6ef96e1f3385",
 CellID->1140812586],
Cell[1045, 37, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"2d552060-5cf0-4007-9ad0-3d7088b65f59",
 CellID->873408468],
Cell[1282, 43, 2494, 65, 30, "ProofText", "ExpressionUUID" -> \
"0f0ef811-344d-4b3e-a975-748b480c870b",
 CellID->1133448115],
Cell[3779, 110, 1134, 36, 18, "ProofText", "ExpressionUUID" -> \
"de210a73-0d8a-4d66-9441-fc1c286feaa5",
 CellID->1875341679],
Cell[4916, 148, 931, 25, 18, "ProofText", "ExpressionUUID" -> \
"2129c845-674a-47b8-9f75-7d0182a7d99c",
 CellID->768724367],
Cell[5850, 175, 2470, 68, 21, "ProofText", "ExpressionUUID" -> \
"762ca60f-17b1-4ec6-9ac0-20eb20a2284e",
 CellID->1508967815],
Cell[8323, 245, 268, 5, 18, "ProofText", "ExpressionUUID" -> \
"4e39bea7-ae0f-4963-add4-ef07fb5e8531",
 CellID->683998968],
Cell[8594, 252, 1612, 42, 21, "ProofText", "ExpressionUUID" -> \
"3cf8342e-1b23-4fec-a153-865bdd12bea4",
 CellID->2139490176],
Cell[10209, 296, 784, 23, 21, "ProofText", "ExpressionUUID" -> \
"db00354e-5b32-4156-a810-374181a9162f",
 CellID->625298973],
Cell[10996, 321, 2660, 70, 30, "ProofText", "ExpressionUUID" -> \
"c7601b09-6779-4d79-9582-1cc37df48db4",
 CellID->87837083]
}
]
*)

