(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4851,        143]
NotebookOptionsPosition[      3781,        111]
NotebookOutlinePosition[      4372,        131]
CellTagsIndexPosition[      4329,        128]
WindowTitle->Proof of (\:2228I1)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[Or] def\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<\[ForAll]I\>\""}]}], ")"}]}]], "ProofText",
 CellChangeTimes->{{3.7150574310266447`*^9, 3.715057459929852*^9}},
 CellID->1825621804,ExpressionUUID->"90e64ef7-b539-4dff-a73b-aa97f24cacdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.715057492366205*^9, 3.715057501631278*^9}},
 CellID->653370766,ExpressionUUID->"578acccf-14a2-4903-b8cf-a3ab0e34ed55"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"intro", " ", "\"\<\[Implies]I\>\""}], ")"}]}]], "ProofText",
 CellChangeTimes->{{3.715057512977858*^9, 3.7150575187705393`*^9}},
 CellID->249141445,ExpressionUUID->"7a72724b-807a-4518-9dac-36b9e357cf25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<a\>\""}], 
   ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.715057540507461*^9, 3.7150576049879093`*^9}},
 CellID->1194426327,ExpressionUUID->"b88fe38a-308a-4afe-983b-2addc8b2f034"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<a\>\"", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}], " ", "show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]], "ProofText",
 CellChangeTimes->{{3.715057611684326*^9, 3.715057639364449*^9}, {
  3.715060963670185*^9, 3.71506096518589*^9}},
 CellID->1051673113,ExpressionUUID->"afafd6ce-2de6-4f3a-b324-44ab0636d0bd"]
},
WindowSize->{808, 869},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Proof of (\[Or]I1)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 347, 7, 20, "ProofText", "ExpressionUUID" -> \
"90e64ef7-b539-4dff-a73b-aa97f24cacdb",
 CellID->1825621804],
Cell[941, 30, 423, 13, 20, "ProofText", "ExpressionUUID" -> \
"578acccf-14a2-4903-b8cf-a3ab0e34ed55",
 CellID->653370766],
Cell[1367, 45, 269, 5, 18, "ProofText", "ExpressionUUID" -> \
"7a72724b-807a-4518-9dac-36b9e357cf25",
 CellID->249141445],
Cell[1639, 52, 1520, 41, 20, "ProofText", "ExpressionUUID" -> \
"b88fe38a-308a-4afe-983b-2addc8b2f034",
 CellID->1194426327],
Cell[3162, 95, 615, 14, 18, "ProofText", "ExpressionUUID" -> \
"afafd6ce-2de6-4f3a-b324-44ab0636d0bd",
 CellID->1051673113]
}
]
*)

(* End of internal cache information *)

