(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12072,        357]
NotebookOptionsPosition[     10241,        307]
NotebookOutlinePosition[     10837,        327]
CellTagsIndexPosition[     10794,        324]
WindowTitle->Proof of (\:2227 cong)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121201148778*^9, 3.71912121131124*^9}},
 CellID->765469584,ExpressionUUID->"5417aab0-1855-409e-8967-341746af0f93"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[DoubleLeftRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
        SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
       TagBox[
        StyleBox["Q1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191212135300817`*^9, 3.71912123816916*^9}},
 CellID->683052546,ExpressionUUID->"355e29b2-9a1e-4112-acd8-b21167f78ab1"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[DoubleLeftRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
     SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<1\>\""}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121243878694*^9, 3.719121257233068*^9}},
 CellID->220687556,ExpressionUUID->"c104ff0c-4bb4-4043-b4a4-d151f7eddcd9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121260930977*^9, 3.7191212791537457`*^9}, 
   3.7191215328384542`*^9},
 CellID->1360056999,ExpressionUUID->"1b5e6b8f-3439-40b4-9644-f063f624a155"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "and", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191212923966217`*^9, 3.719121306480235*^9}},
 CellID->449150412,ExpressionUUID->"242a0fac-e339-4355-9562-af4063fa15b8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", ",", " ", "fact"}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121354610817*^9, 3.719121474006591*^9}},
 CellID->1195279824,ExpressionUUID->"8572cbc8-0fc8-4b78-a300-754357b7a863"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "show", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\"\<2\>\"", " ", 
      FormBox[
       StyleBox["P1", "ExpressionABF"],
       TheoremaForm]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191214837675753`*^9, 3.719121500652739*^9}},
 CellID->188068431,ExpressionUUID->"030bbff9-867e-4817-94b6-d291f8a8f756"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121504394182*^9, 3.7191215123567533`*^9}},
 CellID->58463468,ExpressionUUID->"0d1a4e4b-72ad-4c65-814b-793876d71f22"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191215159600983`*^9, 3.7191215281860123`*^9}},
 CellID->1519183345,ExpressionUUID->"a7500e0c-c9bb-4c5a-8d77-845b20ed9806"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "and", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191212923966217`*^9, 3.719121306480235*^9}, {
  3.719121545175803*^9, 3.719121545479727*^9}},
 CellID->1985161290,ExpressionUUID->"217832ae-672f-45f4-9e5f-08a8fb06bebc"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
      SyntaxForm->"x\[And]y"], 
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", ",", " ", "fact", ",", " ", 
     RowBox[{"simp", ":", " ", 
      RowBox[{"\"\<2\>\"", " ", 
       FormBox[
        StyleBox["P1", "ExpressionABF"],
        TheoremaForm], " ", 
       FormBox[
        StyleBox["Q1", "ExpressionABF"],
        TheoremaForm]}]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719121354610817*^9, 3.719121474006591*^9}, {
  3.719121549425132*^9, 3.7191215739890614`*^9}},
 CellID->739325661,ExpressionUUID->"64dc7481-bb60-486e-a466-3300dd22c07e"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[And] cong)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 517, 17, 20, "ProofText", "ExpressionUUID" -> \
"5417aab0-1855-409e-8967-341746af0f93",
 CellID->765469584],
Cell[1114, 40, 1910, 50, 20, "ProofText", "ExpressionUUID" -> \
"355e29b2-9a1e-4112-acd8-b21167f78ab1",
 CellID->683052546],
Cell[3027, 92, 1656, 47, 39, "ProofText", "ExpressionUUID" -> \
"c104ff0c-4bb4-4043-b4a4-d151f7eddcd9",
 CellID->220687556],
Cell[4686, 141, 812, 22, 20, "ProofText", "ExpressionUUID" -> \
"1b5e6b8f-3439-40b4-9644-f063f624a155",
 CellID->1360056999],
Cell[5501, 165, 463, 13, 18, "ProofText", "ExpressionUUID" -> \
"242a0fac-e339-4355-9562-af4063fa15b8",
 CellID->449150412],
Cell[5967, 180, 885, 24, 41, "ProofText", "ExpressionUUID" -> \
"8572cbc8-0fc8-4b78-a300-754357b7a863",
 CellID->1195279824],
Cell[6855, 206, 575, 17, 18, "ProofText", "ExpressionUUID" -> \
"030bbff9-867e-4817-94b6-d291f8a8f756",
 CellID->188068431],
Cell[7433, 225, 277, 6, 39, "ProofText", "ExpressionUUID" -> \
"0d1a4e4b-72ad-4c65-814b-793876d71f22",
 CellID->58463468],
Cell[7713, 233, 787, 21, 20, "ProofText", "ExpressionUUID" -> \
"a7500e0c-c9bb-4c5a-8d77-845b20ed9806",
 CellID->1519183345],
Cell[8503, 256, 514, 14, 18, "ProofText", "ExpressionUUID" -> \
"217832ae-672f-45f4-9e5f-08a8fb06bebc",
 CellID->1985161290],
Cell[9020, 272, 1217, 33, 20, "ProofText", "ExpressionUUID" -> \
"64dc7481-bb60-486e-a466-3300dd22c07e",
 CellID->739325661]
}
]
*)

