(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16764,        477]
NotebookOptionsPosition[     14918,        427]
NotebookOutlinePosition[     15527,        447]
CellTagsIndexPosition[     15484,        444]
WindowTitle->Proof of (theC \:F431 \:2203!)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"elim", " ", "\"\<\[Exists]!CE\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364964388689*^9, 3.718364974594426*^9}, {
   3.7183650217629337`*^9, 3.718365036140945*^9}, {3.718365068979512*^9, 
   3.7183651207720737`*^9}, 3.71844203081923*^9},
 CellID->71490363,ExpressionUUID->"5f5b03e3-9e4b-43c6-a183-744cd60aa89f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365135977149*^9, 3.718365151263036*^9}, {
  3.718442035363014*^9, 3.718442037879534*^9}},
 CellID->180181516,ExpressionUUID->"bbbf6e37-60d3-4f05-9f06-8f34e828bc68"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<rl\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["y", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}], 
        TagBox["\[LongRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
         SyntaxForm->"x\[LongRightArrow]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["y", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183651640827417`*^9, 3.7183651923347*^9}, {
  3.718365363814909*^9, 3.7183653650953417`*^9}, {3.718442041539275*^9, 
  3.718442064637863*^9}, {3.718442141076878*^9, 3.718442151968718*^9}},
 CellID->909900074,ExpressionUUID->"f0bc3ec5-a06d-4ac9-9a71-d0ce0490cc9d"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox[
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     TagBox[
      StyleBox["x", "ExpressionVariable"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["a", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", "-"}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184418997743*^9, 3.7184419319060793`*^9}, {
  3.718442083122861*^9, 3.718442087713808*^9}},
 CellID->456712112,ExpressionUUID->"d47d600b-6109-4696-86f0-d33f7bd9aea0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718441937829064*^9, 3.718441943572422*^9}},
 CellID->1626657156,ExpressionUUID->"59dc8036-6ee5-4409-9652-a205d85ae0a0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718441946893044*^9, 3.718441960418105*^9}, {
  3.7184420946763144`*^9, 3.7184421035289383`*^9}},
 CellID->1133016938,ExpressionUUID->"061a31c7-a7e3-421c-9760-07aa544f3033"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rl\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365383512864*^9, 3.718365401247723*^9}},
 CellID->1981123989,ExpressionUUID->"80a84d6b-023a-4d6f-807f-6d38a1dd4e13"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rl\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365405627522*^9, 3.718365437336791*^9}, {
  3.7184421202632723`*^9, 3.718442120556265*^9}},
 CellID->1126202645,ExpressionUUID->"7fd156cd-79ff-41db-89c0-892047b08529"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365441465547*^9, 3.718365464504283*^9}, {
   3.71836550040917*^9, 3.718365521041027*^9}, {3.7183655689449873`*^9, 
   3.718365573625759*^9}, 3.718365709947022*^9, {3.718425176126436*^9, 
   3.71842517712827*^9}},
 CellID->807050453,ExpressionUUID->"6016d282-6a20-4cbf-a4d7-52b02458ad4e"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718441978528245*^9, 3.718441982466586*^9}},
 CellID->3922997,ExpressionUUID->"0cda7e5c-5f8e-4e13-94f6-924fc772a9cc"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox[
       TagBox["the",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SuchUnique$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[Equal]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[Equal]y"], 
    TagBox[
     StyleBox["a", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
   "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<theCI weaker\>\""}], ",", " ", 
    SuperscriptBox["fact", "+"]}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718365224909864*^9, 3.718365294350103*^9}, {
  3.718441830009973*^9, 3.718441864017935*^9}, {3.7184419891387577`*^9, 
  3.718441996356555*^9}, {3.718442159807824*^9, 3.718442164076796*^9}},
 CellID->650349429,ExpressionUUID->"f0bfadf1-d469-41c9-b2c8-61c771bd3cfa"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (theC \[Equal] \[Exists]!)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 411, 8, 18, "ProofText", "ExpressionUUID" -> \
"5f5b03e3-9e4b-43c6-a183-744cd60aa89f",
 CellID->71490363],
Cell[1016, 31, 565, 18, 20, "ProofText", "ExpressionUUID" -> \
"bbbf6e37-60d3-4f05-9f06-8f34e828bc68",
 CellID->180181516],
Cell[1584, 51, 4404, 122, 30, "ProofText", "ExpressionUUID" -> \
"f0bc3ec5-a06d-4ac9-9a71-d0ce0490cc9d",
 CellID->909900074],
Cell[5991, 175, 2737, 72, 50, "ProofText", "ExpressionUUID" -> \
"d47d600b-6109-4696-86f0-d33f7bd9aea0",
 CellID->456712112],
Cell[8731, 249, 321, 9, 20, "ProofText", "ExpressionUUID" -> \
"59dc8036-6ee5-4409-9652-a205d85ae0a0",
 CellID->1626657156],
Cell[9055, 260, 799, 23, 20, "ProofText", "ExpressionUUID" -> \
"061a31c7-a7e3-421c-9760-07aa544f3033",
 CellID->1133016938],
Cell[9857, 285, 557, 15, 18, "ProofText", "ExpressionUUID" -> \
"80a84d6b-023a-4d6f-807f-6d38a1dd4e13",
 CellID->1981123989],
Cell[10417, 302, 1107, 32, 18, "ProofText", "ExpressionUUID" -> \
"7fd156cd-79ff-41db-89c0-892047b08529",
 CellID->1126202645],
Cell[11527, 336, 692, 17, 18, "ProofText", "ExpressionUUID" -> \
"6016d282-6a20-4cbf-a4d7-52b02458ad4e",
 CellID->807050453],
Cell[12222, 355, 216, 4, 18, "ProofText", "ExpressionUUID" -> \
"0cda7e5c-5f8e-4e13-94f6-924fc772a9cc",
 CellID->3922997],
Cell[12441, 361, 2473, 64, 35, "ProofText", "ExpressionUUID" -> \
"f0bfadf1-d469-41c9-b2c8-61c771bd3cfa",
 CellID->650349429]
}
]
*)

