(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     24858,        710]
NotebookOptionsPosition[     21118,        615]
NotebookOutlinePosition[     21724,        635]
CellTagsIndexPosition[     21681,        632]
WindowTitle->Proof of (\:2200C\:2228 const)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220240623999*^9, 3.719220249591737*^9}},
 CellID->554110264,ExpressionUUID->"d488f444-ad3e-4b1f-9073-4972a804c22a"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220251026569*^9, 3.7192202531982927`*^9}},
 CellID->1378006495,ExpressionUUID->"03e0d354-32b0-4418-9b5d-d9b71550ed88"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}], 
        TagBox["\[Or]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
         SyntaxForm->"x\[Or]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192202561803207`*^9, 3.719220279662787*^9}},
 CellID->1055299202,ExpressionUUID->"6a431943-9ef2-4430-9807-14706e65889b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]I2 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220285676672*^9, 3.719220303255271*^9}},
 CellID->976289794,ExpressionUUID->"0eb0039e-3048-4da3-83e7-e65f0d1b7cea"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220306806171*^9, 3.7192203165979424`*^9}},
 CellID->955578284,ExpressionUUID->"8156ba79-667e-4e3f-b9af-3d1b2a5a9f7d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71922032776668*^9, 3.719220340407723*^9}},
 CellID->1874958395,ExpressionUUID->"70cfc0b8-89a5-444e-b76a-8621c0a765fb"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220342634234*^9, 3.719220346705832*^9}},
 CellID->1128647380,ExpressionUUID->"9fdcc935-fcb6-4655-9058-4914686f7a07"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192203483941727`*^9, 3.719220358547916*^9}},
 CellID->2029849712,ExpressionUUID->"29b0c4a6-0d0f-4935-a2aa-04590a7167e1"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}], "\[Or]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719220365995206*^9, 3.719220382943901*^9}},
 CellID->656140042,ExpressionUUID->"3fc30ce9-4543-4ca9-b581-5739a41dca75"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192203899025927`*^9, 3.719220402952211*^9}},
 CellID->1495696152,ExpressionUUID->"75f6bd61-bb45-40eb-bcf5-876f93354c43"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220412543524*^9, 3.719220419704853*^9}},
 CellID->547665025,ExpressionUUID->"fb11a760-7ddf-4891-a500-ec795925e78f"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71922042238737*^9, 3.719220435953165*^9}},
 CellID->1260633195,ExpressionUUID->"642822be-a5cb-4158-8315-5cf430181d40"],

Cell[BoxData[
 RowBox[{"\t\t\t", "qed"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220438883586*^9, 3.7192204406007957`*^9}},
 CellID->1110991001,ExpressionUUID->"d17ec67e-da80-41e7-9cf6-4b92b15041bb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220443799426*^9, 3.719220456601129*^9}},
 CellID->2072386075,ExpressionUUID->"abc719c1-8c2e-4abd-adec-efc2000dbcf0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<2\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220458382299*^9, 3.719220474840559*^9}},
 CellID->1143614750,ExpressionUUID->"79052ee3-c097-4c10-bebf-4989b2758c79"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}], 
        TagBox["\[Or]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
         SyntaxForm->"x\[Or]y"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220477244965*^9, 3.719220497464883*^9}},
 CellID->580435616,ExpressionUUID->"6f8de6b9-5718-4e1e-8d84-3d3474c85f06"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192204995528383`*^9, 3.719220503821591*^9}},
 CellID->1324993595,ExpressionUUID->"c37f3533-d814-4489-a263-1b5fc711069e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71922050663827*^9, 3.7192205172853327`*^9}},
 CellID->923151961,ExpressionUUID->"6470c869-8cd5-4499-aa85-fdba70afab89"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]I2 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220529618863*^9, 3.7192205468423853`*^9}},
 CellID->1044842583,ExpressionUUID->"40e37a83-9585-464d-9055-fd868e44220a"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220550302919*^9, 3.719220558705317*^9}},
 CellID->1326379702,ExpressionUUID->"92cfbbe4-00ad-4b78-a09c-3dcb3c3d8378"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<2\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220567412652*^9, 3.719220584178481*^9}},
 CellID->1732692942,ExpressionUUID->"d8d24920-6ce5-45a9-9423-953096c11265"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192205893955917`*^9, 3.7192205988642673`*^9}},
 CellID->1153247018,ExpressionUUID->"53b9f19e-dc21-4450-92f0-36aaffdb55a8"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], 
   " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220602864153*^9, 3.719220633362843*^9}},
 CellID->1111897298,ExpressionUUID->"3f690466-78ca-4aea-89e8-36410cba8749"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220637300003*^9, 3.7192206402751617`*^9}},
 CellID->862093239,ExpressionUUID->"0c9f5f5b-1723-49fb-90d7-2a8b2d6271cb"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220642315737*^9, 3.719220647679255*^9}},
 CellID->267133087,ExpressionUUID->"d869e3fc-639e-456a-9827-e2469a410724"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7192206497669573`*^9, 3.719220661138729*^9}},
 CellID->2144836503,ExpressionUUID->"16712041-c143-454e-b5ac-03fc3cd03c47"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[ForAll]C\[Or] const)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"d488f444-ad3e-4b1f-9073-4972a804c22a",
 CellID->554110264],
Cell[1048, 37, 237, 4, 39, "ProofText", "ExpressionUUID" -> \
"03e0d354-32b0-4418-9b5d-d9b71550ed88",
 CellID->1378006495],
Cell[1288, 43, 1857, 48, 30, "ProofText", "ExpressionUUID" -> \
"6a431943-9ef2-4430-9807-14706e65889b",
 CellID->1055299202],
Cell[3148, 93, 2243, 61, 57, "ProofText", "ExpressionUUID" -> \
"0eb0039e-3048-4da3-83e7-e65f0d1b7cea",
 CellID->976289794],
Cell[5394, 156, 417, 11, 20, "ProofText", "ExpressionUUID" -> \
"8156ba79-667e-4e3f-b9af-3d1b2a5a9f7d",
 CellID->955578284],
Cell[5814, 169, 1625, 42, 52, "ProofText", "ExpressionUUID" -> \
"70cfc0b8-89a5-444e-b76a-8621c0a765fb",
 CellID->1874958395],
Cell[7442, 213, 325, 9, 20, "ProofText", "ExpressionUUID" -> \
"9fdcc935-fcb6-4655-9058-4914686f7a07",
 CellID->1128647380],
Cell[7770, 224, 497, 14, 20, "ProofText", "ExpressionUUID" -> \
"29b0c4a6-0d0f-4935-a2aa-04590a7167e1",
 CellID->2029849712],
Cell[8270, 240, 640, 19, 18, "ProofText", "ExpressionUUID" -> \
"3fc30ce9-4543-4ca9-b581-5739a41dca75",
 CellID->656140042],
Cell[8913, 261, 519, 15, 39, "ProofText", "ExpressionUUID" -> \
"75f6bd61-bb45-40eb-bcf5-876f93354c43",
 CellID->1495696152],
Cell[9435, 278, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"fb11a760-7ddf-4891-a500-ec795925e78f",
 CellID->547665025],
Cell[9765, 289, 450, 12, 18, "ProofText", "ExpressionUUID" -> \
"642822be-a5cb-4158-8315-5cf430181d40",
 CellID->1260633195],
Cell[10218, 303, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"d17ec67e-da80-41e7-9cf6-4b92b15041bb",
 CellID->1110991001],
Cell[10440, 309, 323, 7, 59, "ProofText", "ExpressionUUID" -> \
"abc719c1-8c2e-4abd-adec-efc2000dbcf0",
 CellID->2072386075],
Cell[10766, 318, 2158, 58, 35, "ProofText", "ExpressionUUID" -> \
"79052ee3-c097-4c10-bebf-4989b2758c79",
 CellID->1143614750],
Cell[12927, 378, 1832, 47, 52, "ProofText", "ExpressionUUID" -> \
"6f8de6b9-5718-4e1e-8d84-3d3474c85f06",
 CellID->580435616],
Cell[14762, 427, 325, 9, 20, "ProofText", "ExpressionUUID" -> \
"c37f3533-d814-4489-a263-1b5fc711069e",
 CellID->1324993595],
Cell[15090, 438, 493, 14, 20, "ProofText", "ExpressionUUID" -> \
"6470c869-8cd5-4499-aa85-fdba70afab89",
 CellID->923151961],
Cell[15586, 454, 1272, 35, 39, "ProofText", "ExpressionUUID" -> \
"40e37a83-9585-464d-9055-fd868e44220a",
 CellID->1044842583],
Cell[16861, 491, 418, 11, 20, "ProofText", "ExpressionUUID" -> \
"92cfbbe4-00ad-4b78-a09c-3dcb3c3d8378",
 CellID->1326379702],
Cell[17282, 504, 548, 15, 39, "ProofText", "ExpressionUUID" -> \
"d8d24920-6ce5-45a9-9423-953096c11265",
 CellID->1732692942],
Cell[17833, 521, 1612, 41, 30, "ProofText", "ExpressionUUID" -> \
"53b9f19e-dc21-4450-92f0-36aaffdb55a8",
 CellID->1153247018],
Cell[19448, 564, 541, 15, 18, "ProofText", "ExpressionUUID" -> \
"3f690466-78ca-4aea-89e8-36410cba8749",
 CellID->1111897298],
Cell[19992, 581, 244, 5, 18, "ProofText", "ExpressionUUID" -> \
"0c9f5f5b-1723-49fb-90d7-2a8b2d6271cb",
 CellID->862093239],
Cell[20239, 588, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"d869e3fc-639e-456a-9827-e2469a410724",
 CellID->267133087],
Cell[20569, 599, 545, 14, 19, "ProofText", "ExpressionUUID" -> \
"16712041-c143-454e-b5ac-03fc3cd03c47",
 CellID->2144836503]
}
]
*)

