(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11405,        317]
NotebookOptionsPosition[      9940,        276]
NotebookOutlinePosition[     10545,        296]
CellTagsIndexPosition[     10502,        293]
WindowTitle->Proof of (\:2203!C\:F431')
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719217992581744*^9, 3.7192180157322283`*^9}, {
   3.7196498849034653`*^9, 3.719649885501301*^9}, 3.719650067584435*^9},
 CellID->1140812586,ExpressionUUID->"9123bdf9-3dfc-4030-99ca-24eeaadb6f57"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218020143626*^9, 3.719218023122508*^9}},
 CellID->873408468,ExpressionUUID->"3d6adc19-341f-407f-8e70-bf5520f08ab5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox[
        RowBox[{"\[Exists]", "!"}],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218025255869*^9, 3.71921804812307*^9}, {
  3.719648238233879*^9, 3.719648238928919*^9}, {3.719648288826035*^9, 
  3.719648291793332*^9}, {3.7196498937774363`*^9, 3.71964989966418*^9}, {
  3.71965007264117*^9, 3.7196500747432823`*^9}},
 CellID->1133448115,ExpressionUUID->"12be9b7b-4b44-45cc-95e7-d517efdf399e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], "  ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox["\[And]", "y"], 
      RowBox[{
       RowBox[{
        FormBox[
         StyleBox["Q", "ExpressionABF"],
         TheoremaForm], "[", "y", "]"}], "\[LongRightArrow]", 
       RowBox[{"(", 
        RowBox[{"y", "\[Equal]", 
         FormBox[
          StyleBox["t", "ExpressionABF"],
          TheoremaForm]}], ")"}], "\[LongRightArrow]", 
       RowBox[{"(", 
        RowBox[{"y", "\[Equal]", 
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm]}], ")"}]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719648365403067*^9, 3.719648415506542*^9}, {
   3.7196499043603783`*^9, 3.719649909108362*^9}, {3.719650081226853*^9, 
   3.7196501342187967`*^9}, {3.719650178737471*^9, 3.719650204302174*^9}, 
   3.7196504002201777`*^9, {3.7196504648451233`*^9, 3.7196504673493137`*^9}},
 CellID->1875341679,ExpressionUUID->"2fc2cdbf-3456-47e4-9bdf-1ba580ff6456"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     TagBox[
      StyleBox["t", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "\[Equal]", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218052042149*^9, 3.71921806438694*^9}, {
   3.719648296226829*^9, 3.7196482968255796`*^9}, {3.7196487173594713`*^9, 
   3.719648775024322*^9}, 3.719648973194459*^9, {3.7196496068840513`*^9, 
   3.719649607268939*^9}, {3.719649919607272*^9, 3.719649936446814*^9}, {
   3.719650473159865*^9, 3.719650474502235*^9}},
 CellID->1508967815,ExpressionUUID->"6c2b9052-3266-4a8f-bf7a-bee3d5b82b5e"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218205741378*^9, 3.719218211781164*^9}, {
  3.719649623178658*^9, 3.719649624938047*^9}},
 CellID->683998968,ExpressionUUID->"d421b6ef-9271-4c57-98b7-4d4afd272f21"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719218215896584*^9, 3.7192182264486732`*^9}, {
   3.71964824628963*^9, 3.719648246953409*^9}, {3.719649635347597*^9, 
   3.719649646707787*^9}, 3.719649942578714*^9, 3.719650478847102*^9},
 CellID->2139490176,ExpressionUUID->"d9f2a720-29cb-441d-9dfb-639e7c28e902"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox[
       RowBox[{"\[Exists]", "!"}],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       StyleBox["x", "ExpressionVariable"], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["t", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"intro", " ", "\"\<\[Exists]!CI\>\""}], ",", " ", 
     RowBox[{"rule", " ", "\"\<\[Equal] refl\>\""}], ",", " ", "fact"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719218228920768*^9, 3.719218267829843*^9}, {
  3.719649680964329*^9, 3.7196497277162457`*^9}, {3.7196499491210423`*^9, 
  3.7196499616141*^9}, {3.719650481846027*^9, 3.719650519849698*^9}},
 CellID->87837083,ExpressionUUID->"604e210b-d077-4d70-9191-e774d5627a31"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]!C\[Equal]')",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 447, 12, 20, "ProofText", "ExpressionUUID" -> \
"9123bdf9-3dfc-4030-99ca-24eeaadb6f57",
 CellID->1140812586],
Cell[1048, 35, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"3d6adc19-341f-407f-8e70-bf5520f08ab5",
 CellID->873408468],
Cell[1285, 41, 1991, 52, 31, "ProofText", "ExpressionUUID" -> \
"12be9b7b-4b44-45cc-95e7-d517efdf399e",
 CellID->1133448115],
Cell[3279, 95, 1694, 47, 30, "ProofText", "ExpressionUUID" -> \
"2fc2cdbf-3456-47e4-9bdf-1ba580ff6456",
 CellID->1875341679],
Cell[4976, 144, 1616, 42, 21, "ProofText", "ExpressionUUID" -> \
"6c2b9052-3266-4a8f-bf7a-bee3d5b82b5e",
 CellID->1508967815],
Cell[6595, 188, 268, 5, 18, "ProofText", "ExpressionUUID" -> \
"d421b6ef-9271-4c57-98b7-4d4afd272f21",
 CellID->683998968],
Cell[6866, 195, 955, 23, 21, "ProofText", "ExpressionUUID" -> \
"d9f2a720-29cb-441d-9dfb-639e7c28e902",
 CellID->2139490176],
Cell[7824, 220, 2112, 54, 31, "ProofText", "ExpressionUUID" -> \
"604e210b-d077-4d70-9191-e774d5627a31",
 CellID->87837083]
}
]
*)

