(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8152,        232]
NotebookOptionsPosition[      7322,        206]
NotebookOutlinePosition[      7918,        226]
CellTagsIndexPosition[      7875,        223]
WindowTitle->Proof of (theI weaker)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364054393783*^9, 3.7183640634445744`*^9}},
 CellID->769803610,ExpressionUUID->"af2def09-9864-4497-8f48-44e3231fbace"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<unique\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[And]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
         TagBox["\[Equal]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[Equal]y"], 
         TagBox[
          StyleBox["a", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
        TagBox[")",
         "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<rl\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364066211525*^9, 3.718364091429093*^9}, {
  3.718441236087459*^9, 3.718441243812413*^9}},
 CellID->918527219,ExpressionUUID->"21b807eb-dc2a-495f-b6ab-f924c1eb6bf4"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["R", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`FUN$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
        Theorema`Knowledge`BOOL$TM]]]], "[", 
    RowBox[{
     UnderscriptBox[
      TagBox["the",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Such$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]}], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<rl\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<theI\>\""}], ",", " ", 
    SuperscriptBox["fact", "+"]}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7183640983333063`*^9, 3.71836414807154*^9}, {
  3.718441249963735*^9, 3.718441258313643*^9}},
 CellID->390974505,ExpressionUUID->"9f0fa9b3-80a4-411e-b323-8a4f430a1554"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (theI weaker)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"af2def09-9864-4497-8f48-44e3231fbace",
 CellID->769803610],
Cell[1042, 37, 4449, 118, 28, "ProofText", "ExpressionUUID" -> \
"21b807eb-dc2a-495f-b6ab-f924c1eb6bf4",
 CellID->918527219],
Cell[5494, 157, 1824, 47, 31, "ProofText", "ExpressionUUID" -> \
"9f0fa9b3-80a4-411e-b323-8a4f430a1554",
 CellID->390974505]
}
]
*)

