(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8036,        238]
NotebookOptionsPosition[      6707,        200]
NotebookOutlinePosition[      7299,        220]
CellTagsIndexPosition[      7256,        217]
WindowTitle->Proof of (\:2227I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[And] def\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<\[ForAll]I\>\""}]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715334384506909*^9, 3.715334392664133*^9}, {
  3.715334486409544*^9, 3.715334508505611*^9}},
 CellID->882515214,ExpressionUUID->"10bc4279-9526-4d07-bd92-0c1833f251cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715334519109852*^9, 3.7153345271708317`*^9}},
 CellID->1805302246,ExpressionUUID->"c0291bba-491a-44c2-8861-f446febeb3d9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715334563353179*^9, 3.7153345705246058`*^9}, {
  3.7153346079075193`*^9, 3.715334614512968*^9}},
 CellID->1393827586,ExpressionUUID->"1a47259d-21a1-4b4d-aa9c-489fb9ec5cce"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        TagBox[
         StyleBox["R", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[Implies]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
     SyntaxForm->"x\[Implies]y"], 
    TagBox[
     StyleBox["R", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715334532992258*^9, 3.7153345420260477`*^9}, {
  3.7153346384495296`*^9, 3.71533465473143*^9}},
 CellID->1759227122,ExpressionUUID->"0579889a-aeb6-411c-b86f-6ea154208412"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        TagBox[
         StyleBox["R", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715334658763115*^9, 3.715334670937607*^9}},
 CellID->1776697055,ExpressionUUID->"f6936bc8-89fa-4532-8a9e-fab2fb82e75d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     TagBox[
      StyleBox["R", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<modus ponens reverse\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715334675623027*^9, 3.715334734771735*^9}},
 CellID->1729585373,ExpressionUUID->"702ca90a-cbda-4205-b492-b129bd0acec3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["R", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<modus ponens reverse\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715334741248084*^9, 3.715334769332959*^9}},
 CellID->1886455887,ExpressionUUID->"b28b0c96-3567-4321-96e6-0728b55a1abb"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[And]I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 414, 9, 20, "ProofText", "ExpressionUUID" -> \
"10bc4279-9526-4d07-bd92-0c1833f251cd",
 CellID->882515214],
Cell[1007, 32, 446, 14, 20, "ProofText", "ExpressionUUID" -> \
"c0291bba-491a-44c2-8861-f446febeb3d9",
 CellID->1805302246],
Cell[1456, 48, 559, 14, 20, "ProofText", "ExpressionUUID" -> \
"1a47259d-21a1-4b4d-aa9c-489fb9ec5cce",
 CellID->1393827586],
Cell[2018, 64, 1702, 48, 39, "ProofText", "ExpressionUUID" -> \
"0579889a-aeb6-411c-b86f-6ea154208412",
 CellID->1759227122],
Cell[3723, 114, 1261, 35, 20, "ProofText", "ExpressionUUID" -> \
"f6936bc8-89fa-4532-8a9e-fab2fb82e75d",
 CellID->1776697055],
Cell[4987, 151, 1010, 27, 18, "ProofText", "ExpressionUUID" -> \
"702ca90a-cbda-4205-b492-b129bd0acec3",
 CellID->1729585373],
Cell[6000, 180, 703, 18, 19, "ProofText", "ExpressionUUID" -> \
"b28b0c96-3567-4321-96e6-0728b55a1abb",
 CellID->1886455887]
}
]
*)

