(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5110,        150]
NotebookOptionsPosition[      4039,        118]
NotebookOutlinePosition[      4631,        138]
CellTagsIndexPosition[      4588,        135]
WindowTitle->Proof of (\:2228I2)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[Or] def\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<\[ForAll]I\>\""}]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7150574310266447`*^9, 3.715057459929852*^9}},
 CellID->1825621804,ExpressionUUID->"fdfa344b-ebbd-4081-bca2-133f9d37c4a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715057492366205*^9, 3.715057501631278*^9}},
 CellID->653370766,ExpressionUUID->"3a3b4352-36ab-4882-b92e-80a70fafd303"],

Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"intro", " ", "\"\<\[Implies]I\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715057512977858*^9, 3.7150575187705393`*^9}},
 CellID->249141445,ExpressionUUID->"f18f6ea4-eb5b-43f3-9c78-7c164950d1a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<a\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     TagBox[
      StyleBox["x", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715057540507461*^9, 3.7150576049879093`*^9}, {
  3.7150576771025*^9, 3.715057688428864*^9}},
 CellID->1194426327,ExpressionUUID->"39ff1096-3388-4d28-a933-b755fef3475b"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<a\>\"", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}], " ", "show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715057611684326*^9, 3.715057639364449*^9}, {
  3.7150576913007107`*^9, 3.715057696360371*^9}, {3.715060976368034*^9, 
  3.715060977976049*^9}},
 CellID->1051673113,ExpressionUUID->"a789c649-7f3f-402d-943d-fb3e75ec67d7"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or]I2)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 367, 8, 20, "ProofText", "ExpressionUUID" -> \
"fdfa344b-ebbd-4081-bca2-133f9d37c4a1",
 CellID->1825621804],
Cell[961, 31, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"3a3b4352-36ab-4882-b92e-80a70fafd303",
 CellID->653370766],
Cell[1407, 47, 289, 6, 18, "ProofText", "ExpressionUUID" -> \
"f18f6ea4-eb5b-43f3-9c78-7c164950d1a1",
 CellID->249141445],
Cell[1699, 55, 1554, 41, 20, "ProofText", "ExpressionUUID" -> \
"39ff1096-3388-4d28-a933-b755fef3475b",
 CellID->1194426327],
Cell[3256, 98, 779, 18, 19, "ProofText", "ExpressionUUID" -> \
"a789c649-7f3f-402d-943d-fb3e75ec67d7",
 CellID->1051673113]
}
]
*)

