(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6769,        202]
NotebookOptionsPosition[      5187,        158]
NotebookOutlinePosition[      5789,        178]
CellTagsIndexPosition[      5746,        175]
WindowTitle->Proof of (\:2228I1 classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184525328787603`*^9, 3.7184525382293787`*^9}},
 CellID->207273297,ExpressionUUID->"bfb05651-7f49-45cc-9c30-d3373ea819dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452577225807*^9, 3.718452589956139*^9}},
 CellID->882525460,ExpressionUUID->"9386f143-c787-4dde-91b0-3958fdca34a8"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452545184613*^9, 3.718452574204536*^9}},
 CellID->1168467108,ExpressionUUID->"0ece0885-3c37-4492-8d52-8687bad9ba3b"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["P", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
    TagBox["\[Or]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
     SyntaxForm->"x\[Or]y"], 
    TagBox[
     StyleBox["Q", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452568337882*^9, 3.718452603164507*^9}},
 CellID->1896624645,ExpressionUUID->"618c57d9-c23a-4d4b-8c72-cd878a4e45ba"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452606131966*^9, 3.718452612876959*^9}},
 CellID->677531929,ExpressionUUID->"20237e79-94d8-4c6c-ab86-0e4e0277773a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452618448772*^9, 3.71845263815057*^9}},
 CellID->1692934647,ExpressionUUID->"b9070577-4f9a-4cff-ba4e-158dac2032c3"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184526425097113`*^9, 3.7184526451894712`*^9}},
 CellID->650417045,ExpressionUUID->"53b6f23b-74e0-4c37-a8cf-dfb295bded2a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452648793027*^9, 3.718452658192713*^9}},
 CellID->529582062,ExpressionUUID->"45f89f28-3055-4cd6-a58f-2f52570080da"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ",", " ", 
     RowBox[{"rule", " ", "\"\<*\>\""}], ",", " ", "fact"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718452665867859*^9, 3.718452686661427*^9}},
 CellID->1938586409,ExpressionUUID->"97a92149-cb83-4583-bd48-0570a2aa9990"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or]I1 classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 374, 11, 20, "ProofText", "ExpressionUUID" -> \
"bfb05651-7f49-45cc-9c30-d3373ea819dd",
 CellID->207273297],
Cell[978, 34, 1105, 31, 20, "ProofText", "ExpressionUUID" -> \
"9386f143-c787-4dde-91b0-3958fdca34a8",
 CellID->882525460],
Cell[2086, 67, 567, 15, 18, "ProofText", "ExpressionUUID" -> \
"0ece0885-3c37-4492-8d52-8687bad9ba3b",
 CellID->1168467108],
Cell[2656, 84, 727, 19, 39, "ProofText", "ExpressionUUID" -> \
"618c57d9-c23a-4d4b-8c72-cd878a4e45ba",
 CellID->1896624645],
Cell[3386, 105, 321, 9, 20, "ProofText", "ExpressionUUID" -> \
"20237e79-94d8-4c6c-ab86-0e4e0277773a",
 CellID->677531929],
Cell[3710, 116, 323, 7, 18, "ProofText", "ExpressionUUID" -> \
"b9070577-4f9a-4cff-ba4e-158dac2032c3",
 CellID->1692934647],
Cell[4036, 125, 223, 4, 18, "ProofText", "ExpressionUUID" -> \
"53b6f23b-74e0-4c37-a8cf-dfb295bded2a",
 CellID->650417045],
Cell[4262, 131, 411, 11, 20, "ProofText", "ExpressionUUID" -> \
"45f89f28-3055-4cd6-a58f-2f52570080da",
 CellID->529582062],
Cell[4676, 144, 507, 12, 20, "ProofText", "ExpressionUUID" -> \
"97a92149-cb83-4583-bd48-0570a2aa9990",
 CellID->1938586409]
}
]
*)

