(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9068,        265]
NotebookOptionsPosition[      7465,        221]
NotebookOutlinePosition[      8084,        241]
CellTagsIndexPosition[      8041,        238]
WindowTitle->Proof of (\:21D4E classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453645621529*^9, 3.718453652999708*^9}},
 CellID->60828090,ExpressionUUID->"22327bb8-dbb8-492b-a56e-9214a9149f2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<eq\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[LongRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
         SyntaxForm->"x\[LongRightArrow]y"], 
        TagBox[
         StyleBox["R", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox["\[Not]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
          SyntaxForm->"\[Not]x"], 
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184536551610394`*^9, 3.7184536920973997`*^9}},
 CellID->1832118274,ExpressionUUID->"3e2dfa52-9505-4c06-9781-45d51e21180d"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453825646968*^9, 3.718453848849725*^9}},
 CellID->1377569274,ExpressionUUID->"d3bb047a-bfae-419e-9145-8d22e18e9f9d"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  FormBox[
   StyleBox["R", "ExpressionABF"],
   TheoremaForm]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845385082594*^9, 3.718453854975016*^9}},
 CellID->630623857,ExpressionUUID->"45fdf425-ed03-4347-894f-4a5666434dba"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453856543097*^9, 3.718453862214718*^9}},
 CellID->1267942082,ExpressionUUID->"e6a8b236-2b5e-48c2-853f-7099c8b96a0d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<1\>\""}], ",", " ", 
     RowBox[{"simp", ":", " ", "\"\<eq\>\""}], ",", " ", 
     SuperscriptBox["fact", "+"]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184538705105267`*^9, 3.7184539026454067`*^9}},
 CellID->1168672035,ExpressionUUID->"7855fbb8-4b5d-4fca-b32d-d3aba4007d01"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184539046123257`*^9, 3.718453906270051*^9}},
 CellID->721693590,ExpressionUUID->"9020558f-b3c3-42a0-a859-b041c6ec5e02"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453909115698*^9, 3.718453917665008*^9}},
 CellID->888181202,ExpressionUUID->"5600447d-5fdd-41c6-8aad-e8339f9a3d84"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<2\>\""}], ",", " ", 
     RowBox[{"simp", ":", " ", "\"\<eq\>\""}], ",", " ", 
     SuperscriptBox["fact", "+"]}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.71845392067443*^9, 3.718453933510178*^9}},
 CellID->1009412199,ExpressionUUID->"19ac7aa8-5949-48c2-96f3-3f5ec2afd41f"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[DoubleLeftRightArrow]E classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 442, 14, 20, "ProofText", "ExpressionUUID" -> \
"22327bb8-dbb8-492b-a56e-9214a9149f2f",
 CellID->60828090],
Cell[1045, 37, 3612, 100, 20, "ProofText", "ExpressionUUID" -> \
"3e2dfa52-9505-4c06-9781-45d51e21180d",
 CellID->1832118274],
Cell[4660, 139, 567, 15, 18, "ProofText", "ExpressionUUID" -> \
"d3bb047a-bfae-419e-9145-8d22e18e9f9d",
 CellID->1377569274],
Cell[5230, 156, 293, 7, 39, "ProofText", "ExpressionUUID" -> \
"45fdf425-ed03-4347-894f-4a5666434dba",
 CellID->630623857],
Cell[5526, 165, 322, 9, 20, "ProofText", "ExpressionUUID" -> \
"e6a8b236-2b5e-48c2-853f-7099c8b96a0d",
 CellID->1267942082],
Cell[5851, 176, 441, 10, 22, "ProofText", "ExpressionUUID" -> \
"7855fbb8-4b5d-4fca-b32d-d3aba4007d01",
 CellID->1168672035],
Cell[6295, 188, 221, 4, 18, "ProofText", "ExpressionUUID" -> \
"9020558f-b3c3-42a0-a859-b041c6ec5e02",
 CellID->721693590],
Cell[6519, 194, 411, 11, 20, "ProofText", "ExpressionUUID" -> \
"5600447d-5fdd-41c6-8aad-e8339f9a3d84",
 CellID->888181202],
Cell[6933, 207, 528, 12, 22, "ProofText", "ExpressionUUID" -> \
"19ac7aa8-5949-48c2-96f3-3f5ec2afd41f",
 CellID->1009412199]
}
]
*)

