(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6440,        187]
NotebookOptionsPosition[      5361,        155]
NotebookOutlinePosition[      5956,        175]
CellTagsIndexPosition[      5913,        172]
WindowTitle->Proof of (\:2203I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[Exists] def\>\""}], ",", " ", 
    RowBox[{
    "intro", " ", "\"\<\[ForAll]I\>\"", " ", "\"\<\[Implies]I\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335574875039*^9, 3.715335603783154*^9}, {
  3.715335727801445*^9, 3.715335735505288*^9}},
 CellID->1219410872,ExpressionUUID->"224f0d70-caeb-46d4-894b-54edd2c1b393"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153356140449142`*^9, 3.715335637699998*^9}},
 CellID->504326279,ExpressionUUID->"8e28ae80-ee93-4da8-b0e1-711b6a673d53"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153356977903*^9, 3.715335709944684*^9}, {
  3.715335750841486*^9, 3.71533577971375*^9}},
 CellID->1584364231,ExpressionUUID->"b9b07d18-68b9-4029-ba7c-f5266d90fba1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "\"\<2\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm], "]"}], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     TagBox[
      StyleBox["R", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335785562171*^9, 3.7153358082580957`*^9}},
 CellID->498061374,ExpressionUUID->"67ba574f-907c-4511-92ff-4f68bbac09b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "this", " ", "\"\<1\>\"", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["R", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715335813680018*^9, 3.715335899131283*^9}},
 CellID->346589522,ExpressionUUID->"3a731eab-50f8-4a84-8ef2-78d011ae3c7c"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 456, 11, 20, "ProofText", "ExpressionUUID" -> \
"224f0d70-caeb-46d4-894b-54edd2c1b393",
 CellID->1219410872],
Cell[1049, 34, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"8e28ae80-ee93-4da8-b0e1-711b6a673d53",
 CellID->504326279],
Cell[1497, 50, 2329, 61, 28, "ProofText", "ExpressionUUID" -> \
"b9b07d18-68b9-4029-ba7c-f5266d90fba1",
 CellID->1584364231],
Cell[3829, 113, 1025, 27, 21, "ProofText", "ExpressionUUID" -> \
"67ba574f-907c-4511-92ff-4f68bbac09b1",
 CellID->498061374],
Cell[4857, 142, 500, 11, 19, "ProofText", "ExpressionUUID" -> \
"3a731eab-50f8-4a84-8ef2-78d011ae3c7c",
 CellID->346589522]
}
]
*)

