(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20360,        531]
NotebookOptionsPosition[     19153,        496]
NotebookOutlinePosition[     19742,        516]
CellTagsIndexPosition[     19699,        513]
WindowTitle->Proof of (theI)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363139078302*^9, 3.718363149698311*^9}, {
  3.718363195999001*^9, 3.718363203092044*^9}},
 CellID->1802491860,ExpressionUUID->"ebd2a218-9819-400f-8fe0-a8db0e8037d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<unique\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["a", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183632056086483`*^9, 3.71836321457099*^9}, {
  3.718431865535541*^9, 3.718431879236897*^9}},
 CellID->1683919478,ExpressionUUID->"1cc77329-c4a1-4e2f-b349-0bc0136e4e79"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["A", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", "x"], 
     RowBox[{"(", 
      RowBox[{"True", " ", "\[And]", " ", 
       RowBox[{
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}], " ", "\[And]", " ", 
       RowBox[{"(", 
        RowBox[{
         UnderscriptBox["\[ForAll]", "y"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            FormBox[
             StyleBox["P", "ExpressionABF"],
             TheoremaForm], "[", "y", "]"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"y", "\[Equal]", "x"}], ")"}]}], ")"}]}], ")"}]}], 
      ")"}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363222597866*^9, 3.7183632547877827`*^9}, {
  3.7184317723761806`*^9, 3.718431821681467*^9}},
 CellID->1159315994,ExpressionUUID->"a82c08e2-c293-444e-8821-dcb946d69cb1"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<SomeI\>\""}], ",", " ", 
     RowBox[{"intro", " ", "\"\<\[And]I\>\""}], ",", " ", "rule", ",", " ", 
     "fact", ",", " ", 
     RowBox[{"intro", " ", "\"\<\[ForAll]I\>\"", " ", "\"\<\[Implies]I\>\""}],
      ",", " ", 
     RowBox[{"rule", " ", "\"\<unique\>\""}]}], ")"}]}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363267138813*^9, 3.718363345037739*^9}, {
  3.718431832296833*^9, 3.71843183274472*^9}, {3.71843216190112*^9, 
  3.7184322559428787`*^9}},
 CellID->1751882754,ExpressionUUID->"517c3a27-2906-4479-a721-142d856caac1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      RowBox[{
       TagBox["Some",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`Some$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        "[", 
       RowBox[{
        UnderscriptBox["\[Lambda]", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        RowBox[{"(", 
         RowBox[{
          TagBox["True",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[True, {}]]], 
          TagBox["\[And]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
           SyntaxForm->"x\[And]y"], 
          RowBox[{
           TagBox["(",
            "AutoParentheses"], 
           RowBox[{
            RowBox[{
             TagBox[
              StyleBox["P", "ExpressionABF"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`FUN$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                 Theorema`Knowledge`BOOL$TM]]]], "[", 
             TagBox[
              StyleBox["x", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
            TagBox["\[And]",
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
             SyntaxForm->"x\[And]y"], 
            RowBox[{
             TagBox["(",
              "AutoParentheses"], 
             RowBox[{
              UnderscriptBox[
               TagBox["\[ForAll]",
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
                   Theorema`Language`TFIX$[
                   Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
               TagBox[
                StyleBox["y", "ExpressionVariable"],
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 TagBox[
                  StyleBox["P", "ExpressionABF"],
                  Theorema`Language`TAG$[
                   Theorema`Language`TYPED$[
                    Theorema`Language`FUN$TM[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                    Theorema`Knowledge`BOOL$TM]]]], "[", 
                 TagBox[
                  TagBox[
                   StyleBox["y", "ExpressionVariable"],
                   Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
                  Theorema`Language`TAG$[
                   Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
                TagBox["\[Implies]",
                 Theorema`Language`TAG$[
                  Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
                 
                 SyntaxForm->"x\[Implies]y"], 
                RowBox[{
                 TagBox["(",
                  "AutoParentheses"], 
                 RowBox[{
                  TagBox[
                   TagBox[
                    StyleBox["y", "ExpressionVariable"],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
                   Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
                  TagBox["\[Equal]",
                   Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
                   SyntaxForm->"x\[Equal]y"], 
                  StyleBox["x", "ExpressionVariable"]}], 
                 TagBox[")",
                  "AutoParentheses"]}]}], ")"}]}], 
             TagBox[")",
              "AutoParentheses"]}]}], 
           TagBox[")",
            "AutoParentheses"]}]}], ")"}]}], "]"}], "]"}], 
     TagBox[
      RowBox[{"\[And]", "\n", "\t\t"}],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
      SyntaxForm->"x\[And]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["y", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["y", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
           TagBox["\[Equal]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[Equal]y"], 
           RowBox[{
            TagBox["Some",
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[Theorema`Knowledge`Some$TM, {
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], "[", 
            RowBox[{
             UnderscriptBox["\[Lambda]", 
              TagBox[
               StyleBox["x", "ExpressionVariable"],
               Theorema`Language`TAG$[
                Theorema`Language`TYPED$[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
             RowBox[{"(", 
              RowBox[{
               TagBox["True",
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[True, {}]]], 
               TagBox["\[And]",
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
                SyntaxForm->"x\[And]y"], 
               RowBox[{
                TagBox["(",
                 "AutoParentheses"], 
                RowBox[{
                 RowBox[{
                  TagBox[
                   StyleBox["P", "ExpressionABF"],
                   Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`FUN$TM[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                    Theorema`Knowledge`BOOL$TM]]]], "[", 
                  TagBox[
                   StyleBox["x", "ExpressionVariable"],
                   Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
                 TagBox["\[And]",
                  Theorema`Language`TAG$[
                   Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
                  SyntaxForm->"x\[And]y"], 
                 RowBox[{
                  TagBox["(",
                   "AutoParentheses"], 
                  RowBox[{
                   UnderscriptBox[
                    TagBox["\[ForAll]",
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
                    TagBox[
                    StyleBox["y0", "ExpressionVariable"],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    TagBox[
                    StyleBox["P", "ExpressionABF"],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`FUN$TM[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                    Theorema`Knowledge`BOOL$TM]]]], "[", 
                    TagBox[
                    TagBox[
                    StyleBox["y0", "ExpressionVariable"],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
                    TagBox["\[Implies]",
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`Implies$TM, {}]],
                    SyntaxForm->"x\[Implies]y"], 
                    RowBox[{
                    TagBox["(",
                    "AutoParentheses"], 
                    RowBox[{
                    TagBox[
                    TagBox[
                    StyleBox["y0", "ExpressionVariable"],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
                    TagBox["\[Equal]",
                    Theorema`Language`TAG$[
                    Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
                    SyntaxForm->"x\[Equal]y"], 
                    StyleBox["x", "ExpressionVariable"]}], 
                    TagBox[")",
                    "AutoParentheses"]}]}], ")"}]}], 
                  TagBox[")",
                   "AutoParentheses"]}]}], 
                TagBox[")",
                 "AutoParentheses"]}]}], ")"}]}], "]"}]}], 
          TagBox[")",
           "AutoParentheses"]}]}], ")"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
  ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718439705075212*^9, 3.71843981380048*^9}, {
  3.71844013828284*^9, 3.718440172596448*^9}, {3.71844027691743*^9, 
  3.718440336406343*^9}, {3.718440367697981*^9, 3.718440369087517*^9}},
 CellID->1498773338,ExpressionUUID->"01a83916-eccc-4b1c-a352-72b5a7ccd9f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"thus", " ", "_", " ", "unfolding", " ", "\"\<the def\>\""}], " ", 
  ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718363358207903*^9, 3.718363370989541*^9}, {
   3.718431838985147*^9, 3.71843184473726*^9}, {3.718431918849855*^9, 
   3.718432009043539*^9}, {3.718432048859359*^9, 3.718432104244513*^9}, 
   3.7184387748271523`*^9, {3.71844035742153*^9, 3.718440357967019*^9}},
 CellID->1067176506,ExpressionUUID->"4cd802b6-fc0c-4d87-bda2-fc3117cdfacb"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (theI)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[587, 21, 420, 12, 20, "ProofText", "ExpressionUUID" -> \
"ebd2a218-9819-400f-8fe0-a8db0e8037d0",
 CellID->1802491860],
Cell[1010, 35, 2624, 73, 28, "ProofText", "ExpressionUUID" -> \
"1cc77329-c4a1-4e2f-b349-0bc0136e4e79",
 CellID->1683919478],
Cell[3637, 110, 1064, 30, 35, "ProofText", "ExpressionUUID" -> \
"a82c08e2-c293-444e-8821-dcb946d69cb1",
 CellID->1159315994],
Cell[4704, 142, 970, 25, 41, "ProofText", "ExpressionUUID" -> \
"517c3a27-2906-4479-a721-142d856caac1",
 CellID->1751882754],
Cell[5677, 169, 12872, 312, 76, "ProofText", "ExpressionUUID" -> \
"01a83916-eccc-4b1c-a352-72b5a7ccd9f2",
 CellID->1498773338],
Cell[18552, 483, 597, 11, 19, "ProofText", "ExpressionUUID" -> \
"4cd802b6-fc0c-4d87-bda2-fc3117cdfacb",
 CellID->1067176506]
}
]
*)

