(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     17381,        505]
NotebookOptionsPosition[     14411,        428]
NotebookOutlinePosition[     15014,        448]
CellTagsIndexPosition[     14971,        445]
WindowTitle->Proof of (\:2228 cong reverse)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912244721381*^9, 3.7191224577836523`*^9}},
 CellID->71595966,ExpressionUUID->"8920e71c-725b-4a42-8f76-476323acb45f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[DoubleLeftRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
        SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
       TagBox[
        StyleBox["P1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122472309289*^9, 3.719122493865947*^9}, {
  3.719123536671049*^9, 3.7191235464655247`*^9}},
 CellID->1996263298,ExpressionUUID->"a79084ac-82ee-4403-8de9-785f0a5a5858"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[DoubleLeftRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
     SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<1\>\""}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122498014771*^9, 3.719122511673417*^9}},
 CellID->1759624985,ExpressionUUID->"ede17f02-fed8-408e-9b6a-49137311e621"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122514224495*^9, 3.719122525013747*^9}, {
  3.719123564911663*^9, 3.7191235665746927`*^9}},
 CellID->292283522,ExpressionUUID->"ea69589a-2253-47c7-8429-7c569eead403"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]E2 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122530897979*^9, 3.719122542229487*^9}, {
  3.719123167577207*^9, 3.719123179138012*^9}, {3.7191235745346737`*^9, 
  3.719123575726491*^9}},
 CellID->1208836649,ExpressionUUID->"4a196b2c-5b3b-4331-8688-7d082a80b816"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123197422575*^9, 3.719123203669929*^9}, 
   3.7191235800092297`*^9},
 CellID->1188235030,ExpressionUUID->"300034c1-7d87-45b7-b304-94b5ac30b379"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912320681597*^9, 3.719123227522739*^9}, 
   3.7191233650040207`*^9, 3.719123585702992*^9},
 CellID->2100176693,ExpressionUUID->"211f1075-f51a-4e8e-820b-4b47d313a5fe"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912323078358*^9, 3.7191232336505203`*^9}},
 CellID->858466717,ExpressionUUID->"4e7958de-5c60-4e1a-b7df-16a7838125cd"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q1", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123236882414*^9, 3.719123252272089*^9}, {
  3.719123590029114*^9, 3.719123591769212*^9}},
 CellID->2047873064,ExpressionUUID->"ac54bcac-e133-4afc-8b10-f74ff56a5337"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "have", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", 
      RowBox[{"\"\<2\>\"", " ", 
       RowBox[{"\[OpenCurlyQuote]", 
        RowBox[{"\[Not]", 
         FormBox[
          StyleBox["Q1", "ExpressionABF"],
          TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123284424177*^9, 3.7191233505481*^9}, {
  3.719123595655785*^9, 3.719123645104321*^9}},
 CellID->676164419,ExpressionUUID->"53d4db2e-f377-416d-8617-c51787bcad7e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912335417902*^9, 3.719123375492065*^9}, 
   3.719123658079617*^9},
 CellID->148567486,ExpressionUUID->"a5e33697-ff0e-48fb-8d5f-059a70d4bb2e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123379419035*^9, 3.7191233881725197`*^9}},
 CellID->304245334,ExpressionUUID->"7ecad9da-88f3-494c-bef9-9b55eb467ced"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191233902082987`*^9, 3.719123400411734*^9}},
 CellID->1029126483,ExpressionUUID->"ff33dda0-3ec3-419a-af0d-63af46500050"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]E2 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122530897979*^9, 3.719122542229487*^9}, {
   3.719123167577207*^9, 3.719123179138012*^9}, 3.7191234224300423`*^9, {
   3.71912366588867*^9, 3.719123672535977*^9}},
 CellID->858890241,ExpressionUUID->"7aaa5fad-99e1-4c2a-9fda-3f7f5c239abc"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123197422575*^9, 3.719123203669929*^9}, 
   3.7191236763142767`*^9},
 CellID->1462966552,ExpressionUUID->"1b84fe7c-9ec4-4ea9-bf26-ed721b61b25d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912320681597*^9, 3.719123227522739*^9}, 
   3.7191233650040207`*^9, 3.7191236787521763`*^9},
 CellID->464530090,ExpressionUUID->"50b06b78-8761-4edc-a846-da5624d4df71"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912323078358*^9, 3.7191232336505203`*^9}},
 CellID->842835447,ExpressionUUID->"ebd6bbc8-9022-45c9-8f3d-68bf6c6ead08"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q1", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    FormBox[
     StyleBox["P1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123236882414*^9, 3.719123252272089*^9}, 
   3.719123433733739*^9, {3.719123689155498*^9, 3.719123693242629*^9}},
 CellID->964445162,ExpressionUUID->"437f5018-acd7-47b3-9fba-3aea9a9dfd79"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "have", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", 
      RowBox[{"\"\<2\>\"", " ", 
       RowBox[{"\[OpenCurlyQuote]", 
        RowBox[{"\[Not]", 
         FormBox[
          StyleBox["Q1", "ExpressionABF"],
          TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123284424177*^9, 3.7191233505481*^9}, {
  3.7191234374536343`*^9, 3.719123439479393*^9}, {3.719123698753269*^9, 
  3.719123715941493*^9}},
 CellID->1918140120,ExpressionUUID->"e74e0243-236c-4a5b-96c8-485f5ec5827f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.71912335417902*^9, 3.719123375492065*^9}, 
   3.7191237196338863`*^9},
 CellID->8562551,ExpressionUUID->"e1e0466f-5800-42d4-b242-f39c2c63b918"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or] cong reverse)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 518, 17, 20, "ProofText", "ExpressionUUID" -> \
"8920e71c-725b-4a42-8f76-476323acb45f",
 CellID->71595966],
Cell[1123, 40, 2249, 61, 20, "ProofText", "ExpressionUUID" -> \
"a79084ac-82ee-4403-8de9-785f0a5a5858",
 CellID->1996263298],
Cell[3375, 103, 1651, 47, 39, "ProofText", "ExpressionUUID" -> \
"ede17f02-fed8-408e-9b6a-49137311e621",
 CellID->1759624985],
Cell[5029, 152, 829, 22, 20, "ProofText", "ExpressionUUID" -> \
"ea69589a-2253-47c7-8429-7c569eead403",
 CellID->292283522],
Cell[5861, 176, 1004, 27, 39, "ProofText", "ExpressionUUID" -> \
"4a196b2c-5b3b-4331-8688-7d082a80b816",
 CellID->1208836649],
Cell[6868, 205, 353, 10, 20, "ProofText", "ExpressionUUID" -> \
"300034c1-7d87-45b7-b304-94b5ac30b379",
 CellID->1188235030],
Cell[7224, 217, 375, 8, 18, "ProofText", "ExpressionUUID" -> \
"211f1075-f51a-4e8e-820b-4b47d313a5fe",
 CellID->2100176693],
Cell[7602, 227, 239, 5, 18, "ProofText", "ExpressionUUID" -> \
"4e7958de-5c60-4e1a-b7df-16a7838125cd",
 CellID->858466717],
Cell[7844, 234, 552, 15, 20, "ProofText", "ExpressionUUID" -> \
"ac54bcac-e133-4afc-8b10-f74ff56a5337",
 CellID->2047873064],
Cell[8399, 251, 753, 22, 18, "ProofText", "ExpressionUUID" -> \
"53d4db2e-f377-416d-8617-c51787bcad7e",
 CellID->676164419],
Cell[9155, 275, 350, 8, 18, "ProofText", "ExpressionUUID" -> \
"a5e33697-ff0e-48fb-8d5f-059a70d4bb2e",
 CellID->148567486],
Cell[9508, 285, 278, 6, 39, "ProofText", "ExpressionUUID" -> \
"7ecad9da-88f3-494c-bef9-9b55eb467ced",
 CellID->304245334],
Cell[9789, 293, 782, 21, 20, "ProofText", "ExpressionUUID" -> \
"ff33dda0-3ec3-419a-af0d-63af46500050",
 CellID->1029126483],
Cell[10574, 316, 1025, 27, 39, "ProofText", "ExpressionUUID" -> \
"7aaa5fad-99e1-4c2a-9fda-3f7f5c239abc",
 CellID->858890241],
Cell[11602, 345, 353, 10, 20, "ProofText", "ExpressionUUID" -> \
"1b84fe7c-9ec4-4ea9-bf26-ed721b61b25d",
 CellID->1462966552],
Cell[11958, 357, 376, 8, 18, "ProofText", "ExpressionUUID" -> \
"50b06b78-8761-4edc-a846-da5624d4df71",
 CellID->464530090],
Cell[12337, 367, 239, 5, 18, "ProofText", "ExpressionUUID" -> \
"ebd6bbc8-9022-45c9-8f3d-68bf6c6ead08",
 CellID->842835447],
Cell[12579, 374, 575, 15, 20, "ProofText", "ExpressionUUID" -> \
"437f5018-acd7-47b3-9fba-3aea9a9dfd79",
 CellID->964445162],
Cell[13157, 391, 805, 23, 18, "ProofText", "ExpressionUUID" -> \
"e74e0243-236c-4a5b-96c8-485f5ec5827f",
 CellID->1918140120],
Cell[13965, 416, 442, 10, 19, "ProofText", "ExpressionUUID" -> \
"e1e0466f-5800-42d4-b242-f39c2c63b918",
 CellID->8562551]
}
]
*)

