(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12657,        368]
NotebookOptionsPosition[     10694,        315]
NotebookOutlinePosition[     11298,        335]
CellTagsIndexPosition[     11255,        332]
WindowTitle->Proof of (\:2227 cong reverse)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121201148778*^9, 3.71912121131124*^9}},
 CellID->765469584,ExpressionUUID->"7553545b-01d9-4bc3-9329-f661b033eac9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[DoubleLeftRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
        SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
       TagBox[
        StyleBox["P1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191212135300817`*^9, 3.71912123816916*^9}, {
  3.719121610881322*^9, 3.719121619192259*^9}},
 CellID->683052546,ExpressionUUID->"011ef583-c029-47fe-ab7e-cc3ad6f978a3"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[DoubleLeftRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
     SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<1\>\""}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121243878694*^9, 3.719121257233068*^9}},
 CellID->220687556,ExpressionUUID->"c2e3a6d1-6ae1-42c9-9287-0b727c4acfa5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121260930977*^9, 3.7191212791537457`*^9}, 
   3.7191215328384542`*^9, {3.719121629649829*^9, 3.719121631414751*^9}},
 CellID->1360056999,ExpressionUUID->"1511ed37-745f-4f95-a96c-1ed771c8b21e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "and", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191212923966217`*^9, 3.719121306480235*^9}, {
  3.719121634023925*^9, 3.71912163563948*^9}},
 CellID->449150412,ExpressionUUID->"2a709ab2-9e9a-4b50-ac68-6959ecbddaf0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121354610817*^9, 3.719121474006591*^9}, {
  3.7191216554146557`*^9, 3.719121684791936*^9}},
 CellID->1195279824,ExpressionUUID->"0d1e9eb8-e144-4cca-abd6-710f7a6cb90c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "show", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\"\<2\>\"", " ", 
      FormBox[
       StyleBox["Q1", "ExpressionABF"],
       TheoremaForm]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191214837675753`*^9, 3.719121500652739*^9}, {
  3.719121665785116*^9, 3.719121671594812*^9}},
 CellID->188068431,ExpressionUUID->"22e799c0-4b43-4047-99a3-0136247e9e72"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"qed", " ", "fact"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191216926922293`*^9, 3.719121695215074*^9}},
 CellID->297227332,ExpressionUUID->"44244e36-4910-46b0-b84b-74fb080ee711"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719121504394182*^9, 3.7191215123567533`*^9}, {
  3.719121700040523*^9, 3.7191217022708893`*^9}},
 CellID->58463468,ExpressionUUID->"9713a8ec-442b-4f26-81ff-711470e9c726"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191215159600983`*^9, 3.7191215281860123`*^9}},
 CellID->1519183345,ExpressionUUID->"780ce621-f35f-4ecf-8ec3-ffe711d02b2d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "and", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", "all"}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191212923966217`*^9, 3.719121306480235*^9}, {
  3.719121545175803*^9, 3.719121545479727*^9}},
 CellID->1985161290,ExpressionUUID->"58a74b7e-bf1a-44f1-86da-6b32f5665a70"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
      SyntaxForm->"x\[And]y"], 
     TagBox[
      StyleBox["Q1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", ",", " ", 
     RowBox[{"simp", ":", " ", 
      RowBox[{"\"\<2\>\"", " ", 
       FormBox[
        StyleBox["P1", "ExpressionABF"],
        TheoremaForm], " ", 
       FormBox[
        StyleBox["Q1", "ExpressionABF"],
        TheoremaForm]}]}], ",", " ", "fact"}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719121354610817*^9, 3.719121474006591*^9}, {
  3.719121549425132*^9, 3.7191215739890614`*^9}, {3.719121713684181*^9, 
  3.7191217248470707`*^9}},
 CellID->739325661,ExpressionUUID->"46466a52-800f-49b8-9a36-c1e0fec132cd"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[And] cong reverse)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 517, 17, 20, "ProofText", "ExpressionUUID" -> \
"7553545b-01d9-4bc3-9329-f661b033eac9",
 CellID->765469584],
Cell[1122, 40, 1959, 51, 20, "ProofText", "ExpressionUUID" -> \
"011ef583-c029-47fe-ab7e-cc3ad6f978a3",
 CellID->683052546],
Cell[3084, 93, 1656, 47, 39, "ProofText", "ExpressionUUID" -> \
"c2e3a6d1-6ae1-42c9-9287-0b727c4acfa5",
 CellID->220687556],
Cell[4743, 142, 858, 22, 20, "ProofText", "ExpressionUUID" -> \
"1511ed37-745f-4f95-a96c-1ed771c8b21e",
 CellID->1360056999],
Cell[5604, 166, 511, 14, 18, "ProofText", "ExpressionUUID" -> \
"2a709ab2-9e9a-4b50-ac68-6959ecbddaf0",
 CellID->449150412],
Cell[6118, 182, 850, 22, 39, "ProofText", "ExpressionUUID" -> \
"0d1e9eb8-e144-4cca-abd6-710f7a6cb90c",
 CellID->1195279824],
Cell[6971, 206, 624, 18, 18, "ProofText", "ExpressionUUID" -> \
"22e799c0-4b43-4047-99a3-0136247e9e72",
 CellID->188068431],
Cell[7598, 226, 240, 5, 18, "ProofText", "ExpressionUUID" -> \
"44244e36-4910-46b0-b84b-74fb080ee711",
 CellID->297227332],
Cell[7841, 233, 271, 5, 18, "ProofText", "ExpressionUUID" -> \
"9713a8ec-442b-4f26-81ff-711470e9c726",
 CellID->58463468],
Cell[8115, 240, 787, 21, 20, "ProofText", "ExpressionUUID" -> \
"780ce621-f35f-4ecf-8ec3-ffe711d02b2d",
 CellID->1519183345],
Cell[8905, 263, 514, 14, 18, "ProofText", "ExpressionUUID" -> \
"58a74b7e-bf1a-44f1-86da-6b32f5665a70",
 CellID->1985161290],
Cell[9422, 279, 1268, 34, 20, "ProofText", "ExpressionUUID" -> \
"46466a52-800f-49b8-9a36-c1e0fec132cd",
 CellID->739325661]
}
]
*)

