(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5388,        160]
NotebookOptionsPosition[      4064,        122]
NotebookOutlinePosition[      4658,        142]
CellTagsIndexPosition[      4615,        139]
WindowTitle->Proof of (classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451180421047*^9, 3.718451183552985*^9}},
 CellID->1884693144,ExpressionUUID->"196b5a6d-6c3b-466b-8a41-d3670092c8a5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451348995428*^9, 3.718451361124477*^9}},
 CellID->1093675436,ExpressionUUID->"4f40812c-2976-44a6-a5d7-ec176129b64b"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184512053962173`*^9, 3.718451246442074*^9}, {
  3.718451344395859*^9, 3.7184513471409073`*^9}},
 CellID->1490564116,ExpressionUUID->"868e9ff7-95f5-40e2-94c3-e8113ad85c9e"],

Cell[BoxData[{
 RowBox[{"thus", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451248761405*^9, 3.718451251347093*^9}, {
  3.718451370052618*^9, 3.718451383769904*^9}},
 CellID->232514071,ExpressionUUID->"929cb98d-95d9-4164-8309-d6ee9f512e19"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451388196224*^9, 3.718451396655272*^9}},
 CellID->1675509838,ExpressionUUID->"2f42bd20-7ee0-4c60-a000-cd15a6d9fcf1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451403906578*^9, 3.718451418764189*^9}},
 CellID->1566193250,ExpressionUUID->"0b1a8f37-2f3e-4361-9601-5677acb1c10e"],

Cell[BoxData["qed"], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7184514230697947`*^9, 3.7184514234208527`*^9}},
 CellID->788166925,ExpressionUUID->"5ceaf429-2953-4b19-82be-2266e6e47a0d"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 298, 8, 20, "ProofText", "ExpressionUUID" -> \
"196b5a6d-6c3b-466b-8a41-d3670092c8a5",
 CellID->1884693144],
Cell[893, 31, 1106, 31, 20, "ProofText", "ExpressionUUID" -> \
"4f40812c-2976-44a6-a5d7-ec176129b64b",
 CellID->1093675436],
Cell[2002, 64, 620, 16, 18, "ProofText", "ExpressionUUID" -> \
"868e9ff7-95f5-40e2-94c3-e8113ad85c9e",
 CellID->1490564116],
Cell[2625, 82, 283, 5, 39, "ProofText", "ExpressionUUID" -> \
"929cb98d-95d9-4164-8309-d6ee9f512e19",
 CellID->232514071],
Cell[2911, 89, 412, 11, 20, "ProofText", "ExpressionUUID" -> \
"2f42bd20-7ee0-4c60-a000-cd15a6d9fcf1",
 CellID->1675509838],
Cell[3326, 102, 441, 11, 18, "ProofText", "ExpressionUUID" -> \
"0b1a8f37-2f3e-4361-9601-5677acb1c10e",
 CellID->1566193250],
Cell[3770, 115, 290, 5, 19, "ProofText", "ExpressionUUID" -> \
"5ceaf429-2953-4b19-82be-2266e6e47a0d",
 CellID->788166925]
}
]
*)

