(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15821,        465]
NotebookOptionsPosition[     13987,        415]
NotebookOutlinePosition[     14579,        435]
CellTagsIndexPosition[     14536,        432]
WindowTitle->Proof of (If cond)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903323764879*^9, 3.719033245403179*^9}},
 CellID->299966502,ExpressionUUID->"52df9606-2a49-46e4-8e4d-39b9e52655ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033248037077*^9, 3.719033252027577*^9}},
 CellID->1131339139,ExpressionUUID->"cb10edad-1ad3-4945-a0a5-1f70d6e47e2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["Q", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", 
      TagBox[
       StyleBox["z", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["z", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
           TagBox["\[Equal]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[Equal]y"], 
           TagBox[
            StyleBox["x", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
          TagBox[")",
           "AutoParentheses"]}]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[And]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
        SyntaxForm->"x\[And]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox["\[Not]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
            SyntaxForm->"\[Not]x"], 
           TagBox[
            StyleBox["P", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
          TagBox[")",
           "AutoParentheses"]}], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["z", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
           TagBox["\[Equal]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[Equal]y"], 
           TagBox[
            StyleBox["y", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
          TagBox[")",
           "AutoParentheses"]}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033381733161*^9, 3.719033408616609*^9}},
 CellID->1435251069,ExpressionUUID->"06295983-21ea-433a-9681-418e9d69275c"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["Q", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["Q", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<SomeI\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033422274084*^9, 3.719033447096874*^9}},
 CellID->312787261,ExpressionUUID->"42cf0409-4584-46a3-8050-314f8d31992f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          FormBox[
           StyleBox["x", "ExpressionABF"],
           TheoremaForm], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox["\[Not]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
           SyntaxForm->"\[Not]x"], 
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          FormBox[
           StyleBox["x", "ExpressionABF"],
           TheoremaForm], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["y", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
     "intro", " ", "\"\<\[And]I\>\"", " ", "\"\<\[Implies]I\>\"", " ", 
      "\"\<\[Equal] refl\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033466163023*^9, 3.719033559362998*^9}},
 CellID->488368440,ExpressionUUID->"44c2cd20-e051-4212-a8ae-ad02998e2fea"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033563862568*^9, 3.719033575261362*^9}},
 CellID->171964964,ExpressionUUID->"e853ec65-94fb-4e3b-a41b-c5847d25b2e4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Equal]y"], 
      TagBox[
       StyleBox["y", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
     "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033577901331*^9, 3.719033593639833*^9}},
 CellID->1452130334,ExpressionUUID->"db54d655-e1f8-4ee8-a68c-0c3790a761ab"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033598312675*^9, 3.719033604754583*^9}},
 CellID->1785015531,ExpressionUUID->"0fc9203b-3f12-4435-aa6c-73b435a6b542"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["Some",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`Some$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], "[", 
        FormBox[
         StyleBox["Q", "ExpressionSyntactic"],
         TheoremaForm], "]"}], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
  ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033629840768*^9, 3.719033651170896*^9}},
 CellID->1206170958,ExpressionUUID->"4ac78fe2-304b-450c-b8d0-63d21a22edb1"],

Cell[BoxData[
 RowBox[{"with", " ", 
  FormBox[
   StyleBox["P", "ExpressionABF"],
   TheoremaForm], " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["Q", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "\[Equal]", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<modus ponens reverse\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903367515236*^9, 3.7190337187643013`*^9}},
 CellID->651183493,ExpressionUUID->"4b15e3e5-5aa0-40f2-9457-0c7b6ba7291b"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], ",", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], ",", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm]}], "]"}], "\[Equal]", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<If def\>\"", " ", "by", " ", "fact"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7190332561633987`*^9, 3.719033284646645*^9}, {
  3.719033735476424*^9, 3.719033743180622*^9}},
 CellID->675109028,ExpressionUUID->"f3ca3dd1-e61d-40fc-8779-fc62d2cbcba2"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If cond)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 442, 14, 20, "ProofText", "ExpressionUUID" -> \
"52df9606-2a49-46e4-8e4d-39b9e52655ae",
 CellID->299966502],
Cell[1035, 37, 301, 8, 20, "ProofText", "ExpressionUUID" -> \
"cb10edad-1ad3-4945-a0a5-1f70d6e47e2a",
 CellID->1131339139],
Cell[1339, 47, 3897, 109, 28, "ProofText", "ExpressionUUID" -> \
"06295983-21ea-433a-9681-418e9d69275c",
 CellID->1435251069],
Cell[5239, 158, 583, 16, 39, "ProofText", "ExpressionUUID" -> \
"42cf0409-4584-46a3-8050-314f8d31992f",
 CellID->312787261],
Cell[5825, 176, 3348, 97, 39, "ProofText", "ExpressionUUID" -> \
"44c2cd20-e051-4212-a8ae-ad02998e2fea",
 CellID->488368440],
Cell[9176, 275, 415, 11, 20, "ProofText", "ExpressionUUID" -> \
"e853ec65-94fb-4e3b-a41b-c5847d25b2e4",
 CellID->171964964],
Cell[9594, 288, 1062, 27, 18, "ProofText", "ExpressionUUID" -> \
"db54d655-e1f8-4ee8-a68c-0c3790a761ab",
 CellID->1452130334],
Cell[10659, 317, 276, 6, 39, "ProofText", "ExpressionUUID" -> \
"0fc9203b-3f12-4435-aa6c-73b435a6b542",
 CellID->1785015531],
Cell[10938, 325, 1511, 41, 18, "ProofText", "ExpressionUUID" -> \
"4ac78fe2-304b-450c-b8d0-63d21a22edb1",
 CellID->1206170958],
Cell[12452, 368, 664, 19, 18, "ProofText", "ExpressionUUID" -> \
"4b15e3e5-5aa0-40f2-9457-0c7b6ba7291b",
 CellID->651183493],
Cell[13119, 389, 864, 24, 20, "ProofText", "ExpressionUUID" -> \
"f3ca3dd1-e61d-40fc-8779-fc62d2cbcba2",
 CellID->675109028]
}
]
*)

