(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14025,        389]
NotebookOptionsPosition[     12193,        339]
NotebookOutlinePosition[     12790,        359]
CellTagsIndexPosition[     12747,        356]
WindowTitle->Proof of (\:F431 fun)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["g", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042396925531*^9, 3.7190424199280787`*^9}},
 CellID->1444424836,ExpressionUUID->"bc14b8e9-292b-4bf7-a671-a8be3de721e3"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042423986183*^9, 3.7190424262568417`*^9}},
 CellID->252852372,ExpressionUUID->"a675bb77-5553-4d50-902f-dca5ddacf496"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], " ", "\[Equal]", " ", 
      FormBox[
       StyleBox["g", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042428644232*^9, 3.719042441462369*^9}},
 CellID->1380464751,ExpressionUUID->"2fb906a2-737d-4a89-921c-443e8599ff0e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       RowBox[{
        TagBox[
         StyleBox["g", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042447316874*^9, 3.719042466577593*^9}},
 CellID->171015520,ExpressionUUID->"156659e9-b510-414d-9ade-0aaf5a52a08e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190424684168663`*^9, 3.719042472694783*^9}},
 CellID->170766346,ExpressionUUID->"c29620a0-2d4f-4fff-bd60-5896211b0eca"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["f", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["g", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      "[", 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], 
     TagBox["\[Equal]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->"x\[Equal]y"], 
     RowBox[{
      TagBox[
       StyleBox["g", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      "[", 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042477977069*^9, 3.719042509513877*^9}},
 CellID->1951755585,ExpressionUUID->"b50d4d07-a7df-4c00-b9b9-40cd68ccd9ce"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042513313097*^9, 3.719042526346463*^9}},
 CellID->780947962,ExpressionUUID->"44bb828a-0109-471e-90b7-2cd8c221c0d9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       RowBox[{
        TagBox[
         StyleBox["g", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042530375267*^9, 3.719042540880265*^9}, {
  3.7190425870649433`*^9, 3.7190425879711723`*^9}},
 CellID->1313504076,ExpressionUUID->"8ad1351c-c5c3-4184-bdf7-b61d3cbac2e5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]],
       SyntaxForm->"x\[Equal]y"], 
      TagBox[
       StyleBox["g", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]}],
      "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Equal] ext\>\""}], ")"}]}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719042554018423*^9, 3.719042571339115*^9}},
 CellID->268316737,ExpressionUUID->"a0bdd2a3-0169-4c7f-9722-c5bbe76cda75"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719042577159239*^9, 3.719042582069665*^9}},
 CellID->764270399,ExpressionUUID->"a96bc3f0-716a-46e8-accc-9bcdfbeb3edb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
       SyntaxForm->"x\[Equal]y"], 
      RowBox[{
       TagBox[
        StyleBox["g", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719042592049526*^9, 3.71904260470721*^9}},
 CellID->592269226,ExpressionUUID->"0786a19c-67d5-40ef-a1de-60e9ce83dca1"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Equal] fun)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 373, 11, 20, "ProofText", "ExpressionUUID" -> \
"bc14b8e9-292b-4bf7-a671-a8be3de721e3",
 CellID->1444424836],
Cell[969, 34, 236, 4, 39, "ProofText", "ExpressionUUID" -> \
"a675bb77-5553-4d50-902f-dca5ddacf496",
 CellID->252852372],
Cell[1208, 40, 501, 14, 20, "ProofText", "ExpressionUUID" -> \
"2fb906a2-737d-4a89-921c-443e8599ff0e",
 CellID->1380464751],
Cell[1712, 56, 2187, 56, 50, "ProofText", "ExpressionUUID" -> \
"156659e9-b510-414d-9ade-0aaf5a52a08e",
 CellID->171015520],
Cell[3902, 114, 324, 9, 20, "ProofText", "ExpressionUUID" -> \
"c29620a0-2d4f-4fff-bd60-5896211b0eca",
 CellID->170766346],
Cell[4229, 125, 1891, 51, 18, "ProofText", "ExpressionUUID" -> \
"b50d4d07-a7df-4c00-b9b9-40cd68ccd9ce",
 CellID->1951755585],
Cell[6123, 178, 276, 6, 39, "ProofText", "ExpressionUUID" -> \
"44bb828a-0109-471e-90b7-2cd8c221c0d9",
 CellID->780947962],
Cell[6402, 186, 2259, 57, 28, "ProofText", "ExpressionUUID" -> \
"8ad1351c-c5c3-4184-bdf7-b61d3cbac2e5",
 CellID->1313504076],
Cell[8664, 245, 1401, 34, 39, "ProofText", "ExpressionUUID" -> \
"a0bdd2a3-0169-4c7f-9722-c5bbe76cda75",
 CellID->268316737],
Cell[10068, 281, 322, 9, 20, "ProofText", "ExpressionUUID" -> \
"a96bc3f0-716a-46e8-accc-9bcdfbeb3edb",
 CellID->764270399],
Cell[10393, 292, 1796, 45, 19, "ProofText", "ExpressionUUID" -> \
"0786a19c-67d5-40ef-a1de-60e9ce83dca1",
 CellID->592269226]
}
]
*)

