(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     23552,        690]
NotebookOptionsPosition[     19443,        586]
NotebookOutlinePosition[     20057,        606]
CellTagsIndexPosition[     20014,        603]
WindowTitle->Proof of (\254\:21D4)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036779115632*^9, 3.719036784099112*^9}},
 CellID->543937458,ExpressionUUID->"b9eee171-61b1-4973-9573-a2d8c4a8227c"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036786718067*^9, 3.719036789146389*^9}},
 CellID->495918783,ExpressionUUID->"1c7c973a-22e0-40a7-b14f-0c5d6b146eeb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[NotEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
        Theorema`Language`Unequal$TM, {Theorema`Knowledge`BOOL$TM}]],
       SyntaxForm->"x\[NotEqual]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036791031755*^9, 3.719036800006998*^9}},
 CellID->1111798665,ExpressionUUID->"ee831e74-ae44-4f2f-b801-51c469e679b2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036805703685*^9, 3.719036818394505*^9}},
 CellID->1428958611,ExpressionUUID->"4531c62a-eac1-4e89-9a56-0bc6e5bc8109"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036826136036*^9, 3.719036833151581*^9}},
 CellID->509271159,ExpressionUUID->"442804fb-6a22-41a6-8e30-70380dc7f743"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036842821003*^9, 3.719036854491296*^9}},
 CellID->1029626211,ExpressionUUID->"40d6f504-3e24-4b88-bbeb-a02fe7da0b14"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036859546185*^9, 3.719036864821376*^9}},
 CellID->836765907,ExpressionUUID->"6fbfe854-bb4f-4c80-8119-dc9ee98e4e74"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[DoubleLeftRightArrow]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", ",", " ", 
     RowBox[{"intro", " ", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], ",", " ", 
     RowBox[{"intro", " ", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036876960375*^9, 3.719036899467705*^9}, {
  3.719038870068594*^9, 3.7190389191352167`*^9}},
 CellID->730265384,ExpressionUUID->"b5d6563a-ed78-490a-8dc1-2678dced70f1"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719036907033484*^9, 3.719036931104602*^9}},
 CellID->378033369,ExpressionUUID->"d1d4c2d6-d0b8-4638-89c8-2ea739e9b20e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719038828294043*^9, 3.71903883514032*^9}},
 CellID->863715156,ExpressionUUID->"30b58928-6e0d-4a93-a5cf-6f6e4b7c036c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719038838175096*^9, 3.719038847812792*^9}},
 CellID->202041604,ExpressionUUID->"974b19b8-bf23-48f3-87b6-125a18553633"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<classical contradiction\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039061618805*^9, 3.7190390820184793`*^9}},
 CellID->1956695657,ExpressionUUID->"0e41453f-df84-4130-a83d-89352d0754ef"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190390861275787`*^9, 3.719039095943781*^9}},
 CellID->761178872,ExpressionUUID->"e5b1b035-ea61-46e0-bc6a-765e04803a50"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[DoubleLeftRightArrow]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719038927971537*^9, 3.719038946922566*^9}, {
  3.719039101295144*^9, 3.7190391203314*^9}},
 CellID->970666452,ExpressionUUID->"e7f92a60-50da-47c6-ac38-f6354fa05572"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039125717657*^9, 3.71903914386344*^9}},
 CellID->1394931104,ExpressionUUID->"187678f9-93b9-4a86-b335-dbba37ad212f"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039138457732*^9, 3.719039158118083*^9}},
 CellID->1855347185,ExpressionUUID->"0ba6307e-3c2d-42b8-915a-b03cff536976"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039160489193*^9, 3.71903916357638*^9}},
 CellID->1626584661,ExpressionUUID->"d389581a-62e8-4602-bcbf-d224c96f8f84"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903916574048*^9, 3.719039171658225*^9}},
 CellID->1012538828,ExpressionUUID->"c02d7d2e-7486-4a44-916d-97d771213d6e"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039174180616*^9, 3.719039186287683*^9}},
 CellID->2130667203,ExpressionUUID->"dde66676-52b6-4d04-a58e-e144541607cf"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039243334618*^9, 3.719039246752686*^9}},
 CellID->874074332,ExpressionUUID->"fd13d71c-3b40-478d-aecc-e36493f3239c"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190392529355087`*^9, 3.7190392731844893`*^9}},
 CellID->2065397621,ExpressionUUID->"e17c8edb-9159-4fa7-8084-4163eb0923c7"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190392781421747`*^9, 3.7190392939139*^9}},
 CellID->571290834,ExpressionUUID->"6d792340-a985-4fa1-8403-adf3a33372df"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190392990714273`*^9, 3.719039308234034*^9}},
 CellID->609932442,ExpressionUUID->"5efd14a7-8452-4e00-b648-03cadf82793b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[NotEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
        Theorema`Language`Unequal$TM, {Theorema`Knowledge`BOOL$TM}]],
       SyntaxForm->"x\[NotEqual]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039316926374*^9, 3.7190393292814083`*^9}},
 CellID->1142737730,ExpressionUUID->"cc3f68d6-81ac-43f6-a44a-14655acf2763"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039460757893*^9, 3.719039474567788*^9}},
 CellID->464044799,ExpressionUUID->"5c178b09-4ec6-467e-b77d-45cccfe0d383"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[DoubleLeftRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
      SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[Not]", 
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm]}], ")"}], "\[DoubleLeftRightArrow]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190395127204437`*^9, 3.719039568444909*^9}},
 CellID->2130806084,ExpressionUUID->"a5533734-93a2-43b5-9891-ab8c475f9556"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], "\n", 
   "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]E classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903957860842*^9, 3.7190395932293043`*^9}, {
  3.719039680263196*^9, 3.719039680399963*^9}},
 CellID->1426248798,ExpressionUUID->"57688d88-d527-411a-8114-3737d3038152"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox["False",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[False, {}]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719039682820675*^9, 3.719039706478899*^9}},
 CellID->1007982258,ExpressionUUID->"ad7d9998-fc77-4253-8538-43b457ac7ed4"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox["\[Not]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
          SyntaxForm->"\[Not]x"], 
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
        TagBox[")",
         "AutoParentheses"]}]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox["\[Not]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
          SyntaxForm->"\[Not]x"], 
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox["False",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[False, {}]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719039708870776*^9, 3.719039738143407*^9}},
 CellID->479241220,ExpressionUUID->"9908be71-1254-401c-b0f8-644feaa7b727"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Not]\[DoubleLeftRightArrow])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 370, 11, 20, "ProofText", "ExpressionUUID" -> \
"b9eee171-61b1-4973-9573-a2d8c4a8227c",
 CellID->543937458],
Cell[966, 34, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"1c7c973a-22e0-40a7-b14f-0c5d6b146eeb",
 CellID->495918783],
Cell[1203, 40, 830, 22, 20, "ProofText", "ExpressionUUID" -> \
"ee831e74-ae44-4f2f-b801-51c469e679b2",
 CellID->1111798665],
Cell[2036, 64, 1127, 31, 39, "ProofText", "ExpressionUUID" -> \
"4531c62a-eac1-4e89-9a56-0bc6e5bc8109",
 CellID->1428958611],
Cell[3166, 97, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"442804fb-6a22-41a6-8e30-70380dc7f743",
 CellID->509271159],
Cell[3492, 108, 436, 12, 39, "ProofText", "ExpressionUUID" -> \
"40d6f504-3e24-4b88-bbeb-a02fe7da0b14",
 CellID->1029626211],
Cell[3931, 122, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"6fbfe854-bb4f-4c80-8119-dc9ee98e4e74",
 CellID->836765907],
Cell[4261, 133, 830, 24, 20, "ProofText", "ExpressionUUID" -> \
"b5d6563a-ed78-490a-8dc1-2678dced70f1",
 CellID->730265384],
Cell[5094, 159, 592, 16, 18, "ProofText", "ExpressionUUID" -> \
"d1d4c2d6-d0b8-4638-89c8-2ea739e9b20e",
 CellID->378033369],
Cell[5689, 177, 283, 6, 39, "ProofText", "ExpressionUUID" -> \
"30b58928-6e0d-4a93-a5cf-6f6e4b7c036c",
 CellID->863715156],
Cell[5975, 185, 413, 11, 20, "ProofText", "ExpressionUUID" -> \
"974b19b8-bf23-48f3-87b6-125a18553633",
 CellID->202041604],
Cell[6391, 198, 458, 13, 39, "ProofText", "ExpressionUUID" -> \
"0e41453f-df84-4130-a83d-89352d0754ef",
 CellID->1956695657],
Cell[6852, 213, 419, 11, 20, "ProofText", "ExpressionUUID" -> \
"e5b1b035-ea61-46e0-bc6a-765e04803a50",
 CellID->761178872],
Cell[7274, 226, 580, 16, 39, "ProofText", "ExpressionUUID" -> \
"e7f92a60-50da-47c6-ac38-f6354fa05572",
 CellID->970666452],
Cell[7857, 244, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"187678f9-93b9-4a86-b335-dbba37ad212f",
 CellID->1394931104],
Cell[8187, 255, 451, 12, 18, "ProofText", "ExpressionUUID" -> \
"0ba6307e-3c2d-42b8-915a-b03cff536976",
 CellID->1855347185],
Cell[8641, 269, 242, 5, 18, "ProofText", "ExpressionUUID" -> \
"d389581a-62e8-4602-bcbf-d224c96f8f84",
 CellID->1626584661],
Cell[8886, 276, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"c02d7d2e-7486-4a44-916d-97d771213d6e",
 CellID->1012538828],
Cell[9216, 287, 451, 12, 18, "ProofText", "ExpressionUUID" -> \
"dde66676-52b6-4d04-a58e-e144541607cf",
 CellID->2130667203],
Cell[9670, 301, 241, 5, 18, "ProofText", "ExpressionUUID" -> \
"fd13d71c-3b40-478d-aecc-e36493f3239c",
 CellID->874074332],
Cell[9914, 308, 597, 16, 18, "ProofText", "ExpressionUUID" -> \
"e17c8edb-9159-4fa7-8084-4163eb0923c7",
 CellID->2065397621],
Cell[10514, 326, 322, 7, 59, "ProofText", "ExpressionUUID" -> \
"6d792340-a985-4fa1-8403-adf3a33372df",
 CellID->571290834],
Cell[10839, 335, 1112, 31, 20, "ProofText", "ExpressionUUID" -> \
"5efd14a7-8452-4e00-b648-03cadf82793b",
 CellID->609932442],
Cell[11954, 368, 848, 22, 39, "ProofText", "ExpressionUUID" -> \
"cc3f68d6-81ac-43f6-a44a-14655acf2763",
 CellID->1142737730],
Cell[12805, 392, 818, 21, 20, "ProofText", "ExpressionUUID" -> \
"5c178b09-4ec6-467e-b77d-45cccfe0d383",
 CellID->464044799],
Cell[13626, 415, 1420, 40, 18, "ProofText", "ExpressionUUID" -> \
"a5533734-93a2-43b5-9891-ab8c475f9556",
 CellID->2130806084],
Cell[15049, 457, 517, 13, 39, "ProofText", "ExpressionUUID" -> \
"57688d88-d527-411a-8114-3737d3038152",
 CellID->1426248798],
Cell[15569, 472, 1580, 44, 18, "ProofText", "ExpressionUUID" -> \
"ad7d9998-fc77-4253-8538-43b457ac7ed4",
 CellID->1007982258],
Cell[17152, 518, 2287, 66, 19, "ProofText", "ExpressionUUID" -> \
"9908be71-1254-401c-b0f8-644feaa7b727",
 CellID->479241220]
}
]
*)

