(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20315,        560]
NotebookOptionsPosition[     18474,        510]
NotebookOutlinePosition[     19074,        530]
CellTagsIndexPosition[     19031,        527]
WindowTitle->Proof of (\:2203C comm)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q2", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71922106384249*^9, 3.719221075370769*^9}},
 CellID->4357136,ExpressionUUID->"043ba690-aeff-411d-8a91-a3a9e2c11630"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192210793882103`*^9, 3.7192210813129463`*^9}},
 CellID->1262790837,ExpressionUUID->"52dbb9ab-bd72-412e-bda9-6e432b0e17e4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       GridBox[{
         {
          RowBox[{
           TagBox[
            StyleBox["Q1", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]},
         {
          RowBox[{
           TagBox[
            StyleBox["Q2", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
               Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x0", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}]}
        }]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], ",", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719221090063382*^9, 3.71922110096487*^9}, {
  3.719651960704323*^9, 3.7196519675856247`*^9}},
 CellID->750516444,ExpressionUUID->"3a590068-73d4-4012-ad59-42d6a3d44150"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q1", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["Q2", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], ",", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651974815666*^9, 3.7196520111846943`*^9}},
 CellID->1507019550,ExpressionUUID->"ce7235c2-0df1-4136-b6db-4e8b3d4afd5a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
    " ", "obtain", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q2", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm]}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719652015920911*^9, 3.719652050204856*^9}},
 CellID->1791899018,ExpressionUUID->"95f446d6-c141-4c7b-b72a-5891e12685b3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      GridBox[{
        {
         RowBox[{
          TagBox[
           StyleBox["Q2", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["y", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]],
           "]"}]},
        {
         RowBox[{
          TagBox[
           StyleBox["Q1", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}
       }]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]]], "[", 
      RowBox[{
       StyleBox["x", "ExpressionVariable"], ",", 
       StyleBox["y", "ExpressionVariable"]}], "]"}]}], "\[CloseCurlyQuote]"}],
    " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"intro", " ", "\"\<\[Exists]CI\>\""}], ",", " ", 
     SuperscriptBox["fact", "+"]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192211032963533`*^9, 3.719221117385598*^9}, {
  3.719652056499517*^9, 3.7196520809611*^9}},
 CellID->1737050079,ExpressionUUID->"3e84ac2b-43f7-46bf-82f3-cb7bdb532534"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719289741126137*^9, 3.719289748250708*^9}, 
   3.719652087753314*^9},
 CellID->302706310,ExpressionUUID->"b80f44d9-c702-4b66-8d1e-99d43afb34e0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        GridBox[{
         {
          RowBox[{
           TagBox[
            StyleBox["Q2", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
               Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["y", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}]},
         {
          RowBox[{
           TagBox[
            StyleBox["Q1", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}
        }]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], ",", 
        StyleBox["y", "ExpressionVariable"]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719289749945249*^9, 3.7192897645067663`*^9}, {
  3.719652091481736*^9, 3.719652094658101*^9}},
 CellID->945286431,ExpressionUUID->"929b818a-bc15-40f7-81a2-41288b9c198a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q2", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["Q1", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        ",", 
        FormBox[
         StyleBox["y", "ExpressionABF"],
         TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719651974815666*^9, 3.7196520111846943`*^9}, {
  3.719652110707448*^9, 3.719652126792984*^9}},
 CellID->703736286,ExpressionUUID->"7e5e3967-50ce-4e23-b32a-4bf3908e4db3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
    " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q1", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm]}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719652015920911*^9, 3.719652050204856*^9}, {
  3.719652130340355*^9, 3.719652134388258*^9}},
 CellID->901207275,ExpressionUUID->"bda10cc5-cdac-4794-9e04-3245755fbb14"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      GridBox[{
        {
         RowBox[{
          TagBox[
           StyleBox["Q1", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]],
           "]"}]},
        {
         RowBox[{
          TagBox[
           StyleBox["Q2", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["y", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}
       }]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]]], "[", 
      RowBox[{
       StyleBox["x", "ExpressionVariable"], ",", 
       StyleBox["y", "ExpressionVariable"]}], "]"}]}], "\[CloseCurlyQuote]"}],
    " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"intro", " ", "\"\<\[Exists]CI\>\""}], ",", " ", 
     SuperscriptBox["fact", "+"]}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7192211032963533`*^9, 3.719221117385598*^9}, {
  3.719652056499517*^9, 3.7196520809611*^9}, {3.719652146615597*^9, 
  3.7196521653837757`*^9}},
 CellID->954124531,ExpressionUUID->"8eac9b3d-7f7b-4f9b-912b-e9414d0f2368"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]C comm)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 442, 14, 20, "ProofText", "ExpressionUUID" -> \
"043ba690-aeff-411d-8a91-a3a9e2c11630",
 CellID->4357136],
Cell[1040, 37, 239, 4, 39, "ProofText", "ExpressionUUID" -> \
"52dbb9ab-bd72-412e-bda9-6e432b0e17e4",
 CellID->1262790837],
Cell[1282, 43, 2591, 65, 47, "ProofText", "ExpressionUUID" -> \
"3a590068-73d4-4012-ad59-42d6a3d44150",
 CellID->750516444],
Cell[3876, 110, 2280, 60, 34, "ProofText", "ExpressionUUID" -> \
"ce7235c2-0df1-4136-b6db-4e8b3d4afd5a",
 CellID->1507019550],
Cell[6159, 172, 1052, 32, 20, "ProofText", "ExpressionUUID" -> \
"95f446d6-c141-4c7b-b72a-5891e12685b3",
 CellID->1791899018],
Cell[7214, 206, 2498, 64, 43, "ProofText", "ExpressionUUID" -> \
"3e84ac2b-43f7-46bf-82f3-cb7bdb532534",
 CellID->1737050079],
Cell[9715, 272, 245, 5, 18, "ProofText", "ExpressionUUID" -> \
"b80f44d9-c702-4b66-8d1e-99d43afb34e0",
 CellID->302706310],
Cell[9963, 279, 2425, 61, 43, "ProofText", "ExpressionUUID" -> \
"929b818a-bc15-40f7-81a2-41288b9c198a",
 CellID->945286431],
Cell[12391, 342, 2333, 62, 34, "ProofText", "ExpressionUUID" -> \
"7e5e3967-50ce-4e23-b32a-4bf3908e4db3",
 CellID->703736286],
Cell[14727, 406, 1100, 33, 20, "ProofText", "ExpressionUUID" -> \
"bda10cc5-cdac-4794-9e04-3245755fbb14",
 CellID->901207275],
Cell[15830, 441, 2640, 67, 43, "ProofText", "ExpressionUUID" -> \
"8eac9b3d-7f7b-4f9b-912b-e9414d0f2368",
 CellID->954124531]
}
]
*)

