(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14953,        429]
NotebookOptionsPosition[     13496,        388]
NotebookOutlinePosition[     14093,        408]
CellTagsIndexPosition[     14050,        405]
WindowTitle->Proof of (\:2203!CE)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"simp", ":", " ", "\"\<\[Exists]! def\>\""}], ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Exists]CE\>\"", " ", "\"\<\[And]E\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153381963072443`*^9, 3.715338290033827*^9}, 
   3.715338712247045*^9},
 CellID->915965383,ExpressionUUID->"b7abd777-9db0-4103-b5bc-c0936d5ef2bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338304215048*^9, 3.7153383145912046`*^9}, {
  3.7153387183428793`*^9, 3.7153387202528*^9}},
 CellID->916674552,ExpressionUUID->"09fd2518-c029-4907-89b4-4efaae73c8bd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox[
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     TagBox[
      StyleBox["x", "ExpressionVariable"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", "x", "]"}], "\[LongRightArrow]", 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox[
           TagBox["\[And]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
           TagBox[
            StyleBox["y", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
          RowBox[{
           RowBox[{
            FormBox[
             StyleBox["Q", "ExpressionABF"],
             TheoremaForm], "[", "y", "]"}], "\[LongRightArrow]", 
           RowBox[{
            TagBox[
             StyleBox["P", "ExpressionABF"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`FUN$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                Theorema`Knowledge`BOOL$TM]]]], "[", 
            TagBox[
             StyleBox["y", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
           TagBox["\[LongRightArrow]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
             Theorema`Language`LongRightArrow$TM, {}]],
            SyntaxForm->"x\[LongRightArrow]y"], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             TagBox[
              StyleBox["y", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
             TagBox["\[Equal]",
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[Theorema`Language`EqualTilde$TM, {
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
              SyntaxForm->"x\[EqualTilde]y"], 
             TagBox[
              StyleBox["x", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
            TagBox[")",
             "AutoParentheses"]}]}]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[LongRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
         SyntaxForm->"x\[LongRightArrow]y"], 
        TagBox[
         StyleBox["R", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"and", " ", "\"\<2\>\""}], ":", " ", 
    RowBox[{
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
     "\"\<3\>\""}], ":", " ", 
    RowBox[{
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["t", "ExpressionABF"],
        TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
     "\"\<4\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        FormBox[
         StyleBox["Q", "ExpressionABF"],
         TheoremaForm], "[", "y", "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["y", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["t", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338364297616*^9, 3.715338428011204*^9}, {
  3.7153387272950487`*^9, 3.715338786342388*^9}, {3.718364916441552*^9, 
  3.718364917049334*^9}},
 CellID->943354820,ExpressionUUID->"d6c958eb-d21f-4e84-9468-e2a01a73dbd6"],

Cell[BoxData[{
 RowBox[{"from", " ", "\"\<2\>\"", " ", "\"\<3\>\"", " ", "show", " ", 
  FormBox[
   StyleBox["R", "ExpressionABF"],
   TheoremaForm]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<1\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153384380066233`*^9, 3.715338536199168*^9}, {
  3.715338797647785*^9, 3.7153387984650583`*^9}},
 CellID->729654930,ExpressionUUID->"24306e60-5a88-4449-ad2e-5a709eb1517f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338461269415*^9, 3.715338474595491*^9}, {
  3.715338540492684*^9, 3.715338544470441*^9}},
 CellID->728629593,ExpressionUUID->"e5232a53-002e-4ba1-9ccc-9c62c2ac04e3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338868690421*^9, 3.715338878993568*^9}, {
  3.715339406822777*^9, 3.715339407676339*^9}},
 CellID->7757071,ExpressionUUID->"8cb02372-db98-4602-948b-4dbb7d465f75"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<4\>\"", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
    " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm], "]"}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        FormBox[
         StyleBox["y", "ExpressionABF"],
         TheoremaForm], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715338567094481*^9, 3.715338591933588*^9}, {
  3.7153388300245934`*^9, 3.71533888493325*^9}, {3.715339410391817*^9, 
  3.715339416098789*^9}},
 CellID->1393675077,ExpressionUUID->"9150a9aa-d54c-4dcc-89de-6c2eef787049"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["t", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715338596829564*^9, 3.715338629101534*^9}, {
  3.718364924065529*^9, 3.718364924449214*^9}},
 CellID->154210399,ExpressionUUID->"035aec0d-6408-4189-9b04-c011a8fd9293"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]!CE)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 426, 10, 20, "ProofText", "ExpressionUUID" -> \
"b7abd777-9db0-4103-b5bc-c0936d5ef2bc",
 CellID->915965383],
Cell[1021, 33, 567, 18, 20, "ProofText", "ExpressionUUID" -> \
"09fd2518-c029-4907-89b4-4efaae73c8bd",
 CellID->916674552],
Cell[1591, 53, 7570, 204, 70, "ProofText", "ExpressionUUID" -> \
"d6c958eb-d21f-4e84-9468-e2a01a73dbd6",
 CellID->943354820],
Cell[9164, 259, 476, 11, 39, "ProofText", "ExpressionUUID" -> \
"24306e60-5a88-4449-ad2e-5a709eb1517f",
 CellID->729654930],
Cell[9643, 272, 369, 10, 20, "ProofText", "ExpressionUUID" -> \
"e5232a53-002e-4ba1-9ccc-9c62c2ac04e3",
 CellID->728629593],
Cell[10015, 284, 780, 23, 20, "ProofText", "ExpressionUUID" -> \
"8cb02372-db98-4602-948b-4dbb7d465f75",
 CellID->7757071],
Cell[10798, 309, 1783, 49, 18, "ProofText", "ExpressionUUID" -> \
"9150a9aa-d54c-4dcc-89de-6c2eef787049",
 CellID->1393675077],
Cell[12584, 360, 908, 26, 19, "ProofText", "ExpressionUUID" -> \
"035aec0d-6408-4189-9b04-c011a8fd9293",
 CellID->154210399]
}
]
*)

