(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14135,        412]
NotebookOptionsPosition[     11922,        353]
NotebookOutlinePosition[     12522,        373]
CellTagsIndexPosition[     12479,        370]
WindowTitle->Proof of (\:F523 cong)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116824845714*^9, 3.719116836419395*^9}},
 CellID->64885220,ExpressionUUID->"97cca5a9-fd19-45b7-96b5-9402ed546caa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[DoubleLeftRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
        SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
       TagBox[
        StyleBox["Q1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116851428802*^9, 3.7191168867559977`*^9}},
 CellID->1824970400,ExpressionUUID->"ab297c22-3e25-4d19-a7e8-d1568fc84a82"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[DoubleLeftRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
     SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<1\>\""}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116891392768*^9, 3.7191169150434933`*^9}},
 CellID->1445264721,ExpressionUUID->"ebd5c7da-a41f-44f0-8ee3-5e3d77711218"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191169186638603`*^9, 3.719116930168375*^9}},
 CellID->1695554537,ExpressionUUID->"aa58e15a-3628-43b4-8a4b-73c915ad9a10"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116935316884*^9, 3.719116946819738*^9}},
 CellID->1029536987,ExpressionUUID->"32d9557f-9272-4420-ac31-9eb1ef55ecd8"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["P1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116949408846*^9, 3.719116955190927*^9}},
 CellID->225400203,ExpressionUUID->"26db55fd-2f86-4162-947f-268888cc117e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "have", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191169735004683`*^9, 3.719116992885333*^9}},
 CellID->2057420238,ExpressionUUID->"c4d42a29-8778-4061-9cad-4d28b4115047"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\"\<2\>\"", " ", 
      FormBox[
       StyleBox["P1", "ExpressionABF"],
       TheoremaForm]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191170006154613`*^9, 3.71911703405123*^9}},
 CellID->925797755,ExpressionUUID->"5bd16da7-507f-45ef-9122-27e3febfaf97"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719117044449869*^9, 3.719117053804838*^9}},
 CellID->2090671922,ExpressionUUID->"9bb22e9b-cfac-421e-a4ef-59f6ede1b854"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191170574326487`*^9, 3.719117068698082*^9}},
 CellID->488760866,ExpressionUUID->"cfbdba39-8905-4768-93f9-0339dd32f0f5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191170788511667`*^9, 3.719117091621373*^9}},
 CellID->870099668,ExpressionUUID->"955fe67f-23a3-4deb-b285-f095c4f81afa"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["P1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71911709359945*^9, 3.719117099248324*^9}},
 CellID->2077838241,ExpressionUUID->"a65f1879-ee23-49c4-ae3d-5c68818d523d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     TagBox[
      StyleBox["Q1", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}], " ", "have", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191169735004683`*^9, 3.719116992885333*^9}, {
  3.7191171491760807`*^9, 3.719117154927499*^9}},
 CellID->1219102497,ExpressionUUID->"937e6493-0d8c-42e2-96c0-3b1b93cc619e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\"\<2\>\"", " ", 
      FormBox[
       StyleBox["P1", "ExpressionABF"],
       TheoremaForm]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7191170006154613`*^9, 3.71911703405123*^9}, 
   3.719117159680827*^9},
 CellID->968621095,ExpressionUUID->"5f5989d7-3ebc-410b-83bd-bd7b1ae7e89c"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Implies] cong)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 517, 17, 20, "ProofText", "ExpressionUUID" -> \
"97cca5a9-fd19-45b7-96b5-9402ed546caa",
 CellID->64885220],
Cell[1114, 40, 1912, 50, 20, "ProofText", "ExpressionUUID" -> \
"ab297c22-3e25-4d19-a7e8-d1568fc84a82",
 CellID->1824970400],
Cell[3029, 92, 1683, 47, 39, "ProofText", "ExpressionUUID" -> \
"ebd5c7da-a41f-44f0-8ee3-5e3d77711218",
 CellID->1445264721],
Cell[4715, 141, 796, 21, 20, "ProofText", "ExpressionUUID" -> \
"aa58e15a-3628-43b4-8a4b-73c915ad9a10",
 CellID->1695554537],
Cell[5514, 164, 811, 21, 39, "ProofText", "ExpressionUUID" -> \
"32d9557f-9272-4420-ac31-9eb1ef55ecd8",
 CellID->1029536987],
Cell[6328, 187, 326, 9, 20, "ProofText", "ExpressionUUID" -> \
"26db55fd-2f86-4162-947f-268888cc117e",
 CellID->225400203],
Cell[6657, 198, 942, 25, 18, "ProofText", "ExpressionUUID" -> \
"c4d42a29-8778-4061-9cad-4d28b4115047",
 CellID->2057420238],
Cell[7602, 225, 488, 14, 18, "ProofText", "ExpressionUUID" -> \
"5bd16da7-507f-45ef-9122-27e3febfaf97",
 CellID->925797755],
Cell[8093, 241, 277, 6, 39, "ProofText", "ExpressionUUID" -> \
"9bb22e9b-cfac-421e-a4ef-59f6ede1b854",
 CellID->2090671922],
Cell[8373, 249, 796, 21, 20, "ProofText", "ExpressionUUID" -> \
"cfbdba39-8905-4768-93f9-0339dd32f0f5",
 CellID->488760866],
Cell[9172, 272, 811, 21, 39, "ProofText", "ExpressionUUID" -> \
"955fe67f-23a3-4deb-b285-f095c4f81afa",
 CellID->870099668],
Cell[9986, 295, 326, 9, 20, "ProofText", "ExpressionUUID" -> \
"a65f1879-ee23-49c4-ae3d-5c68818d523d",
 CellID->2077838241],
Cell[10315, 306, 995, 26, 18, "ProofText", "ExpressionUUID" -> \
"937e6493-0d8c-42e2-96c0-3b1b93cc619e",
 CellID->1219102497],
Cell[11313, 334, 605, 17, 19, "ProofText", "ExpressionUUID" -> \
"5f5989d7-3ebc-410b-83bd-bd7b1ae7e89c",
 CellID->968621095]
}
]
*)

