(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     23943,        654]
NotebookOptionsPosition[     21596,        592]
NotebookOutlinePosition[     22196,        612]
CellTagsIndexPosition[     22153,        609]
WindowTitle->Proof of (\:2200C comm)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q2", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71922106384249*^9, 3.719221075370769*^9}},
 CellID->4357136,ExpressionUUID->"eedbe937-0eec-4592-992e-eab291fbdde1"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192210793882103`*^9, 3.7192210813129463`*^9}},
 CellID->1262790837,ExpressionUUID->"ed8b8bd8-bb11-447e-b7ee-2a1be1c1e52b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       GridBox[{
         {
          RowBox[{
           TagBox[
            StyleBox["Q1", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]},
         {
          RowBox[{
           TagBox[
            StyleBox["Q2", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
               Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x0", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}]}
        }]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], ",", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719221090063382*^9, 3.71922110096487*^9}},
 CellID->750516444,ExpressionUUID->"10b6e0b9-676e-4bc4-b4d6-fdcfd0064726"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        GridBox[{
         {
          RowBox[{
           TagBox[
            StyleBox["Q2", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
               Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["y", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}]},
         {
          RowBox[{
           TagBox[
            StyleBox["Q1", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}
        }]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], ",", 
        StyleBox["y", "ExpressionVariable"]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"intro", " ", "\"\<\[ForAll]CI\>\""}], ")"}]}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7192211032963533`*^9, 3.719221117385598*^9}},
 CellID->1737050079,ExpressionUUID->"87db45b2-7a14-4570-b87a-962ac5d5f5e6"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192211211850147`*^9, 3.719221128134598*^9}},
 CellID->268554207,ExpressionUUID->"271f20a8-5288-4f4b-b5ad-049d5a73b93b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q1", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192211322102833`*^9, 3.719221145113298*^9}},
 CellID->535687294,ExpressionUUID->"c0119146-0fae-4728-808f-41ba877ec728"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", "\"\<*\>\""}], ":", 
   " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["Q2", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        FormBox[
         StyleBox["y", "ExpressionABF"],
         TheoremaForm], ",", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}], " ", ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719221150756493*^9, 3.719221175602262*^9}},
 CellID->1859766597,ExpressionUUID->"4409ff91-07d4-46dd-ab39-20029640d44f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q2", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["y", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719289678225707*^9, 3.719289736122225*^9}},
 CellID->781926781,ExpressionUUID->"a48f1dee-e06e-4ec0-a645-699968c3908e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719289741126137*^9, 3.719289748250708*^9}},
 CellID->302706310,ExpressionUUID->"3b17d348-006b-414c-9f6a-6006245a83af"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<2\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        GridBox[{
         {
          RowBox[{
           TagBox[
            StyleBox["Q2", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
               Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["y", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}]},
         {
          RowBox[{
           TagBox[
            StyleBox["Q1", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}
        }]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], ",", 
        StyleBox["y", "ExpressionVariable"]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719289749945249*^9, 3.7192897645067663`*^9}},
 CellID->945286431,ExpressionUUID->"9cceee35-9e9b-43f2-b25d-e325ded46ff7"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       GridBox[{
         {
          RowBox[{
           TagBox[
            StyleBox["Q1", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]},
         {
          RowBox[{
           TagBox[
            StyleBox["Q2", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
               Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x0", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}]}
        }]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        StyleBox["x", "ExpressionVariable"], ",", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"intro", " ", "\"\<\[ForAll]CI\>\""}], ")"}]}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7192211032963533`*^9, 3.719221117385598*^9}, {
  3.719289776224918*^9, 3.719289791114298*^9}},
 CellID->1018783585,ExpressionUUID->"dd7e9e3d-6986-44bf-9bd9-334055ac8a33"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192211211850147`*^9, 3.719221128134598*^9}},
 CellID->535968539,ExpressionUUID->"f7f1c594-32ec-4297-9b51-3a41c871bf8f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q2", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192211322102833`*^9, 3.719221145113298*^9}, {
  3.719289800813985*^9, 3.719289823686068*^9}},
 CellID->145705667,ExpressionUUID->"436718cd-2954-4ab6-bb8c-353d9b74d977"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<2\>\"", " ", "have", " ", "\"\<*\>\""}], ":", 
   " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["Q1", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x0", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        ",", 
        FormBox[
         StyleBox["y", "ExpressionABF"],
         TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719221150756493*^9, 3.719221175602262*^9}, {
  3.719289805971746*^9, 3.719289843357959*^9}},
 CellID->2125710789,ExpressionUUID->"ad9d9418-5c7e-4f40-9245-da1bf7a988a5"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["y", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719289678225707*^9, 3.719289736122225*^9}, {
  3.719289847317683*^9, 3.719289851652195*^9}},
 CellID->1465623330,ExpressionUUID->"a3707cbd-9e69-4c45-812e-e07c170c39fb"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[ForAll]C comm)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 442, 14, 20, "ProofText", "ExpressionUUID" -> \
"eedbe937-0eec-4592-992e-eab291fbdde1",
 CellID->4357136],
Cell[1040, 37, 239, 4, 39, "ProofText", "ExpressionUUID" -> \
"ed8b8bd8-bb11-447e-b7ee-2a1be1c1e52b",
 CellID->1262790837],
Cell[1282, 43, 2576, 65, 47, "ProofText", "ExpressionUUID" -> \
"10b6e0b9-676e-4bc4-b4d6-fdcfd0064726",
 CellID->750516444],
Cell[3861, 110, 2490, 64, 66, "ProofText", "ExpressionUUID" -> \
"87db45b2-7a14-4570-b87a-962ac5d5f5e6",
 CellID->1737050079],
Cell[6354, 176, 400, 12, 20, "ProofText", "ExpressionUUID" -> \
"271f20a8-5288-4f4b-b5ad-049d5a73b93b",
 CellID->268554207],
Cell[6757, 190, 495, 14, 20, "ProofText", "ExpressionUUID" -> \
"c0119146-0fae-4728-808f-41ba877ec728",
 CellID->535687294],
Cell[7255, 206, 1991, 51, 34, "ProofText", "ExpressionUUID" -> \
"4409ff91-07d4-46dd-ab39-20029640d44f",
 CellID->1859766597],
Cell[9249, 259, 1898, 49, 20, "ProofText", "ExpressionUUID" -> \
"a48f1dee-e06e-4ec0-a645-699968c3908e",
 CellID->781926781],
Cell[11150, 310, 276, 6, 39, "ProofText", "ExpressionUUID" -> \
"3b17d348-006b-414c-9f6a-6006245a83af",
 CellID->302706310],
Cell[11429, 318, 2412, 61, 43, "ProofText", "ExpressionUUID" -> \
"9cceee35-9e9b-43f2-b25d-e325ded46ff7",
 CellID->945286431],
Cell[13844, 381, 2706, 69, 71, "ProofText", "ExpressionUUID" -> \
"dd7e9e3d-6986-44bf-9bd9-334055ac8a33",
 CellID->1018783585],
Cell[16553, 452, 400, 12, 20, "ProofText", "ExpressionUUID" -> \
"f7f1c594-32ec-4297-9b51-3a41c871bf8f",
 CellID->535968539],
Cell[16956, 466, 544, 15, 20, "ProofText", "ExpressionUUID" -> \
"436718cd-2954-4ab6-bb8c-353d9b74d977",
 CellID->145705667],
Cell[17503, 483, 2046, 53, 34, "ProofText", "ExpressionUUID" -> \
"ad9d9418-5c7e-4f40-9245-da1bf7a988a5",
 CellID->2125710789],
Cell[19552, 538, 2040, 52, 20, "ProofText", "ExpressionUUID" -> \
"a3707cbd-9e69-4c45-812e-e07c170c39fb",
 CellID->1465623330]
}
]
*)

