(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     51045,       1427]
NotebookOptionsPosition[     45144,       1281]
NotebookOutlinePosition[     45742,       1301]
CellTagsIndexPosition[     45699,       1298]
WindowTitle->Proof of (unique choice)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030578864312*^9, 3.719030582291008*^9}},
 CellID->879512663,ExpressionUUID->"58b9587f-b776-4c46-9b74-5eea1688cdfd"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030591222987*^9, 3.7190305937970667`*^9}},
 CellID->1365655350,ExpressionUUID->"ece40fcd-283d-47c3-9849-303e3675fcba"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       UnderscriptBox[
        TagBox[
         RowBox[{"\[Exists]", "!"}],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030597009663*^9, 3.719030612815872*^9}, 
   3.7190315302439528`*^9},
 CellID->1994599187,ExpressionUUID->"ab2c9bec-47b7-415e-80ba-16fd95fbfcf1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox[
        RowBox[{"\[Exists]", "!"}],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]]], 
       TagBox[
        StyleBox["f", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030615762841*^9, 3.719030627973484*^9}, {
  3.719031533449772*^9, 3.719031536569713*^9}},
 CellID->1799358379,ExpressionUUID->"0b84a702-66a9-49f3-a5bc-122e5a116978"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        RowBox[{
         UnderscriptBox["the", "y"], 
         RowBox[{
          FormBox[
           StyleBox["P", "ExpressionABF"],
           TheoremaForm], "[", 
          RowBox[{"x", ",", "y"}], "]"}]}]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030636851437*^9, 3.719030684646125*^9}, {
  3.7190315442494593`*^9, 3.719031544537171*^9}},
 CellID->662141598,ExpressionUUID->"f9e96f51-0795-4c85-8e3b-32c12fe8291e"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030687936692*^9, 3.71903069369851*^9}},
 CellID->1575820068,ExpressionUUID->"fbf09c9d-ba07-4767-8ded-2033d7c4b655"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox[
        RowBox[{"\[Exists]", "!"}],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], ",", 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030698336796*^9, 3.7190307323342524`*^9}, 
   3.719031551409952*^9},
 CellID->1390111005,ExpressionUUID->"7a9a4884-335e-4cb9-b014-ab23c5cf9dd1"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<theI \[Exists]!\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7190307508069143`*^9, 3.719030776367118*^9}, {
  3.7190315580574102`*^9, 3.719031560105186*^9}},
 CellID->1394671402,ExpressionUUID->"7d8b86ff-66f9-4a63-9f36-84407da0afdf"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719031563644599*^9, 3.719031566976542*^9}, {
  3.719034385556365*^9, 3.7190343922038918`*^9}},
 CellID->1707985752,ExpressionUUID->"17e98bb4-20f2-422e-8af9-e07b863566cb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["g", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903156931645*^9, 3.7190315742064133`*^9}, 
   3.719034397876059*^9},
 CellID->1056724175,ExpressionUUID->"6f15e56a-fe27-438c-894a-f004809eced6"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<**\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        RowBox[{
         TagBox[
          StyleBox["g", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190315774522533`*^9, 3.719031589742853*^9}, 
   3.719034398773193*^9},
 CellID->211884134,ExpressionUUID->"bf2f301b-23a7-473b-88a8-826ba6d6d42f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["g", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]],
       SyntaxForm->"x\[Equal]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox["\[Lambda]", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        RowBox[{"(", 
         RowBox[{
          UnderscriptBox[
           TagBox["the",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`SuchUnique$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
           TagBox[
            StyleBox["y", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
          RowBox[{
           TagBox[
            StyleBox["P", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
               Theorema`Language`FUN$TM[
                Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0],
                 Theorema`Knowledge`BOOL$TM]]]]], "[", 
           RowBox[{
            StyleBox["x", "ExpressionVariable"], ",", 
            TagBox[
             TagBox[
              StyleBox["y", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], "]"}]}], ")"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Equal] ext\>\""}], ")"}]}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719031593513669*^9, 3.719031626970125*^9}, {
  3.7190344001804943`*^9, 3.7190344009957943`*^9}},
 CellID->1110079063,ExpressionUUID->"6378ecc5-6cea-4846-9547-dd204f777c2a"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719031634833065*^9, 3.719031640541979*^9}, 
   3.719034402279697*^9},
 CellID->303911929,ExpressionUUID->"b711d5e6-19e5-4716-a1ac-da101e27293c"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       RowBox[{"\[Exists]", "!"}], "y"], 
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], ",", "y"}], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190318523412647`*^9, 3.719031922677346*^9}, 
   3.7190344033265343`*^9},
 CellID->884197543,ExpressionUUID->"4421ed78-0e9f-4b3b-a73b-51279db89f5b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"moreover", " ", "from", " ", "\"\<**\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]]], "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       RowBox[{
        TagBox[
         StyleBox["g", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "]"}]}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719031731638521*^9, 3.719031760753725*^9}, {
   3.719031926766017*^9, 3.719031927845688*^9}, 3.719034404035141*^9},
 CellID->1785161880,ExpressionUUID->"24ac212a-2927-4334-8e51-f97e36992b67"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"ultimately", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox[
        TagBox["the",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`SuchUnique$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[Equal]", 
     RowBox[{
      FormBox[
       StyleBox["g", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<the \[Equal] \[Exists]!\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719031935441875*^9, 3.719031977353018*^9}, 
   3.7190344045501432`*^9},
 CellID->1139343073,ExpressionUUID->"4fc7b3c2-ac1f-437b-87f0-87499728f73b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Equal] sym\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719031983349586*^9, 3.719031994134357*^9}, 
   3.7190344053737297`*^9},
 CellID->1296647091,ExpressionUUID->"2ba66cd0-38fd-4b7b-b6b7-66dbcfc9ad2d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030780276926*^9, 3.719030791303513*^9}, {
  3.719032008934486*^9, 3.719032013055046*^9}, {3.71903440690915*^9, 
  3.719034411398205*^9}},
 CellID->1573277746,ExpressionUUID->"3470c291-01df-4afb-a013-222a23801930"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox[
        RowBox[{"\[Exists]", "!"}],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]]], 
       TagBox[
        StyleBox["f", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190307940208406`*^9, 3.719030804626834*^9}, 
   3.719032020047833*^9},
 CellID->115727459,ExpressionUUID->"2f4fd170-c206-4ac9-babe-645f50f51220"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], "]"}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<**\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox["\[And]", "g"], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         UnderscriptBox["\[ForAll]", "x"], 
         RowBox[{
          FormBox[
           StyleBox["P", "ExpressionABF"],
           TheoremaForm], "[", 
          RowBox[{"x", ",", 
           RowBox[{"g", "[", "x", "]"}]}], "]"}]}], ")"}], 
       "\[LongRightArrow]", 
       RowBox[{"(", 
        RowBox[{"g", "\[Equal]", 
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm]}], ")"}]}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030807613258*^9, 3.719030856544373*^9}, {
  3.719032058214987*^9, 3.719032100500682*^9}},
 CellID->580285613,ExpressionUUID->"96b08424-0363-443c-9021-278a57ca6f54"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       UnderscriptBox[
        TagBox[
         RowBox[{"\[Exists]", "!"}],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]]], "[", 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          ",", 
         TagBox[
          StyleBox["y", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030858640813*^9, 3.719030885736397*^9}, 
   3.719032207769107*^9},
 CellID->1501664841,ExpressionUUID->"67792263-831c-496a-83a2-bd03cf05e504"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030888087075*^9, 3.719030892771764*^9}},
 CellID->70840569,ExpressionUUID->"02546dae-36c5-42b1-99fc-eb406c96def3"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", 
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "]"}]}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719030901168891*^9, 3.719030926504767*^9}},
 CellID->150008451,ExpressionUUID->"fa5b1d9d-a668-4e90-add1-290cf75e1b25"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox[
        RowBox[{"\[Exists]", "!"}],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}],
        "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190309305489473`*^9, 3.71903094986524*^9}, {
  3.719032221282395*^9, 3.719032227905446*^9}},
 CellID->207193733,ExpressionUUID->"4b21c938-3896-4e42-a424-ca97dbcbe2df"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190322314110613`*^9, 3.719032245225054*^9}},
 CellID->1034205994,ExpressionUUID->"7cb7e679-69aa-4185-ae83-3fbd6d42c2a6"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]]], "[", 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       ",", 
       TagBox[
        StyleBox["y", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]}], 
      "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719032249229206*^9, 3.719032260175565*^9}},
 CellID->1346536806,ExpressionUUID->"25da2331-34ef-4dbb-9bf8-e886d6015ed5"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"let", " ", 
    FormBox[
     StyleBox["g", "ExpressionSyntactic"],
     TheoremaForm], " ", "be", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox["\[Lambda]", "z"], 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"z", "\[Equal]", 
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm]}], ",", 
        FormBox[
         StyleBox["y", "ExpressionABF"],
         TheoremaForm], ",", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", "z", "]"}]}], "]"}]}], "\[CloseCurlyQuote]"}]}],
    ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719032321722692*^9, 3.719032334248391*^9}, {
   3.719032382499755*^9, 3.719032402055543*^9}, 3.7190324950109167`*^9},
 CellID->1484996906,ExpressionUUID->"7729f040-0116-4a23-a0aa-d571d24ebd8f"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox["\[ForAll]", "z"], 
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       RowBox[{"z", ",", 
        RowBox[{
         FormBox[
          StyleBox["g", "ExpressionSyntactic"],
          TheoremaForm], "[", "z", "]"}]}], "]"}]}], "\[CloseCurlyQuote]"}]}],
    "\n", "\t\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190324433621693`*^9, 3.7190324871566973`*^9}},
 CellID->233837660,ExpressionUUID->"08f0c230-f3ee-4402-af47-8763dc07fa64"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["z", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190325017483473`*^9, 3.7190325076253157`*^9}},
 CellID->1038307234,ExpressionUUID->"d8f8a47d-9c7d-499b-aa64-bf091fa3b006"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["z", "ExpressionABF"],
        TheoremaForm], ",", 
       RowBox[{
        FormBox[
         StyleBox["g", "ExpressionSyntactic"],
         TheoremaForm], "[", 
        FormBox[
         StyleBox["z", "ExpressionABF"],
         TheoremaForm], "]"}]}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
   "\t\t\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190325172681637`*^9, 3.719032574849354*^9}, {
  3.719034892739201*^9, 3.719034899523264*^9}, {3.719034971595166*^9, 
  3.719034977948122*^9}},
 CellID->1237023595,ExpressionUUID->"64ec827d-b918-4d2d-9d9a-4e83a5ba83cc"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["z", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719034983721006*^9, 3.719034997931469*^9}},
 CellID->151135473,ExpressionUUID->"492bbecd-a034-4422-bddb-0e97c7f0d5e8"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["g", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["z", "ExpressionABF"],
       TheoremaForm], "]"}], "\[Equal]", 
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719035006698188*^9, 3.719035045459979*^9}},
 CellID->2078345557,ExpressionUUID->"792f13ee-ead1-4c35-be18-4cb0178287dc"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["z", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"simp", ":"}], ",", " ", 
     RowBox[{"intro", " ", 
      RowBox[{"\[OpenCurlyQuote]", 
       RowBox[{
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm], "[", 
        RowBox[{
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm], ",", 
         FormBox[
          StyleBox["y", "ExpressionABF"],
          TheoremaForm]}], "]"}], "\[CloseCurlyQuote]"}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190350700711308`*^9, 3.719035181958151*^9}},
 CellID->1092980501,ExpressionUUID->"02babc15-66df-4e47-a08d-5bd3f574a8fc"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903518727514*^9, 3.7190351913904533`*^9}},
 CellID->559137268,ExpressionUUID->"ac1dfc16-d143-49b5-b759-f9f71c0b40dd"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["z", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719035193261146*^9, 3.719035208398449*^9}},
 CellID->1284469743,ExpressionUUID->"e751ef64-8489-4a27-91c1-27b38f47a03b"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"hence", " ", "\"\<eq\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["g", "ExpressionSyntactic"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["z", "ExpressionABF"],
        TheoremaForm], "]"}], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["z", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<If \[Not]cond\>\""}], ")"}]}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719035212527285*^9, 3.719035240655348*^9}, {
  3.719035272050468*^9, 3.719035273417282*^9}},
 CellID->1832444899,ExpressionUUID->"1e65f242-b2cd-4a43-9f55-6888f418f26c"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["z", "ExpressionABF"],
        TheoremaForm], ",", 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", 
        FormBox[
         StyleBox["z", "ExpressionABF"],
         TheoremaForm], "]"}]}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719035276775687*^9, 3.7190353017030993`*^9}},
 CellID->633752232,ExpressionUUID->"ac40a85a-d255-43b7-b1db-349d4cae8172"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<eq\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190353068058147`*^9, 3.719035319792116*^9}},
 CellID->1747694637,ExpressionUUID->"e8b5601f-3458-4537-b38b-4e2d737548c3"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719032580094083*^9, 3.719032583405774*^9}, {
  3.7190353365282907`*^9, 3.719035340640572*^9}},
 CellID->1578063261,ExpressionUUID->"3463c4a5-dea3-4a4b-8e56-ba814d4c2a4e"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["g", "ExpressionSyntactic"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["f", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<**\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7190325876277018`*^9, 3.7190326071579323`*^9}},
 CellID->1953816575,ExpressionUUID->"682bbd2f-20ca-4ca3-bc27-dee1f09f0882"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["g", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[Equal]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719032628549498*^9, 3.719032660429892*^9}},
 CellID->88544934,ExpressionUUID->"9c8d0d85-5c15-4154-9133-590b81716477"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"moreover", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["g", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[Equal]", 
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<If cond\>\""}], ",", " ", 
     RowBox[{"rule", " ", "\"\<\[Equal] refl\>\""}]}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.719035427167906*^9, 3.719035465281645*^9}},
 CellID->2132411401,ExpressionUUID->"2d98e76c-aabd-4ebf-b5ce-4c6dc9870705"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"ultimately", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["y", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
     TagBox["\[Equal]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->"x\[Equal]y"], 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      "[", 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719032672879849*^9, 3.7190326893307037`*^9}, {
  3.719035485634224*^9, 3.719035491321991*^9}},
 CellID->1137274628,ExpressionUUID->"9d64e89e-7574-47b6-99f8-ce4266920074"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (unique choice)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 297, 8, 20, "ProofText", "ExpressionUUID" -> \
"58b9587f-b776-4c46-9b74-5eea1688cdfd",
 CellID->879512663],
Cell[896, 31, 237, 4, 39, "ProofText", "ExpressionUUID" -> \
"ece40fcd-283d-47c3-9849-303e3675fcba",
 CellID->1365655350],
Cell[1136, 37, 2232, 58, 31, "ProofText", "ExpressionUUID" -> \
"ab2c9bec-47b7-415e-80ba-16fd95fbfcf1",
 CellID->1994599187],
Cell[3371, 97, 2877, 71, 54, "ProofText", "ExpressionUUID" -> \
"0b84a702-66a9-49f3-a5bc-122e5a116978",
 CellID->1799358379],
Cell[6251, 170, 1714, 45, 55, "ProofText", "ExpressionUUID" -> \
"f9e96f51-0795-4c85-8e3b-32c12fe8291e",
 CellID->662141598],
Cell[7968, 217, 324, 9, 20, "ProofText", "ExpressionUUID" -> \
"fbf09c9d-ba07-4767-8ded-2033d7c4b655",
 CellID->1575820068],
Cell[8295, 228, 1599, 41, 31, "ProofText", "ExpressionUUID" -> \
"7a9a4884-335e-4cb9-b014-ab23c5cf9dd1",
 CellID->1390111005],
Cell[9897, 271, 391, 9, 18, "ProofText", "ExpressionUUID" -> \
"7d8b86ff-66f9-4a63-9f36-84407da0afdf",
 CellID->1394671402],
Cell[10291, 282, 336, 7, 39, "ProofText", "ExpressionUUID" -> \
"17e98bb4-20f2-422e-8af9-e07b863566cb",
 CellID->1707985752],
Cell[10630, 291, 350, 10, 20, "ProofText", "ExpressionUUID" -> \
"6f15e56a-fe27-438c-894a-f004809eced6",
 CellID->1056724175],
Cell[10983, 303, 2091, 53, 28, "ProofText", "ExpressionUUID" -> \
"bf2f301b-23a7-473b-88a8-826ba6d6d42f",
 CellID->211884134],
Cell[13077, 358, 3075, 77, 57, "ProofText", "ExpressionUUID" -> \
"6378ecc5-6cea-4846-9547-dd204f777c2a",
 CellID->1110079063],
Cell[16155, 437, 350, 10, 20, "ProofText", "ExpressionUUID" -> \
"b711d5e6-19e5-4716-a1ac-da101e27293c",
 CellID->303911929],
Cell[16508, 449, 681, 20, 31, "ProofText", "ExpressionUUID" -> \
"4421ed78-0e9f-4b3b-a73b-51279db89f5b",
 CellID->884197543],
Cell[17192, 471, 1396, 35, 20, "ProofText", "ExpressionUUID" -> \
"24ac212a-2927-4334-8e51-f97e36992b67",
 CellID->1785161880],
Cell[18591, 508, 2127, 58, 35, "ProofText", "ExpressionUUID" -> \
"4fc7b3c2-ac1f-437b-87f0-87499728f73b",
 CellID->1139343073],
Cell[20721, 568, 361, 8, 18, "ProofText", "ExpressionUUID" -> \
"2ba66cd0-38fd-4b7b-b6b7-66dbcfc9ad2d",
 CellID->1296647091],
Cell[21085, 578, 420, 9, 59, "ProofText", "ExpressionUUID" -> \
"3470c291-01df-4afb-a013-222a23801930",
 CellID->1573277746],
Cell[21508, 589, 2839, 71, 32, "ProofText", "ExpressionUUID" -> \
"2f4fd170-c206-4ac9-babe-645f50f51220",
 CellID->115727459],
Cell[24350, 662, 2618, 73, 32, "ProofText", "ExpressionUUID" -> \
"96b08424-0363-443c-9021-278a57ca6f54",
 CellID->580285613],
Cell[26971, 737, 2208, 57, 53, "ProofText", "ExpressionUUID" -> \
"67792263-831c-496a-83a2-bd03cf05e504",
 CellID->1501664841],
Cell[29182, 796, 321, 9, 20, "ProofText", "ExpressionUUID" -> \
"02546dae-36c5-42b1-99fc-eb406c96def3",
 CellID->70840569],
Cell[29506, 807, 750, 23, 20, "ProofText", "ExpressionUUID" -> \
"fa5b1d9d-a668-4e90-add1-290cf75e1b25",
 CellID->150008451],
Cell[30259, 832, 1734, 45, 53, "ProofText", "ExpressionUUID" -> \
"4b21c938-3896-4e42-a424-ca97dbcbe2df",
 CellID->207193733],
Cell[31996, 879, 327, 9, 20, "ProofText", "ExpressionUUID" -> \
"7cb7e679-69aa-4185-ae83-3fbd6d42c2a6",
 CellID->1034205994],
Cell[32326, 890, 1161, 30, 20, "ProofText", "ExpressionUUID" -> \
"25da2331-34ef-4dbb-9bf8-e886d6015ed5",
 CellID->1346536806],
Cell[33490, 922, 926, 27, 28, "ProofText", "ExpressionUUID" -> \
"7729f040-0116-4a23-a0aa-d571d24ebd8f",
 CellID->1484996906],
Cell[34419, 951, 658, 19, 50, "ProofText", "ExpressionUUID" -> \
"08f0c230-f3ee-4402-af47-8763dc07fa64",
 CellID->233837660],
Cell[35080, 972, 331, 9, 20, "ProofText", "ExpressionUUID" -> \
"d8f8a47d-9c7d-499b-aa64-bf091fa3b006",
 CellID->1038307234],
Cell[35414, 983, 940, 28, 41, "ProofText", "ExpressionUUID" -> \
"64ec827d-b918-4d2d-9d9a-4e83a5ba83cc",
 CellID->1237023595],
Cell[36357, 1013, 498, 14, 20, "ProofText", "ExpressionUUID" -> \
"492bbecd-a034-4422-bddb-0e97c7f0d5e8",
 CellID->151135473],
Cell[36858, 1029, 672, 19, 18, "ProofText", "ExpressionUUID" -> \
"792f13ee-ead1-4c35-be18-4cb0178287dc",
 CellID->2078345557],
Cell[37533, 1050, 997, 31, 20, "ProofText", "ExpressionUUID" -> \
"02babc15-66df-4e47-a08d-5bd3f574a8fc",
 CellID->1092980501],
Cell[38533, 1083, 245, 5, 18, "ProofText", "ExpressionUUID" -> \
"ac1dfc16-d143-49b5-b759-f9f71c0b40dd",
 CellID->559137268],
Cell[38781, 1090, 502, 14, 20, "ProofText", "ExpressionUUID" -> \
"e751ef64-8489-4a27-91c1-27b38f47a03b",
 CellID->1284469743],
Cell[39286, 1106, 905, 27, 18, "ProofText", "ExpressionUUID" -> \
"1e65f242-b2cd-4a43-9f55-6888f418f26c",
 CellID->1832444899],
Cell[40194, 1135, 758, 23, 20, "ProofText", "ExpressionUUID" -> \
"ac40a85a-d255-43b7-b1db-349d4cae8172",
 CellID->633752232],
Cell[40955, 1160, 334, 7, 18, "ProofText", "ExpressionUUID" -> \
"e8b5601f-3458-4537-b38b-4e2d737548c3",
 CellID->1747694637],
Cell[41292, 1169, 343, 7, 39, "ProofText", "ExpressionUUID" -> \
"3463c4a5-dea3-4a4b-8e56-ba814d4c2a4e",
 CellID->1578063261],
Cell[41638, 1178, 561, 15, 18, "ProofText", "ExpressionUUID" -> \
"682bbd2f-20ca-4ca3-bc27-dee1f09f0882",
 CellID->1953816575],
Cell[42202, 1195, 713, 22, 18, "ProofText", "ExpressionUUID" -> \
"9c8d0d85-5c15-4154-9133-590b81716477",
 CellID->88544934],
Cell[42918, 1219, 766, 22, 20, "ProofText", "ExpressionUUID" -> \
"2d98e76c-aabd-4ebf-b5ce-4c6dc9870705",
 CellID->2132411401],
Cell[43687, 1243, 1453, 36, 19, "ProofText", "ExpressionUUID" -> \
"9d64e89e-7574-47b6-99f8-ce4266920074",
 CellID->1137274628]
}
]
*)

