(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6834,        198]
NotebookOptionsPosition[      5880,        169]
NotebookOutlinePosition[      6476,        189]
CellTagsIndexPosition[      6433,        186]
WindowTitle->Proof of (\:2200E')
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["thesis", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71791882214266*^9, 3.7179188316141043`*^9}},
 CellID->422209563,ExpressionUUID->"e1ae9829-567c-4c19-ad24-c00aa9051b9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", 
   " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["t", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         UnderscriptBox[
          TagBox["\[ForAll]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["thesis", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`FORM$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.717918833719419*^9, 3.717918859214336*^9}},
 CellID->838634339,ExpressionUUID->"55e1e27a-8547-4a2b-976b-0a948b7178f4"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<1\>\"", " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "[", 
    FormBox[
     StyleBox["t", "ExpressionABF"],
     TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[ForAll]D\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71791887163415*^9, 3.7179188901991463`*^9}},
 CellID->645086142,ExpressionUUID->"4a7abd3c-7fcf-4b0e-b94c-ea1e965cbfbc"],

Cell[BoxData[
 RowBox[{"from", " ", "this", " ", "\"\<1\>\"", " ", "show", " ", 
  FormBox[
   StyleBox["thesis", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7179188989259167`*^9, 3.7179189221646433`*^9}},
 CellID->318613233,ExpressionUUID->"21ac5fa7-e72e-4b63-b45c-061368bcbb75"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[ForAll]E')",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 449, 14, 20, "ProofText", "ExpressionUUID" -> \
"e1ae9829-567c-4c19-ad24-c00aa9051b9a",
 CellID->422209563],
Cell[1043, 37, 3772, 101, 30, "ProofText", "ExpressionUUID" -> \
"55e1e27a-8547-4a2b-976b-0a948b7178f4",
 CellID->838634339],
Cell[4818, 140, 554, 14, 21, "ProofText", "ExpressionUUID" -> \
"4a7abd3c-7fcf-4b0e-b94c-ea1e965cbfbc",
 CellID->645086142],
Cell[5375, 156, 501, 11, 19, "ProofText", "ExpressionUUID" -> \
"21ac5fa7-e72e-4b63-b45c-061368bcbb75",
 CellID->318613233]
}
]
*)

