(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16817,        494]
NotebookOptionsPosition[     13860,        417]
NotebookOutlinePosition[     14455,        437]
CellTagsIndexPosition[     14412,        434]
WindowTitle->Proof of (\:2228 cong)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912244721381*^9, 3.7191224577836523`*^9}},
 CellID->71595966,ExpressionUUID->"7ae73294-a9c0-454a-a990-1619cfe384cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[DoubleLeftRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
        SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
       TagBox[
        StyleBox["Q1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122472309289*^9, 3.719122493865947*^9}},
 CellID->1996263298,ExpressionUUID->"3381fff0-51b3-44c3-be4b-03317a30aaf0"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[DoubleLeftRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
     SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<1\>\""}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122498014771*^9, 3.719122511673417*^9}},
 CellID->1759624985,ExpressionUUID->"eeeb28b3-6c03-480b-80cf-0efaef03a7b2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122514224495*^9, 3.719122525013747*^9}},
 CellID->292283522,ExpressionUUID->"189ec85a-b161-46a4-924f-b53d546d4b9f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]E1 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122530897979*^9, 3.719122542229487*^9}, {
  3.719123167577207*^9, 3.719123179138012*^9}},
 CellID->1208836649,ExpressionUUID->"03e12258-b02c-468b-bc4b-56ec1ad7f545"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123197422575*^9, 3.719123203669929*^9}},
 CellID->1188235030,ExpressionUUID->"312313f1-5454-49fd-9d07-19f5f248d27c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912320681597*^9, 3.719123227522739*^9}, 
   3.7191233650040207`*^9},
 CellID->2100176693,ExpressionUUID->"da685465-0adb-41b7-a10d-c2d0db9c29c3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912323078358*^9, 3.7191232336505203`*^9}},
 CellID->858466717,ExpressionUUID->"47908843-0bfa-4390-81ff-2b76c70b09bc"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P1", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123236882414*^9, 3.719123252272089*^9}},
 CellID->2047873064,ExpressionUUID->"1c006f73-fae6-4b10-a7c9-3286c6bd7526"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "have", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\"\<2\>\"", "[", 
      RowBox[{"OF", " ", 
       RowBox[{"\[OpenCurlyQuote]", 
        RowBox[{"\[Not]", 
         FormBox[
          StyleBox["P1", "ExpressionABF"],
          TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "]"}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123284424177*^9, 3.7191233505481*^9}},
 CellID->676164419,ExpressionUUID->"425e2813-7efc-4522-8bcb-cf4b5291cd89"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912335417902*^9, 3.719123375492065*^9}},
 CellID->148567486,ExpressionUUID->"20e8603f-427b-4391-948b-fede31ec8ced"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123379419035*^9, 3.7191233881725197`*^9}},
 CellID->304245334,ExpressionUUID->"a92ba958-a1a2-4a42-918e-21ab1ae1201b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191233902082987`*^9, 3.719123400411734*^9}},
 CellID->1029126483,ExpressionUUID->"b130a07b-6aed-476f-90e5-8ddc1d506b24"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]E1 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122530897979*^9, 3.719122542229487*^9}, {
   3.719123167577207*^9, 3.719123179138012*^9}, 3.7191234224300423`*^9},
 CellID->858890241,ExpressionUUID->"a57829c6-ada2-436a-9768-0af166184e26"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123197422575*^9, 3.719123203669929*^9}},
 CellID->1462966552,ExpressionUUID->"12bc4e40-c13a-4abb-b42a-fb053254cb93"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912320681597*^9, 3.719123227522739*^9}, 
   3.7191233650040207`*^9},
 CellID->464530090,ExpressionUUID->"c38cd345-285a-4bad-93d5-3903f5536477"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71912323078358*^9, 3.7191232336505203`*^9}},
 CellID->842835447,ExpressionUUID->"5bffb091-ab61-4a8e-a041-70fcb81979ba"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P1", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    FormBox[
     StyleBox["Q1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123236882414*^9, 3.719123252272089*^9}, 
   3.719123433733739*^9},
 CellID->964445162,ExpressionUUID->"62cd3bbe-82a7-4678-acde-d60e30c68909"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["Q1", "ExpressionABF"],
    TheoremaForm], " ", "have", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", 
     RowBox[{"\"\<2\>\"", "[", 
      RowBox[{"OF", " ", 
       RowBox[{"\[OpenCurlyQuote]", 
        RowBox[{"\[Not]", 
         FormBox[
          StyleBox["P1", "ExpressionABF"],
          TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "]"}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123284424177*^9, 3.7191233505481*^9}, {
  3.7191234374536343`*^9, 3.719123439479393*^9}},
 CellID->1918140120,ExpressionUUID->"b2732595-9b56-4ae7-8761-6b6a96ab592e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.71912335417902*^9, 3.719123375492065*^9}},
 CellID->8562551,ExpressionUUID->"6af6d2a4-d5c4-4803-b540-39e49412fa02"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or] cong)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 518, 17, 20, "ProofText", "ExpressionUUID" -> \
"7ae73294-a9c0-454a-a990-1619cfe384cc",
 CellID->71595966],
Cell[1115, 40, 2198, 60, 20, "ProofText", "ExpressionUUID" -> \
"3381fff0-51b3-44c3-be4b-03317a30aaf0",
 CellID->1996263298],
Cell[3316, 102, 1651, 47, 39, "ProofText", "ExpressionUUID" -> \
"eeeb28b3-6c03-480b-80cf-0efaef03a7b2",
 CellID->1759624985],
Cell[4970, 151, 778, 21, 20, "ProofText", "ExpressionUUID" -> \
"189ec85a-b161-46a4-924f-b53d546d4b9f",
 CellID->292283522],
Cell[5751, 174, 953, 26, 39, "ProofText", "ExpressionUUID" -> \
"03e12258-b02c-468b-bc4b-56ec1ad7f545",
 CellID->1208836649],
Cell[6707, 202, 325, 9, 20, "ProofText", "ExpressionUUID" -> \
"312313f1-5454-49fd-9d07-19f5f248d27c",
 CellID->1188235030],
Cell[7035, 213, 353, 8, 18, "ProofText", "ExpressionUUID" -> \
"da685465-0adb-41b7-a10d-c2d0db9c29c3",
 CellID->2100176693],
Cell[7391, 223, 239, 5, 18, "ProofText", "ExpressionUUID" -> \
"47908843-0bfa-4390-81ff-2b76c70b09bc",
 CellID->858466717],
Cell[7633, 230, 503, 14, 20, "ProofText", "ExpressionUUID" -> \
"1c006f73-fae6-4b10-a7c9-3286c6bd7526",
 CellID->2047873064],
Cell[8139, 246, 708, 21, 22, "ProofText", "ExpressionUUID" -> \
"425e2813-7efc-4522-8bcb-cf4b5291cd89",
 CellID->676164419],
Cell[8850, 269, 324, 7, 18, "ProofText", "ExpressionUUID" -> \
"20e8603f-427b-4391-948b-fede31ec8ced",
 CellID->148567486],
Cell[9177, 278, 278, 6, 39, "ProofText", "ExpressionUUID" -> \
"a92ba958-a1a2-4a42-918e-21ab1ae1201b",
 CellID->304245334],
Cell[9458, 286, 782, 21, 20, "ProofText", "ExpressionUUID" -> \
"b130a07b-6aed-476f-90e5-8ddc1d506b24",
 CellID->1029126483],
Cell[10243, 309, 976, 26, 39, "ProofText", "ExpressionUUID" -> \
"a57829c6-ada2-436a-9768-0af166184e26",
 CellID->858890241],
Cell[11222, 337, 325, 9, 20, "ProofText", "ExpressionUUID" -> \
"12bc4e40-c13a-4abb-b42a-fb053254cb93",
 CellID->1462966552],
Cell[11550, 348, 352, 8, 18, "ProofText", "ExpressionUUID" -> \
"c38cd345-285a-4bad-93d5-3903f5536477",
 CellID->464530090],
Cell[11905, 358, 239, 5, 18, "ProofText", "ExpressionUUID" -> \
"5bffb091-ab61-4a8e-a041-70fcb81979ba",
 CellID->842835447],
Cell[12147, 365, 529, 15, 20, "ProofText", "ExpressionUUID" -> \
"62cd3bbe-82a7-4678-acde-d60e30c68909",
 CellID->964445162],
Cell[12679, 382, 760, 22, 22, "ProofText", "ExpressionUUID" -> \
"b2732595-9b56-4ae7-8761-6b6a96ab592e",
 CellID->1918140120],
Cell[13442, 406, 414, 9, 19, "ProofText", "ExpressionUUID" -> \
"6af6d2a4-d5c4-4803-b540-39e49412fa02",
 CellID->8562551]
}
]
*)

