(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5819,        169]
NotebookOptionsPosition[      4740,        137]
NotebookOutlinePosition[      5337,        157]
CellTagsIndexPosition[      5294,        154]
WindowTitle->Proof of (\:F523E')
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["thesis", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7179186107118807`*^9, 3.717918621000166*^9}},
 CellID->699870307,ExpressionUUID->"73286dc7-7add-44a7-aa33-f5b04509eaf6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["thesis", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`FORM$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<3\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.717918623158517*^9, 3.7179186551529007`*^9}},
 CellID->1742289933,ExpressionUUID->"bceb345e-b69e-4f80-8b14-dbd2146e017f"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<3\>\"", " ", "\"\<1\>\"", " ", "have", " ", 
  FormBox[
   StyleBox["P", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", "assumption"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.717918666078549*^9, 3.717918751476438*^9}},
 CellID->1937401549,ExpressionUUID->"43d5ee9b-b779-4f90-a5e7-2b4ba1005cc7"],

Cell[BoxData[
 RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
  FormBox[
   StyleBox["Q", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[Implies]E\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.717918740104966*^9, 3.717918760565197*^9}},
 CellID->191284288,ExpressionUUID->"ecc22e31-5d52-4fa5-8c6f-b84a34c98c3e"],

Cell[BoxData[
 RowBox[{"with", " ", "\"\<2\>\"", " ", "show", " ", 
  FormBox[
   StyleBox["thesis", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", "assumption"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7179187674505043`*^9, 3.717918785763817*^9}},
 CellID->2094261652,ExpressionUUID->"ef0d6800-0bdc-4d6e-9e5f-039376747661"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Implies]E')",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 450, 14, 20, "ProofText", "ExpressionUUID" -> \
"73286dc7-7add-44a7-aa33-f5b04509eaf6",
 CellID->699870307],
Cell[1044, 37, 2491, 67, 20, "ProofText", "ExpressionUUID" -> \
"bceb345e-b69e-4f80-8b14-dbd2146e017f",
 CellID->1742289933],
Cell[3538, 106, 357, 7, 18, "ProofText", "ExpressionUUID" -> \
"43d5ee9b-b779-4f90-a5e7-2b4ba1005cc7",
 CellID->1937401549],
Cell[3898, 115, 397, 9, 18, "ProofText", "ExpressionUUID" -> \
"ecc22e31-5d52-4fa5-8c6f-b84a34c98c3e",
 CellID->191284288],
Cell[4298, 126, 438, 9, 19, "ProofText", "ExpressionUUID" -> \
"ef0d6800-0bdc-4d6e-9e5f-039376747661",
 CellID->2094261652]
}
]
*)

