(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4880,        141]
NotebookOptionsPosition[      3932,        112]
NotebookOutlinePosition[      4524,        132]
CellTagsIndexPosition[      4481,        129]
WindowTitle->Proof of (\254I2)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["proof"], "ProofText",
 CellChangeTimes->{{3.715059511624938*^9, 3.7150595165722513`*^9}},
 CellID->1357746638,ExpressionUUID->"38a8312d-9b89-41ed-8335-9405d5eeb6f4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["R", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.71505942873559*^9, 3.7150594367674932`*^9}, 
   3.7150595200539923`*^9},
 CellID->1929814480,ExpressionUUID->"aac81bc2-03b3-48c1-b1fd-c8da4826fe81"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
    RowBox[{
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox["\[Not]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
          SyntaxForm->"\[Not]x"], 
         TagBox[
          StyleBox["R", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
        TagBox[")",
         "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
     RowBox[{"\[OpenCurlyQuote]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[CloseCurlyQuote]"}]}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7150594448173037`*^9, 3.715059474587797*^9}, {
  3.715059520771693*^9, 3.7150595359576902`*^9}},
 CellID->1364880570,ExpressionUUID->"cbb89a45-1dfb-4cd2-9183-1f8945eee72f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\"\<2\>\"", " ", "\"\<1\>\""}], ")"}], "[", 
     RowBox[{"OF", " ", 
      RowBox[{"\[OpenCurlyQuote]", 
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "\[CloseCurlyQuote]"}]}], "]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellChangeTimes->{{3.7150590092340393`*^9, 3.7150590400297823`*^9}, {
  3.715059113566833*^9, 3.7150591172393637`*^9}, {3.715059483052249*^9, 
  3.715059496547536*^9}, {3.715059539548832*^9, 3.715059577669142*^9}},
 CellID->576480111,ExpressionUUID->"0847c049-06eb-4d14-9a23-ef2670fa19e4"]
},
WindowSize->{808, 869},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Proof of (\[Not]I2)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 179, 2, 18, "ProofText", "ExpressionUUID" -> \
"38a8312d-9b89-41ed-8335-9405d5eeb6f4",
 CellID->1357746638],
Cell[771, 25, 406, 12, 20, "ProofText", "ExpressionUUID" -> \
"aac81bc2-03b3-48c1-b1fd-c8da4826fe81",
 CellID->1929814480],
Cell[1180, 39, 2004, 52, 20, "ProofText", "ExpressionUUID" -> \
"cbb89a45-1dfb-4cd2-9183-1f8945eee72f",
 CellID->1364880570],
Cell[3187, 93, 741, 17, 21, "ProofText", "ExpressionUUID" -> \
"0847c049-06eb-4d14-9a23-ef2670fa19e4",
 CellID->576480111]
}
]
*)

(* End of internal cache information *)

