(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6496,        192]
NotebookOptionsPosition[      4907,        148]
NotebookOutlinePosition[      5516,        168]
CellTagsIndexPosition[      5473,        165]
WindowTitle->Proof of (\:F523\254 reverse)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191165384745626`*^9, 3.7191165668394403`*^9}, {
  3.71911659890349*^9, 3.719116601744166*^9}},
 CellID->1656969845,ExpressionUUID->"9799c52a-f357-4fea-b70b-6eef5abd50a1"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116604912951*^9, 3.719116607855575*^9}},
 CellID->503380419,ExpressionUUID->"180a7a79-f16c-46f8-b3e2-507f6f02aae9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116611682393*^9, 3.7191166221307983`*^9}, {
  3.719116673908752*^9, 3.719116675104665*^9}},
 CellID->121017002,ExpressionUUID->"92d05517-0d91-4130-9d5d-c512f2e25124"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<classical contradiction\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116643252211*^9, 3.719116657000124*^9}},
 CellID->527059871,ExpressionUUID->"76abb250-8c3b-4d38-91f0-e96ccc6d8e4a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116659885621*^9, 3.71911666848433*^9}},
 CellID->1200896542,ExpressionUUID->"30b97f04-a6a9-4255-ac5b-c53df0de3d93"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", "\"\<*\>\"", " ", "have", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<modus ponens\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116681698531*^9, 3.719116701218292*^9}},
 CellID->1673291761,ExpressionUUID->"bd1d03ed-0054-4365-aaf8-f2a2fb832c99"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116704179524*^9, 3.719116719821765*^9}},
 CellID->1103554519,ExpressionUUID->"c0ba9e21-9f3c-46c2-8a19-a8e3240d94de"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719116722915859*^9, 3.719116726392885*^9}},
 CellID->155183403,ExpressionUUID->"ceff313f-77ff-472c-befb-e55b39828ab6"],

Cell[BoxData[
 RowBox[{"qed", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"intro", " ", "\"\<\[Implies]I\>\""}], ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Not]E\>\""}], ",", " ", "assumption"}], 
   ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719116736192389*^9, 3.719116782049437*^9}},
 CellID->2011563327,ExpressionUUID->"57d616dc-3497-49b9-a231-53c264d9becf"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Implies]\[Not] reverse)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 350, 9, 20, "ProofText", "ExpressionUUID" -> \
"9799c52a-f357-4fea-b70b-6eef5abd50a1",
 CellID->1656969845],
Cell[954, 32, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"180a7a79-f16c-46f8-b3e2-507f6f02aae9",
 CellID->503380419],
Cell[1191, 38, 1179, 33, 20, "ProofText", "ExpressionUUID" -> \
"92d05517-0d91-4130-9d5d-c512f2e25124",
 CellID->121017002],
Cell[2373, 73, 451, 13, 39, "ProofText", "ExpressionUUID" -> \
"76abb250-8c3b-4d38-91f0-e96ccc6d8e4a",
 CellID->527059871],
Cell[2827, 88, 415, 11, 20, "ProofText", "ExpressionUUID" -> \
"30b97f04-a6a9-4255-ac5b-c53df0de3d93",
 CellID->1200896542],
Cell[3245, 101, 425, 10, 18, "ProofText", "ExpressionUUID" -> \
"bd1d03ed-0054-4365-aaf8-f2a2fb832c99",
 CellID->1673291761],
Cell[3673, 113, 509, 13, 18, "ProofText", "ExpressionUUID" -> \
"c0ba9e21-9f3c-46c2-8a19-a8e3240d94de",
 CellID->1103554519],
Cell[4185, 128, 237, 5, 18, "ProofText", "ExpressionUUID" -> \
"ceff313f-77ff-472c-befb-e55b39828ab6",
 CellID->155183403],
Cell[4425, 135, 478, 11, 20, "ProofText", "ExpressionUUID" -> \
"57d616dc-3497-49b9-a231-53c264d9becf",
 CellID->2011563327]
}
]
*)

