(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5555,        170]
NotebookOptionsPosition[      4348,        135]
NotebookOutlinePosition[      4950,        155]
CellTagsIndexPosition[      4907,        152]
WindowTitle->Proof of (contraposition np)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451770606407*^9, 3.718451775875128*^9}},
 CellID->245651762,ExpressionUUID->"2ab5ad60-d5a7-485d-8203-8d177d79aa05"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184517814450912`*^9, 3.718451800100272*^9}, {
  3.718451965225148*^9, 3.7184519686535263`*^9}},
 CellID->1588136335,ExpressionUUID->"2ddaa8e8-4f72-45ad-a40d-771a0ca3f30b"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<classical\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451809154937*^9, 3.718451822356215*^9}},
 CellID->1238140706,ExpressionUUID->"0a0ab344-e55b-4cb2-a77c-ff296d804b88"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184518654735117`*^9, 3.718451876029046*^9}},
 CellID->49637402,ExpressionUUID->"ce139975-612e-424e-8b84-7cf102d11a71"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184518826917*^9, 3.7184518946956863`*^9}, 
   3.718451974501883*^9},
 CellID->703580730,ExpressionUUID->"7cba260f-9087-451d-89ed-243284dbd1d7"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718451900052923*^9, 3.718451913979713*^9}, {
  3.7184519782369127`*^9, 3.718451981068902*^9}},
 CellID->905444750,ExpressionUUID->"4246bce2-66eb-4d72-87f6-7effbccbfa47"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (contraposition np)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 370, 11, 20, "ProofText", "ExpressionUUID" -> \
"2ab5ad60-d5a7-485d-8203-8d177d79aa05",
 CellID->245651762],
Cell[973, 34, 1449, 42, 20, "ProofText", "ExpressionUUID" -> \
"2ddaa8e8-4f72-45ad-a40d-771a0ca3f30b",
 CellID->1588136335],
Cell[2425, 78, 442, 11, 39, "ProofText", "ExpressionUUID" -> \
"0a0ab344-e55b-4cb2-a77c-ff296d804b88",
 CellID->1238140706],
Cell[2870, 91, 414, 11, 20, "ProofText", "ExpressionUUID" -> \
"ce139975-612e-424e-8b84-7cf102d11a71",
 CellID->49637402],
Cell[3287, 104, 467, 12, 18, "ProofText", "ExpressionUUID" -> \
"7cba260f-9087-451d-89ed-243284dbd1d7",
 CellID->703580730],
Cell[3757, 118, 587, 15, 19, "ProofText", "ExpressionUUID" -> \
"4246bce2-66eb-4d72-87f6-7effbccbfa47",
 CellID->905444750]
}
]
*)

