(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10630,        312]
NotebookOptionsPosition[      8421,        253]
NotebookOutlinePosition[      9023,        273]
CellTagsIndexPosition[      8980,        270]
WindowTitle->Proof of (\:2228E1 classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184533484142437`*^9, 3.718453356229343*^9}},
 CellID->317046539,ExpressionUUID->"0fc41ce5-3d35-4fff-959e-88152fc5110b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<disj\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["R", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184533652058067`*^9, 3.718453401997809*^9}, {
  3.719122850661725*^9, 3.719122868356265*^9}},
 CellID->1690460601,ExpressionUUID->"52039814-de91-41b6-887b-7f19053088c8"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453412679021*^9, 3.718453433990211*^9}},
 CellID->1382190333,ExpressionUUID->"59504b1e-162b-4340-b591-2962a64550c8"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  FormBox[
   StyleBox["R", "ExpressionABF"],
   TheoremaForm]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453437103424*^9, 3.718453442138064*^9}, {
  3.7191228940543413`*^9, 3.71912289735817*^9}},
 CellID->1695004691,ExpressionUUID->"259c8395-6dc3-4f66-86df-27dabb8a4a7d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453445495029*^9, 3.718453449616276*^9}},
 CellID->15891537,ExpressionUUID->"b60f0be6-7f4a-4d78-9744-1528e89318b2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453478803009*^9, 3.718453487239769*^9}, 
   3.71912295054261*^9},
 CellID->1886159545,ExpressionUUID->"08018605-2d8e-424a-a94a-5478aab18d54"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845348944554*^9, 3.718453491432213*^9}},
 CellID->1582481557,ExpressionUUID->"09ae6e60-b452-4480-b511-bab9d29b6ea3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453493289164*^9, 3.718453501731073*^9}},
 CellID->1881560526,ExpressionUUID->"ce590bad-f0d4-4a62-934a-5994dfbf7c72"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<disj\>\"", " ", "show", " ", "_"}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453503924453*^9, 3.718453509640131*^9}, {
  3.7191229735832653`*^9, 3.719122981910845*^9}},
 CellID->1496024001,ExpressionUUID->"2653e2bb-72c6-4810-a90e-3b20e27cddec"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719122985339487*^9, 3.719122989593388*^9}},
 CellID->119755217,ExpressionUUID->"a506c714-30a5-4df4-9598-d3e6d6ff634d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7191229913775997`*^9, 3.7191230038737926`*^9}},
 CellID->859263044,ExpressionUUID->"6bdcdb82-def6-4421-b601-7fbb4acd37d6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123006526626*^9, 3.7191230101358767`*^9}},
 CellID->1234582722,ExpressionUUID->"3b969668-befe-4c4a-84e5-603fd0e43253"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719123013614477*^9, 3.719123019423964*^9}},
 CellID->859080878,ExpressionUUID->"896cf913-d917-4376-a477-65aa535899df"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.719123024193721*^9, 3.719123039313442*^9}},
 CellID->1985209373,ExpressionUUID->"0f06ed82-dce6-40c9-a3c8-ca0e8631b6a8"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or]E1 classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"0fc41ce5-3d35-4fff-959e-88152fc5110b",
 CellID->317046539],
Cell[1049, 37, 2838, 77, 20, "ProofText", "ExpressionUUID" -> \
"52039814-de91-41b6-887b-7f19053088c8",
 CellID->1690460601],
Cell[3890, 116, 567, 15, 18, "ProofText", "ExpressionUUID" -> \
"59504b1e-162b-4340-b591-2962a64550c8",
 CellID->1382190333],
Cell[4460, 133, 345, 8, 39, "ProofText", "ExpressionUUID" -> \
"259c8395-6dc3-4f66-86df-27dabb8a4a7d",
 CellID->1695004691],
Cell[4808, 143, 320, 9, 20, "ProofText", "ExpressionUUID" -> \
"b60f0be6-7f4a-4d78-9744-1528e89318b2",
 CellID->15891537],
Cell[5131, 154, 343, 8, 18, "ProofText", "ExpressionUUID" -> \
"08018605-2d8e-424a-a94a-5478aab18d54",
 CellID->1886159545],
Cell[5477, 164, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"09ae6e60-b452-4480-b511-bab9d29b6ea3",
 CellID->1582481557],
Cell[5699, 170, 412, 11, 20, "ProofText", "ExpressionUUID" -> \
"ce590bad-f0d4-4a62-934a-5994dfbf7c72",
 CellID->1881560526],
Cell[6114, 183, 361, 8, 39, "ProofText", "ExpressionUUID" -> \
"2653e2bb-72c6-4810-a90e-3b20e27cddec",
 CellID->1496024001],
Cell[6478, 193, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"a506c714-30a5-4df4-9598-d3e6d6ff634d",
 CellID->119755217],
Cell[6804, 204, 450, 12, 18, "ProofText", "ExpressionUUID" -> \
"6bdcdb82-def6-4421-b601-7fbb4acd37d6",
 CellID->859263044],
Cell[7257, 218, 241, 5, 18, "ProofText", "ExpressionUUID" -> \
"3b969668-befe-4c4a-84e5-603fd0e43253",
 CellID->1234582722],
Cell[7501, 225, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"896cf913-d917-4376-a477-65aa535899df",
 CellID->859080878],
Cell[7827, 236, 590, 15, 19, "ProofText", "ExpressionUUID" -> \
"0f06ed82-dce6-40c9-a3c8-ca0e8631b6a8",
 CellID->1985209373]
}
]
*)

