(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6976,        208]
NotebookOptionsPosition[      5393,        164]
NotebookOutlinePosition[      5995,        184]
CellTagsIndexPosition[      5952,        181]
WindowTitle->Proof of (\:2228I2 classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184525328787603`*^9, 3.7184525382293787`*^9}},
 CellID->207273297,ExpressionUUID->"2b5761fa-b251-4cf8-b3a3-8cdb3925afa6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452577225807*^9, 3.718452589956139*^9}, {
  3.7184527096546593`*^9, 3.718452711375792*^9}},
 CellID->882525460,ExpressionUUID->"5d2bba6b-be45-45d0-8b43-173ae08074a8"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452545184613*^9, 3.718452574204536*^9}, {
  3.718452713999415*^9, 3.718452715094755*^9}},
 CellID->1168467108,ExpressionUUID->"bbd6c3f5-9176-4e0d-b9d8-f3244620f489"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["P", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
    TagBox["\[Or]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
     SyntaxForm->"x\[Or]y"], 
    TagBox[
     StyleBox["Q", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452568337882*^9, 3.718452603164507*^9}},
 CellID->1896624645,ExpressionUUID->"29094454-297e-4a15-af53-92730775457f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452606131966*^9, 3.718452612876959*^9}, 
   3.7184527197105417`*^9},
 CellID->677531929,ExpressionUUID->"d6771969-24a1-4da4-8438-0ba82c4158a6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452618448772*^9, 3.71845263815057*^9}, 
   3.718452722854368*^9},
 CellID->1692934647,ExpressionUUID->"b10e7ce6-3cf8-4719-9d92-950c12861f31"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184526425097113`*^9, 3.7184526451894712`*^9}},
 CellID->650417045,ExpressionUUID->"ec599644-074b-48bb-b6fa-0881fb30aae3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718452648793027*^9, 3.718452658192713*^9}, 
   3.718452725272702*^9},
 CellID->529582062,ExpressionUUID->"c7668c29-7fe8-40eb-a3e8-95f06bf8fcd4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ",", " ", 
     RowBox[{"rule", " ", "\"\<*\>\""}], ",", " ", "fact"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718452665867859*^9, 3.718452686661427*^9}, 
   3.718452727270753*^9},
 CellID->1938586409,ExpressionUUID->"873d9951-c921-4e17-9b0a-8797105e6206"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Or]I2 classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 374, 11, 20, "ProofText", "ExpressionUUID" -> \
"2b5761fa-b251-4cf8-b3a3-8cdb3925afa6",
 CellID->207273297],
Cell[978, 34, 1156, 32, 20, "ProofText", "ExpressionUUID" -> \
"5d2bba6b-be45-45d0-8b43-173ae08074a8",
 CellID->882525460],
Cell[2137, 68, 616, 16, 18, "ProofText", "ExpressionUUID" -> \
"bbd6c3f5-9176-4e0d-b9d8-f3244620f489",
 CellID->1168467108],
Cell[2756, 86, 727, 19, 39, "ProofText", "ExpressionUUID" -> \
"29094454-297e-4a15-af53-92730775457f",
 CellID->1896624645],
Cell[3486, 107, 349, 10, 20, "ProofText", "ExpressionUUID" -> \
"d6771969-24a1-4da4-8438-0ba82c4158a6",
 CellID->677531929],
Cell[3838, 119, 349, 8, 18, "ProofText", "ExpressionUUID" -> \
"b10e7ce6-3cf8-4719-9d92-950c12861f31",
 CellID->1692934647],
Cell[4190, 129, 223, 4, 18, "ProofText", "ExpressionUUID" -> \
"ec599644-074b-48bb-b6fa-0881fb30aae3",
 CellID->650417045],
Cell[4416, 135, 437, 12, 20, "ProofText", "ExpressionUUID" -> \
"c7668c29-7fe8-40eb-a3e8-95f06bf8fcd4",
 CellID->529582062],
Cell[4856, 149, 533, 13, 20, "ProofText", "ExpressionUUID" -> \
"873d9951-c921-4e17-9b0a-8797105e6206",
 CellID->1938586409]
}
]
*)

