(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5585,        171]
NotebookOptionsPosition[      4378,        136]
NotebookOutlinePosition[      4980,        156]
CellTagsIndexPosition[      4937,        153]
WindowTitle->Proof of (contraposition pp)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451770606407*^9, 3.718451775875128*^9}},
 CellID->245651762,ExpressionUUID->"2144779f-f71c-4f8c-a6e3-87f69f890ea7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<*\>\""}], 
   ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184517814450912`*^9, 3.718451800100272*^9}},
 CellID->1588136335,ExpressionUUID->"a9d4a44e-1c41-4f03-9f9c-7d8674211190"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<classical\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718451809154937*^9, 3.718451822356215*^9}},
 CellID->1238140706,ExpressionUUID->"9e45d15d-518c-4c81-8b71-a17ab42c144b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184518654735117`*^9, 3.718451876029046*^9}},
 CellID->49637402,ExpressionUUID->"0e38b3d2-2c0d-4876-9575-282d61a88368"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184518826917*^9, 3.7184518946956863`*^9}},
 CellID->703580730,ExpressionUUID->"d5a59073-5cb9-4b1e-8a03-2b8c80ef00dd"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718451900052923*^9, 3.718451913979713*^9}},
 CellID->905444750,ExpressionUUID->"af15b9a7-c438-4ec8-9da4-f399ecf8ce95"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (contraposition pp)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 370, 11, 20, "ProofText", "ExpressionUUID" -> \
"2144779f-f71c-4f8c-a6e3-87f69f890ea7",
 CellID->245651762],
Cell[973, 34, 1544, 45, 20, "ProofText", "ExpressionUUID" -> \
"a9d4a44e-1c41-4f03-9f9c-7d8674211190",
 CellID->1588136335],
Cell[2520, 81, 442, 11, 39, "ProofText", "ExpressionUUID" -> \
"9e45d15d-518c-4c81-8b71-a17ab42c144b",
 CellID->1238140706],
Cell[2965, 94, 414, 11, 20, "ProofText", "ExpressionUUID" -> \
"0e38b3d2-2c0d-4876-9575-282d61a88368",
 CellID->49637402],
Cell[3382, 107, 469, 12, 18, "ProofText", "ExpressionUUID" -> \
"d5a59073-5cb9-4b1e-8a03-2b8c80ef00dd",
 CellID->703580730],
Cell[3854, 121, 520, 13, 19, "ProofText", "ExpressionUUID" -> \
"af15b9a7-c438-4ec8-9da4-f399ecf8ce95",
 CellID->905444750]
}
]
*)

