(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15314,        413]
NotebookOptionsPosition[     14104,        378]
NotebookOutlinePosition[     14695,        398]
CellTagsIndexPosition[     14652,        395]
WindowTitle->Proof of (theCI2)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363139078302*^9, 3.718363149698311*^9}, {
  3.718363195999001*^9, 3.718363203092044*^9}, {3.7184404244072247`*^9, 
  3.7184404270832663`*^9}},
 CellID->1802491860,ExpressionUUID->"2c73bf0e-4e36-497f-b143-5796c67fb8b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<unique\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}], 
        TagBox["\[LongRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
         SyntaxForm->"x\[LongRightArrow]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["a", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183632056086483`*^9, 3.71836321457099*^9}, {
  3.718431865535541*^9, 3.718431879236897*^9}, {3.718440431223811*^9, 
  3.718440448295657*^9}},
 CellID->1683919478,ExpressionUUID->"e1a5fc39-9b15-4ca9-98ec-cfa03c7ca750"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["A", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", "x"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FormBox[
         StyleBox["Q", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}], " ", "\[And]", " ", 
       RowBox[{
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}], " ", "\[And]", " ", 
       RowBox[{"(", 
        RowBox[{
         UnderscriptBox["\[ForAll]", 
          RowBox[{
           FormBox[
            StyleBox["Q", "ExpressionABF"],
            TheoremaForm], "[", "y", "]"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            FormBox[
             StyleBox["P", "ExpressionABF"],
             TheoremaForm], "[", "y", "]"}], "\[Implies]", 
           RowBox[{"(", 
            RowBox[{"y", "\[Equal]", "x"}], ")"}]}], ")"}]}], ")"}]}], 
      ")"}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363222597866*^9, 3.7183632547877827`*^9}, {
  3.7184317723761806`*^9, 3.718431821681467*^9}, {3.718440459400053*^9, 
  3.718440470460957*^9}},
 CellID->1159315994,ExpressionUUID->"05a16aea-bb1d-4906-98a3-f18ee83e791c"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<SomeI\>\""}], ",", " ", 
     RowBox[{"intro", " ", "\"\<\[And]I\>\""}], ",", " ", "fact", ",", " ", 
     "fact", ",", " ", 
     RowBox[{
     "intro", " ", "\"\<\[ForAll]CI\>\"", " ", "\"\<\[Implies]I\>\""}], ",", 
     " ", 
     RowBox[{"elim", " ", "\"\<unique\>\""}]}], ")"}]}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718363267138813*^9, 3.718363345037739*^9}, {
  3.718431832296833*^9, 3.71843183274472*^9}, {3.71843216190112*^9, 
  3.7184322559428787`*^9}, {3.718440487616537*^9, 3.718440543617199*^9}},
 CellID->1751882754,ExpressionUUID->"9d43a619-362c-49a6-aad2-c68a0be853d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     RowBox[{
      TagBox["Some",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`Some$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      "[", 
      RowBox[{
       UnderscriptBox["\[Lambda]", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          TagBox[
           StyleBox["Q", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
         TagBox["\[And]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
          SyntaxForm->"x\[And]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           RowBox[{
            TagBox[
             StyleBox["P", "ExpressionABF"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`FUN$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                Theorema`Knowledge`BOOL$TM]]]], "[", 
            TagBox[
             StyleBox["x", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
           TagBox["\[And]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
            SyntaxForm->"x\[And]y"], 
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             UnderscriptBox[
              TagBox["\[ForAll]",
               Theorema`Language`TAG$[
                Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
              RowBox[{
               TagBox[
                StyleBox["Q", "ExpressionABF"],
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[
                  Theorema`Language`FUN$TM[
                   Theorema`Language`TFIX$[
                   Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                   Theorema`Knowledge`BOOL$TM]]]], "[", 
               TagBox[
                StyleBox["y", "ExpressionVariable"],
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                TagBox[
                 StyleBox["P", "ExpressionABF"],
                 Theorema`Language`TAG$[
                  Theorema`Language`TYPED$[
                   Theorema`Language`FUN$TM[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                    Theorema`Knowledge`BOOL$TM]]]], "[", 
                TagBox[
                 StyleBox["y", "ExpressionVariable"],
                 Theorema`Language`TAG$[
                  Theorema`Language`TYPED$[
                   Theorema`Language`TFIX$[
                   Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
               TagBox["\[Implies]",
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
                SyntaxForm->"x\[Implies]y"], 
               RowBox[{
                TagBox["(",
                 "AutoParentheses"], 
                RowBox[{
                 TagBox[
                  StyleBox["y", "ExpressionVariable"],
                  Theorema`Language`TAG$[
                   Theorema`Language`TYPED$[
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
                 TagBox["\[Equal]",
                  Theorema`Language`TAG$[
                   Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
                    Theorema`Language`TFIX$[
                    Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
                  SyntaxForm->"x\[Equal]y"], 
                 StyleBox["x", "ExpressionVariable"]}], 
                TagBox[")",
                 "AutoParentheses"]}]}], ")"}]}], 
            TagBox[")",
             "AutoParentheses"]}]}], 
          TagBox[")",
           "AutoParentheses"]}]}], ")"}]}], "]"}], "]"}], 
    "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718439705075212*^9, 3.71843981380048*^9}, {
  3.71844013828284*^9, 3.718440172596448*^9}, {3.71844027691743*^9, 
  3.718440336406343*^9}, {3.718440367697981*^9, 3.718440369087517*^9}, {
  3.718440572377429*^9, 3.718440695985751*^9}, {3.718440726579547*^9, 
  3.718440769315752*^9}, {3.718440807315618*^9, 3.718440811708222*^9}, {
  3.7184408629563313`*^9, 3.718440904477152*^9}, {3.718440953247089*^9, 
  3.718440968621978*^9}},
 CellID->1498773338,ExpressionUUID->"ac3aad3a-883b-424f-85da-f9620e93d560"],

Cell[BoxData[
 RowBox[{"thus", " ", "_", " ", "unfolding", " ", 
  RowBox[{"\"\<the def\>\"", " ", "."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718363358207903*^9, 3.718363370989541*^9}, {
   3.718431838985147*^9, 3.71843184473726*^9}, {3.718431918849855*^9, 
   3.718432009043539*^9}, {3.718432048859359*^9, 3.718432104244513*^9}, 
   3.7184387748271523`*^9, {3.71844035742153*^9, 3.718440357967019*^9}, 
   3.7184407118023663`*^9, {3.718440909948374*^9, 3.718440910220894*^9}, {
   3.718440974774157*^9, 3.7184409929973373`*^9}},
 CellID->1067176506,ExpressionUUID->"d1ea49ee-4453-487a-8eb9-ed9564d6c40f"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (theCI2)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 546, 16, 20, "ProofText", "ExpressionUUID" -> \
"2c73bf0e-4e36-497f-b143-5796c67fb8b7",
 CellID->1802491860],
Cell[1138, 39, 3852, 106, 28, "ProofText", "ExpressionUUID" -> \
"e1a5fc39-9b15-4ca9-98ec-cfa03c7ca750",
 CellID->1683919478],
Cell[4993, 147, 1344, 39, 35, "ProofText", "ExpressionUUID" -> \
"05a16aea-bb1d-4906-98a3-f18ee83e791c",
 CellID->1159315994],
Cell[6340, 188, 1023, 26, 41, "ProofText", "ExpressionUUID" -> \
"9d43a619-362c-49a6-aad2-c68a0be853d6",
 CellID->1751882754],
Cell[7366, 216, 6012, 146, 35, "ProofText", "ExpressionUUID" -> \
"ac3aad3a-883b-424f-85da-f9620e93d560",
 CellID->1498773338],
Cell[13381, 364, 719, 12, 19, "ProofText", "ExpressionUUID" -> \
"d1ea49ee-4453-487a-8eb9-ed9564d6c40f",
 CellID->1067176506]
}
]
*)

