(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     22739,        653]
NotebookOptionsPosition[     19771,        576]
NotebookOutlinePosition[     20365,        596]
CellTagsIndexPosition[     20322,        593]
WindowTitle->Proof of (If split')
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196531996757708`*^9, 3.7196532105631332`*^9}},
 CellID->1549079474,ExpressionUUID->"a00163db-d2b9-43a3-9cbc-88af50fe5b84"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653212724545*^9, 3.7196532155597277`*^9}},
 CellID->811428632,ExpressionUUID->"2d687a04-c370-4a0c-92ce-f7fb1987306d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      RowBox[{
       TagBox["\[Piecewise]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"\[Piecewise]x"], GridBox[{
         {
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]},
         {
          TagBox[
           StyleBox["y", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          "True"}
        }]}], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653221917264*^9, 3.719653240041939*^9}},
 CellID->1783994644,ExpressionUUID->"68ffa789-5792-4b82-99ed-1713b4e387ea"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox["\[Not]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
           SyntaxForm->"\[Not]x"], 
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rule", " ", "\"\<\[Or]I2 classical\>\""}], ",", " ", "simp"}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196532465756083`*^9, 3.719653269840835*^9}, {
  3.719654060643178*^9, 3.719654110162693*^9}},
 CellID->1082447722,ExpressionUUID->"6a70be0b-31c2-4895-b3a0-317dd0310cac"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654129971797*^9, 3.719654146768387*^9}},
 CellID->280032349,ExpressionUUID->"4775f85e-b8bf-4e0a-829f-1fd9d5d5ee6a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Or]E1 classical\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654150052108*^9, 3.719654206427252*^9}},
 CellID->381066545,ExpressionUUID->"4c23b7bd-cb76-43e9-8e5e-4f3fb37fe792"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653273926343*^9, 3.7196532817037992`*^9}, 
   3.7196542311877203`*^9},
 CellID->1636219949,ExpressionUUID->"d696587e-f2a4-4b91-adb7-1f0a3c0370b3"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", "_"}], "\n", "\t\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654245496385*^9, 3.7196542563163967`*^9}},
 CellID->2041682381,ExpressionUUID->"2d44f8f9-4dcd-4832-901e-5dd0fc7388be"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"from", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "\"\<*\>\"", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653288205364*^9, 3.71965334362519*^9}, {
  3.71965426900561*^9, 3.719654273669258*^9}},
 CellID->184893994,ExpressionUUID->"2ff556d1-f2c6-479b-ae22-52502babd648"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71965334724223*^9, 3.719653350065441*^9}, {
  3.7196542818204403`*^9, 3.719654291516396*^9}},
 CellID->1030945612,ExpressionUUID->"755753ff-e2ee-43a1-8d22-e6dad312b73c"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653352027009*^9, 3.7196533607964277`*^9}, {
  3.719654293435903*^9, 3.719654322804963*^9}},
 CellID->563407017,ExpressionUUID->"b83ce608-3184-475b-8597-93d60599909b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
  "from", " ", "this", " ", "\"\<*\>\"", " ", "show", " ", "_", " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653288205364*^9, 3.719653369969645*^9}, {
  3.719654326109761*^9, 3.7196543302698593`*^9}},
 CellID->7738324,ExpressionUUID->"56ac4ca0-f57b-4a50-808c-addd85c84a14"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653372834073*^9, 3.719653378577292*^9}, {
  3.71965434429396*^9, 3.719654354637953*^9}},
 CellID->1847851622,ExpressionUUID->"61d6259a-1e33-463c-af7b-2ca253d76b4c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox["\[Not]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
           SyntaxForm->"\[Not]x"], 
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653381875473*^9, 3.719653397761272*^9}, 
   3.719654364145471*^9},
 CellID->2127038111,ExpressionUUID->"1ab834bf-50f3-4c88-b789-552e84054542"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      RowBox[{
       TagBox["\[Piecewise]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"\[Piecewise]x"], GridBox[{
         {
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]},
         {
          TagBox[
           StyleBox["y", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          "True"}
        }]}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653445373876*^9, 3.719653461394618*^9}, 
   3.7196535005554047`*^9, {3.719653750494095*^9, 3.7196537572704477`*^9}, {
   3.719654373765984*^9, 3.719654380670827*^9}},
 CellID->282813688,ExpressionUUID->"d818c4af-63d4-475b-a418-99129f3c3d69"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "\[And]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71965376109028*^9, 3.719653766297531*^9}, {
  3.719654394456225*^9, 3.719654405998547*^9}},
 CellID->2101435261,ExpressionUUID->"03935123-a803-425d-9e98-8a6739747133"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719654409860436*^9, 3.719654438742962*^9}},
 CellID->705627365,ExpressionUUID->"aa4e29eb-74b5-4695-83fe-639f82bf7168"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653830418902*^9, 3.719653835407381*^9}},
 CellID->212594382,ExpressionUUID->"72fe349b-d77a-4a82-befe-88eb81b55f8a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["y", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196538369558563`*^9, 3.719653844981365*^9}, {
  3.719654454902813*^9, 3.719654455367927*^9}},
 CellID->718617240,ExpressionUUID->"d7b457b1-2e62-48ea-b2d7-67bd4ac968b3"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.71965386778349*^9, 3.719653887609418*^9}, {
  3.719654466526474*^9, 3.719654466910884*^9}},
 CellID->1169424756,ExpressionUUID->"b708f69e-1daf-419a-9dd5-53f76fc7a48f"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If split')",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 521, 17, 20, "ProofText", "ExpressionUUID" -> \
"a00163db-d2b9-43a3-9cbc-88af50fe5b84",
 CellID->1549079474],
Cell[1116, 40, 236, 4, 39, "ProofText", "ExpressionUUID" -> \
"2d687a04-c370-4a0c-92ce-f7fb1987306d",
 CellID->811428632],
Cell[1355, 46, 1648, 43, 35, "ProofText", "ExpressionUUID" -> \
"68ffa789-5792-4b82-99ed-1713b4e387ea",
 CellID->1783994644],
Cell[3006, 91, 2980, 84, 41, "ProofText", "ExpressionUUID" -> \
"6a70be0b-31c2-4895-b3a0-317dd0310cac",
 CellID->1082447722],
Cell[5989, 177, 1461, 41, 20, "ProofText", "ExpressionUUID" -> \
"4775f85e-b8bf-4e0a-829f-1fd9d5d5ee6a",
 CellID->280032349],
Cell[7453, 220, 1266, 34, 39, "ProofText", "ExpressionUUID" -> \
"4c23b7bd-cb76-43e9-8e5e-4f3fb37fe792",
 CellID->381066545],
Cell[8722, 256, 356, 10, 20, "ProofText", "ExpressionUUID" -> \
"d696587e-f2a4-4b91-adb7-1f0a3c0370b3",
 CellID->1636219949],
Cell[9081, 268, 282, 6, 39, "ProofText", "ExpressionUUID" -> \
"2d44f8f9-4dcd-4832-901e-5dd0fc7388be",
 CellID->2041682381],
Cell[9366, 276, 710, 19, 18, "ProofText", "ExpressionUUID" -> \
"2ff556d1-f2c6-479b-ae22-52502babd648",
 CellID->184893994],
Cell[10079, 297, 339, 7, 39, "ProofText", "ExpressionUUID" -> \
"755753ff-e2ee-43a1-8d22-e6dad312b73c",
 CellID->1030945612],
Cell[10421, 306, 758, 22, 20, "ProofText", "ExpressionUUID" -> \
"b83ce608-3184-475b-8597-93d60599909b",
 CellID->563407017],
Cell[11182, 330, 443, 11, 18, "ProofText", "ExpressionUUID" -> \
"56ac4ca0-f57b-4a50-808c-addd85c84a14",
 CellID->7738324],
Cell[11628, 343, 371, 8, 59, "ProofText", "ExpressionUUID" -> \
"61d6259a-1e33-463c-af7b-2ca253d76b4c",
 CellID->1847851622],
Cell[12002, 353, 2802, 80, 20, "ProofText", "ExpressionUUID" -> \
"1ab834bf-50f3-4c88-b789-552e84054542",
 CellID->2127038111],
Cell[14807, 435, 1753, 45, 58, "ProofText", "ExpressionUUID" -> \
"d818c4af-63d4-475b-a418-99129f3c3d69",
 CellID->282813688],
Cell[16563, 482, 653, 20, 20, "ProofText", "ExpressionUUID" -> \
"03935123-a803-425d-9e98-8a6739747133",
 CellID->2101435261],
Cell[17219, 504, 330, 7, 18, "ProofText", "ExpressionUUID" -> \
"aa4e29eb-74b5-4695-83fe-639f82bf7168",
 CellID->705627365],
Cell[17552, 513, 238, 5, 18, "ProofText", "ExpressionUUID" -> \
"72fe349b-d77a-4a82-befe-88eb81b55f8a",
 CellID->212594382],
Cell[17793, 520, 1489, 41, 20, "ProofText", "ExpressionUUID" -> \
"d7b457b1-2e62-48ea-b2d7-67bd4ac968b3",
 CellID->718617240],
Cell[19285, 563, 482, 11, 19, "ProofText", "ExpressionUUID" -> \
"b708f69e-1daf-419a-9dd5-53f76fc7a48f",
 CellID->1169424756]
}
]
*)

