(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12498,        366]
NotebookOptionsPosition[     10794,        319]
NotebookOutlinePosition[     11386,        339]
CellTagsIndexPosition[     11343,        336]
WindowTitle->Proof of (If cong)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x1", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y1", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655002487445*^9, 3.719655017652484*^9}},
 CellID->1186404467,ExpressionUUID->"a048f84d-1bc6-4ddb-b7ef-61aa3eb2de52"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[DoubleLeftRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
       SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P1", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["x1", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<3\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["y", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["y1", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655020292371*^9, 3.719655054631806*^9}, {
  3.7196552381516438`*^9, 3.719655238434087*^9}},
 CellID->340126961,ExpressionUUID->"1d033ce4-f2b6-4139-92da-fd5ec11a70b3"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox["\[Piecewise]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"\[Piecewise]x"], GridBox[{
        {
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "\[DoubleLeftArrow]", 
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]},
        {
         TagBox[
          StyleBox["y", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "\[DoubleLeftArrow]", "True"}
       }]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[Equal]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[Equal]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox["\[Piecewise]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"\[Piecewise]x"], GridBox[{
        {
         TagBox[
          StyleBox["x1", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "\[DoubleLeftArrow]", 
         TagBox[
          StyleBox["P1", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]},
        {
         TagBox[
          StyleBox["y1", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "\[DoubleLeftArrow]", "True"}
       }]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<1\>\""}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655059114818*^9, 3.719655083414806*^9}},
 CellID->1829660215,ExpressionUUID->"739afe4e-cd63-484a-9ab5-9fbd7a86ce31"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["P1", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655086497335*^9, 3.719655094918707*^9}},
 CellID->540943767,ExpressionUUID->"337b3360-1c80-4381-b4f6-0ee5efe6369d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["x1", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655118453669*^9, 3.7196551433117523`*^9}},
 CellID->1022732249,ExpressionUUID->"2a852cfb-ad92-4bc0-982f-4a2c87552e66"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   FormBox[
    StyleBox["P1", "ExpressionABF"],
    TheoremaForm], " ", "show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655146137617*^9, 3.71965516504871*^9}},
 CellID->387803932,ExpressionUUID->"7fcfbecf-f192-4f53-aac5-ef1d9ee54631"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655168243005*^9, 3.719655169976231*^9}},
 CellID->1679477711,ExpressionUUID->"2acc3184-a173-43bf-8dc6-87226747490a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P1", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719655172529306*^9, 3.719655182639802*^9}},
 CellID->640301611,ExpressionUUID->"8ff2d9e5-710a-43ae-ab81-e1a33e32f060"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["y1", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<3\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196551881598997`*^9, 3.71965520623291*^9}},
 CellID->582167598,ExpressionUUID->"e35a768d-cf6a-4f1f-92d3-7d6293c200b5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P1", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7196552440551777`*^9, 3.7196552637934027`*^9}},
 CellID->855422001,ExpressionUUID->"de100413-5464-48c0-a920-af6e7999edcb"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If cong)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 666, 23, 20, "ProofText", "ExpressionUUID" -> \
"a048f84d-1bc6-4ddb-b7ef-61aa3eb2de52",
 CellID->1186404467],
Cell[1259, 46, 3670, 100, 20, "ProofText", "ExpressionUUID" -> \
"1d033ce4-f2b6-4139-92da-fd5ec11a70b3",
 CellID->340126961],
Cell[4932, 148, 2755, 75, 58, "ProofText", "ExpressionUUID" -> \
"739afe4e-cd63-484a-9ab5-9fbd7a86ce31",
 CellID->1829660215],
Cell[7690, 225, 324, 9, 20, "ProofText", "ExpressionUUID" -> \
"337b3360-1c80-4381-b4f6-0ee5efe6369d",
 CellID->540943767],
Cell[8017, 236, 549, 15, 18, "ProofText", "ExpressionUUID" -> \
"2a852cfb-ad92-4bc0-982f-4a2c87552e66",
 CellID->1022732249],
Cell[8569, 253, 414, 10, 18, "ProofText", "ExpressionUUID" -> \
"7fcfbecf-f192-4f53-aac5-ef1d9ee54631",
 CellID->387803932],
Cell[8986, 265, 220, 4, 18, "ProofText", "ExpressionUUID" -> \
"2acc3184-a173-43bf-8dc6-87226747490a",
 CellID->1679477711],
Cell[9209, 271, 414, 11, 20, "ProofText", "ExpressionUUID" -> \
"8ff2d9e5-710a-43ae-ab81-e1a33e32f060",
 CellID->640301611],
Cell[9626, 284, 547, 15, 18, "ProofText", "ExpressionUUID" -> \
"e35a768d-cf6a-4f1f-92d3-7d6293c200b5",
 CellID->582167598],
Cell[10176, 301, 614, 16, 19, "ProofText", "ExpressionUUID" -> \
"de100413-5464-48c0-a920-af6e7999edcb",
 CellID->855422001]
}
]
*)

