(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     21575,        620]
NotebookOptionsPosition[     18611,        543]
NotebookOutlinePosition[     19204,        563]
CellTagsIndexPosition[     19161,        560]
WindowTitle->Proof of (If split)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196531996757708`*^9, 3.7196532105631332`*^9}},
 CellID->1549079474,ExpressionUUID->"7fa82e55-e5a4-4cba-9433-7fc22ab03d9b"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653212724545*^9, 3.7196532155597277`*^9}},
 CellID->811428632,ExpressionUUID->"46533d0b-9ee1-41fd-ab98-53387bf2c14e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      RowBox[{
       TagBox["\[Piecewise]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"\[Piecewise]x"], GridBox[{
         {
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]},
         {
          TagBox[
           StyleBox["y", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          "True"}
        }]}], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653221917264*^9, 3.719653240041939*^9}},
 CellID->1783994644,ExpressionUUID->"dd7fe691-dda4-41c0-bc7b-9dab92a4ee25"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox["\[Not]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
           SyntaxForm->"\[Not]x"], 
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"intro", " ", "\"\<\[And]I\>\"", " ", "\"\<\[Implies]I\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196532465756083`*^9, 3.719653269840835*^9}},
 CellID->1082447722,ExpressionUUID->"b2677c74-db4e-409c-af5c-04a5d4b9cec4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653273926343*^9, 3.7196532817037992`*^9}},
 CellID->1636219949,ExpressionUUID->"a1a27634-35fd-4295-be91-4b04d36be315"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", "this", " ", "\"\<*\>\"", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653288205364*^9, 3.71965334362519*^9}},
 CellID->184893994,ExpressionUUID->"e0801b9f-80cb-4b45-a014-9d6a0f1dce51"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71965334724223*^9, 3.719653350065441*^9}},
 CellID->1030945612,ExpressionUUID->"c734d233-8f51-491a-9697-990161c49265"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653352027009*^9, 3.7196533607964277`*^9}},
 CellID->563407017,ExpressionUUID->"c4329d75-769f-4a67-aece-f6dc7e0b73e7"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", "this", " ", "\"\<*\>\"", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653288205364*^9, 3.719653369969645*^9}},
 CellID->7738324,ExpressionUUID->"2a23404c-2109-4a3c-b94f-0a75fa625b1f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653372834073*^9, 3.719653378577292*^9}},
 CellID->1847851622,ExpressionUUID->"ec2f5d3b-e8c2-49fe-99cb-dc0d33ea37ec"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox["\[Not]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
           SyntaxForm->"\[Not]x"], 
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["y", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653381875473*^9, 3.719653397761272*^9}},
 CellID->2127038111,ExpressionUUID->"2b4c752c-c441-4c9d-8928-40dc335d925b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"hence", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", 
   " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{"\[Not]", 
        FormBox[
         StyleBox["P", "ExpressionABF"],
         TheoremaForm]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["y", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"elim", " ", "\"\<\[And]D1\>\""}], ",", " ", 
      RowBox[{"elim", " ", "\"\<\[And]D2\>\""}]}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196534003636208`*^9, 3.719653431738323*^9}, {
  3.7196535867816057`*^9, 3.719653657973318*^9}, {3.719653688917617*^9, 
  3.7196537426300287`*^9}},
 CellID->1946568842,ExpressionUUID->"2d5da09c-a36a-461b-a8e3-f98369b46cfe"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      RowBox[{
       TagBox["\[Piecewise]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"\[Piecewise]x"], GridBox[{
         {
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]},
         {
          TagBox[
           StyleBox["y", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "\[DoubleLeftArrow]", 
          "True"}
        }]}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653445373876*^9, 3.719653461394618*^9}, 
   3.7196535005554047`*^9, {3.719653750494095*^9, 3.7196537572704477`*^9}},
 CellID->282813688,ExpressionUUID->"3078118e-9b0b-4e6c-8777-acfc06e3d541"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71965376109028*^9, 3.719653766297531*^9}},
 CellID->2101435261,ExpressionUUID->"ccb5c59c-0215-4111-9569-e119e787a8fc"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653774694076*^9, 3.719653796078998*^9}},
 CellID->505024126,ExpressionUUID->"b2ab51d2-faea-4c7c-a34d-9ebffde7a1c3"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", "show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If cond\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196538105436*^9, 3.719653826709193*^9}},
 CellID->514933920,ExpressionUUID->"3a3ebabb-aaed-468b-accc-ea640ef2213b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719653830418902*^9, 3.719653835407381*^9}},
 CellID->212594382,ExpressionUUID->"5994ed54-d5e3-4b6e-9d45-8c0c6b48a31c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196538369558563`*^9, 3.719653844981365*^9}},
 CellID->718617240,ExpressionUUID->"1c16a42b-e064-4cbc-95b1-94785e9d687c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<2\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7196538494990597`*^9, 3.719653864475925*^9}},
 CellID->1159391928,ExpressionUUID->"d2677847-51d6-4fcd-a2fb-23c92aae1eb0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<If \[Not]cond\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.71965386778349*^9, 3.719653887609418*^9}},
 CellID->1169424756,ExpressionUUID->"a66db56f-c8e6-4dfd-a53e-ae14e1121a9d"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If split)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 521, 17, 20, "ProofText", "ExpressionUUID" -> \
"7fa82e55-e5a4-4cba-9433-7fc22ab03d9b",
 CellID->1549079474],
Cell[1115, 40, 236, 4, 39, "ProofText", "ExpressionUUID" -> \
"46533d0b-9ee1-41fd-ab98-53387bf2c14e",
 CellID->811428632],
Cell[1354, 46, 1648, 43, 35, "ProofText", "ExpressionUUID" -> \
"dd7fe691-dda4-41c0-bc7b-9dab92a4ee25",
 CellID->1783994644],
Cell[3005, 91, 2942, 82, 39, "ProofText", "ExpressionUUID" -> \
"b2677c74-db4e-409c-af5c-04a5d4b9cec4",
 CellID->1082447722],
Cell[5950, 175, 326, 9, 20, "ProofText", "ExpressionUUID" -> \
"a1a27634-35fd-4295-be91-4b04d36be315",
 CellID->1636219949],
Cell[6279, 186, 598, 15, 18, "ProofText", "ExpressionUUID" -> \
"e0801b9f-80cb-4b45-a014-9d6a0f1dce51",
 CellID->184893994],
Cell[6880, 203, 238, 5, 18, "ProofText", "ExpressionUUID" -> \
"c734d233-8f51-491a-9697-990161c49265",
 CellID->1030945612],
Cell[7121, 210, 415, 11, 20, "ProofText", "ExpressionUUID" -> \
"c4329d75-769f-4a67-aece-f6dc7e0b73e7",
 CellID->563407017],
Cell[7539, 223, 608, 16, 18, "ProofText", "ExpressionUUID" -> \
"2a23404c-2109-4a3c-b94f-0a75fa625b1f",
 CellID->7738324],
Cell[8150, 241, 277, 6, 39, "ProofText", "ExpressionUUID" -> \
"ec2f5d3b-e8c2-49fe-99cb-dc0d33ea37ec",
 CellID->1847851622],
Cell[8430, 249, 2803, 79, 20, "ProofText", "ExpressionUUID" -> \
"2b4c752c-c441-4c9d-8928-40dc335d925b",
 CellID->2127038111],
Cell[11236, 330, 2488, 68, 20, "ProofText", "ExpressionUUID" -> \
"2d5da09c-a36a-461b-a8e3-f98369b46cfe",
 CellID->1946568842],
Cell[13727, 400, 1793, 46, 58, "ProofText", "ExpressionUUID" -> \
"3078118e-9b0b-4e6c-8777-acfc06e3d541",
 CellID->282813688],
Cell[15523, 448, 323, 9, 20, "ProofText", "ExpressionUUID" -> \
"ccb5c59c-0215-4111-9569-e119e787a8fc",
 CellID->2101435261],
Cell[15849, 459, 531, 15, 18, "ProofText", "ExpressionUUID" -> \
"b2ab51d2-faea-4c7c-a34d-9ebffde7a1c3",
 CellID->505024126],
Cell[16383, 476, 414, 10, 18, "ProofText", "ExpressionUUID" -> \
"3a3ebabb-aaed-468b-accc-ea640ef2213b",
 CellID->514933920],
Cell[16800, 488, 238, 5, 18, "ProofText", "ExpressionUUID" -> \
"5994ed54-d5e3-4b6e-9d45-8c0c6b48a31c",
 CellID->212594382],
Cell[17041, 495, 415, 11, 20, "ProofText", "ExpressionUUID" -> \
"1c16a42b-e064-4cbc-95b1-94785e9d687c",
 CellID->718617240],
Cell[17459, 508, 534, 15, 18, "ProofText", "ExpressionUUID" -> \
"d2677847-51d6-4fcd-a2fb-23c92aae1eb0",
 CellID->1159391928],
Cell[17996, 525, 611, 16, 19, "ProofText", "ExpressionUUID" -> \
"a66db56f-c8e6-4dfd-a53e-ae14e1121a9d",
 CellID->1169424756]
}
]
*)

