(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11167,        317]
NotebookOptionsPosition[      9961,        282]
NotebookOutlinePosition[     10557,        302]
CellTagsIndexPosition[     10514,        299]
WindowTitle->Proof of (\:2203CE)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", ":", " ", "\"\<\[Exists] def\>\""}], ")"}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7153362596185637`*^9, 3.7153362660159683`*^9}},
 CellID->612557708,ExpressionUUID->"43211a95-dc55-4c43-b9f0-be5018dcb837"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715336331843955*^9, 3.7153363373563213`*^9}, {
  3.7153366062276497`*^9, 3.715336608292459*^9}},
 CellID->1961173195,ExpressionUUID->"ecb21d50-e4e4-46ff-8a71-f319410f5e91"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
         Theorema`Language`Forall$TM, {Theorema`Knowledge`BOOL$TM}]]], 
       TagBox[
        StyleBox["R", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox[
           TagBox["\[ForAll]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
           RowBox[{
            FormBox[
             StyleBox["Q", "ExpressionABF"],
             TheoremaForm], "[", "x", "]"}]], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             TagBox[
              StyleBox["P", "ExpressionABF"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`FUN$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
                 Theorema`Knowledge`BOOL$TM]]]], "[", 
             TagBox[
              StyleBox["x", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
            TagBox["\[Implies]",
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
             SyntaxForm->"x\[Implies]y"], 
            TagBox[
             StyleBox["R", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
           ")"}]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        TagBox[
         StyleBox["R", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FormBox[
         StyleBox["Q", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}], "\[LongRightArrow]", 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715336344405979*^9, 3.715336423673874*^9}, {
  3.715336614924898*^9, 3.7153366312469797`*^9}},
 CellID->1959438688,ExpressionUUID->"6c2908a0-1e53-49a6-b3ef-2206947a4ebf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "\"\<1\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        RowBox[{
         FormBox[
          StyleBox["Q", "ExpressionABF"],
          TheoremaForm], "[", "x", "]"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         FormBox[
          StyleBox["R", "ExpressionABF"],
          TheoremaForm]}], ")"}]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     FormBox[
      StyleBox["R", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715336433768116*^9, 3.71533647260253*^9}, {
  3.715336639246682*^9, 3.715336648738509*^9}},
 CellID->1592320899,ExpressionUUID->"cc5d9a33-8f21-4b08-b9e9-04a84a610593"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715336482390582*^9, 3.715336490434799*^9}},
 CellID->664020146,ExpressionUUID->"0d0b9201-cb63-417f-b011-2286345e6a5d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", "x", "]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["R", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
     "intro", " ", "\"\<\[ForAll]CI\>\"", " ", "\"\<\[Implies]I\>\""}], ",", 
     " ", 
     RowBox[{"fact", " ", "\"\<2\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715336497736557*^9, 3.715336576692506*^9}, {
  3.715336657757094*^9, 3.715336737741283*^9}},
 CellID->1573064454,ExpressionUUID->"04573e26-821b-4090-ad4c-2e7787cc5c88"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Exists]CE)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 299, 7, 18, "ProofText", "ExpressionUUID" -> \
"43211a95-dc55-4c43-b9f0-be5018dcb837",
 CellID->612557708],
Cell[893, 30, 497, 15, 20, "ProofText", "ExpressionUUID" -> \
"ecb21d50-e4e4-46ff-8a71-f319410f5e91",
 CellID->1961173195],
Cell[1393, 47, 4331, 114, 35, "ProofText", "ExpressionUUID" -> \
"6c2908a0-1e53-49a6-b3ef-2206947a4ebf",
 CellID->1959438688],
Cell[5727, 163, 1984, 54, 35, "ProofText", "ExpressionUUID" -> \
"cc5d9a33-8f21-4b08-b9e9-04a84a610593",
 CellID->1592320899],
Cell[7714, 219, 353, 8, 39, "ProofText", "ExpressionUUID" -> \
"0d0b9201-cb63-417f-b011-2286345e6a5d",
 CellID->664020146],
Cell[8070, 229, 1887, 51, 30, "ProofText", "ExpressionUUID" -> \
"04573e26-821b-4090-ad4c-2e7787cc5c88",
 CellID->1573064454]
}
]
*)

