(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30928,        879]
NotebookOptionsPosition[     27317,        787]
NotebookOutlinePosition[     27918,        807]
CellTagsIndexPosition[     27875,        804]
WindowTitle->Proof of (\:2200C\:2227)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219114058367*^9, 3.719219124157198*^9}},
 CellID->1032583957,ExpressionUUID->"a298560d-dc9a-4a77-904e-cb901ad7a31d"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71921912770783*^9, 3.719219129608219*^9}},
 CellID->1931420577,ExpressionUUID->"3e9b6b12-4ebd-4c77-b8cb-09a5c1f1e842"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<1\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219132172759*^9, 3.719219149448806*^9}},
 CellID->905398339,ExpressionUUID->"a2d4a0b8-ff08-446e-bcb5-d413702ca5a5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192191557707653`*^9, 3.7192191782970543`*^9}, 
   3.719219802674103*^9},
 CellID->1120421040,ExpressionUUID->"98bbecc7-5b58-4bbc-baad-243f37d3794a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192198077030487`*^9, 3.719219820520657*^9}},
 CellID->665298961,ExpressionUUID->"2e46a8ae-7813-4cce-a8f4-87f543266d7c"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219187987892*^9, 3.719219192029236*^9}, 
   3.719219823968094*^9},
 CellID->1884717778,ExpressionUUID->"32a1bab0-1ad8-4a5f-8b73-72e7c72fae7e"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219252276308*^9, 3.719219268028347*^9}, {
  3.7192193418377934`*^9, 3.7192193424749117`*^9}, {3.719219391371895*^9, 
  3.719219391867928*^9}, {3.719219827162891*^9, 3.7192198289927797`*^9}},
 CellID->429816048,ExpressionUUID->"dcc0292e-a24e-47d3-81b0-456f44ecff9d"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}], "\[And]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71921969998964*^9, 3.719219734746674*^9}, 
   3.7192198307548*^9},
 CellID->152357586,ExpressionUUID->"f5eb3dcc-949f-4389-8bb9-f32f580df952"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192197373012857`*^9, 3.71921975335256*^9}, 
   3.719219834923037*^9},
 CellID->1074271428,ExpressionUUID->"ed4c9d97-5bd8-4567-b0e1-92175dbb4e8d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219756206789*^9, 3.719219759192472*^9}, {
  3.7192198365450993`*^9, 3.7192198400655327`*^9}},
 CellID->928665295,ExpressionUUID->"4e1a9d2c-6883-44d1-8a3d-9f0c2aa618f7"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219847866206*^9, 3.719219860385607*^9}},
 CellID->604493153,ExpressionUUID->"31cf0c07-2489-411f-8cf8-3a95217162fd"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192197607180977`*^9, 3.719219765543391*^9}, 
   3.719219862409986*^9},
 CellID->367048772,ExpressionUUID->"6104ed99-93b8-4715-a385-6f3183e1966a"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192198638974*^9, 3.719219878059101*^9}},
 CellID->1762778497,ExpressionUUID->"0cf88034-7e59-4eaa-94e3-dd2e15af8a67"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}], "\[And]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219882220042*^9, 3.7192198939344397`*^9}},
 CellID->1524721049,ExpressionUUID->"ccc4d5b5-eb12-4b8e-b014-9fc7f89071e3"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219896459589*^9, 3.71921990997296*^9}},
 CellID->2030465203,ExpressionUUID->"e0571686-9b50-493d-abf9-482dd82553b0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192199157029467`*^9, 3.7192199249222393`*^9}},
 CellID->1616928263,ExpressionUUID->"f40614be-d326-44bb-997c-0fceab35cae5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["C", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219926388548*^9, 3.719219949578061*^9}},
 CellID->1400091168,ExpressionUUID->"0bcb0682-d0a4-43f4-9efd-dae49a47da92"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"hence", " ", "\"\<p\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<q\>\""}], ":", 
   " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", 
    RowBox[{"(", 
     RowBox[{"simp", " ", "all"}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719219941294799*^9, 3.7192199761551847`*^9}},
 CellID->1927020858,ExpressionUUID->"13f041c3-3a35-4024-b2e9-6b9296872746"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["C", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}], 
        TagBox["\[And]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
         SyntaxForm->"x\[And]y"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Knowledge`BOOL$TM]]]], "[", 
         StyleBox["x", "ExpressionVariable"], "]"}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192199817168417`*^9, 3.7192199982748957`*^9}},
 CellID->464406967,ExpressionUUID->"3b029265-6712-4931-ab28-1129ac84e350"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220003344056*^9, 3.719220007653881*^9}},
 CellID->1386107,ExpressionUUID->"d4512656-0298-46a3-aa2f-39d9065dc4c4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220010462109*^9, 3.7192200216015797`*^9}},
 CellID->809540981,ExpressionUUID->"77a07a6d-7300-4350-a9bd-e364385bccc8"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}], "\[And]", 
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220024067707*^9, 3.7192200457557697`*^9}},
 CellID->108404434,ExpressionUUID->"49cfcd58-9749-4614-984e-1c5cdaa049f6"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<p\>\"", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7192200513225803`*^9, 3.719220087817863*^9}},
 CellID->1933001244,ExpressionUUID->"5bef3d94-8dfd-4a67-8cdb-78a31967ccb1"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719220093047668*^9, 3.719220096172716*^9}},
 CellID->1276883945,ExpressionUUID->"3f9bbc90-5510-417a-abed-50be6ae4bef6"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<q\>\"", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7192200513225803`*^9, 3.719220103972266*^9}},
 CellID->1261369717,ExpressionUUID->"29efbcf2-9e25-4d0a-8ca3-b75f82a57d8d"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[ForAll]C\[And])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 444, 14, 20, "ProofText", "ExpressionUUID" -> \
"a298560d-dc9a-4a77-904e-cb901ad7a31d",
 CellID->1032583957],
Cell[1043, 37, 234, 4, 39, "ProofText", "ExpressionUUID" -> \
"3e9b6b12-4ebd-4c77-b8cb-09a5c1f1e842",
 CellID->1931420577],
Cell[1280, 43, 2068, 53, 30, "ProofText", "ExpressionUUID" -> \
"a2d4a0b8-ff08-446e-bcb5-d413702ca5a5",
 CellID->905398339],
Cell[3351, 98, 3509, 94, 57, "ProofText", "ExpressionUUID" -> \
"98bbecc7-5b58-4bbc-baad-243f37d3794a",
 CellID->1120421040],
Cell[6863, 194, 1627, 42, 52, "ProofText", "ExpressionUUID" -> \
"2e46a8ae-7813-4cce-a8f4-87f543266d7c",
 CellID->665298961],
Cell[8493, 238, 351, 10, 20, "ProofText", "ExpressionUUID" -> \
"32a1bab0-1ad8-4a5f-8b73-72e7c72fae7e",
 CellID->1884717778],
Cell[8847, 250, 644, 16, 20, "ProofText", "ExpressionUUID" -> \
"dcc0292e-a24e-47d3-81b0-456f44ecff9d",
 CellID->429816048],
Cell[9494, 268, 776, 24, 18, "ProofText", "ExpressionUUID" -> \
"f5eb3dcc-949f-4389-8bb9-f32f580df952",
 CellID->152357586],
Cell[10273, 294, 530, 16, 18, "ProofText", "ExpressionUUID" -> \
"ed4c9d97-5bd8-4567-b0e1-92175dbb4e8d",
 CellID->1074271428],
Cell[10806, 312, 337, 7, 39, "ProofText", "ExpressionUUID" -> \
"4e1a9d2c-6883-44d1-8a3d-9f0c2aa618f7",
 CellID->928665295],
Cell[11146, 321, 1625, 42, 52, "ProofText", "ExpressionUUID" -> \
"31cf0c07-2489-411f-8cf8-3a95217162fd",
 CellID->604493153],
Cell[12774, 365, 352, 10, 20, "ProofText", "ExpressionUUID" -> \
"6104ed99-93b8-4715-a385-6f3183e1966a",
 CellID->367048772],
Cell[13129, 377, 493, 14, 20, "ProofText", "ExpressionUUID" -> \
"0cf88034-7e59-4eaa-94e3-dd2e15af8a67",
 CellID->1762778497],
Cell[13625, 393, 756, 23, 18, "ProofText", "ExpressionUUID" -> \
"ccc4d5b5-eb12-4b8e-b014-9fc7f89071e3",
 CellID->1524721049],
Cell[14384, 418, 502, 15, 18, "ProofText", "ExpressionUUID" -> \
"e0571686-9b50-493d-abf9-482dd82553b0",
 CellID->2030465203],
Cell[14889, 435, 327, 7, 59, "ProofText", "ExpressionUUID" -> \
"f40614be-d326-44bb-997c-0fceab35cae5",
 CellID->1616928263],
Cell[15219, 444, 3463, 93, 35, "ProofText", "ExpressionUUID" -> \
"0bcb0682-d0a4-43f4-9efd-dae49a47da92",
 CellID->1400091168],
Cell[18685, 539, 3118, 81, 30, "ProofText", "ExpressionUUID" -> \
"13f041c3-3a35-4024-b2e9-6b9296872746",
 CellID->1927020858],
Cell[21806, 622, 2050, 52, 52, "ProofText", "ExpressionUUID" -> \
"3b029265-6712-4931-ab28-1129ac84e350",
 CellID->464406967],
Cell[23859, 676, 320, 9, 20, "ProofText", "ExpressionUUID" -> \
"d4512656-0298-46a3-aa2f-39d9065dc4c4",
 CellID->1386107],
Cell[24182, 687, 494, 14, 20, "ProofText", "ExpressionUUID" -> \
"77a07a6d-7300-4350-a9bd-e364385bccc8",
 CellID->809540981],
Cell[24679, 703, 734, 23, 39, "ProofText", "ExpressionUUID" -> \
"49cfcd58-9749-4614-984e-1c5cdaa049f6",
 CellID->108404434],
Cell[25416, 728, 779, 23, 18, "ProofText", "ExpressionUUID" -> \
"5bef3d94-8dfd-4a67-8cdb-78a31967ccb1",
 CellID->1933001244],
Cell[26198, 753, 241, 5, 18, "ProofText", "ExpressionUUID" -> \
"3f9bbc90-5510-417a-abed-50be6ae4bef6",
 CellID->1276883945],
Cell[26442, 760, 871, 25, 19, "ProofText", "ExpressionUUID" -> \
"29efbcf2-9e25-4d0a-8ca3-b75f82a57d8d",
 CellID->1261369717]
}
]
*)

