(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13573,        391]
NotebookOptionsPosition[     11735,        341]
NotebookOutlinePosition[     12343,        361]
CellTagsIndexPosition[     12300,        358]
WindowTitle->Proof of (the \:F431 \:2203!)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"elim", " ", "\"\<\[Exists]!E\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718364964388689*^9, 3.718364974594426*^9}, {
  3.7183650217629337`*^9, 3.718365036140945*^9}, {3.718365068979512*^9, 
  3.7183651207720737`*^9}},
 CellID->71490363,ExpressionUUID->"67cf73d8-03da-4d63-8f4c-1a18d25988a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365135977149*^9, 3.718365151263036*^9}},
 CellID->180181516,ExpressionUUID->"2c7497d6-4630-461b-9451-06efba2acedf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<rl\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["y", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["y", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7183651640827417`*^9, 3.7183651923347*^9}, {
  3.718365363814909*^9, 3.7183653650953417`*^9}},
 CellID->909900074,ExpressionUUID->"62299357-ea86-4de6-98ce-863e6fc46ee5"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox[
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     TagBox[
      StyleBox["x", "ExpressionVariable"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
    RowBox[{
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      "]"}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["a", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", "-"}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184418997743*^9, 3.7184419319060793`*^9}},
 CellID->456712112,ExpressionUUID->"327b90bc-438d-4d10-9f2c-b0adcb893ee8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718441937829064*^9, 3.718441943572422*^9}},
 CellID->1626657156,ExpressionUUID->"0d3f4fad-3b24-4f59-bbf5-bb8a1d0d8809"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718441946893044*^9, 3.718441960418105*^9}},
 CellID->1133016938,ExpressionUUID->"e8d4961f-2e23-4872-b5dc-5f9f54d1704b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rl\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365383512864*^9, 3.718365401247723*^9}},
 CellID->1981123989,ExpressionUUID->"8bdebeb7-bcd5-4d66-9f67-97fc2b2ac554"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "[", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rl\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365405627522*^9, 3.718365437336791*^9}},
 CellID->1126202645,ExpressionUUID->"56f482a3-9ea8-4f43-bbe1-417e501b9847"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], " ", "\[Equal]", " ", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718365441465547*^9, 3.718365464504283*^9}, {
   3.71836550040917*^9, 3.718365521041027*^9}, {3.7183655689449873`*^9, 
   3.718365573625759*^9}, 3.718365709947022*^9, {3.718425176126436*^9, 
   3.71842517712827*^9}},
 CellID->807050453,ExpressionUUID->"a8958f3d-940d-4693-aa16-4a7261e93265"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718441978528245*^9, 3.718441982466586*^9}},
 CellID->3922997,ExpressionUUID->"a40d8dfb-789d-4ae3-ab51-9ce4b8ed02fa"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      UnderscriptBox[
       TagBox["the",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Such$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[Equal]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[Equal]y"], 
    TagBox[
     StyleBox["a", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
   "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<theI weaker\>\""}], ",", " ", 
    SuperscriptBox["fact", "+"]}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718365224909864*^9, 3.718365294350103*^9}, {
  3.718441830009973*^9, 3.718441864017935*^9}, {3.7184419891387577`*^9, 
  3.718441996356555*^9}},
 CellID->650349429,ExpressionUUID->"cd31ed66-8f7c-4f7a-9593-905376fa6ed4"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (the \[Equal] \[Exists]!)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 387, 8, 18, "ProofText", "ExpressionUUID" -> \
"67cf73d8-03da-4d63-8f4c-1a18d25988a9",
 CellID->71490363],
Cell[991, 31, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"2c7497d6-4630-461b-9451-06efba2acedf",
 CellID->180181516],
Cell[1437, 47, 2875, 81, 30, "ProofText", "ExpressionUUID" -> \
"62299357-ea86-4de6-98ce-863e6fc46ee5",
 CellID->909900074],
Cell[4315, 130, 2197, 57, 50, "ProofText", "ExpressionUUID" -> \
"327b90bc-438d-4d10-9f2c-b0adcb893ee8",
 CellID->456712112],
Cell[6515, 189, 321, 9, 20, "ProofText", "ExpressionUUID" -> \
"0d3f4fad-3b24-4f59-bbf5-bb8a1d0d8809",
 CellID->1626657156],
Cell[6839, 200, 491, 14, 20, "ProofText", "ExpressionUUID" -> \
"e8d4961f-2e23-4872-b5dc-5f9f54d1704b",
 CellID->1133016938],
Cell[7333, 216, 557, 15, 18, "ProofText", "ExpressionUUID" -> \
"8bdebeb7-bcd5-4d66-9f67-97fc2b2ac554",
 CellID->1981123989],
Cell[7893, 233, 821, 23, 18, "ProofText", "ExpressionUUID" -> \
"56f482a3-9ea8-4f43-bbe1-417e501b9847",
 CellID->1126202645],
Cell[8717, 258, 692, 17, 18, "ProofText", "ExpressionUUID" -> \
"a8958f3d-940d-4693-aa16-4a7261e93265",
 CellID->807050453],
Cell[9412, 277, 216, 4, 18, "ProofText", "ExpressionUUID" -> \
"a40d8dfb-789d-4ae3-ab51-9ce4b8ed02fa",
 CellID->3922997],
Cell[9631, 283, 2100, 56, 30, "ProofText", "ExpressionUUID" -> \
"cd31ed66-8f7c-4f7a-9593-905376fa6ed4",
 CellID->650349429]
}
]
*)

