(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8022,        236]
NotebookOptionsPosition[      6309,        189]
NotebookOutlinePosition[      6915,        209]
CellTagsIndexPosition[      6872,        206]
WindowTitle->Proof of (\:F523E classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["R", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184533484142437`*^9, 3.718453356229343*^9}},
 CellID->317046539,ExpressionUUID->"597e4942-793a-4950-87bb-e67e4aea236e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<imp\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      TagBox[
       StyleBox["Q", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox["\[Not]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
         SyntaxForm->"\[Not]x"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["R", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["R", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7184533652058067`*^9, 3.718453401997809*^9}},
 CellID->1690460601,ExpressionUUID->"b44dd75a-fe0b-4995-b969-d11db5c8388e"],

Cell[BoxData[
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "\[Or]", " ", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<tertium non datur\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453412679021*^9, 3.718453433990211*^9}},
 CellID->1382190333,ExpressionUUID->"eaeb6c4b-99d9-43d7-863b-6c24e912eed9"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  FormBox[
   StyleBox["R", "ExpressionABF"],
   TheoremaForm]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453437103424*^9, 3.718453442138064*^9}},
 CellID->1695004691,ExpressionUUID->"386ae3f5-68ae-4bfe-905a-b0c185945362"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453445495029*^9, 3.718453449616276*^9}},
 CellID->15891537,ExpressionUUID->"40d804ea-aa0c-44e5-a828-47085e64c53a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<imp\>\"", " ", "have", " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845345905569*^9, 3.718453468564286*^9}},
 CellID->794120510,ExpressionUUID->"77725e05-dd25-48cc-a0b0-6c2113d80529"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453478803009*^9, 3.718453487239769*^9}},
 CellID->1886159545,ExpressionUUID->"2dd4c81b-46f2-4776-8c2f-9f52ce2a3ee2"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71845348944554*^9, 3.718453491432213*^9}},
 CellID->1582481557,ExpressionUUID->"7f3c3d98-4de7-4102-b0f6-a373b8eab91e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.718453493289164*^9, 3.718453501731073*^9}},
 CellID->1881560526,ExpressionUUID->"ce6726e9-3064-4cd5-8c79-be85c783d556"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.718453503924453*^9, 3.718453509640131*^9}},
 CellID->1496024001,ExpressionUUID->"996293c0-679c-43fc-9d7b-29f0fd8c3235"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[Implies]E classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"597e4942-793a-4950-87bb-e67e4aea236e",
 CellID->317046539],
Cell[1048, 37, 2333, 63, 20, "ProofText", "ExpressionUUID" -> \
"b44dd75a-fe0b-4995-b969-d11db5c8388e",
 CellID->1690460601],
Cell[3384, 102, 567, 15, 18, "ProofText", "ExpressionUUID" -> \
"eaeb6c4b-99d9-43d7-863b-6c24e912eed9",
 CellID->1382190333],
Cell[3954, 119, 295, 7, 39, "ProofText", "ExpressionUUID" -> \
"386ae3f5-68ae-4bfe-905a-b0c185945362",
 CellID->1695004691],
Cell[4252, 128, 320, 9, 20, "ProofText", "ExpressionUUID" -> \
"40d804ea-aa0c-44e5-a828-47085e64c53a",
 CellID->15891537],
Cell[4575, 139, 359, 9, 18, "ProofText", "ExpressionUUID" -> \
"77725e05-dd25-48cc-a0b0-6c2113d80529",
 CellID->794120510],
Cell[4937, 150, 318, 7, 18, "ProofText", "ExpressionUUID" -> \
"2dd4c81b-46f2-4776-8c2f-9f52ce2a3ee2",
 CellID->1886159545],
Cell[5258, 159, 219, 4, 18, "ProofText", "ExpressionUUID" -> \
"7f3c3d98-4de7-4102-b0f6-a373b8eab91e",
 CellID->1582481557],
Cell[5480, 165, 412, 11, 20, "ProofText", "ExpressionUUID" -> \
"ce6726e9-3064-4cd5-8c79-be85c783d556",
 CellID->1881560526],
Cell[5895, 178, 410, 9, 19, "ProofText", "ExpressionUUID" -> \
"996293c0-679c-43fc-9d7b-29f0fd8c3235",
 CellID->1496024001]
}
]
*)

