(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     32927,        914]
NotebookOptionsPosition[     25314,        726]
NotebookOutlinePosition[     25915,        746]
CellTagsIndexPosition[     25872,        743]
WindowTitle->Proof of (tertium non datur)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.7161097045711727`*^9, 3.716109708077141*^9}},
 CellID->52285799,ExpressionUUID->"bfe77901-570b-4633-ac6e-cfe21fa3ef24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["A", "ExpressionSyntactic"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", 
      RowBox[{"x", "::", "BOOL"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FormBox[
          StyleBox["P", "ExpressionABF"],
          TheoremaForm], " ", "\[And]", " ", "x"}], ")"}], " ", "\[Or]", " ", 
       
       RowBox[{"\[Not]", "x"}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellChangeTimes->{{3.716109712693369*^9, 3.716109730424843*^9}, {
   3.716109768137537*^9, 3.7161098136762877`*^9}, 3.716109851825617*^9, {
   3.716110448898638*^9, 3.7161104500025454`*^9}, {3.716110526203371*^9, 
   3.716110526507173*^9}},
 CellID->2143602245,ExpressionUUID->"7c2585ce-7b88-475f-b8eb-359b3329cb3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    FormBox[
     StyleBox["B", "ExpressionSyntactic"],
     TheoremaForm], "\[CloseCurlyQuote]"}], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", "x"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FormBox[
          StyleBox["P", "ExpressionABF"],
          TheoremaForm], " ", "\[And]", " ", 
         RowBox[{"\[Not]", "x"}]}], ")"}], " ", "\[Or]", " ", "x"}], ")"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellChangeTimes->{{3.716110532430832*^9, 3.7161105709846077`*^9}},
 CellID->2103006642,ExpressionUUID->"63be03e1-167b-4091-94dd-900fc8139860"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"have", " ", "\"\<a\>\""}], ":", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<SomeI\>\""}], ")"}]}]}], "ProofText",
 CellChangeTimes->{{3.716110592298386*^9, 3.716110637067926*^9}, {
  3.7184425188571997`*^9, 3.71844252424958*^9}},
 CellID->151033211,ExpressionUUID->"95ec274c-f7c9-4da7-84b6-e235addc45e3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", "False"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellChangeTimes->{{3.716110654616148*^9, 3.716110671772806*^9}, {
  3.716110711380842*^9, 3.716110745430162*^9}, {3.71833804632264*^9, 
  3.718338075479621*^9}},
 CellID->1861627579,ExpressionUUID->"66781dda-5ab6-4ee7-8929-6ab5831212f8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "[", "False", "]"}], "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.718338084360382*^9, 3.7183381309600267`*^9}, {
  3.7183472290129337`*^9, 3.7183472293805857`*^9}, {3.718347690586831*^9, 
  3.71834770022924*^9}, {3.71834775504186*^9, 3.718347761116004*^9}},
 CellID->97930354,ExpressionUUID->"f60c0fc0-c254-4d28-b380-bed2bf5fa269"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellChangeTimes->{{3.718348024408999*^9, 3.718348026366309*^9}},
 CellID->1353682894,ExpressionUUID->"fb45e136-41bb-42b5-a997-645462eb9de2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"have", " ", "\"\<b\>\""}], ":", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["B", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["B", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<SomeI\>\""}], ")"}]}]}], "ProofText",
 CellChangeTimes->{{3.716110592298386*^9, 3.716110637067926*^9}, {
  3.718347786414082*^9, 3.718347789988394*^9}, {3.718442528145419*^9, 
  3.718442533017624*^9}},
 CellID->720193781,ExpressionUUID->"9f6b5112-868e-4449-8fc7-18ed0b382fd3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", "True", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellChangeTimes->{{3.716110654616148*^9, 3.716110671772806*^9}, {
  3.716110711380842*^9, 3.716110745430162*^9}, {3.71833804632264*^9, 
  3.718338075479621*^9}, {3.718347800500288*^9, 3.718347800932173*^9}},
 CellID->2117947402,ExpressionUUID->"5ec0d753-2988-41c7-9a71-c17fac49a1f4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionSyntactic"],
      TheoremaForm], "[", "True", "]"}], "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.718338084360382*^9, 3.7183381309600267`*^9}, {
  3.7183472290129337`*^9, 3.7183472293805857`*^9}, {3.718347690586831*^9, 
  3.71834770022924*^9}, {3.71834775504186*^9, 3.718347761116004*^9}, {
  3.718347804324307*^9, 3.718347823468134*^9}},
 CellID->511942003,ExpressionUUID->"9df395e2-1553-4abc-b0cc-ec6dc7e958ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "qed", "*)"}], "\n"}]], "ProofText",
 CellChangeTimes->{{3.718348031558281*^9, 3.71834803968546*^9}},
 CellID->983646033,ExpressionUUID->"afc18564-1438-4b1f-864c-eefec8c9f060"],

Cell[BoxData[{
 RowBox[{"from", " ", "\"\<a\>\"", " ", "show", " ", 
  "_"}], "\n", "proof"}], "ProofText",
 CellChangeTimes->{{3.718347863049098*^9, 3.718347867829152*^9}, {
  3.718347900229247*^9, 3.718347901037362*^9}},
 CellID->1621457932,ExpressionUUID->"fb7333eb-f722-4d61-83bd-3bf49dd21d70"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      RowBox[{"Some", "[", 
       FormBox[
        StyleBox["A", "ExpressionSyntactic"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7183479270791817`*^9, 3.718347974934134*^9}},
 CellID->787713528,ExpressionUUID->"fa2d6ee6-7d34-451f-a3d6-ac29bdf71e46"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"hence", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellChangeTimes->{{3.718347985912771*^9, 3.718347996170879*^9}},
 CellID->1443614707,ExpressionUUID->"a96f4257-3b97-4054-b496-e8e56c960db9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.718347999743627*^9, 3.718348010150744*^9}},
 CellID->948147893,ExpressionUUID->"bbe65831-525e-4c39-b16e-aacad93bba32"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellChangeTimes->{{3.718348013057625*^9, 3.7183480146861477`*^9}},
 CellID->1260567944,ExpressionUUID->"8fb8dea8-937f-4042-92d9-c275a27a6587"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      RowBox[{"Some", "[", 
       FormBox[
        StyleBox["A", "ExpressionSyntactic"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718348059233418*^9, 3.718348077744483*^9}},
 CellID->2057280212,ExpressionUUID->"fd1b7453-69ec-4974-b411-1fe1d118526b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<b\>\"", " ", "show", " ", "_"}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.718348086596343*^9, 3.718348092031987*^9}},
 CellID->989420399,ExpressionUUID->"5d0f639b-fe74-47c1-aa28-28f2e260d392"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      RowBox[{"\[Not]", 
       RowBox[{"Some", "[", 
        FormBox[
         StyleBox["B", "ExpressionSyntactic"],
         TheoremaForm], "]"}]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718348094435974*^9, 3.71834811629737*^9}},
 CellID->775027524,ExpressionUUID->"b721ba99-aaf2-46bc-b792-651da621f82f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"hence", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellChangeTimes->{{3.7183481200514517`*^9, 3.718348129819075*^9}},
 CellID->1786104239,ExpressionUUID->"2a201ece-f7a5-4770-b49b-89a43e20986b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.718348133527184*^9, 3.718348142056929*^9}},
 CellID->992737468,ExpressionUUID->"713e4d0d-3d86-4e10-97d1-0e50c323811b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.718348146253487*^9, 3.718348149857479*^9}},
 CellID->323382833,ExpressionUUID->"31e4e61d-edd7-4453-b32b-a1d082ef2138"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"Some", "[", 
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718348152786396*^9, 3.718348165750368*^9}},
 CellID->595331708,ExpressionUUID->"64fa2533-ade1-403a-9148-2ec004c51bae"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"have", " ", "\"\<neq\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionSyntactic"],
       TheoremaForm], " ", "\[NotEqual]", " ", 
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.718348218758169*^9, 3.718348239201281*^9}, {
  3.718349214838148*^9, 3.718349216488948*^9}},
 CellID->1912605434,ExpressionUUID->"c950d27d-e26c-4cd2-962a-1e768fbbd2c9"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionSyntactic"],
       TheoremaForm], " ", "\[Equal]", " ", 
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7183482474787483`*^9, 3.718348269906888*^9}},
 CellID->1612779128,ExpressionUUID->"6903fae3-46c4-4343-8e67-f93a49406805"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{"Some", "[", 
      FormBox[
       StyleBox["A", "ExpressionSyntactic"],
       TheoremaForm], "]"}], " ", "\[DoubleLeftRightArrow]", " ", 
     RowBox[{"Some", "[", 
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<arg cong\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.718348283446946*^9, 3.718348316034582*^9}},
 CellID->610747751,ExpressionUUID->"620d57a1-9d14-431e-821a-22eea082b050"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["B", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["A", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellChangeTimes->{{3.718348356841589*^9, 3.7183483806195602`*^9}, {
  3.718349055084362*^9, 3.718349089364602*^9}},
 CellID->85277336,ExpressionUUID->"3a3a95e1-c20c-4d50-854b-ccaf6b980807"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      RowBox[{"Some", "[", 
       FormBox[
        StyleBox["A", "ExpressionSyntactic"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellChangeTimes->{{3.718349096517394*^9, 3.718349114760133*^9}},
 CellID->2103013016,ExpressionUUID->"11a27fc0-74fa-4ca5-89a2-feced443853d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.718349118609984*^9, 3.718349122061173*^9}},
 CellID->1006589683,ExpressionUUID->"c2585f96-24b9-4838-9f2f-1f35d7f146e0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.718349152312945*^9, 3.718349169069418*^9}},
 CellID->1387936495,ExpressionUUID->"56aa60fb-e347-41e4-bd86-4559eeb52b7b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718349171458679*^9, 3.7183491802317743`*^9}},
 CellID->560485261,ExpressionUUID->"fc9df478-d5c4-4efd-85f1-e54e06170925"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionSyntactic"],
       TheoremaForm], " ", "\[Equal]", " ", 
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Equal] ext\>\""}], ")"}]}]}]}]], "ProofText",\

 CellChangeTimes->{{3.718349194370463*^9, 3.7183492420782747`*^9}, {
  3.7183492866795607`*^9, 3.718349287383038*^9}},
 CellID->1000637576,ExpressionUUID->"f3162c98-839f-4e8e-9bbe-aa83340338bf"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7183533995618963`*^9, 3.718353405016183*^9}},
 CellID->1716342060,ExpressionUUID->"4994a40a-e617-46cd-9c70-9bac11841909"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"show", " ", "_"}], "\n", "\t\t\t\t", "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.718353428764718*^9, 3.7183534341864843`*^9}},
 CellID->1721191532,ExpressionUUID->"b7ee461b-7850-48b1-889c-7aec57b560d9"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7183534376571703`*^9, 3.7183534844349823`*^9}},
 CellID->914390460,ExpressionUUID->"7dbfdf1c-92e4-4661-a218-482ac2731d66"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t\t\t", 
   "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.718353507330016*^9, 3.718353523006041*^9}},
 CellID->1813048659,ExpressionUUID->"6f5a9df4-0e5d-43d9-ab46-a90bc2d23aa4"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7183535385158978`*^9, 3.718353549470606*^9}},
 CellID->127093580,ExpressionUUID->"9345509c-0f9e-4ad6-a9e7-ee284f01a842"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      RowBox[{"\[Not]", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellChangeTimes->{{3.718353566580716*^9, 3.718353638108469*^9}, {
  3.718353673485899*^9, 3.718353680318479*^9}, {3.7183599542908297`*^9, 
  3.7183599545261793`*^9}},
 CellID->755216063,ExpressionUUID->"9a5178f1-607a-4443-82e7-7153aa7371b5"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.7183599689606867`*^9, 3.71835997998022*^9}},
 CellID->1268010274,ExpressionUUID->"4edbeed0-3bec-4198-a2c4-6aa14ce075bf"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.7183599833476*^9, 3.718360009360902*^9}, {
  3.7183600471693573`*^9, 3.71836004878049*^9}},
 CellID->128425530,ExpressionUUID->"8aec413b-420e-4e82-bd58-fc4ecb913181"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.7183600532901907`*^9, 3.718360071097138*^9}},
 CellID->1683975057,ExpressionUUID->"b50b8cd3-94cb-41df-901f-ade8b0051d18"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"hence", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], " ", ".."}]}]], "ProofText",
 CellChangeTimes->{{3.7183600796072683`*^9, 3.718360089975257*^9}},
 CellID->852977150,ExpressionUUID->"e0d90f83-ffa3-4f4d-bb8d-6c3af7674196"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.7183600928948317`*^9, 3.718360102549511*^9}},
 CellID->1133284943,ExpressionUUID->"994065b5-3c92-4b3b-8efb-f3d6429df37d"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.718360107119961*^9, 3.718360115125764*^9}},
 CellID->1458955501,ExpressionUUID->"4a1efc32-8c56-4c38-938a-b83389c38c5b"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718360012175164*^9, 3.718360026324522*^9}, {
  3.718360126573395*^9, 3.7183601358778152`*^9}},
 CellID->2011700376,ExpressionUUID->"8ed71564-5d2d-4f6b-bc29-786b3e975248"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionSyntactic"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t\t\t", 
   "proof"}]}]], "ProofText",
 CellChangeTimes->{{3.7183601424782476`*^9, 3.718360160843349*^9}},
 CellID->1318177734,ExpressionUUID->"a0748bd4-b862-4bc8-9cdc-f38ece05e99e"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      RowBox[{"\[Not]", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718360164348156*^9, 3.718360189815466*^9}},
 CellID->867045541,ExpressionUUID->"5a016cf2-266a-4053-9767-2bb710b3f368"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"hence", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellChangeTimes->{{3.718360194608738*^9, 3.718360205941619*^9}},
 CellID->2019780132,ExpressionUUID->"eb1d6af8-4ebf-4f21-8cd1-9064e8d5c7ca"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.7183602090486507`*^9, 3.718360219503129*^9}},
 CellID->1922173611,ExpressionUUID->"e1048d06-0e49-4c58-9f53-df0a161c47d1"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.718360221870166*^9, 3.718360225934546*^9}},
 CellID->1718250931,ExpressionUUID->"84aceded-c067-4d25-9882-beb5ec8de4d9"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"case", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellChangeTimes->{{3.718360229479158*^9, 3.718360236209609*^9}},
 CellID->625403761,ExpressionUUID->"223ec96c-ac7b-47d1-be51-f7ec8b893902"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], " ", "\[And]", " ", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellChangeTimes->{{3.71836024428449*^9, 3.718360268965086*^9}},
 CellID->1670843525,ExpressionUUID->"cc562e6a-dcff-41c3-9090-5744478ac605"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.7183602726341963`*^9, 3.718360282215766*^9}},
 CellID->652211656,ExpressionUUID->"bff0b860-2515-49a5-8565-a1b46f4e56d4"],

Cell[BoxData[
 RowBox[{"\t\t\t\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t\t\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.718360284635207*^9, 3.7183603001279507`*^9}},
 CellID->1981094250,ExpressionUUID->"0250ce5f-b307-4bb8-a60d-26a65488e3cd"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<neq\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellChangeTimes->{{3.718360325826709*^9, 3.718360340335291*^9}},
 CellID->761439595,ExpressionUUID->"b634f486-1e21-4833-9881-69af7a4c344c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellChangeTimes->{{3.7183603512529793`*^9, 3.718360354792289*^9}},
 CellID->538780486,ExpressionUUID->"1c7ebbd8-053a-4e67-8f29-e0c40b9776dc"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellChangeTimes->{{3.718360361377914*^9, 3.718360373536852*^9}},
 CellID->1400627339,ExpressionUUID->"ebad3868-58c7-4af8-9c83-1ab44d1a185d"]
},
WindowSize->{808, 869},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Proof of (tertium non datur)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 278, 7, 20, "ProofText", "ExpressionUUID" -> \
"bfe77901-570b-4633-ac6e-cfe21fa3ef24",
 CellID->52285799],
Cell[881, 30, 943, 25, 28, "ProofText", "ExpressionUUID" -> \
"7c2585ce-7b88-475f-b8eb-359b3329cb3f",
 CellID->2143602245],
Cell[1827, 57, 734, 20, 28, "ProofText", "ExpressionUUID" -> \
"63be03e1-167b-4091-94dd-900fc8139860",
 CellID->2103006642],
Cell[2564, 79, 649, 17, 39, "ProofText", "ExpressionUUID" -> \
"95ec274c-f7c9-4da7-84b6-e235addc45e3",
 CellID->151033211],
Cell[3216, 98, 431, 10, 18, "ProofText", "ExpressionUUID" -> \
"66781dda-5ab6-4ee7-8929-6ab5831212f8",
 CellID->1861627579],
Cell[3650, 110, 620, 14, 21, "ProofText", "ExpressionUUID" -> \
"f60c0fc0-c254-4d28-b380-bed2bf5fa269",
 CellID->97930354],
Cell[4273, 126, 199, 3, 18, "ProofText", "ExpressionUUID" -> \
"fb45e136-41bb-42b5-a997-645462eb9de2",
 CellID->1353682894],
Cell[4475, 131, 697, 18, 39, "ProofText", "ExpressionUUID" -> \
"9f6b5112-868e-4449-8fc7-18ed0b382fd3",
 CellID->720193781],
Cell[5175, 151, 450, 9, 18, "ProofText", "ExpressionUUID" -> \
"5ec0d753-2988-41c7-9a71-c17fac49a1f4",
 CellID->2117947402],
Cell[5628, 162, 669, 15, 18, "ProofText", "ExpressionUUID" -> \
"9df395e2-1553-4abc-b0cc-ec6dc7e958ff",
 CellID->511942003],
Cell[6300, 179, 216, 4, 39, "ProofText", "ExpressionUUID" -> \
"afc18564-1438-4b1f-864c-eefec8c9f060",
 CellID->983646033],
Cell[6519, 185, 298, 5, 39, "ProofText", "ExpressionUUID" -> \
"fb7333eb-f722-4d61-83bd-3bf49dd21d70",
 CellID->1621457932],
Cell[6820, 192, 528, 15, 20, "ProofText", "ExpressionUUID" -> \
"fa2d6ee6-7d34-451f-a3d6-ac29bdf71e46",
 CellID->787713528],
Cell[7351, 209, 370, 9, 18, "ProofText", "ExpressionUUID" -> \
"a96f4257-3b97-4054-b496-e8e56c960db9",
 CellID->1443614707],
Cell[7724, 220, 303, 6, 18, "ProofText", "ExpressionUUID" -> \
"bbe65831-525e-4c39-b16e-aacad93bba32",
 CellID->948147893],
Cell[8030, 228, 202, 3, 18, "ProofText", "ExpressionUUID" -> \
"8fb8dea8-937f-4042-92d9-c275a27a6587",
 CellID->1260567944],
Cell[8235, 233, 440, 12, 20, "ProofText", "ExpressionUUID" -> \
"fd1b7453-69ec-4974-b411-1fe1d118526b",
 CellID->2057280212],
Cell[8678, 247, 286, 6, 39, "ProofText", "ExpressionUUID" -> \
"5d0f639b-fe74-47c1-aa28-28f2e260d392",
 CellID->989420399],
Cell[8967, 255, 558, 16, 20, "ProofText", "ExpressionUUID" -> \
"b721ba99-aaf2-46bc-b792-651da621f82f",
 CellID->775027524],
Cell[9528, 273, 374, 9, 18, "ProofText", "ExpressionUUID" -> \
"2a201ece-f7a5-4770-b49b-89a43e20986b",
 CellID->1786104239],
Cell[9905, 284, 305, 6, 18, "ProofText", "ExpressionUUID" -> \
"713e4d0d-3d86-4e10-97d1-0e50c323811b",
 CellID->992737468],
Cell[10213, 292, 218, 4, 18, "ProofText", "ExpressionUUID" -> \
"31e4e61d-edd7-4453-b32b-a1d082ef2138",
 CellID->323382833],
Cell[10434, 298, 407, 10, 20, "ProofText", "ExpressionUUID" -> \
"64fa2533-ade1-403a-9148-2ec004c51bae",
 CellID->595331708],
Cell[10844, 310, 609, 16, 39, "ProofText", "ExpressionUUID" -> \
"c950d27d-e26c-4cd2-962a-1e768fbbd2c9",
 CellID->1912605434],
Cell[11456, 328, 501, 13, 20, "ProofText", "ExpressionUUID" -> \
"6903fae3-46c4-4343-8e67-f93a49406805",
 CellID->1612779128],
Cell[11960, 343, 647, 16, 18, "ProofText", "ExpressionUUID" -> \
"620d57a1-9d14-431e-821a-22eea082b050",
 CellID->610747751],
Cell[12610, 361, 664, 16, 18, "ProofText", "ExpressionUUID" -> \
"3a3a95e1-c20c-4d50-854b-ccaf6b980807",
 CellID->85277336],
Cell[13277, 379, 535, 13, 18, "ProofText", "ExpressionUUID" -> \
"11a27fc0-74fa-4ca5-89a2-feced443853d",
 CellID->2103013016],
Cell[13815, 394, 220, 4, 18, "ProofText", "ExpressionUUID" -> \
"c2585f96-24b9-4838-9f2f-1f35d7f146e0",
 CellID->1006589683],
Cell[14038, 400, 416, 11, 39, "ProofText", "ExpressionUUID" -> \
"56aa60fb-e347-41e4-bd86-4559eeb52b7b",
 CellID->1387936495],
Cell[14457, 413, 370, 9, 20, "ProofText", "ExpressionUUID" -> \
"fc9df478-d5c4-4efd-85f1-e54e06170925",
 CellID->560485261],
Cell[14830, 424, 669, 18, 39, "ProofText", "ExpressionUUID" -> \
"f3162c98-839f-4e8e-9bbe-aa83340338bf",
 CellID->1000637576],
Cell[15502, 444, 309, 8, 70, "ProofText", "ExpressionUUID" -> \
"4994a40a-e617-46cd-9c70-9bac11841909",
 CellID->1716342060],
Cell[15814, 454, 266, 5, 70, "ProofText", "ExpressionUUID" -> \
"b7ee461b-7850-48b1-889c-7aec57b560d9",
 CellID->1721191532],
Cell[16083, 461, 486, 13, 70, "ProofText", "ExpressionUUID" -> \
"7dbfdf1c-92e4-4661-a218-482ac2731d66",
 CellID->914390460],
Cell[16572, 476, 511, 14, 70, "ProofText", "ExpressionUUID" -> \
"6f5a9df4-0e5d-43d9-ab46-a90bc2d23aa4",
 CellID->1813048659],
Cell[17086, 492, 403, 10, 70, "ProofText", "ExpressionUUID" -> \
"9345509c-0f9e-4ad6-a9e7-ee284f01a842",
 CellID->127093580],
Cell[17492, 504, 780, 21, 70, "ProofText", "ExpressionUUID" -> \
"9a5178f1-607a-4443-82e7-7153aa7371b5",
 CellID->755216063],
Cell[18275, 527, 315, 6, 70, "ProofText", "ExpressionUUID" -> \
"4edbeed0-3bec-4198-a2c4-6aa14ce075bf",
 CellID->1268010274],
Cell[18593, 535, 274, 5, 70, "ProofText", "ExpressionUUID" -> \
"8aec413b-420e-4e82-bd58-fc4ecb913181",
 CellID->128425530],
Cell[18870, 542, 491, 13, 70, "ProofText", "ExpressionUUID" -> \
"b50b8cd3-94cb-41df-901f-ade8b0051d18",
 CellID->1683975057],
Cell[19364, 557, 320, 8, 70, "ProofText", "ExpressionUUID" -> \
"e0d90f83-ffa3-4f4d-bb8d-6c3af7674196",
 CellID->852977150],
Cell[19687, 567, 316, 6, 70, "ProofText", "ExpressionUUID" -> \
"994065b5-3c92-4b3b-8efb-f3d6429df37d",
 CellID->1133284943],
Cell[20006, 575, 277, 5, 70, "ProofText", "ExpressionUUID" -> \
"4a1efc32-8c56-4c38-938a-b83389c38c5b",
 CellID->1458955501],
Cell[20286, 582, 534, 14, 70, "ProofText", "ExpressionUUID" -> \
"8ed71564-5d2d-4f6b-bc29-786b3e975248",
 CellID->2011700376],
Cell[20823, 598, 513, 14, 70, "ProofText", "ExpressionUUID" -> \
"a0748bd4-b862-4bc8-9cdc-f38ece05e99e",
 CellID->1318177734],
Cell[21339, 614, 518, 14, 70, "ProofText", "ExpressionUUID" -> \
"5a016cf2-266a-4053-9767-2bb710b3f368",
 CellID->867045541],
Cell[21860, 630, 411, 11, 70, "ProofText", "ExpressionUUID" -> \
"eb1d6af8-4ebf-4f21-8cd1-9064e8d5c7ca",
 CellID->2019780132],
Cell[22274, 643, 316, 6, 70, "ProofText", "ExpressionUUID" -> \
"e1048d06-0e49-4c58-9f53-df0a161c47d1",
 CellID->1922173611],
Cell[22593, 651, 227, 4, 70, "ProofText", "ExpressionUUID" -> \
"84aceded-c067-4d25-9882-beb5ec8de4d9",
 CellID->1718250931],
Cell[22823, 657, 311, 8, 70, "ProofText", "ExpressionUUID" -> \
"223ec96c-ac7b-47d1-be51-f7ec8b893902",
 CellID->625403761],
Cell[23137, 667, 646, 18, 70, "ProofText", "ExpressionUUID" -> \
"cc562e6a-dcff-41c3-9090-5744478ac605",
 CellID->1670843525],
Cell[23786, 687, 315, 6, 70, "ProofText", "ExpressionUUID" -> \
"bff0b860-2515-49a5-8565-a1b46f4e56d4",
 CellID->652211656],
Cell[24104, 695, 326, 6, 70, "ProofText", "ExpressionUUID" -> \
"0250ce5f-b307-4bb8-a60d-26a65488e3cd",
 CellID->1981094250],
Cell[24433, 703, 344, 7, 70, "ProofText", "ExpressionUUID" -> \
"b634f486-1e21-4833-9881-69af7a4c344c",
 CellID->761439595],
Cell[24780, 712, 221, 4, 70, "ProofText", "ExpressionUUID" -> \
"1c7ebbd8-053a-4e67-8f29-e0c40b9776dc",
 CellID->538780486],
Cell[25004, 718, 306, 6, 70, "ProofText", "ExpressionUUID" -> \
"ebad3868-58c7-4af8-9c83-1ab44d1a185d",
 CellID->1400627339]
}
]
*)

(* End of internal cache information *)

