(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8047,        237]
NotebookOptionsPosition[      6844,        202]
NotebookOutlinePosition[      7437,        222]
CellTagsIndexPosition[      7394,        219]
WindowTitle->Proof of (\:2227D2)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"simp", ":", " ", "\"\<\[And] def\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335011265348*^9, 3.715335019144208*^9}},
 CellID->1621663981,ExpressionUUID->"f6aa858e-6e54-4d63-92e9-1e11d17e876f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71533505052392*^9, 3.715335056316585*^9}},
 CellID->2139168285,ExpressionUUID->"1c0063ba-f7cb-4c8e-9607-f4457a1b57a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
        Theorema`Language`Forall$TM, {Theorema`Knowledge`BOOL$TM}]]], 
      TagBox[
       StyleBox["R", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["Q", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
           TagBox["\[Implies]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
            SyntaxForm->"x\[Implies]y"], 
           TagBox[
            StyleBox["R", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
          TagBox[")",
           "AutoParentheses"]}]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["R", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], ")"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153350630926647`*^9, 3.715335121729454*^9}},
 CellID->1730717471,ExpressionUUID->"bc6ff57e-7d01-4674-9156-6ddfc4c4ca0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["Q", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         FormBox[
          StyleBox["Q", "ExpressionABF"],
          TheoremaForm]}], 
        TagBox[")",
         "AutoParentheses"]}]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     FormBox[
      StyleBox["Q", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7153351281603203`*^9, 3.715335154881777*^9}, {
  3.7153353273728857`*^9, 3.7153353291520557`*^9}},
 CellID->1422040216,ExpressionUUID->"7ca5bb25-4555-4e39-ac54-8467a68a656f"],

Cell[BoxData[{
 RowBox[{"thus", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.715335195306616*^9, 3.715335255437851*^9}, 
   3.715335333182424*^9},
 CellID->850330599,ExpressionUUID->"8b357ca3-1a48-41a0-a5cc-d1d8f5bc3f9c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       TagBox[
        StyleBox["Q", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"intro", " ", "\"\<\[Implies]I\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.715335259267177*^9, 3.7153352928834257`*^9}, 
   3.715335342125765*^9},
 CellID->1761109414,ExpressionUUID->"d6413ab2-24b5-4f3c-b171-10d45903c041"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[And]D2)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 291, 6, 18, "ProofText", "ExpressionUUID" -> \
"f6aa858e-6e54-4d63-92e9-1e11d17e876f",
 CellID->1621663981],
Cell[885, 29, 370, 11, 20, "ProofText", "ExpressionUUID" -> \
"1c0063ba-f7cb-4c8e-9607-f4457a1b57a4",
 CellID->2139168285],
Cell[1258, 42, 2169, 59, 29, "ProofText", "ExpressionUUID" -> \
"bc6ff57e-7d01-4674-9156-6ddfc4c4ca0f",
 CellID->1730717471],
Cell[3430, 103, 1605, 46, 18, "ProofText", "ExpressionUUID" -> \
"7ca5bb25-4555-4e39-ac54-8467a68a656f",
 CellID->1422040216],
Cell[5038, 151, 379, 9, 39, "ProofText", "ExpressionUUID" -> \
"8b357ca3-1a48-41a0-a5cc-d1d8f5bc3f9c",
 CellID->850330599],
Cell[5420, 162, 1420, 38, 19, "ProofText", "ExpressionUUID" -> \
"d6413ab2-24b5-4f3c-b171-10d45903c041",
 CellID->1761109414]
}
]
*)

