(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9443,        267]
NotebookOptionsPosition[      8485,        238]
NotebookOutlinePosition[      9082,        258]
CellTagsIndexPosition[      9039,        255]
WindowTitle->Proof of (\:2200CE')
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["Q", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["t", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["thesis", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71791894385205*^9, 3.717918955868288*^9}},
 CellID->2115042752,ExpressionUUID->"7f01f68c-0147-4977-97cb-ec83deee251e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<2\>\""}], ":", 
   " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["t", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         UnderscriptBox[
          TagBox["\[ForAll]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
          RowBox[{
           TagBox[
            StyleBox["Q", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0],
                Theorema`Knowledge`BOOL$TM]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]], 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["thesis", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`FORM$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.717918957850195*^9, 3.7179189817550383`*^9}},
 CellID->575257447,ExpressionUUID->"3ecd9f23-f6aa-432c-a8b8-231be0ace6ba"],

Cell[BoxData[
 RowBox[{"from", " ", "\"\<1\>\"", " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox[
      StyleBox["Q", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     TagBox[
      StyleBox["t", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     "]"}], 
    TagBox["\[LongRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
     SyntaxForm->"x\[LongRightArrow]y"], 
    RowBox[{
     TagBox[
      StyleBox["P", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Knowledge`BOOL$TM]]]], "[", 
     TagBox[
      StyleBox["t", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[ForAll]CD\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7179189945825853`*^9, 3.717919011928979*^9}},
 CellID->884855528,ExpressionUUID->"9ed618db-54e0-4184-9fa6-7b10a0ad55e4"],

Cell[BoxData[
 RowBox[{"from", " ", "this", " ", "\"\<1\>\"", " ", "show", " ", 
  FormBox[
   StyleBox["thesis", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7179190162327337`*^9, 3.7179190308956413`*^9}},
 CellID->1126590645,ExpressionUUID->"42b17517-c2e4-4d22-b557-eb73c677a772"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (\[ForAll]CE')",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 521, 17, 20, "ProofText", "ExpressionUUID" -> \
"7f01f68c-0147-4977-97cb-ec83deee251e",
 CellID->2115042752],
Cell[1116, 40, 5306, 141, 35, "ProofText", "ExpressionUUID" -> \
"3ecd9f23-f6aa-432c-a8b8-231be0ace6ba",
 CellID->575257447],
Cell[6425, 183, 1551, 40, 21, "ProofText", "ExpressionUUID" -> \
"9ed618db-54e0-4184-9fa6-7b10a0ad55e4",
 CellID->884855528],
Cell[7979, 225, 502, 11, 19, "ProofText", "ExpressionUUID" -> \
"42b17517-c2e4-4d22-b557-eb73c677a772",
 CellID->1126590645]
}
]
*)

