(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16659,        486]
NotebookOptionsPosition[     14818,        436]
NotebookOutlinePosition[     15416,        456]
CellTagsIndexPosition[     15373,        453]
WindowTitle->Proof of (If \254cond)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["y", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903323764879*^9, 3.719033245403179*^9}},
 CellID->299966502,ExpressionUUID->"d18bdb31-253f-43d3-b84a-0f4106f1c266"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     FormBox[
      StyleBox["P", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033248037077*^9, 3.719033252027577*^9}, {
  3.7190337941976223`*^9, 3.719033801005632*^9}},
 CellID->1131339139,ExpressionUUID->"7320c01b-8370-4fe9-90e6-5612bb4db936"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["Q", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Lambda]", 
      TagBox[
       StyleBox["z", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["P", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["z", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
           TagBox["\[Equal]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[Equal]y"], 
           TagBox[
            StyleBox["x", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
          TagBox[")",
           "AutoParentheses"]}]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[And]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
        SyntaxForm->"x\[And]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox["\[Not]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
            SyntaxForm->"\[Not]x"], 
           TagBox[
            StyleBox["P", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
          TagBox[")",
           "AutoParentheses"]}], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            StyleBox["z", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
           TagBox["\[Equal]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[Equal]y"], 
           TagBox[
            StyleBox["y", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
          TagBox[")",
           "AutoParentheses"]}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033381733161*^9, 3.719033408616609*^9}},
 CellID->1435251069,ExpressionUUID->"2381c8be-2829-46eb-bc83-f2796a54c35a"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["Q", "ExpressionSyntactic"],
     TheoremaForm], "[", 
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["Q", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<SomeI\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033422274084*^9, 3.719033447096874*^9}},
 CellID->312787261,ExpressionUUID->"a2b05197-9f79-4bc6-a2ac-e89b9fdc359e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          FormBox[
           StyleBox["y", "ExpressionABF"],
           TheoremaForm], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox["\[Not]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
           SyntaxForm->"\[Not]x"], 
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          FormBox[
           StyleBox["y", "ExpressionABF"],
           TheoremaForm], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Equal]y"], 
          TagBox[
           StyleBox["y", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
     "intro", " ", "\"\<\[And]I\>\"", " ", "\"\<\[Implies]I\>\"", " ", 
      "\"\<\[Equal] refl\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033466163023*^9, 3.719033559362998*^9}, {
  3.719033811847519*^9, 3.719033825741444*^9}},
 CellID->488368440,ExpressionUUID->"05149d29-4fa8-422a-929c-1e4292b5608c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033563862568*^9, 3.719033575261362*^9}, {
  3.7190338308374147`*^9, 3.7190338326836557`*^9}},
 CellID->171964964,ExpressionUUID->"b969139f-6d3a-4ba4-9c2e-0ec17b7ba1ea"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Not]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["y", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Equal]y"], 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
     "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033577901331*^9, 3.719033593639833*^9}, {
  3.719033837053753*^9, 3.719033849231905*^9}},
 CellID->1452130334,ExpressionUUID->"93024fa3-28b3-47eb-905b-5358ce596cbb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033598312675*^9, 3.719033604754583*^9}},
 CellID->1785015531,ExpressionUUID->"301b74d0-d2ce-4157-ba21-5ff59444b090"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Not]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
        SyntaxForm->"\[Not]x"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[Implies]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
      SyntaxForm->"x\[Implies]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["Some",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`Some$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], "[", 
        FormBox[
         StyleBox["Q", "ExpressionSyntactic"],
         TheoremaForm], "]"}], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Equal]y"], 
       TagBox[
        StyleBox["y", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
  ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.719033629840768*^9, 3.719033651170896*^9}, {
  3.719033859544333*^9, 3.719033866623848*^9}, {3.7190339010622396`*^9, 
  3.719033906767952*^9}},
 CellID->1206170958,ExpressionUUID->"3727691f-77fe-4511-9c03-1c0fdbfbce67"],

Cell[BoxData[
 RowBox[{"with", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"\[Not]", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"Some", "[", 
     FormBox[
      StyleBox["Q", "ExpressionSyntactic"],
      TheoremaForm], "]"}], "\[Equal]", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<modus ponens reverse\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.71903367515236*^9, 3.7190337187643013`*^9}, {
  3.7190339136954517`*^9, 3.719033921295336*^9}},
 CellID->651183493,ExpressionUUID->"cfaf53cb-791e-4146-ac94-8c89c8fe34aa"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], ",", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], ",", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm]}], "]"}], "\[Equal]", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<If def\>\"", " ", "by", " ", "fact"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7190332561633987`*^9, 3.719033284646645*^9}, {
   3.719033735476424*^9, 3.719033743180622*^9}, 3.7190339271453333`*^9},
 CellID->675109028,ExpressionUUID->"175b4a11-0e18-4c48-ad68-a3ce4c4ba74e"]
},
WindowSize->{808, 869},
WindowMargins->{{1, Automatic}, {Automatic, 22}},
WindowTitle->"Proof of (If \[Not]cond)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 442, 14, 20, "ProofText", "ExpressionUUID" -> \
"d18bdb31-253f-43d3-b84a-0f4106f1c266",
 CellID->299966502],
Cell[1039, 37, 440, 11, 20, "ProofText", "ExpressionUUID" -> \
"7320c01b-8370-4fe9-90e6-5612bb4db936",
 CellID->1131339139],
Cell[1482, 50, 3897, 109, 28, "ProofText", "ExpressionUUID" -> \
"2381c8be-2829-46eb-bc83-f2796a54c35a",
 CellID->1435251069],
Cell[5382, 161, 583, 16, 39, "ProofText", "ExpressionUUID" -> \
"a2b05197-9f79-4bc6-a2ac-e89b9fdc359e",
 CellID->312787261],
Cell[5968, 179, 3397, 98, 39, "ProofText", "ExpressionUUID" -> \
"05149d29-4fa8-422a-929c-1e4292b5608c",
 CellID->488368440],
Cell[9368, 279, 378, 10, 20, "ProofText", "ExpressionUUID" -> \
"b969139f-6d3a-4ba4-9c2e-0ec17b7ba1ea",
 CellID->171964964],
Cell[9749, 291, 1188, 30, 18, "ProofText", "ExpressionUUID" -> \
"93024fa3-28b3-47eb-905b-5358ce596cbb",
 CellID->1452130334],
Cell[10940, 323, 276, 6, 39, "ProofText", "ExpressionUUID" -> \
"301b74d0-d2ce-4157-ba21-5ff59444b090",
 CellID->1785015531],
Cell[11219, 331, 1899, 53, 18, "ProofText", "ExpressionUUID" -> \
"3727691f-77fe-4511-9c03-1c0fdbfbce67",
 CellID->1206170958],
Cell[13121, 386, 801, 22, 18, "ProofText", "ExpressionUUID" -> \
"cfaf53cb-791e-4146-ac94-8c89c8fe34aa",
 CellID->651183493],
Cell[13925, 410, 889, 24, 20, "ProofText", "ExpressionUUID" -> \
"175b4a11-0e18-4c48-ad68-a3ce4c4ba74e",
 CellID->675109028]
}
]
*)

