(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4382,        127]
NotebookOptionsPosition[      3444,        102]
NotebookOutlinePosition[      4054,        122]
CellTagsIndexPosition[      4011,        119]
WindowTitle->Proof of (\:22C2- dist left)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", 
     RowBox[{
     "\"\<\[Equal] iff SET\>\"", " ", "\"\<\[And]\[Or] dist left\>\"", " ", 
      "\"\<\[ForAll] reflect\>\""}]}]}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765266642232916*^9, 3.765266649596752*^9}, {
  3.765266687820855*^9, 3.765266711580092*^9}, {3.765266755267623*^9, 
  3.765266761315523*^9}},
 CellID->342209486,ExpressionUUID->"101bf1fe-0d12-426d-aa47-6ff4a78375c4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765266764156362*^9, 3.765266775362834*^9}},
 CellID->1296323830,ExpressionUUID->"9121d5a0-8ae9-4cf1-8a86-b590354d32d2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"simp", " ", 
      RowBox[{"only", ":", " ", 
       RowBox[{"\"\<\[And] assoc\>\"", " ", 
        RowBox[{"\"\<\[And] comm\>\"", "[", 
         RowBox[{"of", " ", "_", " ", 
          RowBox[{"\[OpenCurlyQuote]", 
           RowBox[{
            FormBox[
             StyleBox["x", "ExpressionABF"],
             TheoremaForm], "\[NotElement]", 
            FormBox[
             StyleBox["C", "ExpressionABF"],
             TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "]"}]}]}]}], ",", 
     "\n", "\t\t\t\t", 
     RowBox[{"simp", " ", 
      RowBox[{"add", ":", " ", 
       RowBox[{"\"\<\[And] assoc\>\"", "[", 
        RowBox[{"symmetric", ",", " ", 
         RowBox[{"of", " ", 
          RowBox[{"\[OpenCurlyQuote]", 
           RowBox[{
            FormBox[
             StyleBox["x", "ExpressionABF"],
             TheoremaForm], "\[NotElement]", 
            FormBox[
             StyleBox["C", "ExpressionABF"],
             TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}], "]"}]}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652667795410547`*^9, 3.765266793259453*^9}, {
  3.765266853762439*^9, 3.765266869555419*^9}, {3.765266907345784*^9, 
  3.76526694219273*^9}, {3.765266982112709*^9, 3.76526700731254*^9}},
 CellID->465396388,ExpressionUUID->"41dbc108-61e4-413b-bd82-0b06af97ee2b"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7652670099216843`*^9, 3.765267011640362*^9}},
 CellID->1600190354,ExpressionUUID->"6e9d9472-5bd2-47d1-a0c9-01f45a0cfd5d"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Intersection]- dist left)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 522, 12, 19, "ProofText",ExpressionUUID->"101bf1fe-0d12-426d-aa47-6ff4a78375c4",
 CellID->342209486],
Cell[1125, 35, 549, 18, 19, "ProofText",ExpressionUUID->"9121d5a0-8ae9-4cf1-8a86-b590354d32d2",
 CellID->1296323830],
Cell[1677, 55, 1447, 37, 42, "ProofText",ExpressionUUID->"41dbc108-61e4-413b-bd82-0b06af97ee2b",
 CellID->465396388],
Cell[3127, 94, 313, 6, 20, "ProofText",ExpressionUUID->"6e9d9472-5bd2-47d1-a0c9-01f45a0cfd5d",
 CellID->1600190354]
}
]
*)

