(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      4060,        124]
NotebookOptionsPosition[      3026,         97]
NotebookOutlinePosition[      3618,        117]
CellTagsIndexPosition[      3575,        114]
WindowTitle->Proof of (Pow mono)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]I\>\""}], ",", " ", "simp"}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271263966823*^9, 3.765271294555669*^9}},
 CellID->1905468003,ExpressionUUID->"b205e0df-3c30-4abe-8dd6-c9a1548177d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271296509017*^9, 3.7652713040544453`*^9}},
 CellID->57907166,ExpressionUUID->"5189ccfa-5202-4f46-bef5-9da57bbcaffb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271306260631*^9, 3.765271328054223*^9}},
 CellID->304271789,ExpressionUUID->"0ba6fc4f-8127-465e-bbb8-936caa5d6a6c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual] trans\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652713299325*^9, 3.765271347757576*^9}},
 CellID->1032246857,ExpressionUUID->"760889f6-c441-47d6-838b-05921bb5ae6a"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765271349364511*^9, 3.7652713510269327`*^9}},
 CellID->1778122715,ExpressionUUID->"c844e6f2-9ddd-4b76-a451-9172728bd0f8"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (Pow mono)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 328, 8, 19, "ProofText",ExpressionUUID->"b205e0df-3c30-4abe-8dd6-c9a1548177d2",
 CellID->1905468003],
Cell[922, 31, 444, 14, 19, "ProofText",ExpressionUUID->"5189ccfa-5202-4f46-bef5-9da57bbcaffb",
 CellID->57907166],
Cell[1369, 47, 761, 22, 19, "ProofText",ExpressionUUID->"0ba6fc4f-8127-465e-bbb8-936caa5d6a6c",
 CellID->304271789],
Cell[2133, 71, 573, 16, 19, "ProofText",ExpressionUUID->"760889f6-c441-47d6-838b-05921bb5ae6a",
 CellID->1032246857],
Cell[2709, 89, 313, 6, 20, "ProofText",ExpressionUUID->"c844e6f2-9ddd-4b76-a451-9172728bd0f8",
 CellID->1778122715]
}
]
*)

