(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6013,        178]
NotebookOptionsPosition[      5087,        153]
NotebookOutlinePosition[      5684,        173]
CellTagsIndexPosition[      5641,        170]
WindowTitle->Proof of (\:F431E SET)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["thesis", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010507507188*^9, 3.7650105229472933`*^9}},
 CellID->1417868819,ExpressionUUID->"6b917faf-76b0-4f56-855e-12005c5128c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       TagBox["\[SubsetEqual]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[SubsetEqual]y"], 
       TagBox[
        StyleBox["B", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["B", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       TagBox["\[SubsetEqual]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[SubsetEqual]y"], 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     TagBox[
      StyleBox["thesis", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`FORM$TM]]]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010526121994*^9, 3.7650106282813797`*^9}},
 CellID->750793393,ExpressionUUID->"fe48a46c-c81d-4733-baf8-159f94f49448"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  FormBox[
   StyleBox["thesis", "ExpressionABF"],
   TheoremaForm]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"apply", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"apply", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"simp", " ", 
      RowBox[{"add", ":", " ", 
       RowBox[{"\[OpenCurlyQuote]", 
        RowBox[{
         FormBox[
          StyleBox["A", "ExpressionABF"],
          TheoremaForm], "\[Equal]", 
         FormBox[
          StyleBox["B", "ExpressionABF"],
          TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}], ")"}], 
    "+"]}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010633122427*^9, 3.765010731085923*^9}, {
  3.765510591353323*^9, 3.765510591617692*^9}},
 CellID->111101115,ExpressionUUID->"725d4e64-f12b-47a3-8500-e2f4a5f063ef"],

Cell[BoxData["qed"], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765010743103095*^9, 3.7650107434934673`*^9}},
 CellID->398770169,ExpressionUUID->"859e06cf-045c-4a42-b563-289a01542177"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Equal]E SET)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 451, 14, 19, "ProofText",ExpressionUUID->"6b917faf-76b0-4f56-855e-12005c5128c9",
 CellID->1417868819],
Cell[1048, 37, 2859, 78, 19, "ProofText",ExpressionUUID->"fe48a46c-c81d-4733-baf8-159f94f49448",
 CellID->750793393],
Cell[3910, 117, 882, 27, 64, "ProofText",ExpressionUUID->"725d4e64-f12b-47a3-8500-e2f4a5f063ef",
 CellID->111101115],
Cell[4795, 146, 288, 5, 20, "ProofText",ExpressionUUID->"859e06cf-045c-4a42-b563-289a01542177",
 CellID->398770169]
}
]
*)

