(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8074,        237]
NotebookOptionsPosition[      6904,        208]
NotebookOutlinePosition[      7505,        228]
CellTagsIndexPosition[      7462,        225]
WindowTitle->Proof of (@\:2286 I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[And]", "a"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Element]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}], ")"}], "\[LongRightArrow]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", "a", "]"}], "\[Element]", 
        FormBox[
         StyleBox["B", "ExpressionABF"],
         TheoremaForm]}], ")"}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651031334820957`*^9, 3.765103170411982*^9}, {
  3.7651033010252457`*^9, 3.765103301734727*^9}},
 CellID->1530306591,ExpressionUUID->"c6d0a2ad-49f2-4616-97c9-779c9b02c0d2"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      TagBox["@",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
       SyntaxForm->"x@y"], 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    TagBox[
     StyleBox["B", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Knowledge`SET$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765103176698928*^9, 3.765103181800303*^9}},
 CellID->519838779,ExpressionUUID->"a2f56d0a-2a4e-44ba-89a6-1271c5530175"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765103184241411*^9, 3.765103206898594*^9}},
 CellID->1916683158,ExpressionUUID->"491dd467-c53d-46e7-8f18-ff42c4dc67e1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<x\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765103214089047*^9, 3.765103271406878*^9}},
 CellID->674452885,ExpressionUUID->"2591ddab-f15e-408c-9038-9082af06fe8d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["x", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
     TagBox["\[Element]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->"x\[Element]y"], 
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]]}], 
    "\[CloseCurlyQuote]"}], " ", "unfolding", " ", "\"\<x\>\"", " ", "using", 
   " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765103258384597*^9, 3.765103310646831*^9}},
 CellID->263457010,ExpressionUUID->"67f4db95-bb60-4b62-9f75-01c8909dfef7"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7651029051824217`*^9, 3.765102988554572*^9}, {
  3.765103021209943*^9, 3.765103021866089*^9}, {3.765103317054225*^9, 
  3.765103318694569*^9}},
 CellID->914776532,ExpressionUUID->"2edfed29-68f7-45f4-98ae-5df3142a3566"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (@\[SubsetEqual] I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 1121, 35, 26, "ProofText",ExpressionUUID->"c6d0a2ad-49f2-4616-97c9-779c9b02c0d2",
 CellID->1530306591],
Cell[1716, 58, 1729, 44, 42, "ProofText",ExpressionUUID->"a2f56d0a-2a4e-44ba-89a6-1271c5530175",
 CellID->519838779],
Cell[3448, 104, 688, 21, 19, "ProofText",ExpressionUUID->"491dd467-c53d-46e7-8f18-ff42c4dc67e1",
 CellID->1916683158],
Cell[4139, 127, 1017, 32, 19, "ProofText",ExpressionUUID->"2591ddab-f15e-408c-9038-9082af06fe8d",
 CellID->674452885],
Cell[5159, 161, 1328, 35, 19, "ProofText",ExpressionUUID->"67f4db95-bb60-4b62-9f75-01c8909dfef7",
 CellID->263457010],
Cell[6490, 198, 410, 8, 20, "ProofText",ExpressionUUID->"2edfed29-68f7-45f4-98ae-5df3142a3566",
 CellID->914776532]
}
]
*)

