(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13343,        383]
NotebookOptionsPosition[     11354,        340]
NotebookOutlinePosition[     11948,        360]
CellTagsIndexPosition[     11905,        357]
WindowTitle->Proof of (\:2200@)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76526985987199*^9, 3.765269867968103*^9}},
 CellID->573973656,ExpressionUUID->"2d90ca99-abd6-4db6-8680-a1cda29b1ecd"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
   "intro", " ", "\"\<\[DoubleLeftRightArrow]I\>\"", " ", 
    "\"\<\[ForAll]CI\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269875734696*^9, 3.7652698898450947`*^9}},
 CellID->1056658407,ExpressionUUID->"0fdc2c6e-9cb3-4922-83b5-cbe98adc418e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269904734599*^9, 3.765269918968566*^9}},
 CellID->838085054,ExpressionUUID->"fef36610-f8e7-4336-9afc-94be2f8e34d1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"hence", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<@I\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652699306699657`*^9, 3.7652699536735153`*^9}, {
  3.765270040910507*^9, 3.765270041883408*^9}},
 CellID->2011876230,ExpressionUUID->"da1e8b10-7561-49d1-913d-3e1f5f660408"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        "\[Element]", 
        RowBox[{
         TagBox[
          StyleBox["f", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
         TagBox["@",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
          
          SyntaxForm->"x@y"], 
         TagBox[
          StyleBox["A", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76526995896566*^9, 3.765269970009704*^9}, {
  3.765270044090962*^9, 3.765270045043648*^9}},
 CellID->714238820,ExpressionUUID->"4362cfd5-e048-4b6e-bbf4-3ecaf50fa275"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", "\"\<*\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269972157515*^9, 3.765270010995672*^9}, {
  3.765270046955262*^9, 3.765270053042961*^9}},
 CellID->1759660323,ExpressionUUID->"eafa48a8-56bf-460c-9de9-6928a4729e67"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76527005605238*^9, 3.7652700587550592`*^9}},
 CellID->67746720,ExpressionUUID->"553e6da0-75ac-41bb-9fe3-d37449eff332"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76527006247639*^9, 3.765270085133451*^9}},
 CellID->1624551914,ExpressionUUID->"90263232-641c-4e6d-873d-b5ca417a02a2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["b", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["b", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<x\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["b", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652700876997957`*^9, 3.765270133955319*^9}},
 CellID->1609430716,ExpressionUUID->"55b67af6-7a76-4578-9832-6b606d3f96a5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["a", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "\[Element]", 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        TagBox[
         StyleBox["a", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652701412112103`*^9, 3.765270149533408*^9}},
 CellID->796788481,ExpressionUUID->"93458f5f-3f4b-40c5-b40e-43af1dcd1108"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["b", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["b", "ExpressionABF"],
        TheoremaForm], "]"}], "]"}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270152267262*^9, 3.765270178236906*^9}},
 CellID->1416830938,ExpressionUUID->"69dd36ef-5b13-479f-b95e-8407dfbb5d04"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<x\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270180763014*^9, 3.765270189257325*^9}},
 CellID->1358737719,ExpressionUUID->"b60091eb-323a-492e-8487-3eb98a81e3d8"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765270191530796*^9, 3.765270193393283*^9}},
 CellID->1274262502,ExpressionUUID->"d5ed7186-d4e1-4f6a-afa6-6617ec5390e8"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[ForAll]@)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 442, 14, 19, "ProofText",ExpressionUUID->"2d90ca99-abd6-4db6-8680-a1cda29b1ecd",
 CellID->573973656],
Cell[1035, 37, 378, 9, 42, "ProofText",ExpressionUUID->"0fdc2c6e-9cb3-4922-83b5-cbe98adc418e",
 CellID->1056658407],
Cell[1416, 48, 582, 17, 19, "ProofText",ExpressionUUID->"fef36610-f8e7-4336-9afc-94be2f8e34d1",
 CellID->838085054],
Cell[2001, 67, 878, 26, 19, "ProofText",ExpressionUUID->"da1e8b10-7561-49d1-913d-3e1f5f660408",
 CellID->2011876230],
Cell[2882, 95, 2327, 59, 28, "ProofText",ExpressionUUID->"4362cfd5-e048-4b6e-bbf4-3ecaf50fa275",
 CellID->714238820],
Cell[5212, 156, 702, 20, 19, "ProofText",ExpressionUUID->"eafa48a8-56bf-460c-9de9-6928a4729e67",
 CellID->1759660323],
Cell[5917, 178, 219, 4, 19, "ProofText",ExpressionUUID->"553e6da0-75ac-41bb-9fe3-d37449eff332",
 CellID->67746720],
Cell[6139, 184, 687, 21, 19, "ProofText",ExpressionUUID->"90263232-641c-4e6d-873d-b5ca417a02a2",
 CellID->1624551914],
Cell[6829, 207, 1020, 32, 19, "ProofText",ExpressionUUID->"55b67af6-7a76-4578-9832-6b606d3f96a5",
 CellID->1609430716],
Cell[7852, 241, 1944, 50, 27, "ProofText",ExpressionUUID->"93458f5f-3f4b-40c5-b40e-43af1dcd1108",
 CellID->796788481],
Cell[9799, 293, 882, 27, 19, "ProofText",ExpressionUUID->"69dd36ef-5b13-479f-b95e-8407dfbb5d04",
 CellID->1416830938],
Cell[10684, 322, 352, 8, 19, "ProofText",ExpressionUUID->"b60091eb-323a-492e-8487-3eb98a81e3d8",
 CellID->1358737719],
Cell[11039, 332, 311, 6, 20, "ProofText",ExpressionUUID->"d5ed7186-d4e1-4f6a-afa6-6617ec5390e8",
 CellID->1274262502]
}
]
*)

