(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6350,        186]
NotebookOptionsPosition[      5047,        155]
NotebookOutlinePosition[      5668,        175]
CellTagsIndexPosition[      5625,        172]
WindowTitle->Proof of (\:2282 implies \:2203\:2208)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765086653800172*^9, 3.765086658767396*^9}},
 CellID->1249171141,ExpressionUUID->"f82aa265-6767-4ac3-8722-1df6d502407a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[Subset]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Subset$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[Subset]y"], 
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765086662710678*^9, 3.7650866669332523`*^9}},
 CellID->1565180485,ExpressionUUID->"8a1a1b3a-4fc9-4290-90fb-b363ca046ec4"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"\[Not]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[Subset]E\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650874555810337`*^9, 3.7650874893588667`*^9}},
 CellID->294042336,ExpressionUUID->"799f4596-7873-4c71-9196-23f0240cbd80"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"(", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{"x", "\[Element]", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]], 
     RowBox[{"x", "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], ")"}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<\[SubsetEqual] alt\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765087495364558*^9, 3.765087594642137*^9}},
 CellID->1886165268,ExpressionUUID->"d9ccd5e9-a5e1-4a78-bb81-3b18d8043f39"],

Cell[BoxData[
 RowBox[{
  RowBox[{"then", " ", "obtain", " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", "where", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765087599555717*^9, 3.765087629259804*^9}},
 CellID->1200360848,ExpressionUUID->"89833b31-3542-4613-bc82-0e57fa38026f"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], "\[Element]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "-", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  "simp"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650876359528913`*^9, 3.765087655760936*^9}},
 CellID->503723001,ExpressionUUID->"6e67402f-6684-448a-9684-0ad1bb4ba292"],

Cell[BoxData[
 RowBox[{
  RowBox[{"thus", " ", "_"}], " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765086672848125*^9, 3.765086817059451*^9}, {
  3.765087661009235*^9, 3.7650876665529203`*^9}},
 CellID->106808225,ExpressionUUID->"9f93634e-f346-45dd-836f-1b0e7cf4d033"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Subset] implies \[Exists]\[Element])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 371, 11, 19, "ProofText",ExpressionUUID->"f82aa265-6767-4ac3-8722-1df6d502407a",
 CellID->1249171141],
Cell[984, 34, 995, 25, 19, "ProofText",ExpressionUUID->"8a1a1b3a-4fc9-4290-90fb-b363ca046ec4",
 CellID->1565180485],
Cell[1982, 61, 566, 15, 19, "ProofText",ExpressionUUID->"799f4596-7873-4c71-9196-23f0240cbd80",
 CellID->294042336],
Cell[2551, 78, 707, 20, 30, "ProofText",ExpressionUUID->"d9ccd5e9-a5e1-4a78-bb81-3b18d8043f39",
 CellID->1886165268],
Cell[3261, 100, 827, 24, 19, "ProofText",ExpressionUUID->"89833b31-3542-4613-bc82-0e57fa38026f",
 CellID->1200360848],
Cell[4091, 126, 565, 17, 19, "ProofText",ExpressionUUID->"6e67402f-6684-448a-9684-0ad1bb4ba292",
 CellID->503723001],
Cell[4659, 145, 384, 8, 20, "ProofText",ExpressionUUID->"9f93634e-f346-45dd-836f-1b0e7cf4d033",
 CellID->106808225]
}
]
*)

