(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14776,        448]
NotebookOptionsPosition[     12542,        401]
NotebookOutlinePosition[     13143,        421]
CellTagsIndexPosition[     13100,        418]
WindowTitle->Proof of (\:2286@ E)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[And]", "C"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"C", "\[SubsetEqual]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}], ")"}], "\[LongRightArrow]", 
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["B", "ExpressionABF"],
         TheoremaForm], "\[Equal]", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "@", "C"}]}], ")"}], "\[LongRightArrow]", 
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651033410648937`*^9, 3.765103414296485*^9}},
 CellID->1724772664,ExpressionUUID->"4c62c5eb-eb04-4cca-9317-7a312bf5c465"],

Cell[BoxData[
 RowBox[{
  RowBox[{"let", " ", 
   FormBox[
    StyleBox["C", "ExpressionSyntactic"],
    TheoremaForm], " ", "be", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"{", 
     RowBox[{"x", 
      UnderscriptBox["|", 
       RowBox[{"x", "\[Element]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}]], 
      RowBox[{
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", "x", "]"}], "\[Element]", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "}"}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104039504603*^9, 3.765104061380858*^9}},
 CellID->483567736,ExpressionUUID->"5281a534-be00-4e2c-b94c-32fcee0ed437"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["C", "ExpressionSyntactic"],
     TheoremaForm], "\[SubsetEqual]", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"simp", " ", 
      RowBox[{"add", ":", " ", 
       RowBox[{
       "\"\<\[SubsetEqual] def\>\"", " ", "\"\<SetOf def\>\"", " ", 
        "\"\<\[ForAll] reflect\>\"", " ", 
        "\"\<\[Implies]\[And] left\>\""}]}]}], ",", " ", 
     RowBox[{"simp", " ", 
      RowBox[{"add", ":", " ", "\"\<\[Implies] reflect\>\""}]}]}], 
    ")"}]}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651034239586763`*^9, 3.76510348361287*^9}, {
  3.7651035227802896`*^9, 3.765103689770451*^9}, {3.765104065653564*^9, 
  3.7651040675612926`*^9}},
 CellID->668714773,ExpressionUUID->"f251776e-ed75-4bc5-9cf6-31dc117449b3"],

Cell[BoxData[{
 RowBox[{"moreover", " ", "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], "\[Equal]", 
    RowBox[{
     FormBox[
      StyleBox["f", "ExpressionABF"],
      TheoremaForm], "@", 
     FormBox[
      StyleBox["C", "ExpressionSyntactic"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
   "intro", " ", "\"\<\[SubsetEqual] antisym\>\"", " ", 
    "\"\<\[SubsetEqual]I\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765103694403157*^9, 3.7651037507295723`*^9}, {
  3.765103797336371*^9, 3.765103799704564*^9}, {3.76510388343931*^9, 
  3.765103898831833*^9}, {3.7651040720211077`*^9, 3.765104073880786*^9}},
 CellID->763261184,ExpressionUUID->"752fc8e4-3c86-4792-bcc5-88c0732ec3f4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["b", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["b", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765103901921068*^9, 3.7651039173707647`*^9}},
 CellID->1437803788,ExpressionUUID->"d9503c42-be54-4140-ba01-0fbe92a91236"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "@", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["b", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "@", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765103919936837*^9, 3.765103963462789*^9}},
 CellID->644269467,ExpressionUUID->"ff730f49-a736-43d6-bd25-d84108c248e1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["b", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651039741841288`*^9, 3.765104006185416*^9}},
 CellID->709660850,ExpressionUUID->"cacf87b5-76e1-4aac-a2ba-cba3843466e5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["b", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["C", "ExpressionSyntactic"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<SetOf def\>\""}]}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765104016927623*^9, 3.7651040351256857`*^9}, {
  3.76510408072069*^9, 3.765104184147684*^9}},
 CellID->166130795,ExpressionUUID->"1e1f368d-c5f6-4f4d-b4c8-b6c8777cca01"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["b", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["b", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["C", "ExpressionSyntactic"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651041976452913`*^9, 3.765104227379447*^9}},
 CellID->399745848,ExpressionUUID->"8b681104-73aa-4182-8af6-3d52bf9db992"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104230989009*^9, 3.765104233251643*^9}},
 CellID->1825188357,ExpressionUUID->"2aa4da97-aa5a-4d26-865b-7573158c36d5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["C", "ExpressionSyntactic"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104242310788*^9, 3.765104269022367*^9}},
 CellID->160038690,ExpressionUUID->"964dfa28-94db-4f5e-8707-a00589e90aa1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["C", "ExpressionSyntactic"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104271548121*^9, 3.7651043076303453`*^9}},
 CellID->1368093352,ExpressionUUID->"10353dbb-3be2-46f8-a2d8-2d9773f487cf"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<SetOf def\>\""}]}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765104323684093*^9, 3.765104347375456*^9}},
 CellID->407705071,ExpressionUUID->"c99de744-133c-4007-ace6-f7809237f803"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104351523274*^9, 3.7651043536906548`*^9}},
 CellID->75687321,ExpressionUUID->"9fcad7b3-a4ac-4113-9f88-d8f41d58866d"],

Cell[BoxData[
 RowBox[{"ultimately", " ", "show", " ", 
  FormBox[
   StyleBox["P", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765104356203599*^9, 3.7651043670936127`*^9}},
 CellID->854829013,ExpressionUUID->"c98e4a05-38bd-4a90-97f9-7b35e8d51912"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual]@ E)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 1611, 52, 27, "ProofText",ExpressionUUID->"4c62c5eb-eb04-4cca-9317-7a312bf5c465",
 CellID->1724772664],
Cell[2206, 75, 800, 25, 34, "ProofText",ExpressionUUID->"5281a534-be00-4e2c-b94c-32fcee0ed437",
 CellID->483567736],
Cell[3009, 102, 983, 27, 42, "ProofText",ExpressionUUID->"f251776e-ed75-4bc5-9cf6-31dc117449b3",
 CellID->668714773],
Cell[3995, 131, 863, 23, 42, "ProofText",ExpressionUUID->"752fc8e4-3c86-4792-bcc5-88c0732ec3f4",
 CellID->763261184],
Cell[4861, 156, 585, 17, 19, "ProofText",ExpressionUUID->"d9503c42-be54-4140-ba01-0fbe92a91236",
 CellID->1437803788],
Cell[5449, 175, 1020, 32, 19, "ProofText",ExpressionUUID->"ff730f49-a736-43d6-bd25-d84108c248e1",
 CellID->644269467],
Cell[6472, 209, 976, 30, 19, "ProofText",ExpressionUUID->"cacf87b5-76e1-4aac-a2ba-cba3843466e5",
 CellID->709660850],
Cell[7451, 241, 910, 26, 19, "ProofText",ExpressionUUID->"1e1f368d-c5f6-4f4d-b4c8-b6c8777cca01",
 CellID->166130795],
Cell[8364, 269, 983, 31, 19, "ProofText",ExpressionUUID->"8b681104-73aa-4182-8af6-3d52bf9db992",
 CellID->399745848],
Cell[9350, 302, 220, 4, 19, "ProofText",ExpressionUUID->"2aa4da97-aa5a-4d26-865b-7573158c36d5",
 CellID->1825188357],
Cell[9573, 308, 693, 21, 19, "ProofText",ExpressionUUID->"964dfa28-94db-4f5e-8707-a00589e90aa1",
 CellID->160038690],
Cell[10269, 331, 983, 30, 19, "ProofText",ExpressionUUID->"10353dbb-3be2-46f8-a2d8-2d9773f487cf",
 CellID->1368093352],
Cell[11255, 363, 589, 17, 19, "ProofText",ExpressionUUID->"c99de744-133c-4007-ace6-f7809237f803",
 CellID->407705071],
Cell[11847, 382, 219, 4, 19, "ProofText",ExpressionUUID->"9fcad7b3-a4ac-4113-9f88-d8f41d58866d",
 CellID->75687321],
Cell[12069, 388, 469, 11, 20, "ProofText",ExpressionUUID->"c98e4a05-38bd-4a90-97f9-7b35e8d51912",
 CellID->854829013]
}
]
*)

