(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9963,        294]
NotebookOptionsPosition[      8324,        257]
NotebookOutlinePosition[      8921,        277]
CellTagsIndexPosition[      8878,        274]
WindowTitle->Proof of (\:22C3 mono)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["D", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["D", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652720808682947`*^9, 3.765272116020235*^9}},
 CellID->1219819328,ExpressionUUID->"37032f27-37a7-4048-873d-9138a5d81c23"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Union]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Union$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Union]y"], 
      TagBox[
       StyleBox["C", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Union]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Union$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Union]y"], 
      TagBox[
       StyleBox["D", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]I\>\""}], ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Union]E\>\""}]}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765272118450656*^9, 3.765272139696888*^9}},
 CellID->1346744578,ExpressionUUID->"5c9e510e-4edd-4cd0-aaa7-8be00662781a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652721456182623`*^9, 3.765272160071211*^9}},
 CellID->1820737598,ExpressionUUID->"6d8f502a-001b-4865-ad5f-b46f8745cb92"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765272162897872*^9, 3.765272178234725*^9}},
 CellID->246211538,ExpressionUUID->"ba5aa0b9-d8b3-4327-83bb-296eb3016e85"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[Union]", 
      FormBox[
       StyleBox["D", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Union]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652721802900667`*^9, 3.765272208495949*^9}},
 CellID->28790894,ExpressionUUID->"df685009-0f4d-41d7-b0b3-f5d76bcbf196"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765272211225329*^9, 3.765272213231998*^9}},
 CellID->2009407087,ExpressionUUID->"672b3d61-4be2-498a-bb03-715666056931"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["c", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["c", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652721456182623`*^9, 3.765272160071211*^9}, {
  3.765272220073453*^9, 3.765272222945157*^9}},
 CellID->547577890,ExpressionUUID->"48810e46-70bf-47e1-ae0b-4d4465239c96"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<2\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["c", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["D", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765272162897872*^9, 3.765272178234725*^9}, {
  3.7652722246638517`*^9, 3.765272228529366*^9}},
 CellID->1510067633,ExpressionUUID->"656b923a-bf4d-416c-a88a-02fa3de2da7e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["c", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[Union]", 
      FormBox[
       StyleBox["D", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Union]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652721802900667`*^9, 3.765272232623596*^9}},
 CellID->1953114832,ExpressionUUID->"78ec1192-8768-4566-bd0c-e0633db6b6b8"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765272234057397*^9, 3.765272235575715*^9}},
 CellID->1062318198,ExpressionUUID->"22fbc9e1-0af1-40df-aa37-4bd95d7eed23"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Union] mono)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 1131, 36, 19, "ProofText",ExpressionUUID->"37032f27-37a7-4048-873d-9138a5d81c23",
 CellID->1219819328],
Cell[1728, 59, 2375, 66, 47, "ProofText",ExpressionUUID->"5c9e510e-4edd-4cd0-aaa7-8be00662781a",
 CellID->1346744578],
Cell[4106, 127, 585, 17, 19, "ProofText",ExpressionUUID->"6d8f502a-001b-4865-ad5f-b46f8745cb92",
 CellID->1820737598],
Cell[4694, 146, 531, 15, 19, "ProofText",ExpressionUUID->"ba5aa0b9-d8b3-4327-83bb-296eb3016e85",
 CellID->246211538],
Cell[5228, 163, 664, 19, 19, "ProofText",ExpressionUUID->"df685009-0f4d-41d7-b0b3-f5d76bcbf196",
 CellID->28790894],
Cell[5895, 184, 220, 4, 19, "ProofText",ExpressionUUID->"672b3d61-4be2-498a-bb03-715666056931",
 CellID->2009407087],
Cell[6118, 190, 633, 18, 19, "ProofText",ExpressionUUID->"48810e46-70bf-47e1-ae0b-4d4465239c96",
 CellID->547577890],
Cell[6754, 210, 583, 16, 19, "ProofText",ExpressionUUID->"656b923a-bf4d-416c-a88a-02fa3de2da7e",
 CellID->1510067633],
Cell[7340, 228, 666, 19, 19, "ProofText",ExpressionUUID->"78ec1192-8768-4566-bd0c-e0633db6b6b8",
 CellID->1953114832],
Cell[8009, 249, 311, 6, 20, "ProofText",ExpressionUUID->"22fbc9e1-0af1-40df-aa37-4bd95d7eed23",
 CellID->1062318198]
}
]
*)

