(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20109,        555]
NotebookOptionsPosition[     18579,        520]
NotebookOutlinePosition[     19173,        540]
CellTagsIndexPosition[     19130,        537]
WindowTitle->Proof of (SetOf mono)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["g", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["P", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["Q", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`CoreAll$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["P", "ExpressionABF"],
        TheoremaForm], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Gamma]$TM, 0]}]]], 
         RowBox[{
          FormBox[
           StyleBox["Q", "ExpressionABF"],
           TheoremaForm], "[", 
          TagBox[
           StyleBox["y", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Gamma]$TM, 0]]]], "]"}]], 
        RowBox[{
         RowBox[{
          FormBox[
           StyleBox["f", "ExpressionABF"],
           TheoremaForm], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], 
         TagBox["\[Equal]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
          
          SyntaxForm->"x\[Equal]y"], 
         RowBox[{
          FormBox[
           StyleBox["g", "ExpressionABF"],
           TheoremaForm], "[", 
          StyleBox["y", "ExpressionVariable"], "]"}]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271552057746*^9, 3.765271592223626*^9}},
 CellID->795836301,ExpressionUUID->"1afbcbb8-e981-4393-9620-3d8a73ace641"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["{",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->"("], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], 
      UnderscriptBox[
       TagBox["|",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]]}], 
     TagBox["}",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->")"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    RowBox[{
     TagBox["{",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->"("], 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["g", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0]]]], 
       "]"}], 
      UnderscriptBox[
       TagBox["|",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["Q", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
            Theorema`Knowledge`BOOL$TM]]]], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0]]]], 
        "]"}]]}], 
     TagBox["}",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
      SyntaxForm->")"]}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271595153195*^9, 3.765271606004924*^9}},
 CellID->1567783334,ExpressionUUID->"2cc851b6-d98d-494a-9b27-b21e259a27bb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       TagBox["{",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->"("], 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["f", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "]"}], 
        UnderscriptBox[
         TagBox["|",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]]}], 
       TagBox["}",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->")"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765271608361174*^9, 3.765271623383678*^9}},
 CellID->69015243,ExpressionUUID->"64f5b9c4-ce8b-418b-a50a-62fec4c853ed"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["P", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<x\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271632529173*^9, 3.765271682065701*^9}},
 CellID->1398402866,ExpressionUUID->"bcbad9a5-bedf-4844-bf9d-2e22ddd4b680"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", 
   RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
   " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0]}]]], 
      
      RowBox[{
       FormBox[
        StyleBox["Q", "ExpressionABF"],
        TheoremaForm], "[", 
       TagBox[
        StyleBox["y", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0]]]], 
       "]"}]], 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm], "]"}], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
       SyntaxForm->"x\[Equal]y"], 
      RowBox[{
       FormBox[
        StyleBox["g", "ExpressionABF"],
        TheoremaForm], "[", 
       StyleBox["y", "ExpressionVariable"], "]"}]}]}], "\[CloseCurlyQuote]"}],
    " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76527169028004*^9, 3.76527172498698*^9}},
 CellID->1108377717,ExpressionUUID->"b4664096-cc56-4ce6-8c1e-8ab139cfa27a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["z", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["z", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<eq\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["y", "ExpressionABF"],
        TheoremaForm], "]"}], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["g", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["z", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652717279758368`*^9, 3.76527176702468*^9}, {
  3.765271821135766*^9, 3.7652718225570803`*^9}},
 CellID->1249824163,ExpressionUUID->"4305bb8d-0de9-43eb-a32e-a0f8146cbc6c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     RowBox[{
      FormBox[
       StyleBox["g", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["z", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", 
      RowBox[{"\"\<x\>\"", " ", "\"\<eq\>\""}]}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271876746265*^9, 3.765271899972136*^9}},
 CellID->1468392241,ExpressionUUID->"42e5169a-dcb2-4a47-9f36-00b41d39008e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "this", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["Q", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["z", "ExpressionABF"],
       TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       TagBox["{",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->"("], 
       RowBox[{
        RowBox[{
         TagBox[
          StyleBox["g", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0]]]],
          "]"}], 
        UnderscriptBox[
         TagBox["|",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
         RowBox[{
          TagBox[
           StyleBox["Q", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Gamma]$TM, 0]]]], "]"}]]}], 
       TagBox["}",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`SetOf$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Gamma]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->")"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271773414722*^9, 3.765271837844626*^9}, {
  3.765271905076146*^9, 3.765271918251169*^9}},
 CellID->427459438,ExpressionUUID->"9e0e9584-b822-41c8-b0cc-7898f26b4cf5"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765271920397097*^9, 3.7652719220755568`*^9}},
 CellID->869638468,ExpressionUUID->"3d4b6a17-4113-455b-8472-4b94796d9114"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (SetOf mono)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 3138, 91, 37, "ProofText",ExpressionUUID->"1afbcbb8-e981-4393-9620-3d8a73ace641",
 CellID->795836301],
Cell[3734, 114, 4524, 112, 61, "ProofText",ExpressionUUID->"2cc851b6-d98d-494a-9b27-b21e259a27bb",
 CellID->1567783334],
Cell[8261, 228, 2608, 65, 37, "ProofText",ExpressionUUID->"64f5b9c4-ce8b-418b-a50a-62fec4c853ed",
 CellID->69015243],
Cell[10872, 295, 1014, 32, 19, "ProofText",ExpressionUUID->"bcbad9a5-bedf-4844-bf9d-2e22ddd4b680",
 CellID->1398402866],
Cell[11889, 329, 1619, 46, 30, "ProofText",ExpressionUUID->"b4664096-cc56-4ce6-8c1e-8ab139cfa27a",
 CellID->1108377717],
Cell[13511, 377, 1177, 37, 19, "ProofText",ExpressionUUID->"4305bb8d-0de9-43eb-a32e-a0f8146cbc6c",
 CellID->1249824163],
Cell[14691, 416, 721, 21, 19, "ProofText",ExpressionUUID->"42e5169a-dcb2-4a47-9f36-00b41d39008e",
 CellID->1468392241],
Cell[15415, 439, 2845, 71, 37, "ProofText",ExpressionUUID->"9e0e9584-b822-41c8-b0cc-7898f26b4cf5",
 CellID->427459438],
Cell[18263, 512, 312, 6, 20, "ProofText",ExpressionUUID->"3d4b6a17-4113-455b-8472-4b94796d9114",
 CellID->869638468]
}
]
*)

