(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     36767,       1027]
NotebookOptionsPosition[     31188,        924]
NotebookOutlinePosition[     31796,        944]
CellTagsIndexPosition[     31753,        941]
WindowTitle->Proof of (\:2286Insert iff)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093787103723*^9, 3.765093794432304*^9}},
 CellID->587133918,ExpressionUUID->"4bfc0d08-4488-4b0b-8452-cf4cbc0a8d59"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093797665846*^9, 3.765093799636961*^9}},
 CellID->1034705643,ExpressionUUID->"23f92169-2323-48f5-a072-1ed5335998d8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      RowBox[{
       TagBox["Insert",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093804559613*^9, 3.7650938101007977`*^9}, {
  3.765094188154812*^9, 3.7650941889120817`*^9}},
 CellID->719960527,ExpressionUUID->"ba30d648-d9a3-405c-a123-fea5ea09b881"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", "_"}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093816191227*^9, 3.765093881819811*^9}},
 CellID->137573105,ExpressionUUID->"3257b040-243c-498f-b8da-828ced566a6e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093899957003*^9, 3.765093912135047*^9}},
 CellID->435115784,ExpressionUUID->"505c0862-c7de-4c6f-a183-ceaa1d06c7e5"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"moreover", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["-",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Subtract$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
         SyntaxForm->"x-y"], 
        TagBox[
         RowBox[{"{", 
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "}"}],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`EMPTY$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650939505484543`*^9, 3.765093969586657*^9}, {
  3.7650940588017673`*^9, 3.765094062449637*^9}},
 CellID->384745912,ExpressionUUID->"9d4e56ac-cb5d-4735-bccf-1a4650fc1f4d"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm], "-", 
       RowBox[{"{", 
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "}"}]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094064699132*^9, 3.765094087948811*^9}},
 CellID->534952836,ExpressionUUID->"65052af3-4fbe-415a-9a04-509eaf505d83"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[NotEqual]", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   SuperscriptBox["simp", "+"]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094094154273*^9, 3.76509413593682*^9}},
 CellID->548323000,ExpressionUUID->"3e9a20a9-30cd-4eb1-ba56-8634ce2c834f"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", "\"\<*\>\"", " ", 
   RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
   " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"Insert", "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650941996652727`*^9, 3.765094232847665*^9}},
 CellID->1423062073,ExpressionUUID->"391d0ec3-28ee-4cb3-8016-e14c1fd3b194"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094238736972*^9, 3.765094251953136*^9}},
 CellID->302064405,ExpressionUUID->"f9f2a667-e5ca-4ae5-9389-c28513adec47"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094261040707*^9, 3.7650942731862593`*^9}},
 CellID->1740423359,ExpressionUUID->"974c736d-58cf-41f3-b3f2-f2edfc4d09ab"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094275016142*^9, 3.765094290577724*^9}},
 CellID->70379086,ExpressionUUID->"e837d500-37e7-4553-a8d5-03733e967227"],

Cell[BoxData[
 RowBox[{"\t\t\t", "qed"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650942933762836`*^9, 3.765094295407116*^9}},
 CellID->1352219881,ExpressionUUID->"da6be4b1-9fa1-472e-8fce-3652ebc51c24"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094302079754*^9, 3.765094304982605*^9}},
 CellID->127113471,ExpressionUUID->"f4782065-2f3a-4a8c-8954-cf4d2c505f55"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
  "ultimately", " ", "show", " ", "_", " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093972092268*^9, 3.765093977250577*^9}},
 CellID->325555430,ExpressionUUID->"f83af78c-9bf9-401f-9729-3837525c3b5b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650939818760242`*^9, 3.765093984587049*^9}},
 CellID->2089398971,ExpressionUUID->"4a88ff52-8cce-46b3-b73d-5f36cfb7a87b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650939870440693`*^9, 3.765093999485429*^9}},
 CellID->2083875546,ExpressionUUID->"77c9e0b4-3966-4fb0-9de5-8487c58aff76"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"moreover", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094006995905*^9, 3.765094014626225*^9}, {
  3.7650943116786833`*^9, 3.765094315062478*^9}},
 CellID->491698102,ExpressionUUID->"3361ee37-7e01-4e8a-acc6-ee195383b8ad"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094064699132*^9, 3.765094087948811*^9}, 
   3.765094336413916*^9},
 CellID->977115133,ExpressionUUID->"e097b226-88b0-471e-a66b-9f4140deed5a"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"with", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"Insert", "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650941996652727`*^9, 3.765094232847665*^9}, {
  3.7650943474219027`*^9, 3.765094349318263*^9}},
 CellID->1252531773,ExpressionUUID->"6e6757fb-5c0f-4845-af87-3caeff11d6ba"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094238736972*^9, 3.765094251953136*^9}},
 CellID->1413483402,ExpressionUUID->"352b7684-fe4d-4f04-a10a-df370814ec86"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094261040707*^9, 3.7650942731862593`*^9}},
 CellID->346345438,ExpressionUUID->"1922f17b-8d58-440d-b117-42b82a6ec1e8"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650943645591507`*^9, 3.76509439659273*^9}},
 CellID->838649727,ExpressionUUID->"fcdab4de-744f-4a94-9706-21bbf17c526d"],

Cell[BoxData[
 RowBox[{"\t\t\t", "qed"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650942933762836`*^9, 3.765094295407116*^9}},
 CellID->1692062075,ExpressionUUID->"54a42656-b582-47be-871c-170701933140"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
  "ultimately", " ", "show", " ", "_", " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094016507471*^9, 3.7650940230505323`*^9}},
 CellID->1965752854,ExpressionUUID->"3064641d-d720-478e-b71b-3a3b89d39877"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094026099515*^9, 3.765094031946035*^9}},
 CellID->1912331292,ExpressionUUID->"158a6dc8-f32d-4f19-8a20-23aa85d8dc51"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox["\[Piecewise]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[{Theorema`Language`If$TM, 1}, {
          Theorema`Knowledge`BOOL$TM}]],
        SyntaxForm->"\[Piecewise]x"], GridBox[{
         {
          RowBox[{
           RowBox[{
            TagBox["(",
             "AutoParentheses"], 
            RowBox[{
             TagBox[
              StyleBox["A", "ExpressionABF"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
             TagBox["-",
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[Theorema`Language`Subtract$TM, {
                 Theorema`Knowledge`SET$TM[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
              SyntaxForm->"x-y"], 
             TagBox[
              RowBox[{"{", 
               TagBox[
                StyleBox["x", "ExpressionABF"],
                Theorema`Language`TAG$[
                 Theorema`Language`TYPED$[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "}"}],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[Theorema`Knowledge`EMPTY$TM, {
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]]}], 
            TagBox[")",
             "AutoParentheses"]}], 
           TagBox["\[SubsetEqual]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[SubsetEqual]y"], 
           TagBox[
            StyleBox["B", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
          "\[DoubleLeftArrow]", 
          RowBox[{
           TagBox[
            StyleBox["x", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
           TagBox["\[Element]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[Element]y"], 
           TagBox[
            StyleBox["A", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]},
         {
          RowBox[{
           TagBox[
            StyleBox["A", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
           TagBox["\[SubsetEqual]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[SubsetEqual]y"], 
           TagBox[
            StyleBox["B", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
          "\[DoubleLeftArrow]", "True"}
        }]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650940391646423`*^9, 3.765094044433847*^9}, {
  3.7650944273248873`*^9, 3.76509442808525*^9}},
 CellID->1409866319,ExpressionUUID->"72519a60-0f51-49d6-b716-46166055350f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      RowBox[{
       TagBox["Insert",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
     "intro", " ", "\"\<\[SubsetEqual]I\>\"", " ", 
      "\"\<InsertI classical\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094435982006*^9, 3.765094476276388*^9}},
 CellID->240013490,ExpressionUUID->"712b4251-3195-4548-834c-12843dddab33"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094484029829*^9, 3.765094515855274*^9}},
 CellID->865728350,ExpressionUUID->"75c835d8-0188-4301-b27f-8d435a976319"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<classical contradiction\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650946183720818`*^9, 3.765094655114266*^9}},
 CellID->1425783646,ExpressionUUID->"c220e4f6-d9be-45ea-b65b-d3bc6ac1fdea"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650946582515383`*^9, 3.7650946693573017`*^9}},
 CellID->1274719133,ExpressionUUID->"647435bf-a672-46da-8928-6c06063ebad8"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "-", 
      RowBox[{"{", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "}"}]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094674571412*^9, 3.765094714509336*^9}},
 CellID->1585688878,ExpressionUUID->"991657a2-9bbc-4d1c-aa1a-d1d6ccd5f851"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094722962927*^9, 3.765094744545293*^9}},
 CellID->1563356751,ExpressionUUID->"dae5dc8e-e729-469d-bffd-c9b590268761"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650947468735943`*^9, 3.765094758723937*^9}},
 CellID->1709834917,ExpressionUUID->"23ac584e-f849-42ac-afe8-957b345e4ab9"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"from", " ", "this", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "-", 
      RowBox[{"{", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "}"}]}], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76509476223414*^9, 3.765094784469343*^9}},
 CellID->1970434790,ExpressionUUID->"2a5e6551-f8f1-456f-8c8e-c56e9246c158"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "-", 
      RowBox[{"{", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "}"}]}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D reverse\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094788282014*^9, 3.7650948216321907`*^9}},
 CellID->1888912181,ExpressionUUID->"edd75dd2-013e-4c7a-af3f-425241f4b6b9"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650948250018263`*^9, 3.765094829040091*^9}},
 CellID->233126636,ExpressionUUID->"84814b4a-64c2-4209-aff9-003143460284"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650948308815804`*^9, 3.765094845555273*^9}},
 CellID->1470019447,ExpressionUUID->"3dc7ee51-1bee-44ad-b3ae-93a58594e3f8"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"from", " ", "this", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094850649249*^9, 3.76509486950736*^9}},
 CellID->1671674332,ExpressionUUID->"5608f599-c06d-4f9b-8d16-10bed4e1ce4e"],

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D reverse\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094788282014*^9, 3.7650948216321907`*^9}, 
   3.7650948762154303`*^9},
 CellID->1642992955,ExpressionUUID->"ac664874-4688-4088-b2aa-112ba7308af9"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650948807529583`*^9, 3.765094884815447*^9}},
 CellID->2004972283,ExpressionUUID->"ff35e3d5-80ca-4f03-85c6-3bfac852b496"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765094889752933*^9, 3.765094908826091*^9}},
 CellID->72513684,ExpressionUUID->"0f85ccca-cafa-45af-805f-f4b78752b989"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", "\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7650949113366947`*^9, 3.76509492107932*^9}},
 CellID->918571381,ExpressionUUID->"4b728b6b-7051-4ef7-81e7-dfe6a242cd2c"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual]Insert iff)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 443, 14, 19, "ProofText",ExpressionUUID->"4bfc0d08-4488-4b0b-8452-cf4cbc0a8d59",
 CellID->587133918],
Cell[1045, 37, 235, 4, 42, "ProofText",ExpressionUUID->"23f92169-2323-48f5-a072-1ed5335998d8",
 CellID->1034705643],
Cell[1283, 43, 1643, 43, 19, "ProofText",ExpressionUUID->"ba30d648-d9a3-405c-a123-fea5ea09b881",
 CellID->719960527],
Cell[2929, 88, 365, 9, 42, "ProofText",ExpressionUUID->"3257b040-243c-498f-b8da-828ced566a6e",
 CellID->137573105],
Cell[3297, 99, 496, 14, 19, "ProofText",ExpressionUUID->"505c0862-c7de-4c6f-a183-ceaa1d06c7e5",
 CellID->435115784],
Cell[3796, 115, 2054, 54, 42, "ProofText",ExpressionUUID->"9d4e56ac-cb5d-4735-bccf-1a4650fc1f4d",
 CellID->384745912],
Cell[5853, 171, 726, 23, 19, "ProofText",ExpressionUUID->"65052af3-4fbe-415a-9a04-509eaf505d83",
 CellID->534952836],
Cell[6582, 196, 770, 22, 19, "ProofText",ExpressionUUID->"3e9a20a9-30cd-4eb1-ba56-8634ce2c834f",
 CellID->548323000],
Cell[7355, 220, 829, 23, 19, "ProofText",ExpressionUUID->"391d0ec3-28ee-4cb3-8016-e14c1fd3b194",
 CellID->1423062073],
Cell[8187, 245, 520, 15, 42, "ProofText",ExpressionUUID->"f9f2a667-e5ca-4ae5-9389-c28513adec47",
 CellID->302064405],
Cell[8710, 262, 501, 14, 19, "ProofText",ExpressionUUID->"974c736d-58cf-41f3-b3f2-f2edfc4d09ab",
 CellID->1740423359],
Cell[9214, 278, 531, 15, 19, "ProofText",ExpressionUUID->"e837d500-37e7-4553-a8d5-03733e967227",
 CellID->70379086],
Cell[9748, 295, 219, 4, 19, "ProofText",ExpressionUUID->"da6be4b1-9fa1-472e-8fce-3652ebc51c24",
 CellID->1352219881],
Cell[9970, 301, 239, 5, 19, "ProofText",ExpressionUUID->"f4782065-2f3a-4a8c-8954-cf4d2c505f55",
 CellID->127113471],
Cell[10212, 308, 288, 7, 19, "ProofText",ExpressionUUID->"f83af78c-9bf9-401f-9729-3837525c3b5b",
 CellID->325555430],
Cell[10503, 317, 241, 5, 19, "ProofText",ExpressionUUID->"4a88ff52-8cce-46b3-b73d-5f36cfb7a87b",
 CellID->2089398971],
Cell[10747, 324, 502, 14, 19, "ProofText",ExpressionUUID->"77c9e0b4-3966-4fb0-9de5-8487c58aff76",
 CellID->2083875546],
Cell[11252, 340, 1151, 29, 42, "ProofText",ExpressionUUID->"3361ee37-7e01-4e8a-acc6-ee195383b8ad",
 CellID->491698102],
Cell[12406, 371, 612, 18, 19, "ProofText",ExpressionUUID->"e097b226-88b0-471e-a66b-9f4140deed5a",
 CellID->977115133],
Cell[13021, 391, 795, 22, 19, "ProofText",ExpressionUUID->"6e6757fb-5c0f-4845-af87-3caeff11d6ba",
 CellID->1252531773],
Cell[13819, 415, 521, 15, 42, "ProofText",ExpressionUUID->"352b7684-fe4d-4f04-a10a-df370814ec86",
 CellID->1413483402],
Cell[14343, 432, 500, 14, 19, "ProofText",ExpressionUUID->"1922f17b-8d58-440d-b117-42b82a6ec1e8",
 CellID->346345438],
Cell[14846, 448, 778, 22, 19, "ProofText",ExpressionUUID->"fcdab4de-744f-4a94-9706-21bbf17c526d",
 CellID->838649727],
Cell[15627, 472, 219, 4, 19, "ProofText",ExpressionUUID->"54a42656-b582-47be-871c-170701933140",
 CellID->1692062075],
Cell[15849, 478, 291, 7, 19, "ProofText",ExpressionUUID->"3064641d-d720-478e-b71b-3a3b89d39877",
 CellID->1965752854],
Cell[16143, 487, 277, 6, 42, "ProofText",ExpressionUUID->"158a6dc8-f32d-4f19-8a20-23aa85d8dc51",
 CellID->1912331292],
Cell[16423, 495, 4424, 112, 35, "ProofText",ExpressionUUID->"72519a60-0f51-49d6-b716-46166055350f",
 CellID->1409866319],
Cell[20850, 609, 1714, 46, 42, "ProofText",ExpressionUUID->"712b4251-3195-4548-834c-12843dddab33",
 CellID->240013490],
Cell[22567, 657, 846, 25, 19, "ProofText",ExpressionUUID->"75c835d8-0188-4301-b27f-8d435a976319",
 CellID->865728350],
Cell[23416, 684, 627, 18, 42, "ProofText",ExpressionUUID->"c220e4f6-d9be-45ea-b65b-d3bc6ac1fdea",
 CellID->1425783646],
Cell[24046, 704, 504, 14, 19, "ProofText",ExpressionUUID->"647435bf-a672-46da-8928-6c06063ebad8",
 CellID->1274719133],
Cell[24553, 720, 881, 27, 19, "ProofText",ExpressionUUID->"991657a2-9bbc-4d1c-aa1a-d1d6ccd5f851",
 CellID->1585688878],
Cell[25437, 749, 611, 17, 42, "ProofText",ExpressionUUID->"dae5dc8e-e729-469d-bffd-c9b590268761",
 CellID->1563356751],
Cell[26051, 768, 503, 14, 19, "ProofText",ExpressionUUID->"23ac584e-f849-42ac-afe8-957b345e4ab9",
 CellID->1709834917],
Cell[26557, 784, 678, 19, 19, "ProofText",ExpressionUUID->"2a5e6551-f8f1-456f-8c8e-c56e9246c158",
 CellID->1970434790],
Cell[27238, 805, 740, 22, 19, "ProofText",ExpressionUUID->"edd75dd2-013e-4c7a-af3f-425241f4b6b9",
 CellID->1888912181],
Cell[27981, 829, 244, 5, 19, "ProofText",ExpressionUUID->"84814b4a-64c2-4209-aff9-003143460284",
 CellID->233126636],
Cell[28228, 836, 506, 14, 19, "ProofText",ExpressionUUID->"3dc7ee51-1bee-44ad-b3ae-93a58594e3f8",
 CellID->1470019447],
Cell[28737, 852, 547, 14, 19, "ProofText",ExpressionUUID->"5608f599-c06d-4f9b-8d16-10bed4e1ce4e",
 CellID->1671674332],
Cell[29287, 868, 637, 18, 19, "ProofText",ExpressionUUID->"ac664874-4688-4088-b2aa-112ba7308af9",
 CellID->1642992955],
Cell[29927, 888, 244, 5, 19, "ProofText",ExpressionUUID->"ff35e3d5-80ca-4f03-85c6-3bfac852b496",
 CellID->2004972283],
Cell[30174, 895, 593, 16, 19, "ProofText",ExpressionUUID->"0f85ccca-cafa-45af-805f-f4b78752b989",
 CellID->72513684],
Cell[30770, 913, 414, 9, 64, "ProofText",ExpressionUUID->"4b728b6b-7051-4ef7-81e7-dfe6a242cd2c",
 CellID->918571381]
}
]
*)

