(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12730,        363]
NotebookOptionsPosition[     10844,        322]
NotebookOutlinePosition[     11448,        342]
CellTagsIndexPosition[     11405,        339]
WindowTitle->Proof of (\:2286Insert)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", "assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092447472466*^9, 3.765092454929142*^9}, {
  3.7650926312357607`*^9, 3.765092632231282*^9}},
 CellID->1456135510,ExpressionUUID->"2cb9841e-a8ba-4725-8bc8-bee906f7f7cc"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      RowBox[{
       TagBox["Insert",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[DoubleLeftRightArrow]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
     SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092474360004*^9, 3.7650924798131742`*^9}, {
  3.765092549756441*^9, 3.765092578268001*^9}},
 CellID->1697922835,ExpressionUUID->"79b6c6df-db28-46b9-bb42-7fa5eb0e6d5c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      RowBox[{
       TagBox["Insert",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        "[", 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650924867042713`*^9, 3.765092491837119*^9}, {
  3.765092655177821*^9, 3.765092655987146*^9}},
 CellID->1547893788,ExpressionUUID->"33ddd1b8-31d6-4543-bc46-93d7a3e6eda9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092501342615*^9, 3.7650925105010138`*^9}, {
  3.765092591116041*^9, 3.765092592971922*^9}},
 CellID->1812269033,ExpressionUUID->"69044590-7bff-49de-a218-8418ebc3d326"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650925972854137`*^9, 3.765092619206881*^9}},
 CellID->1654283187,ExpressionUUID->"723ff236-1e94-479d-a56a-19d3709c4737"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"Insert", "[", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], ",", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765092659173088*^9, 3.765092687178965*^9}},
 CellID->1699129633,ExpressionUUID->"3023ec81-3d08-479b-895a-e81fe72a0f4d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092692244948*^9, 3.765092705981498*^9}},
 CellID->166142672,ExpressionUUID->"6162197d-e266-4651-bd53-c4e2483eb86f"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650927095001707`*^9, 3.7650927235496387`*^9}},
 CellID->2023837531,ExpressionUUID->"d1bc8257-dccd-485b-ae93-0c000cf87f6a"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092736179482*^9, 3.765092772657487*^9}},
 CellID->1975939394,ExpressionUUID->"4d633f6d-8b5b-4f87-bc00-868d6f59a435"],

Cell[BoxData[
 RowBox[{"\t\t", "qed"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092776291341*^9, 3.7650927903295*^9}},
 CellID->918168217,ExpressionUUID->"87e970ed-12e5-43e4-b74b-30a309d69493"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765092801971053*^9, 3.765092804897563*^9}},
 CellID->783475356,ExpressionUUID->"152210b9-21b3-4b47-83d1-5e7e9b2028f0"],

Cell[BoxData[
 RowBox[{"qed", " ", 
  RowBox[{"(", 
   RowBox[{"fact", " ", "\"\<\[SubsetEqual]Insert I2\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7650925131102858`*^9, 3.765092533668981*^9}},
 CellID->187982324,ExpressionUUID->"0d6b836e-fd27-4cf2-9d67-85a30a0c4671"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual]Insert)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 752, 23, 19, "ProofText",ExpressionUUID->"2cb9841e-a8ba-4725-8bc8-bee906f7f7cc",
 CellID->1456135510],
Cell[1350, 46, 2724, 75, 42, "ProofText",ExpressionUUID->"79b6c6df-db28-46b9-bb42-7fa5eb0e6d5c",
 CellID->1697922835],
Cell[4077, 123, 1642, 43, 19, "ProofText",ExpressionUUID->"33ddd1b8-31d6-4543-bc46-93d7a3e6eda9",
 CellID->1547893788],
Cell[5722, 168, 1131, 29, 42, "ProofText",ExpressionUUID->"69044590-7bff-49de-a218-8418ebc3d326",
 CellID->1812269033],
Cell[6856, 199, 587, 17, 19, "ProofText",ExpressionUUID->"723ff236-1e94-479d-a56a-19d3709c4737",
 CellID->1654283187],
Cell[7446, 218, 740, 21, 19, "ProofText",ExpressionUUID->"3023ec81-3d08-479b-895a-e81fe72a0f4d",
 CellID->1699129633],
Cell[8189, 241, 516, 15, 42, "ProofText",ExpressionUUID->"6162197d-e266-4651-bd53-c4e2483eb86f",
 CellID->166142672],
Cell[8708, 258, 501, 14, 19, "ProofText",ExpressionUUID->"d1bc8257-dccd-485b-ae93-0c000cf87f6a",
 CellID->2023837531],
Cell[9212, 274, 776, 22, 19, "ProofText",ExpressionUUID->"4d633f6d-8b5b-4f87-bc00-868d6f59a435",
 CellID->1975939394],
Cell[9991, 298, 212, 4, 19, "ProofText",ExpressionUUID->"87e970ed-12e5-43e4-b74b-30a309d69493",
 CellID->918168217],
Cell[10206, 304, 237, 5, 19, "ProofText",ExpressionUUID->"152210b9-21b3-4b47-83d1-5e7e9b2028f0",
 CellID->783475356],
Cell[10446, 311, 394, 9, 20, "ProofText",ExpressionUUID->"0d6b836e-fd27-4cf2-9d67-85a30a0c4671",
 CellID->187982324]
}
]
*)

