(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      3717,        107]
NotebookOptionsPosition[      2897,         84]
NotebookOutlinePosition[      3508,        104]
CellTagsIndexPosition[      3465,        101]
WindowTitle->Proof of (\:F431 iff \:2286)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"have", " ", "\"\<*\>\""}], ":", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox["\[And]", 
     RowBox[{"P", ",", "Q"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"P", "\[Implies]", "Q"}], ")"}], "\[And]", 
        RowBox[{"(", 
         RowBox[{"Q", "\[Implies]", "P"}], ")"}]}], ")"}], 
      "\[DoubleLeftRightArrow]", 
      RowBox[{"(", 
       RowBox[{"P", "\[DoubleLeftRightArrow]", "Q"}], ")"}]}], ")"}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"apply", " ", 
   RowBox[{"(", 
    RowBox[{"intro", " ", "\"\<\[DoubleLeftRightArrow]I\>\""}], 
    ")"}]}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"apply", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
      "elim", " ", "\"\<\[And]E\>\"", " ", "\"\<modus ponens reverse\>\""}], 
      ",", " ", "assumption"}], ")"}], "+"]}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"apply", " ", "simp"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650859929754143`*^9, 3.7650860302051973`*^9}, {
  3.7650860869085817`*^9, 3.76508614910732*^9}, {3.765086196907152*^9, 
  3.765086350713099*^9}, {3.7650863858807*^9, 3.7650864570796967`*^9}},
 CellID->490485640,ExpressionUUID->"a57d3bbc-f80f-4ec9-a25f-42e9eb5c0872"],

Cell[BoxData[
 RowBox[{"\t", "qed"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765086463129573*^9, 3.765086464919817*^9}},
 CellID->357581840,ExpressionUUID->"b65e0d5d-0954-45df-abfd-511b4ad28419"],

Cell[BoxData[
 RowBox[{"show", " ", "_", " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", 
     RowBox[{
     "\"\<\[Equal] iff SET\>\"", " ", "\"\<\[SubsetEqual] def\>\"", " ", 
      RowBox[{"\"\<\[ForAll]C\[And]\>\"", "[", "symmetric", "]"}], " ", 
      "\"\<*\>\""}]}]}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765085047620336*^9, 3.765085084065341*^9}, {
  3.765085140488579*^9, 3.7650851550804777`*^9}, {3.76508591941462*^9, 
  3.765085930718452*^9}, {3.7650860419170017`*^9, 3.765086067060966*^9}},
 CellID->263164946,ExpressionUUID->"79479f42-33f8-41bb-a1fd-5d3f9178aabf"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Equal] iff \[SubsetEqual])",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 1338, 38, 97, "ProofText",ExpressionUUID->"a57d3bbc-f80f-4ec9-a25f-42e9eb5c0872",
 CellID->490485640],
Cell[1941, 61, 212, 4, 19, "ProofText",ExpressionUUID->"b65e0d5d-0954-45df-abfd-511b4ad28419",
 CellID->357581840],
Cell[2156, 67, 737, 15, 20, "ProofText",ExpressionUUID->"79479f42-33f8-41bb-a1fd-5d3f9178aabf",
 CellID->263164946]
}
]
*)

