(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8748,        261]
NotebookOptionsPosition[      7455,        230]
NotebookOutlinePosition[      8059,        250]
CellTagsIndexPosition[      8016,        247]
WindowTitle->Proof of (\:22C2 mono)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["D", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["D", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652720808682947`*^9, 3.765272116020235*^9}},
 CellID->1219819328,ExpressionUUID->"53966a7e-92a6-4e21-942f-1487f4d0ffe7"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Intersection]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Union$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Union]y"], 
      TagBox[
       StyleBox["C", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Intersection]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Union$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Union]y"], 
      TagBox[
       StyleBox["D", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]I\>\""}], ",", " ", 
    RowBox[{"elim", " ", "\"\<\[Intersection]E\>\""}]}], 
   ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765272118450656*^9, 3.765272139696888*^9}, {
  3.7652723033352222`*^9, 3.765272347246565*^9}},
 CellID->1346744578,ExpressionUUID->"eaa971c6-330f-496b-997b-f32de505090f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652721456182623`*^9, 3.765272160071211*^9}, {
  3.765272360511683*^9, 3.765272374000751*^9}},
 CellID->1820737598,ExpressionUUID->"8b335067-b48b-4746-82bf-0efebc3d387c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<1\>\"", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
    " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765272379279559*^9, 3.765272410174135*^9}},
 CellID->1727435985,ExpressionUUID->"cd3f5e21-6359-47d8-9619-ba76b45453f0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"moreover", " ", "from", " ", "\"\<2\>\"", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["D", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765272413447028*^9, 3.765272437286106*^9}},
 CellID->498130076,ExpressionUUID->"c6220a6c-f223-4cab-b741-b3dfb3858107"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"ultimately", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm], "\[Intersection]", 
       FormBox[
        StyleBox["D", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652724392307*^9, 3.765272456780795*^9}},
 CellID->1122828173,ExpressionUUID->"7bb89817-e794-486e-87b0-89172202acd4"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765272234057397*^9, 3.765272235575715*^9}},
 CellID->1062318198,ExpressionUUID->"48205d63-74c5-4b81-9eb7-59b482917630"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Intersection] mono)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 1131, 36, 19, "ProofText",ExpressionUUID->"53966a7e-92a6-4e21-942f-1487f4d0ffe7",
 CellID->1219819328],
Cell[1728, 59, 2451, 68, 47, "ProofText",ExpressionUUID->"eaa971c6-330f-496b-997b-f32de505090f",
 CellID->1346744578],
Cell[4182, 129, 893, 26, 19, "ProofText",ExpressionUUID->"8b335067-b48b-4746-82bf-0efebc3d387c",
 CellID->1820737598],
Cell[5078, 157, 619, 17, 19, "ProofText",ExpressionUUID->"cd3f5e21-6359-47d8-9619-ba76b45453f0",
 CellID->1727435985],
Cell[5700, 176, 795, 23, 19, "ProofText",ExpressionUUID->"c6220a6c-f223-4cab-b741-b3dfb3858107",
 CellID->498130076],
Cell[6498, 201, 639, 19, 19, "ProofText",ExpressionUUID->"7bb89817-e794-486e-87b0-89172202acd4",
 CellID->1122828173],
Cell[7140, 222, 311, 6, 20, "ProofText",ExpressionUUID->"48205d63-74c5-4b81-9eb7-59b482917630",
 CellID->1062318198]
}
]
*)

