(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12926,        367]
NotebookOptionsPosition[     11158,        328]
NotebookOutlinePosition[     11765,        348]
CellTagsIndexPosition[     11722,        345]
WindowTitle->Proof of (\:F431E classical SET)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650108132868423`*^9, 3.765010821991675*^9}},
 CellID->1617895502,ExpressionUUID->"0d0d0bfe-c51f-49b3-b1c5-eb5e2824801f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        
        TagBox["\[Element]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Element]y"], 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["x", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
          TagBox["\[Element]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Element]y"], 
          TagBox[
           StyleBox["B", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[LongRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
         SyntaxForm->"x\[LongRightArrow]y"], 
        TagBox[
         StyleBox["P", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<2\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       TagBox["\[NotElement]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`NotElement$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[NotElement]y"], 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
         TagBox["\[NotElement]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`NotElement$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[NotElement]y"], 
         TagBox[
          StyleBox["B", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650108240781307`*^9, 3.7650108570348063`*^9}},
 CellID->324268184,ExpressionUUID->"1b95ef0f-b3d4-4e07-b952-067146365d37"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  FormBox[
   StyleBox["P", "ExpressionABF"],
   TheoremaForm]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010990331482*^9, 3.765011041753776*^9}, {
  3.765011090107216*^9, 3.7650110987130632`*^9}},
 CellID->1462406519,ExpressionUUID->"d32f3557-9fbf-47fa-a621-d2188a006a3c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010860421214*^9, 3.765010883947712*^9}, {
  3.765011047713619*^9, 3.765011057313805*^9}, {3.7650111041881847`*^9, 
  3.765011110136689*^9}},
 CellID->1262638191,ExpressionUUID->"c6173658-8172-4c08-9ac5-f9ed697ddcd1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "from", " ", "this", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", 
      RowBox[{"\[OpenCurlyQuote]", 
       RowBox[{
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm], "\[Equal]", 
        FormBox[
         StyleBox["B", "ExpressionABF"],
         TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765011117834029*^9, 3.765011146225525*^9}},
 CellID->1428792733,ExpressionUUID->"bbf2364f-c109-4791-8892-82398118d513"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650111497376003`*^9, 3.765011157032343*^9}},
 CellID->1555888312,ExpressionUUID->"75b97fc8-ea3a-476f-b557-85f9b6a652ea"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765011160139538*^9, 3.765011162416277*^9}},
 CellID->1171757799,ExpressionUUID->"aa6b0ce4-111b-49b8-8f42-1f1145d5582c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765011164601595*^9, 3.765011182994891*^9}},
 CellID->649899717,ExpressionUUID->"096f81ae-01ae-4284-aea3-5205fc145766"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "from", " ", "this", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", 
      RowBox[{"\[OpenCurlyQuote]", 
       RowBox[{
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm], "\[Equal]", 
        FormBox[
         StyleBox["B", "ExpressionABF"],
         TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765011186632711*^9, 3.765011222746614*^9}},
 CellID->415579504,ExpressionUUID->"388b6af8-faa3-4ef7-b7d5-87fed5e30311"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765011225112986*^9, 3.765011233247386*^9}},
 CellID->1092745854,ExpressionUUID->"1707e2c7-042a-4043-998b-5f92031f3fc4"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765011235792531*^9, 3.76501123782327*^9}},
 CellID->763723466,ExpressionUUID->"9ab8eaf1-40a5-41ad-95ee-1c7c59a586b7"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Equal]E classical SET)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 519, 17, 19, "ProofText",ExpressionUUID->"0d0d0bfe-c51f-49b3-b1c5-eb5e2824801f",
 CellID->1617895502],
Cell[1126, 40, 5530, 153, 19, "ProofText",ExpressionUUID->"1b95ef0f-b3d4-4e07-b952-067146365d37",
 CellID->324268184],
Cell[6659, 195, 434, 11, 42, "ProofText",ExpressionUUID->"d32f3557-9fbf-47fa-a621-d2188a006a3c",
 CellID->1462406519],
Cell[7096, 208, 595, 16, 19, "ProofText",ExpressionUUID->"c6173658-8172-4c08-9ac5-f9ed697ddcd1",
 CellID->1262638191],
Cell[7694, 226, 869, 25, 19, "ProofText",ExpressionUUID->"bbf2364f-c109-4791-8892-82398118d513",
 CellID->1428792733],
Cell[8566, 253, 339, 7, 19, "ProofText",ExpressionUUID->"75b97fc8-ea3a-476f-b557-85f9b6a652ea",
 CellID->1555888312],
Cell[8908, 262, 220, 4, 19, "ProofText",ExpressionUUID->"aa6b0ce4-111b-49b8-8f42-1f1145d5582c",
 CellID->1171757799],
Cell[9131, 268, 497, 14, 19, "ProofText",ExpressionUUID->"096f81ae-01ae-4284-aea3-5205fc145766",
 CellID->649899717],
Cell[9631, 284, 871, 25, 19, "ProofText",ExpressionUUID->"388b6af8-faa3-4ef7-b7d5-87fed5e30311",
 CellID->415579504],
Cell[10505, 311, 337, 7, 19, "ProofText",ExpressionUUID->"1707e2c7-042a-4043-998b-5f92031f3fc4",
 CellID->1092745854],
Cell[10845, 320, 309, 6, 20, "ProofText",ExpressionUUID->"9ab8eaf1-40a5-41ad-95ee-1c7c59a586b7",
 CellID->763723466]
}
]
*)

