(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12743,        364]
NotebookOptionsPosition[     10380,        315]
NotebookOutlinePosition[     11000,        335]
CellTagsIndexPosition[     10957,        332]
WindowTitle->Proof of (complement \:2286 complement)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765191428434443*^9, 3.765191433668066*^9}},
 CellID->625273754,ExpressionUUID->"0b7f4a79-62a6-4089-bf3a-fba172d09b0f"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651912251252623`*^9, 3.765191255195426*^9}, {
  3.765191435864994*^9, 3.765191442528577*^9}},
 CellID->114001715,ExpressionUUID->"00b87aef-1a2c-4fe8-817e-fb6cb8941d0a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{"-", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}], "\[SubsetEqual]", 
      RowBox[{"-", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651914475706882`*^9, 3.765191462528598*^9}, {
  3.7651915657050457`*^9, 3.7651915664475737`*^9}},
 CellID->143125604,ExpressionUUID->"be09830d-81c8-4f2d-a262-702539ed7c6a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rule", " ", "\"\<\[SubsetEqual]I\>\""}], ",", " ", 
      RowBox[{"rule", " ", "\"\<classical contradiction\>\""}]}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765191465866509*^9, 3.7651915248397408`*^9}},
 CellID->630761642,ExpressionUUID->"93f98fa6-9078-4f8c-b495-1c45186725d0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76519148492218*^9, 3.765191539146892*^9}},
 CellID->1668546000,ExpressionUUID->"e9e294e1-71a0-43ef-a3c4-e84c27206824"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"-", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765191544385398*^9, 3.765191562706772*^9}},
 CellID->1230686456,ExpressionUUID->"82ecc9c6-9c0b-4267-aea5-8f84f84d8b01"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"-", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7651915737369967`*^9, 3.765191614750903*^9}},
 CellID->215979133,ExpressionUUID->"5e0b747e-33a1-4626-b9c7-ebd5ef519b43"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651916210404177`*^9, 3.7651916547669973`*^9}},
 CellID->290707880,ExpressionUUID->"3c2b6889-19ed-4729-914d-cddff51ec4ea"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765191658072137*^9, 3.7651916653424263`*^9}},
 CellID->516098565,ExpressionUUID->"b78f74fc-d0cc-4134-8859-ae5b4f0f5b5c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651914475706882`*^9, 3.765191462528598*^9}, {
  3.7651915657050457`*^9, 3.7651915664475737`*^9}, {3.765191679157959*^9, 
  3.765191694935925*^9}},
 CellID->1260488555,ExpressionUUID->"5d49b9c6-4a1e-4705-9acc-460c9825ad74"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{"-", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}], "\[SubsetEqual]", 
      RowBox[{"-", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rule", " ", "\"\<\[SubsetEqual]I\>\""}], ",", " ", 
      RowBox[{"rule", " ", "\"\<classical contradiction\>\""}]}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765191465866509*^9, 3.7651915248397408`*^9}, {
  3.7651916825900097`*^9, 3.765191698183599*^9}},
 CellID->1543766364,ExpressionUUID->"b1e28c8c-d414-4543-9290-02e62795e91e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{"-", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      RowBox[{"-", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76519148492218*^9, 3.765191539146892*^9}, {
  3.765191706967731*^9, 3.7651917179094477`*^9}},
 CellID->237281451,ExpressionUUID->"782dca57-8406-495b-8bc9-1297d516bd9e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", 
   RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765191544385398*^9, 3.765191562706772*^9}, {
  3.7651917232855988`*^9, 3.765191725717526*^9}},
 CellID->817242502,ExpressionUUID->"2b19c53b-5f84-4930-a5ab-a58642d2292e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", "\"\<*\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7651915737369967`*^9, 3.765191614750903*^9}, {
  3.765191729782998*^9, 3.765191731269432*^9}},
 CellID->1063598471,ExpressionUUID->"a7ef5db9-0bc0-4aff-9921-1f4aaac6f34d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"-", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651916210404177`*^9, 3.7651916547669973`*^9}, {
  3.765191736461282*^9, 3.76519174319104*^9}},
 CellID->430662069,ExpressionUUID->"b7f176eb-6c03-4e44-b703-0e0b74658038"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765191258773059*^9, 3.765191267355122*^9}, {
  3.7651917486210203`*^9, 3.765191754205202*^9}},
 CellID->1182417604,ExpressionUUID->"2834dc8c-7b72-48fe-a76c-8cfbd3a6217e"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (complement \[SubsetEqual] complement)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 370, 11, 19, "ProofText",ExpressionUUID->"0b7f4a79-62a6-4089-bf3a-fba172d09b0f",
 CellID->625273754],
Cell[984, 34, 285, 5, 42, "ProofText",ExpressionUUID->"00b87aef-1a2c-4fe8-817e-fb6cb8941d0a",
 CellID->114001715],
Cell[1272, 41, 641, 18, 19, "ProofText",ExpressionUUID->"be09830d-81c8-4f2d-a262-702539ed7c6a",
 CellID->143125604],
Cell[1916, 61, 712, 20, 42, "ProofText",ExpressionUUID->"93f98fa6-9078-4f8c-b495-1c45186725d0",
 CellID->630761642],
Cell[2631, 83, 846, 25, 19, "ProofText",ExpressionUUID->"e9e294e1-71a0-43ef-a3c4-e84c27206824",
 CellID->1668546000],
Cell[3480, 110, 618, 17, 19, "ProofText",ExpressionUUID->"82ecc9c6-9c0b-4267-aea5-8f84f84d8b01",
 CellID->1230686456],
Cell[4101, 129, 621, 17, 19, "ProofText",ExpressionUUID->"5e0b747e-33a1-4626-b9c7-ebd5ef519b43",
 CellID->215979133],
Cell[4725, 148, 583, 15, 19, "ProofText",ExpressionUUID->"3c2b6889-19ed-4729-914d-cddff51ec4ea",
 CellID->290707880],
Cell[5311, 165, 278, 6, 42, "ProofText",ExpressionUUID->"b78f74fc-d0cc-4134-8859-ae5b4f0f5b5c",
 CellID->516098565],
Cell[5592, 173, 641, 17, 19, "ProofText",ExpressionUUID->"5d49b9c6-4a1e-4705-9acc-460c9825ad74",
 CellID->1260488555],
Cell[6236, 192, 814, 23, 42, "ProofText",ExpressionUUID->"b1e28c8c-d414-4543-9290-02e62795e91e",
 CellID->1543766364],
Cell[7053, 217, 946, 28, 19, "ProofText",ExpressionUUID->"782dca57-8406-495b-8bc9-1297d516bd9e",
 CellID->237281451],
Cell[8002, 247, 644, 17, 19, "ProofText",ExpressionUUID->"2b19c53b-5f84-4930-a5ab-a58642d2292e",
 CellID->817242502],
Cell[8649, 266, 647, 17, 19, "ProofText",ExpressionUUID->"a7ef5db9-0bc0-4aff-9921-1f4aaac6f34d",
 CellID->1063598471],
Cell[9299, 285, 655, 17, 19, "ProofText",ExpressionUUID->"b7f176eb-6c03-4e44-b703-0e0b74658038",
 CellID->430662069],
Cell[9957, 304, 419, 9, 42, "ProofText",ExpressionUUID->"2834dc8c-7b72-48fe-a76c-8cfbd3a6217e",
 CellID->1182417604]
}
]
*)

