(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10368,        302]
NotebookOptionsPosition[      8479,        261]
NotebookOutlinePosition[      9092,        281]
CellTagsIndexPosition[      9049,        278]
WindowTitle->Proof of (\:2282\:2286 trans)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650159292715683`*^9, 3.7650159368481293`*^9}},
 CellID->558702817,ExpressionUUID->"44bfc83e-c056-4d95-a564-d3a4df973365"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[Subset]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[SubsetEqual]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[SubsetEqual]y"], 
     TagBox[
      StyleBox["C", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76501593867815*^9, 3.765015957796517*^9}},
 CellID->1666708378,ExpressionUUID->"363aefa7-4eec-4b3c-baa1-05300f3d932b"],

Cell[BoxData[
 RowBox[{"from", " ", 
  RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], " ",
   "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[SubsetEqual]", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[Subset] implies \[SubsetEqual]\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015979053547*^9, 3.7650160131796913`*^9}, {
  3.765016136849577*^9, 3.765016142459134*^9}},
 CellID->1694118313,ExpressionUUID->"5d17cd07-5773-4262-86d7-0fc0c3eb0b3f"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[Subset]", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015961221858*^9, 3.765015973316264*^9}},
 CellID->363799804,ExpressionUUID->"6da91d9e-9296-45de-b09c-147938e953e8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual] trans\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016020427916*^9, 3.765016071162709*^9}, {
  3.7650161507635813`*^9, 3.765016160867676*^9}},
 CellID->1139342672,ExpressionUUID->"5714e46b-545a-435c-b7b6-8d5cdc70f9e4"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016074011547*^9, 3.765016076035124*^9}},
 CellID->1030793600,ExpressionUUID->"4fde70e9-2d52-4b3a-8692-f2908975e4bf"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650160791951447`*^9, 3.7650160926026707`*^9}},
 CellID->2137979828,ExpressionUUID->"d5fbc20c-58f8-43c0-b83f-38683aed7c97"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016096419463*^9, 3.765016109077479*^9}},
 CellID->604973979,ExpressionUUID->"a5982171-16eb-4c10-a867-a57bafd01911"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016186778853*^9, 3.765016219633132*^9}},
 CellID->456957849,ExpressionUUID->"52d83091-b90d-4ad2-9cb5-5969fc3ab460"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650162251937733`*^9, 3.765016254096324*^9}},
 CellID->835549568,ExpressionUUID->"2467283d-1db7-4db9-a59b-a4bd5dff0aec"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[Subset]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<\[Subset] alt\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016260050005*^9, 3.765016297360367*^9}, {
  3.765016598644514*^9, 3.765016647123947*^9}},
 CellID->827325767,ExpressionUUID->"16c530df-d8a7-42fe-bc1c-e9e7bb4f4d5b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.76501665131105*^9, 3.765016658627946*^9}},
 CellID->1721463590,ExpressionUUID->"ab5b2e31-d6b2-4b39-a765-33996cb5c36c"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Subset]\[SubsetEqual] trans)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 447, 14, 19, "ProofText",ExpressionUUID->"44bfc83e-c056-4d95-a564-d3a4df973365",
 CellID->558702817],
Cell[1051, 37, 1257, 33, 19, "ProofText",ExpressionUUID->"363aefa7-4eec-4b3c-baa1-05300f3d932b",
 CellID->1666708378],
Cell[2311, 72, 704, 18, 19, "ProofText",ExpressionUUID->"5d17cd07-5773-4262-86d7-0fc0c3eb0b3f",
 CellID->1694118313],
Cell[3018, 92, 454, 12, 42, "ProofText",ExpressionUUID->"6da91d9e-9296-45de-b09c-147938e953e8",
 CellID->363799804],
Cell[3475, 106, 1125, 33, 19, "ProofText",ExpressionUUID->"5714e46b-545a-435c-b7b6-8d5cdc70f9e4",
 CellID->1139342672],
Cell[4603, 141, 220, 4, 19, "ProofText",ExpressionUUID->"4fde70e9-2d52-4b3a-8692-f2908975e4bf",
 CellID->1030793600],
Cell[4826, 147, 518, 15, 42, "ProofText",ExpressionUUID->"d5fbc20c-58f8-43c0-b83f-38683aed7c97",
 CellID->2137979828],
Cell[5347, 164, 494, 14, 19, "ProofText",ExpressionUUID->"a5982171-16eb-4c10-a867-a57bafd01911",
 CellID->604973979],
Cell[5844, 180, 755, 22, 19, "ProofText",ExpressionUUID->"52d83091-b90d-4ad2-9cb5-5969fc3ab460",
 CellID->456957849],
Cell[6602, 204, 766, 23, 19, "ProofText",ExpressionUUID->"2467283d-1db7-4db9-a59b-a4bd5dff0aec",
 CellID->835549568],
Cell[7371, 229, 734, 20, 19, "ProofText",ExpressionUUID->"16c530df-d8a7-42fe-bc1c-e9e7bb4f4d5b",
 CellID->827325767],
Cell[8108, 251, 367, 8, 42, "ProofText",ExpressionUUID->"ab5b2e31-d6b2-4b39-a765-33996cb5c36c",
 CellID->1721463590]
}
]
*)

