(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     38357,       1045]
NotebookOptionsPosition[     34810,        976]
NotebookOutlinePosition[     35412,        996]
CellTagsIndexPosition[     35369,        993]
WindowTitle->Proof of (Cantor's paradox 2)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564004544812*^9, 3.7315640091239576`*^9}, 
   3.765106327985765*^9},
 CellID->220420563,ExpressionUUID->"ba8aaaac-3949-414e-a236-142e70c16016"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox[
     TagBox["\[NotExists]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`NotExists$TM, {
         Theorema`Language`FUN$TM[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]}]]], 
     TagBox[
      StyleBox["f", "ExpressionVariable"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`FUN$TM[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]]], 
    RowBox[{
     UnderscriptBox[
      TagBox["\[ForAll]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
      TagBox[
       StyleBox["B", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          TagBox[
           StyleBox["B", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
         TagBox["\[SubsetEqual]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[SubsetEqual]y"], 
         TagBox[
          StyleBox["A", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[Implies]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
        SyntaxForm->"x\[Implies]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         UnderscriptBox[
          TagBox["\[Exists]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
          RowBox[{
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "\[Element]", 
           FormBox[
            StyleBox["A", "ExpressionABF"],
            TheoremaForm]}]], 
         RowBox[{
          TagBox[
           StyleBox["B", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
           SyntaxForm->"x\[Equal]y"], 
          RowBox[{
           StyleBox["f", "ExpressionVariable"], "[", 
           TagBox[
            TagBox[
             StyleBox["x", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`FUN$TM[
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "]"}]}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315640128750477`*^9, 3.7315640438690224`*^9}, {
  3.7315641620033827`*^9, 3.7315641660839252`*^9}, {3.76510632899384*^9, 
  3.7651063323297033`*^9}},
 CellID->660093170,ExpressionUUID->"722afe2c-7f40-4b0b-9294-fab5a79ec6f1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`NotExists$TM, {
           Theorema`Language`FUN$TM[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
            
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]}]]], 
       TagBox[
        StyleBox["f", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]]], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
        TagBox[
         StyleBox["B", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           TagBox[
            TagBox[
             StyleBox["B", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Language`FUN$TM[
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
           TagBox["\[SubsetEqual]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
            SyntaxForm->"x\[SubsetEqual]y"], 
           TagBox[
            StyleBox["A", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
          TagBox[")",
           "AutoParentheses"]}], 
         TagBox["\[Implies]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
          SyntaxForm->"x\[Implies]y"], 
         RowBox[{
          TagBox["(",
           "AutoParentheses"], 
          RowBox[{
           UnderscriptBox[
            TagBox["\[Exists]",
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
            RowBox[{
             TagBox[
              StyleBox["x", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "\[Element]", 
             FormBox[
              StyleBox["A", "ExpressionABF"],
              TheoremaForm]}]], 
           RowBox[{
            TagBox[
             StyleBox["B", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
            TagBox["\[Equal]",
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
             SyntaxForm->"x\[Equal]y"], 
            RowBox[{
             StyleBox["f", "ExpressionVariable"], "[", 
             TagBox[
              TagBox[
               StyleBox["x", "ExpressionVariable"],
               Theorema`Language`TAG$[
                Theorema`Language`TYPED$[
                 Theorema`Language`FUN$TM[
                  Theorema`Knowledge`SET$TM[
                   Theorema`Language`TFIX$[
                   Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
                  Theorema`Knowledge`SET$TM[
                   Theorema`Language`TFIX$[
                   Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Knowledge`SET$TM[
                 Theorema`Language`TFIX$[
                 Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "]"}]}]}], 
          TagBox[")",
           "AutoParentheses"]}]}], ")"}]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315640487461247`*^9, 3.7315640635312796`*^9}, {
   3.7315641751187344`*^9, 3.731564178525367*^9}, 3.7651063347734222`*^9},
 CellID->570245504,ExpressionUUID->"d0a11541-544f-4b38-ad50-b162d7cdeb9b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", "\"\<1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
       TagBox[
        StyleBox["B", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           TagBox[
            StyleBox["B", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
          TagBox["\[SubsetEqual]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[SubsetEqual]y"], 
          TagBox[
           StyleBox["A", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[Implies]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
         SyntaxForm->"x\[Implies]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          UnderscriptBox[
           TagBox["\[Exists]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
           RowBox[{
            TagBox[
             StyleBox["x", "ExpressionVariable"],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "\[Element]", 
            FormBox[
             StyleBox["A", "ExpressionABF"],
             TheoremaForm]}]], 
          RowBox[{
           TagBox[
            StyleBox["B", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
           TagBox["\[Equal]",
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
            SyntaxForm->"x\[Equal]y"], 
           RowBox[{
            FormBox[
             StyleBox["f", "ExpressionABF"],
             TheoremaForm], "[", 
            TagBox[
             TagBox[
              StyleBox["x", "ExpressionVariable"],
              Theorema`Language`TAG$[
               Theorema`Language`TYPED$[
                Theorema`Language`FUN$TM[
                 Theorema`Knowledge`SET$TM[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
                 Theorema`Knowledge`SET$TM[
                  Theorema`Language`TFIX$[
                  Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
             Theorema`Language`TAG$[
              Theorema`Language`TYPED$[
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "]"}]}]}], 
         TagBox[")",
          "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564068643059*^9, 3.731564108111047*^9}, {
   3.7315641842159343`*^9, 3.731564195360551*^9}, {3.731564244128869*^9, 
   3.731564245379281*^9}, {3.7315653177096033`*^9, 3.731565331260725*^9}, 
   3.765106335689769*^9},
 CellID->3265058,ExpressionUUID->"223e7ca9-0cee-43a9-b51c-971f136c4a0f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"let", " ", 
    FormBox[
     StyleBox["X", "ExpressionSyntactic"],
     TheoremaForm], " ", "be", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"Collect", "[", 
      RowBox[{
       UnderscriptBox["\[Lambda]", "x"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"x", "\[Element]", 
          FormBox[
           StyleBox["A", "ExpressionABF"],
           TheoremaForm]}], "\[And]", 
         RowBox[{"x", "\[NotElement]", 
          RowBox[{
           FormBox[
            StyleBox["f", "ExpressionABF"],
            TheoremaForm], "[", "x", "]"}]}]}], ")"}]}], "]"}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315641989862275`*^9, 3.7315642370000534`*^9}, 
   3.765106336408993*^9},
 CellID->381723682,ExpressionUUID->"a789d344-4499-4138-b30b-d781f7b6c318"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<1\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["X", "ExpressionSyntactic"],
         TheoremaForm], "\[SubsetEqual]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}], ")"}], 
      TagBox["\[Implies]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Implies$TM, {}]],
       SyntaxForm->"x\[Implies]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
         RowBox[{
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "\[Element]", 
          FormBox[
           StyleBox["A", "ExpressionABF"],
           TheoremaForm]}]], 
        RowBox[{
         FormBox[
          StyleBox["X", "ExpressionSyntactic"],
          TheoremaForm], 
         TagBox["\[Equal]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
          SyntaxForm->"x\[Equal]y"], 
         RowBox[{
          FormBox[
           StyleBox["f", "ExpressionABF"],
           TheoremaForm], "[", 
          TagBox[
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "]"}]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315642480524516`*^9, 3.731564311222247*^9}, 
   3.76510633715836*^9},
 CellID->57082720,ExpressionUUID->"2f8202cd-f49c-4b8d-a2c6-c483bb6aec17"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"moreover", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["X", "ExpressionSyntactic"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315643251788955`*^9, 3.7315643426988087`*^9}, {
  3.7315649805124626`*^9, 3.7315649825283003`*^9}, {3.765106337649581*^9, 
  3.765106338277917*^9}},
 CellID->163564385,ExpressionUUID->"948097cd-eb91-4e9b-83fc-24bff392645d"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315649868272133`*^9, 3.731564996079585*^9}, 
   3.765106339209449*^9},
 CellID->147382316,ExpressionUUID->"0f3411b2-a193-4152-86f3-a766d5c0308e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["X", "ExpressionSyntactic"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315649991285453`*^9, 3.731565012789082*^9}, 
   3.765106339889275*^9},
 CellID->245970692,ExpressionUUID->"d9059fd8-4741-4128-808d-54db1347791f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["X", "ExpressionSyntactic"],
      TheoremaForm], "\[ReverseElement]", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
   RowBox[{"\"\<\[Element] def\>\"", " ", "."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731565017649767*^9, 3.7315650472375636`*^9}, {
  3.765106340515606*^9, 3.765106343105632*^9}},
 CellID->254148405,ExpressionUUID->"791ec5d8-673b-4128-bd0d-970991d9edf5"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<Collect inverse\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315650538020077`*^9, 3.7315651285829887`*^9}, 
   3.765106344641486*^9},
 CellID->395465286,ExpressionUUID->"b5739ef1-d08f-4fa9-9d8d-0cbecdb170fc"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315651344282494`*^9, 3.7315651378212137`*^9}, 
   3.7651063463778133`*^9},
 CellID->842653328,ExpressionUUID->"ced5d58e-6443-4649-8ff4-8b8f6041c7b5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"ultimately", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "\[Element]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}]], 
      RowBox[{
       FormBox[
        StyleBox["X", "ExpressionSyntactic"],
        TheoremaForm], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
        SyntaxForm->"x\[Equal]y"], 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", 
        TagBox[
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]], 
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], "]"}]}]}], 
     "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315643460436983`*^9, 3.731564360110801*^9}, 
   3.765106347104926*^9},
 CellID->843189483,ExpressionUUID->"fe8241bb-07ce-472e-a04e-af3f2786f66e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["X", "ExpressionSyntactic"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564363533761*^9, 3.731564405312913*^9}, 
   3.765106348585429*^9},
 CellID->25633564,ExpressionUUID->"ecb96f5b-4f55-49a2-999b-0184f9cdf1e6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"note", " ", "\"\<eq\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
    "[", "symmetric", "]"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315644112992153`*^9, 3.731564442058528*^9}, {
   3.765008222845574*^9, 3.765008232861054*^9}, 3.7651063494729*^9},
 CellID->369749251,ExpressionUUID->"1090c03c-d7b3-4249-95f7-58dea9e547fb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "\[Element]", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm], "]"}]}], ")"}], "\[DoubleLeftRightArrow]", 
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "\[NotElement]", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm], "]"}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], "\n", 
   "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564466847536*^9, 3.73156452017689*^9}, {
  3.7651063503291187`*^9, 3.765106351145421*^9}},
 CellID->480459473,ExpressionUUID->"9499f337-85bc-404b-90b6-610908a87f45"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564524475361*^9, 3.7315645412608733`*^9}, 
   3.765106354097395*^9},
 CellID->165920660,ExpressionUUID->"cdc6041e-a147-441f-9103-db45ca441810"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["X", "ExpressionSyntactic"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<eq\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564544355965*^9, 3.731564562863431*^9}, 
   3.7651063558491507`*^9},
 CellID->346921206,ExpressionUUID->"89de20e6-30a5-4179-8ba9-6565733fcfdf"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", 
      RowBox[{"\"\<\[Element] def\>\"", " ", "\"\<Collect inverse\>\""}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315646298078613`*^9, 3.7315646678529353`*^9}, {
   3.7315651495431924`*^9, 3.731565170738083*^9}, 3.7651063566168327`*^9},
 CellID->77021923,ExpressionUUID->"32e7b4b4-6d26-4e41-beea-182f1805e39d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315647012705865`*^9, 3.731564704741289*^9}, 
   3.765106357452486*^9},
 CellID->921342730,ExpressionUUID->"a12f2e77-4299-4b42-a9cb-4240d3bcae9a"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564706773093*^9, 3.7315647285775394`*^9}, 
   3.7651063585454407`*^9},
 CellID->404622797,ExpressionUUID->"b4045b96-5966-4848-b4a9-68bd7cd1bd90"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["X", "ExpressionSyntactic"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<eq\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315647304845505`*^9, 3.731564749678494*^9}, 
   3.765106360406521*^9},
 CellID->710768629,ExpressionUUID->"56cf992c-c004-47d9-b2ce-368e05e97125"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", 
      RowBox[{
       RowBox[{"\[OpenCurlyQuote]", 
        RowBox[{
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm], "\[Element]", 
         FormBox[
          StyleBox["A", "ExpressionABF"],
          TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
       "\"\<\[Element] def\>\"", " ", "\"\<Collect inverse\>\""}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564758697504*^9, 3.731564810937987*^9}, {
   3.7315651971996803`*^9, 3.7315652219419775`*^9}, 3.765106361160063*^9},
 CellID->474761569,ExpressionUUID->"d86f925b-eb01-4fe2-a695-d3518b11283a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7315648982475367`*^9, 3.7315649018434353`*^9}, 
   3.765106362841345*^9},
 CellID->179951392,ExpressionUUID->"72a1f5e9-c78a-417c-8863-f2b6dc577ecc"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731564904124447*^9, 3.731564912737995*^9}, 
   3.765106363971582*^9},
 CellID->20664516,ExpressionUUID->"501dcfc9-d1f2-4fad-a955-b36e80448d11"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7315649157689342`*^9, 3.7315649236786947`*^9}, {
  3.7651063651212254`*^9, 3.76510636721014*^9}},
 CellID->571430711,ExpressionUUID->"a9fc09b4-7ac5-4998-96b3-c8277ea552e1"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (Cantor's paradox 2)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 325, 9, 19, "ProofText",ExpressionUUID->"ba8aaaac-3949-414e-a236-142e70c16016",
 CellID->220420563],
Cell[929, 32, 5560, 142, 57, "ProofText",ExpressionUUID->"722afe2c-7f40-4b0b-9294-fab5a79ec6f1",
 CellID->660093170],
Cell[6492, 176, 5865, 146, 32, "ProofText",ExpressionUUID->"d0a11541-544f-4b38-ad50-b162d7cdeb9b",
 CellID->570245504],
Cell[12360, 324, 5153, 132, 30, "ProofText",ExpressionUUID->"223e7ca9-0cee-43a9-b51c-971f136c4a0f",
 CellID->3265058],
Cell[17516, 458, 887, 26, 29, "ProofText",ExpressionUUID->"a789d344-4499-4138-b30b-d781f7b6c318",
 CellID->381723682],
Cell[18406, 486, 2845, 78, 30, "ProofText",ExpressionUUID->"2f8202cd-f49c-4b8d-a2c6-c483bb6aec17",
 CellID->57082720],
Cell[21254, 566, 645, 17, 42, "ProofText",ExpressionUUID->"948097cd-eb91-4e9b-83fc-24bff392645d",
 CellID->163564385],
Cell[21902, 585, 350, 10, 19, "ProofText",ExpressionUUID->"0f3411b2-a193-4152-86f3-a766d5c0308e",
 CellID->147382316],
Cell[22255, 597, 530, 15, 19, "ProofText",ExpressionUUID->"d9059fd8-4741-4128-808d-54db1347791f",
 CellID->245970692],
Cell[22788, 614, 605, 15, 19, "ProofText",ExpressionUUID->"791ec5d8-673b-4128-bd0d-970991d9edf5",
 CellID->254148405],
Cell[23396, 631, 630, 18, 19, "ProofText",ExpressionUUID->"b5739ef1-d08f-4fa9-9d8d-0cbecdb170fc",
 CellID->395465286],
Cell[24029, 651, 269, 6, 19, "ProofText",ExpressionUUID->"ced5d58e-6443-4649-8ff4-8b8f6041c7b5",
 CellID->842653328],
Cell[24301, 659, 2179, 58, 27, "ProofText",ExpressionUUID->"fe8241bb-07ce-472e-a04e-af3f2786f66e",
 CellID->843189483],
Cell[26483, 719, 1005, 31, 19, "ProofText",ExpressionUUID->"ecb96f5b-4f55-49a2-999b-0184f9cdf1e6",
 CellID->25633564],
Cell[27491, 752, 460, 10, 19, "ProofText",ExpressionUUID->"1090c03c-d7b3-4249-95f7-58dea9e547fb",
 CellID->369749251],
Cell[27954, 764, 1110, 34, 42, "ProofText",ExpressionUUID->"9499f337-85bc-404b-90b6-610908a87f45",
 CellID->480459473],
Cell[29067, 800, 638, 20, 19, "ProofText",ExpressionUUID->"cdc6041e-a147-441f-9103-db45ca441810",
 CellID->165920660],
Cell[29708, 822, 618, 17, 19, "ProofText",ExpressionUUID->"89de20e6-30a5-4179-8ba9-6565733fcfdf",
 CellID->346921206],
Cell[30329, 841, 836, 23, 19, "ProofText",ExpressionUUID->"32e7b4b4-6d26-4e41-beea-182f1805e39d",
 CellID->77021923],
Cell[31168, 866, 266, 6, 19, "ProofText",ExpressionUUID->"a12f2e77-4299-4b42-a9cb-4240d3bcae9a",
 CellID->921342730],
Cell[31437, 874, 643, 20, 19, "ProofText",ExpressionUUID->"b4045b96-5966-4848-b4a9-68bd7cd1bd90",
 CellID->404622797],
Cell[32083, 896, 621, 17, 19, "ProofText",ExpressionUUID->"56cf992c-c004-47d9-b2ce-368e05e97125",
 CellID->710768629],
Cell[32707, 915, 1109, 32, 19, "ProofText",ExpressionUUID->"d86f925b-eb01-4fe2-a695-d3518b11283a",
 CellID->474761569],
Cell[33819, 949, 267, 6, 19, "ProofText",ExpressionUUID->"72a1f5e9-c78a-417c-8863-f2b6dc577ecc",
 CellID->179951392],
Cell[34089, 957, 350, 8, 19, "ProofText",ExpressionUUID->"501dcfc9-d1f2-4fad-a955-b36e80448d11",
 CellID->20664516],
Cell[34442, 967, 364, 7, 20, "ProofText",ExpressionUUID->"a9fc09b4-7ac5-4998-96b3-c8277ea552e1",
 CellID->571430711]
}
]
*)

