(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8243,        235]
NotebookOptionsPosition[      7195,        208]
NotebookOutlinePosition[      7795,        228]
CellTagsIndexPosition[      7752,        225]
WindowTitle->Proof of (\:22C2E)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["thesis", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765020233665526*^9, 3.765020244610437*^9}},
 CellID->922659869,ExpressionUUID->"b156e50c-5162-4c88-b0e4-218e3f22b42b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       TagBox["\[Element]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Element]y"], 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
         TagBox["\[Element]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[Element]y"], 
         TagBox[
          StyleBox["B", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["thesis", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`FORM$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765020314670924*^9, 3.765020323206036*^9}},
 CellID->1613523811,ExpressionUUID->"ea476503-952c-4815-8e07-876ff0bbe029"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["x", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     TagBox["\[Element]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[Element]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       TagBox["\[Intersection]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Intersection$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Intersection]y"], 
       TagBox[
        StyleBox["B", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765020246624262*^9, 3.765020263902405*^9}},
 CellID->86307794,ExpressionUUID->"d5b92c02-9250-47b5-801d-9b310ce7ba82"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["x", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
    TagBox["\[Element]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[Element]y"], 
    TagBox[
     StyleBox["A", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Knowledge`SET$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
   "\[CloseCurlyQuote]"}], " ", "and", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], "\[Element]", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"rule", " ", "\"\<\[Intersection]D1\>\""}], ",", " ", 
    RowBox[{"rule", " ", "\"\<\[Intersection]D2\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76502026639177*^9, 3.765020305325632*^9}},
 CellID->98556181,ExpressionUUID->"11d2bade-e97d-4640-aacc-40f62b00e123"],

Cell[BoxData[
 RowBox[{"thus", " ", 
  FormBox[
   StyleBox["thesis", "ExpressionABF"],
   TheoremaForm], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765020325767062*^9, 3.765020333936365*^9}},
 CellID->373445931,ExpressionUUID->"ed3a2191-f4dc-4dba-acbf-d2b97cef8217"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Intersection]E)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 521, 17, 19, "ProofText",ExpressionUUID->"b156e50c-5162-4c88-b0e4-218e3f22b42b",
 CellID->922659869],
Cell[1114, 40, 2676, 72, 19, "ProofText",ExpressionUUID->"ea476503-952c-4815-8e07-876ff0bbe029",
 CellID->1613523811],
Cell[3793, 114, 1597, 41, 25, "ProofText",ExpressionUUID->"d5b92c02-9250-47b5-801d-9b310ce7ba82",
 CellID->86307794],
Cell[5393, 157, 1342, 36, 19, "ProofText",ExpressionUUID->"11d2bade-e97d-4640-aacc-40f62b00e123",
 CellID->98556181],
Cell[6738, 195, 453, 11, 20, "ProofText",ExpressionUUID->"ed3a2191-f4dc-4dba-acbf-d2b97cef8217",
 CellID->373445931]
}
]
*)

