(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5473,        171]
NotebookOptionsPosition[      4252,        136]
NotebookOutlinePosition[      4867,        156]
CellTagsIndexPosition[      4824,        153]
WindowTitle->Proof of (contraposition \:2286D)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730611976425995*^9, 3.730611985180635*^9}},
 CellID->1105013655,ExpressionUUID->"fd6ce84a-dad9-4624-82b5-6f564538639c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730612007148493*^9, 3.730612032025155*^9}},
 CellID->842802081,ExpressionUUID->"a7b2c6bd-1cb9-40e5-a8c1-4a74d1144397"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], "\[NotElement]", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7306120344629583`*^9, 3.730612048461042*^9}},
 CellID->496040264,ExpressionUUID->"49364583-6ea6-4552-ac51-9edd6eb72359"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730612053607691*^9, 3.730612065446443*^9}},
 CellID->1207332498,ExpressionUUID->"6ddd4dab-555f-41ad-a5e9-e7b9b85a8a8a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7306120682083883`*^9, 3.730612110632341*^9}},
 CellID->610289759,ExpressionUUID->"bfa4fba3-d5d4-4203-878a-c23cb986e1eb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7306121144647503`*^9, 3.730612135437441*^9}},
 CellID->1439376358,ExpressionUUID->"cded1aac-bd21-4ab3-aa9c-a1b68359d78a"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (contraposition \[SubsetEqual]D)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 444, 14, 20, "ProofText", "ExpressionUUID" -> \
"fd6ce84a-dad9-4624-82b5-6f564538639c",
 CellID->1105013655],
Cell[1052, 37, 724, 21, 20, "ProofText", "ExpressionUUID" -> \
"a7b2c6bd-1cb9-40e5-a8c1-4a74d1144397",
 CellID->842802081],
Cell[1779, 60, 460, 12, 39, "ProofText", "ExpressionUUID" -> \
"49364583-6ea6-4552-ac51-9edd6eb72359",
 CellID->496040264],
Cell[2242, 74, 495, 14, 20, "ProofText", "ExpressionUUID" -> \
"6ddd4dab-555f-41ad-a5e9-e7b9b85a8a8a",
 CellID->1207332498],
Cell[2740, 90, 820, 24, 18, "ProofText", "ExpressionUUID" -> \
"bfa4fba3-d5d4-4203-878a-c23cb986e1eb",
 CellID->610289759],
Cell[3563, 116, 685, 18, 19, "ProofText", "ExpressionUUID" -> \
"cded1aac-bd21-4ab3-aa9c-a1b68359d78a",
 CellID->1439376358]
}
]
*)

