(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7667,        224]
NotebookOptionsPosition[      6276,        191]
NotebookOutlinePosition[      6870,        211]
CellTagsIndexPosition[      6827,        208]
WindowTitle->Proof of (\:2282I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009264410657*^9, 3.765009269249851*^9}},
 CellID->734019049,ExpressionUUID->"c16f5fa3-fed8-4e36-a586-7c827c151658"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[SubsetEqual]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[SubsetEqual]y"], 
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[NotEqual]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Unequal$TM, {
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
      SyntaxForm->"x\[NotEqual]y"], 
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009272089704*^9, 3.76500929418373*^9}},
 CellID->691513495,ExpressionUUID->"85d26a10-21c5-4922-bf06-3fdbaf195582"],

Cell[BoxData[{
 RowBox[{"have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"\[Not]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009316888831*^9, 3.765009350022822*^9}},
 CellID->957365242,ExpressionUUID->"3d0e2275-8c19-465e-8b82-0a90c687ae05"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009353335772*^9, 3.765009366918788*^9}},
 CellID->1128384998,ExpressionUUID->"6149a1b5-0c6a-4cef-ac31-e23567a587af"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765011926288484*^9, 3.765011952329095*^9}},
 CellID->934576423,ExpressionUUID->"7619e523-f41a-40e8-8671-ae594fa1eb1c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765011955119357*^9, 3.7650119806059093`*^9}},
 CellID->852775341,ExpressionUUID->"43a4771e-e496-4a3b-ae95-ebe7a002e772"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765011985367221*^9, 3.765011987550136*^9}},
 CellID->287431989,ExpressionUUID->"4910b298-f3f3-48a1-b7d8-771a61ef83ab"],

Cell[BoxData[
 RowBox[{"with", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[SubsetEqual]", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[Subset]", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<\[Subset] def\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.76501199966339*^9, 3.765012044285267*^9}},
 CellID->88312297,ExpressionUUID->"4109aca2-6092-4c4e-9e05-06c9786c7dda"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Subset]I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 370, 11, 19, "ProofText",ExpressionUUID->"c16f5fa3-fed8-4e36-a586-7c827c151658",
 CellID->734019049],
Cell[963, 34, 1826, 46, 19, "ProofText",ExpressionUUID->"85d26a10-21c5-4922-bf06-3fdbaf195582",
 CellID->691513495],
Cell[2792, 82, 494, 14, 42, "ProofText",ExpressionUUID->"3d0e2275-8c19-465e-8b82-0a90c687ae05",
 CellID->957365242],
Cell[3289, 98, 499, 14, 19, "ProofText",ExpressionUUID->"6149a1b5-0c6a-4cef-ac31-e23567a587af",
 CellID->1128384998],
Cell[3791, 114, 762, 23, 19, "ProofText",ExpressionUUID->"7619e523-f41a-40e8-8671-ae594fa1eb1c",
 CellID->934576423],
Cell[4556, 139, 590, 16, 19, "ProofText",ExpressionUUID->"43a4771e-e496-4a3b-ae95-ebe7a002e772",
 CellID->852775341],
Cell[5149, 157, 218, 4, 19, "ProofText",ExpressionUUID->"4910b298-f3f3-48a1-b7d8-771a61ef83ab",
 CellID->287431989],
Cell[5370, 163, 902, 26, 20, "ProofText",ExpressionUUID->"4109aca2-6092-4c4e-9e05-06c9786c7dda",
 CellID->88312297]
}
]
*)

