(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12113,        342]
NotebookOptionsPosition[     10358,        303]
NotebookOutlinePosition[     10958,        323]
CellTagsIndexPosition[     10915,        320]
WindowTitle->Proof of (\:F431 iff SET)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650096655326033`*^9, 3.765009670642297*^9}},
 CellID->446769120,ExpressionUUID->"510f0156-760f-4067-8ced-fb2ebc26b6f0"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650096773717003`*^9, 3.765009680314773*^9}},
 CellID->921551091,ExpressionUUID->"520eaee9-ecc6-4635-97fe-6bc409f0c372"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650096830603333`*^9, 3.765009695506652*^9}, {
  3.765009732954204*^9, 3.765009740282773*^9}, {3.765009908698142*^9, 
  3.765009909080532*^9}},
 CellID->2059686531,ExpressionUUID->"bfba5b85-e36d-461a-9bdf-488399a4a60f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009704651944*^9, 3.765009904471833*^9}},
 CellID->199768328,ExpressionUUID->"12c95620-decf-4bf4-b980-5e6bfa55829f"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650099136081247`*^9, 3.76500991517594*^9}},
 CellID->1319417245,ExpressionUUID->"2c21296d-708c-4644-bbcc-6451bdbe415c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<*\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
          TagBox["\[Element]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Element]y"], 
          TagBox[
           StyleBox["A", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["\[DoubleLeftRightArrow]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
         SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
          TagBox["\[Element]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
           SyntaxForm->"x\[Element]y"], 
          TagBox[
           StyleBox["B", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}]}], 
      TagBox[")",
       "AutoParentheses"]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009917897334*^9, 3.7650099293908033`*^9}, {
  3.76501006980475*^9, 3.765010071869952*^9}},
 CellID->1856834927,ExpressionUUID->"ca430d5b-95ac-406c-8477-db4d7c465aa2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
    RowBox[{"\"\<ReverseElement inject\>\"", "[", "symmetric", "]"}]}], "\n", 
   "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Equal] ext\>\""}], ")"}]}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765009959920394*^9, 3.765010037062482*^9}},
 CellID->1368590631,ExpressionUUID->"a884fa29-fc4e-4f5b-8de5-bd2997fcc81f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765009532071681*^9, 3.765009638667407*^9}, {
  3.765009949591455*^9, 3.765009951199494*^9}, {3.765010058014104*^9, 
  3.7650100631131496`*^9}},
 CellID->2072981662,ExpressionUUID->"eec6ab92-0bf0-40bf-9af2-48a2ff12c436"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "\[Element]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}], 
       TagBox[")",
        "AutoParentheses"]}], "\[DoubleLeftRightArrow]", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "\[Element]", 
        FormBox[
         StyleBox["B", "ExpressionABF"],
         TheoremaForm]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010074471711*^9, 3.765010114674938*^9}},
 CellID->1007174840,ExpressionUUID->"113c0eff-37f6-4e0b-9081-b3cd7b880e15"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    StyleBox[
     FormBox[
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["A", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
         TagBox["\[ReverseElement]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`ReverseElement$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[ReverseElement]y"], 
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[DoubleLeftRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Iff$TM, {}]],
        SyntaxForm->"x\[DoubleLeftRightArrow]y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["B", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
         TagBox["\[ReverseElement]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`ReverseElement$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[ReverseElement]y"], 
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]}], 
        TagBox[")",
         "AutoParentheses"]}]}],
      TheoremaForm],
     Selectable->True], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<\[Element] def\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010119647084*^9, 3.765010136789083*^9}},
 CellID->2068471703,ExpressionUUID->"164d5119-d0ad-48b4-8494-243d9263257c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7650101404545317`*^9, 3.76501014955691*^9}},
 CellID->113823749,ExpressionUUID->"e1fee2be-f4f9-4b5f-b69a-5af0ab0c2927"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Equal] iff SET)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[597, 21, 372, 11, 19, "ProofText",ExpressionUUID->"510f0156-760f-4067-8ced-fb2ebc26b6f0",
 CellID->446769120],
Cell[972, 34, 236, 4, 42, "ProofText",ExpressionUUID->"520eaee9-ecc6-4635-97fe-6bc409f0c372",
 CellID->921551091],
Cell[1211, 40, 593, 16, 19, "ProofText",ExpressionUUID->"bfba5b85-e36d-461a-9bdf-488399a4a60f",
 CellID->2059686531],
Cell[1807, 58, 260, 5, 19, "ProofText",ExpressionUUID->"12c95620-decf-4bf4-b980-5e6bfa55829f",
 CellID->199768328],
Cell[2070, 65, 221, 4, 19, "ProofText",ExpressionUUID->"2c21296d-708c-4644-bbcc-6451bdbe415c",
 CellID->1319417245],
Cell[2294, 71, 3033, 81, 29, "ProofText",ExpressionUUID->"ca430d5b-95ac-406c-8477-db4d7c465aa2",
 CellID->1856834927],
Cell[5330, 154, 704, 20, 42, "ProofText",ExpressionUUID->"a884fa29-fc4e-4f5b-8de5-bd2997fcc81f",
 CellID->1368590631],
Cell[6037, 176, 423, 11, 19, "ProofText",ExpressionUUID->"eec6ab92-0bf0-40bf-9af2-48a2ff12c436",
 CellID->2072981662],
Cell[6463, 189, 1017, 33, 19, "ProofText",ExpressionUUID->"113c0eff-37f6-4e0b-9081-b3cd7b880e15",
 CellID->1007174840],
Cell[7483, 224, 2500, 67, 19, "ProofText",ExpressionUUID->"164d5119-d0ad-48b4-8494-243d9263257c",
 CellID->2068471703],
Cell[9986, 293, 368, 8, 42, "ProofText",ExpressionUUID->"e1fee2be-f4f9-4b5f-b69a-5af0ab0c2927",
 CellID->113823749]
}
]
*)

