(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8465,        252]
NotebookOptionsPosition[      6586,        211]
NotebookOutlinePosition[      7194,        231]
CellTagsIndexPosition[      7151,        228]
WindowTitle->Proof of (\:22C2 greatest)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082488395553*^9, 3.7650824964770823`*^9}},
 CellID->409832741,ExpressionUUID->"6749be1c-2f00-4323-83c0-33c8590e3b85"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082501708446*^9, 3.765082526385633*^9}},
 CellID->340458117,ExpressionUUID->"e8cc66f6-cd2c-489a-a84a-0f66c8205fcc"],

Cell[BoxData[
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm], "\[SubsetEqual]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[Intersection]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082530851172*^9, 3.765082546561537*^9}},
 CellID->570161807,ExpressionUUID->"86c70d36-6c20-470a-b39c-665ec2539342"],

Cell[BoxData[
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
   "intro", " ", "\"\<\[SubsetEqual]I\>\"", " ", "\"\<\[Intersection]I\>\""}],
    ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765020461510435*^9, 3.765020507778887*^9}, {
  3.7650825490818*^9, 3.765082549545416*^9}},
 CellID->353411904,ExpressionUUID->"320902f7-02f0-44a1-8e5a-626dd92d992b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082561826681*^9, 3.765082566628346*^9}},
 CellID->83481164,ExpressionUUID->"51017217-165f-4925-adc7-a8911715e96c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082569194995*^9, 3.76508258326724*^9}},
 CellID->2051090814,ExpressionUUID->"c4adfb16-9443-4bb7-95f9-ceaab9bccf6d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765082586922007*^9, 3.765082623200563*^9}},
 CellID->2043310142,ExpressionUUID->"576dba63-7f11-42e8-a22b-fe40e6c94faf"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082626553934*^9, 3.765082628664299*^9}},
 CellID->2124119304,ExpressionUUID->"274c41b8-67e4-4911-9f53-7cf2076a2902"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082561826681*^9, 3.765082566628346*^9}, 
   3.765082638121861*^9},
 CellID->1804380179,ExpressionUUID->"c5a0dc40-4f0e-4877-b9c6-b63de6b805e5"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["y", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765082569194995*^9, 3.76508258326724*^9}, 
   3.765082639845381*^9},
 CellID->1547228060,ExpressionUUID->"26249fb9-32cf-4723-9a60-d440e89aa22f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765082586922007*^9, 3.765082649354086*^9}},
 CellID->2109833612,ExpressionUUID->"db2b272c-50a3-42f9-ba54-209cd0c4db96"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765082651969532*^9, 3.765082653672027*^9}},
 CellID->1186667670,ExpressionUUID->"090b49ce-9506-4148-b3bd-bfeefbf57d9b"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Intersection] greatest)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 445, 14, 19, "ProofText",ExpressionUUID->"6749be1c-2f00-4323-83c0-33c8590e3b85",
 CellID->409832741],
Cell[1046, 37, 725, 21, 19, "ProofText",ExpressionUUID->"e8cc66f6-cd2c-489a-a84a-0f66c8205fcc",
 CellID->340458117],
Cell[1774, 60, 553, 16, 19, "ProofText",ExpressionUUID->"86c70d36-6c20-470a-b39c-665ec2539342",
 CellID->570161807],
Cell[2330, 78, 379, 9, 19, "ProofText",ExpressionUUID->"320902f7-02f0-44a1-8e5a-626dd92d992b",
 CellID->353411904],
Cell[2712, 89, 319, 9, 19, "ProofText",ExpressionUUID->"51017217-165f-4925-adc7-a8911715e96c",
 CellID->83481164],
Cell[3034, 100, 494, 14, 19, "ProofText",ExpressionUUID->"c4adfb16-9443-4bb7-95f9-ceaab9bccf6d",
 CellID->2051090814],
Cell[3531, 116, 819, 24, 19, "ProofText",ExpressionUUID->"576dba63-7f11-42e8-a22b-fe40e6c94faf",
 CellID->2043310142],
Cell[4353, 142, 220, 4, 19, "ProofText",ExpressionUUID->"274c41b8-67e4-4911-9f53-7cf2076a2902",
 CellID->2124119304],
Cell[4576, 148, 347, 10, 19, "ProofText",ExpressionUUID->"c5a0dc40-4f0e-4877-b9c6-b63de6b805e5",
 CellID->1804380179],
Cell[4926, 160, 520, 15, 19, "ProofText",ExpressionUUID->"26249fb9-32cf-4723-9a60-d440e89aa22f",
 CellID->1547228060],
Cell[5449, 177, 819, 24, 19, "ProofText",ExpressionUUID->"db2b272c-50a3-42f9-ba54-209cd0c4db96",
 CellID->2109833612],
Cell[6271, 203, 311, 6, 20, "ProofText",ExpressionUUID->"090b49ce-9506-4148-b3bd-bfeefbf57d9b",
 CellID->1186667670]
}
]
*)

