(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      6128,        193]
NotebookOptionsPosition[      4792,        155]
NotebookOutlinePosition[      5397,        175]
CellTagsIndexPosition[      5354,        172]
WindowTitle->Proof of (\:2286 trans)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730612211716984*^9, 3.7306122221809797`*^9}},
 CellID->888311073,ExpressionUUID->"eea82d5e-80a5-491a-9e91-f11589e74c11"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.73061222462182*^9, 3.730612249717198*^9}},
 CellID->1888919931,ExpressionUUID->"14fbf9f5-f870-4bf0-add6-b8b3a13c19d4"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[SubsetEqual]", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7306122540093527`*^9, 3.730612267386372*^9}},
 CellID->685401819,ExpressionUUID->"3c0bf891-b86e-4ab0-b3af-5978461e460d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.73061227028688*^9, 3.730612275025069*^9}},
 CellID->1938434355,ExpressionUUID->"50460804-d49e-4ce9-92fc-9619623f7c3e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730612276888743*^9, 3.730612289998466*^9}},
 CellID->1733782849,ExpressionUUID->"2e28383b-d4d2-4a6a-9a07-fd1fd8eb229d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.730612295418481*^9, 3.730612356979279*^9}},
 CellID->818989593,ExpressionUUID->"43e152fa-dc29-46f0-be63-79a545283c9a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.730612368707427*^9, 3.730612379485634*^9}},
 CellID->1073403718,ExpressionUUID->"949b5e27-f4c7-4522-b30c-2de6cce96520"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual] trans)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 445, 14, 20, "ProofText", "ExpressionUUID" -> \
"eea82d5e-80a5-491a-9e91-f11589e74c11",
 CellID->888311073],
Cell[1043, 37, 725, 21, 20, "ProofText", "ExpressionUUID" -> \
"14fbf9f5-f870-4bf0-add6-b8b3a13c19d4",
 CellID->1888919931],
Cell[1771, 60, 461, 12, 39, "ProofText", "ExpressionUUID" -> \
"3c0bf891-b86e-4ab0-b3af-5978461e460d",
 CellID->685401819],
Cell[2235, 74, 320, 9, 20, "ProofText", "ExpressionUUID" -> \
"50460804-d49e-4ce9-92fc-9619623f7c3e",
 CellID->1938434355],
Cell[2558, 85, 495, 14, 20, "ProofText", "ExpressionUUID" -> \
"2e28383b-d4d2-4a6a-9a07-fd1fd8eb229d",
 CellID->1733782849],
Cell[3056, 101, 818, 24, 18, "ProofText", "ExpressionUUID" -> \
"43e152fa-dc29-46f0-be63-79a545283c9a",
 CellID->818989593],
Cell[3877, 127, 911, 26, 19, "ProofText", "ExpressionUUID" -> \
"949b5e27-f4c7-4522-b30c-2de6cce96520",
 CellID->1073403718]
}
]
*)

