(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9191,        269]
NotebookOptionsPosition[      7846,        231]
NotebookOutlinePosition[      8456,        251]
CellTagsIndexPosition[      8413,        248]
WindowTitle->Proof of (\:2286E classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["x", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7305481733173523`*^9, 3.730548182096896*^9}},
 CellID->1968998219,ExpressionUUID->"b9397ff7-4ec2-404c-a8b7-d69869707e45"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        
        TagBox["\[NotElement]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`NotElement$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[NotElement]y"], 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[LongRightArrow]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
       SyntaxForm->"x\[LongRightArrow]y"], 
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<rule\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       TagBox["\[Element]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x\[Element]y"], 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
         TagBox["\[Element]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
          SyntaxForm->"x\[Element]y"], 
         TagBox[
          StyleBox["B", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["\[LongRightArrow]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
        SyntaxForm->"x\[LongRightArrow]y"], 
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`BOOL$TM]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730548187932475*^9, 3.7305482210440273`*^9}, {
  3.7305483827893057`*^9, 3.730548385134733*^9}},
 CellID->2031476884,ExpressionUUID->"8c342c64-5799-4929-a2d5-4490bea946f7"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  FormBox[
   StyleBox["P", "ExpressionABF"],
   TheoremaForm]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730548225963511*^9, 3.730548238112939*^9}},
 CellID->99062534,ExpressionUUID->"379ff53d-69c2-465d-98c4-1bd6cbccfdb3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730548243117581*^9, 3.7305482631164293`*^9}},
 CellID->896021866,ExpressionUUID->"51539b9a-4866-4421-86c0-4946348d0b4a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.730548278518076*^9, 3.73054832544628*^9}},
 CellID->1470615982,ExpressionUUID->"c4dcce6a-0549-4b5e-994b-bfc2fa9b8ae4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<rule\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7305483289457817`*^9, 3.730548339134139*^9}, {
  3.730548387374057*^9, 3.730548387766698*^9}},
 CellID->1986407017,ExpressionUUID->"cc7f0cb2-8e91-48e1-86c0-ea9454bda8c2"],

Cell[BoxData[
 RowBox[{"qed", " ", "fact"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7305483432548923`*^9, 3.73054837900657*^9}},
 CellID->2051655095,ExpressionUUID->"1d790741-2ee1-4ef4-aa34-ff4726fa3c4e"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual]E classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 519, 17, 20, "ProofText", "ExpressionUUID" -> \
"b9397ff7-4ec2-404c-a8b7-d69869707e45",
 CellID->1968998219],
Cell[1122, 40, 4291, 117, 20, "ProofText", "ExpressionUUID" -> \
"8c342c64-5799-4929-a2d5-4490bea946f7",
 CellID->2031476884],
Cell[5416, 159, 381, 10, 39, "ProofText", "ExpressionUUID" -> \
"379ff53d-69c2-465d-98c4-1bd6cbccfdb3",
 CellID->99062534],
Cell[5800, 171, 494, 14, 20, "ProofText", "ExpressionUUID" -> \
"51539b9a-4866-4421-86c0-4946348d0b4a",
 CellID->896021866],
Cell[6297, 187, 835, 24, 18, "ProofText", "ExpressionUUID" -> \
"c4dcce6a-0549-4b5e-994b-bfc2fa9b8ae4",
 CellID->1470615982],
Cell[7135, 213, 391, 8, 18, "ProofText", "ExpressionUUID" -> \
"cc7f0cb2-8e91-48e1-86c0-ea9454bda8c2",
 CellID->1986407017],
Cell[7529, 223, 313, 6, 19, "ProofText", "ExpressionUUID" -> \
"1d790741-2ee1-4ef4-aa34-ff4726fa3c4e",
 CellID->2051655095]
}
]
*)

