(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16904,        484]
NotebookOptionsPosition[     14911,        441]
NotebookOutlinePosition[     15497,        461]
CellTagsIndexPosition[     15454,        458]
WindowTitle->Proof of (@-)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651046519449244`*^9, 3.765104660929267*^9}},
 CellID->1853781343,ExpressionUUID->"2d77ad60-d2b1-4d9e-9609-8a48787a78b6"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
        TagBox["@",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
         SyntaxForm->"x@y"], 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["-",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Subtract$TM, {
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]],
       SyntaxForm->"x-y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
        TagBox["@",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
         SyntaxForm->"x@y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      TagBox["@",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
       SyntaxForm->"x@y"], 
      RowBox[{"(", 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["-",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Subtract$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
         SyntaxForm->"x-y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], ")"}]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651046653048983`*^9, 3.765104719805203*^9}},
 CellID->409260187,ExpressionUUID->"7ec39711-95d7-4cf8-ace0-d02268a6cc3a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
          TagBox["@",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
           SyntaxForm->"x@y"], 
          TagBox[
           StyleBox["A", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["-",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Subtract$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]],
         SyntaxForm->"x-y"], 
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
          TagBox["@",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
           SyntaxForm->"x@y"], 
          TagBox[
           StyleBox["B", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
         TagBox[")",
          "AutoParentheses"]}]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104727111038*^9, 3.7651047484168367`*^9}},
 CellID->1235594466,ExpressionUUID->"82f9d1b1-57df-40fa-90d7-e6ff574f46b9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "@", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "@", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   SuperscriptBox["simp", "+"]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104756518284*^9, 3.765104800420342*^9}},
 CellID->1236604286,ExpressionUUID->"d451cf59-94db-43ef-99fe-859a5138148e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
    " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<x\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104807526157*^9, 3.765104842447529*^9}, {
  3.765104906092513*^9, 3.765104908139285*^9}},
 CellID->929098966,ExpressionUUID->"31c555f8-b019-44fa-8833-0e605036f779"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104893932773*^9, 3.765104914819128*^9}},
 CellID->1004793976,ExpressionUUID->"c1591590-081d-4602-b3a5-8b5214a56d45"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104916708452*^9, 3.765104927990725*^9}},
 CellID->1911057171,ExpressionUUID->"d7d45d52-bb73-42fa-a7e5-187e6880605f"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<x\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104934860156*^9, 3.765104955738611*^9}},
 CellID->1192555977,ExpressionUUID->"c2038dd1-f26d-49d1-98ee-9ddec867fcad"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765104961531176*^9, 3.765104986078101*^9}},
 CellID->1907944888,ExpressionUUID->"e89df104-fd57-47e1-9511-765b3e6d066a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651049883636312`*^9, 3.765104991178409*^9}},
 CellID->1488346187,ExpressionUUID->"5b5460e7-3f01-4d7f-a20a-0907964422ec"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm], "-", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765105000163108*^9, 3.765105029993541*^9}},
 CellID->1861270750,ExpressionUUID->"934678a7-b407-47fd-bb95-d2ea68637ba1"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<x\>\"", " ", "show", " ", "_"}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765105033667019*^9, 3.765105038993557*^9}},
 CellID->523722424,ExpressionUUID->"7e923637-88fd-469d-959b-25d909a0968f"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765105041458867*^9, 3.765105043489502*^9}},
 CellID->41821414,ExpressionUUID->"6b8570e1-a7f1-452d-b02d-b054e7b5eab5"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (@-)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 446, 14, 19, "ProofText",ExpressionUUID->"2d77ad60-d2b1-4d9e-9609-8a48787a78b6",
 CellID->1853781343],
Cell[1034, 37, 4530, 118, 42, "ProofText",ExpressionUUID->"7ec39711-95d7-4cf8-ace0-d02268a6cc3a",
 CellID->409260187],
Cell[5567, 157, 3147, 85, 19, "ProofText",ExpressionUUID->"82f9d1b1-57df-40fa-90d7-e6ff574f46b9",
 CellID->1235594466],
Cell[8717, 244, 972, 30, 19, "ProofText",ExpressionUUID->"d451cf59-94db-43ef-99fe-859a5138148e",
 CellID->1236604286],
Cell[9692, 276, 1153, 35, 19, "ProofText",ExpressionUUID->"31c555f8-b019-44fa-8833-0e605036f779",
 CellID->929098966],
Cell[10848, 313, 516, 15, 42, "ProofText",ExpressionUUID->"c1591590-081d-4602-b3a5-8b5214a56d45",
 CellID->1004793976],
Cell[11367, 330, 470, 13, 19, "ProofText",ExpressionUUID->"d7d45d52-bb73-42fa-a7e5-187e6880605f",
 CellID->1911057171],
Cell[11840, 345, 641, 19, 19, "ProofText",ExpressionUUID->"c2038dd1-f26d-49d1-98ee-9ddec867fcad",
 CellID->1192555977],
Cell[12484, 366, 698, 20, 19, "ProofText",ExpressionUUID->"e89df104-fd57-47e1-9511-765b3e6d066a",
 CellID->1907944888],
Cell[13185, 388, 240, 5, 19, "ProofText",ExpressionUUID->"5b5460e7-3f01-4d7f-a20a-0907964422ec",
 CellID->1488346187],
Cell[13428, 395, 868, 27, 19, "ProofText",ExpressionUUID->"934678a7-b407-47fd-bb95-d2ea68637ba1",
 CellID->1861270750],
Cell[14299, 424, 296, 7, 19, "ProofText",ExpressionUUID->"7e923637-88fd-469d-959b-25d909a0968f",
 CellID->523722424],
Cell[14598, 433, 309, 6, 20, "ProofText",ExpressionUUID->"6b8570e1-a7f1-452d-b02d-b054e7b5eab5",
 CellID->41821414]
}
]
*)

