(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5321,        154]
NotebookOptionsPosition[      4279,        127]
NotebookOutlinePosition[      4873,        147]
CellTagsIndexPosition[      4830,        144]
WindowTitle->Proof of (\:2282D)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765014980819173*^9, 3.76501499267198*^9}},
 CellID->1817308914,ExpressionUUID->"fa602a20-7394-41dd-b0de-a29786475645"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[Subset]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Subset$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[Subset]y"], 
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015051360358*^9, 3.76501505965003*^9}},
 CellID->129536996,ExpressionUUID->"d9f8d4c3-a26a-42d3-b329-db0ca6212a36"],

Cell[BoxData[
 RowBox[{"hence", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[SubsetEqual]", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<\[Subset] def\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015075120075*^9, 3.765015098297516*^9}},
 CellID->1135415496,ExpressionUUID->"7006a7e2-2bca-481f-93f0-956c56f9bae1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"moreover", " ", "assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["a", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     TagBox["\[Element]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[Element]y"], 
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76501506787297*^9, 3.765015072471595*^9}, {
  3.765015102591071*^9, 3.765015104519272*^9}},
 CellID->175919199,ExpressionUUID->"a8e020be-2e42-4891-b8ad-4410ca9cc06b"],

Cell[BoxData[
 RowBox[{"ultimately", " ", "show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], "\[Element]", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7650151092324543`*^9, 3.765015172125576*^9}},
 CellID->1620117941,ExpressionUUID->"83fe092c-dc75-439e-8ee6-70f281e76689"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Subset]D)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 443, 14, 19, "ProofText",ExpressionUUID->"fa602a20-7394-41dd-b0de-a29786475645",
 CellID->1817308914],
Cell[1036, 37, 991, 25, 19, "ProofText",ExpressionUUID->"d9f8d4c3-a26a-42d3-b329-db0ca6212a36",
 CellID->129536996],
Cell[2030, 64, 571, 16, 19, "ProofText",ExpressionUUID->"7006a7e2-2bca-481f-93f0-956c56f9bae1",
 CellID->1135415496],
Cell[2604, 82, 1023, 25, 19, "ProofText",ExpressionUUID->"a8e020be-2e42-4891-b8ad-4410ca9cc06b",
 CellID->175919199],
Cell[3630, 109, 645, 16, 20, "ProofText",ExpressionUUID->"83fe092c-dc75-439e-8ee6-70f281e76689",
 CellID->1620117941]
}
]
*)

