(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9351,        272]
NotebookOptionsPosition[      8071,        241]
NotebookOutlinePosition[      8661,        261]
CellTagsIndexPosition[      8618,        258]
WindowTitle->Proof of (@ mono)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", "assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270809348131*^9, 3.765270840537232*^9}},
 CellID->1688078030,ExpressionUUID->"ff8f649a-cfa8-4e39-aefe-714cecc27b11"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      TagBox["@",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
       SyntaxForm->"x@y"], 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
      TagBox["@",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
       SyntaxForm->"x@y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76527081958703*^9, 3.765270853552977*^9}},
 CellID->1180808920,ExpressionUUID->"07a34f2d-468c-4408-bf60-60d51a7a5b7a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       
       TagBox["@",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
        SyntaxForm->"x@y"], 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270856282546*^9, 3.765270873236154*^9}},
 CellID->1176540220,ExpressionUUID->"429e2140-2fa3-4f17-900d-6c615be8fc67"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    "\"\<x\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
    ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652708748981733`*^9, 3.7652709075801477`*^9}},
 CellID->597252789,ExpressionUUID->"02f6c0e9-61dc-41d9-9907-fbd3d63ac55e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", 
    RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
    " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765270911473583*^9, 3.7652709652876596`*^9}},
 CellID->2018893974,ExpressionUUID->"23c96076-e934-4c03-a1c2-d876a6b7db5b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<x\>\"", " ", "show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270970496489*^9, 3.765271047030657*^9}, {
  3.7652710835106897`*^9, 3.765271108808793*^9}},
 CellID->1040932802,ExpressionUUID->"e088cb7b-2f51-48ab-8776-b3158f8b836b"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.76527099716866*^9, 3.765270998695344*^9}},
 CellID->1311491610,ExpressionUUID->"1f77747d-9d3d-4a99-995e-4a430dbbc538"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (@ mono)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 702, 22, 19, "ProofText",ExpressionUUID->"ff8f649a-cfa8-4e39-aefe-714cecc27b11",
 CellID->1688078030],
Cell[1294, 45, 2477, 64, 42, "ProofText",ExpressionUUID->"07a34f2d-468c-4408-bf60-60d51a7a5b7a",
 CellID->1180808920],
Cell[3774, 111, 1406, 37, 19, "ProofText",ExpressionUUID->"429e2140-2fa3-4f17-900d-6c615be8fc67",
 CellID->1176540220],
Cell[5183, 150, 1021, 32, 19, "ProofText",ExpressionUUID->"02f6c0e9-61dc-41d9-9907-fbd3d63ac55e",
 CellID->597252789],
Cell[6207, 184, 854, 25, 19, "ProofText",ExpressionUUID->"23c96076-e934-4c03-a1c2-d876a6b7db5b",
 CellID->2018893974],
Cell[7064, 211, 690, 20, 19, "ProofText",ExpressionUUID->"e088cb7b-2f51-48ab-8776-b3158f8b836b",
 CellID->1040932802],
Cell[7757, 233, 310, 6, 20, "ProofText",ExpressionUUID->"1f77747d-9d3d-4a99-995e-4a430dbbc538",
 CellID->1311491610]
}
]
*)

