(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15127,        430]
NotebookOptionsPosition[     12531,        377]
NotebookOutlinePosition[     13139,        397]
CellTagsIndexPosition[     13096,        394]
WindowTitle->Proof of (\:2286 singleton)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096482661059*^9, 3.765096488325385*^9}},
 CellID->1687425991,ExpressionUUID->"a35191d6-c308-4a96-9d8c-5186310d7f84"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096492252613*^9, 3.7650964947789993`*^9}},
 CellID->762694816,ExpressionUUID->"7d6b1e64-8792-4fd3-bfb9-01bd397884ae"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      TagBox[
       RowBox[{"{", 
        TagBox[
         StyleBox["a", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "}"}],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`EMPTY$TM, {
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650965042533903`*^9, 3.76509650999524*^9}},
 CellID->855585010,ExpressionUUID->"c3e3cc22-2a26-4945-81ad-055f4036c391"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
         SyntaxForm->"x\[Equal]y"], 
        TagBox["\[EmptySet]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`EMPTY$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Or]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Or$TM, {}]],
       SyntaxForm->"x\[Or]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[Equal]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
         SyntaxForm->"x\[Equal]y"], 
        TagBox[
         RowBox[{"{", 
          TagBox[
           StyleBox["a", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "}"}],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`EMPTY$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096517532078*^9, 3.765096522722664*^9}, {
  3.765096559994339*^9, 3.7650965653783417`*^9}},
 CellID->581954539,ExpressionUUID->"3cb48b0f-2b11-4e00-b1fa-dd1a5b22e8d6"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096567572035*^9, 3.7650965788696537`*^9}},
 CellID->321753165,ExpressionUUID->"f7c3f508-d460-4cb7-b2d8-948debc05c8b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{"{", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "}"}], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<\[SubsetEqual] def\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096589851397*^9, 3.76509662456948*^9}},
 CellID->1632228792,ExpressionUUID->"9bd528eb-9f41-4cfa-894b-4f7176435c51"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      RowBox[{"{", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "}"}]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{"{", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "}"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096630970931*^9, 3.765096661393117*^9}},
 CellID->1127117277,ExpressionUUID->"b4f759fd-874c-461a-ae32-256377e4d349"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096666202536*^9, 3.765096678704917*^9}},
 CellID->1474094737,ExpressionUUID->"c02af30c-2fff-432b-9c8a-bcee39a72da3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096681547743*^9, 3.765096684280916*^9}},
 CellID->1194615977,ExpressionUUID->"52818939-8339-4701-8e0c-3949d6842266"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76509668654615*^9, 3.765096699172217*^9}},
 CellID->60210991,ExpressionUUID->"bb46ebbc-609a-47c5-a676-40051d28d123"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      RowBox[{"{", "}"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096738825242*^9, 3.765096752751635*^9}},
 CellID->2048929763,ExpressionUUID->"dac0934a-5f5f-40b2-bc5b-97af13229d4b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650967552174177`*^9, 3.765096775090745*^9}},
 CellID->1830758219,ExpressionUUID->"bb489168-5006-4fe1-8385-c4a499f8dc0b"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     RowBox[{"{", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "}"}]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{"{", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "}"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765096777704981*^9, 3.7650968100552263`*^9}},
 CellID->963739496,ExpressionUUID->"430afe96-8c03-466f-9b60-c538b7aa4dde"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", "_", " ", 
   "by", " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650968227683897`*^9, 3.765096863565102*^9}},
 CellID->217709674,ExpressionUUID->"006a9f41-e5a7-4e9b-a41f-4bc53eb82bdf"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096867519272*^9, 3.76509688356914*^9}},
 CellID->1971167053,ExpressionUUID->"a806ce14-7fc0-4834-9bd2-d29303bf4142"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{
   "from", " ", "this", " ", "\"\<{}\[SubsetEqual]\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{"{", "}"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096894271709*^9, 3.7650969362250967`*^9}},
 CellID->1626611042,ExpressionUUID->"ef516aab-acbf-465d-9e8e-8db25fba20d4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Or]I1\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765096939247116*^9, 3.765096949941614*^9}},
 CellID->767099869,ExpressionUUID->"be23de2f-a6fb-4609-a295-35d3c4e22493"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"qed", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"elim", " ", "\"\<\[Or]E\>\""}], ",", " ", "simp", ",", " ", 
     "simp"}], ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765096952150929*^9, 3.765096999324666*^9}},
 CellID->1434111687,ExpressionUUID->"5494e89b-e1a2-4bf7-8bf5-68089e4c80fc"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual] singleton)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 371, 11, 19, "ProofText",ExpressionUUID->"a35191d6-c308-4a96-9d8c-5186310d7f84",
 CellID->1687425991],
Cell[973, 34, 236, 4, 42, "ProofText",ExpressionUUID->"7d6b1e64-8792-4fd3-bfb9-01bd397884ae",
 CellID->762694816],
Cell[1212, 40, 1262, 33, 19, "ProofText",ExpressionUUID->"c3e3cc22-2a26-4945-81ad-055f4036c391",
 CellID->855585010],
Cell[2477, 75, 2694, 73, 42, "ProofText",ExpressionUUID->"3cb48b0f-2b11-4e00-b1fa-dd1a5b22e8d6",
 CellID->581954539],
Cell[5174, 150, 498, 14, 19, "ProofText",ExpressionUUID->"f7c3f508-d460-4cb7-b2d8-948debc05c8b",
 CellID->321753165],
Cell[5675, 166, 637, 18, 19, "ProofText",ExpressionUUID->"9bd528eb-9f41-4cfa-894b-4f7176435c51",
 CellID->1632228792],
Cell[6315, 186, 827, 25, 19, "ProofText",ExpressionUUID->"b4f759fd-874c-461a-ae32-256377e4d349",
 CellID->1127117277],
Cell[7145, 213, 326, 7, 19, "ProofText",ExpressionUUID->"c02af30c-2fff-432b-9c8a-bcee39a72da3",
 CellID->1474094737],
Cell[7474, 222, 239, 5, 19, "ProofText",ExpressionUUID->"52818939-8339-4701-8e0c-3949d6842266",
 CellID->1194615977],
Cell[7716, 229, 497, 14, 19, "ProofText",ExpressionUUID->"bb46ebbc-609a-47c5-a676-40051d28d123",
 CellID->60210991],
Cell[8216, 245, 471, 13, 42, "ProofText",ExpressionUUID->"dac0934a-5f5f-40b2-bc5b-97af13229d4b",
 CellID->2048929763],
Cell[8690, 260, 589, 17, 19, "ProofText",ExpressionUUID->"bb489168-5006-4fe1-8385-c4a499f8dc0b",
 CellID->1830758219],
Cell[9282, 279, 882, 26, 19, "ProofText",ExpressionUUID->"430afe96-8c03-466f-9b60-c538b7aa4dde",
 CellID->963739496],
Cell[10167, 307, 777, 22, 19, "ProofText",ExpressionUUID->"006a9f41-e5a7-4e9b-a41f-4bc53eb82bdf",
 CellID->217709674],
Cell[10947, 331, 239, 5, 19, "ProofText",ExpressionUUID->"a806ce14-7fc0-4834-9bd2-d29303bf4142",
 CellID->1971167053],
Cell[11189, 338, 518, 14, 19, "ProofText",ExpressionUUID->"ef516aab-acbf-465d-9e8e-8db25fba20d4",
 CellID->1626611042],
Cell[11710, 354, 325, 7, 19, "ProofText",ExpressionUUID->"be23de2f-a6fb-4609-a295-35d3c4e22493",
 CellID->767099869],
Cell[12038, 363, 489, 12, 42, "ProofText",ExpressionUUID->"5494e89b-e1a2-4bf7-8bf5-68089e4c80fc",
 CellID->1434111687]
}
]
*)

