(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      5232,        166]
NotebookOptionsPosition[      4152,        134]
NotebookOutlinePosition[      4752,        154]
CellTagsIndexPosition[      4709,        151]
WindowTitle->Proof of (\:2286D)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730547904984172*^9, 3.730547911973536*^9}},
 CellID->914026725,ExpressionUUID->"389a0084-2807-4117-84ac-27914f854570"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7305479255719433`*^9, 3.7305479517402067`*^9}},
 CellID->580942129,ExpressionUUID->"591037ce-a5ea-45d8-8214-df70c65705f8"],

Cell[BoxData[
 RowBox[{"from", " ", 
  RowBox[{"this", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], " ",
   "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    UnderscriptBox["\[ForAll]", "x"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x", "\[Element]", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}], " ", "\[Implies]", " ", 
      RowBox[{"x", "\[Element]", 
       FormBox[
        StyleBox["B", "ExpressionABF"],
        TheoremaForm]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"only", ":", " ", "\"\<\[SubsetEqual] def\>\""}]}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.730547956950642*^9, 3.730548012193713*^9}},
 CellID->521572968,ExpressionUUID->"c24b1411-8115-449e-967e-f21f01c0466b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], " ", "\[Implies]", " ", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.730548023099245*^9, 3.730548046274494*^9}},
 CellID->315953008,ExpressionUUID->"7fbe5133-8402-40bb-b233-5fb0d990be18"],

Cell[BoxData[
 RowBox[{
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.730548052315876*^9, 3.730548076309141*^9}},
 CellID->1413679688,ExpressionUUID->"53c97635-272a-48e9-803d-831a34be63ba"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual]D)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 443, 14, 20, "ProofText", "ExpressionUUID" -> \
"389a0084-2807-4117-84ac-27914f854570",
 CellID->914026725],
Cell[1036, 37, 725, 21, 20, "ProofText", "ExpressionUUID" -> \
"591037ce-a5ea-45d8-8214-df70c65705f8",
 CellID->580942129],
Cell[1764, 60, 847, 23, 28, "ProofText", "ExpressionUUID" -> \
"c24b1411-8115-449e-967e-f21f01c0466b",
 CellID->521572968],
Cell[2614, 85, 703, 22, 18, "ProofText", "ExpressionUUID" -> \
"7fbe5133-8402-40bb-b233-5fb0d990be18",
 CellID->315953008],
Cell[3320, 109, 828, 23, 19, "ProofText", "ExpressionUUID" -> \
"53c97635-272a-48e9-803d-831a34be63ba",
 CellID->1413679688]
}
]
*)

