(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20587,        567]
NotebookOptionsPosition[     18000,        514]
NotebookOutlinePosition[     18600,        534]
CellTagsIndexPosition[     18557,        531]
WindowTitle->Proof of (Cantor's paradox)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["proof"], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731563687524102*^9, 3.7315637060935984`*^9}, {
  3.731563929288916*^9, 3.731563930820403*^9}},
 CellID->365771853,ExpressionUUID->"6a1b04e0-15bd-4da2-a85c-8a23167421ce"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]}]]], 
       TagBox[
        StyleBox["f", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]]], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
        TagBox[
         StyleBox["A", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]], 
       RowBox[{"(", 
        RowBox[{
         UnderscriptBox[
          TagBox["\[Exists]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
         RowBox[{
          TagBox[
           StyleBox["A", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
          TagBox["\[Equal]",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
              Theorema`Knowledge`SET$TM[
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
           SyntaxForm->"x\[Equal]y"], 
          RowBox[{
           TagBox[
            StyleBox["f", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
               Theorema`Knowledge`SET$TM[
                Theorema`Language`TFIX$[
                Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}]}], ")"}]}]}],
      "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731487049678977*^9, 3.731487065202533*^9}, 
   3.731491655368789*^9, {3.7315637130641003`*^9, 3.7315637418534484`*^9}, {
   3.7315639337741776`*^9, 3.731563944731528*^9}},
 CellID->377831645,ExpressionUUID->"3cd2917e-ee88-4266-8b58-87dc94e3ce0f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "::", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]_", "\[Rule]", 
        RowBox[{"{", "\[Alpha]_", "}"}]}], ")"}]}], "\[CloseCurlyQuote]"}], 
    " ", "where", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Forall$TM, {
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]]], 
       TagBox[
        StyleBox["A", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]], 
      RowBox[{"(", 
       RowBox[{
        UnderscriptBox[
         TagBox["\[Exists]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        RowBox[{
         TagBox[
          StyleBox["A", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
         TagBox["\[Equal]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
          SyntaxForm->"x\[Equal]y"], 
         RowBox[{
          FormBox[
           StyleBox["f", "ExpressionABF"],
           TheoremaForm], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}]}]}], ")"}]}], 
     "\[CloseCurlyQuote]"}], " ", ".."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731487068393903*^9, 3.73148709123029*^9}, {
   3.7314871829543433`*^9, 3.7314871999117885`*^9}, {3.731487332058201*^9, 
   3.7314873334752254`*^9}, 3.7314916562180524`*^9, {3.731563750856395*^9, 
   3.731563786759469*^9}, {3.7315639476548576`*^9, 3.7315639609239902`*^9}},
 CellID->155553160,ExpressionUUID->"a0e8d6bf-6085-4c37-a5cf-5f99605cab3c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"let", " ", 
    FormBox[
     StyleBox["X", "ExpressionSyntactic"],
     TheoremaForm], " ", "be", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"Collect", "[", 
      RowBox[{
       UnderscriptBox["\[Lambda]", "x"], 
       RowBox[{"(", 
        RowBox[{"x", "\[NotElement]", 
         RowBox[{
          FormBox[
           StyleBox["f", "ExpressionABF"],
           TheoremaForm], "[", "x", "]"}]}], ")"}]}], "]"}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731487244587942*^9, 3.731487316527341*^9}, 
   3.73149165709403*^9, 3.731563791838813*^9, 3.7315639633931465`*^9},
 CellID->152650973,ExpressionUUID->"c2dbe30e-5d8a-4eb0-a884-2fb13c23ca9a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"from", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      RowBox[{
       FormBox[
        StyleBox["X", "ExpressionSyntactic"],
        TheoremaForm], 
       TagBox["\[Equal]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
        SyntaxForm->"x\[Equal]y"], 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", 
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}]}]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314873371815944`*^9, 3.731487370572255*^9}, 
   3.731491657654146*^9},
 CellID->98251250,ExpressionUUID->"251159fa-9da8-4ab3-9474-0ce95dc72e30"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["X", "ExpressionSyntactic"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314873784628897`*^9, 3.731487402893485*^9}, {
   3.7314875650532503`*^9, 3.7314875666274223`*^9}, 3.731487712886527*^9, 
   3.7314916582026443`*^9},
 CellID->935697922,ExpressionUUID->"f2433588-c15e-4acf-b108-94e9ab1749c8"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"note", " ", "\"\<eq\>\""}], ":", " ", 
    RowBox[{"this", "[", "symmetric", "]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765008137711684*^9, 3.765008168286035*^9}},
 CellID->1367648857,ExpressionUUID->"28da010d-e8d4-43e2-8a60-4976dde7d90c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "\[Element]", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm], "]"}]}], ")"}], "\[DoubleLeftRightArrow]", 
      RowBox[{"(", 
       RowBox[{
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "\[NotElement]", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["x", "ExpressionABF"],
          TheoremaForm], "]"}]}], ")"}]}], "\[CloseCurlyQuote]"}]}], "\n", 
   "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314874545402527`*^9, 3.731487458362407*^9}, {
  3.7314875097704453`*^9, 3.7314875456580253`*^9}, {3.7314875761857367`*^9, 
  3.731487587206615*^9}, {3.731487747376442*^9, 3.731487762504182*^9}, {
  3.7314878297626753`*^9, 3.7314878328175077`*^9}, {3.731491659713709*^9, 
  3.731491660716292*^9}},
 CellID->122979231,ExpressionUUID->"fc24a04d-5856-4897-ba3a-db194ced327c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314878367776146`*^9, 3.731487854428107*^9}, 
   3.731491661515376*^9},
 CellID->338027768,ExpressionUUID->"03265b2f-98e8-404c-b7b2-cda21d56336e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["X", "ExpressionSyntactic"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<eq\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731487862934944*^9, 3.7314878844741096`*^9}, 
   3.731491662099391*^9},
 CellID->159868604,ExpressionUUID->"5b6ee609-cf0c-4a3f-a497-669eadab55db"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["X", "ExpressionSyntactic"],
      TheoremaForm], "\[ReverseElement]", 
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
   RowBox[{"\"\<\[Element] def\>\"", " ", "."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731487903434137*^9, 3.7314879391040573`*^9}, {
   3.731487974228836*^9, 3.731487974622079*^9}, {3.7314880056471157`*^9, 
   3.731488028932522*^9}, 3.7314916626697764`*^9},
 CellID->36640179,ExpressionUUID->"d5d4c086-2830-4f5e-acfe-c4776b04a5b0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<Collect inverse\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314880835124545`*^9, 3.7314881159881115`*^9}, 
   3.7314916635367413`*^9},
 CellID->193189654,ExpressionUUID->"f9903dbd-2239-4d7c-930c-750e99c50d84"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314881217584267`*^9, 3.7314881249067326`*^9}, 
   3.731491664501807*^9},
 CellID->50527935,ExpressionUUID->"4c6ec828-2b86-46d6-9d4a-fdd0062683b5"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314881268886166`*^9, 3.7314881464501953`*^9}, 
   3.731491665107089*^9},
 CellID->524014446,ExpressionUUID->"b81183f1-cf1c-4c12-956a-00914a081ef0"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[NotElement]", 
     FormBox[
      StyleBox["X", "ExpressionSyntactic"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<eq\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731488153445471*^9, 3.7314881796546836`*^9}, 
   3.7314916662997093`*^9},
 CellID->32167577,ExpressionUUID->"fa907f8f-8973-4611-ac09-9ba261757421"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", 
      RowBox[{"\"\<Collect inverse\>\"", " ", "\"\<\[Element] def\>\""}]}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7314881891667366`*^9, 3.7314882204394927`*^9}, 
   3.7314916672665453`*^9},
 CellID->131804129,ExpressionUUID->"d2a98a80-a70d-4b36-a6f8-8df9f04c9237"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.731488227171192*^9, 3.731488230589447*^9}, 
   3.731491668177249*^9},
 CellID->855803949,ExpressionUUID->"6c7a75a0-98da-4567-b993-6c6c20e0f70d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
    " ", "simp"}], "\n", 
   RowBox[{"(*", "qed", "*)"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7314882424579763`*^9, 3.731488255581664*^9}, {
  3.7314916688286104`*^9, 3.7314916762774467`*^9}},
 CellID->76721490,ExpressionUUID->"f3dec48c-c335-4a93-86f2-d3fd9245beec"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (Cantor's paradox)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 247, 4, 19, "ProofText",ExpressionUUID->"6a1b04e0-15bd-4da2-a85c-8a23167421ce",
 CellID->365771853],
Cell[849, 27, 3621, 89, 32, "ProofText",ExpressionUUID->"3cd2917e-ee88-4266-8b58-87dc94e3ce0f",
 CellID->377831645],
Cell[4473, 118, 2914, 75, 30, "ProofText",ExpressionUUID->"a0e8d6bf-6085-4c37-a5cf-5f99605cab3c",
 CellID->155553160],
Cell[7390, 195, 766, 21, 29, "ProofText",ExpressionUUID->"c2dbe30e-5d8a-4eb0-a884-2fb13c23ca9a",
 CellID->152650973],
Cell[8159, 218, 1536, 40, 26, "ProofText",ExpressionUUID->"251159fa-9da8-4ab3-9474-0ce95dc72e30",
 CellID->98251250],
Cell[9698, 260, 827, 24, 19, "ProofText",ExpressionUUID->"f2433588-c15e-4acf-b108-94e9ab1749c8",
 CellID->935697922],
Cell[10528, 286, 336, 8, 19, "ProofText",ExpressionUUID->"28da010d-e8d4-43e2-8a60-4976dde7d90c",
 CellID->1367648857],
Cell[10867, 296, 1314, 37, 42, "ProofText",ExpressionUUID->"fc24a04d-5856-4897-ba3a-db194ced327c",
 CellID->122979231],
Cell[12184, 335, 638, 20, 19, "ProofText",ExpressionUUID->"03265b2f-98e8-404c-b7b2-cda21d56336e",
 CellID->338027768],
Cell[12825, 357, 618, 17, 19, "ProofText",ExpressionUUID->"5b6ee609-cf0c-4a3f-a497-669eadab55db",
 CellID->159868604],
Cell[13446, 376, 681, 16, 19, "ProofText",ExpressionUUID->"d5d4c086-2830-4f5e-acfe-c4776b04a5b0",
 CellID->36640179],
Cell[14130, 394, 741, 22, 19, "ProofText",ExpressionUUID->"f9903dbd-2239-4d7c-930c-750e99c50d84",
 CellID->193189654],
Cell[14874, 418, 267, 6, 19, "ProofText",ExpressionUUID->"4c6ec828-2b86-46d6-9d4a-fdd0062683b5",
 CellID->50527935],
Cell[15144, 426, 643, 20, 19, "ProofText",ExpressionUUID->"b81183f1-cf1c-4c12-956a-00914a081ef0",
 CellID->524014446],
Cell[15790, 448, 622, 17, 19, "ProofText",ExpressionUUID->"fa907f8f-8973-4611-ac09-9ba261757421",
 CellID->32167577],
Cell[16415, 467, 786, 23, 19, "ProofText",ExpressionUUID->"d2a98a80-a70d-4b36-a6f8-8df9f04c9237",
 CellID->131804129],
Cell[17204, 492, 263, 6, 19, "ProofText",ExpressionUUID->"6c7a75a0-98da-4567-b993-6c6c20e0f70d",
 CellID->855803949],
Cell[17470, 500, 526, 12, 42, "ProofText",ExpressionUUID->"f3dec48c-c335-4a93-86f2-d3fd9245beec",
 CellID->76721490]
}
]
*)

