(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12628,        359]
NotebookOptionsPosition[     10752,        318]
NotebookOutlinePosition[     11350,        338]
CellTagsIndexPosition[     11307,        335]
WindowTitle->Proof of (\:22C3 least)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76508346040291*^9, 3.765083543692986*^9}, {
  3.765083635643276*^9, 3.7650836449257917`*^9}},
 CellID->367181659,ExpressionUUID->"4ae1b766-ae31-46f2-9469-e489564ca14d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083647404759*^9, 3.765083671540663*^9}},
 CellID->1552453272,ExpressionUUID->"c078be2d-3e52-4d35-83c6-f297b87909d6"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Union]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Union$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Union]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    TagBox[
     StyleBox["C", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Knowledge`SET$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083679181476*^9, 3.765083691970935*^9}},
 CellID->458889627,ExpressionUUID->"2ee7a3f4-47a1-45b9-b924-3a5ec8c737ba"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650836945640497`*^9, 3.765083699845139*^9}},
 CellID->343817315,ExpressionUUID->"2caea434-812b-4e45-8ffa-db98a8d4ef23"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[Union]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Union$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[Union]y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083701748036*^9, 3.765083711525949*^9}},
 CellID->1209349803,ExpressionUUID->"c870f873-4e50-4ff3-a9d1-c6c448c9062f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      TagBox[
       StyleBox["C", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083716131357*^9, 3.765083726098291*^9}},
 CellID->2006117687,ExpressionUUID->"d3df5a91-f17a-4bf9-bc4a-e29f92cc49f7"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083728491781*^9, 3.765083737276971*^9}},
 CellID->306167279,ExpressionUUID->"1bd8f1ca-4255-4e18-bfe3-25d1d5a0699b"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650837406357203`*^9, 3.7650837710818567`*^9}},
 CellID->248533825,ExpressionUUID->"2d79178c-eb98-47c1-b2d1-883f99aa946a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083773715137*^9, 3.765083776665763*^9}},
 CellID->769063340,ExpressionUUID->"792d65c0-e7db-4c02-992f-af90290499e9"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765083728491781*^9, 3.765083737276971*^9}, 
   3.765083788011224*^9},
 CellID->207610456,ExpressionUUID->"2d73e0cc-71d6-44e4-bbd5-98d92b538552"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650837406357203`*^9, 3.765083789849826*^9}},
 CellID->288260689,ExpressionUUID->"86f0bbc7-d317-4c61-908b-996aadaf3ba0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765083793915036*^9, 3.765083802049515*^9}},
 CellID->1864104092,ExpressionUUID->"d09cdab4-4bee-4756-981a-31985b21eac6"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Union] least)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 493, 15, 19, "ProofText",ExpressionUUID->"4ae1b766-ae31-46f2-9469-e489564ca14d",
 CellID->367181659],
Cell[1091, 38, 726, 21, 19, "ProofText",ExpressionUUID->"c078be2d-3e52-4d35-83c6-f297b87909d6",
 CellID->1552453272],
Cell[1820, 61, 1597, 43, 47, "ProofText",ExpressionUUID->"2ee7a3f4-47a1-45b9-b924-3a5ec8c737ba",
 CellID->458889627],
Cell[3420, 106, 322, 9, 19, "ProofText",ExpressionUUID->"2caea434-812b-4e45-8ffa-db98a8d4ef23",
 CellID->343817315],
Cell[3745, 117, 1661, 45, 25, "ProofText",ExpressionUUID->"c870f873-4e50-4ff3-a9d1-c6c448c9062f",
 CellID->1209349803],
Cell[5409, 164, 1023, 26, 42, "ProofText",ExpressionUUID->"d3df5a91-f17a-4bf9-bc4a-e29f92cc49f7",
 CellID->2006117687],
Cell[6435, 192, 1010, 26, 19, "ProofText",ExpressionUUID->"1bd8f1ca-4255-4e18-bfe3-25d1d5a0699b",
 CellID->306167279],
Cell[7448, 220, 824, 24, 19, "ProofText",ExpressionUUID->"2d79178c-eb98-47c1-b2d1-883f99aa946a",
 CellID->248533825],
Cell[8275, 246, 238, 5, 19, "ProofText",ExpressionUUID->"792d65c0-e7db-4c02-992f-af90290499e9",
 CellID->769063340],
Cell[8516, 253, 1036, 27, 19, "ProofText",ExpressionUUID->"2d73e0cc-71d6-44e4-bbd5-98d92b538552",
 CellID->207610456],
Cell[9555, 282, 822, 24, 19, "ProofText",ExpressionUUID->"86f0bbc7-d317-4c61-908b-996aadaf3ba0",
 CellID->288260689],
Cell[10380, 308, 368, 8, 42, "ProofText",ExpressionUUID->"d09cdab4-4bee-4756-981a-31985b21eac6",
 CellID->1864104092]
}
]
*)

