(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9047,        256]
NotebookOptionsPosition[      7293,        217]
NotebookOutlinePosition[      7892,        237]
CellTagsIndexPosition[      7849,        234]
WindowTitle->Proof of (@\:F431{} iff)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269547844009*^9, 3.765269552994795*^9}},
 CellID->1600339525,ExpressionUUID->"15c22c4a-3783-45d1-b2dd-4265f3682315"],

Cell[BoxData[
 RowBox[{"show", " ", "_", " ", "proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]I\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269387246092*^9, 3.765269424706925*^9}, {
  3.765269543497476*^9, 3.765269555161331*^9}},
 CellID->855688079,ExpressionUUID->"fd706c3e-d643-4ffb-9895-71e40d167a6a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<eq\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
        TagBox["@",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
         SyntaxForm->"x@y"], 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]}]],
       SyntaxForm->"x\[Equal]y"], 
      TagBox["\[EmptySet]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`EMPTY$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]]}],
      "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652695608987503`*^9, 3.765269571276301*^9}},
 CellID->1532479015,ExpressionUUID->"b79a9dcb-4f9b-417c-b44b-098e03ea6e7b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{"{", "}"}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<classical contradiction\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269575098053*^9, 3.765269594272707*^9}},
 CellID->1085883461,ExpressionUUID->"6634afcc-a527-455f-ab9d-8097403c8aa4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      RowBox[{"{", "}"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652695971381273`*^9, 3.765269608026763*^9}},
 CellID->354169925,ExpressionUUID->"b38b99b6-fc3b-44d0-a31f-691e9fc0ae21"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Exists]", "a"], 
     RowBox[{"a", "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<\[Exists]\[Element] conv\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269617105494*^9, 3.765269697279463*^9}},
 CellID->50667653,ExpressionUUID->"3b0fb975-53de-4711-a92c-f2ab95a5f232"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765269702008943*^9, 3.765269718930292*^9}},
 CellID->2084487172,ExpressionUUID->"c84481a4-969e-41dc-848b-745b0a9cdc09"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}], "\[Element]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "@", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<@I\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652697402883873`*^9, 3.765269763705723*^9}},
 CellID->2012663769,ExpressionUUID->"fa935096-bbf6-4466-8542-bd170b3d08b3"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<eq\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652697678799133`*^9, 3.765269777582511*^9}},
 CellID->1401003623,ExpressionUUID->"93a286cd-965f-4639-8e17-f73f85e2104f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269780945035*^9, 3.7652697855665007`*^9}},
 CellID->146440053,ExpressionUUID->"95e4d393-aa63-4fd8-b2bc-5460b49d8569"],

Cell[BoxData[
 RowBox[{"qed", " ", 
  RowBox[{"(", 
   RowBox[{"simp", " ", 
    RowBox[{"add", ":", " ", "\"\<@{}\>\""}]}], ")"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7652697879673557`*^9, 3.7652697948384113`*^9}},
 CellID->2017191999,ExpressionUUID->"796107b7-fb13-4d97-a9b5-00ecb3429b77"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (@\[Equal]{} iff)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 371, 11, 19, "ProofText",ExpressionUUID->"15c22c4a-3783-45d1-b2dd-4265f3682315",
 CellID->1600339525],
Cell[970, 34, 375, 8, 19, "ProofText",ExpressionUUID->"fd706c3e-d643-4ffb-9895-71e40d167a6a",
 CellID->855688079],
Cell[1348, 44, 1864, 46, 19, "ProofText",ExpressionUUID->"b79a9dcb-4f9b-417c-b44b-098e03ea6e7b",
 CellID->1532479015],
Cell[3215, 92, 571, 16, 42, "ProofText",ExpressionUUID->"6634afcc-a527-455f-ab9d-8097403c8aa4",
 CellID->1085883461],
Cell[3789, 110, 449, 12, 19, "ProofText",ExpressionUUID->"b38b99b6-fc3b-44d0-a31f-691e9fc0ae21",
 CellID->354169925],
Cell[4241, 124, 600, 16, 26, "ProofText",ExpressionUUID->"3b0fb975-53de-4711-a92c-f2ab95a5f232",
 CellID->50667653],
Cell[4844, 142, 608, 18, 19, "ProofText",ExpressionUUID->"c84481a4-969e-41dc-848b-745b0a9cdc09",
 CellID->2084487172],
Cell[5455, 162, 760, 23, 19, "ProofText",ExpressionUUID->"fa935096-bbf6-4466-8542-bd170b3d08b3",
 CellID->2012663769],
Cell[6218, 187, 421, 10, 19, "ProofText",ExpressionUUID->"93a286cd-965f-4639-8e17-f73f85e2104f",
 CellID->1401003623],
Cell[6642, 199, 239, 5, 19, "ProofText",ExpressionUUID->"95e4d393-aa63-4fd8-b2bc-5460b49d8569",
 CellID->146440053],
Cell[6884, 206, 405, 9, 20, "ProofText",ExpressionUUID->"796107b7-fb13-4d97-a9b5-00ecb3429b77",
 CellID->2017191999]
}
]
*)

