(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14903,        417]
NotebookOptionsPosition[     12791,        372]
NotebookOutlinePosition[     13388,        392]
CellTagsIndexPosition[     13345,        389]
WindowTitle->Proof of (\:2282 alt)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015356068981*^9, 3.7650153611652727`*^9}},
 CellID->1587169778,ExpressionUUID->"294a885e-5c20-402a-8e7c-d680a961d97d"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015370757242*^9, 3.765015373075903*^9}},
 CellID->33899901,ExpressionUUID->"d6e38d0c-99a0-4eaa-adca-b7bc516bd368"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Subset]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Subset$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Subset]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650153784383307`*^9, 3.7650154215399227`*^9}},
 CellID->1663195834,ExpressionUUID->"daed0aac-d59c-4cfd-85ba-4e4eab4a99f7"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[SubsetEqual]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[SubsetEqual]y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[NotEqual]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Unequal$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
         SyntaxForm->"x\[NotEqual]y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<\[Subset]E\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015389838235*^9, 3.765015431083158*^9}},
 CellID->762791163,ExpressionUUID->"fc9d21a2-cba2-4ffc-a10e-0225c93005e5"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[SubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[SubsetEqual]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[NotSubsetEqual]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`NotSubsetEqual$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[NotSubsetEqual]y"], 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650154443648243`*^9, 3.7650154660181723`*^9}},
 CellID->512922288,ExpressionUUID->"8ea23fb7-06b6-4fe9-a81d-a0383208877e"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"show", " ", "_"}], "\n", "\t\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"intro", " ", "\"\<\[And]I\>\"", " ", "\"\<\[Not]I\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015404988855*^9, 3.765015415019071*^9}, {
  3.76501547764218*^9, 3.765015497482477*^9}},
 CellID->1078051064,ExpressionUUID->"850facd4-1876-4a7b-b65b-ef3e18f76db1"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015503539624*^9, 3.765015521625772*^9}},
 CellID->872988972,ExpressionUUID->"464f5c75-09d0-4961-87df-6944f6b0d7ae"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76501552757121*^9, 3.765015623536159*^9}, {
  3.765510625873151*^9, 3.765510626289032*^9}},
 CellID->827493920,ExpressionUUID->"e62b6f68-5389-4e5b-b9a1-b89959e0a67c"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"qed", " ", "fact"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015626978244*^9, 3.765015629528129*^9}},
 CellID->1797564379,ExpressionUUID->"0db5db60-d21e-41d2-b457-7b672d94234a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "next", "*)"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015635025964*^9, 3.765015646336419*^9}},
 CellID->1071499078,ExpressionUUID->"1912e310-7bf5-4b98-afce-985c003f6ba4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[SubsetEqual]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
         
         SyntaxForm->"x\[SubsetEqual]y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}], 
      TagBox["\[And]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
       SyntaxForm->"x\[And]y"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
        TagBox["\[NotEqual]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Unequal$TM, {
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
         SyntaxForm->"x\[NotEqual]y"], 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015651057754*^9, 3.765015660967965*^9}},
 CellID->700097288,ExpressionUUID->"1a5f3f38-7bb1-4a3a-a3b0-26b42976f970"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[NotEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   SuperscriptBox["simp", "+"]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650156688015537`*^9, 3.765015728846883*^9}},
 CellID->1972948205,ExpressionUUID->"80156a13-acda-4eec-8a36-d03308dfd899"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[Subset]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Subset]I\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650157614721327`*^9, 3.765015786425831*^9}},
 CellID->1469422597,ExpressionUUID->"873aeb33-1701-4d00-8e68-1b89e6ac5436"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765015788262753*^9, 3.765015790046185*^9}},
 CellID->1094631338,ExpressionUUID->"43c9c724-23b3-44b7-aa9e-2018ec84d9be"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Subset] alt)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[593, 21, 373, 11, 19, "ProofText",ExpressionUUID->"294a885e-5c20-402a-8e7c-d680a961d97d",
 CellID->1587169778],
Cell[969, 34, 233, 4, 42, "ProofText",ExpressionUUID->"d6e38d0c-99a0-4eaa-adca-b7bc516bd368",
 CellID->33899901],
Cell[1205, 40, 1055, 28, 19, "ProofText",ExpressionUUID->"daed0aac-d59c-4cfd-85ba-4e4eab4a99f7",
 CellID->1663195834],
Cell[2263, 70, 2454, 68, 42, "ProofText",ExpressionUUID->"fc9d21a2-cba2-4ffc-a10e-0225c93005e5",
 CellID->762791163],
Cell[4720, 140, 1910, 50, 19, "ProofText",ExpressionUUID->"8ea23fb7-06b6-4fe9-a81d-a0383208877e",
 CellID->512922288],
Cell[6633, 192, 447, 11, 42, "ProofText",ExpressionUUID->"850facd4-1876-4a7b-b65b-ef3e18f76db1",
 CellID->1078051064],
Cell[7083, 205, 496, 14, 19, "ProofText",ExpressionUUID->"464f5c75-09d0-4961-87df-6944f6b0d7ae",
 CellID->872988972],
Cell[7582, 221, 678, 17, 19, "ProofText",ExpressionUUID->"e62b6f68-5389-4e5b-b9a1-b89959e0a67c",
 CellID->827493920],
Cell[8263, 240, 241, 5, 19, "ProofText",ExpressionUUID->"0db5db60-d21e-41d2-b457-7b672d94234a",
 CellID->1797564379],
Cell[8507, 247, 277, 6, 42, "ProofText",ExpressionUUID->"1912e310-7bf5-4b98-afce-985c003f6ba4",
 CellID->1071499078],
Cell[8787, 255, 2349, 66, 19, "ProofText",ExpressionUUID->"1a5f3f38-7bb1-4a3a-a3b0-26b42976f970",
 CellID->700097288],
Cell[11139, 323, 774, 22, 19, "ProofText",ExpressionUUID->"80156a13-acda-4eec-8a36-d03308dfd899",
 CellID->1972948205],
Cell[11916, 347, 557, 15, 19, "ProofText",ExpressionUUID->"873aeb33-1701-4d00-8e68-1b89e6ac5436",
 CellID->1469422597],
Cell[12476, 364, 311, 6, 20, "ProofText",ExpressionUUID->"43c9c724-23b3-44b7-aa9e-2018ec84d9be",
 CellID->1094631338]
}
]
*)

