(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10632,        307]
NotebookOptionsPosition[      8743,        266]
NotebookOutlinePosition[      9356,        286]
CellTagsIndexPosition[      9313,        283]
WindowTitle->Proof of (\:2286\:2282 trans)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["C", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650159292715683`*^9, 3.7650159368481293`*^9}},
 CellID->558702817,ExpressionUUID->"0635b913-c403-4818-beeb-d48fbfeaaa04"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[Subset]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[SubsetEqual]y"], 
     TagBox[
      StyleBox["C", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76501593867815*^9, 3.765015957796517*^9}, {
  3.7650166938929167`*^9, 3.7650166980593567`*^9}},
 CellID->1666708378,ExpressionUUID->"0e287520-9595-4c64-8543-466fcde42f4d"],

Cell[BoxData[
 RowBox[{"from", " ", 
  RowBox[{"this", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], " ",
   "have", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], "\[SubsetEqual]", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[Subset] implies \[SubsetEqual]\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015979053547*^9, 3.7650160131796913`*^9}, {
  3.765016136849577*^9, 3.765016142459134*^9}, {3.765016700756751*^9, 
  3.7650167056287117`*^9}},
 CellID->1694118313,ExpressionUUID->"5aab08ac-3a50-47b7-ba65-5081a1a9f4c2"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], "\[Subset]", 
    FormBox[
     StyleBox["C", "ExpressionABF"],
     TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765015961221858*^9, 3.765015973316264*^9}},
 CellID->363799804,ExpressionUUID->"75f4d09c-a420-4ae7-af4a-1e343b7c96f4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"from", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual] trans\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016020427916*^9, 3.765016071162709*^9}, {
  3.7650161507635813`*^9, 3.765016160867676*^9}},
 CellID->1139342672,ExpressionUUID->"8ddc4106-faf4-48d0-bd70-f29090210357"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016074011547*^9, 3.765016076035124*^9}},
 CellID->1030793600,ExpressionUUID->"0d58eac5-1d70-4cac-9628-a483a2645dfb"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[NotEqual]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], "\n", "\t", 
   "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650160791951447`*^9, 3.7650160926026707`*^9}},
 CellID->2137979828,ExpressionUUID->"202bbefb-981a-4730-8258-de6d54f1da86"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016096419463*^9, 3.765016109077479*^9}},
 CellID->604973979,ExpressionUUID->"901b45d3-1c7d-4e00-be30-41e578d2b221"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", "this", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016186778853*^9, 3.765016219633132*^9}, {
  3.76501673160423*^9, 3.76501674521999*^9}},
 CellID->456957849,ExpressionUUID->"e47fd246-bf52-43ec-abec-834370d103dc"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[SubsetEqual]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      FormBox[
       StyleBox["C", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650162251937733`*^9, 3.765016254096324*^9}, {
  3.765016750867975*^9, 3.765016756363983*^9}},
 CellID->835549568,ExpressionUUID->"ded09b4c-29ef-4f33-b77d-486c46d3d1d3"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[Subset]", 
     FormBox[
      StyleBox["C", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", "False", "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"add", ":", " ", "\"\<\[Subset] alt\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765016260050005*^9, 3.765016297360367*^9}, {
  3.765016598644514*^9, 3.765016647123947*^9}, {3.765016760339802*^9, 
  3.7650167620678673`*^9}},
 CellID->827325767,ExpressionUUID->"cdf67701-b7e8-4f73-9b8a-f56ba7595907"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"(*", "qed", "*)"}], "\n", 
  RowBox[{"(*", "qed", "*)"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.76501665131105*^9, 3.765016658627946*^9}},
 CellID->1721463590,ExpressionUUID->"404650c3-f98b-4046-b7e3-83492e2cc9f6"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual]\[Subset] trans)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 447, 14, 19, "ProofText",ExpressionUUID->"0635b913-c403-4818-beeb-d48fbfeaaa04",
 CellID->558702817],
Cell[1051, 37, 1310, 34, 19, "ProofText",ExpressionUUID->"0e287520-9595-4c64-8543-466fcde42f4d",
 CellID->1666708378],
Cell[2364, 73, 755, 19, 19, "ProofText",ExpressionUUID->"5aab08ac-3a50-47b7-ba65-5081a1a9f4c2",
 CellID->1694118313],
Cell[3122, 94, 454, 12, 42, "ProofText",ExpressionUUID->"75f4d09c-a420-4ae7-af4a-1e343b7c96f4",
 CellID->363799804],
Cell[3579, 108, 1125, 33, 19, "ProofText",ExpressionUUID->"8ddc4106-faf4-48d0-bd70-f29090210357",
 CellID->1139342672],
Cell[4707, 143, 220, 4, 19, "ProofText",ExpressionUUID->"0d58eac5-1d70-4cac-9628-a483a2645dfb",
 CellID->1030793600],
Cell[4930, 149, 518, 15, 42, "ProofText",ExpressionUUID->"202bbefb-981a-4730-8258-de6d54f1da86",
 CellID->2137979828],
Cell[5451, 166, 494, 14, 19, "ProofText",ExpressionUUID->"901b45d3-1c7d-4e00-be30-41e578d2b221",
 CellID->604973979],
Cell[5948, 182, 815, 23, 19, "ProofText",ExpressionUUID->"e47fd246-bf52-43ec-abec-834370d103dc",
 CellID->456957849],
Cell[6766, 207, 815, 24, 19, "ProofText",ExpressionUUID->"ded09b4c-29ef-4f33-b77d-486c46d3d1d3",
 CellID->835549568],
Cell[7584, 233, 785, 21, 19, "ProofText",ExpressionUUID->"cdf67701-b7e8-4f73-9b8a-f56ba7595907",
 CellID->827325767],
Cell[8372, 256, 367, 8, 42, "ProofText",ExpressionUUID->"404650c3-f98b-4046-b7e3-83492e2cc9f6",
 CellID->1721463590]
}
]
*)

