(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     21943,        589]
NotebookOptionsPosition[     20061,        548]
NotebookOutlinePosition[     20655,        568]
CellTagsIndexPosition[     20612,        565]
WindowTitle->Proof of (\:2203@)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["P", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76526985987199*^9, 3.765269867968103*^9}},
 CellID->573973656,ExpressionUUID->"605038c8-4414-475c-ae16-b9debfea0469"],

Cell[BoxData[{
 RowBox[{"show", " ", "_"}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<\[DoubleLeftRightArrow]I\>\""}], 
   ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765269875734696*^9, 3.7652698898450947`*^9}, {
  3.76527022473699*^9, 3.7652702423847637`*^9}},
 CellID->1056658407,ExpressionUUID->"64511697-c011-43a6-8ad7-47e644eaf678"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
       
       RowBox[{
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
        "\[Element]", 
        RowBox[{
         TagBox[
          StyleBox["f", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
         TagBox["@",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
          
          SyntaxForm->"x@y"], 
         TagBox[
          StyleBox["A", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
       "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270256290082*^9, 3.765270262872292*^9}},
 CellID->1198890897,ExpressionUUID->"2b0bc4c4-f8e6-4fbe-a15e-fb1162892b5e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     RowBox[{"(", 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
         "\[Element]", 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
          TagBox["@",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
           SyntaxForm->"x@y"], 
          TagBox[
           StyleBox["A", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]}]], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{"\[Not]", 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]],
           "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270265689981*^9, 3.765270283568028*^9}},
 CellID->370042889,ExpressionUUID->"00e25772-3527-4bf4-b7d6-0e81b61f5fc0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     RowBox[{"(", 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
         "\[Element]", 
         TagBox[
          StyleBox["A", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{"\[Not]", 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          RowBox[{
           FormBox[
            StyleBox["f", "ExpressionABF"],
            TheoremaForm], "[", 
           TagBox[
            StyleBox["x", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], "]"}], "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<\[ForAll]@\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652702897857313`*^9, 3.765270320999888*^9}},
 CellID->1274974142,ExpressionUUID->"87bf2588-b3b5-473e-bae4-6c2eaa08f603"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
      
      RowBox[{
       TagBox[
        StyleBox["a", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "\[Element]", 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
       "[", 
       TagBox[
        StyleBox["a", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
       "]"}], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652703363290586`*^9, 3.7652703423595037`*^9}},
 CellID->651746774,ExpressionUUID->"aaf6097e-9c8e-4e96-b678-64e9436967d1"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76527005605238*^9, 3.7652700587550592`*^9}},
 CellID->67746720,ExpressionUUID->"c686b741-49c6-4551-815c-e15f36efaac3"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox[
       TagBox["\[Exists]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
       RowBox[{
        TagBox[
         StyleBox["a", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "\[Element]", 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]], 
      RowBox[{
       TagBox[
        StyleBox["P", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
           Theorema`Knowledge`BOOL$TM]]]], "[", 
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]],
         "[", 
        TagBox[
         StyleBox["a", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        "]"}], "]"}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270256290082*^9, 3.765270262872292*^9}, 
   3.7652703629714127`*^9},
 CellID->1902521904,ExpressionUUID->"0a37ee32-d840-4d17-9e02-60ffeffc600c"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     RowBox[{"(", 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
        RowBox[{
         TagBox[
          StyleBox["a", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]],
          "\[Element]", 
         TagBox[
          StyleBox["A", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Knowledge`SET$TM[
             Theorema`Language`TFIX$[
             Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{"\[Not]", 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          RowBox[{
           TagBox[
            StyleBox["f", "ExpressionABF"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`FUN$TM[
               Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
               Theorema`Language`TFIX$[
               Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], "[", 
           TagBox[
            StyleBox["a", "ExpressionVariable"],
            Theorema`Language`TAG$[
             Theorema`Language`TYPED$[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], "]"}], "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", 
   " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765270265689981*^9, 3.765270283568028*^9}, {
  3.765270368283318*^9, 3.7652703792635*^9}},
 CellID->213373955,ExpressionUUID->"15fd216c-31e3-442f-a58d-057e3ee79cc6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Not]", 
     RowBox[{"(", 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
        RowBox[{
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
         "\[Element]", 
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
          TagBox["@",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
              
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
           SyntaxForm->"x@y"], 
          TagBox[
           StyleBox["A", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Knowledge`SET$TM[
              Theorema`Language`TFIX$[
              Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]}]], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{"\[Not]", 
         RowBox[{
          TagBox[
           StyleBox["P", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`FUN$TM[
              Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
              Theorema`Knowledge`BOOL$TM]]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]],
           "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], ")"}]}], "\[CloseCurlyQuote]"}], " ", "by", 
   " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<\[ForAll]@\>\""}]}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652702897857313`*^9, 3.765270320999888*^9}, 
   3.7652703888460083`*^9},
 CellID->1005916699,ExpressionUUID->"b26c346c-527c-4ec2-9799-2cb6fe187d13"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox[
      TagBox["\[Exists]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Exists$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]]], 
      RowBox[{
       TagBox[
        StyleBox["x", "ExpressionVariable"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
       "\[Element]", 
       RowBox[{
        TagBox[
         StyleBox["f", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]]], 
        TagBox["@",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
            Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]}]],
         SyntaxForm->"x@y"], 
        TagBox[
         StyleBox["A", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}]}]], 
     RowBox[{
      TagBox[
       StyleBox["P", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0], 
          Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionVariable"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Beta]$TM, 0]]]], 
      "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652703363290586`*^9, 3.7652703423595037`*^9}, 
   3.765270397753392*^9},
 CellID->1953189558,ExpressionUUID->"25e13a6b-a1a3-4eb5-924d-ddf1f06d7b92"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765270191530796*^9, 3.765270193393283*^9}},
 CellID->1274262502,ExpressionUUID->"5aa25207-3f90-4b8b-a724-ba2c6b8b0016"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[Exists]@)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 442, 14, 19, "ProofText",ExpressionUUID->"605038c8-4414-475c-ae16-b9debfea0469",
 CellID->573973656],
Cell[1035, 37, 394, 9, 42, "ProofText",ExpressionUUID->"64511697-c011-43a6-8ad7-47e644eaf678",
 CellID->1056658407],
Cell[1432, 48, 2280, 58, 28, "ProofText",ExpressionUUID->"2b0bc4c4-f8e6-4fbe-a15e-fb1162892b5e",
 CellID->1198890897],
Cell[3715, 108, 2572, 66, 33, "ProofText",ExpressionUUID->"00e25772-3527-4bf4-b7d6-0e81b61f5fc0",
 CellID->370042889],
Cell[6290, 176, 2083, 57, 30, "ProofText",ExpressionUUID->"87bf2588-b3b5-473e-bae4-6c2eaa08f603",
 CellID->1274974142],
Cell[8376, 235, 1916, 51, 27, "ProofText",ExpressionUUID->"aaf6097e-9c8e-4e96-b678-64e9436967d1",
 CellID->651746774],
Cell[10295, 288, 219, 4, 19, "ProofText",ExpressionUUID->"c686b741-49c6-4551-815c-e15f36efaac3",
 CellID->67746720],
Cell[10517, 294, 1971, 51, 27, "ProofText",ExpressionUUID->"0a37ee32-d840-4d17-9e02-60ffeffc600c",
 CellID->1902521904],
Cell[12491, 347, 2303, 60, 30, "ProofText",ExpressionUUID->"15fd216c-31e3-442f-a58d-057e3ee79cc6",
 CellID->213373955],
Cell[14797, 409, 2708, 71, 33, "ProofText",ExpressionUUID->"b26c346c-527c-4ec2-9799-2cb6fe187d13",
 CellID->1005916699],
Cell[17508, 482, 2235, 56, 28, "ProofText",ExpressionUUID->"25e13a6b-a1a3-4eb5-924d-ddf1f06d7b92",
 CellID->1953189558],
Cell[19746, 540, 311, 6, 20, "ProofText",ExpressionUUID->"5aa25207-3f90-4b8b-a724-ba2c6b8b0016",
 CellID->1274262502]
}
]
*)

