(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      8966,        258]
NotebookOptionsPosition[      7450,        223]
NotebookOutlinePosition[      8045,        243]
CellTagsIndexPosition[      8002,        240]
WindowTitle->Proof of (Insert mono)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["B", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271384741194*^9, 3.765271409586319*^9}},
 CellID->1173875858,ExpressionUUID->"5cc3ad3f-4a94-41fc-b568-a3e234214c3e"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["Insert",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     "[", 
     RowBox[{
      TagBox[
       StyleBox["a", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      ",", 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}], 
    TagBox["\[SubsetEqual]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[SubsetEqual]y"], 
    RowBox[{
     TagBox["Insert",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     "[", 
     RowBox[{
      TagBox[
       StyleBox["a", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      ",", 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271412267651*^9, 3.7652714213698893`*^9}},
 CellID->829529964,ExpressionUUID->"0a7e7c43-3908-4d71-9e9d-12a742361d71"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{"Insert", "[", 
       RowBox[{
        FormBox[
         StyleBox["a", "ExpressionABF"],
         TheoremaForm], ",", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271423611451*^9, 3.76527144291708*^9}},
 CellID->188669488,ExpressionUUID->"8edade7c-b271-489d-ac79-ef9ccae05e5b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"thus", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      RowBox[{
       TagBox["Insert",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]],
        "[", 
       RowBox[{
        TagBox[
         StyleBox["a", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
        ",", 
        TagBox[
         StyleBox["B", "ExpressionABF"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Knowledge`SET$TM[
            Theorema`Language`TFIX$[
            Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271445755281*^9, 3.765271455489223*^9}},
 CellID->301366352,ExpressionUUID->"9d0ecebf-d1d3-408c-a93a-4db547d455c4"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7652714579150677`*^9, 3.765271478828463*^9}},
 CellID->1481276738,ExpressionUUID->"72a81b0e-7ca8-43c3-8695-bf06f06956fb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{
   RowBox[{"with", " ", "\"\<*\>\"", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["B", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], " ", ".."}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7652714821465054`*^9, 3.765271498499671*^9}},
 CellID->2091191393,ExpressionUUID->"84d74713-3436-474b-865a-71fd369aa3bb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<InsertI2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.76527150206631*^9, 3.765271511777214*^9}},
 CellID->514740307,ExpressionUUID->"73e9d2a5-3d26-476a-854a-16be57bc028e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"qed", " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765271514113459*^9, 3.7652715169527607`*^9}},
 CellID->339709790,ExpressionUUID->"76b178e4-0bda-459e-bb4e-3fb65be4867c"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765271520530266*^9, 3.765271522120826*^9}},
 CellID->1896897303,ExpressionUUID->"7c742571-6c4d-4d67-bd98-612707a7cecf"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (Insert mono)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 748, 23, 19, "ProofText",ExpressionUUID->"5cc3ad3f-4a94-41fc-b568-a3e234214c3e",
 CellID->1173875858],
Cell[1345, 46, 1926, 52, 42, "ProofText",ExpressionUUID->"0a7e7c43-3908-4d71-9e9d-12a742361d71",
 CellID->829529964],
Cell[3274, 100, 734, 23, 19, "ProofText",ExpressionUUID->"8edade7c-b271-489d-ac79-ef9ccae05e5b",
 CellID->188669488],
Cell[4011, 125, 1509, 39, 42, "ProofText",ExpressionUUID->"9d0ecebf-d1d3-408c-a93a-4db547d455c4",
 CellID->301366352],
Cell[5523, 166, 499, 14, 19, "ProofText",ExpressionUUID->"72a81b0e-7ca8-43c3-8695-bf06f06956fb",
 CellID->1481276738],
Cell[6025, 182, 536, 15, 19, "ProofText",ExpressionUUID->"84d74713-3436-474b-865a-71fd369aa3bb",
 CellID->2091191393],
Cell[6564, 199, 325, 7, 19, "ProofText",ExpressionUUID->"73e9d2a5-3d26-476a-854a-16be57bc028e",
 CellID->514740307],
Cell[6892, 208, 240, 5, 19, "ProofText",ExpressionUUID->"76b178e4-0bda-459e-bb4e-3fb65be4867c",
 CellID->339709790],
Cell[7135, 215, 311, 6, 20, "ProofText",ExpressionUUID->"7c742571-6c4d-4d67-bd98-612707a7cecf",
 CellID->1896897303]
}
]
*)

