(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7405,        215]
NotebookOptionsPosition[      5885,        180]
NotebookOutlinePosition[      6486,        200]
CellTagsIndexPosition[      6443,        197]
WindowTitle->Proof of (InsertI classical)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "\[NotElement]", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}], ")"}], "\[LongRightArrow]", 
     RowBox[{"(", 
      RowBox[{
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "\[Equal]", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm]}], ")"}]}], "\[CloseCurlyQuote]"}]}], 
  ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093384396879*^9, 3.765093428308921*^9}},
 CellID->534173760,ExpressionUUID->"3034c508-fa30-45b6-88e1-1a00ad627910"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    TagBox[
     StyleBox["x", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
    TagBox["\[Element]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
     SyntaxForm->"x\[Element]y"], 
    RowBox[{
     TagBox["Insert",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Insert$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]]], 
     "[", 
     RowBox[{
      TagBox[
       StyleBox["a", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      ",", 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], "]"}]}], 
   "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093439307238*^9, 3.765093508473092*^9}},
 CellID->906736046,ExpressionUUID->"6b405e9d-0cbc-4659-9bfc-22b9ff2577c9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093511577876*^9, 3.765093522907505*^9}},
 CellID->2126641250,ExpressionUUID->"24842adc-2580-4d11-8e3d-56c03c04ae1f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<InsertI2\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093525281835*^9, 3.7650935337843447`*^9}},
 CellID->1125418302,ExpressionUUID->"7a328010-a272-4983-9813-d00266d84add"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093537704835*^9, 3.76509354132825*^9}},
 CellID->436368269,ExpressionUUID->"eb654513-bd80-4c03-8533-ef7276702f11"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[NotElement]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093544785593*^9, 3.765093555994864*^9}},
 CellID->1162451602,ExpressionUUID->"b73c0282-3072-4cac-8efd-972ba3fd85a4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<*\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765093558993374*^9, 3.765093582871707*^9}},
 CellID->1556395231,ExpressionUUID->"2ddc5f0a-2c65-4da0-b9ef-813b7e9b06c2"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", "_", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<InsertI1'\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650935761311502`*^9, 3.765093592279422*^9}},
 CellID->278578672,ExpressionUUID->"355e2ce5-54a8-40ff-a48c-4c2abaaf60c5"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7650935944568367`*^9, 3.765093596007666*^9}},
 CellID->492304289,ExpressionUUID->"845e2bb3-b2c3-4e07-b943-5590e0fca5b6"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (InsertI classical)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 1040, 34, 19, "ProofText",ExpressionUUID->"3034c508-fa30-45b6-88e1-1a00ad627910",
 CellID->534173760],
Cell[1643, 57, 1494, 40, 42, "ProofText",ExpressionUUID->"6b405e9d-0cbc-4659-9bfc-22b9ff2577c9",
 CellID->906736046],
Cell[3140, 99, 495, 14, 19, "ProofText",ExpressionUUID->"24842adc-2580-4d11-8e3d-56c03c04ae1f",
 CellID->2126641250],
Cell[3638, 115, 327, 7, 19, "ProofText",ExpressionUUID->"7a328010-a272-4983-9813-d00266d84add",
 CellID->1125418302],
Cell[3968, 124, 218, 4, 19, "ProofText",ExpressionUUID->"eb654513-bd80-4c03-8533-ef7276702f11",
 CellID->436368269],
Cell[4189, 130, 498, 14, 19, "ProofText",ExpressionUUID->"b73c0282-3072-4cac-8efd-972ba3fd85a4",
 CellID->1162451602],
Cell[4690, 146, 546, 15, 19, "ProofText",ExpressionUUID->"2ddc5f0a-2c65-4da0-b9ef-813b7e9b06c2",
 CellID->1556395231],
Cell[5239, 163, 327, 7, 19, "ProofText",ExpressionUUID->"355e2ce5-54a8-40ff-a48c-4c2abaaf60c5",
 CellID->278578672],
Cell[5569, 172, 312, 6, 20, "ProofText",ExpressionUUID->"845e2bb3-b2c3-4e07-b943-5590e0fca5b6",
 CellID->492304289]
}
]
*)

