(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11055,        317]
NotebookOptionsPosition[      9421,        280]
NotebookOutlinePosition[     10014,        300]
CellTagsIndexPosition[      9971,        297]
WindowTitle->Proof of (@ ident I)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["f", "ExpressionABF"],
     TheoremaForm], " ", 
    FormBox[
     StyleBox["A", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", "\"\<*\>\""}], ":", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[And]", "a"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "\[Element]", 
        FormBox[
         StyleBox["A", "ExpressionABF"],
         TheoremaForm]}], ")"}], "\[LongRightArrow]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", "a", "]"}], "\[Equal]", "a"}], ")"}]}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765102356773307*^9, 3.7651023908294773`*^9}},
 CellID->1823954601,ExpressionUUID->"aad9868e-21dd-47ae-9e1a-29e23cdf862d"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{
    RowBox[{
     TagBox["(",
      "AutoParentheses"], 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`FUN$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["@",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x@y"], 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     TagBox[")",
      "AutoParentheses"]}], 
    TagBox["\[Equal]",
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
     SyntaxForm->"x\[Equal]y"], 
    TagBox[
     StyleBox["A", "ExpressionABF"],
     Theorema`Language`TAG$[
      Theorema`Language`TYPED$[
       Theorema`Knowledge`SET$TM[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
   "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
   "intro", " ", "\"\<\[SubsetEqual] antisym\>\"", " ", 
    "\"\<\[SubsetEqual]I\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765102396395249*^9, 3.765102466745306*^9}},
 CellID->968347504,ExpressionUUID->"7920f6b4-c3fd-49cb-9a7d-239ad5d43e41"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "@", 
       FormBox[
        StyleBox["A", "ExpressionABF"],
        TheoremaForm]}]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651024715704327`*^9, 3.765102498237072*^9}},
 CellID->730000361,ExpressionUUID->"6ef451f9-a80f-481b-beb4-2cd45994f5c4"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "where", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["x", "ExpressionABF"],
       TheoremaForm], "\[Equal]", 
      RowBox[{
       FormBox[
        StyleBox["f", "ExpressionABF"],
        TheoremaForm], "[", 
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}]}], " ", 
   ".."}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765102500578074*^9, 3.7651025414596853`*^9}, {
  3.765102796524843*^9, 3.765102796653211*^9}},
 CellID->2063132279,ExpressionUUID->"e925883d-0dd1-405b-8576-5a08aebbdc15"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"thus", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<*\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765102548361517*^9, 3.7651025826667843`*^9}},
 CellID->1634219308,ExpressionUUID->"13e194fc-2d5f-4e93-b0a1-55d171647160"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765102587256309*^9, 3.7651025892795153`*^9}},
 CellID->806893562,ExpressionUUID->"730b7d0b-efb5-4a8d-af7d-568d3474b20b"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["a", "ExpressionABF"],
     TheoremaForm], " ", "assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "\[Element]", 
      FormBox[
       StyleBox["A", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765102590542351*^9, 3.7651026137384253`*^9}},
 CellID->1814336939,ExpressionUUID->"947d388e-363b-415f-936b-58d4534bc906"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"moreover", " ", "from", " ", "this", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["a", "ExpressionABF"],
      TheoremaForm], "\[Equal]", 
     RowBox[{
      FormBox[
       StyleBox["f", "ExpressionABF"],
       TheoremaForm], "[", 
      FormBox[
       StyleBox["a", "ExpressionABF"],
       TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", " ", 
     RowBox[{"only", ":", " ", "\"\<*\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651026224166327`*^9, 3.765102645522398*^9}},
 CellID->106059338,ExpressionUUID->"d587e5e5-9633-4b25-b9a4-023ee8fc5535"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"ultimately", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["a", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
     TagBox["\[Element]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[Element]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`FUN$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
       TagBox["@",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Componentwise$TM, {
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0], 
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
        SyntaxForm->"x@y"], 
       TagBox[
        StyleBox["A", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[
           Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<@I eq reverse\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7651026483680897`*^9, 3.7651026714623632`*^9}},
 CellID->427368670,ExpressionUUID->"80995c6a-1a39-465c-8b6a-bccfee326ad6"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765102673215941*^9, 3.765102675046535*^9}},
 CellID->500112767,ExpressionUUID->"682e58d5-1b4a-4f23-9ca0-db1d6064f8ab"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (@ ident I)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 916, 28, 26, "ProofText",ExpressionUUID->"aad9868e-21dd-47ae-9e1a-29e23cdf862d",
 CellID->1823954601],
Cell[1511, 51, 1902, 51, 42, "ProofText",ExpressionUUID->"7920f6b4-c3fd-49cb-9a7d-239ad5d43e41",
 CellID->968347504],
Cell[3416, 104, 689, 21, 19, "ProofText",ExpressionUUID->"6ef451f9-a80f-481b-beb4-2cd45994f5c4",
 CellID->730000361],
Cell[4108, 127, 1026, 31, 19, "ProofText",ExpressionUUID->"e925883d-0dd1-405b-8576-5a08aebbdc15",
 CellID->2063132279],
Cell[5137, 160, 583, 16, 19, "ProofText",ExpressionUUID->"13e194fc-2d5f-4e93-b0a1-55d171647160",
 CellID->1634219308],
Cell[5723, 178, 221, 4, 19, "ProofText",ExpressionUUID->"730b7d0b-efb5-4a8d-af7d-568d3474b20b",
 CellID->806893562],
Cell[5947, 184, 585, 17, 19, "ProofText",ExpressionUUID->"947d388e-363b-415f-936b-58d4534bc906",
 CellID->1814336939],
Cell[6535, 203, 729, 20, 19, "ProofText",ExpressionUUID->"d587e5e5-9633-4b25-b9a4-023ee8fc5535",
 CellID->106059338],
Cell[7267, 225, 1837, 45, 19, "ProofText",ExpressionUUID->"80995c6a-1a39-465c-8b6a-bccfee326ad6",
 CellID->427368670],
Cell[9107, 272, 310, 6, 20, "ProofText",ExpressionUUID->"682e58d5-1b4a-4f23-9ca0-db1d6064f8ab",
 CellID->500112767]
}
]
*)

