(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10765,        303]
NotebookOptionsPosition[      9003,        264]
NotebookOutlinePosition[      9609,        284]
CellTagsIndexPosition[      9566,        281]
WindowTitle->Proof of (\:2286 antisym)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["A", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["B", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010213630877*^9, 3.765010219501751*^9}},
 CellID->1114650490,ExpressionUUID->"a84dcbcc-9892-4c48-8434-b72565ada3c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[SubsetEqual]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[SubsetEqual]y"], 
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}], " ", "and", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["B", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
     TagBox["\[SubsetEqual]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`SubsetEqual$TM, {
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
      SyntaxForm->"x\[SubsetEqual]y"], 
     TagBox[
      StyleBox["A", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
        Theorema`Knowledge`SET$TM[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010222165502*^9, 3.7650102375564957`*^9}},
 CellID->1298825738,ExpressionUUID->"5415435d-4895-43c6-b4fb-8421b86aafb3"],

Cell[BoxData[{
 RowBox[{"show", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   StyleBox[
    FormBox[
     RowBox[{
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]], 
      
      TagBox["\[Equal]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Equal$TM, {
          Theorema`Knowledge`SET$TM[
           Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]}]],
       
       SyntaxForm->"x\[Equal]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}],
     TheoremaForm],
    Selectable->True], "\[CloseCurlyQuote]"}], " ", "unfolding", " ", 
  "\"\<\[Equal] iff SET\>\""}], "\n", 
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{
   "intro", " ", "\"\<\[ForAll]I\>\"", " ", 
    "\"\<\[DoubleLeftRightArrow]I\>\""}], ")"}]}]}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650102437332287`*^9, 3.765010264011469*^9}, {
  3.765010306522543*^9, 3.765010322722824*^9}},
 CellID->1023665859,ExpressionUUID->"df380f2e-5299-44dd-b8ba-3ecff2e0fb5e"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010267773093*^9, 3.765010272121894*^9}},
 CellID->354208326,ExpressionUUID->"d94dfbdc-6bd1-47b9-90e2-55b8787ad2fc"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      TagBox[
       StyleBox["A", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650103388755817`*^9, 3.765010345234408*^9}},
 CellID->182206418,ExpressionUUID->"7ee86a85-12a9-4f7d-858c-5b6efd1ee909"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["x", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.7650103508037577`*^9, 3.765010384170245*^9}},
 CellID->1192571393,ExpressionUUID->"e24da0dc-d208-4d94-a20a-87e2f0081410"],

Cell[BoxData[
 RowBox[{"(*", "next", "*)"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010387595478*^9, 3.765010389961905*^9}},
 CellID->1902288196,ExpressionUUID->"2f5784b1-f1c3-4f7c-be12-cbc147146657"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["y", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7650103920673323`*^9, 3.7650104144021873`*^9}},
 CellID->130880117,ExpressionUUID->"9c2d74e5-1fdb-458d-8110-1ff75881004a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox[
       StyleBox["y", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]], 
      TagBox["\[Element]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Element$TM, {
          Theorema`Language`TFIX$[Theorema`Knowledge`VAR$\[Alpha]$TM, 0]}]],
       SyntaxForm->"x\[Element]y"], 
      TagBox[
       StyleBox["B", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Knowledge`SET$TM[
          Theorema`Language`TFIX$[
          Theorema`Knowledge`VAR$\[Alpha]$TM, 0]]]]]}], 
     "\[CloseCurlyQuote]"}]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.765010421860195*^9, 3.765010428993627*^9}},
 CellID->375317780,ExpressionUUID->"372dc569-58e6-4e38-9659-5801e4cd4d12"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["B", "ExpressionABF"],
      TheoremaForm], "\[SubsetEqual]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["y", "ExpressionABF"],
      TheoremaForm], "\[Element]", 
     FormBox[
      StyleBox["A", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[SubsetEqual]D\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.765010438449202*^9, 3.765010444650778*^9}},
 CellID->683849770,ExpressionUUID->"827c5236-0017-4568-ab3a-311af1e37d55"],

Cell[BoxData[
 RowBox[{"(*", "qed", "*)"}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.765010446667006*^9, 3.7650104488330717`*^9}},
 CellID->59279898,ExpressionUUID->"27a0d0b7-6f31-43d7-8a5a-781ac2a1899d"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (\[SubsetEqual] antisym)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[597, 21, 371, 11, 19, "ProofText",ExpressionUUID->"a84dcbcc-9892-4c48-8434-b72565ada3c5",
 CellID->1114650490],
Cell[971, 34, 1802, 45, 19, "ProofText",ExpressionUUID->"5415435d-4895-43c6-b4fb-8421b86aafb3",
 CellID->1298825738],
Cell[2776, 81, 1367, 37, 42, "ProofText",ExpressionUUID->"df380f2e-5299-44dd-b8ba-3ecff2e0fb5e",
 CellID->1023665859],
Cell[4146, 120, 320, 9, 19, "ProofText",ExpressionUUID->"d94dfbdc-6bd1-47b9-90e2-55b8787ad2fc",
 CellID->354208326],
Cell[4469, 131, 1010, 26, 19, "ProofText",ExpressionUUID->"7ee86a85-12a9-4f7d-858c-5b6efd1ee909",
 CellID->182206418],
Cell[5482, 159, 821, 24, 19, "ProofText",ExpressionUUID->"e24da0dc-d208-4d94-a20a-87e2f0081410",
 CellID->1192571393],
Cell[6306, 185, 220, 4, 19, "ProofText",ExpressionUUID->"2f5784b1-f1c3-4f7c-be12-cbc147146657",
 CellID->1902288196],
Cell[6529, 191, 324, 9, 19, "ProofText",ExpressionUUID->"9c2d74e5-1fdb-458d-8110-1ff75881004a",
 CellID->130880117],
Cell[6856, 202, 1008, 26, 19, "ProofText",ExpressionUUID->"372dc569-58e6-4e38-9659-5801e4cd4d12",
 CellID->375317780],
Cell[7867, 230, 818, 24, 19, "ProofText",ExpressionUUID->"827c5236-0017-4568-ab3a-311af1e37d55",
 CellID->683849770],
Cell[8688, 256, 311, 6, 20, "ProofText",ExpressionUUID->"27a0d0b7-6f31-43d7-8a5a-781ac2a1899d",
 CellID->59279898]
}
]
*)

