(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     80012,       1897]
NotebookOptionsPosition[     29925,        795]
NotebookOutlinePosition[     74338,       1750]
CellTagsIndexPosition[     73717,       1731]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Minimal Core Theory", "Title",
 CellChangeTimes->{{3.730437817763541*^9, 3.730437822923644*^9}, 
   3.73043805292661*^9},
 CellID->789857065,ExpressionUUID->"58d70843-36f7-4a42-ae16-484f4d2b76b5"],

Cell["\<\
Alexander Maletzky, RISC, JKU Linz
March 28, 2018\
\>", "Subsubtitle",
 CellChangeTimes->{{3.730437827867491*^9, 3.730437839907885*^9}, {
  3.731227859112377*^9, 3.731227859360071*^9}},
 CellID->1318729276,ExpressionUUID->"3168374c-85fd-441a-9aa7-0de95f54b390"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Theorema`Core`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.730438042934276*^9, 3.7304380495701036`*^9}},
 CellID->2081197628,ExpressionUUID->"384caccc-29e0-452e-8ee9-0936291d2387"],

Cell[CellGroupData[{

Cell["Bootstrapping", "Section",
 CellChangeTimes->{{3.730449691027795*^9, 3.730449693420102*^9}},
 CellID->412313213,ExpressionUUID->"e993874c-d88f-4d3f-af04-ede89511bab0"],

Cell[BoxData[
 RowBox[{"LoadFile", "[", " ", "\"\<$Minimal/init.m\>\"", "]"}]], "Code",
 CellChangeTimes->{{3.7304602666956244`*^9, 3.730460276624412*^9}},
 CellID->114623714,ExpressionUUID->"54149d81-4ddd-4a15-a88b-234768e58895"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RegisterTheory", "[", " ", "\"\<$Minimal\>\"", "]"}], 
  ";"}]], "Code",
 CellChangeTimes->{{3.730449665652561*^9, 3.730449674372587*^9}, {
   3.7304589063530703`*^9, 3.730458921327121*^9}, 3.730458977391234*^9, {
   3.730459732337853*^9, 3.7304597329161797`*^9}, 3.7304602868177*^9},
 CellID->398607118,ExpressionUUID->"564137fb-58d3-4146-aad1-6e7a1e64b452"]
}, Closed]],

Cell[CellGroupData[{

Cell["Theorem Schemas", "Section",
 CellChangeTimes->{{3.730437885380192*^9, 3.7304378884278297`*^9}},
 CellID->891466572,ExpressionUUID->"df28b156-b493-4a97-8cc2-4cf99c93305b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginCore", "[", " ", "\"\<Theorema`Minimal`\>\"", "]"}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"AddTheoremSchemas", "[", "\n", "\t", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", " ", 
       RowBox[{
        RowBox[{"{", "Automatic", "}"}], ",", " ", 
        RowBox[{"Insert", "[", " ", 
         RowBox[{"#", ",", " ", 
          RowBox[{"0", "&"}], ",", " ", "3"}], "]"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", " ", "True"}], "}"}]}], "]"}], "&"}], " ", 
     "/@", "\n", "\t", 
     RowBox[{"{", "\n", "\t\t", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rearrangeStatement", ",", " ", "rearrangeProof", ",", " ", 
         "\"\<Rearrange\>\""}], "}"}], ",", "\n", "\t\t", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"mpStatement", "[", " ", "Forward", "]"}], ",", " ", 
         RowBox[{"mpProof", "[", " ", "Forward", "]"}], ",", " ", 
         "\"\<Modus Ponens\>\""}], "}"}], ",", "\n", "\t\t", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"mpStatement", "[", " ", "Backward", "]"}], ",", " ", 
         RowBox[{"mpProof", "[", " ", "Backward", "]"}], ",", " ", 
         "\"\<Modus Ponens reverse\>\""}], "}"}], ",", "\n", "\t\t", 
       RowBox[{"{", 
        RowBox[{
        "gmpStatement", ",", " ", "gmpProof", ",", " ", "\"\<GMP\>\""}], 
        "}"}]}], "\n", "\t", "}"}]}], "\n", "]"}], ";"}], "\n"}], "\n", 
 RowBox[{"EndCore", "[", "]"}]}], "Code",
 CellChangeTimes->{{3.7304386267208014`*^9, 3.730438654839094*^9}, {
   3.730438699184712*^9, 3.7304387347920218`*^9}, {3.730438982946093*^9, 
   3.7304389847934647`*^9}, {3.730439039827183*^9, 3.730439075860318*^9}, {
   3.730442967075597*^9, 3.730442971658128*^9}, {3.730443245408697*^9, 
   3.730443275489025*^9}, {3.730443347467578*^9, 3.7304434043115187`*^9}, {
   3.730443455120699*^9, 3.730443488076413*^9}, 3.730460310325547*^9},
 CellID->1863625329,ExpressionUUID->"ed7291aa-79d4-40be-b2d2-50a6eaf84247"]
}, Closed]],

Cell[CellGroupData[{

Cell["Constants and Formulas", "Section",
 CellChangeTimes->{{3.7304391473395844`*^9, 3.730439148163496*^9}, {
  3.730461246331806*^9, 3.7304612518359747`*^9}},
 CellID->1377567936,ExpressionUUID->"03cbe7df-b51c-42db-9658-684c7f06b3c7"],

Cell[BoxData[
 RowBox[{"default", " ", "sort", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"{", "}"}], "\[CloseCurlyQuote]"}]}]], "TheoremaCode",
 CellChangeTimes->{{3.730458660283867*^9, 3.730458665883573*^9}},
 CellID->996798660,ExpressionUUID->"05b65b08-2a5d-4352-9430-e9c5c4a7a76a"],

Cell[CellGroupData[{

Cell["CoreEqual", "Subsection",
 CellChangeTimes->{{3.730439155179079*^9, 3.7304391569631863`*^9}},
 CellID->1514539412,ExpressionUUID->"ff0e2058-5a1f-4900-87d5-9bce0619b67d"],

Cell["", "OpenEnvironment",
 CellID->222563640,ExpressionUUID->"dc059fa3-4f96-4a3c-9736-a098a5e7e996"],

Cell[CellGroupData[{

Cell["Lemma (Properties of \[EqualTilde])", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.730457015247764*^9, 3.730457021919993*^9}},
 CellID->1340868144,ExpressionUUID->"444b3fdb-3756-4ff8-b34e-ab069019d639"],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[And]", 
   RowBox[{"x", ",", "y"}]], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"x", "\[EqualTilde]", "y"}], ")"}], "\[LongRightArrow]", 
   RowBox[{"(", 
    RowBox[{"y", "\[EqualTilde]", "x"}], ")"}]}]}]], "FormalTextInputFormula",\

 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        TooltipBox[
         ButtonBox[
          StyleBox["(CoreEqual symmetric)", "FrameLabel"], Evaluator -> 
          Automatic, Appearance -> None, ButtonFunction :> 
          Theorema`Common`editCellTags[]], "sym"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[]]}]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.730457054072105*^9, 3.7304570707756777`*^9}},
 CellTags->{"CoreEqual symmetric", "sym"},
 CellID->1696915507,ExpressionUUID->"57a8afbb-ae1c-41e8-8186-6761b7d61a49"],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[And]", 
   RowBox[{"P", ",", "x", ",", "y"}]], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"x", "\[EqualTilde]", "y"}], ")"}], "\[LongRightArrow]", 
   RowBox[{"P", "[", "y", "]"}], "\[LongRightArrow]", 
   RowBox[{"P", "[", "x", "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        ButtonBox[
         StyleBox["(CoreEqual transitive forward)", "FrameLabel"], Evaluator -> 
         Automatic, Appearance -> None, ButtonFunction :> 
         Theorema`Common`editCellTags[]], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[]]}]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.730457121793014*^9, 3.730457146425428*^9}},
 CellTags->"CoreEqual transitive forward",
 CellID->547733394,ExpressionUUID->"22e5a94b-e4b0-462f-8050-2ed3ab5c71fe"],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[And]", 
   RowBox[{"P", ",", "y", ",", "z"}]], 
  RowBox[{
   RowBox[{"P", "[", "y", "]"}], "\[LongRightArrow]", 
   RowBox[{"(", 
    RowBox[{"y", "\[EqualTilde]", "z"}], ")"}], "\[LongRightArrow]", 
   RowBox[{"P", "[", "z", "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        ButtonBox[
         StyleBox["(CoreEqual transitive backward)", "FrameLabel"], Evaluator -> 
         Automatic, Appearance -> None, ButtonFunction :> 
         Theorema`Common`editCellTags[]], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[]]}]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.730457170296568*^9, 3.730457199275865*^9}},
 CellTags->"CoreEqual transitive backward",
 CellID->479765905,ExpressionUUID->"342d05e6-c955-4e10-871c-c75cf5d89760"],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[And]", 
   RowBox[{"P", ",", "x", ",", "y", ",", "z"}]], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"x", "\[EqualTilde]", "y"}], ")"}], "\[LongRightArrow]", 
   RowBox[{"P", "[", 
    RowBox[{"y", ",", "z"}], "]"}], "\[LongRightArrow]", 
   RowBox[{"P", "[", 
    RowBox[{"x", ",", "z"}], "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        TooltipBox[
         ButtonBox[
          StyleBox["(CoreEqual transitive forward 2)", "FrameLabel"], 
          Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
          Theorema`Common`editCellTags[]], "trans"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[]]}]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.730457232361826*^9, 3.7304572582906303`*^9}},
 CellTags->{"CoreEqual transitive forward 2", "trans"},
 CellID->141999747,ExpressionUUID->"0c982efa-bf44-4aaf-b970-8310db663a75"],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[And]", 
   RowBox[{"P", ",", "x", ",", "y", ",", "z"}]], 
  RowBox[{
   RowBox[{"P", "[", 
    RowBox[{"x", ",", "y"}], "]"}], "\[LongRightArrow]", 
   RowBox[{"(", 
    RowBox[{"y", "\[EqualTilde]", "z"}], ")"}], "\[LongRightArrow]", 
   RowBox[{"P", "[", 
    RowBox[{"x", ",", "z"}], "]"}]}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        TooltipBox[
         ButtonBox[
          StyleBox["(CoreEqual transitive backward 2)", "FrameLabel"], 
          Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
          Theorema`Common`editCellTags[]], "trans"], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[]]}]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.730457284594179*^9, 3.7304573048034573`*^9}},
 CellTags->{"CoreEqual transitive backward 2", "trans"},
 CellID->816233139,ExpressionUUID->"bdfd2e8d-50e6-4458-8506-0375d71b74f2"],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1551395378,ExpressionUUID->"d9f1073a-f6ea-4844-b826-ad40b3ea663d"]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->926352679,ExpressionUUID->"c1f15026-3a07-4d83-a802-e875cab49ec6"],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Show proof\"\>",
   StripOnInput->False,
   FontVariations->{"Underline"->True}],
  Appearance->None,
  ButtonFunction:>Theorema`Core`Tools`Interactive`Private`displayCoreProof[],
  Evaluator->Automatic,
  ImageSize->Automatic,
  Method->
   "Queued"]],ExpressionUUID->"69111d9e-9737-4727-8a1e-dd4527abcb10"]], \
"ProofInfo",
 ShowCellBracket->Automatic,
 Evaluatable->True,
 CellEvaluationFunction->
  Theorema`Core`Tools`Interactive`Private`evaluateProofCell,
 CellFrameLabels->{{
    Cell[
     TextData[{"\[CheckmarkedBox] ", "\[FivePointedStar]", " Proof of ", 
       Cell[
        BoxData[
         ButtonBox[
          
          PaneSelectorBox[{
           False -> StyleBox[
             "\"(CoreEqual symmetric)\"", "FormReference", StripOnInput -> 
              False], True -> 
            StyleBox[
             "\"(CoreEqual symmetric)\"", "FormReferenceHover", StripOnInput -> 
              False]}, 
           Dynamic[
            CurrentValue["MouseOver"]], ImageSize -> Automatic, FrameMargins -> 
           0], ButtonFunction :> 
          If[Theorema`Common`selectCells["1696915507", CellID] === $Failed, 
            Theorema`Common`selectCells["ID:1696915507", CellTags]], 
          Appearance -> None, Evaluator -> Automatic, Method -> 
          "Preemptive"]]], " \[NumberSign]1  ", 
       StyleBox[
       "[Wed 28 Mar 2018 14:09:57, 0.033217 sec]", FontSize -> Small]}]], 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Core`Tools`Interactive`Private`removeCoreProof[]]]]}, {
   None, None}},
 CellTags->{"Proof|ID:1696915507-1", "5"},
 CellID->1178144437,ExpressionUUID->"06ac16b6-8dfc-40cb-945f-80a2cb7a01d6"],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Show proof\"\>",
   StripOnInput->False,
   FontVariations->{"Underline"->True}],
  Appearance->None,
  ButtonFunction:>Theorema`Core`Tools`Interactive`Private`displayCoreProof[],
  Evaluator->Automatic,
  ImageSize->Automatic,
  Method->
   "Queued"]],ExpressionUUID->"9d86ba89-6612-4e39-8f55-f225e8b0d093"]], \
"ProofInfo",
 ShowCellBracket->Automatic,
 Evaluatable->True,
 CellEvaluationFunction->
  Theorema`Core`Tools`Interactive`Private`evaluateProofCell,
 CellFrameLabels->{{
    Cell[
     TextData[{"\[CheckmarkedBox] ", "\[FivePointedStar]", " Proof of ", 
       Cell[
        BoxData[
         ButtonBox[
          
          PaneSelectorBox[{
           False -> StyleBox[
             "\"(CoreEqual transitive forward)\"", "FormReference", 
              StripOnInput -> False], True -> 
            StyleBox[
             "\"(CoreEqual transitive forward)\"", "FormReferenceHover", 
              StripOnInput -> False]}, 
           Dynamic[
            CurrentValue["MouseOver"]], ImageSize -> Automatic, FrameMargins -> 
           0], ButtonFunction :> 
          If[Theorema`Common`selectCells["547733394", CellID] === $Failed, 
            Theorema`Common`selectCells["ID:547733394", CellTags]], 
          Appearance -> None, Evaluator -> Automatic, Method -> 
          "Preemptive"]]], " \[NumberSign]1  ", 
       StyleBox[
       "[Wed 28 Mar 2018 14:09:57, 0.033682 sec]", FontSize -> Small]}]], 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Core`Tools`Interactive`Private`removeCoreProof[]]]]}, {
   None, None}},
 CellTags->{"Proof|ID:547733394-1", "5"},
 CellID->155721987,ExpressionUUID->"aa68f9af-f227-4bd4-927e-ca11e7f7bc83"],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Show proof\"\>",
   StripOnInput->False,
   FontVariations->{"Underline"->True}],
  Appearance->None,
  ButtonFunction:>Theorema`Core`Tools`Interactive`Private`displayCoreProof[],
  Evaluator->Automatic,
  ImageSize->Automatic,
  Method->
   "Queued"]],ExpressionUUID->"6e3d2638-0f43-4212-90e7-1b5da37b6c37"]], \
"ProofInfo",
 ShowCellBracket->Automatic,
 Evaluatable->True,
 CellEvaluationFunction->
  Theorema`Core`Tools`Interactive`Private`evaluateProofCell,
 CellFrameLabels->{{
    Cell[
     TextData[{"\[CheckmarkedBox] ", "\[FivePointedStar]", " Proof of ", 
       Cell[
        BoxData[
         ButtonBox[
          
          PaneSelectorBox[{
           False -> StyleBox[
             "\"(CoreEqual transitive backward)\"", "FormReference", 
              StripOnInput -> False], True -> 
            StyleBox[
             "\"(CoreEqual transitive backward)\"", "FormReferenceHover", 
              StripOnInput -> False]}, 
           Dynamic[
            CurrentValue["MouseOver"]], ImageSize -> Automatic, FrameMargins -> 
           0], ButtonFunction :> 
          If[Theorema`Common`selectCells["479765905", CellID] === $Failed, 
            Theorema`Common`selectCells["ID:479765905", CellTags]], 
          Appearance -> None, Evaluator -> Automatic, Method -> 
          "Preemptive"]]], " \[NumberSign]1  ", 
       StyleBox[
       "[Wed 28 Mar 2018 14:09:58, 0.041929 sec]", FontSize -> Small]}]], 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Core`Tools`Interactive`Private`removeCoreProof[]]]]}, {
   None, None}},
 CellTags->{"Proof|ID:479765905-1", "5"},
 CellID->1208240564,ExpressionUUID->"dd80963d-9414-4d73-81ba-c9b8d97ff64d"],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Show proof\"\>",
   StripOnInput->False,
   FontVariations->{"Underline"->True}],
  Appearance->None,
  ButtonFunction:>Theorema`Core`Tools`Interactive`Private`displayCoreProof[],
  Evaluator->Automatic,
  ImageSize->Automatic,
  Method->
   "Queued"]],ExpressionUUID->"52ed7863-3d3b-4a45-8328-cfcf505da952"]], \
"ProofInfo",
 ShowCellBracket->Automatic,
 Evaluatable->True,
 CellEvaluationFunction->
  Theorema`Core`Tools`Interactive`Private`evaluateProofCell,
 CellFrameLabels->{{
    Cell[
     TextData[{"\[CheckmarkedBox] ", "\[FivePointedStar]", " Proof of ", 
       Cell[
        BoxData[
         ButtonBox[
          
          PaneSelectorBox[{
           False -> StyleBox[
             "\"(CoreEqual transitive forward 2)\"", "FormReference", 
              StripOnInput -> False], True -> 
            StyleBox[
             "\"(CoreEqual transitive forward 2)\"", "FormReferenceHover", 
              StripOnInput -> False]}, 
           Dynamic[
            CurrentValue["MouseOver"]], ImageSize -> Automatic, FrameMargins -> 
           0], ButtonFunction :> 
          If[Theorema`Common`selectCells["141999747", CellID] === $Failed, 
            Theorema`Common`selectCells["ID:141999747", CellTags]], 
          Appearance -> None, Evaluator -> Automatic, Method -> 
          "Preemptive"]]], " \[NumberSign]1  ", 
       StyleBox[
       "[Wed 28 Mar 2018 14:09:58, 0.043433 sec]", FontSize -> Small]}]], 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Core`Tools`Interactive`Private`removeCoreProof[]]]]}, {
   None, None}},
 CellTags->{"Proof|ID:141999747-1", "5"},
 CellID->1142919876,ExpressionUUID->"0252dfeb-6af0-4f7c-8a8c-45c6c583ed97"],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Show proof\"\>",
   StripOnInput->False,
   FontVariations->{"Underline"->True}],
  Appearance->None,
  ButtonFunction:>Theorema`Core`Tools`Interactive`Private`displayCoreProof[],
  Evaluator->Automatic,
  ImageSize->Automatic,
  Method->
   "Queued"]],ExpressionUUID->"820ae5e3-a422-4e6a-9647-0856ef14d500"]], \
"ProofInfo",
 ShowCellBracket->Automatic,
 Evaluatable->True,
 CellEvaluationFunction->
  Theorema`Core`Tools`Interactive`Private`evaluateProofCell,
 CellFrameLabels->{{
    Cell[
     TextData[{"\[CheckmarkedBox] ", "\[FivePointedStar]", " Proof of ", 
       Cell[
        BoxData[
         ButtonBox[
          
          PaneSelectorBox[{
           False -> StyleBox[
             "\"(CoreEqual transitive backward 2)\"", "FormReference", 
              StripOnInput -> False], True -> 
            StyleBox[
             "\"(CoreEqual transitive backward 2)\"", "FormReferenceHover", 
              StripOnInput -> False]}, 
           Dynamic[
            CurrentValue["MouseOver"]], ImageSize -> Automatic, FrameMargins -> 
           0], ButtonFunction :> 
          If[Theorema`Common`selectCells["816233139", CellID] === $Failed, 
            Theorema`Common`selectCells["ID:816233139", CellTags]], 
          Appearance -> None, Evaluator -> Automatic, Method -> 
          "Preemptive"]]], " \[NumberSign]1  ", 
       StyleBox[
       "[Wed 28 Mar 2018 14:09:59, 0.054865 sec]", FontSize -> Small]}]], 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Core`Tools`Interactive`Private`removeCoreProof[]]]]}, {
   None, None}},
 CellTags->{"Proof|ID:816233139-1", "5"},
 CellID->437423969,ExpressionUUID->"2ba41a7c-b2dc-470f-a252-e0476a094838"]
}, Closed]],

Cell[CellGroupData[{

Cell["NOMATCH", "Subsection",
 CellChangeTimes->{{3.730457432548511*^9, 3.7304574341564302`*^9}},
 CellID->604245228,ExpressionUUID->"af6a4919-7b4b-4410-857d-291c497e2f85"],

Cell[BoxData[
 RowBox[{"decl", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"NOMATCH", "::", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]_", "\[Rule]", 
      RowBox[{"\[Beta]_", "\[Rule]", "FORM"}]}], ")"}]}], 
   "\[CloseCurlyQuote]"}]}]], "TheoremaCode",
 CellChangeTimes->{{3.7304580107080383`*^9, 3.73045805912821*^9}, {
  3.730458566851165*^9, 3.7304585837472277`*^9}},
 CellID->414106688,ExpressionUUID->"f5bb0b24-0444-49b4-b26b-6073fb6c95db"],

Cell["\<\
The minimal theory does not enable definitions of term-constants in formula \
cells. So we must do it manually ...\
\>", "Text",
 CellChangeTimes->{{3.73045784448938*^9, 3.730457907737953*^9}},
 CellID->98671853,ExpressionUUID->"595cc5a6-0b72-4436-865f-e1aac5e88441"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BeginCore", "[", " ", "\"\<Theorema`Minimal`\>\"", "]"}], ";"}], 
  "\n", "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"NOMATCH", " ", "\[EqualTilde]", " ", 
    RowBox[{"(", 
     RowBox[{
      UnderscriptBox["\[Lambda]", 
       RowBox[{"x", ",", "y"}]], 
      RowBox[{"(", 
       RowBox[{"CoreEqual", "\[EqualTilde]", "CoreEqual"}], ")"}]}], ")"}]}], 
   " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"addAxmToTheory", "[", "\n", "\t", 
    RowBox[{
     RowBox[{"FML$", "[", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cellIDLabel", "[", " ", 
          RowBox[{"CurrentValue", "[", " ", 
           RowBox[{
            RowBox[{"EvalCell", "[", "]"}], ",", " ", "CellID"}], "]"}], 
          "]"}], ",", " ", 
         RowBox[{"EvalTheoryName", "[", "]"}]}], "}"}], ",", "\n", "\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"TYPED$", "[", " ", 
          RowBox[{"CoreEqual$TM", ",", " ", 
           RowBox[{"{", 
            RowBox[{"FUN$TM", "[", " ", 
             RowBox[{
              RowBox[{"TVAR$", "[", " ", "0", "]"}], ",", " ", 
              RowBox[{"FUN$TM", "[", " ", 
               RowBox[{
                RowBox[{"TVAR$", "[", " ", "1", "]"}], ",", " ", "FORM$TM"}], 
               "]"}]}], "]"}], "}"}]}], "]"}], "[", "\n", "\t\t\t", 
         RowBox[{"TYPED$", "[", " ", 
          RowBox[{"Theorema`Knowledge`NOMATCH$TM", ",", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"TVAR$", "[", " ", "0", "]"}], ",", " ", 
             RowBox[{"TVAR$", "[", " ", "1", "]"}]}], "}"}]}], "]"}], "\n", 
         "\t\t", "]"}], "[", "\n", "\t\t\t", 
        RowBox[{"Lambda$TM", "[", " ", 
         RowBox[{
          RowBox[{"RNG$", "[", " ", 
           RowBox[{"TYPRNG$", "[", " ", 
            RowBox[{"Null", ",", " ", 
             RowBox[{"TVAR$", "[", " ", "0", "]"}]}], "]"}], "]"}], ",", " ", 
          
          RowBox[{"Lambda$TM", "[", " ", 
           RowBox[{
            RowBox[{"RNG$", "[", " ", 
             RowBox[{"TYPRNG$", "[", " ", 
              RowBox[{"Null", ",", " ", 
               RowBox[{"TVAR$", "[", " ", "1", "]"}]}], "]"}], "]"}], ",", 
            "\n", "\t\t\t\t", 
            RowBox[{
             RowBox[{
              RowBox[{"TYPED$", "[", " ", 
               RowBox[{"CoreEqual$TM", ",", " ", 
                RowBox[{"{", 
                 RowBox[{"FUN$TM", "[", " ", 
                  RowBox[{"FORM$TM", ",", " ", 
                   RowBox[{"FUN$TM", "[", " ", 
                    RowBox[{"FORM$TM", ",", " ", "FORM$TM"}], "]"}]}], "]"}], 
                 "}"}]}], "]"}], "[", " ", 
              RowBox[{"TYPED$", "[", " ", 
               RowBox[{"CoreEqual$TM", ",", " ", 
                RowBox[{"{", "FORM$TM", "}"}]}], "]"}], "]"}], "[", " ", 
             RowBox[{"TYPED$", "[", " ", 
              RowBox[{"CoreEqual$TM", ",", " ", 
               RowBox[{"{", "FORM$TM", "}"}]}], "]"}], "]"}]}], "]"}]}], "\n",
          "\t\t\t", "]"}], "\n", "\t\t", "]"}], ",", "\n", "\t\t", 
       "\"\<NOMATCH def\>\""}], "\n", "\t", "]"}], ",", "\n", "\t", 
     RowBox[{"If", "[", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"getDefaultSort", "[", "]"}], " ", "===", " ", 
        RowBox[{"{", "}"}]}], ",", " ", 
       RowBox[{"\[LeftAssociation]", "\[RightAssociation]"}], ",", " ", 
       RowBox[{"\[LeftAssociation]", 
        RowBox[{
         RowBox[{
          RowBox[{"TVAR$", "[", " ", "0", "]"}], " ", "\[Rule]", " ", 
          RowBox[{"{", "}"}]}], ",", " ", 
         RowBox[{
          RowBox[{"TVAR$", "[", " ", "1", "]"}], " ", "\[Rule]", " ", 
          RowBox[{"{", "}"}]}]}], "\[RightAssociation]"}]}], "]"}], ",", "\n",
      "\t", "True", ",", "\n", "\t", "False", ",", "\n", "\t", "True", ",", 
     "\n", "\t", "False", ",", "\n", "\t", "False"}], "\n", "]"}], ";"}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"EndCore", "[", "]"}], ";"}]}], "Code",
 CellChangeTimes->{{3.7304575455215807`*^9, 3.730457648624752*^9}, {
   3.730457706544828*^9, 3.730457709472773*^9}, {3.7304577732253323`*^9, 
   3.730457815234211*^9}, {3.7304579180987473`*^9, 3.730457977084146*^9}, {
   3.73045806369315*^9, 3.730458063917091*^9}, {3.730458711029477*^9, 
   3.730458733493413*^9}, 3.730460668974086*^9, {3.731227843560485*^9, 
   3.731227844752102*^9}},
 CellID->1061661890,ExpressionUUID->"10c56c24-654a-4e09-9935-31187168cc8d"],

Cell["", "OpenEnvironment",
 CellID->1848103537,ExpressionUUID->"bd551dea-408e-40f1-93f1-0c164a43d170"],

Cell[CellGroupData[{

Cell["Lemma (NOMATCH)", "EnvironmentHeader",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Common`removeEnvironment[
         ButtonNotebook[]]]]]}, {None, None}},
 CellChangeTimes->{{3.7304574589409018`*^9, 3.730457464069037*^9}, 
   3.730457526342044*^9},
 CellID->1219727102,ExpressionUUID->"475123ef-20b3-4222-b4d7-e58c8a18df9b"],

Cell[BoxData[
 RowBox[{
  UnderscriptBox["\[And]", 
   RowBox[{"x", ",", "y"}]], 
  RowBox[{"NOMATCH", "[", 
   RowBox[{"x", ",", "y"}], "]"}]}]], "FormalTextInputFormula",
 CellFrameLabels->{{None, 
    Cell[
     BoxData[
      RowBox[{
        ButtonBox[
         StyleBox["(NOMATCH I)", "FrameLabel"], Evaluator -> Automatic, 
         Appearance -> None, ButtonFunction :> 
         Theorema`Common`editCellTags[]], "  ", 
        ButtonBox[
        "\[Times]", Evaluator -> Automatic, Appearance -> None, 
         ButtonFunction :> 
         Theorema`Language`Session`Private`removeFormula[]]}]]]}, {
   None, None}},
 ShowCellTags->False,
 CellChangeTimes->{{3.7304579896679573`*^9, 3.7304579968275557`*^9}},
 CellTags->"NOMATCH I",
 CellID->1591861209,ExpressionUUID->"273480ab-5201-4d2c-9d9b-5686df09e735"],

Cell["\[GraySquare]", "EndEnvironmentMarker",
 CellID->1092825495,ExpressionUUID->"4896c89f-851a-4edd-aa69-128b714a9f9d"]
}, Open  ]],

Cell["", "CloseEnvironment",
 CellID->1707983279,ExpressionUUID->"18ce8e56-7b67-4726-8c23-0f86670b3dac"],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Show proof\"\>",
   StripOnInput->False,
   FontVariations->{"Underline"->True}],
  Appearance->None,
  ButtonFunction:>Theorema`Core`Tools`Interactive`Private`displayCoreProof[],
  Evaluator->Automatic,
  ImageSize->Automatic,
  Method->
   "Queued"]],ExpressionUUID->"8ad0bc3f-d3ec-49dd-acb3-c08c673a897a"]], \
"ProofInfo",
 ShowCellBracket->Automatic,
 Evaluatable->True,
 CellEvaluationFunction->
  Theorema`Core`Tools`Interactive`Private`evaluateProofCell,
 CellFrameLabels->{{
    Cell[
     TextData[{"\[CheckmarkedBox] ", "\[FivePointedStar]", " Proof of ", 
       Cell[
        BoxData[
         ButtonBox[
          
          PaneSelectorBox[{
           False -> StyleBox[
             "\"(NOMATCH I)\"", "FormReference", StripOnInput -> False], True -> 
            StyleBox[
             "\"(NOMATCH I)\"", "FormReferenceHover", StripOnInput -> False]}, 
           Dynamic[
            CurrentValue["MouseOver"]], ImageSize -> Automatic, FrameMargins -> 
           0], ButtonFunction :> 
          If[Theorema`Common`selectCells["1591861209", CellID] === $Failed, 
            Theorema`Common`selectCells["ID:1591861209", CellTags]], 
          Appearance -> None, Evaluator -> Automatic, Method -> 
          "Preemptive"]]], " \[NumberSign]1  ", 
       StyleBox[
       "[Wed 28 Mar 2018 14:10:49, 0.025985 sec]", FontSize -> Small]}]], 
    Cell[
     BoxData[
      ButtonBox[
      "\[Times]", Evaluator -> Automatic, Appearance -> None, ButtonFunction :> 
       Theorema`Core`Tools`Interactive`Private`removeCoreProof[]]]]}, {
   None, None}},
 CellTags->{"Proof|ID:1591861209-1", "5"},
 CellID->985202979,ExpressionUUID->"ab947a83-39ac-47c9-8912-156cc99329b4"]
}, Closed]],

Cell[CellGroupData[{

Cell["TYPE", "Subsection",
 CellChangeTimes->{{3.730461123202228*^9, 3.730461124121849*^9}},
 CellID->34124658,ExpressionUUID->"9a51722d-89f8-4480-a9ba-34a170bcf807"],

Cell["\<\
Maybe it\[CloseCurlyQuote]s better to declare \[OpenCurlyQuote]TYPE\
\[CloseCurlyQuote] immediately after entering \[OpenCurlyDoubleQuote]Core\
\[CloseCurlyDoubleQuote], even without loading the minimal theory?\
\>", "Text",
 CellChangeTimes->{{3.730461134202262*^9, 3.730461186987452*^9}},
 CellID->572435876,ExpressionUUID->"fcedfa9b-5b46-4999-9f58-bc4fdcfce8e6"],

Cell[BoxData[{
 RowBox[{"decl", " ", 
  RowBox[{"\[OpenCurlyQuote]", 
   RowBox[{"TYPE", "::", "\[Alpha]_"}], "\[CloseCurlyQuote]"}]}], "\n", 
 RowBox[{"lock", " ", 
  RowBox[{
  "\[OpenCurlyQuote]", "TYPE", "\[CloseCurlyQuote]"}]}]}], "TheoremaCode",
 CellChangeTimes->{{3.730461197930703*^9, 3.730461219627839*^9}},
 CellID->74339585,ExpressionUUID->"fdeae0f0-7dec-42ef-a962-3f1583c1ab8b"]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{1047, 917},
WindowMargins->{{212, Automatic}, {48, Automatic}},
Visible->False,
CounterAssignments->{{"TheoremaFormulaCounter" -> 0}, {
  "NotebookFileName" -> 
   "/home/amaletzk/WolframWorkspaces/Base/Theorema/Theorema/CoreTheories/\
Minimal/Minimal.nb"}},
Magnification->1.,
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Theorema"}, "TheoremaCore.nb"]]], 
   
   Cell["Modify the definitions below to change the default appearance of all \
cells in a given style. \nMake modifications to any definition using commands \
in the Format menu.", "Text"], 
   Cell[
    CellGroupData[{
      Cell["Notebook Options Settings", "Section"], 
      Cell[
      "The options defined for the style below will be used at the Notebook \
level.", "Text"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Notebook"], InputAliases -> {"and" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[And]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "or" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", "\[Or]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "not" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Not]", "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "impl" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[Implies]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[DoubleLongLeftRightArrow]", 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               
               RowBox[{
                "\[SelectionPlaceholder]", "\[Equal]", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":equiv" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox[
                  
                  RowBox[{
                   ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
                    "\[DoubleLongLeftRightArrow]"}], Identity, SyntaxForm -> 
                  "a:=b"], "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], ":eq" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", ":=", "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "andn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[And]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "orn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Or]", "\[Piecewise]", 
                 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
                  ColumnAlignments -> Left]}], 
               TagBox[")", "AutoParentheses"]}], "equivn" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[DoubleLeftRightArrow]", "\[Piecewise]", 
                 GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "cdist" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[Piecewise]", 
                 
                 GridBox[{{
                   "\[SelectionPlaceholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}, {
                   "\[Placeholder]", "\[DoubleLeftArrow]", 
                    "\[Placeholder]"}}]}], 
               TagBox[")", "AutoParentheses"]}], "far" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exr" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "farc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "exrc" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox[
                  UnderscriptBox["\[Exists]", "\[Placeholder]"], 
                  "\[Placeholder]"], "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "let" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{
                 UnderscriptBox["let", 
                  RowBox[{"\[Placeholder]", "=", "\[Placeholder]"}]], 
                 "\[SelectionPlaceholder]"}], 
               TagBox[")", "AutoParentheses"]}], "app" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293a", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "prep" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:293b", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "join" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22c8", Identity, SyntaxForm -> "a*b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "elemT" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               RowBox[{"\[SelectionPlaceholder]", 
                 TagBox["\:22ff", Identity, SyntaxForm -> "a+b"], 
                 "\[Placeholder]"}], 
               TagBox[")", "AutoParentheses"]}], "subop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "supop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SuperscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "subsupop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubsuperscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "oop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "uoop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               UnderoverscriptBox[
               "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "osop" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               SubscriptBox[
                OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
                "\[Placeholder]"], 
               TagBox[")", "AutoParentheses"]}], "op" -> RowBox[{
               TagBox["(", "AutoParentheses"], 
               TagBox["\[SelectionPlaceholder]", Identity], 
               TagBox[")", "AutoParentheses"]}], "seq" -> RowBox[{
               TagBox["\[VerticalEllipsis]", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\[VerticalEllipsis]", Identity, SyntaxForm -> ")"]}], 
            "()" -> RowBox[{
               TagBox["\:fd3e", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:fd3f", Identity, SyntaxForm -> ")"]}], "(())" -> 
            RowBox[{
               TagBox["\:2e28", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:2e29", Identity, SyntaxForm -> ")"]}], "(|)" -> 
            RowBox[{
               TagBox["\:2987", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:2988", Identity, SyntaxForm -> ")"]}], "[]" -> 
            RowBox[{
               TagBox["\:e114", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:e115", Identity, SyntaxForm -> ")"]}], "[[]]" -> 
            RowBox[{
               TagBox["\:27e6", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:27e7", Identity, SyntaxForm -> ")"]}], "[|]" -> 
            RowBox[{
               TagBox["\:27ec", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:27ed", Identity, SyntaxForm -> ")"]}], "{}" -> 
            RowBox[{
               TagBox["\:e117", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:e118", Identity, SyntaxForm -> ")"]}], "{{}}" -> 
            RowBox[{
               TagBox["\:2983", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:2984", Identity, SyntaxForm -> ")"]}], "<>" -> 
            RowBox[{
               TagBox["\:27e8", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:27e9", Identity, SyntaxForm -> ")"]}], "<<>>" -> 
            RowBox[{
               TagBox["\:27ea", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:27eb", Identity, SyntaxForm -> ")"]}], "<|>" -> 
            RowBox[{
               TagBox["\:2989", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:298a", Identity, SyntaxForm -> ")"]}], "<.>" -> 
            RowBox[{
               TagBox["\:2991", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:2992", Identity, SyntaxForm -> ")"]}], "<c>" -> 
            RowBox[{
               TagBox["\:29fc", Identity, SyntaxForm -> "("], 
               "\[SelectionPlaceholder]", 
               TagBox["\:29fd", Identity, SyntaxForm -> ")"]}], "(" -> 
            TagBox["(", "AutoParentheses"], ")" -> 
            TagBox[")", "AutoParentheses"]}, Background -> 
          RGBColor[0.957, 0.96, 0.97]], 
         Cell[
          StyleData["Notebook", "Printout"], Background -> None]}, Open]]}, 
     Open]], 
   Cell[
    CellGroupData[{
      Cell["Style Environment Names", "Section"], 
      Cell[
       StyleData[All, "Working"], DockedCells -> {
         Cell[
         "Theorema 2.0", "SBO", FontTracking -> 8, 
          CellMargins -> {{0, 0}, {0, 0}}, 
          CellFrameMargins -> {{0, 50}, {0, 0}}, FontSize -> 28, FontSlant -> 
          "Plain", FontColor -> RGBColor[0.29, 0.46, 0.6], TextAlignment -> 
          Right, Background -> RGBColor[0.36, 0.54, 0.69]]}], 
      Cell[
       StyleData[
       All, "Layout", StyleDefinitions -> StyleData[All, "Working"]], 
       MenuSortingValue -> 1200]}, Open]], 
   Cell[
    CellGroupData[{
      Cell["Styles for Title and Section Cells", "Section"], 
      Cell[
       CellGroupData[{
         Cell["Title", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{27, 27}, {10, 30}}, 
             TextAlignment -> Center, MenuSortingValue -> 1100, 
             MenuCommandKey -> "1", FontFamily -> "Bitstream Charter", 
             FontSize -> 36, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Title", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{6, 10}, {5, 30}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], CellMargins -> {{27, 27}, {20, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1150, FontFamily -> 
             "Bitstream Charter", FontSize -> 24, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{6, 10}, {5, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], CellMargins -> {{27, 27}, {8, 2}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Author"], CellMargins -> {{27, 27}, {18, 20}}, 
             TextAlignment -> Center, MenuSortingValue -> 1200, FontFamily -> 
             "Bitstream Charter", FontSize -> 16, FontWeight -> "Plain", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.23, 0.25, 0.34]], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{6, 10}, {0, 0}}]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Sectioning", "Subsection"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], ShowGroupOpener -> True, MenuSortingValue -> 
             1250, MenuCommandKey -> "4", FontFamily -> "Bitstream Charter", 
             FontSize -> 20, FontWeight -> "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Section", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{2, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {8, 12}}, 
             MenuSortingValue -> 1300, MenuCommandKey -> "5", FontFamily -> 
             "Bitstream Charter", FontSize -> 14, FontWeight -> "Bold", 
             FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.3, 0.3, 0.3]], 
            Cell[
             StyleData["Subsection", "Printout"], ShowGroupOpener -> False, 
             CellMargins -> {{9, 0}, {7, 22}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{27, Inherited}, {2, 10}}, 
             MenuSortingValue -> 1350, MenuCommandKey -> "6", FontFamily -> 
             "Bitstream Charter", FontSize -> 12, FontWeight -> "Bold", 
             FontSlant -> "Italic", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsection", "Printout"], ShowGroupOpener -> False,
              CellMargins -> {{35, 0}, {7, 14}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsubsection"], CellDingbat -> None, 
             ShowGroupOpener -> True, 
             CellMargins -> {{27, Inherited}, {Inherited, Inherited}}, 
             FontFamily -> "Bitstream Charter", FontSize -> 11, FontWeight -> 
             "Bold", FontSlant -> "Plain", 
             FontVariations -> {
              "StrikeThrough" -> False, "Underline" -> False}, FontColor -> 
             RGBColor[0.4, 0.4, 0.4]], 
            Cell[
             StyleData["Subsubsubsection", "Printout"], 
             CellMargins -> {{50, 0}, {7, 14}}]}, Closed]]}, Open]]}, Open]], 
   
   Cell[
    CellGroupData[{
      Cell["Styles for Publication\[Hyphen]ready Documents", "Section"], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Author"], CellMargins -> {{27, 30}, {20, 5}}, 
          MenuSortingValue -> 1900, FontFamily -> "Helvetica", FontSize -> 14,
           FontSlant -> "Italic"], 
         Cell[
          StyleData["Author", "Printout"], CellMargins -> {{6, 10}, {0, 10}}, 
          FontSize -> 10]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Abstract"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
          CellMargins -> {{27, 140}, {20, 20}}, LineSpacing -> {0.9, 0}, 
          MenuSortingValue -> 2050, FontFamily -> "Times", FontSize -> 12], 
         Cell[
          StyleData["Abstract", "Printout"], Hyphenation -> True, 
          LineSpacing -> {1, 2}, FontSize -> 10]}, Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Text", "Section"], 
      Cell[
       StyleData["Text"], CellMargins -> {{27, 27}, {Inherited, Inherited}}, 
       TextJustification -> 1., ParagraphIndent -> 15, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["EnvironmentText"], ShowCellBracket -> Automatic, 
       CellMargins -> {{82, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextJustification -> 1., ParagraphSpacing -> {0.3, 0.}, 
       MenuSortingValue -> 1480, MenuCommandKey -> "T", FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Item"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "Item", 
          CounterAssignments -> {{"Subitem", 0}, {"Subsubitem", 0}}, 
          MenuSortingValue -> 1600, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Item", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemParagraph"], CellMargins -> {{81, 10}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          DefaultNewCellStyle -> "Item", MenuSortingValue -> 1600, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemParagraph", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "Subitem", 
          CounterAssignments -> {{"Subsubitem", 0}}, MenuSortingValue -> 1610,
           FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subitem", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemParagraph"], CellMargins -> {{105, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subitem", 
          MenuSortingValue -> 1610, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemParagraph", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Subsubitem"], CellDingbat -> 
          Cell["\[FilledSmallCircle]", FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1620, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["Subsubitem", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemParagraph"], 
          CellMargins -> {{129, 12}, {4, 1}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Subsubitem", 
          CounterIncrements -> "Subsubitem", MenuSortingValue -> 1625, 
          FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemParagraph", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 2}}, FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["ItemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{81, 10}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15000}, 
          CellFrameLabelMargins -> 4, CounterIncrements -> "ItemNumbered", 
          CounterAssignments -> {{"SubitemNumbered", 0}, {
            "SubsubitemNumbered", 0}}, MenuSortingValue -> 1630, FontFamily -> 
          "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", 
          FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["ItemNumbered", "Presentation"], 
          CellMargins -> {{140, 10}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{105, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15100}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> "Item", 
          CounterIncrements -> "SubitemNumbered", 
          CounterAssignments -> {{"SubsubitemNumbered", 0}}, MenuSortingValue -> 
          1640, FontFamily -> "Bitstream Charter", FontSize -> 12, FontWeight -> 
          "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubitemNumbered", "Presentation"], 
          CellMargins -> {{176, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["SubsubitemNumbered"], CellDingbat -> Cell[
            TextData[{
              CounterBox["ItemNumbered"], ".", 
              CounterBox["SubitemNumbered"], ".", 
              CounterBox["SubsubitemNumbered"], "."}], FontWeight -> "Bold"], 
          CellMargins -> {{129, 12}, {4, 4}}, 
          CellGroupingRules -> {"GroupTogetherNestedGrouping", 15200}, 
          CellFrameLabelMargins -> 4, DefaultNewCellStyle -> 
          "SubitemNumbered", CounterIncrements -> "SubsubitemNumbered", 
          MenuSortingValue -> 1645, FontFamily -> "Bitstream Charter", 
          FontSize -> 12, FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> 
            False}, $CellContext`ReturnCreatesNewCell -> True], 
         Cell[
          StyleData["SubsubitemNumbered", "Presentation"], 
          CellMargins -> {{212, 12}, {7, 7}}, CellFrameLabelMargins -> 6, 
          FontSize -> 24]}, Open]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell["Theorema", "Section"], 
      Cell[
       StyleData["GlobalDeclaration"], CellFrame -> {{0, 2}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 3}, {2, 2}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       InitializationCell -> True, CellFrameMargins -> 10, CellFrameColor -> 
       RGBColor[0.73, 0.65, 0.61], CellFrameLabelMargins -> {{33, 7}, {1, 1}},
        ShowAutoStyles -> False, MenuSortingValue -> 1441, MenuCommandKey -> 
       "G", FontSize -> 14], 
      Cell[
       StyleData["OpenEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {-4, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       StyleData["EnvironmentHeader"], 
       CellFrame -> {{False, False}, {False, False}}, 
       CellMargins -> {{76, Inherited}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 6, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       ShowAutoStyles -> False, MenuSortingValue -> 1460, FontSize -> 14, 
       FontWeight -> "Bold", FontVariations -> {"CapsType" -> "SmallCaps"}, 
       Background -> RGBColor[0.89, 0.8, 0.69]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FormalTextInputFormula"], ShowCellBracket -> Automatic, 
          CellMargins -> {{96, 10}, {2, 2}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
          InitializationCell -> True, CellFrameLabelMargins -> 53, 
          ShowAutoStyles -> False, LimitsPositioningTokens -> {}, 
          MenuSortingValue -> 1470, MenuCommandKey -> "F", FontWeight -> 
          "Bold", FontColor -> RGBColor[0.25, 0.19, 0.2]], 
         Cell[
          StyleData["FormalTextInputFormula", "Layout"], Editable -> False], 
         Cell[
          StyleData["FormalTextInputFormula", "Presentation"], Editable -> 
          False]}, Open]], 
      Cell[
       StyleData["EndEnvironmentMarker"], 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       TextAlignment -> Right, MenuSortingValue -> 1480], 
      Cell[
       StyleData["CloseEnvironment"], Editable -> False, Selectable -> False, 
       CellFrame -> {{False, False}, {False, True}}, ShowCellBracket -> True, 
       CellMargins -> {{76, 6}, {Inherited, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 2, CellFrameColor -> RGBColor[0.4, 0.4, 0.4], 
       MenuSortingValue -> 1485], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["TheoremaInput"], CellFrame -> {{1.5, 0}, {0, 0}}, 
          CellFrameMargins -> {{8, 8}, {3, 4}}, CellFrameColor -> 
          RGBColor[0.486, 0.33, 0.32], ShowAutoStyles -> False, 
          LimitsPositioningTokens -> {}, MenuSortingValue -> 1500, 
          MenuCommandKey -> "I"], 
         Cell[
          StyleData["TheoremaInput", "Layout"], Editable -> False], 
         Cell[
          StyleData["TheoremaInput", "Presentation"], Editable -> False]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["TheoremaCode"], CellFrame -> {{1.5, 0}, {0, 0}}, 
          CellFrameMargins -> {{8, 8}, {3, 4}}, CellFrameColor -> 
          RGBColor[0.486, 0.33, 0.32], ShowAutoStyles -> False, 
          LimitsPositioningTokens -> {}, MenuSortingValue -> 1455, 
          MenuCommandKey -> "C"], 
         Cell[
          StyleData["TheoremaCode", "Layout"], Editable -> False], 
         Cell[
          StyleData["TheoremaCode", "Presentation"], Editable -> False]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Computation"], CellFrame -> {{1.5, 0}, {0, 0}}, 
          ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 7}}, 
          CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
          CellFrameMargins -> {{8, 8}, {3, 4}}, CellFrameColor -> 
          RGBColor[0.486, 0.33, 0.32], ShowAutoStyles -> False, 
          MenuSortingValue -> 1510, FontWeight -> "Bold", FontColor -> 
          RGBColor[0.23, 0.25, 0.34], Background -> 
          RGBColor[0.88, 0.88, 0.92]], 
         Cell[
          StyleData["Computation", "Layout"], Editable -> False], 
         Cell[
          StyleData["Computation", "Presentation"], Editable -> False]}, 
        Open]], 
      Cell[
       StyleData["ComputationResult"], CellFrame -> {{1.5, 0}, {0, 0}}, 
       ShowCellBracket -> Automatic, CellMargins -> {{76, 10}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.23, 0.25, 0.34]}, 
       CellFrameMargins -> {{8, 8}, {4, 3}}, CellFrameColor -> 
       RGBColor[0.486, 0.33, 0.32], StyleMenuListing -> None, FontColor -> 
       RGBColor[0.23, 0.25, 0.34], Background -> RGBColor[0.88, 0.88, 0.92]], 
      
      Cell[
       StyleData["ComputationInfo"], ShowCellBracket -> False, 
       CellMargins -> {{120, 10}, {10, 2}}, StyleMenuListing -> None, 
       FontFamily -> $CellContext`Arial], 
      Cell[
       StyleData["ComputationInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{144, 10}, {10, 2}}, StyleMenuListing -> None], 
      Cell[
       StyleData["ProofInfo"], ShowCellBracket -> False, 
       CellMargins -> {{76, 10}, {6, 6}}, CellFrameLabelMargins -> 15, 
       StyleMenuListing -> None, FontFamily -> "Arial"], 
      Cell[
       StyleData["ProofInfoBody"], ShowCellBracket -> False, 
       CellMargins -> {{100, 10}, {0, 0}}, StyleMenuListing -> None], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["FrameLabel"], LanguageCategory -> None, StyleMenuListing -> 
          None, FontFamily -> "Times New Roman", FontSize -> 10, FontWeight -> 
          "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
          FontVariations -> {
           "Outline" -> False, "Shadow" -> False, "StrikeThrough" -> False, 
            "Underline" -> False}, FontColor -> RGBColor[0.55, 0.44, 0.42], 
          Background -> None, FontVariations -> {"Masked" -> False}], 
         Cell[
          StyleData["FrameLabel", "Printout"]]}, Open]], 
      Cell[
       StyleData["OpenArchive"], CellFrame -> {{False, False}, {False, True}},
        ShowCellBracket -> Automatic, CellMargins -> {{70, 70}, {0, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 20}, CellFrameMargins -> 3, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], CellFrameLabelMargins -> 1, 
       DefaultFormatType -> DefaultInputFormatType, ShowAutoStyles -> False, 
       MenuSortingValue -> 1210, FontWeight -> Bold, Background -> 
       RGBColor[0.73, 0.74, 0.84]], 
      Cell[
       StyleData["ArchiveInfo"], ShowCellBracket -> Automatic, 
       CellMargins -> {{70, 70}, {0, 0}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameMargins -> 5, CellFrameLabelMargins -> 3, ShowCellTags -> 
       False, ShowAutoStyles -> False, MenuSortingValue -> 1220, FontWeight -> 
       "Bold", Background -> RGBColor[0.88, 0.88, 0.92]], 
      Cell[
       StyleData["CloseArchive"], 
       CellFrame -> {{False, False}, {True, False}}, ShowCellBracket -> 
       Automatic, CellMargins -> {{0, 0}, {5, 10}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellGroupingRules -> {"SectionGrouping", 25}, CellFrameMargins -> 2, 
       CellFrameColor -> RGBColor[0.4, 0.4, 0.4], TextAlignment -> Center, 
       MenuSortingValue -> 1230, FontFamily -> "Arial Black", FontSize -> 24, 
       FontWeight -> "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       Background -> RGBColor[0.73, 0.65, 0.61]], 
      Cell[
       StyleData["IncludeArchive"], CellFrame -> {{4, 0}, {False, False}}, 
       ShowCellBracket -> Automatic, 
       CellMargins -> {{81, 100}, {Inherited, Inherited}}, 
       CellBracketOptions -> {"Color" -> RGBColor[0.73, 0.74, 0.84]}, 
       CellFrameColor -> RGBColor[0.55, 0.44, 0.42], 
       CellFrameLabels -> {{"\[RightSkeleton]", None}, {None, None}}, 
       CellFrameLabelMargins -> 25, MenuSortingValue -> 1445], 
      Cell[
       StyleData["ExpressionVariable"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionABF"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       StyleData["ExpressionMeta"], SingleLetterItalics -> True, 
       MultiLetterItalics -> True, FontColor -> RGBColor[0.29, 0.46, 0.6]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["AutoParentheses"], Editable -> False, SpanMaxSize -> 3, 
          FontOpacity -> 0.15], 
         Cell[
          StyleData["AutoParentheses", "Layout"], FontOpacity -> 0], 
         Cell[
          StyleData["AutoParentheses", "SlideShow"], FontOpacity -> 0]}, 
        Open]], 
      Cell[
       CellGroupData[{
         Cell[
          StyleData["Emphasized"], MenuCommandKey -> "E", FontSlant -> 
          "Italic"], 
         Cell[
          StyleData["Emphasized", "SlideShow"], FontSlant -> "Plain", 
          FontColor -> RGBColor[0.36, 0.54, 0.69]]}, Open]], 
      Cell[
       StyleData["GenericButton"], FontFamily -> "Bitstream Charter", 
       FontWeight -> "Plain", FontSlant -> "Italic", FontTracking -> "Plain", 
       FontVariations -> {
        "Outline" -> False, "Shadow" -> False, "StrikeThrough" -> False, 
         "Underline" -> False}, FontColor -> RGBColor[0.23, 0.25, 0.34], 
       FontVariations -> {"Masked" -> False}], 
      Cell[
       StyleData["TheoremaForm"], "TwoByteSyntaxCharacterAutoReplacement" -> 
       True, LineSpacing -> {1.25, 0, 2}, SingleLetterItalics -> True, 
       StyleMenuListing -> None, FontFamily -> "Courier"], 
      Cell[
       StyleData["ComponentActive"], FontFamily -> "Times New Roman"], 
      Cell[
       StyleData["ComponentInactive"], FontFamily -> "Times New Roman", 
       FontOpacity -> 0.4], 
      Cell[
       StyleData["ComponentEmpty"], FontFamily -> "Times New Roman", 
       FontVariations -> {"StrikeThrough" -> True}], 
      Cell[
       StyleData["TabView"], FontFamily -> "Times New Roman", FontSize -> 10], 
      Cell[
       StyleData["TabViewLabel"], FontFamily -> "Times New Roman", FontSize -> 
       10, FontWeight -> "Bold"], 
      Cell[
       StyleData["FormReference", StyleDefinitions -> StyleData["Text"]], 
       FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> "Plain",
        FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}], 
      Cell[
       StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
        FontFamily -> "Times New Roman", FontSize -> 12, FontWeight -> 
       "Plain", FontSlant -> "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> True}, 
       FontColor -> RGBColor[0.404, 0.43, 0.545]], 
      Cell[
       StyleData["DisplayFormula"], CellMargins -> {{36, 6}, {7, 7}}, 
       ConversionRules :> {
        "HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}}, 
       CellHorizontalScrolling -> True, DefaultFormatType -> TraditionalForm, 
       InputAutoReplacements -> {}, TextAlignment -> Center, FontFamily -> 
       "Bitstream Charter", FontSize -> 12, FontWeight -> "Plain", FontSlant -> 
       "Plain", 
       FontVariations -> {"StrikeThrough" -> False, "Underline" -> False}, 
       ButtonBoxOptions -> {Appearance -> {Automatic, None}}]}, Open]]}, 
  Visible -> False, FrontEndVersion -> 
  "11.1 for Linux x86 (64-bit) (April 18, 2017)", StyleDefinitions -> 
  "StylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "CoreEqual symmetric"->{
  Cell[5682, 151, 980, 27, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "57a8afbb-
   ae1c-41e8-8186-6761b7d61a49",
   CellTags->{"CoreEqual symmetric", "sym"},
   CellID->1696915507]},
 "sym"->{
  Cell[5682, 151, 980, 27, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "57a8afbb-
   ae1c-41e8-8186-6761b7d61a49",
   CellTags->{"CoreEqual symmetric", "sym"},
   CellID->1696915507]},
 "CoreEqual transitive forward"->{
  Cell[6665, 180, 985, 25, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "22e5a94b-
   e4b0-462f-8050-2ed3ab5c71fe",
   CellTags->"CoreEqual transitive forward",
   CellID->547733394]},
 "CoreEqual transitive backward"->{
  Cell[7653, 207, 987, 25, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "342d05e6-c955-4e10-871c-
   c75cf5d89760",
   CellTags->"CoreEqual transitive backward",
   CellID->479765905]},
 "CoreEqual transitive forward 2"->{
  Cell[8643, 234, 1096, 28, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "0c982efa-bf44-4aaf-
   b970-8310db663a75",
   CellTags->{"CoreEqual transitive forward 2", "trans"},
   CellID->141999747]},
 "trans"->{
  Cell[8643, 234, 1096, 28, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "0c982efa-bf44-4aaf-
   b970-8310db663a75",
   CellTags->{"CoreEqual transitive forward 2", "trans"},
   CellID->141999747],
  Cell[9742, 264, 1098, 28, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "
   bdfd2e8d-50e6-4458-8506-0375d71b74f2",
   CellTags->{"CoreEqual transitive backward 2", "trans"},
   CellID->816233139]},
 "CoreEqual transitive backward 2"->{
  Cell[9742, 264, 1098, 28, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "
   bdfd2e8d-50e6-4458-8506-0375d71b74f2",
   CellTags->{"CoreEqual transitive backward 2", "trans"},
   CellID->816233139]},
 "Proof|ID:1696915507-1"->{
  Cell[11085, 301, 1793, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "06ac16b6-8dfc-40cb-945f-80a2cb7a01d6",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:1696915507-1", "5"},
   CellID->1178144437]},
 "5"->{
  Cell[11085, 301, 1793, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "06ac16b6-8dfc-40cb-945f-80a2cb7a01d6",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:1696915507-1", "5"},
   CellID->1178144437],
  Cell[12881, 349, 1807, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "aa68f9af-f227-4bd4-927e-ca11e7f7bc83",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:547733394-1", "5"},
   CellID->155721987],
  Cell[14691, 397, 1810, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "dd80963d-9414-4d73-81ba-c9b8d97ff64d",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:479765905-1", "5"},
   CellID->1208240564],
  Cell[16504, 445, 1812, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "0252dfeb-6af0-4f7c-8a8c-45c6c583ed97",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:141999747-1", "5"},
   CellID->1142919876],
  Cell[18319, 493, 1813, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "2ba41a7c-b2dc-470f-a252-e0476a094838",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:816233139-1", "5"},
   CellID->437423969],
  Cell[27168, 721, 1742, 44, 
  28, "ProofInfo", "ExpressionUUID" -> "ab947a83-39ac-47c9-8912-156cc99329b4",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:1591861209-1", "5"},
   CellID->985202979]},
 "Proof|ID:547733394-1"->{
  Cell[12881, 349, 1807, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "aa68f9af-f227-4bd4-927e-ca11e7f7bc83",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:547733394-1", "5"},
   CellID->155721987]},
 "Proof|ID:479765905-1"->{
  Cell[14691, 397, 1810, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "dd80963d-9414-4d73-81ba-c9b8d97ff64d",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:479765905-1", "5"},
   CellID->1208240564]},
 "Proof|ID:141999747-1"->{
  Cell[16504, 445, 1812, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "0252dfeb-6af0-4f7c-8a8c-45c6c583ed97",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:141999747-1", "5"},
   CellID->1142919876]},
 "Proof|ID:816233139-1"->{
  Cell[18319, 493, 1813, 46, 
  28, "ProofInfo", "ExpressionUUID" -> "2ba41a7c-b2dc-470f-a252-e0476a094838",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:816233139-1", "5"},
   CellID->437423969]},
 "NOMATCH I"->{
  Cell[26106, 690, 816, 22, 
  51, "FormalTextInputFormula", "ExpressionUUID" -> "
   273480ab-5201-4d2c-9d9b-5686df09e735",
   CellTags->"NOMATCH I",
   CellID->1591861209]},
 "Proof|ID:1591861209-1"->{
  Cell[27168, 721, 1742, 44, 
  28, "ProofInfo", "ExpressionUUID" -> "ab947a83-39ac-47c9-8912-156cc99329b4",
   
   Evaluatable->True,
   CellTags->{"Proof|ID:1591861209-1", "5"},
   CellID->985202979]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"CoreEqual symmetric", 69117, 1596},
 {"sym", 69321, 1602},
 {"CoreEqual transitive forward", 69550, 1608},
 {"CoreEqual transitive backward", 69779, 1614},
 {"CoreEqual transitive forward 2", 70010, 1620},
 {"trans", 70229, 1626},
 {"CoreEqual transitive backward 2", 70681, 1637},
 {"Proof|ID:1696915507-1", 70917, 1643},
 {"5", 71130, 1650},
 {"Proof|ID:547733394-1", 72375, 1687},
 {"Proof|ID:479765905-1", 72605, 1694},
 {"Proof|ID:141999747-1", 72836, 1701},
 {"Proof|ID:816233139-1", 73067, 1708},
 {"NOMATCH I", 73286, 1715},
 {"Proof|ID:1591861209-1", 73490, 1721}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 202, 3, 84, "Title", "ExpressionUUID" -> \
"58d70843-36f7-4a42-ae16-484f4d2b76b5",
 CellID->789857065],
Cell[785, 27, 271, 6, 53, "Subsubtitle", "ExpressionUUID" -> \
"3168374c-85fd-441a-9aa7-0de95f54b390",
 CellID->1318729276],
Cell[1059, 35, 223, 3, 32, "Input", "ExpressionUUID" -> \
"384caccc-29e0-452e-8ee9-0936291d2387",
 CellID->2081197628],
Cell[CellGroupData[{
Cell[1307, 42, 173, 2, 57, "Section", "ExpressionUUID" -> \
"e993874c-d88f-4d3f-af04-ede89511bab0",
 CellID->412313213],
Cell[1483, 46, 230, 3, 52, "Code", "ExpressionUUID" -> \
"54149d81-4ddd-4a15-a88b-234768e58895",
 CellID->114623714],
Cell[1716, 51, 394, 7, 54, "Code", "ExpressionUUID" -> \
"564137fb-58d3-4146-aad1-6e7a1e64b452",
 CellID->398607118]
}, Closed]],
Cell[CellGroupData[{
Cell[2147, 63, 177, 2, 43, "Section", "ExpressionUUID" -> \
"df28b156-b493-4a97-8cc2-4cf99c93305b",
 CellID->891466572],
Cell[2327, 67, 2011, 45, 308, "Code", "ExpressionUUID" -> \
"ed7291aa-79d4-40be-b2d2-50a6eaf84247",
 CellID->1863625329]
}, Closed]],
Cell[CellGroupData[{
Cell[4375, 117, 236, 3, 43, "Section", "ExpressionUUID" -> \
"03cbe7df-b51c-42db-9658-684c7f06b3c7",
 CellID->1377567936],
Cell[4614, 122, 291, 5, 43, "TheoremaCode", "ExpressionUUID" -> \
"05b65b08-2a5d-4352-9430-e9c5c4a7a76a",
 CellID->996798660],
Cell[CellGroupData[{
Cell[4930, 131, 175, 2, 38, "Subsection", "ExpressionUUID" -> \
"ff0e2058-5a1f-4900-87d5-9bce0619b67d",
 CellID->1514539412],
Cell[5108, 135, 102, 1, 12, "OpenEnvironment", "ExpressionUUID" -> \
"dc059fa3-4f96-4a3c-9736-a098a5e7e996",
 CellID->222563640],
Cell[CellGroupData[{
Cell[5235, 140, 444, 9, 38, "EnvironmentHeader", "ExpressionUUID" -> \
"444b3fdb-3756-4ff8-b34e-ab069019d639",
 CellID->1340868144],
Cell[5682, 151, 980, 27, 51, "FormalTextInputFormula", "ExpressionUUID" -> \
"57a8afbb-ae1c-41e8-8186-6761b7d61a49",
 CellTags->{"CoreEqual symmetric", "sym"},
 CellID->1696915507],
Cell[6665, 180, 985, 25, 51, "FormalTextInputFormula", "ExpressionUUID" -> \
"22e5a94b-e4b0-462f-8050-2ed3ab5c71fe",
 CellTags->"CoreEqual transitive forward",
 CellID->547733394],
Cell[7653, 207, 987, 25, 51, "FormalTextInputFormula", "ExpressionUUID" -> \
"342d05e6-c955-4e10-871c-c75cf5d89760",
 CellTags->"CoreEqual transitive backward",
 CellID->479765905],
Cell[8643, 234, 1096, 28, 51, "FormalTextInputFormula", "ExpressionUUID" -> \
"0c982efa-bf44-4aaf-b970-8310db663a75",
 CellTags->{"CoreEqual transitive forward 2", "trans"},
 CellID->141999747],
Cell[9742, 264, 1098, 28, 51, "FormalTextInputFormula", "ExpressionUUID" -> \
"bdfd2e8d-50e6-4458-8506-0375d71b74f2",
 CellTags->{"CoreEqual transitive backward 2", "trans"},
 CellID->816233139],
Cell[10843, 294, 121, 1, 23, "EndEnvironmentMarker", "ExpressionUUID" -> \
"d9f1073a-f6ea-4844-b826-ad40b3ea663d",
 CellID->1551395378]
}, Open  ]],
Cell[10979, 298, 103, 1, 16, "CloseEnvironment", "ExpressionUUID" -> \
"c1f15026-3a07-4d83-a802-e875cab49ec6",
 CellID->926352679],
Cell[11085, 301, 1793, 46, 28, "ProofInfo", "ExpressionUUID" -> \
"06ac16b6-8dfc-40cb-945f-80a2cb7a01d6",
 Evaluatable->True,
 CellTags->{"Proof|ID:1696915507-1", "5"},
 CellID->1178144437],
Cell[12881, 349, 1807, 46, 28, "ProofInfo", "ExpressionUUID" -> \
"aa68f9af-f227-4bd4-927e-ca11e7f7bc83",
 Evaluatable->True,
 CellTags->{"Proof|ID:547733394-1", "5"},
 CellID->155721987],
Cell[14691, 397, 1810, 46, 28, "ProofInfo", "ExpressionUUID" -> \
"dd80963d-9414-4d73-81ba-c9b8d97ff64d",
 Evaluatable->True,
 CellTags->{"Proof|ID:479765905-1", "5"},
 CellID->1208240564],
Cell[16504, 445, 1812, 46, 28, "ProofInfo", "ExpressionUUID" -> \
"0252dfeb-6af0-4f7c-8a8c-45c6c583ed97",
 Evaluatable->True,
 CellTags->{"Proof|ID:141999747-1", "5"},
 CellID->1142919876],
Cell[18319, 493, 1813, 46, 28, "ProofInfo", "ExpressionUUID" -> \
"2ba41a7c-b2dc-470f-a252-e0476a094838",
 Evaluatable->True,
 CellTags->{"Proof|ID:816233139-1", "5"},
 CellID->437423969]
}, Closed]],
Cell[CellGroupData[{
Cell[20169, 544, 172, 2, 30, "Subsection", "ExpressionUUID" -> \
"af6a4919-7b4b-4410-857d-291c497e2f85",
 CellID->604245228],
Cell[20344, 548, 451, 10, 45, "TheoremaCode", "ExpressionUUID" -> \
"f5bb0b24-0444-49b4-b26b-6073fb6c95db",
 CellID->414106688],
Cell[20798, 560, 277, 5, 24, "Text", "ExpressionUUID" -> \
"595cc5a6-0b72-4436-865f-e1aac5e88441",
 CellID->98671853],
Cell[21078, 567, 4442, 104, 551, "Code", "ExpressionUUID" -> \
"10c56c24-654a-4e09-9935-31187168cc8d",
 CellID->1061661890],
Cell[25523, 673, 103, 1, 12, "OpenEnvironment", "ExpressionUUID" -> \
"bd551dea-408e-40f1-93f1-0c164a43d170",
 CellID->1848103537],
Cell[CellGroupData[{
Cell[25651, 678, 452, 10, 38, "EnvironmentHeader", "ExpressionUUID" -> \
"475123ef-20b3-4222-b4d7-e58c8a18df9b",
 CellID->1219727102],
Cell[26106, 690, 816, 22, 51, "FormalTextInputFormula", "ExpressionUUID" -> \
"273480ab-5201-4d2c-9d9b-5686df09e735",
 CellTags->"NOMATCH I",
 CellID->1591861209],
Cell[26925, 714, 121, 1, 23, "EndEnvironmentMarker", "ExpressionUUID" -> \
"4896c89f-851a-4edd-aa69-128b714a9f9d",
 CellID->1092825495]
}, Open  ]],
Cell[27061, 718, 104, 1, 16, "CloseEnvironment", "ExpressionUUID" -> \
"18ce8e56-7b67-4726-8c23-0f86670b3dac",
 CellID->1707983279],
Cell[27168, 721, 1742, 44, 28, "ProofInfo", "ExpressionUUID" -> \
"ab947a83-39ac-47c9-8912-156cc99329b4",
 Evaluatable->True,
 CellTags->{"Proof|ID:1591861209-1", "5"},
 CellID->985202979]
}, Closed]],
Cell[CellGroupData[{
Cell[28947, 770, 166, 2, 30, "Subsection", "ExpressionUUID" -> \
"9a51722d-89f8-4480-a9ba-34a170bcf807",
 CellID->34124658],
Cell[29116, 774, 375, 6, 24, "Text", "ExpressionUUID" -> \
"fcedfa9b-5b46-4999-9f58-bc4fdcfce8e6",
 CellID->572435876],
Cell[29494, 782, 391, 8, 66, "TheoremaCode", "ExpressionUUID" -> \
"fdeae0f0-7dec-42ef-a962-3f1583c1ab8b",
 CellID->74339585]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

