(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11092,        293]
NotebookOptionsPosition[      9515,        249]
NotebookOutlinePosition[     10115,        269]
CellTagsIndexPosition[     10072,        266]
WindowTitle->Proof of (drinker paradox)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"proof", " ", 
  RowBox[{"(", 
   RowBox[{"rule", " ", "\"\<case dist\>\""}], ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.698834583473626*^9, 3.6988346353965263`*^9}, {
  3.69942074998153*^9, 3.6994207645635443`*^9}, {3.7305402324573812`*^9, 
  3.730540232921371*^9}},
 CellID->168609965,ExpressionUUID->"8cbf71d2-b7cf-4117-a7e5-27e864dafae7"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{
    RowBox[{"case", " ", "\"\<everybody drinks\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      UnderscriptBox["\[ForAll]", 
       RowBox[{"pub", "[", "x", "]"}]], 
      RowBox[{"drinks", "[", "x", "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705389876877239*^9, 3.705389908090958*^9}, {
  3.730540239114056*^9, 3.730540240714714*^9}},
 CellID->1313591854,ExpressionUUID->"ba4bfa0c-6158-46d1-9710-11ac11abc117"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", "_", " ", "by", " ", 
    RowBox[{"(", 
     RowBox[{"rule", ",", " ", "rule", ",", " ", 
      RowBox[{"rule", " ", "\"\<everybody drinks\>\""}], ",", " ", 
      RowBox[{"fact", " ", "\"\<joe in pub\>\""}]}], ")"}]}], "\n", 
   RowBox[{"(*", "next", "*)"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.699427252372854*^9, 3.6994273206623955`*^9}, {
  3.705291845903255*^9, 3.7052918667671547`*^9}, {3.7053809080784073`*^9, 
  3.705381022575151*^9}, {3.7053810751742783`*^9, 3.705381078431367*^9}, {
  3.7130888300130367`*^9, 3.7130888439895353`*^9}, {3.7305402477061234`*^9, 
  3.730540275057988*^9}, {3.730540351819042*^9, 3.7305403538512774`*^9}, {
  3.730540394836864*^9, 3.730540396518963*^9}},
 CellID->498506874,ExpressionUUID->"116610ab-1b43-41d8-8cac-822fd0060a58"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"case", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      TagBox["\[Not]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Not$TM, {}]],
       SyntaxForm->"\[Not]x"], 
      RowBox[{
       TagBox["(",
        "AutoParentheses"], 
       RowBox[{
        UnderscriptBox[
         TagBox["\[ForAll]",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
           Theorema`Language`Forall$TM, {Theorema`Knowledge`PERSON$TM}]]], 
         RowBox[{
          TagBox["pub",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`pub$TM, {}]]], "[", 
          TagBox[
           StyleBox["x", "ExpressionVariable"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`PERSON$TM]]], "]"}]], 
        
        RowBox[{
         TagBox["drinks",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
            Theorema`Language`FUN$TM[
            Theorema`Knowledge`PERSON$TM, Theorema`Knowledge`BOOL$TM]]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`PERSON$TM]]], "]"}]}], 
       
       TagBox[")",
        "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.6994277703618155`*^9, 3.699427811568836*^9}, {
   3.699427856541876*^9, 3.699427860018648*^9}, {3.705389928531295*^9, 
   3.705389939891058*^9}, 3.7305404101055183`*^9},
 CellID->625282970,ExpressionUUID->"023cb92d-9c84-493f-b0b3-8023edff68d9"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     UnderscriptBox["\[Exists]", 
      RowBox[{"pub", "[", "x", "]"}]], 
     RowBox[{"\[Not]", 
      RowBox[{"drinks", "[", "x", "]"}]}]}], "\[CloseCurlyQuote]"}], " ", 
   "by", " ", "simp"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.699427863311562*^9, 3.699427955880608*^9}, {
   3.705389948051436*^9, 3.7053899645531273`*^9}, 3.713088850860374*^9, {
   3.730540422724123*^9, 3.730540424372786*^9}, {3.730540522909265*^9, 
   3.7305405308129187`*^9}},
 CellID->22764760,ExpressionUUID->"3c304180-e853-4aa9-ad82-60a82b80d2d0"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"then", " ", "obtain", " ", 
    FormBox[
     StyleBox["x", "ExpressionABF"],
     TheoremaForm]}], "\n", "\t\t", 
   RowBox[{
    RowBox[{"where", " ", "\"\<x in pub\>\""}], ":", " ", 
    RowBox[{
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{"pub", "[", 
       FormBox[
        StyleBox["x", "ExpressionABF"],
        TheoremaForm], "]"}], "\[CloseCurlyQuote]"}], " ", "and", " ", 
     "\"\<x does not drink\>\""}], ":", " ", 
    RowBox[{
     RowBox[{"\[OpenCurlyQuote]", 
      RowBox[{"\[Not]", 
       RowBox[{"drinks", "[", 
        FormBox[
         StyleBox["x", "ExpressionABF"],
         TheoremaForm], "]"}]}], "\[CloseCurlyQuote]"}], " ", 
     ".."}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.699427970688034*^9, 3.6994280106479435`*^9}, {
   3.6995054574883184`*^9, 3.6995054699923544`*^9}, {3.6995056880637455`*^9, 
   3.699505720683303*^9}, 3.699505755976949*^9, {3.699505812747855*^9, 
   3.6995058172338977`*^9}, {3.6995062946289377`*^9, 3.699506358387026*^9}, 
   3.699506737893177*^9, 3.705291900631641*^9, {3.705291942623599*^9, 
   3.7052919894477377`*^9}, 3.705292057807959*^9, {3.705381117659142*^9, 
   3.705381118097148*^9}, {3.705389958435433*^9, 3.7053899588350573`*^9}, 
   3.712638925516927*^9, {3.713088859923923*^9, 3.713088864972327*^9}, {
   3.7305405377335367`*^9, 3.730540545989805*^9}},
 CellID->4317400,ExpressionUUID->"9bdf4aa7-686a-45e3-b2d6-1a14a286098d"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", "_"}], "\n", "\t", 
   RowBox[{"proof", " ", 
    RowBox[{"(", 
     RowBox[{"rule", ",", " ", "rule"}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.6995062538346915`*^9, 3.6995062714189076`*^9}, {
  3.705381138343588*^9, 3.705381153071424*^9}, {3.713088870935966*^9, 
  3.713088873549088*^9}, {3.730540553509672*^9, 3.730540567525527*^9}, {
  3.730540604526224*^9, 3.730540610166627*^9}, {3.730540656980184*^9, 
  3.730540659455134*^9}},
 CellID->55413291,ExpressionUUID->"7be22491-75f2-4807-9d23-d204ebe2c253"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"from", " ", "\"\<x does not drink\>\"", " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["drinks",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`Rule$TM[
         Theorema`Knowledge`PERSON$TM, Theorema`Knowledge`BOOL$TM]]]], "[", 
      TagBox[
       StyleBox["x", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`PERSON$TM]]], "]"}], 
     TagBox["\[LongRightArrow]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`LongRightArrow$TM, {}]],
      SyntaxForm->"x\[LongRightArrow]y"], 
     RowBox[{
      TagBox["(",
       "AutoParentheses"], 
      RowBox[{
       UnderscriptBox[
        TagBox["\[ForAll]",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
          Theorema`Language`Forall$TM, {Theorema`Knowledge`PERSON$TM}]]], 
        RowBox[{
         TagBox["pub",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`pub$TM, {}]]], "[", 
         TagBox[
          StyleBox["x", "ExpressionVariable"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`PERSON$TM]]], "]"}]], 
       RowBox[{
        TagBox["drinks",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
           Theorema`Language`FUN$TM[
           Theorema`Knowledge`PERSON$TM, Theorema`Knowledge`BOOL$TM]]]], "[", 
        
        TagBox[
         StyleBox["x", "ExpressionVariable"],
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[Theorema`Knowledge`PERSON$TM]]], "]"}]}], 
      TagBox[")",
       "AutoParentheses"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[Not]E\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.6995064518260365`*^9, 3.6995065042974424`*^9}, {
  3.6995065903421464`*^9, 3.699506595688368*^9}, {3.6995069428336787`*^9, 
  3.699506953194811*^9}, {3.699767381898036*^9, 3.699767394874126*^9}, {
  3.705390015793436*^9, 3.705390023843555*^9}, {3.730540671509573*^9, 
  3.7305407085424213`*^9}, {3.730540773416807*^9, 3.730540774856908*^9}},
 CellID->737035727,ExpressionUUID->"f79dbe93-f6e5-47d7-b685-e066262468d7"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"qed", " ", "fact"}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.7305407821423197`*^9, 3.73054078507242*^9}},
 CellID->1983331133,ExpressionUUID->"1e737633-f38f-4079-9b61-61b1e9bcee7e"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (drinker paradox)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 387, 8, 18, "ProofText", "ExpressionUUID" -> \
"8cbf71d2-b7cf-4117-a7e5-27e864dafae7",
 CellID->168609965],
Cell[988, 31, 549, 14, 30, "ProofText", "ExpressionUUID" -> \
"ba4bfa0c-6158-46d1-9710-11ac11abc117",
 CellID->1313591854],
Cell[1540, 47, 856, 16, 41, "ProofText", "ExpressionUUID" -> \
"116610ab-1b43-41d8-8cac-822fd0060a58",
 CellID->498506874],
Cell[2399, 65, 1694, 46, 35, "ProofText", "ExpressionUUID" -> \
"023cb92d-9c84-493f-b0b3-8023edff68d9",
 CellID->625282970],
Cell[4096, 113, 649, 15, 30, "ProofText", "ExpressionUUID" -> \
"3c304180-e853-4aa9-ad82-60a82b80d2d0",
 CellID->22764760],
Cell[4748, 130, 1478, 34, 39, "ProofText", "ExpressionUUID" -> \
"9bdf4aa7-686a-45e3-b2d6-1a14a286098d",
 CellID->4317400],
Cell[6229, 166, 602, 13, 41, "ProofText", "ExpressionUUID" -> \
"7be22491-75f2-4807-9d23-d204ebe2c253",
 CellID->55413291],
Cell[6834, 181, 2342, 57, 35, "ProofText", "ExpressionUUID" -> \
"f79dbe93-f6e5-47d7-b685-e066262468d7",
 CellID->737035727],
Cell[9179, 240, 332, 7, 19, "ProofText", "ExpressionUUID" -> \
"1e737633-f38f-4079-9b61-61b1e9bcee7e",
 CellID->1983331133]
}
]
*)

