(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     38998,       1083]
NotebookOptionsPosition[     33823,        955]
NotebookOutlinePosition[     34417,        975]
CellTagsIndexPosition[     34374,        972]
WindowTitle->Proof of (isLimit +)
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"apply", " ", 
  RowBox[{"(", 
   RowBox[{"intro", " ", "\"\<\[ForAll]I\>\"", " ", "\"\<\[Implies]I\>\""}], 
   ")"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705294365072688*^9, 3.705294376570024*^9}, 
   3.705294467474275*^9, {3.705294501762525*^9, 3.705294531378818*^9}, 
   3.7130889210620747`*^9, {3.730539291494494*^9, 3.7305392926222677`*^9}},
 CellID->561321545,ExpressionUUID->"b1dada69-2ada-4c68-8829-b1b49f6416b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fix", " ", 
   FormBox[
    StyleBox["f", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["g", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["a", "ExpressionABF"],
    TheoremaForm], " ", 
   FormBox[
    StyleBox["b", "ExpressionABF"],
    TheoremaForm]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705294477456929*^9, 3.7052944888373413`*^9}},
 CellID->359224460,ExpressionUUID->"64d794b3-2e9b-4f58-8a8a-f936937822ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"assume", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      TagBox["isLimit",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`isLimit$TM, {}]]], "[", 
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`Rule$TM[
          Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], ",", 
       TagBox[
        StyleBox["a", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}], "]"}], 
     TagBox["\[And]",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Language`And$TM, {}]],
      SyntaxForm->"x\[And]y"], 
     RowBox[{
      TagBox["isLimit",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`isLimit$TM, {}]]], "[", 
      RowBox[{
       TagBox[
        StyleBox["g", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`Rule$TM[
          Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], ",", 
       TagBox[
        StyleBox["b", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}], "]"}]}], 
    "\[CloseCurlyQuote]"}]}], ";"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705294598706375*^9, 3.7052946086154747`*^9}},
 CellID->136798322,ExpressionUUID->"920021b8-605b-4ab4-a3c5-1ec3e5b41271"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hence", " ", "\"\<lim f\>\""}], ":", " ", 
  RowBox[{
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox["isLimit",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`isLimit$TM, {}]]], "[", 
     RowBox[{
      TagBox[
       StyleBox["f", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`Rule$TM[
         Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], ",", 
      TagBox[
       StyleBox["a", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}], "]"}], 
    "\[CloseCurlyQuote]"}], " ", "and", " ", "\"\<lim g\>\""}], ":", " ", 
  RowBox[{
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox["isLimit",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`isLimit$TM, {}]]], "[", 
     RowBox[{
      TagBox[
       StyleBox["g", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`Rule$TM[
         Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], ",", 
      TagBox[
       StyleBox["b", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}], "]"}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rule", " ", "\"\<\[And]D1\>\""}], ",", " ", 
     RowBox[{"rule", " ", "\"\<\[And]D2\>\""}]}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052946458192873`*^9, 3.705294684011409*^9}, {
  3.7052965849235067`*^9, 3.705296605235725*^9}, {3.7305393068550043`*^9, 
  3.730539307758691*^9}},
 CellID->805597599,ExpressionUUID->"6ab799be-5e45-4d09-b895-e41be93ba8c0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox["isLimit",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`isLimit$TM, {}]]], "[", 
     RowBox[{
      RowBox[{
       TagBox[
        StyleBox["f", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`Rule$TM[
          Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], 
       TagBox["+",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`Plus$TM, {
           Theorema`Language`Rule$TM[
           Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]}]],
        SyntaxForm->"x+y"], 
       TagBox[
        StyleBox["g", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
          Theorema`Language`Rule$TM[
          Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]]}], ",", 
      RowBox[{
       TagBox[
        StyleBox["a", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]], 
       TagBox["+",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
         Theorema`Language`Plus$TM, {Theorema`Knowledge`REAL$TM}]],
        SyntaxForm->"x+y"], 
       TagBox[
        StyleBox["b", "ExpressionABF"],
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}]}], "]"}], 
    "\[CloseCurlyQuote]"}], " ", "unfolding", " ", "\"\<isLimit\>\""}], 
  ";"}], "\n", "proof"}], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705294692245707*^9, 3.7052947028960047`*^9}, {
  3.705383351317162*^9, 3.705383351882698*^9}, {3.706259200140253*^9, 
  3.706259207643935*^9}, {3.7084066976861677`*^9, 3.708406708638283*^9}, {
  3.711858372563569*^9, 3.711858388414291*^9}, {3.711858442363412*^9, 
  3.71185845308363*^9}, {3.713088931935903*^9, 3.713088935875436*^9}},
 CellID->943477530,ExpressionUUID->"38e00314-6621-4502-9029-59ddeafa7f0a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["\[Epsilon]", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705294735532352*^9, 3.705294740675466*^9}},
 CellID->1402248063,ExpressionUUID->"325d59be-a236-4c72-addb-bed35a495c9a"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"assume", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], " ", ">", " ", "0"}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705294743353756*^9, 3.70529475762789*^9}, {
   3.705295524847921*^9, 3.705295529799881*^9}, 3.705298754776885*^9},
 CellID->1838462798,ExpressionUUID->"5d37033a-7c55-4290-aba5-7c4e4abf47c6"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"hence", " ", "\"\<pos\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["\[Epsilon]", "ExpressionABF"],
        TheoremaForm], " ", "/", " ", "2"}], " ", ">", " ", "0"}], 
     "\[CloseCurlyQuote]"}], " ", "by", " ", 
    RowBox[{"(", 
     RowBox[{"rule", " ", "\"\<half > 0\>\""}], ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705298758421583*^9, 3.7052988042445498`*^9}, {
  3.705298897945323*^9, 3.705298900205166*^9}},
 CellID->224489026,ExpressionUUID->"7ef6c504-1c5c-47f0-a098-1ec07ad6b250"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"with", " ", "\"\<lim f\>\"", " ", "have"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.70529526604576*^9, 3.7052953384808273`*^9}, {
  3.705295429014681*^9, 3.7052954294304247`*^9}, {3.70583374740812*^9, 
  3.705833747951909*^9}},
 CellID->2021715415,ExpressionUUID->"97113628-a747-4fa4-86c6-cd8e62394760"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[Exists]", "m"], 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", "n"], 
     RowBox[{"n", "\[GreaterEqual]", "m"}]], 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], "/", "2"}], ">", 
     RowBox[{"\[LeftBracketingBar]", 
      RowBox[{
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "-", 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", "n", "]"}]}], "\[RightBracketingBar]"}]}]}]}], 
  ";"}]], "FormalTextInputFormula",
 CellChangeTimes->{{3.705295737855782*^9, 3.705295746946781*^9}, {
  3.705298910645089*^9, 3.705298910925165*^9}},
 CellID->39847309,ExpressionUUID->"36cf6d3c-454e-498b-b79b-969e789a17eb"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"unfolding", " ", "\"\<isLimit\>\"", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[ForAll]CD\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295756417201*^9, 3.705295771504005*^9}, 
   3.705297298918363*^9, {3.7058337776880903`*^9, 3.7058338156004887`*^9}, {
   3.705833928817046*^9, 3.7058339418807383`*^9}, {3.705834792619413*^9, 
   3.705834793917404*^9}, 3.713088945990059*^9},
 CellID->1619842134,ExpressionUUID->"9de86e5a-62e6-47cb-8dd9-ea77bbe8e19f"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"then", " ", "obtain", " ", 
   FormBox[
    StyleBox["m1", "ExpressionABF"],
    TheoremaForm], " ", "where"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295780471752*^9, 3.7052957954104347`*^9}, {
  3.705295890099544*^9, 3.705295890200898*^9}},
 CellID->507000229,ExpressionUUID->"61731cc9-9c21-4b23-bce4-2f84bdfbaf31"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\"\<f1\>\"", ":", 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", "n"], 
     RowBox[{"n", "\[GreaterEqual]", 
      FormBox[
       StyleBox["m1", "ExpressionABF"],
       TheoremaForm]}]], 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], "/", "2"}], ">", 
     RowBox[{"\[LeftBracketingBar]", 
      RowBox[{
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], "-", 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", "n", "]"}]}], "\[RightBracketingBar]"}]}]}]}], 
  ";"}]], "FormalTextInputFormula",
 CellChangeTimes->{{3.7052958033890657`*^9, 3.7052958057690573`*^9}, {
  3.705295845451799*^9, 3.7052958484564533`*^9}, {3.705295892778619*^9, 
  3.7052958928896723`*^9}, {3.70529891849317*^9, 3.705298918725305*^9}},
 CellID->766962253,ExpressionUUID->"f428d488-2408-4bc3-9e00-81094d702061"],

Cell[BoxData[
 RowBox[{"\t\t", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295811391323*^9, 3.705295822376226*^9}, 
   3.705297300270302*^9, 3.7126390860068007`*^9, {3.713088955302178*^9, 
   3.713088955446041*^9}},
 CellID->1153211963,ExpressionUUID->"a0015c47-260c-47c8-b4d8-8454adeb7908"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
  "from", " ", "\"\<lim g\>\"", " ", "\"\<pos\>\"", " ", 
   "have"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052957209039297`*^9, 3.705295730487792*^9}, 
   3.705298922853588*^9, {3.705834828876561*^9, 3.705834830732544*^9}},
 CellID->1514984103,ExpressionUUID->"aeba9769-beb4-4602-b05d-0e972de3d8c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderscriptBox["\[Exists]", "m"], 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", "n"], 
     RowBox[{"n", "\[GreaterEqual]", "m"}]], 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], "/", "2"}], ">", 
     RowBox[{"\[LeftBracketingBar]", 
      RowBox[{
       FormBox[
        StyleBox["b", "ExpressionABF"],
        TheoremaForm], "-", 
       RowBox[{
        FormBox[
         StyleBox["g", "ExpressionABF"],
         TheoremaForm], "[", "n", "]"}]}], "\[RightBracketingBar]"}]}]}]}], 
  ";"}]], "FormalTextInputFormula",
 CellChangeTimes->{{3.705295737855782*^9, 3.705295746946781*^9}, {
  3.705295881378086*^9, 3.705295882682016*^9}, {3.70529892510913*^9, 
  3.7052989253413677`*^9}},
 CellID->647268103,ExpressionUUID->"5d4cda22-7034-4bda-bc4c-8ad9195737c2"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"unfolding", " ", "\"\<isLimit\>\"", " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[ForAll]CD\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295756417201*^9, 3.705295771504005*^9}, 
   3.7052972923378267`*^9, {3.7058348350283813`*^9, 3.705834840020344*^9}, 
   3.713088959845852*^9},
 CellID->1219596540,ExpressionUUID->"0574ec19-0794-4c20-8b05-bd05cbb3b116"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{"then", " ", "obtain", " ", 
   FormBox[
    StyleBox["m2", "ExpressionABF"],
    TheoremaForm], " ", "where"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295780471752*^9, 3.7052957954104347`*^9}, {
  3.705295899769085*^9, 3.7052958998889647`*^9}},
 CellID->1910978749,ExpressionUUID->"05ad63b8-4669-4d07-8849-84a6421063ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\"\<g1\>\"", ":", 
   RowBox[{
    UnderscriptBox[
     UnderscriptBox["\[ForAll]", "n"], 
     RowBox[{"n", "\[GreaterEqual]", 
      FormBox[
       StyleBox["m2", "ExpressionABF"],
       TheoremaForm]}]], 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], "/", "2"}], ">", 
     RowBox[{"\[LeftBracketingBar]", 
      RowBox[{
       FormBox[
        StyleBox["b", "ExpressionABF"],
        TheoremaForm], "-", 
       RowBox[{
        FormBox[
         StyleBox["g", "ExpressionABF"],
         TheoremaForm], "[", "n", "]"}]}], "\[RightBracketingBar]"}]}]}]}], 
  ";"}]], "FormalTextInputFormula",
 CellChangeTimes->{{3.7052958033890657`*^9, 3.7052958057690573`*^9}, {
  3.705295845451799*^9, 3.7052958484564533`*^9}, {3.705295902128777*^9, 
  3.705295912594489*^9}, {3.705298929989204*^9, 3.705298930277391*^9}},
 CellID->2042672109,ExpressionUUID->"c890c726-9a95-435f-8887-0e50524d7477"],

Cell[BoxData[
 RowBox[{"\t\t", ".."}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295811391323*^9, 3.705295822376226*^9}, 
   3.705297290845142*^9, 3.7126390924149103`*^9, {3.713088963199565*^9, 
   3.71308896334277*^9}},
 CellID->1922893659,ExpressionUUID->"183fe8fe-8e87-4329-8edf-d2aded5dc6ec"],

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{
   RowBox[{"show", " ", "_"}], "\n", "\t", "proof"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705295947765066*^9, 3.705295974448823*^9}, 
   3.713088966520759*^9},
 CellID->718508470,ExpressionUUID->"4648c527-2b62-491e-ae07-be8d242ce734"],

Cell[BoxData[
 RowBox[{"\t\t", "show"}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705296133969975*^9, 3.7052961422176933`*^9}},
 CellID->718794428,ExpressionUUID->"84ad9fdb-ad58-4573-815b-b3267bf9768e"],

Cell[BoxData[
 RowBox[{"\t", 
  StyleBox[
   FormBox[
    RowBox[{
     UnderscriptBox[
      UnderscriptBox[
       TagBox["\[ForAll]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
         Theorema`Language`Forall$TM, {Theorema`Knowledge`NAT$TM}]]], "n"], 
      RowBox[{"n", "\[GreaterEqual]", 
       RowBox[{"max", "[", 
        RowBox[{
         FormBox[
          StyleBox["m1", "ExpressionABF"],
          TheoremaForm], ",", 
         FormBox[
          StyleBox["m2", "ExpressionABF"],
          TheoremaForm]}], "]"}]}]], 
     RowBox[{
      TagBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[
         Theorema`Language`Rule$TM[
         Theorema`Knowledge`REAL$TM, Theorema`Knowledge`REAL$TM]]]], 
      TagBox[">",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`Greater$TM, {
          Theorema`Language`Rule$TM[
          Theorema`Knowledge`REAL$TM, Theorema`Knowledge`REAL$TM]}]],
       SyntaxForm->"x>y"], 
      RowBox[{
       TagBox["\[LeftBracketingBar]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`BracketingBar$TM, {}]],
        SyntaxForm->"("], 
       RowBox[{
        RowBox[{
         TagBox["(",
          "AutoParentheses"], 
         RowBox[{
          TagBox[
           StyleBox["a", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]], 
          TagBox["+",
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
            Theorema`Language`Plus$TM, {Theorema`Knowledge`REAL$TM}]],
           SyntaxForm->"x+y"], 
          TagBox[
           StyleBox["b", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}], 
         TagBox[")",
          "AutoParentheses"]}], 
        TagBox["-",
         Theorema`Language`TAG$[
          Theorema`Language`TYPED$[
          Theorema`Language`Subtract$TM, {Theorema`Knowledge`REAL$TM}]],
         SyntaxForm->"x-y"], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FormBox[
            StyleBox["f", "ExpressionABF"],
            TheoremaForm], "+", 
           FormBox[
            StyleBox["g", "ExpressionABF"],
            TheoremaForm]}], ")"}], "[", "n", "]"}]}], 
       TagBox["\[RightBracketingBar]",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[Theorema`Language`BracketingBar$TM, {}]],
        SyntaxForm->")"]}]}]}],
    TheoremaForm],
   Selectable->True]}]], "FormalTextInputFormula",
 CellChangeTimes->{{3.705296158161557*^9, 3.705296214403137*^9}, {
  3.705296304699993*^9, 3.7052963172762947`*^9}},
 CellID->604217469,ExpressionUUID->"bc061355-e8d8-48f7-a706-79fabeb58668"],

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{"proof", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"simp", ":", " ", "\"\<+ fun\>\""}], ",", " ", "rule"}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705296246418785*^9, 3.705296255890283*^9}, {
   3.7053023916032543`*^9, 3.705302396899321*^9}, 3.7130889705926456`*^9},
 CellID->563753406,ExpressionUUID->"4ffece00-c95f-45d8-b6d0-e7c2f3aa7784"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"fix", " ", 
    FormBox[
     StyleBox["n", "ExpressionABF"],
     TheoremaForm]}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705296261655435*^9, 3.705296268868833*^9}},
 CellID->476936952,ExpressionUUID->"25d42059-2109-456d-a1fc-6da2519ac0ca"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{
    RowBox[{"assume", " ", "\"\<n\>\""}], ":", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["n", "ExpressionABF"],
       TheoremaForm], " ", "\[GreaterEqual]", " ", 
      RowBox[{"max", "[", 
       RowBox[{
        FormBox[
         StyleBox["m1", "ExpressionABF"],
         TheoremaForm], ",", " ", 
        FormBox[
         StyleBox["m2", "ExpressionABF"],
         TheoremaForm]}], "]"}]}], "\[CloseCurlyQuote]"}]}], 
   ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052962715863867`*^9, 3.705296291778863*^9}, {
  3.705296648693864*^9, 3.705296654059855*^9}, {3.705298055852674*^9, 
  3.70529805747931*^9}},
 CellID->1349348616,ExpressionUUID->"7dbc27da-11a5-4721-97a9-860696193ddf"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"also", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Ellipsis]", " ", "\[GreaterEqual]", " ", 
     FormBox[
      StyleBox["m1", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"fact", " ", "\"\<max\[GreaterEqual] 1\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052966564078217`*^9, 3.7052967220919847`*^9}, {
  3.705296853119081*^9, 3.705296856540587*^9}},
 CellID->1968320060,ExpressionUUID->"074b61e2-4988-4d70-b2f4-b22afb87d375"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"finally", 
    RowBox[{"(", "\"\<\[GreaterEqual] trans\>\"", ")"}], " ", "have", " ", 
    "\"\<n1\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["n", "ExpressionABF"],
       TheoremaForm], " ", "\[GreaterEqual]", " ", 
      FormBox[
       StyleBox["m1", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052968648087187`*^9, 3.7052968885994463`*^9}, {
  3.705296959789147*^9, 3.7052969666612177`*^9}, {3.7052978177846537`*^9, 
  3.7052978197764273`*^9}, {3.705298034121586*^9, 3.705298062425865*^9}},
 CellID->694762913,ExpressionUUID->"1333b24d-d059-451b-88b6-66941c7b4966"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"note", " ", "\"\<n\>\""}], ";"}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705378487420051*^9, 3.705378493787998*^9}},
 CellID->742127147,ExpressionUUID->"c86fb7c0-80a0-4c4e-aca7-5f65fef94597"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"also", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{"\[Ellipsis]", " ", "\[GreaterEqual]", " ", 
     FormBox[
      StyleBox["m2", "ExpressionABF"],
      TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"fact", " ", "\"\<max\[GreaterEqual] 2\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7053784989545813`*^9, 3.7053785269323597`*^9}},
 CellID->1654898217,ExpressionUUID->"5b6fc9ef-baa3-4fa8-a072-c3b0f19a3718"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"finally", 
    RowBox[{"(", "\"\<\[GreaterEqual] trans\>\"", ")"}], " ", "have", " ", 
    "\"\<n2\>\""}], ":", " ", 
   RowBox[{
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{
      FormBox[
       StyleBox["n", "ExpressionABF"],
       TheoremaForm], " ", "\[GreaterEqual]", " ", 
      FormBox[
       StyleBox["m2", "ExpressionABF"],
       TheoremaForm]}], "\[CloseCurlyQuote]"}], " ", "."}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7053785322195387`*^9, 3.705378568516498*^9}},
 CellID->250540774,ExpressionUUID->"de3b80c7-d9dc-44bf-8006-314f60a10346"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"from", " ", "\"\<f1\>\"", " ", "\"\<n1\>\"", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], "/", "2"}], " ", ">", " ", 
     RowBox[{"\[LeftBracketingBar]", 
      RowBox[{
       FormBox[
        StyleBox["a", "ExpressionABF"],
        TheoremaForm], " ", "-", " ", 
       RowBox[{
        FormBox[
         StyleBox["f", "ExpressionABF"],
         TheoremaForm], "[", 
        FormBox[
         StyleBox["n", "ExpressionABF"],
         TheoremaForm], "]"}]}], "\[RightBracketingBar]"}]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[ForAll]CD\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052983690382833`*^9, 3.705298381795032*^9}, {
   3.705298952109296*^9, 3.705298977504115*^9}, {3.705301804188127*^9, 
   3.705301805417141*^9}, 3.705378596693434*^9, 3.7130889831508093`*^9, {
   3.730539425408745*^9, 3.730539456427638*^9}, {3.730539566665608*^9, 
   3.730539567233548*^9}, 3.7305396680747347`*^9, {3.730539702087162*^9, 
   3.7305397273288116`*^9}, {3.730539863485201*^9, 3.730539872061048*^9}},
 CellID->299583835,ExpressionUUID->"a4411878-c3b8-4d54-99e8-5239314247ae"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
  "moreover", " ", "from", " ", "\"\<g1\>\"", " ", "\"\<n2\>\"", " ", "have", 
   " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      FormBox[
       StyleBox["\[Epsilon]", "ExpressionABF"],
       TheoremaForm], "/", "2"}], " ", ">", " ", 
     RowBox[{"\[LeftBracketingBar]", 
      RowBox[{
       FormBox[
        StyleBox["b", "ExpressionABF"],
        TheoremaForm], " ", "-", " ", 
       RowBox[{
        FormBox[
         StyleBox["g", "ExpressionABF"],
         TheoremaForm], "[", 
        FormBox[
         StyleBox["n", "ExpressionABF"],
         TheoremaForm], "]"}]}], "\[RightBracketingBar]"}]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<\[ForAll]CD\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.7052983690382833`*^9, 3.705298381795032*^9}, {
   3.705298952109296*^9, 3.705298992991387*^9}, {3.7052990644699173`*^9, 
   3.705299066325967*^9}, {3.705301808948316*^9, 3.70530182017492*^9}, {
   3.705378600500842*^9, 3.705378601676766*^9}, 3.713088985950815*^9},
 CellID->285650457,ExpressionUUID->"8d555e9f-bc18-4ec7-bd76-425f0e891c3d"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"ultimately", " ", "have", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     RowBox[{
      RowBox[{
       FormBox[
        StyleBox["\[Epsilon]", "ExpressionABF"],
        TheoremaForm], "/", "2"}], " ", "+", " ", 
      RowBox[{
       FormBox[
        StyleBox["\[Epsilon]", "ExpressionABF"],
        TheoremaForm], "/", "2"}]}], " ", ">", " ", 
     RowBox[{
      RowBox[{"\[LeftBracketingBar]", 
       RowBox[{
        FormBox[
         StyleBox["a", "ExpressionABF"],
         TheoremaForm], " ", "-", " ", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["n", "ExpressionABF"],
          TheoremaForm], "]"}]}], "\[RightBracketingBar]"}], " ", "+", " ", 
      RowBox[{"\[LeftBracketingBar]", 
       RowBox[{
        FormBox[
         StyleBox["b", "ExpressionABF"],
         TheoremaForm], " ", "-", " ", 
        RowBox[{
         FormBox[
          StyleBox["g", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["n", "ExpressionABF"],
          TheoremaForm], "]"}]}], "\[RightBracketingBar]"}]}]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"rule", " ", "\"\<>+\>\""}], ")"}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705299071937229*^9, 3.7052991350572166`*^9}, {
  3.7053018163050413`*^9, 3.705301825417173*^9}, {3.705302075018009*^9, 
  3.705302082378234*^9}, {3.705378608252714*^9, 3.705378609748706*^9}},
 CellID->1077309799,ExpressionUUID->"e84b5192-01eb-47d4-8edd-0671f4ff0b68"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"hence", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     FormBox[
      StyleBox["\[Epsilon]", "ExpressionABF"],
      TheoremaForm], " ", ">", " ", 
     RowBox[{
      RowBox[{"\[LeftBracketingBar]", 
       RowBox[{
        FormBox[
         StyleBox["a", "ExpressionABF"],
         TheoremaForm], " ", "-", " ", 
        RowBox[{
         FormBox[
          StyleBox["f", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["n", "ExpressionABF"],
          TheoremaForm], "]"}]}], "\[RightBracketingBar]"}], " ", "+", " ", 
      RowBox[{"\[LeftBracketingBar]", 
       RowBox[{
        FormBox[
         StyleBox["b", "ExpressionABF"],
         TheoremaForm], " ", "-", " ", 
        RowBox[{
         FormBox[
          StyleBox["g", "ExpressionABF"],
          TheoremaForm], "[", 
         FormBox[
          StyleBox["n", "ExpressionABF"],
          TheoremaForm], "]"}]}], "\[RightBracketingBar]"}]}]}], 
    "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<half + half\>\""}], ")"}]}]}]], "ProofText",\

 CellDingbat->None,
 CellChangeTimes->{{3.705302093964266*^9, 3.705302140234466*^9}, {
  3.705302280640564*^9, 3.7053022807385178`*^9}, {3.705305370022867*^9, 
  3.705305390855048*^9}, {3.705305861632723*^9, 3.705305871072871*^9}, {
  3.705307017805591*^9, 3.705307022013342*^9}},
 CellID->1174145603,ExpressionUUID->"7dd6f744-3a76-44da-8799-2f73dbfb6529"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{
   RowBox[{"also", " ", "have", " ", 
    RowBox[{"\[OpenCurlyQuote]", 
     RowBox[{"\[Ellipsis]", " ", "\[GreaterEqual]", " ", 
      RowBox[{"\[LeftBracketingBar]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FormBox[
           StyleBox["a", "ExpressionABF"],
           TheoremaForm], " ", "-", " ", 
          RowBox[{
           FormBox[
            StyleBox["f", "ExpressionABF"],
            TheoremaForm], "[", 
           FormBox[
            StyleBox["n", "ExpressionABF"],
            TheoremaForm], "]"}]}], ")"}], " ", "+", " ", 
        RowBox[{"(", 
         RowBox[{
          FormBox[
           StyleBox["b", "ExpressionABF"],
           TheoremaForm], " ", "-", " ", 
          RowBox[{
           FormBox[
            StyleBox["g", "ExpressionABF"],
            TheoremaForm], "[", 
           FormBox[
            StyleBox["n", "ExpressionABF"],
            TheoremaForm], "]"}]}], ")"}]}], "\[RightBracketingBar]"}]}], 
     "\[CloseCurlyQuote]"}]}], "\n", "\t\t\t\t", 
   RowBox[{"by", " ", 
    RowBox[{"(", 
     RowBox[{"fact", " ", "\"\<triangle inequality\>\""}], 
     ")"}]}]}]}]], "ProofText",
 CellDingbat->None,
 CellChangeTimes->{{3.705304232470729*^9, 3.705304291006524*^9}, {
   3.7053043549373693`*^9, 3.705304407233323*^9}, {3.7053786369249973`*^9, 
   3.7053787141653547`*^9}, 3.705378838568084*^9},
 CellID->690087970,ExpressionUUID->"5f291186-a2fd-4483-9912-3618041e7ffb"],

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{"finally", 
   RowBox[{"(", "\"\<>\[GreaterEqual] trans\>\"", ")"}], " ", "show", " ", 
   RowBox[{"\[OpenCurlyQuote]", 
    RowBox[{
     TagBox[
      StyleBox["\[Epsilon]", "ExpressionABF"],
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]], 
     TagBox[">",
      Theorema`Language`TAG$[
       Theorema`Language`TYPED$[
       Theorema`Language`Greater$TM, {Theorema`Knowledge`REAL$TM}]],
      SyntaxForm->"x>y"], 
     RowBox[{
      TagBox["\[LeftBracketingBar]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`BracketingBar$TM, {}]],
       SyntaxForm->"("], 
      RowBox[{
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         TagBox[
          StyleBox["a", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]], 
         TagBox["+",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
           Theorema`Language`Plus$TM, {Theorema`Knowledge`REAL$TM}]],
          SyntaxForm->"x+y"], 
         TagBox[
          StyleBox["b", "ExpressionABF"],
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[Theorema`Knowledge`REAL$TM]]]}], 
        TagBox[")",
         "AutoParentheses"]}], 
       TagBox["-",
        Theorema`Language`TAG$[
         Theorema`Language`TYPED$[
         Theorema`Language`Subtract$TM, {Theorema`Knowledge`REAL$TM}]],
        SyntaxForm->"x-y"], 
       RowBox[{
        TagBox["(",
         "AutoParentheses"], 
        RowBox[{
         RowBox[{
          TagBox[
           StyleBox["f", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`Rule$TM[
             Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], "[", 
          TagBox[
           StyleBox["n", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`NAT$TM]]], "]"}], 
         TagBox["+",
          Theorema`Language`TAG$[
           Theorema`Language`TYPED$[
           Theorema`Language`Plus$TM, {Theorema`Knowledge`REAL$TM}]],
          SyntaxForm->"x+y"], 
         RowBox[{
          TagBox[
           StyleBox["g", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[
             Theorema`Language`Rule$TM[
             Theorema`Knowledge`NAT$TM, Theorema`Knowledge`REAL$TM]]]], "[", 
          TagBox[
           StyleBox["n", "ExpressionABF"],
           Theorema`Language`TAG$[
            Theorema`Language`TYPED$[Theorema`Knowledge`NAT$TM]]], "]"}]}], 
        TagBox[")",
         "AutoParentheses"]}]}], 
      TagBox["\[RightBracketingBar]",
       Theorema`Language`TAG$[
        Theorema`Language`TYPED$[Theorema`Language`BracketingBar$TM, {}]],
       SyntaxForm->")"]}]}], "\[CloseCurlyQuote]"}], " ", "by", " ", 
   RowBox[{"(", 
    RowBox[{"simp", ":", " ", "\"\<+- rearrange\>\""}], 
    ")"}]}]}]], "ProofText",
 CellDingbat->StyleBox[
  "\[FilledRightTriangle]", "Text", FontColor -> RGBColor[0, 
     Rational[2, 3], 0]],
 CellChangeTimes->{{3.705304512762158*^9, 3.70530451568365*^9}, 
   3.705304549291317*^9, {3.7053047032758627`*^9, 3.7053047103244963`*^9}, {
   3.70537872726814*^9, 3.705378752709016*^9}, 3.705378840945652*^9, {
   3.7053788834060707`*^9, 3.7053788907736607`*^9}},
 CellID->190560714,ExpressionUUID->"9db97c41-e505-44d8-b1d5-871d69a89bb8"]
},
WindowSize->{808, 869},
WindowMargins->{{3, Automatic}, {Automatic, 29}},
WindowTitle->"Proof of (isLimit +)",
CreateCellID->True,
DefaultNewCellStyle->"ProofText",
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->FrontEnd`FileName[{$RootDirectory, "home", "amaletzk", 
   ".Mathematica", "Applications", "Theorema", "Interface", "Templates"}, 
  "Proof Script.nb", CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 466, 9, 18, "ProofText", "ExpressionUUID" -> \
"b1dada69-2ada-4c68-8829-b1b49f6416b7",
 CellID->561321545],
Cell[1061, 32, 518, 17, 20, "ProofText", "ExpressionUUID" -> \
"64d794b3-2e9b-4f58-8a8a-f936937822ee",
 CellID->359224460],
Cell[1582, 51, 1573, 42, 20, "ProofText", "ExpressionUUID" -> \
"920021b8-605b-4ab4-a3c5-1ec3e5b41271",
 CellID->136798322],
Cell[3158, 95, 1798, 47, 20, "ProofText", "ExpressionUUID" -> \
"6ab799be-5e45-4d09-b895-e41be93ba8c0",
 CellID->805597599],
Cell[4959, 144, 2047, 50, 41, "ProofText", "ExpressionUUID" -> \
"38e00314-6621-4502-9029-59ddeafa7f0a",
 CellID->943477530],
Cell[7009, 196, 330, 9, 20, "ProofText", "ExpressionUUID" -> \
"325d59be-a236-4c72-addb-bed35a495c9a",
 CellID->1402248063],
Cell[7342, 207, 508, 13, 20, "ProofText", "ExpressionUUID" -> \
"5d37033a-7c55-4290-aba5-7c4e4abf47c6",
 CellID->1838462798],
Cell[7853, 222, 652, 17, 18, "ProofText", "ExpressionUUID" -> \
"7ef6c504-1c5c-47f0-a098-1ec07ad6b250",
 CellID->224489026],
Cell[8508, 241, 362, 7, 18, "ProofText", "ExpressionUUID" -> \
"97113628-a747-4fa4-86c6-cd8e62394760",
 CellID->2021715415],
Cell[8873, 250, 834, 25, 56, "FormalTextInputFormula", "ExpressionUUID" -> \
"36cf6d3c-454e-498b-b79b-969e789a17eb",
 CellID->39847309],
Cell[9710, 277, 549, 10, 18, "ProofText", "ExpressionUUID" -> \
"9de86e5a-62e6-47cb-8dd9-ea77bbe8e19f",
 CellID->1619842134],
Cell[10262, 289, 380, 9, 18, "ProofText", "ExpressionUUID" -> \
"61731cc9-9c21-4b23-bce4-2f84bdfbaf31",
 CellID->507000229],
Cell[10645, 300, 991, 28, 56, "FormalTextInputFormula", "ExpressionUUID" -> \
"f428d488-2408-4bc3-9e00-81094d702061",
 CellID->766962253],
Cell[11639, 330, 314, 6, 18, "ProofText", "ExpressionUUID" -> \
"a0015c47-260c-47c8-b4d8-8454adeb7908",
 CellID->1153211963],
Cell[11956, 338, 363, 8, 18, "ProofText", "ExpressionUUID" -> \
"aeba9769-beb4-4602-b05d-0e972de3d8c4",
 CellID->1514984103],
Cell[12322, 348, 885, 26, 56, "FormalTextInputFormula", "ExpressionUUID" -> \
"5d4cda22-7034-4bda-bc4c-8ad9195737c2",
 CellID->647268103],
Cell[13210, 376, 451, 9, 18, "ProofText", "ExpressionUUID" -> \
"0574ec19-0794-4c20-8b05-bd05cbb3b116",
 CellID->1219596540],
Cell[13664, 387, 383, 9, 18, "ProofText", "ExpressionUUID" -> \
"05ad63b8-4669-4d07-8849-84a6421063ec",
 CellID->1910978749],
Cell[14050, 398, 991, 28, 56, "FormalTextInputFormula", "ExpressionUUID" -> \
"c890c726-9a95-435f-8887-0e50524d7477",
 CellID->2042672109],
Cell[15044, 428, 313, 6, 18, "ProofText", "ExpressionUUID" -> \
"183fe8fe-8e87-4329-8edf-d2aded5dc6ec",
 CellID->1922893659],
Cell[15360, 436, 297, 7, 39, "ProofText", "ExpressionUUID" -> \
"4648c527-2b62-491e-ae07-be8d242ce734",
 CellID->718508470],
Cell[15660, 445, 217, 4, 18, "ProofText", "ExpressionUUID" -> \
"84ad9fdb-ad58-4573-815b-b3267bf9768e",
 CellID->718794428],
Cell[15880, 451, 2835, 80, 56, "FormalTextInputFormula", "ExpressionUUID" -> \
"bc061355-e8d8-48f7-a706-79fabeb58668",
 CellID->604217469],
Cell[18718, 533, 423, 10, 20, "ProofText", "ExpressionUUID" -> \
"4ffece00-c95f-45d8-b6d0-e7c2f3aa7784",
 CellID->563753406],
Cell[19144, 545, 324, 9, 20, "ProofText", "ExpressionUUID" -> \
"25d42059-2109-456d-a1fc-6da2519ac0ca",
 CellID->476936952],
Cell[19471, 556, 808, 23, 20, "ProofText", "ExpressionUUID" -> \
"7dbc27da-11a5-4721-97a9-860696193ddf",
 CellID->1349348616],
Cell[20282, 581, 598, 14, 18, "ProofText", "ExpressionUUID" -> \
"074b61e2-4988-4d70-b2f4-b22afb87d375",
 CellID->1968320060],
Cell[20883, 597, 788, 19, 18, "ProofText", "ExpressionUUID" -> \
"1333b24d-d059-451b-88b6-66941c7b4966",
 CellID->694762913],
Cell[21674, 618, 267, 6, 20, "ProofText", "ExpressionUUID" -> \
"c86fb7c0-80a0-4c4e-aca7-5f65fef94597",
 CellID->742127147],
Cell[21944, 626, 549, 13, 18, "ProofText", "ExpressionUUID" -> \
"5b6fc9ef-baa3-4fa8-a072-c3b0f19a3718",
 CellID->1654898217],
Cell[22496, 641, 636, 17, 18, "ProofText", "ExpressionUUID" -> \
"de3b80c7-d9dc-44bf-8006-314f60a10346",
 CellID->250540774],
Cell[23135, 660, 1322, 31, 18, "ProofText", "ExpressionUUID" -> \
"a4411878-c3b8-4d54-99e8-5239314247ae",
 CellID->299583835],
Cell[24460, 693, 1197, 31, 18, "ProofText", "ExpressionUUID" -> \
"8d555e9f-bc18-4ec7-bd76-425f0e891c3d",
 CellID->285650457],
Cell[25660, 726, 1637, 46, 18, "ProofText", "ExpressionUUID" -> \
"e84b5192-01eb-47d4-8edd-0671f4ff0b68",
 CellID->1077309799],
Cell[27300, 774, 1502, 42, 18, "ProofText", "ExpressionUUID" -> \
"7dd6f744-3a76-44da-8799-2f73dbfb6529",
 CellID->1174145603],
Cell[28805, 818, 1483, 41, 39, "ProofText", "ExpressionUUID" -> \
"5f291186-a2fd-4483-9912-3618041e7ffb",
 CellID->690087970],
Cell[30291, 861, 3528, 92, 19, "ProofText", "ExpressionUUID" -> \
"9db97c41-e505-44d8-b1d5-871d69a89bb8",
 CellID->190560714]
}
]
*)

