(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25317,        906]
NotebookOptionsPosition[     17078,        690]
NotebookOutlinePosition[     17548,        710]
CellTagsIndexPosition[     17505,        707]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[StyleData[StyleDefinitions -> FrontEnd`FileName[{"Theorema"}, 
  "TheoremaCore.nb"]]],

Cell["\<\
Modify the definitions below to change the default appearance of all cells in \
a given style. 
Make modifications to any definition using commands in the Format menu.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Notebook Options Settings", "Section"],

Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Notebook"],
 InputAliases->{},
 Background->CMYKColor[0, 0, 1, 1]],

Cell[StyleData["Notebook", "Printout"],
 Background->None]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Working"]],

Cell[StyleData[All, "Layout", StyleDefinitions -> StyleData[All, "Working"]],
 MenuSortingValue->1200]
}, Open  ]],

Cell[CellGroupData[{

Cell["Styles for Title and Section Cells", "Section"],

Cell[CellGroupData[{

Cell["Title", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Title"],
 CellMargins->{{27, 27}, {10, 30}},
 TextAlignment->Center,
 MenuSortingValue->1100,
 MenuCommandKey->"1",
 FontFamily->"Bitstream Charter",
 FontSize->36,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 0, 1, 1]],

Cell[StyleData["Title", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{6, 10}, {5, 30}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subtitle"],
 CellMargins->{{27, 27}, {20, 2}},
 TextAlignment->Center,
 MenuSortingValue->1150,
 FontFamily->"Bitstream Charter",
 FontSize->24,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 0, 1, 1]],

Cell[StyleData["Subtitle", "Printout"],
 CellMargins->{{6, 10}, {5, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubtitle"],
 CellMargins->{{27, 27}, {8, 2}},
 TextAlignment->Center,
 MenuSortingValue->1200,
 FontFamily->"Bitstream Charter",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 0, 1, 1]],

Cell[StyleData["Subsubtitle", "Printout"],
 CellMargins->{{6, 10}, {0, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Author"],
 CellMargins->{{27, 27}, {18, 20}},
 TextAlignment->Center,
 MenuSortingValue->1200,
 FontFamily->"Bitstream Charter",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 0, 1, 1]],

Cell[StyleData["Subsubtitle", "Printout"],
 CellMargins->{{6, 10}, {0, 0}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Sectioning", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 ShowGroupOpener->True,
 MenuSortingValue->1250,
 MenuCommandKey->"4",
 FontFamily->"Bitstream Charter",
 FontSize->20,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 1, 1, 1]],

Cell[StyleData["Section", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{2, 0}, {7, 22}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, Inherited}, {8, 12}},
 MenuSortingValue->1300,
 MenuCommandKey->"5",
 FontFamily->"Bitstream Charter",
 FontSize->14,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 1, 1, 1]],

Cell[StyleData["Subsection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{9, 0}, {7, 22}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, Inherited}, {2, 10}},
 MenuSortingValue->1350,
 MenuCommandKey->"6",
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Bold",
 FontSlant->"Italic",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 1, 1, 0]],

Cell[StyleData["Subsubsection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{35, 0}, {7, 14}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, Inherited}, {Inherited, Inherited}},
 FontFamily->"Bitstream Charter",
 FontSize->11,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 1, 1, 0]],

Cell[StyleData["Subsubsubsection", "Printout"],
 CellMargins->{{50, 0}, {7, 14}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Styles for Publication\[Hyphen]ready Documents", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Author"],
 CellMargins->{{27, 30}, {20, 5}},
 MenuSortingValue->1900,
 FontFamily->"Helvetica",
 FontSize->14,
 FontSlant->"Italic"],

Cell[StyleData["Author", "Printout"],
 CellMargins->{{6, 10}, {0, 10}},
 FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Abstract"],
 CellFrame->{{0, 0}, {0.5, 0.5}},
 CellMargins->{{27, 140}, {20, 20}},
 LineSpacing->{0.9, 0},
 MenuSortingValue->2050,
 FontFamily->"Times",
 FontSize->12],

Cell[StyleData["Abstract", "Printout"],
 Hyphenation->True,
 LineSpacing->{1, 2},
 FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Text", "Section"],

Cell[StyleData["Text"],
 CellMargins->{{27, 27}, {Inherited, Inherited}},
 TextJustification->1.,
 ParagraphIndent->15,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["EnvironmentText"],
 ShowCellBracket->Automatic,
 CellMargins->{{82, Inherited}, {Inherited, Inherited}},
 CellBracketOptions->{"Color"->CMYKColor[0, 1, 0, 1]},
 TextJustification->1.,
 ParagraphSpacing->{0.3, 0.},
 MenuSortingValue->1480,
 MenuCommandKey->"T",
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[CellGroupData[{

Cell[StyleData["Item"],
 CellDingbat->Cell["\[FilledSmallCircle]", FontWeight -> "Bold"],
 CellMargins->{{81, 10}, {4, 4}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 CellFrameLabelMargins->4,
 CounterIncrements->"Item",
 CounterAssignments->{{"Subitem", 0}, {"Subsubitem", 0}},
 MenuSortingValue->1600,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["Item", "Presentation"],
 CellMargins->{{140, 10}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ItemParagraph"],
 CellMargins->{{81, 10}, {4, 1}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 DefaultNewCellStyle->"Item",
 MenuSortingValue->1600,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["ItemParagraph", "Presentation"],
 CellMargins->{{140, 10}, {7, 2}},
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subitem"],
 CellDingbat->Cell["\[FilledSmallCircle]", FontWeight -> "Bold"],
 CellMargins->{{105, 12}, {4, 4}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15100},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Item",
 CounterIncrements->"Subitem",
 CounterAssignments->{{"Subsubitem", 0}},
 MenuSortingValue->1610,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["Subitem", "Presentation"],
 CellMargins->{{176, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubitemParagraph"],
 CellMargins->{{105, 12}, {4, 1}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15100},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Subitem",
 MenuSortingValue->1610,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["SubitemParagraph", "Presentation"],
 CellMargins->{{176, 12}, {7, 2}},
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subsubitem"],
 CellDingbat->Cell["\[FilledSmallCircle]", FontWeight -> "Bold"],
 CellMargins->{{129, 12}, {4, 4}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15200},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Subsubitem",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1620,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["Subsubitem", "Presentation"],
 CellMargins->{{212, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubsubitemParagraph"],
 CellMargins->{{129, 12}, {4, 1}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15200},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Subsubitem",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1625,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["SubsubitemParagraph", "Presentation"],
 CellMargins->{{212, 12}, {7, 2}},
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ItemNumbered"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemNumbered"], "."}], FontWeight -> "Bold"],
 CellMargins->{{81, 10}, {4, 4}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 CellFrameLabelMargins->4,
 CounterIncrements->"ItemNumbered",
 CounterAssignments->{{"SubitemNumbered", 0}, {"SubsubitemNumbered", 0}},
 MenuSortingValue->1630,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["ItemNumbered", "Presentation"],
 CellMargins->{{140, 10}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubitemNumbered"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemNumbered"], ".", 
     CounterBox["SubitemNumbered"], "."}], FontWeight -> "Bold"],
 CellMargins->{{105, 12}, {4, 4}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15100},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Item",
 CounterIncrements->"SubitemNumbered",
 CounterAssignments->{{"SubsubitemNumbered", 0}},
 MenuSortingValue->1640,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["SubitemNumbered", "Presentation"],
 CellMargins->{{176, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubsubitemNumbered"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemNumbered"], ".", 
     CounterBox["SubitemNumbered"], ".", 
     CounterBox["SubsubitemNumbered"], "."}], FontWeight -> "Bold"],
 CellMargins->{{129, 12}, {4, 4}},
 ReturnCreatesNewCell->True,
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15200},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"SubitemNumbered",
 CounterIncrements->"SubsubitemNumbered",
 MenuSortingValue->1645,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["SubsubitemNumbered", "Presentation"],
 CellMargins->{{212, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Theorema", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ProofText", StyleDefinitions -> StyleData["Code"]],
 CellMargins->{{60, 10}, {1, 1}},
 CellBracketOptions->{"Color"->CMYKColor[0, 1, 0, 1]},
 Evaluatable->False,
 CellGroupingRules->"NormalGrouping",
 InitializationCell->False,
 CellFrameLabelMargins->45,
 ShowCellTags->False,
 ShowAutoStyles->False,
 LimitsPositioningTokens->{},
 MenuSortingValue->1470,
 MenuCommandKey->"P",
 FontWeight->"Plain",
 FontColor->CMYKColor[1, 1, 0, 0],
 Background->None],

Cell[StyleData["ProofText", "Layout"],
 Editable->False],

Cell[StyleData["ProofText", "Presentation"],
 Editable->False]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["FormalTextInputFormula"],
 CellMargins->{{96, 10}, {1, 1}},
 CellBracketOptions->{"Color"->CMYKColor[0, 1, 0, 1]},
 Evaluatable->False,
 CellGroupingRules->"NormalGrouping",
 CellProlog->None,
 CellEpilog->None,
 InitializationCell->False,
 CellFrameLabelMargins->53,
 ShowCellTags->False,
 ShowAutoStyles->False,
 LimitsPositioningTokens->{},
 MenuSortingValue->1470,
 MenuCommandKey->"F",
 FontSize->12,
 FontWeight->"Plain",
 FontColor->CMYKColor[1, 1, 0, 0],
 Background->CMYKColor[0, 1, 0, 0]],

Cell[StyleData["FormalTextInputFormula", "Layout"],
 Editable->False],

Cell[StyleData["FormalTextInputFormula", "Presentation"],
 Editable->False]
}, Open  ]],

Cell[StyleData["ExpressionVariable"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Century Schoolbook L",
 FontColor->RGBColor[0.1, 0.4, 0.9]],

Cell[StyleData["ExpressionABF"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontColor->RGBColor[0.9, 0.5, 0.]],

Cell[StyleData["ExpressionMeta"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->Bold,
 FontColor->RGBColor[0.05, 0.3, 0.7]],

Cell[StyleData["ExpressionSyntactic"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->Bold,
 FontColor->RGBColor[0.8, 0.1, 0.7]],

Cell[CellGroupData[{

Cell[StyleData["AutoParentheses"],
 Editable->False,
 SpanMaxSize->3,
 FontOpacity->0.15],

Cell[StyleData["AutoParentheses", "Layout"],
 FontOpacity->0],

Cell[StyleData["AutoParentheses", "SlideShow"],
 FontOpacity->0]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Emphasized"],
 MenuCommandKey->"E",
 FontSlant->"Italic"],

Cell[StyleData["Emphasized", "SlideShow"],
 FontSlant->"Plain",
 FontColor->CMYKColor[0, 0, 1, 0]]
}, Closed]],

Cell[StyleData["GenericButton"],
 FontFamily->"Arial",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[0, 0, 1, 1],
 FontVariations -> {"Masked" -> False}],

Cell[StyleData["TheoremaForm"],
 "TwoByteSyntaxCharacterAutoReplacement"->True,
 LineSpacing->{1.25, 0, 2},
 SingleLetterItalics->True,
 StyleMenuListing->None,
 FontFamily->"Courier"],

Cell[StyleData["ComponentActive"],
 FontFamily->"Times New Roman"],

Cell[StyleData["ComponentInactive"],
 FontFamily->"Times New Roman",
 FontOpacity->0.4],

Cell[StyleData["ComponentEmpty"],
 FontFamily->"Times New Roman",
 FontVariations->{"StrikeThrough"->True}],

Cell[StyleData["TabView"],
 FontFamily->"Times New Roman",
 FontSize->10],

Cell[StyleData["TabViewLabel"],
 FontFamily->"Times New Roman",
 FontSize->10,
 FontWeight->"Bold"],

Cell[StyleData["FormReference", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times New Roman",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False}],

Cell[StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times New Roman",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->True},
 FontColor->CMYKColor[0, 1, 1, 0]],

Cell[StyleData["DisplayFormula"],
 CellMargins->{{36, 6}, {7, 7}},
 ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}},
 CellHorizontalScrolling->True,
 DefaultFormatType->TraditionalForm,
 InputAutoReplacements->{},
 TextAlignment->Center,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 ButtonBoxOptions->{Appearance->{Automatic, None}}]
}, Open  ]]
},
FileChangeProtection->None,
AutoGeneratedPackage->None,
Editable->True,
Saveable->True,
WindowSize->{740, 867},
WindowMargins->{{421, Automatic}, {32, Automatic}},
TrackCellChangeTimes->False,
FrontEndVersion->"11.0 for Linux x86 (64-bit) (September 21, 2016)",
StyleDefinitions->"StylesheetFormatting.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 90, 1, 40, 90, 1, "StyleData", "StyleDefinitions", ""],
Cell[650, 23, 191, 4, 65, "Text"],
Cell[CellGroupData[{
Cell[866, 31, 44, 0, 54, "Section"],
Cell[913, 33, 99, 2, 46, "Text"],
Cell[CellGroupData[{
Cell[1037, 39, 82, 2, 56, 27, 0, "StyleData", "Notebook", "All"],
Cell[1122, 43, 58, 1, 40, 39, 0, "StyleData", "Notebook", "Printout"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1229, 50, 42, 0, 54, "Section"],
Cell[1274, 52, 31, 0, 40, 31, 0, "StyleData", "All", "Working"],
Cell[1308, 54, 102, 1, 40, 77, 0, "StyleData", "All", "Layout",
 MenuSortingValue->1200]
}, Open  ]],
Cell[CellGroupData[{
Cell[1447, 60, 53, 0, 54, "Section"],
Cell[CellGroupData[{
Cell[1525, 64, 27, 0, 49, "Subsection"],
Cell[CellGroupData[{
Cell[1577, 68, 321, 11, 101, 24, 0, "StyleData", "Title", "All",
 MenuSortingValue->1100,
 MenuCommandKey->"1"],
Cell[1901, 81, 95, 2, 67, 36, 0, "StyleData", "Title", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2033, 88, 302, 10, 69, 27, 0, "StyleData", "Subtitle", "All",
 MenuSortingValue->1150],
Cell[2338, 100, 72, 1, 37, 39, 0, "StyleData", "Subtitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2447, 106, 304, 10, 48, 30, 0, "StyleData", "Subsubtitle", "All",
 MenuSortingValue->1200],
Cell[2754, 118, 75, 1, 32, 42, 0, "StyleData", "Subsubtitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2866, 124, 301, 10, 60, 25, 0, "StyleData", "Author", "All",
 MenuSortingValue->1200],
Cell[3170, 136, 75, 1, 32, 42, 0, "StyleData", "Subsubtitle", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3294, 143, 32, 0, 33, "Subsection"],
Cell[CellGroupData[{
Cell[3351, 147, 287, 10, 74, 26, 0, "StyleData", "Section", "All",
 MenuSortingValue->1250,
 MenuCommandKey->"4"],
Cell[3641, 159, 96, 2, 61, 38, 0, "StyleData", "Section", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[3774, 166, 352, 12, 47, 29, 0, "StyleData", "Subsection", "All",
 MenuSortingValue->1300,
 MenuCommandKey->"5"],
Cell[4129, 180, 99, 2, 61, 41, 0, "StyleData", "Subsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4265, 187, 356, 12, 39, 32, 0, "StyleData", "Subsubsection", "All",
 MenuSortingValue->1350,
 MenuCommandKey->"6"],
Cell[4624, 201, 103, 2, 52, 44, 0, "StyleData", "Subsubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4764, 208, 326, 10, 39, 35, 0, "StyleData", "Subsubsubsection", "All"],
Cell[5093, 220, 81, 1, 53, 47, 0, "StyleData", "Subsubsubsection", \
"Printout"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[5235, 228, 65, 0, 38, "Section"],
Cell[CellGroupData[{
Cell[5325, 232, 148, 5, 61, 25, 0, "StyleData", "Author", "All",
 MenuSortingValue->1900],
Cell[5476, 239, 86, 2, 38, 37, 0, "StyleData", "Author", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[5599, 246, 184, 6, 75, 27, 0, "StyleData", "Abstract", "All",
 MenuSortingValue->2050],
Cell[5786, 254, 96, 3, 36, 39, 0, "StyleData", "Abstract", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[5931, 263, 23, 0, 38, "Section"],
Cell[5957, 265, 275, 9, 41, 23, 0, "StyleData", "Text", "All"],
Cell[6235, 276, 432, 13, 41, 34, 0, "StyleData", "EnvironmentText", "All",
 MenuSortingValue->1480,
 MenuCommandKey->"T"],
Cell[CellGroupData[{
Cell[6692, 293, 506, 14, 41, 23, 0, "StyleData", "Item", "All",
 CounterIncrements->"Item",
 CounterAssignments->{{"Subitem", 0}, {"Subsubitem", 0}},
 MenuSortingValue->1600],
Cell[7201, 309, 116, 3, 60, 39, 0, "StyleData", "Item", "Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7354, 317, 366, 11, 38, 32, 0, "StyleData", "ItemParagraph", "All",
 MenuSortingValue->1600],
Cell[7723, 330, 98, 2, 55, 48, 0, "StyleData", "ItemParagraph", "Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7858, 337, 527, 15, 41, 26, 0, "StyleData", "Subitem", "All",
 CounterIncrements->"Subitem",
 CounterAssignments->{{"Subsubitem", 0}},
 MenuSortingValue->1610],
Cell[8388, 354, 119, 3, 60, 42, 0, "StyleData", "Subitem", "Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8544, 362, 400, 12, 38, 35, 0, "StyleData", "SubitemParagraph", "All",
 MenuSortingValue->1610],
Cell[8947, 376, 101, 2, 55, 51, 0, "StyleData", "SubitemParagraph", \
"Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9085, 383, 497, 14, 41, 29, 0, "StyleData", "Subsubitem", "All",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1620],
Cell[9585, 399, 122, 3, 60, 45, 0, "StyleData", "Subsubitem", "Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9744, 407, 440, 13, 38, 38, 0, "StyleData", "SubsubitemParagraph", "All",
 
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1625],
Cell[10187, 422, 104, 2, 55, 54, 0, "StyleData", "SubsubitemParagraph", \
"Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10328, 429, 569, 16, 41, 31, 0, "StyleData", "ItemNumbered", "All",
 CounterIncrements->"ItemNumbered",
 CounterAssignments->{{"SubitemNumbered", 0}, {"SubsubitemNumbered", 0}},
 MenuSortingValue->1630],
Cell[10900, 447, 124, 3, 60, 47, 0, "StyleData", "ItemNumbered", \
"Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11061, 455, 624, 18, 41, 34, 0, "StyleData", "SubitemNumbered", "All",
 CounterIncrements->"SubitemNumbered",
 CounterAssignments->{{"SubsubitemNumbered", 0}},
 MenuSortingValue->1640],
Cell[11688, 475, 127, 3, 60, 50, 0, "StyleData", "SubitemNumbered", \
"Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11852, 483, 636, 18, 41, 37, 0, "StyleData", "SubsubitemNumbered", "All",
 
 CounterIncrements->"SubsubitemNumbered",
 MenuSortingValue->1645],
Cell[12491, 503, 130, 3, 60, 53, 0, "StyleData", "SubsubitemNumbered", \
"Presentation"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[12670, 512, 27, 0, 38, "Section"],
Cell[CellGroupData[{
Cell[12722, 516, 470, 14, 34, 67, 0, "StyleData", "ProofText", "All",
 MenuSortingValue->1470,
 MenuCommandKey->"P"],
Cell[13195, 532, 56, 1, 40, 38, 0, "StyleData", "ProofText", "Layout"],
Cell[13254, 535, 62, 1, 69, 44, 0, "StyleData", "ProofText", "Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13353, 541, 514, 17, 50, 41, 0, "StyleData", "FormalTextInputFormula", \
"All",
 MenuSortingValue->1470,
 MenuCommandKey->"F"],
Cell[13870, 560, 69, 1, 40, 51, 0, "StyleData", "FormalTextInputFormula", \
"Layout"],
Cell[13942, 563, 75, 1, 69, 57, 0, "StyleData", "FormalTextInputFormula", \
"Presentation"]
}, Open  ]],
Cell[14032, 567, 166, 4, 43, 37, 0, "StyleData", "ExpressionVariable", \
"All"],
Cell[14201, 573, 145, 4, 39, 32, 0, "StyleData", "ExpressionABF", "All"],
Cell[14349, 579, 167, 5, 39, 33, 0, "StyleData", "ExpressionMeta", "All"],
Cell[14519, 586, 171, 5, 39, 38, 0, "StyleData", "ExpressionSyntactic", "All"],
Cell[CellGroupData[{
Cell[14715, 595, 89, 3, 40, 34, 0, "StyleData", "AutoParentheses", "All"],
Cell[14807, 600, 61, 1, 40, 44, 0, "StyleData", "AutoParentheses", "Layout"],
Cell[14871, 603, 64, 1, 40, 47, 0, "StyleData", "AutoParentheses", "SlideShow"]
}, Closed]],
Cell[CellGroupData[{
Cell[14972, 609, 73, 2, 40, 29, 0, "StyleData", "Emphasized", "All",
 MenuCommandKey->"E"],
Cell[15048, 613, 98, 2, 40, 42, 0, "StyleData", "Emphasized", "SlideShow"]
}, Closed]],
Cell[15161, 618, 296, 10, 36, 32, 0, "StyleData", "GenericButton", "All"],
Cell[15460, 630, 184, 5, 40, 31, 0, "StyleData", "TheoremaForm", "All",
 StyleMenuListing->None],
Cell[15647, 637, 66, 1, 39, 34, 0, "StyleData", "ComponentActive", "All"],
Cell[15716, 640, 87, 2, 39, 36, 0, "StyleData", "ComponentInactive", "All"],
Cell[15806, 644, 107, 2, 39, 33, 0, "StyleData", "ComponentEmpty", "All"],
Cell[15916, 648, 73, 2, 36, 26, 0, "StyleData", "TabView", "All"],
Cell[15992, 652, 99, 3, 36, 31, 0, "StyleData", "TabViewLabel", "All"],
Cell[16094, 657, 225, 6, 39, 71, 0, "StyleData", "FormReference", "All"],
Cell[16322, 665, 264, 7, 39, 76, 0, "StyleData", "FormReferenceHover", \
"All"],
Cell[16589, 674, 473, 13, 47, 33, 0, "StyleData", "DisplayFormula", "All"]
}, Open  ]]
}
]
*)

