(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     47222,       1258]
NotebookOptionsPosition[     33922,        974]
NotebookOutlinePosition[     34434,        995]
CellTagsIndexPosition[     34391,        992]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[StyleData[StyleDefinitions -> FrontEnd`FileName[{"Theorema"}, 
  "TheoremaCore.nb"]],ExpressionUUID->"5837f3fd-14c1-458d-ad80-77fc629a438b"],

Cell["\<\
Modify the definitions below to change the default appearance of all cells in \
a given style. 
Make modifications to any definition using commands in the Format menu.\
\>", "Text",ExpressionUUID->"4403af04-cc6d-49e7-87cc-d277a50b0da6"],

Cell[CellGroupData[{

Cell["Notebook Options Settings", "Section",ExpressionUUID->"b57b3282-76d1-404b-aae5-e0882a354668"],

Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text",ExpressionUUID->"a921ab0f-76ec-4b1b-9d5c-823e7321068b"],

Cell[CellGroupData[{

Cell[StyleData["Notebook"],
 InputAliases->{"and" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", "\[And]", "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "or" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", "\[Or]", "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "not" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[Not]", "\[SelectionPlaceholder]"}], 
      TagBox[")", "AutoParentheses"]}], "impl" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", "\[Implies]", "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "equiv" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{
       "\[SelectionPlaceholder]", "\[DoubleLongLeftRightArrow]", 
        "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "eq" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", "\[Equal]", "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], ":equiv" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", 
        TagBox[
         RowBox[{
          ":", "\[NegativeThickSpace]\[NegativeThinSpace]", 
           "\[DoubleLongLeftRightArrow]"}], Identity, SyntaxForm -> "a:=b"], 
        "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], ":eq" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", ":=", "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "andn" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[And]", "\[Piecewise]", 
        GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
         ColumnAlignments -> Left]}], 
      TagBox[")", "AutoParentheses"]}], "orn" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[Or]", "\[Piecewise]", 
        GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}, 
         ColumnAlignments -> Left]}], 
      TagBox[")", "AutoParentheses"]}], "equivn" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[DoubleLeftRightArrow]", "\[Piecewise]", 
        GridBox[{{"\[SelectionPlaceholder]"}, {"\[Placeholder]"}}]}], 
      TagBox[")", "AutoParentheses"]}], "cdist" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[Piecewise]", 
        GridBox[{{
          "\[SelectionPlaceholder]", "\[DoubleLeftArrow]", 
           "\[Placeholder]"}, {
          "\[Placeholder]", "\[DoubleLeftArrow]", "\[Placeholder]"}}]}], 
      TagBox[")", "AutoParentheses"]}], "far" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{
        UnderscriptBox["\[ForAll]", "\[Placeholder]"], 
        "\[SelectionPlaceholder]"}], 
      TagBox[")", "AutoParentheses"]}], "exr" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{
        UnderscriptBox["\[Exists]", "\[Placeholder]"], 
        "\[SelectionPlaceholder]"}], 
      TagBox[")", "AutoParentheses"]}], "farc" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{
        UnderscriptBox[
         UnderscriptBox["\[ForAll]", "\[Placeholder]"], "\[Placeholder]"], 
        "\[SelectionPlaceholder]"}], 
      TagBox[")", "AutoParentheses"]}], "exrc" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{
        UnderscriptBox[
         UnderscriptBox["\[Exists]", "\[Placeholder]"], "\[Placeholder]"], 
        "\[SelectionPlaceholder]"}], 
      TagBox[")", "AutoParentheses"]}], "let" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{
        UnderscriptBox["let", 
         RowBox[{"\[Placeholder]", "=", "\[Placeholder]"}]], 
        "\[SelectionPlaceholder]"}], 
      TagBox[")", "AutoParentheses"]}], "app" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", 
        TagBox["\:293a", Identity, SyntaxForm -> "a*b"], "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "prep" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", 
        TagBox["\:293b", Identity, SyntaxForm -> "a*b"], "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "join" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", 
        TagBox["\:22c8", Identity, SyntaxForm -> "a*b"], "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "elemT" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      RowBox[{"\[SelectionPlaceholder]", 
        TagBox["\:22ff", Identity, SyntaxForm -> "a+b"], "\[Placeholder]"}], 
      TagBox[")", "AutoParentheses"]}], "subop" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      SubscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
      TagBox[")", "AutoParentheses"]}], "supop" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      SuperscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
      TagBox[")", "AutoParentheses"]}], "subsupop" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      SubsuperscriptBox[
      "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
      TagBox[")", "AutoParentheses"]}], "oop" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
      TagBox[")", "AutoParentheses"]}], "uoop" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      UnderoverscriptBox[
      "\[SelectionPlaceholder]", "\[Placeholder]", "\[Placeholder]"], 
      TagBox[")", "AutoParentheses"]}], "osop" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      SubscriptBox[
       OverscriptBox["\[SelectionPlaceholder]", "\[Placeholder]"], 
       "\[Placeholder]"], 
      TagBox[")", "AutoParentheses"]}], "op" -> RowBox[{
      TagBox["(", "AutoParentheses"], 
      TagBox["\[SelectionPlaceholder]", Identity], 
      TagBox[")", "AutoParentheses"]}], "seq" -> RowBox[{
      TagBox["\[VerticalEllipsis]", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\[VerticalEllipsis]", Identity, SyntaxForm -> ")"]}], "()" -> 
   RowBox[{
      TagBox["\:fd3e", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:fd3f", Identity, SyntaxForm -> ")"]}], "(())" -> RowBox[{
      TagBox["\:2e28", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:2e29", Identity, SyntaxForm -> ")"]}], "(|)" -> RowBox[{
      TagBox["\:2987", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:2988", Identity, SyntaxForm -> ")"]}], "[]" -> RowBox[{
      TagBox["\:e114", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:e115", Identity, SyntaxForm -> ")"]}], "[[]]" -> RowBox[{
      TagBox["\:27e6", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:27e7", Identity, SyntaxForm -> ")"]}], "[|]" -> RowBox[{
      TagBox["\:27ec", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:27ed", Identity, SyntaxForm -> ")"]}], "{}" -> RowBox[{
      TagBox["\:e117", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:e118", Identity, SyntaxForm -> ")"]}], "{{}}" -> RowBox[{
      TagBox["\:2983", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:2984", Identity, SyntaxForm -> ")"]}], "<>" -> RowBox[{
      TagBox["\:27e8", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:27e9", Identity, SyntaxForm -> ")"]}], "<<>>" -> RowBox[{
      TagBox["\:27ea", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:27eb", Identity, SyntaxForm -> ")"]}], "<|>" -> RowBox[{
      TagBox["\:2989", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:298a", Identity, SyntaxForm -> ")"]}], "<.>" -> RowBox[{
      TagBox["\:2991", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:2992", Identity, SyntaxForm -> ")"]}], "<c>" -> RowBox[{
      TagBox["\:29fc", Identity, SyntaxForm -> "("], 
      "\[SelectionPlaceholder]", 
      TagBox["\:29fd", Identity, SyntaxForm -> ")"]}], "(" -> 
   TagBox["(", "AutoParentheses"], ")" -> TagBox[")", "AutoParentheses"], 
   "tma" -> RowBox[{
     "\[OpenCurlyQuote]", "\[SelectionPlaceholder]", "\[CloseCurlyQuote]"}], 
   "fix" -> FormBox[
     StyleBox["\[SelectionPlaceholder]", "ExpressionABF"], TheoremaForm], 
   "meta" -> FormBox[
     StyleBox["\[SelectionPlaceholder]", "ExpressionMeta"], TheoremaForm], 
   "svar" -> FormBox[
     StyleBox["\[SelectionPlaceholder]", "ExpressionSyntactic"], 
     TheoremaForm]},
 Background->RGBColor[
  0.957, 0.96, 0.97],ExpressionUUID->"56a18546-61aa-4e31-a0a8-56cb01d9c753"],

Cell[StyleData["Notebook", "Printout"],
 Background->None,ExpressionUUID->"9e6b701d-591a-4570-bc35-317724dcd470"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section",ExpressionUUID->"6384e7be-e305-4f32-9d74-ef1c87995f9a"],

Cell[StyleData[All, "Working"],
 DockedCells->{
   Cell[
    BoxData[
     TemplateBox[{
       InterpretationBox[
        StyleBox[
         GraphicsBox[{}, ImageSize -> {5, 0}, BaselinePosition -> Baseline], 
         "CacheGraphics" -> False], 
        Spacer[5], Selectable -> False], 
       ButtonBox["\"FIX\"", ButtonFunction :> FrontEndExecute[{
           NotebookApply[
            InputNotebook[], Theorema`Interface`ProofScript`Private`$FixBox, 
            Placeholder]}], Appearance -> "Frameless", Evaluator -> Automatic,
         Method -> "Preemptive"], 
       ButtonBox["\"META\"", ButtonFunction :> FrontEndExecute[{
           NotebookApply[
            InputNotebook[], Theorema`Interface`ProofScript`Private`$MetaBox, 
            Placeholder]}], Appearance -> "Frameless", Evaluator -> Automatic,
         Method -> "Preemptive"], 
       ButtonBox["\"SVAR\"", ButtonFunction :> FrontEndExecute[{
           NotebookApply[
            InputNotebook[], 
            Theorema`Interface`ProofScript`Private`$SyntacticBox, 
            Placeholder]}], Appearance -> "Frameless", Evaluator -> Automatic,
         Method -> "Preemptive"], 
       ButtonBox[
       "\"Available Knowledge\"", ButtonFunction :> 
        Theorema`Interface`ProofScript`Private`$displayKnowledge[], 
        Appearance -> "Frameless", Evaluator -> Automatic, Method -> 
        "Preemptive"], 
       ButtonBox["\"Internal Status\"", ButtonFunction :> CreateDocument[
          
          With[{Theorema`Interface`ProofScript`Private`cells = 
            Theorema`Interface`ProofScript`Private`$printProofSituation[]}, 
           Join[
            If[
             ListQ[Theorema`Interface`ProofScript`Private`cells], 
             Theorema`Interface`ProofScript`Private`cells, {}], {
             CellGroup[
              Join[{
                TextCell["Last/Pending Commands", "Subsubsection"]}, 
               Theorema`Interface`ProofScript`Private`$lastCmd, 
               If[
                MatchQ[Theorema`Interface`ProofScript`Private`$pendingCommand, 
                 Blank[Hold]], {
                Theorema`Interface`ProofScript`Private`$pendingCommand}, {}]],
               1]}]], WindowTitle -> "Current Status"], Appearance -> 
        "Frameless", Evaluator -> Automatic, Method -> "Preemptive"], 
       ButtonBox[
       "\"Proof Object\"", ButtonFunction :> 
        CreateDocument[{Theorema`Common`$TMAproofObject}, WindowTitle -> 
          "Proof Object"], Appearance -> "Frameless", Evaluator -> Automatic, 
        Method -> "Preemptive"], 
       ButtonBox["\"Export Proof\"", ButtonFunction :> (Replace[
           Theorema`Interface`ProofScript`Private`$proofExportationFunction[
           Theorema`Common`$TMAproofObject], {Null :> MessageDialog[
              StringJoin["\[Checkmark] ", 
               Theorema`Common`translate["exportSuccess"]]], 
            Pattern[Theorema`Interface`ProofScript`Private`res, 
              Blank[String]] :> MessageDialog[
              StringJoin["\[WarningSign] ", 
               Theorema`Common`translate["exportFailure"], ": ", 
               Theorema`Interface`ProofScript`Private`res]], Blank[] :> 
            MessageDialog[
              StringJoin["\[WarningSign] ", 
               Theorema`Common`translate["exportFailure"], "."]]}]; Null), 
        Appearance -> "Frameless", Evaluator -> Automatic, Method -> 
        "Preemptive"]}, "RowWithSeparator"]], "Text", Background -> 
    RGBColor[0.29, 0.46, 0.6], Deployed -> 
    True]},ExpressionUUID->"224cfb35-edbc-404e-a7b4-b078ff8acf36"],

Cell[StyleData[All, "Layout", StyleDefinitions -> StyleData[All, "Working"]],
 MenuSortingValue->
  1200,ExpressionUUID->"e63b0bad-4dc8-4e37-95f3-2d6b50a11915"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Styles for Title and Section Cells", "Section",ExpressionUUID->"5b768e5e-5cbd-47af-8f30-0f9866f027a1"],

Cell[CellGroupData[{

Cell["Title", "Subsection",ExpressionUUID->"597a567f-e645-4ae9-b025-89f624fdbbd4"],

Cell[CellGroupData[{

Cell[StyleData["Title"],
 CellMargins->{{27, 27}, {10, 30}},
 TextAlignment->Center,
 MenuSortingValue->1100,
 MenuCommandKey->"1",
 FontFamily->"Bitstream Charter",
 FontSize->36,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.23, 0.25, 0.34],ExpressionUUID->"e9c9324c-a9cd-4ee0-b8f9-6060939f5201"],

Cell[StyleData["Title", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{6, 10}, {5, 
  30}},ExpressionUUID->"87a159a9-74d3-48f1-b9d1-3c77d1d7e0b8"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subtitle"],
 CellMargins->{{27, 27}, {20, 2}},
 TextAlignment->Center,
 MenuSortingValue->1150,
 FontFamily->"Bitstream Charter",
 FontSize->24,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.23, 0.25, 0.34],ExpressionUUID->"6d2cad18-762e-4d9a-a164-78812b0f00cd"],

Cell[StyleData["Subtitle", "Printout"],
 CellMargins->{{6, 10}, {5, 
  0}},ExpressionUUID->"1df9fbde-76bd-4fe5-9107-f306912dac5c"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubtitle"],
 CellMargins->{{27, 27}, {8, 2}},
 TextAlignment->Center,
 MenuSortingValue->1200,
 FontFamily->"Bitstream Charter",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.23, 0.25, 0.34],ExpressionUUID->"99d850b0-e640-44e6-b42c-109cf85ebea5"],

Cell[StyleData["Subsubtitle", "Printout"],
 CellMargins->{{6, 10}, {0, 
  0}},ExpressionUUID->"5b11130f-d80a-44df-bdee-b9d2bbed9134"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Author"],
 CellMargins->{{27, 27}, {18, 20}},
 TextAlignment->Center,
 MenuSortingValue->1200,
 FontFamily->"Bitstream Charter",
 FontSize->16,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.23, 0.25, 0.34],ExpressionUUID->"fad80b95-0835-4a73-a350-9aa3acf769ca"],

Cell[StyleData["Subsubtitle", "Printout"],
 CellMargins->{{6, 10}, {0, 
  0}},ExpressionUUID->"889264c6-098b-46c4-b14e-de6173e2651c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Sectioning", "Subsection",ExpressionUUID->"2537422f-1801-4f86-bcbc-f83945f0c2ea"],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 ShowGroupOpener->True,
 MenuSortingValue->1250,
 MenuCommandKey->"4",
 FontFamily->"Bitstream Charter",
 FontSize->20,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.3, 0.3, 0.3],ExpressionUUID->"0c204c6c-b5e6-4119-a89a-5cfeeedc4f39"],

Cell[StyleData["Section", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{2, 0}, {7, 
  22}},ExpressionUUID->"c672f402-b660-43d8-85da-d2948feffc35"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, Inherited}, {8, 12}},
 MenuSortingValue->1300,
 MenuCommandKey->"5",
 FontFamily->"Bitstream Charter",
 FontSize->14,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.3, 0.3, 0.3],ExpressionUUID->"537b380d-1448-4b41-9066-8ede2e229f54"],

Cell[StyleData["Subsection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{9, 0}, {7, 
  22}},ExpressionUUID->"d3567e28-f90f-4122-b85d-08d7724de018"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, Inherited}, {2, 10}},
 MenuSortingValue->1350,
 MenuCommandKey->"6",
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Bold",
 FontSlant->"Italic",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.4, 0.4, 0.4],ExpressionUUID->"41d73563-d2a6-4832-9c88-78148a445cc2"],

Cell[StyleData["Subsubsection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{35, 0}, {7, 
  14}},ExpressionUUID->"b469bae5-7ea3-474f-b4f6-587b86a45432"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{27, Inherited}, {Inherited, Inherited}},
 FontFamily->"Bitstream Charter",
 FontSize->11,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[
  0.4, 0.4, 0.4],ExpressionUUID->"2565b495-8224-41bb-b95c-b30fa7abea74"],

Cell[StyleData["Subsubsubsection", "Printout"],
 CellMargins->{{50, 0}, {7, 
  14}},ExpressionUUID->"19ebe00a-da29-4de8-935a-2b84ab729657"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Styles for Publication\[Hyphen]ready Documents", "Section",ExpressionUUID->"334a785d-3b59-4bbf-9e17-32cfb33609ec"],

Cell[CellGroupData[{

Cell[StyleData["Author"],
 CellMargins->{{27, 30}, {20, 5}},
 MenuSortingValue->1900,
 FontFamily->"Helvetica",
 FontSize->14,
 FontSlant->"Italic",ExpressionUUID->"ea56b359-0784-4c2a-a17f-f4d291931921"],

Cell[StyleData["Author", "Printout"],
 CellMargins->{{6, 10}, {0, 10}},
 FontSize->10,ExpressionUUID->"3cbb8f55-a3e4-4d5e-88ef-b26c111da732"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Abstract"],
 CellFrame->{{0, 0}, {0.5, 0.5}},
 CellMargins->{{27, 140}, {20, 20}},
 LineSpacing->{0.9, 0},
 MenuSortingValue->2050,
 FontFamily->"Times",
 FontSize->12,ExpressionUUID->"c8a5058b-df0b-4cc2-975e-8f846b849206"],

Cell[StyleData["Abstract", "Printout"],
 Hyphenation->True,
 LineSpacing->{1, 2},
 FontSize->10,ExpressionUUID->"0f128768-9525-43a9-827d-9373f2398650"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Text", "Section",ExpressionUUID->"3942c934-41fc-4908-8e85-e4cc3fdf6029"],

Cell[StyleData["Text"],
 CellMargins->{{27, 27}, {Inherited, Inherited}},
 TextJustification->1.,
 ParagraphIndent->15,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},ExpressionUUID->"9b474e81-dffc-46db-a161-1fe10d234365"],

Cell[StyleData["EnvironmentText"],
 ShowCellBracket->Automatic,
 CellMargins->{{82, Inherited}, {Inherited, Inherited}},
 CellBracketOptions->{"Color"->RGBColor[0.73, 0.74, 0.84]},
 TextJustification->1.,
 ParagraphSpacing->{0.3, 0.},
 MenuSortingValue->1480,
 MenuCommandKey->"T",
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},ExpressionUUID->"e048ad1f-f562-4ece-b7c4-44d17d1cb3c0"],

Cell[CellGroupData[{

Cell[StyleData["Item"],
 CellDingbat->Cell["\[FilledSmallCircle]", FontWeight -> "Bold"],
 CellMargins->{{81, 10}, {4, 4}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 CellFrameLabelMargins->4,
 CounterIncrements->"Item",
 CounterAssignments->{{"Subitem", 0}, {"Subsubitem", 0}},
 MenuSortingValue->1600,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"a6675e5b-2a07-4862-843a-f592723d7f8a"],

Cell[StyleData["Item", "Presentation"],
 CellMargins->{{140, 10}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24,ExpressionUUID->"ff79f70f-ad89-40bc-9bae-abde5c529497"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ItemParagraph"],
 CellMargins->{{81, 10}, {4, 1}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 DefaultNewCellStyle->"Item",
 MenuSortingValue->1600,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"b101bc5b-65f3-42c4-b370-01eb262ef300"],

Cell[StyleData["ItemParagraph", "Presentation"],
 CellMargins->{{140, 10}, {7, 2}},
 FontSize->24,ExpressionUUID->"f9a20242-c509-4964-966c-f3ec22020e7f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subitem"],
 CellDingbat->Cell["\[FilledSmallCircle]", FontWeight -> "Bold"],
 CellMargins->{{105, 12}, {4, 4}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15100},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Item",
 CounterIncrements->"Subitem",
 CounterAssignments->{{"Subsubitem", 0}},
 MenuSortingValue->1610,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"36e8d557-afb2-48fc-be3d-b618d1935407"],

Cell[StyleData["Subitem", "Presentation"],
 CellMargins->{{176, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24,ExpressionUUID->"cfa3860a-505e-4724-a8d8-e35b55e1e874"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubitemParagraph"],
 CellMargins->{{105, 12}, {4, 1}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15100},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Subitem",
 MenuSortingValue->1610,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"ce62fd4b-6c4c-4ac6-8ed5-eb76662e6e8f"],

Cell[StyleData["SubitemParagraph", "Presentation"],
 CellMargins->{{176, 12}, {7, 2}},
 FontSize->24,ExpressionUUID->"608e5ed9-a83f-40a5-9e24-02f481a00601"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subsubitem"],
 CellDingbat->Cell["\[FilledSmallCircle]", FontWeight -> "Bold"],
 CellMargins->{{129, 12}, {4, 4}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15200},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Subsubitem",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1620,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"e740dd0b-3507-4544-9982-44c6c1215804"],

Cell[StyleData["Subsubitem", "Presentation"],
 CellMargins->{{212, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24,ExpressionUUID->"e151f6ef-364f-49af-b72f-e9f4a24ce86f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubsubitemParagraph"],
 CellMargins->{{129, 12}, {4, 1}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15200},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Subsubitem",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1625,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"5d9115cf-89e5-4527-80cb-8e90f2c2fd2a"],

Cell[StyleData["SubsubitemParagraph", "Presentation"],
 CellMargins->{{212, 12}, {7, 2}},
 FontSize->24,ExpressionUUID->"1c649447-fadf-4d77-be51-0b2aeb4c1e3f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["ItemNumbered"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemNumbered"], "."}], FontWeight -> "Bold"],
 CellMargins->{{81, 10}, {4, 4}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15000},
 CellFrameLabelMargins->4,
 CounterIncrements->"ItemNumbered",
 CounterAssignments->{{"SubitemNumbered", 0}, {"SubsubitemNumbered", 0}},
 MenuSortingValue->1630,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"0332f4f1-0b1e-4bb1-82bc-f15966738568"],

Cell[StyleData["ItemNumbered", "Presentation"],
 CellMargins->{{140, 10}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24,ExpressionUUID->"c7a1d5af-27bb-4330-b926-05c16935a969"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubitemNumbered"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemNumbered"], ".", 
     CounterBox["SubitemNumbered"], "."}], FontWeight -> "Bold"],
 CellMargins->{{105, 12}, {4, 4}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15100},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"Item",
 CounterIncrements->"SubitemNumbered",
 CounterAssignments->{{"SubsubitemNumbered", 0}},
 MenuSortingValue->1640,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"587f45b3-83b3-4399-a3a4-2d5bd030c6a9"],

Cell[StyleData["SubitemNumbered", "Presentation"],
 CellMargins->{{176, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24,ExpressionUUID->"c32db1e1-7e5f-4bdc-bef8-61534145bf0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["SubsubitemNumbered"],
 CellDingbat->Cell[
   TextData[{
     CounterBox["ItemNumbered"], ".", 
     CounterBox["SubitemNumbered"], ".", 
     CounterBox["SubsubitemNumbered"], "."}], FontWeight -> "Bold"],
 CellMargins->{{129, 12}, {4, 4}},
 CellGroupingRules->{"GroupTogetherNestedGrouping", 15200},
 CellFrameLabelMargins->4,
 DefaultNewCellStyle->"SubitemNumbered",
 CounterIncrements->"SubsubitemNumbered",
 MenuSortingValue->1645,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 $CellContext`ReturnCreatesNewCell -> 
 True,ExpressionUUID->"a04ae3dd-473d-4532-9754-f24b27873db8"],

Cell[StyleData["SubsubitemNumbered", "Presentation"],
 CellMargins->{{212, 12}, {7, 7}},
 CellFrameLabelMargins->6,
 FontSize->24,ExpressionUUID->"595436fa-b6e3-4a0c-ae66-8076d2e76c83"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Theorema", "Section",ExpressionUUID->"9c8415d3-5507-4a19-ac22-c75b4faa0898"],

Cell[CellGroupData[{

Cell[StyleData["ProofText", StyleDefinitions -> StyleData["Code"]],
 CellMargins->{{60, 10}, {1, 1}},
 CellBracketOptions->{"Color"->RGBColor[0.73, 0.74, 0.84]},
 Evaluatable->False,
 CellGroupingRules->"NormalGrouping",
 InitializationCell->False,
 CellFrameLabelMargins->45,
 ShowCellTags->False,
 ShowAutoStyles->False,
 LimitsPositioningTokens->{},
 MenuSortingValue->1470,
 MenuCommandKey->"P",
 FontWeight->"Plain",
 FontColor->RGBColor[0.25, 0.19, 0.2],
 Background->None,ExpressionUUID->"a6d4df30-da01-4bd1-a29a-9713ef3ec60d"],

Cell[StyleData["ProofText", "Layout"],
 Editable->False,ExpressionUUID->"0689b5e2-1be7-4df5-94f8-402fdc38cb16"],

Cell[StyleData["ProofText", "Presentation"],
 Editable->False,ExpressionUUID->"7318ad79-3f5f-4b7e-be95-9665817ee163"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["FormalTextInputFormula"],
 CellMargins->{{96, 10}, {1, 1}},
 CellBracketOptions->{"Color"->RGBColor[0.73, 0.74, 0.84]},
 Evaluatable->False,
 CellGroupingRules->"NormalGrouping",
 CellProlog->None,
 CellEpilog->None,
 InitializationCell->False,
 CellFrameLabelMargins->53,
 ShowCellTags->False,
 ShowAutoStyles->False,
 LimitsPositioningTokens->{},
 MenuSortingValue->1470,
 MenuCommandKey->"F",
 FontSize->12,
 FontWeight->"Plain",
 FontColor->RGBColor[0.25, 0.19, 0.2],
 Background->RGBColor[
  0.88, 0.88, 0.92],ExpressionUUID->"7b634b86-7608-4778-bfad-a0d8c91e9bf4"],

Cell[StyleData["FormalTextInputFormula", "Layout"],
 Editable->False,ExpressionUUID->"2078928f-3e91-4dd9-a642-338de9f30bd7"],

Cell[StyleData["FormalTextInputFormula", "Presentation"],
 Editable->False,ExpressionUUID->"16ac170f-6f55-498b-a342-c3adbff4932b"]
}, Open  ]],

Cell[StyleData["ExpressionVariable"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Century Schoolbook L",
 FontColor->RGBColor[
  0.1, 0.4, 0.9],ExpressionUUID->"ecc7391e-51b1-4f1f-8b45-922b4cf5d4ce"],

Cell[StyleData["ExpressionABF"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontColor->RGBColor[
  0.9, 0.5, 0.],ExpressionUUID->"ebf7c9b5-61c3-4f04-9416-613c5552c0a5"],

Cell[StyleData["ExpressionMeta"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->Bold,
 FontColor->RGBColor[
  0.05, 0.3, 0.7],ExpressionUUID->"7e1c6e5b-20aa-4a8c-b89b-abf16ce0f216"],

Cell[StyleData["ExpressionSyntactic"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->Bold,
 FontColor->RGBColor[
  0.8, 0.1, 0.7],ExpressionUUID->"3b944421-7b57-4d57-aa00-3f622d2afa85"],

Cell[CellGroupData[{

Cell[StyleData["AutoParentheses"],
 Editable->False,
 SpanMaxSize->3,
 FontOpacity->0.15,ExpressionUUID->"776c4bc6-55be-4d77-8bdc-d8d481696730"],

Cell[StyleData["AutoParentheses", "Layout"],
 FontOpacity->0,ExpressionUUID->"a838ff71-080e-473d-9cb8-1770f06ee9ec"],

Cell[StyleData["AutoParentheses", "SlideShow"],
 FontOpacity->0,ExpressionUUID->"2e3500bf-ac13-47c7-89d0-1784c4c9567d"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Emphasized"],
 MenuCommandKey->"E",
 FontSlant->"Italic",ExpressionUUID->"eff82861-64f2-4cdc-89c3-2bf95fb8f487"],

Cell[StyleData["Emphasized", "SlideShow"],
 FontSlant->"Plain",
 FontColor->RGBColor[
  0.36, 0.54, 0.69],ExpressionUUID->"a70eeef0-5c2a-49b2-af41-62cbcf17fdbe"]
}, Closed]],

Cell[StyleData["GenericButton"],
 FontFamily->"Arial",
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[0.957, 0.96, 0.97],
 FontVariations -> {
  "Masked" -> False},ExpressionUUID->"3b694c95-8a41-4f43-98bf-b8cdc9ca09b4"],

Cell[StyleData["TheoremaForm"],
 "TwoByteSyntaxCharacterAutoReplacement"->True,
 LineSpacing->{1.25, 0, 2},
 SingleLetterItalics->True,
 StyleMenuListing->None,
 FontFamily->"Courier",ExpressionUUID->"e87fe30d-2a73-4afa-a2eb-f83fd6983069"],

Cell[StyleData["ComponentActive"],
 FontFamily->
  "Times New Roman",ExpressionUUID->"f5d6e672-3ec1-4dbf-a381-c9ff11cfe216"],

Cell[StyleData["ComponentInactive"],
 FontFamily->"Times New Roman",
 FontOpacity->0.4,ExpressionUUID->"dd862048-961f-4f4c-8843-ae96f80a63bb"],

Cell[StyleData["ComponentEmpty"],
 FontFamily->"Times New Roman",
 FontVariations->{
 "StrikeThrough"->
  True},ExpressionUUID->"6e3fab66-e0f2-406f-8842-978322b2d931"],

Cell[StyleData["TabView"],
 FontFamily->"Times New Roman",
 FontSize->10,ExpressionUUID->"01f74fb4-c55c-41dc-b51c-dc84777ff58c"],

Cell[StyleData["TabViewLabel"],
 FontFamily->"Times New Roman",
 FontSize->10,
 FontWeight->"Bold",ExpressionUUID->"31028c8f-1470-4418-865d-238462c93ebb"],

Cell[StyleData["FormReference", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times New Roman",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},ExpressionUUID->"6b0b6303-1d7b-41ab-a00f-f821ee306762"],

Cell[StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times New Roman",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->True},
 FontColor->RGBColor[
  0.404, 0.43, 0.545],ExpressionUUID->"b6b5bf69-5abc-4df6-8a8d-a47db77c2b76"],

Cell[StyleData["DisplayFormula"],
 CellMargins->{{36, 6}, {7, 7}},
 ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}},
 CellHorizontalScrolling->True,
 DefaultFormatType->TraditionalForm,
 InputAutoReplacements->{},
 TextAlignment->Center,
 FontFamily->"Bitstream Charter",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 ButtonBoxOptions->{
 Appearance->{
  Automatic, None}},ExpressionUUID->"300cc526-865d-4b7b-8e89-0102ddbe1cdc"]
}, Open  ]]
},
AutoGeneratedPackage->None,
Editable->True,
Saveable->True,
WindowSize->{740, 867},
WindowMargins->{{421, Automatic}, {32, Automatic}},
Visible->False,
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"StylesheetFormatting.nb",
$CellContext`FileChangeProtection -> None,
Theorema`HOL`TrackCellChangeTimes -> False
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 145, 1, 70, 90, 1, "StyleData", "StyleDefinitions", "", \
"ExpressionUUID" -> "5837f3fd-14c1-458d-ad80-77fc629a438b"],
Cell[706, 23, 246, 4, 70, "Text", "ExpressionUUID" -> \
"4403af04-cc6d-49e7-87cc-d277a50b0da6"],
Cell[CellGroupData[{
Cell[977, 31, 99, 0, 70, "Section", "ExpressionUUID" -> \
"b57b3282-76d1-404b-aae5-e0882a354668"],
Cell[1079, 33, 154, 2, 70, "Text", "ExpressionUUID" -> \
"a921ab0f-76ec-4b1b-9d5c-823e7321068b"],
Cell[CellGroupData[{
Cell[1258, 39, 8774, 177, 70, 27, 0, "StyleData", "Notebook", "All", \
"ExpressionUUID" -> "56a18546-61aa-4e31-a0a8-56cb01d9c753"],
Cell[10035, 218, 113, 1, 70, 39, 0, "StyleData", "Notebook", "Printout", \
"ExpressionUUID" -> "9e6b701d-591a-4570-bc35-317724dcd470"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10197, 225, 97, 0, 70, "Section", "ExpressionUUID" -> \
"6384e7be-e305-4f32-9d74-ef1c87995f9a"],
Cell[10297, 227, 3577, 70, 70, 31, 0, "StyleData", "All", "Working", \
"ExpressionUUID" -> "224cfb35-edbc-404e-a7b4-b078ff8acf36"],
Cell[13877, 299, 160, 2, 70, 77, 0, "StyleData", "All", "Layout", \
"ExpressionUUID" -> "e63b0bad-4dc8-4e37-95f3-2d6b50a11915",
 MenuSortingValue->1200]
}, Open  ]],
Cell[CellGroupData[{
Cell[14074, 306, 108, 0, 70, "Section", "ExpressionUUID" -> \
"5b768e5e-5cbd-47af-8f30-0f9866f027a1"],
Cell[CellGroupData[{
Cell[14207, 310, 82, 0, 70, "Subsection", "ExpressionUUID" -> \
"597a567f-e645-4ae9-b025-89f624fdbbd4"],
Cell[CellGroupData[{
Cell[14314, 314, 384, 12, 70, 24, 0, "StyleData", "Title", "All", \
"ExpressionUUID" -> "e9c9324c-a9cd-4ee0-b8f9-6060939f5201",
 MenuSortingValue->1100,
 MenuCommandKey->"1"],
Cell[14701, 328, 153, 3, 70, 36, 0, "StyleData", "Title", "Printout", \
"ExpressionUUID" -> "87a159a9-74d3-48f1-b9d1-3c77d1d7e0b8"]
}, Closed]],
Cell[CellGroupData[{
Cell[14891, 336, 365, 11, 70, 27, 0, "StyleData", "Subtitle", "All", \
"ExpressionUUID" -> "6d2cad18-762e-4d9a-a164-78812b0f00cd",
 MenuSortingValue->1150],
Cell[15259, 349, 130, 2, 70, 39, 0, "StyleData", "Subtitle", "Printout", \
"ExpressionUUID" -> "1df9fbde-76bd-4fe5-9107-f306912dac5c"]
}, Closed]],
Cell[CellGroupData[{
Cell[15426, 356, 367, 11, 70, 30, 0, "StyleData", "Subsubtitle", "All", \
"ExpressionUUID" -> "99d850b0-e640-44e6-b42c-109cf85ebea5",
 MenuSortingValue->1200],
Cell[15796, 369, 133, 2, 70, 42, 0, "StyleData", "Subsubtitle", "Printout", \
"ExpressionUUID" -> "5b11130f-d80a-44df-bdee-b9d2bbed9134"]
}, Closed]],
Cell[CellGroupData[{
Cell[15966, 376, 364, 11, 70, 25, 0, "StyleData", "Author", "All", \
"ExpressionUUID" -> "fad80b95-0835-4a73-a350-9aa3acf769ca",
 MenuSortingValue->1200],
Cell[16333, 389, 133, 2, 70, 42, 0, "StyleData", "Subsubtitle", "Printout", \
"ExpressionUUID" -> "889264c6-098b-46c4-b14e-de6173e2651c"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[16515, 397, 87, 0, 70, "Subsection", "ExpressionUUID" -> \
"2537422f-1801-4f86-bcbc-f83945f0c2ea"],
Cell[CellGroupData[{
Cell[16627, 401, 347, 11, 70, 26, 0, "StyleData", "Section", "All", \
"ExpressionUUID" -> "0c204c6c-b5e6-4119-a89a-5cfeeedc4f39",
 MenuSortingValue->1250,
 MenuCommandKey->"4"],
Cell[16977, 414, 154, 3, 70, 38, 0, "StyleData", "Section", "Printout", \
"ExpressionUUID" -> "c672f402-b660-43d8-85da-d2948feffc35"]
}, Closed]],
Cell[CellGroupData[{
Cell[17168, 422, 412, 13, 70, 29, 0, "StyleData", "Subsection", "All", \
"ExpressionUUID" -> "537b380d-1448-4b41-9066-8ede2e229f54",
 MenuSortingValue->1300,
 MenuCommandKey->"5"],
Cell[17583, 437, 157, 3, 70, 41, 0, "StyleData", "Subsection", "Printout", \
"ExpressionUUID" -> "d3567e28-f90f-4122-b85d-08d7724de018"]
}, Closed]],
Cell[CellGroupData[{
Cell[17777, 445, 416, 13, 70, 32, 0, "StyleData", "Subsubsection", "All", \
"ExpressionUUID" -> "41d73563-d2a6-4832-9c88-78148a445cc2",
 MenuSortingValue->1350,
 MenuCommandKey->"6"],
Cell[18196, 460, 161, 3, 70, 44, 0, "StyleData", "Subsubsection", "Printout", \
"ExpressionUUID" -> "b469bae5-7ea3-474f-b4f6-587b86a45432"]
}, Closed]],
Cell[CellGroupData[{
Cell[18394, 468, 386, 11, 70, 35, 0, "StyleData", "Subsubsubsection", "All", \
"ExpressionUUID" -> "2565b495-8224-41bb-b95c-b30fa7abea74"],
Cell[18783, 481, 139, 2, 70, 47, 0, "StyleData", "Subsubsubsection", \
"Printout", "ExpressionUUID" -> "19ebe00a-da29-4de8-935a-2b84ab729657"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18983, 490, 120, 0, 70, "Section", "ExpressionUUID" -> \
"334a785d-3b59-4bbf-9e17-32cfb33609ec"],
Cell[CellGroupData[{
Cell[19128, 494, 203, 5, 70, 25, 0, "StyleData", "Author", "All", \
"ExpressionUUID" -> "ea56b359-0784-4c2a-a17f-f4d291931921",
 MenuSortingValue->1900],
Cell[19334, 501, 141, 2, 70, 37, 0, "StyleData", "Author", "Printout", \
"ExpressionUUID" -> "3cbb8f55-a3e4-4d5e-88ef-b26c111da732"]
}, Closed]],
Cell[CellGroupData[{
Cell[19512, 508, 239, 6, 70, 27, 0, "StyleData", "Abstract", "All", \
"ExpressionUUID" -> "c8a5058b-df0b-4cc2-975e-8f846b849206",
 MenuSortingValue->2050],
Cell[19754, 516, 151, 3, 70, 39, 0, "StyleData", "Abstract", "Printout", \
"ExpressionUUID" -> "0f128768-9525-43a9-827d-9373f2398650"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[19954, 525, 78, 0, 70, "Section", "ExpressionUUID" -> \
"3942c934-41fc-4908-8e85-e4cc3fdf6029"],
Cell[20035, 527, 330, 9, 70, 23, 0, "StyleData", "Text", "All", \
"ExpressionUUID" -> "9b474e81-dffc-46db-a161-1fe10d234365"],
Cell[20368, 538, 492, 13, 70, 34, 0, "StyleData", "EnvironmentText", "All", \
"ExpressionUUID" -> "e048ad1f-f562-4ece-b7c4-44d17d1cb3c0",
 MenuSortingValue->1480,
 MenuCommandKey->"T"],
Cell[CellGroupData[{
Cell[20885, 555, 578, 15, 70, 23, 0, "StyleData", "Item", "All", \
"ExpressionUUID" -> "a6675e5b-2a07-4862-843a-f592723d7f8a",
 CounterIncrements->"Item",
 CounterAssignments->{{"Subitem", 0}, {"Subsubitem", 0}},
 MenuSortingValue->1600],
Cell[21466, 572, 171, 3, 70, 39, 0, "StyleData", "Item", "Presentation", \
"ExpressionUUID" -> "ff79f70f-ad89-40bc-9bae-abde5c529497"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21674, 580, 438, 12, 70, 32, 0, "StyleData", "ItemParagraph", "All", \
"ExpressionUUID" -> "b101bc5b-65f3-42c4-b370-01eb262ef300",
 MenuSortingValue->1600],
Cell[22115, 594, 153, 2, 70, 48, 0, "StyleData", "ItemParagraph", \
"Presentation", "ExpressionUUID" -> "f9a20242-c509-4964-966c-f3ec22020e7f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22305, 601, 599, 16, 70, 26, 0, "StyleData", "Subitem", "All", \
"ExpressionUUID" -> "36e8d557-afb2-48fc-be3d-b618d1935407",
 CounterIncrements->"Subitem",
 CounterAssignments->{{"Subsubitem", 0}},
 MenuSortingValue->1610],
Cell[22907, 619, 174, 3, 70, 42, 0, "StyleData", "Subitem", "Presentation", \
"ExpressionUUID" -> "cfa3860a-505e-4724-a8d8-e35b55e1e874"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23118, 627, 472, 13, 70, 35, 0, "StyleData", "SubitemParagraph", "All", \
"ExpressionUUID" -> "ce62fd4b-6c4c-4ac6-8ed5-eb76662e6e8f",
 MenuSortingValue->1610],
Cell[23593, 642, 156, 2, 70, 51, 0, "StyleData", "SubitemParagraph", \
"Presentation", "ExpressionUUID" -> "608e5ed9-a83f-40a5-9e24-02f481a00601"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23786, 649, 569, 15, 70, 29, 0, "StyleData", "Subsubitem", "All", \
"ExpressionUUID" -> "e740dd0b-3507-4544-9982-44c6c1215804",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1620],
Cell[24358, 666, 177, 3, 70, 45, 0, "StyleData", "Subsubitem", \
"Presentation", "ExpressionUUID" -> "e151f6ef-364f-49af-b72f-e9f4a24ce86f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24572, 674, 512, 14, 70, 38, 0, "StyleData", "SubsubitemParagraph", \
"All", "ExpressionUUID" -> "5d9115cf-89e5-4527-80cb-8e90f2c2fd2a",
 CounterIncrements->"Subsubitem",
 MenuSortingValue->1625],
Cell[25087, 690, 159, 2, 70, 54, 0, "StyleData", "SubsubitemParagraph", \
"Presentation", "ExpressionUUID" -> "1c649447-fadf-4d77-be51-0b2aeb4c1e3f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25283, 697, 641, 17, 70, 31, 0, "StyleData", "ItemNumbered", "All", \
"ExpressionUUID" -> "0332f4f1-0b1e-4bb1-82bc-f15966738568",
 CounterIncrements->"ItemNumbered",
 CounterAssignments->{{"SubitemNumbered", 0}, {"SubsubitemNumbered", 0}},
 MenuSortingValue->1630],
Cell[25927, 716, 179, 3, 70, 47, 0, "StyleData", "ItemNumbered", \
"Presentation", "ExpressionUUID" -> "c7a1d5af-27bb-4330-b926-05c16935a969"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26143, 724, 696, 19, 70, 34, 0, "StyleData", "SubitemNumbered", "All", \
"ExpressionUUID" -> "587f45b3-83b3-4399-a3a4-2d5bd030c6a9",
 CounterIncrements->"SubitemNumbered",
 CounterAssignments->{{"SubsubitemNumbered", 0}},
 MenuSortingValue->1640],
Cell[26842, 745, 182, 3, 70, 50, 0, "StyleData", "SubitemNumbered", \
"Presentation", "ExpressionUUID" -> "c32db1e1-7e5f-4bdc-bef8-61534145bf0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27061, 753, 708, 19, 70, 37, 0, "StyleData", "SubsubitemNumbered", \
"All", "ExpressionUUID" -> "a04ae3dd-473d-4532-9754-f24b27873db8",
 CounterIncrements->"SubsubitemNumbered",
 MenuSortingValue->1645],
Cell[27772, 774, 185, 3, 70, 53, 0, "StyleData", "SubsubitemNumbered", \
"Presentation", "ExpressionUUID" -> "595436fa-b6e3-4a0c-ae66-8076d2e76c83"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[28006, 783, 82, 0, 70, "Section", "ExpressionUUID" -> \
"9c8415d3-5507-4a19-ac22-c75b4faa0898"],
Cell[CellGroupData[{
Cell[28113, 787, 534, 14, 70, 67, 0, "StyleData", "ProofText", "All", \
"ExpressionUUID" -> "a6d4df30-da01-4bd1-a29a-9713ef3ec60d",
 MenuSortingValue->1470,
 MenuCommandKey->"P"],
Cell[28650, 803, 111, 1, 70, 38, 0, "StyleData", "ProofText", "Layout", \
"ExpressionUUID" -> "0689b5e2-1be7-4df5-94f8-402fdc38cb16"],
Cell[28764, 806, 117, 1, 70, 44, 0, "StyleData", "ProofText", "Presentation", \
"ExpressionUUID" -> "7318ad79-3f5f-4b7e-be95-9665817ee163"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28918, 812, 586, 18, 70, 41, 0, "StyleData", "FormalTextInputFormula", \
"All", "ExpressionUUID" -> "7b634b86-7608-4778-bfad-a0d8c91e9bf4",
 MenuSortingValue->1470,
 MenuCommandKey->"F"],
Cell[29507, 832, 124, 1, 70, 51, 0, "StyleData", "FormalTextInputFormula", \
"Layout", "ExpressionUUID" -> "2078928f-3e91-4dd9-a642-338de9f30bd7"],
Cell[29634, 835, 130, 1, 70, 57, 0, "StyleData", "FormalTextInputFormula", \
"Presentation", "ExpressionUUID" -> "16ac170f-6f55-498b-a342-c3adbff4932b"]
}, Open  ]],
Cell[29779, 839, 224, 5, 70, 37, 0, "StyleData", "ExpressionVariable", "All", \
"ExpressionUUID" -> "ecc7391e-51b1-4f1f-8b45-922b4cf5d4ce"],
Cell[30006, 846, 203, 5, 70, 32, 0, "StyleData", "ExpressionABF", "All", \
"ExpressionUUID" -> "ebf7c9b5-61c3-4f04-9416-613c5552c0a5"],
Cell[30212, 853, 225, 6, 70, 33, 0, "StyleData", "ExpressionMeta", "All", \
"ExpressionUUID" -> "7e1c6e5b-20aa-4a8c-b89b-abf16ce0f216"],
Cell[30440, 861, 229, 6, 70, 38, 0, "StyleData", "ExpressionSyntactic", \
"All", "ExpressionUUID" -> "3b944421-7b57-4d57-aa00-3f622d2afa85"],
Cell[CellGroupData[{
Cell[30694, 871, 144, 3, 70, 34, 0, "StyleData", "AutoParentheses", "All", \
"ExpressionUUID" -> "776c4bc6-55be-4d77-8bdc-d8d481696730"],
Cell[30841, 876, 116, 1, 70, 44, 0, "StyleData", "AutoParentheses", "Layout", \
"ExpressionUUID" -> "a838ff71-080e-473d-9cb8-1770f06ee9ec"],
Cell[30960, 879, 119, 1, 70, 47, 0, "StyleData", "AutoParentheses", \
"SlideShow", "ExpressionUUID" -> "2e3500bf-ac13-47c7-89d0-1784c4c9567d"]
}, Closed]],
Cell[CellGroupData[{
Cell[31116, 885, 128, 2, 70, 29, 0, "StyleData", "Emphasized", "All", \
"ExpressionUUID" -> "eff82861-64f2-4cdc-89c3-2bf95fb8f487",
 MenuCommandKey->"E"],
Cell[31247, 889, 161, 3, 70, 42, 0, "StyleData", "Emphasized", "SlideShow", \
"ExpressionUUID" -> "a70eeef0-5c2a-49b2-af41-62cbcf17fdbe"]
}, Closed]],
Cell[31423, 895, 360, 11, 70, 32, 0, "StyleData", "GenericButton", "All", \
"ExpressionUUID" -> "3b694c95-8a41-4f43-98bf-b8cdc9ca09b4"],
Cell[31786, 908, 239, 5, 70, 31, 0, "StyleData", "TheoremaForm", "All", \
"ExpressionUUID" -> "e87fe30d-2a73-4afa-a2eb-f83fd6983069",
 StyleMenuListing->None],
Cell[32028, 915, 124, 2, 70, 34, 0, "StyleData", "ComponentActive", "All", \
"ExpressionUUID" -> "f5d6e672-3ec1-4dbf-a381-c9ff11cfe216"],
Cell[32155, 919, 142, 2, 70, 36, 0, "StyleData", "ComponentInactive", "All", \
"ExpressionUUID" -> "dd862048-961f-4f4c-8843-ae96f80a63bb"],
Cell[32300, 923, 167, 4, 70, 33, 0, "StyleData", "ComponentEmpty", "All", \
"ExpressionUUID" -> "6e3fab66-e0f2-406f-8842-978322b2d931"],
Cell[32470, 929, 128, 2, 70, 26, 0, "StyleData", "TabView", "All", \
"ExpressionUUID" -> "01f74fb4-c55c-41dc-b51c-dc84777ff58c"],
Cell[32601, 933, 154, 3, 70, 31, 0, "StyleData", "TabViewLabel", "All", \
"ExpressionUUID" -> "31028c8f-1470-4418-865d-238462c93ebb"],
Cell[32758, 938, 280, 6, 70, 71, 0, "StyleData", "FormReference", "All", \
"ExpressionUUID" -> "6b0b6303-1d7b-41ab-a00f-f821ee306762"],
Cell[33041, 946, 329, 8, 70, 76, 0, "StyleData", "FormReferenceHover", "All", \
"ExpressionUUID" -> "b6b5bf69-5abc-4df6-8a8d-a47db77c2b76"],
Cell[33373, 956, 533, 15, 70, 33, 0, "StyleData", "DisplayFormula", "All", \
"ExpressionUUID" -> "300cc526-865d-4b7b-8e89-0102ddbe1cdc"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

