(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     16445,        582]
NotebookOptionsPosition[     10602,        437]
NotebookOutlinePosition[     11067,        457]
CellTagsIndexPosition[     11024,        454]
MenuPosition->0
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[StyleData[StyleDefinitions -> "Default.nb"]],

Cell["\<\
Modify the definitions below to change the default appearance of all cells in \
a given style. 
Make modifications to any definition using commands in the Format menu.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Working"],
 FontSize->12],

Cell[StyleData[All, "Presentation"]],

Cell[StyleData[All, "Printout"]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notebook Options Settings", "Section"],

Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text"],

Cell[StyleData["Notebook"],
 CellGrouping->"Manual",
 WindowOpacity->0.97,
 PageHeaders->{{
    Cell[
     TextData[{
       Cell[
        TextData[{
          CounterBox["Page"]}], "PageNumber"], " ", 
       Cell[
       " ", "Header", CellFrame -> {{0.5, 0}, {0, 0}}, CellFrameMargins -> 4], 
       Cell[
        TextData[{
          ValueBox["FileName"]}], "Header"]}], 
     CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
   None, None, 
    Cell[
     TextData[{
       Cell[
        TextData[{
          ValueBox["FileName"]}], "Header"], 
       Cell[
       " ", "Header", CellFrame -> {{0, 0.5}, {0, 0}}, CellFrameMargins -> 4],
        " ", 
       Cell[
        TextData[{
          CounterBox["Page"]}], "PageNumber"]}], 
     CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}},
 PageHeaderLines->{False, False},
 PageFooterLines->{False, False},
 PrintingOptions->{"FacingPages"->True,
 "FirstPageFace"->Right,
 "FirstPageFooter"->True,
 "FirstPageHeader"->False},
 Background->CMYKColor[0, 0, 0, 0]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Styles for Title, Section Cells and Text", "Section"],

Cell[CellGroupData[{

Cell["Title", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Title"],
 CellMargins->{{27, Inherited}, {0, 30}},
 MenuSortingValue->1100,
 MenuCommandKey->"1"],

Cell[StyleData["Title", "Presentation"],
 CellMargins->{{27, 10}, {0, 45}}],

Cell[StyleData["Title", "SlideShow"],
 CellMargins->{{27, 10}, {0, 45}}],

Cell[StyleData["Title", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{6, 10}, {5, 30}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subtitle"],
 CellMargins->{{27, Inherited}, {0, 2}},
 MenuSortingValue->1150],

Cell[StyleData["Subtitle", "Presentation"],
 CellMargins->{{27, 10}, {0, 3}}],

Cell[StyleData["Subtitle", "SlideShow"],
 CellMargins->{{27, 10}, {0, 3}}],

Cell[StyleData["Subtitle", "Printout"],
 CellMargins->{{6, 10}, {5, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubtitle"],
 MenuSortingValue->1200],

Cell[StyleData["Subsubtitle", "Presentation"],
 CellMargins->{{27, 10}, {12, 3}}],

Cell[StyleData["Subsubtitle", "SlideShow"],
 CellMargins->{{27, 10}, {12, 3}}],

Cell[StyleData["Subsubtitle", "Printout"],
 CellMargins->{{6, 10}, {0, 0}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Sectioning", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Section"],
 ShowGroupOpener->False,
 FontSize->12,
 Background->CMYKColor[0, 1, 0, 1]],

Cell[StyleData["Section", "Presentation"],
 CellMargins->{{27, 10}, {12, 51}}],

Cell[StyleData["Section", "SlideShow"],
 CellMargins->{{27, 10}, {12, 51}}],

Cell[StyleData["Section", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{2, 0}, {7, 22}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{48, Inherited}, {8, 12}},
 MenuSortingValue->1300,
 MenuCommandKey->"5"],

Cell[StyleData["Subsection", "Presentation"],
 CellMargins->{{48, 10}, {12, 18}}],

Cell[StyleData["Subsection", "SlideShow"],
 CellMargins->{{48, 10}, {12, 18}}],

Cell[StyleData["Subsection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{9, 0}, {7, 22}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{60, Inherited}, {2, 10}},
 MenuSortingValue->1350,
 MenuCommandKey->"6",
 FontSlant->"Italic"],

Cell[StyleData["Subsubsection", "Presentation"],
 CellMargins->{{60, 10}, {3, 15}}],

Cell[StyleData["Subsubsection", "SlideShow"],
 CellMargins->{{60, 10}, {3, 15}}],

Cell[StyleData["Subsubsection", "Printout"],
 ShowGroupOpener->False,
 CellMargins->{{35, 0}, {7, 14}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
 CellDingbat->None,
 ShowGroupOpener->True,
 CellMargins->{{92, Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Subsubsubsection", "Presentation"],
 CellMargins->{{92, 10}, {3, 15}},
 LineSpacing->{1, 0}],

Cell[StyleData["Subsubsubsection", "SlideShow"],
 CellMargins->{{92, 10}, {3, 15}},
 LineSpacing->{1, 0}],

Cell[StyleData["Subsubsubsection", "Printout"],
 CellMargins->{{50, 0}, {7, 14}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Text", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Text"],
 CellMargins->{{36, 10}, {7, 7}},
 LineSpacing->{1, 3}],

Cell[StyleData["Text", "Presentation"],
 CellMargins->{{36, 10}, {10, 10}},
 LineSpacing->{1, 5},
 FontSize->24],

Cell[StyleData["Text", "Printout"],
 CellMargins->{{36, Inherited}, {Inherited, Inherited}},
 TextJustification->0.5,
 Hyphenation->True]
}, Open  ]],

Cell[StyleData["Hint"],
 CellMargins->{{0, 0}, {0, 7}},
 CellFrameMargins->{{25, 20}, {4, 4}},
 ShowStringCharacters->False,
 FontWeight->"Bold",
 FontColor->CMYKColor[0, 0, 1, 1],
 Background->CMYKColor[0, 0, 0, 1]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Theorema", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Goal"],
 CellMargins->{{66, Inherited}, {Inherited, Inherited}},
 StripStyleOnPaste->True,
 DefaultFormatType->DefaultInputFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 FontWeight->"Bold",
 FontColor->CMYKColor[0, 1, 1, 1],
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["Goal", "Presentation"],
 CellMargins->{{100, Inherited}, {Inherited 1.5, Inherited 1.5}},
 LineSpacing->{1, 5},
 FontSize->24],

Cell[StyleData["Goal", "Printout"],
 CellMargins->{{49, Inherited}, {Inherited, Inherited}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Assumption"],
 CellMargins->{{66, Inherited}, {Inherited, Inherited}},
 StripStyleOnPaste->True,
 DefaultFormatType->DefaultInputFormatType,
 HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
 LanguageCategory->"Formula",
 ScriptLevel->0,
 SingleLetterItalics->True,
 FontWeight->"Bold",
 FontColor->CMYKColor[0, 1, 1, 0],
 UnderoverscriptBoxOptions->{LimitsPositioning->True}],

Cell[StyleData["Assumption", "Presentation"],
 CellMargins->{{100, Inherited}, {Inherited 1.5, Inherited 1.5}},
 LineSpacing->{1, 5},
 FontSize->24],

Cell[StyleData["Assumption", "Printout"],
 CellMargins->{{49, Inherited}, {Inherited, Inherited}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["GoalLabel"],
 LanguageCategory->None,
 StyleMenuListing->None,
 FontFamily->"Times New Roman",
 FontSize->10,
 FontWeight->"Bold",
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[1, 0, 1, 0],
 Background->None,
 FontVariations -> {"Masked" -> False}],

Cell[StyleData["GoalLabel", "Presentation"],
 FontSize->18],

Cell[StyleData["GoalLabel", "Printout"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["AssumptionLabel"],
 LanguageCategory->None,
 StyleMenuListing->None,
 FontFamily->"Times New Roman",
 FontSize->10,
 FontWeight->"Bold",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->CMYKColor[0, 0, 1, 0],
 Background->None,
 FontVariations -> {"Masked" -> False}],

Cell[StyleData["AssumptionLabel", "Presentation"],
 FontSize->18],

Cell[StyleData["AssumptionLabel", "Printout"]]
}, Open  ]],

Cell[StyleData["ExpressionVariable"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Century Schoolbook L",
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[0.1, 0.4, 0.8]],

Cell[StyleData["ExpressionABF"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[0.9, 0.5, 0],
 FontVariations -> {"Masked" -> False}],

Cell[StyleData["ExpressionMeta"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->Bold,
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[0.05, 0.3, 0.7],
 FontVariations -> {"Masked" -> False}],

Cell[StyleData["ExpressionSyntactic"],
 SingleLetterItalics->True,
 MultiLetterItalics->True,
 FontFamily->"Arial",
 FontWeight->Bold,
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "StrikeThrough"->False,
 "Underline"->False},
 FontColor->RGBColor[0.8, 0.1, 0.7],
 FontVariations -> {"Masked" -> False}],

Cell[CellGroupData[{

Cell[StyleData["FormReference", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times New Roman",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->True}],

Cell[StyleData["FormReference", "Presentation"],
 FontSize->24]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["FormReferenceHover", StyleDefinitions -> StyleData["Text"]],
 FontFamily->"Times New Roman",
 FontSize->12,
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontVariations->{"StrikeThrough"->False,
 "Underline"->True},
 FontColor->CMYKColor[0, 0, 0, 1]],

Cell[StyleData["FormReferenceHover", "Presentation"],
 FontSize->24]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
Editable->True,
Saveable->True,
WindowSize->{950, 958},
WindowMargins->{{437, Automatic}, {4, Automatic}},
TrackCellChangeTimes->False,
MenuSortingValue->None,
FrontEndVersion->"11.0 for Linux x86 (64-bit) (September 21, 2016)",
StyleDefinitions->"StylesheetFormatting.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[561, 21, 49, 0, 40, 49, 0, "StyleData", "StyleDefinitions", ""],
Cell[613, 23, 191, 4, 65, "Text"],
Cell[CellGroupData[{
Cell[829, 31, 42, 0, 54, "Section"],
Cell[874, 33, 46, 1, 40, 31, 0, "StyleData", "All", "Working"],
Cell[923, 36, 36, 0, 40, 36, 0, "StyleData", "All", "Presentation"],
Cell[962, 38, 32, 0, 33, 32, 0, "StyleData", "All", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1031, 43, 44, 0, 54, "Section"],
Cell[1078, 45, 99, 2, 46, "Text"],
Cell[1180, 49, 1049, 34, 56, 27, 0, "StyleData", "Notebook", "All"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2266, 88, 59, 0, 54, "Section"],
Cell[CellGroupData[{
Cell[2350, 92, 27, 0, 49, "Subsection"],
Cell[CellGroupData[{
Cell[2402, 96, 113, 3, 94, 24, 0, "StyleData", "Title", "All",
 MenuSortingValue->1100,
 MenuCommandKey->"1"],
Cell[2518, 101, 75, 1, 145, 40, 0, "StyleData", "Title", "Presentation"],
Cell[2596, 104, 72, 1, 145, 37, 0, "StyleData", "Title", "SlideShow"],
Cell[2671, 107, 95, 2, 67, 36, 0, "StyleData", "Title", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[2803, 114, 93, 2, 50, 27, 0, "StyleData", "Subtitle", "All",
 MenuSortingValue->1150],
Cell[2899, 118, 77, 1, 75, 43, 0, "StyleData", "Subtitle", "Presentation"],
Cell[2979, 121, 74, 1, 75, 40, 0, "StyleData", "Subtitle", "SlideShow"],
Cell[3056, 124, 72, 1, 37, 39, 0, "StyleData", "Subtitle", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[3165, 130, 55, 1, 47, 30, 0, "StyleData", "Subsubtitle", "All",
 MenuSortingValue->1200],
Cell[3223, 133, 81, 1, 69, 46, 0, "StyleData", "Subsubtitle", \
"Presentation"],
Cell[3307, 136, 78, 1, 69, 43, 0, "StyleData", "Subsubtitle", "SlideShow"],
Cell[3388, 139, 75, 1, 32, 42, 0, "StyleData", "Subsubtitle", "Printout"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3512, 146, 32, 0, 33, "Subsection"],
Cell[CellGroupData[{
Cell[3569, 150, 102, 3, 67, 26, 0, "StyleData", "Section", "All"],
Cell[3674, 155, 78, 1, 137, 42, 0, "StyleData", "Section", "Presentation"],
Cell[3755, 158, 75, 1, 137, 39, 0, "StyleData", "Section", "SlideShow"],
Cell[3833, 161, 96, 2, 61, 38, 0, "StyleData", "Section", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3966, 168, 162, 5, 61, 29, 0, "StyleData", "Subsection", "All",
 MenuSortingValue->1300,
 MenuCommandKey->"5"],
Cell[4131, 175, 81, 1, 80, 45, 0, "StyleData", "Subsection", "Presentation"],
Cell[4215, 178, 78, 1, 80, 42, 0, "StyleData", "Subsection", "SlideShow"],
Cell[4296, 181, 99, 2, 61, 41, 0, "StyleData", "Subsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4432, 188, 187, 6, 46, 32, 0, "StyleData", "Subsubsection", "All",
 MenuSortingValue->1350,
 MenuCommandKey->"6"],
Cell[4622, 196, 83, 1, 63, 48, 0, "StyleData", "Subsubsection", \
"Presentation"],
Cell[4708, 199, 80, 1, 63, 45, 0, "StyleData", "Subsubsection", "SlideShow"],
Cell[4791, 202, 103, 2, 52, 44, 0, "StyleData", "Subsubsection", "Printout"]
}, Closed]],
Cell[CellGroupData[{
Cell[4931, 209, 136, 3, 41, 35, 0, "StyleData", "Subsubsubsection", "All"],
Cell[5070, 214, 108, 2, 64, 51, 0, "StyleData", "Subsubsubsection", \
"Presentation"],
Cell[5181, 218, 105, 2, 60, 48, 0, "StyleData", "Subsubsubsection", \
"SlideShow"],
Cell[5289, 222, 81, 1, 53, 47, 0, "StyleData", "Subsubsubsection", \
"Printout"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5419, 229, 26, 0, 49, "Subsection"],
Cell[CellGroupData[{
Cell[5470, 233, 79, 2, 47, 23, 0, "StyleData", "Text", "All"],
Cell[5552, 237, 112, 3, 66, 39, 0, "StyleData", "Text", "Presentation"],
Cell[5667, 242, 137, 3, 40, 35, 0, "StyleData", "Text", "Printout"]
}, Open  ]],
Cell[5819, 248, 216, 6, 48, 23, 0, "StyleData", "Hint", "All"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6084, 260, 27, 0, 54, "Section"],
Cell[CellGroupData[{
Cell[6136, 264, 402, 10, 41, 23, 0, "StyleData", "Goal", "All"],
Cell[6541, 276, 142, 3, 64, 39, 0, "StyleData", "Goal", "Presentation"],
Cell[6686, 281, 92, 1, 40, 35, 0, "StyleData", "Goal", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6815, 287, 408, 10, 41, 29, 0, "StyleData", "Assumption", "All"],
Cell[7226, 299, 148, 3, 64, 45, 0, "StyleData", "Assumption", \
"Presentation"],
Cell[7377, 304, 98, 1, 40, 41, 0, "StyleData", "Assumption", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7512, 310, 386, 14, 36, 28, 0, "StyleData", "GoalLabel", "All",
 StyleMenuListing->None],
Cell[7901, 326, 59, 1, 47, 44, 0, "StyleData", "GoalLabel", "Presentation"],
Cell[7963, 329, 40, 0, 36, 40, 0, "StyleData", "GoalLabel", "Printout"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8040, 334, 371, 13, 36, 34, 0, "StyleData", "AssumptionLabel", "All",
 StyleMenuListing->None],
Cell[8414, 349, 65, 1, 47, 50, 0, "StyleData", "AssumptionLabel", \
"Presentation"],
Cell[8482, 352, 46, 0, 36, 46, 0, "StyleData", "AssumptionLabel", "Printout"]
}, Open  ]],
Cell[8543, 355, 273, 8, 43, 37, 0, "StyleData", "ExpressionVariable", "All"],
Cell[8819, 365, 352, 12, 39, 32, 0, "StyleData", "ExpressionABF", "All"],
Cell[9174, 379, 353, 12, 39, 33, 0, "StyleData", "ExpressionMeta", "All"],
Cell[9530, 393, 357, 12, 39, 38, 0, "StyleData", "ExpressionSyntactic", "All"],
Cell[CellGroupData[{
Cell[9912, 409, 224, 6, 45, 71, 0, "StyleData", "FormReference", "All"],
Cell[10139, 417, 63, 1, 66, 48, 0, "StyleData", "FormReference", \
"Presentation"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10239, 423, 264, 7, 45, 76, 0, "StyleData", "FormReferenceHover", \
"All"],
Cell[10506, 432, 68, 1, 66, 53, 0, "StyleData", "FormReferenceHover", \
"Presentation"]
}, Open  ]]
}, Open  ]]
}
]
*)

